"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/errors","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/lineRange","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ee=function(j){for(var t=[],F=0,T=j.length;F<T;F++)t[F]=K[j[F]];return t};const qe=this,We=typeof global=="object"?global:{};var fe;(function(j){j.global=qe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof j.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}j.Environment=t})(fe||(fe={}));var fe;(function(j){class t{constructor(u,R,w){this.type=u,this.detail=R,this.timestamp=w}}j.LoaderEvent=t;class F{constructor(u){this._events=[new t(1,"",u)]}record(u,R){this._events.push(new t(u,R,j.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}j.LoaderEventRecorder=F;class T{record(u,R){}getEvents(){return[]}}T.INSTANCE=new T,j.NullLoaderEventRecorder=T})(fe||(fe={}));var fe;(function(j){class t{static fileUriToFilePath(T,i){if(i=decodeURI(i).replace(/%23/g,"#"),T){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(T,i){return T.length>=i.length&&T.substr(0,i.length)===i}static endsWith(T,i){return T.length>=i.length&&T.substr(T.length-i.length)===i}static containsQueryString(T){return/^[^\#]*\?/gi.test(T)}static isAbsolutePath(T){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(T)}static forEachProperty(T,i){if(T){let u;for(u in T)T.hasOwnProperty(u)&&i(u,T[u])}}static isEmpty(T){let i=!0;return t.forEachProperty(T,()=>{i=!1}),i}static recursiveClone(T){if(!T||typeof T!="object"||T instanceof RegExp||!Array.isArray(T)&&Object.getPrototypeOf(T)!==Object.prototype)return T;let i=Array.isArray(T)?[]:{};return t.forEachProperty(T,(u,R)=>{R&&typeof R=="object"?i[u]=t.recursiveClone(R):i[u]=R}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(T){return t.startsWith(T,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=j.global.performance&&typeof j.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?j.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,j.Utilities=t})(fe||(fe={}));var fe;(function(j){function t(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}j.ensureError=t;class F{static validateConfigurationOptions(u){function R(w){if(w.phase==="loading"){console.error('Loading "'+w.moduleId+'" failed'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}if(w.phase==="factory"){console.error('The factory function of "'+w.moduleId+'" has thrown an exception'),console.error(w),console.error("Here are the modules that depend on it:"),console.error(w.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=R),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(j.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const w=t(new Error("INVALID cached data configuration, 'path' MUST be set"));w.phase="configuration",u.onError(w),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,R=null){let w=j.Utilities.recursiveClone(R||{});return j.Utilities.forEachProperty(u,(a,l)=>{a==="ignoreDuplicateModules"&&typeof w.ignoreDuplicateModules<"u"?w.ignoreDuplicateModules=w.ignoreDuplicateModules.concat(l):a==="paths"&&typeof w.paths<"u"?j.Utilities.forEachProperty(l,(g,M)=>w.paths[g]=M):a==="config"&&typeof w.config<"u"?j.Utilities.forEachProperty(l,(g,M)=>w.config[g]=M):w[a]=j.Utilities.recursiveClone(l)}),F.validateConfigurationOptions(w)}}j.ConfigurationOptionsUtil=F;class T{constructor(u,R){if(this._env=u,this.options=F.mergeConfigurationOptions(R),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let w=this.options.nodeRequire.main.filename,a=Math.max(w.lastIndexOf("/"),w.lastIndexOf("\\"));this.options.baseUrl=w.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],j.Utilities.forEachProperty(this.options.paths,(u,R)=>{Array.isArray(R)?this.sortedPathsRules.push({from:u,to:R}):this.sortedPathsRules.push({from:u,to:[R]})}),this.sortedPathsRules.sort((u,R)=>R.from.length-u.from.length)}cloneAndMerge(u){return new T(this._env,F.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let R;for(let w=0,a=this.sortedPathsRules.length;w<a;w++)if(R=this.sortedPathsRules[w],j.Utilities.startsWith(u,R.from)){let l=[];for(let g=0,M=R.to.length;g<M;g++)l.push(R.to[g]+u.substr(R.from.length));return l}return[u]}_addUrlArgsToUrl(u){return j.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let R=0,w=u.length;R<w;R++)u[R]=this._addUrlArgsToUrl(u[R]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let R=u,w;if(!j.Utilities.endsWith(R,".js")&&!j.Utilities.isAbsolutePath(R)){w=this._applyPaths(R);for(let a=0,l=w.length;a<l;a++)this.isBuild()&&w[a]==="empty:"||(j.Utilities.isAbsolutePath(w[a])||(w[a]=this.options.baseUrl+w[a]),!j.Utilities.endsWith(w[a],".js")&&!j.Utilities.containsQueryString(w[a])&&(w[a]=w[a]+".js"))}else!j.Utilities.endsWith(R,".js")&&!j.Utilities.containsQueryString(R)&&(R=R+".js"),w=[R];return this._addUrlArgsIfNecessaryToUrls(w)}requireToUrl(u){let R=u;return j.Utilities.isAbsolutePath(R)||(R=this._applyPaths(R)[0],j.Utilities.isAbsolutePath(R)||(R=this.options.baseUrl+R)),this._addUrlArgsIfNecessaryToUrl(R)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||j.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}j.Configuration=T})(fe||(fe={}));var fe;(function(j){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,g,M,h){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new F;let d={callback:M,errorback:h};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(d);return}this._callbackMap[g]=[d],this._scriptLoader.load(l,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(l){let g=this._callbackMap[l];delete this._callbackMap[l];for(let M=0;M<g.length;M++)g[M].callback()}triggerErrorback(l,g){let M=this._callbackMap[l];delete this._callbackMap[l];for(let h=0;h<M.length;h++)M[h].errorback(g)}}class F{attachListeners(l,g,M){let h=()=>{l.removeEventListener("load",d),l.removeEventListener("error",e)},d=A=>{h(),g()},e=A=>{h(),M(A)};l.addEventListener("load",d),l.addEventListener("error",e)}load(l,g,M,h){if(/^node\|/.test(g)){let d=l.getConfig().getOptionsLiteral(),e=R(l.getRecorder(),d.nodeRequire||j.global.nodeRequire),A=g.split("|"),y=null;try{y=e(A[1])}catch(_){h(_);return}l.enqueueDefineAnonymousModule([],()=>y),M()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,M,h);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),d.setAttribute("src",g);const{cspNonce:A}=l.getConfig().getOptionsLiteral();A&&d.setAttribute("nonce",A),document.getElementsByTagName("head")[0].appendChild(d)}}}function T(a){const{trustedTypesPolicy:l}=a.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=T(l)),this._cachedCanUseEval}load(l,g,M,h){if(/^node\|/.test(g)){const d=l.getConfig().getOptionsLiteral(),e=R(l.getRecorder(),d.nodeRequire||j.global.nodeRequire),A=g.split("|");let y=null;try{y=e(A[1])}catch(_){h(_);return}l.enqueueDefineAnonymousModule([],function(){return y}),M()}else{const{trustedTypesPolicy:d}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(g).then(A=>{if(A.status!==200)throw new Error(A.statusText);return A.text()}).then(A=>{A=`${A}
//# sourceURL=${g}`,(d?self.eval(d.createScript("",A)):new Function(A)).call(self),M()}).then(void 0,h);return}try{d&&(g=d.createScriptURL(g)),importScripts(g),M()}catch(A){h(A)}}}}class u{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,g){const{nodeCachedData:M}=g.getConfig().getOptionsLiteral();if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const h=this,d=l("module");function e(A){const y=A.constructor;let _=function(D){try{return A.require(D)}finally{}};return _.resolve=function(D,m){return y._resolveFilename(D,A,!1,m)},_.resolve.paths=function(D){return y._resolveLookupPaths(D,A)},_.main=process.mainModule,_.extensions=y._extensions,_.cache=y._cache,_}d.prototype._compile=function(A,y){const _=d.wrap(A.replace(/^#!.*/,"")),v=g.getRecorder(),D=h._getCachedDataPath(M,y),m={filename:y};let L;try{const o=h._fs.readFileSync(D);L=o.slice(0,16),m.cachedData=o.slice(16),v.record(60,D)}catch{v.record(61,D)}const r=new h._vm.Script(_,m),s=r.runInThisContext(m),b=h._path.dirname(y),f=e(this),p=[this.exports,f,this,y,b,process,We,Buffer],c=s.apply(this.exports,p);return h._handleCachedData(r,_,D,!m.cachedData,g),h._verifyCachedData(r,_,D,L,g),c}}load(l,g,M,h){const d=l.getConfig().getOptionsLiteral(),e=R(l.getRecorder(),d.nodeRequire||j.global.nodeRequire),A=d.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,l);let y=l.getRecorder();if(/^node\|/.test(g)){let _=g.split("|"),v=null;try{v=e(_[1])}catch(D){h(D);return}l.enqueueDefineAnonymousModule([],()=>v),M()}else{g=j.Utilities.fileUriToFilePath(this._env.isWindows,g);const _=this._path.normalize(g),v=this._getElectronRendererScriptPathOrUri(_),D=!!d.nodeCachedData,m=D?this._getCachedDataPath(d.nodeCachedData,g):void 0;this._readSourceAndCachedData(_,m,y,(L,r,s,b)=>{if(L){h(L);return}let f;r.charCodeAt(0)===u._BOM?f=u._PREFIX+r.substring(1)+u._SUFFIX:f=u._PREFIX+r+u._SUFFIX,f=A(f,_);const p={filename:v,cachedData:s},c=this._createAndEvalScript(l,f,p,M,h);this._handleCachedData(c,f,m,D&&!s,l),this._verifyCachedData(c,f,m,b,l)})}}_createAndEvalScript(l,g,M,h,d){const e=l.getRecorder();e.record(31,M.filename);const A=new this._vm.Script(g,M),y=A.runInThisContext(M),_=l.getGlobalAMDDefineFunc();let v=!1;const D=function(){return v=!0,_.apply(null,arguments)};return D.amd=_.amd,y.call(j.global,l.getGlobalAMDRequireFunc(),D,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),v?h():d(new Error(`Didn't receive define call in ${M.filename}!`)),A}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let g=l.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,g){const M=this._crypto.createHash("md5").update(g,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(g).replace(/\.js$/,"");return this._path.join(l.path,`${h}-${M}.code`)}_handleCachedData(l,g,M,h,d){l.cachedDataRejected?this._fs.unlink(M,e=>{d.getRecorder().record(62,M),this._createAndWriteCachedData(l,g,M,d),e&&d.getConfig().onError(e)}):h&&this._createAndWriteCachedData(l,g,M,d)}_createAndWriteCachedData(l,g,M,h){let d=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,A=0,y;const _=()=>{setTimeout(()=>{y||(y=this._crypto.createHash("md5").update(g,"utf8").digest());const v=l.createCachedData();if(!(v.length===0||v.length===e||A>=5)){if(v.length<e){_();return}e=v.length,this._fs.writeFile(M,Buffer.concat([y,v]),D=>{D&&h.getConfig().onError(D),h.getRecorder().record(63,M),_()})}},d*Math.pow(4,A++))};_()}_readSourceAndCachedData(l,g,M,h){if(!g)this._fs.readFile(l,{encoding:"utf8"},h);else{let d,e,A,y=2;const _=v=>{v?h(v):--y===0&&h(void 0,d,e,A)};this._fs.readFile(l,{encoding:"utf8"},(v,D)=>{d=D,_(v)}),this._fs.readFile(g,(v,D)=>{!v&&D&&D.length>0?(A=D.slice(0,16),e=D.slice(16),M.record(60,g)):M.record(61,g),_()})}}_verifyCachedData(l,g,M,h,d){h&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();h.equals(e)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${M}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(M,A=>{A&&d.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function R(a,l){if(l.__$__isRecorded)return l;const g=function(h){a.record(33,h);try{return l(h)}finally{a.record(34,h)}};return g.__$__isRecorded=!0,g}j.ensureRecordedNodeRequire=R;function w(a){return new t(a)}j.createScriptLoader=w})(fe||(fe={}));var fe;(function(j){class t{constructor(a){let l=a.lastIndexOf("/");l!==-1?this.fromModulePath=a.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(a){let l=a,g;for(g=/\/\.\//;g.test(l);)l=l.replace(g,"/");for(l=l.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(l);)l=l.replace(g,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(a){let l=a;return j.Utilities.isAbsolutePath(l)||(j.Utilities.startsWith(l,"./")||j.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),j.ModuleIdResolver=t;class F{constructor(a,l,g,M,h,d){this.id=a,this.strId=l,this.dependencies=g,this._callback=M,this._errorback=h,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,l){try{return{returnedValue:a.apply(j.global,l),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(a,l,g,M){return a.shouldInvokeFactory(l)?a.shouldCatchError()?this._safeInvokeFunction(g,M):{returnedValue:g.apply(j.global,M),producedError:null}:{returnedValue:null,producedError:null}}complete(a,l,g,M){this._isComplete=!0;let h=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let d=F._invokeFactory(l,this.strId,this._callback,g);h=d.producedError,a.record(22,this.strId),!h&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||j.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(h){let d=j.ensureError(h);d.phase="factory",d.moduleId=this.strId,d.neededBy=M(this.id),this.error=d,l.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}j.Module=F;class T{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let l=this._strModuleIdToIntModuleId.get(a);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(a,l),this._intModuleIdToStrModuleId[l]=a),l}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),j.RegularDependency=i;class u{constructor(a,l,g){this.id=a,this.pluginId=l,this.pluginParam=g}}j.PluginDependency=u;class R{constructor(a,l,g,M,h=0){this._env=a,this._scriptLoader=l,this._loaderAvailableTimestamp=h,this._defineFunc=g,this._requireFunc=M,this._moduleIdProvider=new T,this._config=new j.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new R(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,l){let g=d=>d.replace(/\\/g,"/"),M=g(a),h=l.split(/\n/);for(let d=0;d<h.length;d++){let e=h[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){let A=e[1],y=e[2],_=e[3],v=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(v),A=g(A),A===M){let D={line:parseInt(y,10),col:parseInt(_,10)};return D.line===1&&(D.col-=53),D}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],l=0;for(let g=0,M=this._modules2.length;g<M;g++){let h=this._modules2[g];if(!h)continue;let d=this._buildInfoPath[h.id]||null,e=this._buildInfoDefineStack[h.id]||null,A=this._buildInfoDependencies[h.id];a[l++]={id:h.strId,path:d,defineLocation:d&&e?R._findRelevantLocationInStack(d,e):null,dependencies:A,shim:null,exports:h.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new j.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=j.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:a,callback:l}}defineModule(a,l,g,M,h,d=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let A=new F(e,a,this._normalizeDependencies(l,d),g,M,d);this._modules2[e]=A,this._config.isBuild()&&(this._buildInfoDefineStack[e]=h,this._buildInfoDependencies[e]=(A.dependencies||[]).map(y=>this._moduleIdProvider.getStrModuleId(y.id))),this._resolve(A)}_normalizeDependency(a,l){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let g=a.indexOf("!");if(g>=0){let M=l.resolveModule(a.substr(0,g)),h=l.resolveModule(a.substr(g+1)),d=this._moduleIdProvider.getModuleId(M+"!"+h),e=this._moduleIdProvider.getModuleId(M);return new u(d,e,h)}return new i(this._moduleIdProvider.getModuleId(l.resolveModule(a)))}_normalizeDependencies(a,l){let g=[],M=0;for(let h=0,d=a.length;h<d;h++)g[M++]=this._normalizeDependency(a[h],l);return g}_relativeRequire(a,l,g,M){if(typeof l=="string")return this.synchronousRequire(l,a);this.defineModule(j.Utilities.generateAnonymousModule(),l,g,M,null,a)}synchronousRequire(a,l=new t(a)){let g=this._normalizeDependency(a,l),M=this._modules2[g.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports}configure(a,l){let g=this._config.shouldRecordStats();l?this._config=new j.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),l.dependencies,l.callback,null,l.stack)}}_createLoadError(a,l){let g=this._moduleIdProvider.getStrModuleId(a),M=(this._inverseDependencies2[a]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const h=j.ensureError(l);return h.phase="loading",h.moduleId=g,h.neededBy=M,h}_onLoadError(a,l){const g=this._createLoadError(a,l);this._modules2[a]||(this._modules2[a]=new F(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let M=[];for(let e=0,A=this._moduleIdProvider.getMaxModuleId();e<A;e++)M[e]=!1;let h=!1,d=[];for(d.push(a),M[a]=!0;d.length>0;){let e=d.shift(),A=this._modules2[e];A&&(h=A.onDependencyError(g)||h);let y=this._inverseDependencies2[e];if(y)for(let _=0,v=y.length;_<v;_++){let D=y[_];M[D]||(d.push(D),M[D]=!0)}}h||this._config.onError(g)}_hasDependencyPath(a,l){let g=this._modules2[a];if(!g)return!1;let M=[];for(let d=0,e=this._moduleIdProvider.getMaxModuleId();d<e;d++)M[d]=!1;let h=[];for(h.push(g),M[a]=!0;h.length>0;){let e=h.shift().dependencies;if(e)for(let A=0,y=e.length;A<y;A++){let _=e[A];if(_.id===l)return!0;let v=this._modules2[_.id];v&&!M[_.id]&&(M[_.id]=!0,h.push(v))}}return!1}_findCyclePath(a,l,g){if(a===l||g===50)return[a];let M=this._modules2[a];if(!M)return null;let h=M.dependencies;if(h)for(let d=0,e=h.length;d<e;d++){let A=this._findCyclePath(h[d].id,l,g+1);if(A!==null)return A.push(a),A}return null}_createRequire(a){let l=(g,M,h)=>this._relativeRequire(a,g,M,h);return l.toUrl=g=>this._config.requireToUrl(a.resolveModule(g)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(g,M=!1)=>{this.configure(g,M)},l.__$__nodeRequire=j.global.nodeRequire,l}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let l=this._moduleIdProvider.getStrModuleId(a),g=this._config.moduleIdToPaths(l),M=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||M.test(l))&&g.push("node|"+l);let h=-1,d=e=>{if(h++,h>=g.length)this._onLoadError(a,e);else{let A=g[h],y=this.getRecorder();if(this._config.isBuild()&&A==="empty:"){this._buildInfoPath[a]=A,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}y.record(10,A),this._scriptLoader.load(this,A,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=A),y.record(11,A),this._onLoad(a)},_=>{y.record(12,A),d(_)})}};d(null)}_loadPluginDependency(a,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let g=M=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],M,null,null)};g.error=M=>{this._config.onError(this._createLoadError(l.id,M))},a.load(l.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(a){let l=a.dependencies;if(l)for(let g=0,M=l.length;g<M;g++){let h=l[g];if(h===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(h===i.MODULE){a.unresolvedDependenciesCount--;continue}if(h===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let d=this._modules2[h.id];if(d&&d.isComplete()){if(d.error){a.onDependencyError(d.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(h.id,a.id,0)||[];e.reverse(),e.push(h.id),console.warn(e.map(A=>this._moduleIdProvider.getStrModuleId(A)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(a.id),h instanceof u){let e=this._modules2[h.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,h);continue}let A=this._inversePluginDependencies2.get(h.pluginId);A||(A=[],this._inversePluginDependencies2.set(h.pluginId,A)),A.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let l=this.getRecorder();if(a.isComplete())return;let g=a.dependencies,M=[];if(g)for(let A=0,y=g.length;A<y;A++){let _=g[A];if(_===i.EXPORTS){M[A]=a.exports;continue}if(_===i.MODULE){M[A]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(_===i.REQUIRE){M[A]=this._createRequire(a.moduleIdResolver);continue}let v=this._modules2[_.id];if(v){M[A]=v.exports;continue}M[A]=null}const h=A=>(this._inverseDependencies2[A]||[]).map(y=>this._moduleIdProvider.getStrModuleId(y));a.complete(l,this._config,M,h);let d=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,d)for(let A=0,y=d.length;A<y;A++){let _=d[A],v=this._modules2[_];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let A=0,y=e.length;A<y;A++)this._loadPluginDependency(a.exports,e[A])}}}j.ModuleManager=R})(fe||(fe={}));var J,fe;(function(j){const t=new j.Environment;let F=null;const T=function(w,a,l){typeof w!="string"&&(l=a,a=w,w=null),(typeof a!="object"||!Array.isArray(a))&&(l=a,a=null),a||(a=["require","exports","module"]),w?F.defineModule(w,a,l,null,null):F.enqueueDefineAnonymousModule(a,l)};T.amd={jQuery:!0};const i=function(w,a=!1){F.configure(w,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(j.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return F.getConfig().getOptionsLiteral()},u.reset=function(){F=F.reset()},u.getBuildInfo=function(){return F.getBuildInfo()},u.getStats=function(){return F.getLoaderEvents()},u.define=T;function R(){if(typeof j.global.require<"u"||typeof require<"u"){const w=j.global.require||require;if(typeof w=="function"&&typeof w.resolve=="function"){const a=j.ensureRecordedNodeRequire(F.getRecorder(),w);j.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(j.global.define=T),j.global.require=u)}j.init=R,(typeof j.global.define!="function"||!j.global.define.amd)&&(F=new j.ModuleManager(t,j.createScriptLoader(t),T,u,j.Utilities.getHighPerformanceTimestamp()),typeof j.global.require<"u"&&typeof j.global.require!="function"&&u.config(j.global.require),J=function(){return T.apply(null,arguments)},J.amd=T.amd,typeof doNotInitLoader>"u"&&R())})(fe||(fe={})),J(K[57],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(w,a,l,g){if(g=g||{},(g["vs/css"]||{}).disabled){l({});return}const h=a.toUrl(w+".css");T(w,h,()=>{l({})},d=>{typeof l.error=="function"&&l.error("Could not find "+h+".")})}t.load=F;function T(w,a,l,g){if(i(w,a)){l();return}u(w,a,l,g)}function i(w,a){const l=document.getElementsByTagName("link");for(let g=0,M=l.length;g<M;g++){const h=l[g].getAttribute("data-name"),d=l[g].getAttribute("href");if(h===w||d===a)return!0}return!1}function u(w,a,l,g){const M=document.createElement("link");M.setAttribute("rel","stylesheet"),M.setAttribute("type","text/css"),M.setAttribute("data-name",w),R(w,M,l,g),M.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(M)}function R(w,a,l,g){const M=()=>{a.removeEventListener("load",h),a.removeEventListener("error",d)},h=e=>{M(),l()},d=e=>{M(),g(e)};a.addEventListener("load",h),a.addEventListener("error",d)}}),J("vs/nls",["require","exports"],function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const T="i-default";function i(e,A){let y;return A.length===0?y=e:y=e.replace(/\{(\d+)\}/g,(_,v)=>{const D=v[0],m=A[D];let L=_;return typeof m=="string"?L=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(L=String(m)),L}),F&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function u(e,A){let y=e[A];return y||(y=e["*"],y)?y:null}function R(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function w(e,A,y){const _=R(e)+R(A)+"vscode/"+R(y),v=await fetch(_);if(v.ok)return await v.json();throw new Error(`${v.status} - ${v.statusText}`)}function a(e){return function(A,y){const _=Array.prototype.slice.call(arguments,2);return i(e[A],_)}}function l(e,A,...y){return i(A,y)}t.localize=l;function g(e){}t.getConfiguredDefaultLocale=g;function M(e){F=e}t.setPseudoTranslation=M;function h(e,A){return{localize:a(A[e]),getConfiguredDefaultLocale:A.getConfiguredDefaultLocale??(y=>{})}}t.create=h;function d(e,A,y,_){const v=_["vs/nls"]??{};if(!e||e.length===0)return y({localize:l,getConfiguredDefaultLocale:()=>v.availableLanguages?.["*"]});const D=v.availableLanguages?u(v.availableLanguages,e):null,m=D===null||D===T;let L=".nls";m||(L=L+"."+D);const r=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>v.availableLanguages?.["*"],y(s)};typeof v.loadBundle=="function"?v.loadBundle(e,D,(s,b)=>{s?A([e+".nls"],r):r(b)}):v.translationServiceUrl&&!m?(async()=>{try{const s=await w(v.translationServiceUrl,D,e);return r(s)}catch(s){if(!D.includes("-"))return console.error(s),A([e+".nls"],r);try{const b=D.split("-")[0],f=await w(v.translationServiceUrl,b,e);return v.availableLanguages??={},v.availableLanguages["*"]=b,r(f)}catch(b){return console.error(b),A([e+".nls"],r)}}})():A([e+L],r,s=>{if(L===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${D}. Falling back to the default language:`,s),A([e+".nls"],r)})}t.load=d}),function(){const j=globalThis.MonacoEnvironment,t=j&&j.baseUrl?j.baseUrl:"../../../",F=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:l=>l,createScript:(l,...g)=>{const M=g.slice(0,-1).join(","),h=g.pop().toString();return`(function anonymous(${M}) { ${h}
})`}}):void 0;function T(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function i(){return new Promise((l,g)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return l();const M=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(M)&&M.substring(0,globalThis.origin.length)!==globalThis.origin)&&T()){fetch(M).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${M}`,(F?globalThis.eval(F.createScript("",d)):new Function(d)).call(globalThis),l()}).then(void 0,g);return}F?importScripts(F.createScriptURL(M)):importScripts(M),l()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function R(l){i().then(()=>{u(),require([l],function(g){setTimeout(function(){const M=g.create((h,d)=>{globalThis.postMessage(h,d)},null);for(globalThis.onmessage=h=>M.onmessage(h.data,h.ports);a.length>0;){const h=a.shift();M.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&u();let w=!0;const a=[];globalThis.onmessage=l=>{if(!w){a.push(l);return}w=!1,R(l.data)}}(),J(K[27],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function F(w,a){const l=Math.pow(10,a);return Math.round(w*l)/l}class T{constructor(a,l,g,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=F(Math.max(Math.min(1,M),0),3)}static equals(a,l){return a.r===l.r&&a.g===l.g&&a.b===l.b&&a.a===l.a}}t.RGBA=T;class i{constructor(a,l,g,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.l=F(Math.max(Math.min(1,g),0),3),this.a=F(Math.max(Math.min(1,M),0),3)}static equals(a,l){return a.h===l.h&&a.s===l.s&&a.l===l.l&&a.a===l.a}static fromRGBA(a){const l=a.r/255,g=a.g/255,M=a.b/255,h=a.a,d=Math.max(l,g,M),e=Math.min(l,g,M);let A=0,y=0;const _=(e+d)/2,v=d-e;if(v>0){switch(y=Math.min(_<=.5?v/(2*_):v/(2-2*_),1),d){case l:A=(g-M)/v+(g<M?6:0);break;case g:A=(M-l)/v+2;break;case M:A=(l-g)/v+4;break}A*=60,A=Math.round(A)}return new i(A,y,_,h)}static i(a,l,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?a+(l-a)*6*g:g<1/2?l:g<2/3?a+(l-a)*(2/3-g)*6:a}static toRGBA(a){const l=a.h/360,{s:g,l:M,a:h}=a;let d,e,A;if(g===0)d=e=A=M;else{const y=M<.5?M*(1+g):M+g-M*g,_=2*M-y;d=i.i(_,y,l+1/3),e=i.i(_,y,l),A=i.i(_,y,l-1/3)}return new T(Math.round(d*255),Math.round(e*255),Math.round(A*255),h)}}t.HSLA=i;class u{constructor(a,l,g,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.v=F(Math.max(Math.min(1,g),0),3),this.a=F(Math.max(Math.min(1,M),0),3)}static equals(a,l){return a.h===l.h&&a.s===l.s&&a.v===l.v&&a.a===l.a}static fromRGBA(a){const l=a.r/255,g=a.g/255,M=a.b/255,h=Math.max(l,g,M),d=Math.min(l,g,M),e=h-d,A=h===0?0:e/h;let y;return e===0?y=0:h===l?y=((g-M)/e%6+6)%6:h===g?y=(M-l)/e+2:y=(l-g)/e+4,new u(Math.round(y*60),A,h,a.a)}static toRGBA(a){const{h:l,s:g,v:M,a:h}=a,d=M*g,e=d*(1-Math.abs(l/60%2-1)),A=M-d;let[y,_,v]=[0,0,0];return l<60?(y=d,_=e):l<120?(y=e,_=d):l<180?(_=d,v=e):l<240?(_=e,v=d):l<300?(y=e,v=d):l<=360&&(y=d,v=e),y=Math.round((y+A)*255),_=Math.round((_+A)*255),v=Math.round((v+A)*255),new T(y,_,v,h)}}t.HSVA=u;class R{static fromHex(a){return R.Format.CSS.parseHex(a)||R.red}static equals(a,l){return!a&&!l?!0:!a||!l?!1:a.equals(l)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:u.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof T)this.rgba=a;else if(a instanceof i)this.i=a,this.rgba=i.toRGBA(a);else if(a instanceof u)this.j=a,this.rgba=u.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&T.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&u.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=R.k(this.rgba.r),l=R.k(this.rgba.g),g=R.k(this.rgba.b),M=.2126*a+.7152*l+.0722*g;return F(M,4)}static k(a){const l=a/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(a){const l=this.getRelativeLuminance(),g=a.getRelativeLuminance();return l>g?(l+.05)/(g+.05):(g+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const l=this.getRelativeLuminance(),g=a.getRelativeLuminance();return l>g}isDarkerThan(a){const l=this.getRelativeLuminance(),g=a.getRelativeLuminance();return l<g}lighten(a){return new R(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new R(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:l,g,b:M,a:h}=this.rgba;return new R(new T(l,g,M,h*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const l=a.rgba,g=this.rgba.a,M=l.a,h=g+M*(1-g);if(h<1e-6)return R.transparent;const d=this.rgba.r*g/h+l.r*M*(1-g)/h,e=this.rgba.g*g/h+l.g*M*(1-g)/h,A=this.rgba.b*g/h+l.b*M*(1-g)/h;return new R(new T(d,e,A,h))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:l,g,b:M,a:h}=this.rgba;return new R(new T(a.rgba.r-h*(a.rgba.r-l),a.rgba.g-h*(a.rgba.g-g),a.rgba.b-h*(a.rgba.b-M),1))}flatten(...a){const l=a.reduceRight((g,M)=>R.o(M,g));return R.o(this,l)}static o(a,l){const g=1-a.rgba.a;return new R(new T(g*l.rgba.r+a.rgba.a*a.rgba.r,g*l.rgba.g+a.rgba.a*a.rgba.g,g*l.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(a,l,g){if(a.isLighterThan(l))return a;g=g||.5;const M=a.getRelativeLuminance(),h=l.getRelativeLuminance();return g=g*(h-M)/h,a.lighten(g)}static getDarkerColor(a,l,g){if(a.isDarkerThan(l))return a;g=g||.5;const M=a.getRelativeLuminance(),h=l.getRelativeLuminance();return g=g*(M-h)/M,a.darken(g)}}t.Color=R,R.white=new R(new T(255,255,255,1)),R.black=new R(new T(0,0,0,1)),R.red=new R(new T(255,0,0,1)),R.blue=new R(new T(0,0,255,1)),R.green=new R(new T(0,255,0,1)),R.cyan=new R(new T(0,255,255,1)),R.lightgrey=new R(new T(211,211,211,1)),R.transparent=new R(new T(0,0,0,0)),function(w){let a;(function(l){let g;(function(M){function h(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:w.Format.CSS.formatRGBA(r)}M.formatRGB=h;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}M.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(r)}M.formatHSL=e;function A(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}M.formatHSLA=A;function y(r){const s=r.toString(16);return s.length!==2?"0"+s:s}function _(r){return`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}`}M.formatHex=_;function v(r,s=!1){return s&&r.rgba.a===1?w.Format.CSS.formatHex(r):`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}${y(Math.round(r.rgba.a*255))}`}M.formatHexA=v;function D(r){return r.isOpaque()?w.Format.CSS.formatHex(r):w.Format.CSS.formatRGBA(r)}M.format=D;function m(r){const s=r.length;if(s===0||r.charCodeAt(0)!==35)return null;if(s===7){const b=16*L(r.charCodeAt(1))+L(r.charCodeAt(2)),f=16*L(r.charCodeAt(3))+L(r.charCodeAt(4)),p=16*L(r.charCodeAt(5))+L(r.charCodeAt(6));return new w(new T(b,f,p,1))}if(s===9){const b=16*L(r.charCodeAt(1))+L(r.charCodeAt(2)),f=16*L(r.charCodeAt(3))+L(r.charCodeAt(4)),p=16*L(r.charCodeAt(5))+L(r.charCodeAt(6)),c=16*L(r.charCodeAt(7))+L(r.charCodeAt(8));return new w(new T(b,f,p,c/255))}if(s===4){const b=L(r.charCodeAt(1)),f=L(r.charCodeAt(2)),p=L(r.charCodeAt(3));return new w(new T(16*b+b,16*f+f,16*p+p))}if(s===5){const b=L(r.charCodeAt(1)),f=L(r.charCodeAt(2)),p=L(r.charCodeAt(3)),c=L(r.charCodeAt(4));return new w(new T(16*b+b,16*f+f,16*p+p,(16*c+c)/255))}return null}M.parseHex=m;function L(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=l.CSS||(l.CSS={}))})(a=w.Format||(w.Format={}))}(R||(t.Color=R={}))}),J(K[28],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class F{constructor(i,u,R,w){this.originalStart=i,this.originalLength=u,this.modifiedStart=R,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=F}),J(K[2],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class F{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(b=>{b(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}t.ErrorHandler=F,t.errorHandler=new F;function T(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=T;function i(r){if(!r||typeof r!="object")return!1;const s=r;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){l(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function R(r){l(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=R;function w(r){if(r instanceof Error){const{name:s,message:b}=r,f=r.stacktrace||r.stack;return{$isError:!0,name:s,message:b,stack:f,noTelemetry:m.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=w;const a="Canceled";function l(r){return r instanceof g?!0:r instanceof Error&&r.name===a&&r.message===a}t.isCancellationError=l;class g extends Error{constructor(){super(a),this.name=this.message}}t.CancellationError=g;function M(){const r=new Error(a);return r.name=r.message,r}t.canceled=M;function h(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=h;function d(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=d;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function A(r){const s=new Error(`${r} has been disposed`);return s.name="DISPOSED",s}t.disposed=A;function y(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=y;class _ extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=_;class v extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=v;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=D;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const b=new m;return b.message=s.message,b.stack=s.stack,b}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=m;class L extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}t.BugIndicatingError=L}),J(K[29],ee([0,1,2]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function T(U,C=0){return U[U.length-(1+C)]}t.tail=T;function i(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.tail2=i;function u(U,C,O=(V,H)=>V===H){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let V=0,H=U.length;V<H;V++)if(!O(U[V],C[V]))return!1;return!0}t.equals=u;function R(U,C){const O=U.length-1;C<O&&(U[C]=U[O]),U.pop()}t.removeFastWithoutKeepingOrder=R;function w(U,C,O){return a(U.length,V=>O(U[V],C))}t.binarySearch=w;function a(U,C){let O=0,V=U-1;for(;O<=V;){const H=(O+V)/2|0,ne=C(H);if(ne<0)O=H+1;else if(ne>0)V=H-1;else return H}return-(O+1)}t.binarySearch2=a;function l(U,C){let O=0,V=U.length;if(V===0)return 0;for(;O<V;){const H=Math.floor((O+V)/2);C(U[H])?V=H:O=H+1}return O}t.findFirstInSorted=l;function g(U,C,O){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const V=C[Math.floor(C.length*Math.random())],H=[],ne=[],ie=[];for(const ae of C){const ce=O(ae,V);ce<0?H.push(ae):ce>0?ne.push(ae):ie.push(ae)}return U<H.length?g(U,H,O):U<H.length+ie.length?ie[0]:g(U-(H.length+ie.length),ne,O)}t.quickSelect=g;function M(U,C){const O=[];let V;for(const H of U.slice(0).sort(C))!V||C(V[0],H)!==0?(V=[H],O.push(V)):V.push(H);return O}t.groupBy=M;function h(U,C,O){const V=[];function H(ae,ce,he){if(ce===0&&he.length===0)return;const Le=V[V.length-1];Le&&Le.start+Le.deleteCount===ae?(Le.deleteCount+=ce,Le.toInsert.push(...he)):V.push({start:ae,deleteCount:ce,toInsert:he})}let ne=0,ie=0;for(;;){if(ne===U.length){H(ne,0,C.slice(ie));break}if(ie===C.length){H(ne,U.length-ne,[]);break}const ae=U[ne],ce=C[ie],he=O(ae,ce);he===0?(ne+=1,ie+=1):he<0?(H(ne,1,[]),ne+=1):he>0&&(H(ne,0,[ce]),ie+=1)}return V}t.sortedDiff=h;function d(U,C,O){const V=h(U,C,O),H=[],ne=[];for(const ie of V)H.push(...U.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:H,added:ne}}t.delta=d;function e(U,C,O){if(O===0)return[];const V=U.slice(0,O).sort(C);return y(U,C,V,O,U.length),V}t.top=e;function A(U,C,O,V,H){return O===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const ae=U.length,ce=U.slice(0,O).sort(C);for(let he=O,Le=Math.min(O+V,ae);he<ae;he=Le,Le=Math.min(Le+V,ae)){if(he>O&&await new Promise(ye=>setTimeout(ye)),H&&H.isCancellationRequested)throw new F.CancellationError;y(U,C,ce,he,Le)}return ce})().then(ne,ie)})}t.topAsync=A;function y(U,C,O,V,H){for(const ne=O.length;V<H;V++){const ie=U[V];if(C(ie,O[ne-1])<0){O.pop();const ae=l(O,ce=>C(ie,ce)<0);O.splice(ae,0,ie)}}}function _(U){return U.filter(C=>!!C)}t.coalesce=_;function v(U){let C=0;for(let O=0;O<U.length;O++)U[O]&&(U[C]=U[O],C+=1);U.length=C}t.coalesceInPlace=v;function D(U,C,O){U.splice(O,0,U.splice(C,1)[0])}t.move=D;function m(U){return!Array.isArray(U)||U.length===0}t.isFalsyOrEmpty=m;function L(U){return Array.isArray(U)&&U.length>0}t.isNonEmptyArray=L;function r(U,C=O=>O){const O=new Set;return U.filter(V=>{const H=C(V);return O.has(H)?!1:(O.add(H),!0)})}t.distinct=r;function s(U){const C=new Set;return O=>{const V=U(O);return C.has(V)?!1:(C.add(V),!0)}}t.uniqueFilter=s;function b(U,C){const O=f(U,C);if(O!==-1)return U[O]}t.findLast=b;function f(U,C){for(let O=U.length-1;O>=0;O--){const V=U[O];if(C(V))return O}return-1}t.lastIndex=f;function p(U,C){return U.length>0?U[0]:C}t.firstOrDefault=p;function c(U,C){return U.length>0?U[U.length-1]:C}t.lastOrDefault=c;function o(U,C,O=(V,H)=>V===H){let V=0;for(let H=0,ne=Math.min(U.length,C.length);H<ne&&O(U[H],C[H]);H++)V++;return V}t.commonPrefixLength=o;function N(U){return[].concat(...U)}t.flatten=N;function P(U,C){let O=typeof C=="number"?U:0;typeof C=="number"?O=U:(O=0,C=U);const V=[];if(O<=C)for(let H=O;H<C;H++)V.push(H);else for(let H=O;H>C;H--)V.push(H);return V}t.range=P;function S(U,C,O){return U.reduce((V,H)=>(V[C(H)]=O?O(H):H,V),Object.create(null))}t.index=S;function E(U,C){return U.push(C),()=>I(U,C)}t.insert=E;function I(U,C){const O=U.indexOf(C);if(O>-1)return U.splice(O,1),C}t.remove=I;function q(U,C,O){const V=U.slice(0,C),H=U.slice(C);return V.concat(O,H)}t.arrayInsert=q;function W(U,C){let O;if(typeof C=="number"){let V=C;O=()=>{const H=Math.sin(V++)*179426549;return H-Math.floor(H)}}else O=Math.random;for(let V=U.length-1;V>0;V-=1){const H=Math.floor(O()*(V+1)),ne=U[V];U[V]=U[H],U[H]=ne}}t.shuffle=W;function z(U,C){const O=U.indexOf(C);O>-1&&(U.splice(O,1),U.unshift(C))}t.pushToStart=z;function Z(U,C){const O=U.indexOf(C);O>-1&&(U.splice(O,1),U.push(C))}t.pushToEnd=Z;function Y(U,C){for(const O of C)U.push(O)}t.pushMany=Y;function G(U,C){return Array.isArray(U)?U.map(C):C(U)}t.mapArrayOrNot=G;function se(U){return Array.isArray(U)?U:[U]}t.asArray=se;function n(U){return U[Math.floor(Math.random()*U.length)]}t.getRandomElement=n;function me(U,C){for(const O of U){const V=C(O);if(V!==void 0)return V}}t.mapFind=me;function de(U,C,O){const V=we(U,C),H=U.length,ne=O.length;U.length=H+ne;for(let ie=H-1;ie>=V;ie--)U[ie+ne]=U[ie];for(let ie=0;ie<ne;ie++)U[ie+V]=O[ie]}t.insertInto=de;function be(U,C,O,V){const H=we(U,C),ne=U.splice(H,O);return de(U,H,V),ne}t.splice=be;function we(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var Ne;(function(U){function C(H){return H<0}U.isLessThan=C;function O(H){return H>0}U.isGreaterThan=O;function V(H){return H===0}U.isNeitherLessOrGreaterThan=V,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(Ne||(t.CompareResult=Ne={}));function le(U,C){return(O,V)=>C(U(O),U(V))}t.compareBy=le;function oe(...U){return(C,O)=>{for(const V of U){const H=V(C,O);if(!Ne.isNeitherLessOrGreaterThan(H))return H}return Ne.neitherLessOrGreaterThan}}t.tieBreakComparators=oe;const Ae=(U,C)=>U-C;t.numberComparator=Ae;function ve(U,C){if(U.length===0)return;let O=U[0];for(let V=1;V<U.length;V++){const H=U[V];C(H,O)>0&&(O=H)}return O}t.findMaxBy=ve;function De(U,C){if(U.length===0)return;let O=U[0];for(let V=1;V<U.length;V++){const H=U[V];C(H,O)>=0&&(O=H)}return O}t.findLastMaxBy=De;function Fe(U,C){return ve(U,(O,V)=>-C(O,V))}t.findMinBy=Fe;class te{constructor(C){this.f=C,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(C){let O=this.c;for(;O<this.f.length&&C(this.f[O]);)O++;const V=O===this.c?null:this.f.slice(this.c,O);return this.c=O,V}takeFromEndWhile(C){let O=this.d;for(;O>=0&&C(this.f[O]);)O--;const V=O===this.d?null:this.f.slice(O+1,this.d+1);return this.d=O,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const C=this.f[this.c];return this.c++,C}removeLast(){const C=this.f[this.d];return this.d--,C}takeCount(C){const O=this.f.slice(this.c,this.c+C);return this.c+=C,O}}t.ArrayQueue=te;class X{constructor(C){this.iterate=C}forEach(C){this.iterate(O=>(C(O),!0))}toArray(){const C=[];return this.iterate(O=>(C.push(O),!0)),C}filter(C){return new X(O=>this.iterate(V=>C(V)?O(V):!0))}map(C){return new X(O=>this.iterate(V=>O(C(V))))}some(C){let O=!1;return this.iterate(V=>(O=C(V),!O)),O}findFirst(C){let O;return this.iterate(V=>C(V)?(O=V,!1):!0),O}findLast(C){let O;return this.iterate(V=>(C(V)&&(O=V),!0)),O}findLastMaxBy(C){let O,V=!0;return this.iterate(H=>((V||Ne.isGreaterThan(C(H,O)))&&(V=!1,O=H),!0)),O}}t.CallbackIterable=X,X.empty=new X(U=>{})}),J(K[11],ee([0,1,2]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function T(a,l){if(!a)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=T;function i(a,l="Unreachable"){throw new Error(l)}t.assertNever=i;function u(a){if(!a)throw new F.BugIndicatingError("Assertion Failed")}t.assert=u;function R(a){if(!a()){debugger;a(),(0,F.onUnexpectedError)(new F.BugIndicatingError("Assertion Failed"))}}t.assertFn=R;function w(a,l){let g=0;for(;g<a.length-1;){const M=a[g],h=a[g+1];if(!l(M,h))return!1;g++}return!0}t.checkAdjacentItems=w}),J(K[14],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function F(T){const i=this;let u=!1,R;return function(){return u||(u=!0,R=T.apply(i,arguments)),R}}t.once=F}),J(K[15],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(T){function i(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}T.is=i;const u=Object.freeze([]);function R(){return u}T.empty=R;function*w(m){yield m}T.single=w;function a(m){return i(m)?m:w(m)}T.wrap=a;function l(m){return m||u}T.from=l;function g(m){return!m||m[Symbol.iterator]().next().done===!0}T.isEmpty=g;function M(m){return m[Symbol.iterator]().next().value}T.first=M;function h(m,L){for(const r of m)if(L(r))return!0;return!1}T.some=h;function d(m,L){for(const r of m)if(L(r))return r}T.find=d;function*e(m,L){for(const r of m)L(r)&&(yield r)}T.filter=e;function*A(m,L){let r=0;for(const s of m)yield L(s,r++)}T.map=A;function*y(...m){for(const L of m)for(const r of L)yield r}T.concat=y;function _(m,L,r){let s=r;for(const b of m)s=L(s,b);return s}T.reduce=_;function*v(m,L,r=m.length){for(L<0&&(L+=m.length),r<0?r+=m.length:r>m.length&&(r=m.length);L<r;L++)yield m[L]}T.slice=v;function D(m,L=Number.POSITIVE_INFINITY){const r=[];if(L===0)return[r,m];const s=m[Symbol.iterator]();for(let b=0;b<L;b++){const f=s.next();if(f.done)return[r,T.empty()];r.push(f.value)}return[r,{[Symbol.iterator](){return s}}]}T.consume=D})(F||(t.Iterable=F={}))}),J(K[30],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(F||(t.KeyCode=F={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(A,y){this._keyCodeToStr[A]=y,this._strToKeyCode[y.toLowerCase()]=A}keyCodeToStr(A){return this._keyCodeToStr[A]}strToKeyCode(A){return this._strToKeyCode[A.toLowerCase()]||0}}const u=new i,R=new i,w=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],l=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>l[e]||0,toString:e=>a[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",A=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",0,"VK_F20",e,e],[1,118,"F21",79,"F21",0,"VK_F21",e,e],[1,119,"F22",80,"F22",0,"VK_F22",e,e],[1,120,"F23",81,"F23",0,"VK_F23",e,e],[1,121,"F24",82,"F24",0,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],y=[],_=[];for(const v of A){const[D,m,L,r,s,b,f,p,c]=v;if(_[m]||(_[m]=!0,a[m]=L,l[L]=m,g[L.toLowerCase()]=m,D&&(t.IMMUTABLE_CODE_TO_KEY_CODE[m]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=m))),!y[r]){if(y[r]=!0,!s)throw new Error(`String representation missing for key code ${r} around scan code ${L}`);u.define(r,s),R.define(r,p||s),w.define(r,c||p||s)}b&&(t.EVENT_KEY_CODE_MAP[b]=r),f&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var M;(function(e){function A(L){return u.keyCodeToStr(L)}e.toString=A;function y(L){return u.strToKeyCode(L)}e.fromString=y;function _(L){return R.keyCodeToStr(L)}e.toUserSettingsUS=_;function v(L){return w.keyCodeToStr(L)}e.toUserSettingsGeneral=v;function D(L){return R.strToKeyCode(L)||w.strToKeyCode(L)}e.fromUserSettings=D;function m(L){if(L>=98&&L<=113)return null;switch(L){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(L)}e.toElectronAccelerator=m})(M||(t.KeyCodeUtils=M={}));var h;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(h||(t.KeyMod=h={}));function d(e,A){const y=(A&65535)<<16>>>0;return(e|y)>>>0}t.KeyChord=d}),J(K[31],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class F{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=F}),J(K[7],ee([0,1,14,15]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function R(c){u=c}if(t.setDisposableTracker=R,i){const c="__is_disposable_tracked__";R(new class{trackDisposable(o){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(N)},3e3)}setParent(o,N){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function w(c){return u?.trackDisposable(c),c}function a(c){u?.markAsDisposed(c)}function l(c,o){u?.setParent(c,o)}function g(c,o){if(u)for(const N of c)u.setParent(N,o)}function M(c){return u?.markAsSingleton(c),c}t.markAsSingleton=M;function h(c){return typeof c.dispose=="function"&&c.dispose.length===0}t.isDisposable=h;function d(c){if(T.Iterable.is(c)){const o=[];for(const N of c)if(N)try{N.dispose()}catch(P){o.push(P)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}t.dispose=d;function e(c){for(const o of c)h(o)&&o.dispose();return[]}t.disposeIfDisposable=e;function A(...c){const o=y(()=>d(c));return g(c,o),o}t.combinedDisposable=A;function y(c){const o=w({dispose:(0,F.once)(()=>{a(o),c()})});return o}t.toDisposable=y;class _{constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(a(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return l(o,this),this.g?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(o),o}}t.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new _,w(this),l(this.q,this)}dispose(){a(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}t.Disposable=v,v.None=Object.freeze({dispose(){}});class D{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&l(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&l(o,null),o}}t.MutableDisposable=D;class m{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=m;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(o){let N=o;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,a(this))},this}}t.SafeDisposable=L;class r{constructor(){this.a=new Map}acquire(o,...N){let P=this.a.get(o);P||(P={counter:0,object:this.b(o,...N)},this.a.set(o,P));const{object:S}=P,E=(0,F.once)(()=>{--P.counter===0&&(this.c(o,P.object),this.a.delete(o))});return P.counter++,{object:S,dispose:E}}}t.ReferenceCollection=r;class s{constructor(o){this.a=o}async acquire(o,...N){const P=this.a.acquire(o,...N);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(S){throw P.dispose(),S}}}t.AsyncReferenceCollection=s;class b{constructor(o){this.object=o}dispose(){}}t.ImmortalReference=b;function f(c){const o=new _;try{c(o)}finally{o.dispose()}}t.disposeOnReturn=f;class p{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,N,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(o)?.dispose(),this.a.set(o,N)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=p}),J(K[16],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class F{constructor(u){this.element=u,this.next=F.Undefined,this.prev=F.Undefined}}F.Undefined=new F(void 0);class T{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let u=this.a;for(;u!==F.Undefined;){const R=u.next;u.prev=F.Undefined,u.next=F.Undefined,u=R}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(u){return this.d(u,!1)}push(u){return this.d(u,!0)}d(u,R){const w=new F(u);if(this.a===F.Undefined)this.a=w,this.b=w;else if(R){const l=this.b;this.b=w,w.prev=l,l.next=w}else{const l=this.a;this.a=w,w.next=l,l.prev=w}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(w))}}shift(){if(this.a!==F.Undefined){const u=this.a.element;return this.e(this.a),u}}pop(){if(this.b!==F.Undefined){const u=this.b.element;return this.e(this.b),u}}e(u){if(u.prev!==F.Undefined&&u.next!==F.Undefined){const R=u.prev;R.next=u.next,u.next.prev=R}else u.prev===F.Undefined&&u.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):u.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):u.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let u=this.a;for(;u!==F.Undefined;)yield u.element,u=u.next}}t.LinkedList=T}),J(K[8],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let F=!1,T=!1,i=!1,u=!1,R=!1,w=!1,a=!1,l=!1,g=!1,M=!1,h,d=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT,A,y;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?_=t.globals.vscode.process:typeof process<"u"&&(_=process);const v=typeof _?.versions?.electron=="string",D=v&&_?.type==="renderer";if(typeof navigator=="object"&&!D){y=navigator.userAgent,F=y.indexOf("Windows")>=0,T=y.indexOf("Macintosh")>=0,l=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,i=y.indexOf("Linux")>=0,M=y?.indexOf("Mobi")>=0,w=!0,h=t.LANGUAGE_DEFAULT,d=h,e=navigator.language;const o=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),N=o&&o.getAttribute("data-settings");if(N)try{const P=JSON.parse(N),S=P.availableLanguages["*"];h=P.locale,e=P.osLocale,d=S||t.LANGUAGE_DEFAULT,A=P._translationsConfigFile}catch{}}else if(typeof _=="object"){F=_.platform==="win32",T=_.platform==="darwin",i=_.platform==="linux",u=i&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,a=v,g=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.LANGUAGE_DEFAULT,d=t.LANGUAGE_DEFAULT;const o=_.env.VSCODE_NLS_CONFIG;if(o)try{const N=JSON.parse(o),P=N.availableLanguages["*"];h=N.locale,e=N.osLocale,d=P||t.LANGUAGE_DEFAULT,A=N._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var m;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(m||(t.Platform=m={}));function L(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=L;let r=0;T?r=1:F?r=3:i&&(r=2),t.isWindows=F,t.isMacintosh=T,t.isLinux=i,t.isLinuxSnap=u,t.isNative=R,t.isElectron=a,t.isWeb=w,t.isWebWorker=w&&typeof t.globals.importScripts=="function",t.isIOS=l,t.isMobile=M,t.isCI=g,t.platform=r,t.userAgent=y,t.language=d;var s;(function(o){function N(){return t.language}o.value=N;function P(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}o.isDefaultVariant=P;function S(){return t.language==="en"}o.isDefault=S})(s||(t.Language=s={})),t.locale=h,t.platformLocale=e,t.translationsConfigFile=A,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const o=[];t.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let S=0,E=o.length;S<E;S++){const I=o[S];if(I.id===P.data.vscodeScheduleAsyncWork){o.splice(S,1),I.callback();return}}});let N=0;return P=>{const S=++N;o.push({id:S,callback:P}),t.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return o=>setTimeout(o)})();var b;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(b||(t.OperatingSystem=b={})),t.OS=T||l?2:F?1:3;let f=!0,p=!1;function c(){if(!p){p=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,f=new Uint16Array(o.buffer)[0]===(2<<8)+1}return f}t.isLittleEndian=c,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),J(K[32],ee([0,1,8]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let T;if(typeof F.globals.vscode<"u"&&typeof F.globals.vscode.process<"u"){const i=F.globals.vscode.process;T={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return F.isWindows?"win32":F.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.platform=T.platform,t.arch=T.arch}),J(K[33],ee([0,1,32]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const T=65,i=97,u=90,R=122,w=46,a=47,l=92,g=58,M=63;class h extends Error{constructor(s,b,f){let p;typeof b=="string"&&b.indexOf("not ")===0?(p="must not be",b=b.replace(/^not /,"")):p="must be";const c=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${c} ${p} of type ${b}`;o+=`. Received type ${typeof f}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,s){if(r===null||typeof r!="object")throw new h(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new h(s,"string",r)}const A=F.platform==="win32";function y(r){return r===a||r===l}function _(r){return r===a}function v(r){return r>=T&&r<=u||r>=i&&r<=R}function D(r,s,b,f){let p="",c=0,o=-1,N=0,P=0;for(let S=0;S<=r.length;++S){if(S<r.length)P=r.charCodeAt(S);else{if(f(P))break;P=a}if(f(P)){if(!(o===S-1||N===1))if(N===2){if(p.length<2||c!==2||p.charCodeAt(p.length-1)!==w||p.charCodeAt(p.length-2)!==w){if(p.length>2){const E=p.lastIndexOf(b);E===-1?(p="",c=0):(p=p.slice(0,E),c=p.length-1-p.lastIndexOf(b)),o=S,N=0;continue}else if(p.length!==0){p="",c=0,o=S,N=0;continue}}s&&(p+=p.length>0?`${b}..`:"..",c=2)}else p.length>0?p+=`${b}${r.slice(o+1,S)}`:p=r.slice(o+1,S),c=S-o-1;o=S,N=0}else P===w&&N!==-1?++N:N=-1}return p}function m(r,s){d(s,"pathObject");const b=s.dir||s.root,f=s.base||`${s.name||""}${s.ext||""}`;return b?b===s.root?`${b}${f}`:`${b}${r}${f}`:f}t.win32={resolve(...r){let s="",b="",f=!1;for(let p=r.length-1;p>=-1;p--){let c;if(p>=0){if(c=r[p],e(c,"path"),c.length===0)continue}else s.length===0?c=F.cwd():(c=F.env[`=${s}`]||F.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==s.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${s}\\`));const o=c.length;let N=0,P="",S=!1;const E=c.charCodeAt(0);if(o===1)y(E)&&(N=1,S=!0);else if(y(E))if(S=!0,y(c.charCodeAt(1))){let I=2,q=I;for(;I<o&&!y(c.charCodeAt(I));)I++;if(I<o&&I!==q){const W=c.slice(q,I);for(q=I;I<o&&y(c.charCodeAt(I));)I++;if(I<o&&I!==q){for(q=I;I<o&&!y(c.charCodeAt(I));)I++;(I===o||I!==q)&&(P=`\\\\${W}\\${c.slice(q,I)}`,N=I)}}}else N=1;else v(E)&&c.charCodeAt(1)===g&&(P=c.slice(0,2),N=2,o>2&&y(c.charCodeAt(2))&&(S=!0,N=3));if(P.length>0)if(s.length>0){if(P.toLowerCase()!==s.toLowerCase())continue}else s=P;if(f){if(s.length>0)break}else if(b=`${c.slice(N)}\\${b}`,f=S,S&&s.length>0)break}return b=D(b,!f,"\\",y),f?`${s}\\${b}`:`${s}${b}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let b=0,f,p=!1;const c=r.charCodeAt(0);if(s===1)return _(c)?"\\":r;if(y(c))if(p=!0,y(r.charCodeAt(1))){let N=2,P=N;for(;N<s&&!y(r.charCodeAt(N));)N++;if(N<s&&N!==P){const S=r.slice(P,N);for(P=N;N<s&&y(r.charCodeAt(N));)N++;if(N<s&&N!==P){for(P=N;N<s&&!y(r.charCodeAt(N));)N++;if(N===s)return`\\\\${S}\\${r.slice(P)}\\`;N!==P&&(f=`\\\\${S}\\${r.slice(P,N)}`,b=N)}}}else b=1;else v(c)&&r.charCodeAt(1)===g&&(f=r.slice(0,2),b=2,s>2&&y(r.charCodeAt(2))&&(p=!0,b=3));let o=b<s?D(r.slice(b),!p,"\\",y):"";return o.length===0&&!p&&(o="."),o.length>0&&y(r.charCodeAt(s-1))&&(o+="\\"),f===void 0?p?`\\${o}`:o:p?`${f}\\${o}`:`${f}${o}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const b=r.charCodeAt(0);return y(b)||s>2&&v(b)&&r.charCodeAt(1)===g&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,b;for(let c=0;c<r.length;++c){const o=r[c];e(o,"path"),o.length>0&&(s===void 0?s=b=o:s+=`\\${o}`)}if(s===void 0)return".";let f=!0,p=0;if(typeof b=="string"&&y(b.charCodeAt(0))){++p;const c=b.length;c>1&&y(b.charCodeAt(1))&&(++p,c>2&&(y(b.charCodeAt(2))?++p:f=!1))}if(f){for(;p<s.length&&y(s.charCodeAt(p));)p++;p>=2&&(s=`\\${s.slice(p)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const b=t.win32.resolve(r),f=t.win32.resolve(s);if(b===f||(r=b.toLowerCase(),s=f.toLowerCase(),r===s))return"";let p=0;for(;p<r.length&&r.charCodeAt(p)===l;)p++;let c=r.length;for(;c-1>p&&r.charCodeAt(c-1)===l;)c--;const o=c-p;let N=0;for(;N<s.length&&s.charCodeAt(N)===l;)N++;let P=s.length;for(;P-1>N&&s.charCodeAt(P-1)===l;)P--;const S=P-N,E=o<S?o:S;let I=-1,q=0;for(;q<E;q++){const z=r.charCodeAt(p+q);if(z!==s.charCodeAt(N+q))break;z===l&&(I=q)}if(q!==E){if(I===-1)return f}else{if(S>E){if(s.charCodeAt(N+q)===l)return f.slice(N+q+1);if(q===2)return f.slice(N+q)}o>E&&(r.charCodeAt(p+q)===l?I=q:q===2&&(I=3)),I===-1&&(I=0)}let W="";for(q=p+I+1;q<=c;++q)(q===c||r.charCodeAt(q)===l)&&(W+=W.length===0?"..":"\\..");return N+=I,W.length>0?`${W}${f.slice(N,P)}`:(f.charCodeAt(N)===l&&++N,f.slice(N,P))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const b=s.charCodeAt(2);if(b!==M&&b!==w)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(v(s.charCodeAt(0))&&s.charCodeAt(1)===g&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let b=-1,f=0;const p=r.charCodeAt(0);if(s===1)return y(p)?r:".";if(y(p)){if(b=f=1,y(r.charCodeAt(1))){let N=2,P=N;for(;N<s&&!y(r.charCodeAt(N));)N++;if(N<s&&N!==P){for(P=N;N<s&&y(r.charCodeAt(N));)N++;if(N<s&&N!==P){for(P=N;N<s&&!y(r.charCodeAt(N));)N++;if(N===s)return r;N!==P&&(b=f=N+1)}}}}else v(p)&&r.charCodeAt(1)===g&&(b=s>2&&y(r.charCodeAt(2))?3:2,f=b);let c=-1,o=!0;for(let N=s-1;N>=f;--N)if(y(r.charCodeAt(N))){if(!o){c=N;break}}else o=!1;if(c===-1){if(b===-1)return".";c=b}return r.slice(0,c)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let b=0,f=-1,p=!0,c;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===g&&(b=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let o=s.length-1,N=-1;for(c=r.length-1;c>=b;--c){const P=r.charCodeAt(c);if(y(P)){if(!p){b=c+1;break}}else N===-1&&(p=!1,N=c+1),o>=0&&(P===s.charCodeAt(o)?--o===-1&&(f=c):(o=-1,f=N))}return b===f?f=N:f===-1&&(f=r.length),r.slice(b,f)}for(c=r.length-1;c>=b;--c)if(y(r.charCodeAt(c))){if(!p){b=c+1;break}}else f===-1&&(p=!1,f=c+1);return f===-1?"":r.slice(b,f)},extname(r){e(r,"path");let s=0,b=-1,f=0,p=-1,c=!0,o=0;r.length>=2&&r.charCodeAt(1)===g&&v(r.charCodeAt(0))&&(s=f=2);for(let N=r.length-1;N>=s;--N){const P=r.charCodeAt(N);if(y(P)){if(!c){f=N+1;break}continue}p===-1&&(c=!1,p=N+1),P===w?b===-1?b=N:o!==1&&(o=1):b!==-1&&(o=-1)}return b===-1||p===-1||o===0||o===1&&b===p-1&&b===f+1?"":r.slice(b,p)},format:m.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const b=r.length;let f=0,p=r.charCodeAt(0);if(b===1)return y(p)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(y(p)){if(f=1,y(r.charCodeAt(1))){let I=2,q=I;for(;I<b&&!y(r.charCodeAt(I));)I++;if(I<b&&I!==q){for(q=I;I<b&&y(r.charCodeAt(I));)I++;if(I<b&&I!==q){for(q=I;I<b&&!y(r.charCodeAt(I));)I++;I===b?f=I:I!==q&&(f=I+1)}}}}else if(v(p)&&r.charCodeAt(1)===g){if(b<=2)return s.root=s.dir=r,s;if(f=2,y(r.charCodeAt(2))){if(b===3)return s.root=s.dir=r,s;f=3}}f>0&&(s.root=r.slice(0,f));let c=-1,o=f,N=-1,P=!0,S=r.length-1,E=0;for(;S>=f;--S){if(p=r.charCodeAt(S),y(p)){if(!P){o=S+1;break}continue}N===-1&&(P=!1,N=S+1),p===w?c===-1?c=S:E!==1&&(E=1):c!==-1&&(E=-1)}return N!==-1&&(c===-1||E===0||E===1&&c===N-1&&c===o+1?s.base=s.name=r.slice(o,N):(s.name=r.slice(o,c),s.base=r.slice(o,N),s.ext=r.slice(c,N))),o>0&&o!==f?s.dir=r.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(A){const r=/\\/g;return()=>{const s=F.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>F.cwd()})();t.posix={resolve(...r){let s="",b=!1;for(let f=r.length-1;f>=-1&&!b;f--){const p=f>=0?r[f]:L();e(p,"path"),p.length!==0&&(s=`${p}/${s}`,b=p.charCodeAt(0)===a)}return s=D(s,!b,"/",_),b?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a,b=r.charCodeAt(r.length-1)===a;return r=D(r,!s,"/",_),r.length===0?s?"/":b?"./":".":(b&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let s;for(let b=0;b<r.length;++b){const f=r[b];e(f,"path"),f.length>0&&(s===void 0?s=f:s+=`/${f}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const b=1,f=r.length,p=f-b,c=1,o=s.length-c,N=p<o?p:o;let P=-1,S=0;for(;S<N;S++){const I=r.charCodeAt(b+S);if(I!==s.charCodeAt(c+S))break;I===a&&(P=S)}if(S===N)if(o>N){if(s.charCodeAt(c+S)===a)return s.slice(c+S+1);if(S===0)return s.slice(c+S)}else p>N&&(r.charCodeAt(b+S)===a?P=S:S===0&&(P=0));let E="";for(S=b+P+1;S<=f;++S)(S===f||r.charCodeAt(S)===a)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(c+P)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a;let b=-1,f=!0;for(let p=r.length-1;p>=1;--p)if(r.charCodeAt(p)===a){if(!f){b=p;break}}else f=!1;return b===-1?s?"/":".":s&&b===1?"//":r.slice(0,b)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let b=0,f=-1,p=!0,c;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let o=s.length-1,N=-1;for(c=r.length-1;c>=0;--c){const P=r.charCodeAt(c);if(P===a){if(!p){b=c+1;break}}else N===-1&&(p=!1,N=c+1),o>=0&&(P===s.charCodeAt(o)?--o===-1&&(f=c):(o=-1,f=N))}return b===f?f=N:f===-1&&(f=r.length),r.slice(b,f)}for(c=r.length-1;c>=0;--c)if(r.charCodeAt(c)===a){if(!p){b=c+1;break}}else f===-1&&(p=!1,f=c+1);return f===-1?"":r.slice(b,f)},extname(r){e(r,"path");let s=-1,b=0,f=-1,p=!0,c=0;for(let o=r.length-1;o>=0;--o){const N=r.charCodeAt(o);if(N===a){if(!p){b=o+1;break}continue}f===-1&&(p=!1,f=o+1),N===w?s===-1?s=o:c!==1&&(c=1):s!==-1&&(c=-1)}return s===-1||f===-1||c===0||c===1&&s===f-1&&s===b+1?"":r.slice(s,f)},format:m.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const b=r.charCodeAt(0)===a;let f;b?(s.root="/",f=1):f=0;let p=-1,c=0,o=-1,N=!0,P=r.length-1,S=0;for(;P>=f;--P){const E=r.charCodeAt(P);if(E===a){if(!N){c=P+1;break}continue}o===-1&&(N=!1,o=P+1),E===w?p===-1?p=P:S!==1&&(S=1):p!==-1&&(S=-1)}if(o!==-1){const E=c===0&&b?1:c;p===-1||S===0||S===1&&p===o-1&&p===c+1?s.base=s.name=r.slice(E,o):(s.name=r.slice(E,p),s.base=r.slice(E,o),s.ext=r.slice(p,o))}return c>0?s.dir=r.slice(0,c-1):b&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=A?t.win32.normalize:t.posix.normalize,t.isAbsolute=A?t.win32.isAbsolute:t.posix.isAbsolute,t.join=A?t.win32.join:t.posix.join,t.resolve=A?t.win32.resolve:t.posix.resolve,t.relative=A?t.win32.relative:t.posix.relative,t.dirname=A?t.win32.dirname:t.posix.dirname,t.basename=A?t.win32.basename:t.posix.basename,t.extname=A?t.win32.extname:t.posix.extname,t.format=A?t.win32.format:t.posix.format,t.parse=A?t.win32.parse:t.posix.parse,t.toNamespacedPath=A?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=A?t.win32.sep:t.posix.sep,t.delimiter=A?t.win32.delimiter:t.posix.delimiter}),J(K[17],ee([0,1,8]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const T=F.globals.performance&&typeof F.globals.performance.now=="function";class i{static create(R=!0){return new i(R)}constructor(R){this.a=T&&R,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?F.globals.performance.now():Date.now()}}t.StopWatch=i}),J(K[9],ee([0,1,2,14,7,16,17]),function(j,t,F,T,i,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,a=!1;var l;(function(c){c.None=()=>i.Disposable.None;function o(te){if(a){const{onDidAddListener:X}=te,U=e.create();let C=0;te.onDidAddListener=()=>{++C===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),X?.()}}}function N(te,X){return Y(te,()=>{},0,void 0,!0,void 0,X)}c.defer=N;function P(te){return(X,U=null,C)=>{let O=!1,V;return V=te(H=>{if(!O)return V?V.dispose():O=!0,X.call(U,H)},null,C),O&&V.dispose(),V}}c.once=P;function S(te,X,U){return Z((C,O=null,V)=>te(H=>C.call(O,X(H)),null,V),U)}c.map=S;function E(te,X,U){return Z((C,O=null,V)=>te(H=>{X(H),C.call(O,H)},null,V),U)}c.forEach=E;function I(te,X,U){return Z((C,O=null,V)=>te(H=>X(H)&&C.call(O,H),null,V),U)}c.filter=I;function q(te){return te}c.signal=q;function W(...te){return(X,U=null,C)=>(0,i.combinedDisposable)(...te.map(O=>O(V=>X.call(U,V),null,C)))}c.any=W;function z(te,X,U,C){let O=U;return S(te,V=>(O=X(O,V),O),C)}c.reduce=z;function Z(te,X){let U;const C={onWillAddFirstListener(){U=te(O.fire,O)},onDidRemoveLastListener(){U?.dispose()}};X||o(C);const O=new y(C);return X?.add(O),O.event}function Y(te,X,U=100,C=!1,O=!1,V,H){let ne,ie,ae,ce=0,he;const Le={leakWarningThreshold:V,onWillAddFirstListener(){ne=te(Se=>{ce++,ie=X(ie,Se),C&&!ae&&(ye.fire(ie),ie=void 0),he=()=>{const Ie=ie;ie=void 0,ae=void 0,(!C||ce>1)&&ye.fire(Ie),ce=0},typeof U=="number"?(clearTimeout(ae),ae=setTimeout(he,U)):ae===void 0&&(ae=0,queueMicrotask(he))})},onWillRemoveListener(){O&&ce>0&&he?.()},onDidRemoveLastListener(){he=void 0,ne.dispose()}};H||o(Le);const ye=new y(Le);return H?.add(ye),ye.event}c.debounce=Y;function G(te,X=0,U){return c.debounce(te,(C,O)=>C?(C.push(O),C):[O],X,void 0,!0,void 0,U)}c.accumulate=G;function se(te,X=(C,O)=>C===O,U){let C=!0,O;return I(te,V=>{const H=C||!X(V,O);return C=!1,O=V,H},U)}c.latch=se;function n(te,X,U){return[c.filter(te,X,U),c.filter(te,C=>!X(C),U)]}c.split=n;function me(te,X=!1,U=[]){let C=U.slice(),O=te(ne=>{C?C.push(ne):H.fire(ne)});const V=()=>{C?.forEach(ne=>H.fire(ne)),C=null},H=new y({onWillAddFirstListener(){O||(O=te(ne=>H.fire(ne)))},onDidAddFirstListener(){C&&(X?setTimeout(V):V())},onDidRemoveLastListener(){O&&O.dispose(),O=null}});return H.event}c.buffer=me;class de{constructor(X){this.event=X,this.c=new i.DisposableStore}map(X){return new de(S(this.event,X,this.c))}forEach(X){return new de(E(this.event,X,this.c))}filter(X){return new de(I(this.event,X,this.c))}reduce(X,U){return new de(z(this.event,X,U,this.c))}latch(){return new de(se(this.event,void 0,this.c))}debounce(X,U=100,C=!1,O=!1,V){return new de(Y(this.event,X,U,C,O,V,this.c))}on(X,U,C){return this.event(X,U,C)}once(X,U,C){return P(this.event)(X,U,C)}dispose(){this.c.dispose()}}function be(te){return new de(te)}c.chain=be;function we(te,X,U=C=>C){const C=(...ne)=>H.fire(U(...ne)),O=()=>te.on(X,C),V=()=>te.removeListener(X,C),H=new y({onWillAddFirstListener:O,onDidRemoveLastListener:V});return H.event}c.fromNodeEventEmitter=we;function Ne(te,X,U=C=>C){const C=(...ne)=>H.fire(U(...ne)),O=()=>te.addEventListener(X,C),V=()=>te.removeEventListener(X,C),H=new y({onWillAddFirstListener:O,onDidRemoveLastListener:V});return H.event}c.fromDOMEventEmitter=Ne;function le(te){return new Promise(X=>P(te)(X))}c.toPromise=le;function oe(te,X){return X(void 0),te(U=>X(U))}c.runAndSubscribe=oe;function Ae(te,X){let U=null;function C(V){U?.dispose(),U=new i.DisposableStore,X(V,U)}C(void 0);const O=te(V=>C(V));return(0,i.toDisposable)(()=>{O.dispose(),U?.dispose()})}c.runAndSubscribeWithStore=Ae;class ve{constructor(X,U){this._observable=X,this.c=0,this.d=!1;const C={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};U||o(C),this.emitter=new y(C),U&&U.add(this.emitter)}beginUpdate(X){this.c++}handlePossibleChange(X){}handleChange(X,U){this.d=!0}endUpdate(X){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function De(te,X){return new ve(te,X).emitter.event}c.fromObservable=De;function Fe(te){return X=>{let U=0,C=!1;const O={beginUpdate(){U++},endUpdate(){U--,U===0&&(te.reportChanges(),C&&(C=!1,X()))},handlePossibleChange(){},handleChange(){C=!0}};return te.addObserver(O),{dispose(){te.removeObserver(O)}}}}c.fromObservableLight=Fe})(l||(t.Event=l={}));class g{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${g.c++}`,g.all.add(this)}start(o){this.d=new R.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=g,g.all=new Set,g.c=0;let M=-1;function h(c){const o=M;return M=c,{dispose(){M=o}}}t.setGlobalLeakWarningThreshold=h;class d{constructor(o,N=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=N,this.d=0}dispose(){this.c?.clear()}check(o,N){const P=this.threshold;if(P<=0||N<P)return;this.c||(this.c=new Map);const S=this.c.get(o.value)||0;if(this.c.set(o.value,S+1),this.d-=1,this.d<=0){this.d=P*.5;let E,I=0;for(const[q,W]of this.c)(!E||I<W)&&(E=q,I=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${I}):`),console.warn(E)}return()=>{const E=this.c.get(o.value)||0;this.c.set(o.value,E-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class A{constructor(o,N,P){this.callback=o,this.callbackThis=N,this.stack=P,this.subscription=new i.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class y{constructor(o){this.j=!1,this.d=o,this.f=M>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??M):void 0,this.g=this.d?._profName?new g(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const o=Array.from(this.q);queueMicrotask(()=>{for(const N of o)N.subscription.isset()&&(N.subscription.unset(),N.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,N,P)=>{if(this.q||(this.q=new u.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const S=this.q.isEmpty();S&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let E,I;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(I=e.create(),E=this.f.check(I,this.q.size+1)),w&&(I=I??e.create());const q=new A(o,N,I),W=this.q.push(q);S&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,N);const z=q.subscription.set(()=>{E?.(),this.j||(this.d?.onWillRemoveListener?.(this),W(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return P instanceof i.DisposableStore?P.add(z):Array.isArray(P)&&P.push(z),z}),this.l}fire(o){if(this.q){this.m||(this.m=new v(this.d?.onListenerError));for(const N of this.q)this.m.push(this,N,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=y;class _{constructor(o=F.onUnexpectedError){this.d=o,this.c=new u.LinkedList}get size(){return this.c.size}push(o,N,P){this.c.push(new D(o,N,P))}clear(o){const N=new u.LinkedList;for(const P of this.c)P.emitter!==o&&N.push(P);this.c=N}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(N){this.d(N)}}}}t.EventDeliveryQueue=_;class v extends _{clear(o){this.c.clear()}}class D{constructor(o,N,P){this.emitter=o,this.listener=N,this.event=P}}class m extends y{async fireAsync(o,N,P){if(this.q){this.c||(this.c=new u.LinkedList);for(const S of this.q)this.c.push([S,o]);for(;this.c.size>0&&!N.isCancellationRequested;){const[S,E]=this.c.shift(),I=[],q={...E,token:N,waitUntil:W=>{if(Object.isFrozen(I))throw new Error("waitUntil can NOT be called asynchronous");P&&(W=P(W,S.callback)),I.push(W)}};try{S.invoke(q)}catch(W){(0,F.onUnexpectedError)(W);continue}Object.freeze(I),await Promise.allSettled(I).then(W=>{for(const z of W)z.status==="rejected"&&(0,F.onUnexpectedError)(z.reason)})}}}}t.AsyncEmitter=m;class L extends y{constructor(o){super(o),this.h=0,this.s=new u.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}t.PauseableEmitter=L;class r extends L{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}t.DebounceEmitter=r;class s extends y{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){this.hasListeners()&&(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(N=>super.fire(N)),this.c=[]}))}}t.MicrotaskEmitter=s;class b{constructor(){this.d=!1,this.f=[],this.c=new y({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const N={event:o,listener:null};this.f.push(N),this.d&&this.j(N);const P=()=>{this.d&&this.k(N);const S=this.f.indexOf(N);this.f.splice(S,1)};return(0,i.toDisposable)((0,T.once)(P))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(N=>this.c.fire(N))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=b;class f{constructor(){this.c=[]}wrapEvent(o){return(N,P,S)=>o(E=>{const I=this.c[this.c.length-1];I?I.push(()=>N.call(P,E)):N.call(P,E)},void 0,S)}bufferEvents(o){const N=[];this.c.push(N);const P=o();return this.c.pop(),N.forEach(S=>S()),P}}t.EventBufferer=f;class p{constructor(){this.c=!1,this.d=l.None,this.f=i.Disposable.None,this.g=new y({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=p}),J(K[18],ee([0,1,9]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const T=Object.freeze(function(w,a){const l=setTimeout(w.bind(a),0);return{dispose(){clearTimeout(l)}}});var i;(function(w){function a(l){return l===w.None||l===w.Cancelled||l instanceof u?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}w.isCancellationToken=a,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i||(t.CancellationToken=i={}));class u{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new F.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(a){this.a=void 0,this.b=void 0,this.b=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new u),this.a}cancel(){this.a?this.a instanceof u&&this.a.cancel():this.a=i.Cancelled}dispose(a=!1){a&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof u&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=R}),J(K[34],ee([0,1,18]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class T{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new F.CancellationTokenSource,a=this.b(w.token);return this.a={promise:a,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=T;class i{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const a=JSON.stringify(w);return this.b!==a&&(this.b=a,this.a=this.c(w)),this.a}}t.LRUCachedFunction=i;class u{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const a=this.b(w);return this.a.set(w,a),a}}t.CachedFunction=u}),J(K[5],ee([0,1,34,31]),function(j,t,F,T){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(k){return!k||typeof k!="string"?!0:k.trim().length===0}t.isFalsyOrWhitespace=u;const R=/{(\d+)}/g;function w(k,...B){return B.length===0?k:k.replace(R,function(x,$){const Q=parseInt($,10);return isNaN(Q)||Q<0||Q>=B.length?x:B[Q]})}t.format=w;const a=/{([^}]+)}/g;function l(k,B){return k.replace(a,(x,$)=>B[$]??x)}t.format2=l;function g(k){return k.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=g;function M(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=M;function h(k,B){let x=0;const $=B.charCodeAt(0);for(let Q=k.length-1;Q>=0;Q--)k.charCodeAt(Q)===$&&x++;return x}t.count=h;function d(k,B,x="\u2026"){return k.length<=B?k:`${k.substr(0,B)}${x}`}t.truncate=d;function e(k,B=" "){const x=A(k,B);return y(x,B)}t.trim=e;function A(k,B){if(!k||!B)return k;const x=B.length;if(x===0||k.length===0)return k;let $=0;for(;k.indexOf(B,$)===$;)$=$+x;return k.substring($)}t.ltrim=A;function y(k,B){if(!k||!B)return k;const x=B.length,$=k.length;if(x===0||$===0)return k;let Q=$,re=-1;for(;re=k.lastIndexOf(B,Q-1),!(re===-1||re+x!==Q);){if(re===0)return"";Q=re}return k.substring(0,Q)}t.rtrim=y;function _(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function v(k){return k.replace(/\*/g,"")}t.stripWildcards=v;function D(k,B,x={}){if(!k)throw new Error("Cannot create regex from empty string");B||(k=M(k)),x.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let $="";return x.global&&($+="g"),x.matchCase||($+="i"),x.multiline&&($+="m"),x.unicode&&($+="u"),new RegExp(k,$)}t.createRegExp=D;function m(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}t.regExpLeadsToEndlessLoop=m;function L(k){return!!k.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=L;function r(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}t.regExpFlags=r;function s(k){return k.split(/\r\n|\r|\n/)}t.splitLines=s;function b(k){for(let B=0,x=k.length;B<x;B++){const $=k.charCodeAt(B);if($!==32&&$!==9)return B}return-1}t.firstNonWhitespaceIndex=b;function f(k,B=0,x=k.length){for(let $=B;$<x;$++){const Q=k.charCodeAt($);if(Q!==32&&Q!==9)return k.substring(B,$)}return k.substring(B,x)}t.getLeadingWhitespace=f;function p(k,B=k.length-1){for(let x=B;x>=0;x--){const $=k.charCodeAt(x);if($!==32&&$!==9)return x}return-1}t.lastNonWhitespaceIndex=p;function c(k,B,x){const $=[];let Q=0;for(const re of k.matchAll(B)){if($.push(k.slice(Q,re.index)),re.index===void 0)throw new Error("match.index should be defined");Q=re.index+re[0].length,$.push(x(re[0],...re.slice(1),re.index,k,re.groups))}return $.push(k.slice(Q)),Promise.all($).then(re=>re.join(""))}t.replaceAsync=c;function o(k,B){return k<B?-1:k>B?1:0}t.compare=o;function N(k,B,x=0,$=k.length,Q=0,re=B.length){for(;x<$&&Q<re;x++,Q++){const Re=k.charCodeAt(x),ue=B.charCodeAt(Q);if(Re<ue)return-1;if(Re>ue)return 1}const ge=$-x,Pe=re-Q;return ge<Pe?-1:ge>Pe?1:0}t.compareSubstring=N;function P(k,B){return S(k,B,0,k.length,0,B.length)}t.compareIgnoreCase=P;function S(k,B,x=0,$=k.length,Q=0,re=B.length){for(;x<$&&Q<re;x++,Q++){let Re=k.charCodeAt(x),ue=B.charCodeAt(Q);if(Re===ue)continue;if(Re>=128||ue>=128)return N(k.toLowerCase(),B.toLowerCase(),x,$,Q,re);I(Re)&&(Re-=32),I(ue)&&(ue-=32);const pe=Re-ue;if(pe!==0)return pe}const ge=$-x,Pe=re-Q;return ge<Pe?-1:ge>Pe?1:0}t.compareSubstringIgnoreCase=S;function E(k){return k>=48&&k<=57}t.isAsciiDigit=E;function I(k){return k>=97&&k<=122}t.isLowerAsciiLetter=I;function q(k){return k>=65&&k<=90}t.isUpperAsciiLetter=q;function W(k,B){return k.length===B.length&&S(k,B)===0}t.equalsIgnoreCase=W;function z(k,B){const x=B.length;return B.length>k.length?!1:S(k,B,0,x)===0}t.startsWithIgnoreCase=z;function Z(k,B){const x=Math.min(k.length,B.length);let $;for($=0;$<x;$++)if(k.charCodeAt($)!==B.charCodeAt($))return $;return x}t.commonPrefixLength=Z;function Y(k,B){const x=Math.min(k.length,B.length);let $;const Q=k.length-1,re=B.length-1;for($=0;$<x;$++)if(k.charCodeAt(Q-$)!==B.charCodeAt(re-$))return $;return x}t.commonSuffixLength=Y;function G(k){return 55296<=k&&k<=56319}t.isHighSurrogate=G;function se(k){return 56320<=k&&k<=57343}t.isLowSurrogate=se;function n(k,B){return(k-55296<<10)+(B-56320)+65536}t.computeCodePoint=n;function me(k,B,x){const $=k.charCodeAt(x);if(G($)&&x+1<B){const Q=k.charCodeAt(x+1);if(se(Q))return n($,Q)}return $}t.getNextCodePoint=me;function de(k,B){const x=k.charCodeAt(B-1);if(se(x)&&B>1){const $=k.charCodeAt(B-2);if(G($))return n($,x)}return x}class be{get offset(){return this.e}constructor(B,x=0){this.c=B,this.d=B.length,this.e=x}setOffset(B){this.e=B}prevCodePoint(){const B=de(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=me(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.CodePointIterator=be;class we{get offset(){return this.c.offset}constructor(B,x=0){this.c=new be(B,x)}nextGraphemeLength(){const B=_e.getInstance(),x=this.c,$=x.offset;let Q=B.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const re=x.offset,ge=B.getGraphemeBreakType(x.nextCodePoint());if(Ce(Q,ge)){x.setOffset(re);break}Q=ge}return x.offset-$}prevGraphemeLength(){const B=_e.getInstance(),x=this.c,$=x.offset;let Q=B.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const re=x.offset,ge=B.getGraphemeBreakType(x.prevCodePoint());if(Ce(ge,Q)){x.setOffset(re);break}Q=ge}return $-x.offset}eol(){return this.c.eol()}}t.GraphemeIterator=we;function Ne(k,B){return new we(k,B).nextGraphemeLength()}t.nextCharLength=Ne;function le(k,B){return new we(k,B).prevGraphemeLength()}t.prevCharLength=le;function oe(k,B){B>0&&se(k.charCodeAt(B))&&B--;const x=B+Ne(k,B);return[x-le(k,x),x]}t.getCharContainingOffset=oe;function Ae(k){const B=new we(k);let x=0;for(;!B.eol();)x++,B.nextGraphemeLength();return x}t.charCount=Ae;let ve;function De(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(k){return ve||(ve=De()),ve.test(k)}t.containsRTL=Fe;const te=/^[\t\n\r\x20-\x7E]*$/;function X(k){return te.test(k)}t.isBasicASCII=X,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(k){return t.UNUSUAL_LINE_TERMINATORS.test(k)}t.containsUnusualLineTerminators=U;function C(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}t.isFullWidthCharacter=C;function O(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}t.isEmojiImprecise=O;function V(k,B){if(k.length<B)return k;const x=/\b/g;let $=0;for(;x.test(k)&&!(k.length-x.lastIndex<B);)$=x.lastIndex,x.lastIndex+=1;return k.substring($).replace(/^\s/,"")}t.lcut=V;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function ie(k){return k&&(k=k.replace(H,"").replace(ne,"")),k}t.removeAnsiEscapeCodes=ie,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ae;function ce(k){return ae(k)?k.substr(1):k}t.stripUTF8BOM=ce;function he(k,B){if(!k||!B||k.length<B.length)return!1;const x=B.length,$=k.toLowerCase();let Q=0,re=-1;for(;Q<x;){const ge=$.indexOf(B[Q],re+1);if(ge<0)return!1;re=ge,Q++}return!0}t.fuzzyContains=he;function Le(k,B=!1){return k?(B&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}t.containsUppercaseCharacter=Le;function ye(k){return k.charAt(0).toUpperCase()+k.slice(1)}t.uppercaseFirstLetter=ye;function Se(k,B=1){if(B===0)return"";let x=-1;do x=k.indexOf(`
`,x+1),B--;while(B>0&&x>=0);return x===-1?k:(k[x-1]==="\r"&&x--,k.substr(0,x))}t.getNLines=Se;function Ie(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}t.singleLetterHash=Ie;function Ve(k){return _e.getInstance().getGraphemeBreakType(k)}t.getGraphemeBreakType=Ve;function Ce(k,B){return k===0?B!==5&&B!==7:k===2&&B===3?!1:k===4||k===2||k===3||B===4||B===2||B===3?!0:!(k===8&&(B===8||B===9||B===11||B===12)||(k===11||k===9)&&(B===9||B===10)||(k===12||k===10)&&B===10||B===5||B===13||B===7||k===1||k===13&&B===14||k===6&&B===6)}var Oe;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(t.GraphemeBreakType=Oe={}));class _e{static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=je()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const x=this.d,$=x.length/3;let Q=1;for(;Q<=$;)if(B<x[3*Q])Q=2*Q;else if(B>x[3*Q+1])Q=2*Q+1;else return x[3*Q+2];return 0}}_e.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(k,B){if(k===0)return 0;const x=He(k,B);if(x!==void 0)return x;const $=new be(B,k);return $.prevCodePoint(),$.offset}t.getLeftDeleteOffset=xe;function He(k,B){const x=new be(B,k);let $=x.prevCodePoint();for(;ze($)||$===65039||$===8419;){if(x.offset===0)return;$=x.prevCodePoint()}if(!O($))return;let Q=x.offset;return Q>0&&x.prevCodePoint()===8205&&(Q=x.offset),Q}function ze(k){return 127995<=k&&k<=127999}var Be;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ee{static getInstance(B){return Ee.d.get(Array.from(B))}static getLocales(){return Ee.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Ee,i=Ee,Ee.c=new T.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.d=new F.LRUCachedFunction(k=>{function B(ue){const pe=new Map;for(let Me=0;Me<ue.length;Me+=2)pe.set(ue[Me],ue[Me+1]);return pe}function x(ue,pe){const Me=new Map(ue);for(const[Te,Ue]of pe)Me.set(Te,Ue);return Me}function $(ue,pe){if(!ue)return pe;const Me=new Map;for(const[Te,Ue]of ue)pe.has(Te)&&Me.set(Te,Ue);return Me}const Q=i.c.value;let re=k.filter(ue=>!ue.startsWith("_")&&ue in Q);re.length===0&&(re=["_default"]);let ge;for(const ue of re){const pe=B(Q[ue]);ge=$(ge,pe)}const Pe=B(Q._common),Re=x(Pe,ge);return new Ee(Re)}),Ee.e=new T.Lazy(()=>Object.keys(Ee.c.value).filter(k=>!k.startsWith("_")));class ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ke.c())),this.d}static isInvisibleCharacter(B){return ke.e().has(B)}static get codePoints(){return ke.e()}}t.InvisibleCharacters=ke,ke.d=void 0}),J(K[35],ee([0,1,5]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function T(_){return i(_,0)}t.hash=T;function i(_,v){switch(typeof _){case"object":return _===null?u(349,v):Array.isArray(_)?a(_,v):l(_,v);case"string":return w(_,v);case"boolean":return R(_,v);case"number":return u(_,v);case"undefined":return u(937,v);default:return u(617,v)}}t.doHash=i;function u(_,v){return(v<<5)-v+_|0}t.numberHash=u;function R(_,v){return u(_?433:863,v)}function w(_,v){v=u(149417,v);for(let D=0,m=_.length;D<m;D++)v=u(_.charCodeAt(D),v);return v}t.stringHash=w;function a(_,v){return v=u(104579,v),_.reduce((D,m)=>i(m,D),v)}function l(_,v){return v=u(181387,v),Object.keys(_).sort().reduce((D,m)=>(D=w(m,D),i(_[m],D)),v)}class g{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=i(v,this.g),this.g}}t.Hasher=g;var M;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function h(_,v,D=32){const m=D-v,L=~((1<<m)-1);return(_<<v|(L&_)>>>m)>>>0}function d(_,v=0,D=_.byteLength,m=0){for(let L=0;L<D;L++)_[v+L]=m}function e(_,v,D="0"){for(;_.length<v;)_=D+_;return _}function A(_,v=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),v/4)}t.toHexString=A;class y{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const D=v.length;if(D===0)return;const m=this.p;let L=this.r,r=this.u,s,b;for(r!==0?(s=r,b=-1,r=0):(s=v.charCodeAt(0),b=0);;){let f=s;if(F.isHighSurrogate(s))if(b+1<D){const p=v.charCodeAt(b+1);F.isLowSurrogate(p)?(b++,f=F.computeCodePoint(s,p)):f=65533}else{r=s;break}else F.isLowSurrogate(s)&&(f=65533);if(L=this.w(m,L,f),b++,b<D)s=v.charCodeAt(b);else break}this.r=L,this.u=r}w(v,D,m){return m<128?v[D++]=m:m<2048?(v[D++]=192|(m&1984)>>>6,v[D++]=128|(m&63)>>>0):m<65536?(v[D++]=224|(m&61440)>>>12,v[D++]=128|(m&4032)>>>6,v[D++]=128|(m&63)>>>0):(v[D++]=240|(m&1835008)>>>18,v[D++]=128|(m&258048)>>>12,v[D++]=128|(m&4032)>>>6,v[D++]=128|(m&63)>>>0),D>=64&&(this.y(),D-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),D}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),A(this.h)+A(this.l)+A(this.m)+A(this.n)+A(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=y.g,D=this.q;for(let o=0;o<64;o+=4)v.setUint32(o,D.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,h(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let m=this.h,L=this.l,r=this.m,s=this.n,b=this.o,f,p,c;for(let o=0;o<80;o++)o<20?(f=L&r|~L&s,p=1518500249):o<40?(f=L^r^s,p=1859775393):o<60?(f=L&r|L&s|r&s,p=2400959708):(f=L^r^s,p=3395469782),c=h(m,5)+f+b+p+v.getUint32(o*4,!1)&4294967295,b=s,s=r,r=h(L,30),L=m,m=c;this.h=this.h+m&4294967295,this.l=this.l+L&4294967295,this.m=this.m+r&4294967295,this.n=this.n+s&4294967295,this.o=this.o+b&4294967295}}t.StringSHA1=y,y.g=new DataView(new ArrayBuffer(320))}),J(K[19],ee([0,1,28,35]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(h){this.a=h}getElements(){const h=this.a,d=new Int32Array(h.length);for(let e=0,A=h.length;e<A;e++)d[e]=h.charCodeAt(e);return d}}t.StringDiffSequence=i;function u(M,h,d){return new g(new i(M),new i(h)).ComputeDiff(d).changes}t.stringDiff=u;class R{static Assert(h,d){if(!h)throw new Error(d)}}class w{static Copy(h,d,e,A,y){for(let _=0;_<y;_++)e[A+_]=h[d+_]}static Copy2(h,d,e,A,y){for(let _=0;_<y;_++)e[A+_]=h[d+_]}}var a;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(h,d){this.b=Math.min(this.b,h),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(h,d){this.b=Math.min(this.b,h),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(h,d,e=null){this.a=e,this.b=h,this.c=d;const[A,y,_]=g.o(h),[v,D,m]=g.o(d);this.d=_&&m,this.e=A,this.f=y,this.g=v,this.h=D,this.k=[],this.m=[]}static n(h){return h.length>0&&typeof h[0]=="string"}static o(h){const d=h.getElements();if(g.n(d)){const e=new Int32Array(d.length);for(let A=0,y=d.length;A<y;A++)e[A]=(0,T.stringHash)(d[A],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(h,d){return this.f[h]!==this.h[d]?!1:this.d?this.e[h]===this.g[d]:!0}q(h,d){if(!this.p(h,d))return!1;const e=g.r(this.b,h),A=g.r(this.c,d);return e===A}static r(h,d){return typeof h.getStrictElement=="function"?h.getStrictElement(d):null}s(h,d){return this.f[h]!==this.f[d]?!1:this.d?this.e[h]===this.e[d]:!0}u(h,d){return this.h[h]!==this.h[d]?!1:this.d?this.g[h]===this.g[d]:!0}ComputeDiff(h){return this.v(0,this.f.length-1,0,this.h.length-1,h)}v(h,d,e,A,y){const _=[!1];let v=this.w(h,d,e,A,_);return y&&(v=this.z(v)),{quitEarly:_[0],changes:v}}w(h,d,e,A,y){for(y[0]=!1;h<=d&&e<=A&&this.p(h,e);)h++,e++;for(;d>=h&&A>=e&&this.p(d,A);)d--,A--;if(h>d||e>A){let r;return e<=A?(R.Assert(h===d+1,"originalStart should only be one more than originalEnd"),r=[new F.DiffChange(h,0,e,A-e+1)]):h<=d?(R.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[new F.DiffChange(h,d-h+1,e,0)]):(R.Assert(h===d+1,"originalStart should only be one more than originalEnd"),R.Assert(e===A+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const _=[0],v=[0],D=this.y(h,d,e,A,_,v,y),m=_[0],L=v[0];if(D!==null)return D;if(!y[0]){const r=this.w(h,m,e,L,y);let s=[];return y[0]?s=[new F.DiffChange(m+1,d-(m+1)+1,L+1,A-(L+1)+1)]:s=this.w(m+1,d,L+1,A,y),this.H(r,s)}return[new F.DiffChange(h,d-h+1,e,A-e+1)]}x(h,d,e,A,y,_,v,D,m,L,r,s,b,f,p,c,o,N){let P=null,S=null,E=new l,I=d,q=e,W=b[0]-c[0]-A,z=-1073741824,Z=this.k.length-1;do{const Y=W+h;Y===I||Y<q&&m[Y-1]<m[Y+1]?(r=m[Y+1],f=r-W-A,r<z&&E.MarkNextChange(),z=r,E.AddModifiedElement(r+1,f),W=Y+1-h):(r=m[Y-1]+1,f=r-W-A,r<z&&E.MarkNextChange(),z=r-1,E.AddOriginalElement(r,f+1),W=Y-1-h),Z>=0&&(m=this.k[Z],h=m[0],I=1,q=m.length-1)}while(--Z>=-1);if(P=E.getReverseChanges(),N[0]){let Y=b[0]+1,G=c[0]+1;if(P!==null&&P.length>0){const se=P[P.length-1];Y=Math.max(Y,se.getOriginalEnd()),G=Math.max(G,se.getModifiedEnd())}S=[new F.DiffChange(Y,s-Y+1,G,p-G+1)]}else{E=new l,I=_,q=v,W=b[0]-c[0]-D,z=1073741824,Z=o?this.m.length-1:this.m.length-2;do{const Y=W+y;Y===I||Y<q&&L[Y-1]>=L[Y+1]?(r=L[Y+1]-1,f=r-W-D,r>z&&E.MarkNextChange(),z=r+1,E.AddOriginalElement(r+1,f+1),W=Y+1-y):(r=L[Y-1],f=r-W-D,r>z&&E.MarkNextChange(),z=r,E.AddModifiedElement(r+1,f+1),W=Y-1-y),Z>=0&&(L=this.m[Z],y=L[0],I=1,q=L.length-1)}while(--Z>=-1);S=E.getChanges()}return this.H(P,S)}y(h,d,e,A,y,_,v){let D=0,m=0,L=0,r=0,s=0,b=0;h--,e--,y[0]=0,_[0]=0,this.k=[],this.m=[];const f=d-h+(A-e),p=f+1,c=new Int32Array(p),o=new Int32Array(p),N=A-e,P=d-h,S=h-e,E=d-A,q=(P-N)%2===0;c[N]=h,o[P]=d,v[0]=!1;for(let W=1;W<=f/2+1;W++){let z=0,Z=0;L=this.J(N-W,W,N,p),r=this.J(N+W,W,N,p);for(let G=L;G<=r;G+=2){G===L||G<r&&c[G-1]<c[G+1]?D=c[G+1]:D=c[G-1]+1,m=D-(G-N)-S;const se=D;for(;D<d&&m<A&&this.p(D+1,m+1);)D++,m++;if(c[G]=D,D+m>z+Z&&(z=D,Z=m),!q&&Math.abs(G-P)<=W-1&&D>=o[G])return y[0]=D,_[0]=m,se<=o[G]&&1447>0&&W<=1447+1?this.x(N,L,r,S,P,s,b,E,c,o,D,d,y,m,A,_,q,v):null}const Y=(z-h+(Z-e)-W)/2;if(this.a!==null&&!this.a(z,Y))return v[0]=!0,y[0]=z,_[0]=Z,Y>0&&1447>0&&W<=1447+1?this.x(N,L,r,S,P,s,b,E,c,o,D,d,y,m,A,_,q,v):(h++,e++,[new F.DiffChange(h,d-h+1,e,A-e+1)]);s=this.J(P-W,W,P,p),b=this.J(P+W,W,P,p);for(let G=s;G<=b;G+=2){G===s||G<b&&o[G-1]>=o[G+1]?D=o[G+1]-1:D=o[G-1],m=D-(G-P)-E;const se=D;for(;D>h&&m>e&&this.p(D,m);)D--,m--;if(o[G]=D,q&&Math.abs(G-N)<=W&&D<=c[G])return y[0]=D,_[0]=m,se>=c[G]&&1447>0&&W<=1447+1?this.x(N,L,r,S,P,s,b,E,c,o,D,d,y,m,A,_,q,v):null}if(W<=1447){let G=new Int32Array(r-L+2);G[0]=N-L+1,w.Copy2(c,L,G,1,r-L+1),this.k.push(G),G=new Int32Array(b-s+2),G[0]=P-s+1,w.Copy2(o,s,G,1,b-s+1),this.m.push(G)}}return this.x(N,L,r,S,P,s,b,E,c,o,D,d,y,m,A,_,q,v)}z(h){for(let d=0;d<h.length;d++){const e=h[d],A=d<h.length-1?h[d+1].originalStart:this.f.length,y=d<h.length-1?h[d+1].modifiedStart:this.h.length,_=e.originalLength>0,v=e.modifiedLength>0;for(;e.originalStart+e.originalLength<A&&e.modifiedStart+e.modifiedLength<y&&(!_||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!v||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const D=[null];if(d<h.length-1&&this.I(h[d],h[d+1],D)){h[d]=D[0],h.splice(d+1,1),d--;continue}}for(let d=h.length-1;d>=0;d--){const e=h[d];let A=0,y=0;if(d>0){const r=h[d-1];A=r.originalStart+r.originalLength,y=r.modifiedStart+r.modifiedLength}const _=e.originalLength>0,v=e.modifiedLength>0;let D=0,m=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,b=e.modifiedStart-r;if(s<A||b<y||_&&!this.s(s,s+e.originalLength)||v&&!this.u(b,b+e.modifiedLength))break;const p=(s===A&&b===y?5:0)+this.G(s,e.originalLength,b,e.modifiedLength);p>m&&(m=p,D=r)}e.originalStart-=D,e.modifiedStart-=D;const L=[null];if(d>0&&this.I(h[d-1],h[d],L)){h[d-1]=L[0],h.splice(d,1),d++;continue}}if(this.d)for(let d=1,e=h.length;d<e;d++){const A=h[d-1],y=h[d],_=y.originalStart-A.originalStart-A.originalLength,v=A.originalStart,D=y.originalStart+y.originalLength,m=D-v,L=A.modifiedStart,r=y.modifiedStart+y.modifiedLength,s=r-L;if(_<5&&m<20&&s<20){const b=this.A(v,m,L,s,_);if(b){const[f,p]=b;(f!==A.originalStart+A.originalLength||p!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=f-A.originalStart,A.modifiedLength=p-A.modifiedStart,y.originalStart=f+_,y.modifiedStart=p+_,y.originalLength=D-y.originalStart,y.modifiedLength=r-y.modifiedStart)}}}return h}A(h,d,e,A,y){if(d<y||A<y)return null;const _=h+d-y+1,v=e+A-y+1;let D=0,m=0,L=0;for(let r=h;r<_;r++)for(let s=e;s<v;s++){const b=this.B(r,s,y);b>0&&b>D&&(D=b,m=r,L=s)}return D>0?[m,L]:null}B(h,d,e){let A=0;for(let y=0;y<e;y++){if(!this.p(h+y,d+y))return 0;A+=this.e[h+y].length}return A}C(h){return h<=0||h>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[h])}D(h,d){if(this.C(h)||this.C(h-1))return!0;if(d>0){const e=h+d;if(this.C(e-1)||this.C(e))return!0}return!1}E(h){return h<=0||h>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[h])}F(h,d){if(this.E(h)||this.E(h-1))return!0;if(d>0){const e=h+d;if(this.E(e-1)||this.E(e))return!0}return!1}G(h,d,e,A){const y=this.D(h,d)?1:0,_=this.F(e,A)?1:0;return y+_}H(h,d){const e=[];if(h.length===0||d.length===0)return d.length>0?d:h;if(this.I(h[h.length-1],d[0],e)){const A=new Array(h.length+d.length-1);return w.Copy(h,0,A,0,h.length-1),A[h.length-1]=e[0],w.Copy(d,1,A,h.length,d.length-1),A}else{const A=new Array(h.length+d.length);return w.Copy(h,0,A,0,h.length),w.Copy(d,0,A,h.length,d.length),A}}I(h,d,e){if(R.Assert(h.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),R.Assert(h.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=d.originalStart||h.modifiedStart+h.modifiedLength>=d.modifiedStart){const A=h.originalStart;let y=h.originalLength;const _=h.modifiedStart;let v=h.modifiedLength;return h.originalStart+h.originalLength>=d.originalStart&&(y=d.originalStart+d.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=d.modifiedStart&&(v=d.modifiedStart+d.modifiedLength-h.modifiedStart),e[0]=new F.DiffChange(A,y,_,v),!0}else return e[0]=null,!1}J(h,d,e,A){if(h>=0&&h<A)return h;const y=e,_=A-e-1,v=d%2===0;if(h<0){const D=y%2===0;return v===D?0:1}else{const D=_%2===0;return v===D?A-1:A-2}}}t.LcsDiff=g}),J(K[20],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function F(s){return typeof s=="string"}t.isString=F;function T(s){return Array.isArray(s)&&s.every(b=>F(b))}t.isStringArray=T;function i(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=i;function u(s){const b=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof b}t.isTypedArray=u;function R(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=R;function w(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=w;function a(s){return s===!0||s===!1}t.isBoolean=a;function l(s){return typeof s>"u"}t.isUndefined=l;function g(s){return!M(s)}t.isDefined=g;function M(s){return l(s)||s===null}t.isUndefinedOrNull=M;function h(s,b){if(!s)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}t.assertType=h;function d(s){if(M(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=d;function e(...s){const b=[];for(let f=0;f<s.length;f++){const p=s[f];if(M(p))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);b.push(p)}return b}t.assertAllDefined=e;const A=Object.prototype.hasOwnProperty;function y(s){if(!i(s))return!1;for(const b in s)if(A.call(s,b))return!1;return!0}t.isEmptyObject=y;function _(s){return typeof s=="function"}t.isFunction=_;function v(...s){return s.length>0&&s.every(_)}t.areFunctions=v;function D(s,b){const f=Math.min(s.length,b.length);for(let p=0;p<f;p++)m(s[p],b[p])}t.validateConstraints=D;function m(s,b){if(F(b)){if(typeof s!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(_(b)){try{if(s instanceof b)return}catch{}if(!M(s)&&s.constructor===b||b.length===1&&b.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=m;function L(s){return s===null?void 0:s}t.withNullAsUndefined=L;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),J(K[36],ee([0,1,20]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const T=Object.create(null);function i(w,a){if((0,F.isString)(a)){const l=T[a];if(l===void 0)throw new Error(`${w} references an unknown codicon: ${a}`);a=l}return T[w]=a,{id:w}}function u(){return T}t.getCodiconFontCharacters=u;function R(){return Object.values(t.Codicon)}t.getAllCodicons=R,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),J(K[12],ee([0,1,20]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(_){if(!_||typeof _!="object"||_ instanceof RegExp)return _;const v=Array.isArray(_)?[]:{};return Object.entries(_).forEach(([D,m])=>{v[D]=m&&typeof m=="object"?T(m):m}),v}t.deepClone=T;function i(_){if(!_||typeof _!="object")return _;const v=[_];for(;v.length>0;){const D=v.shift();Object.freeze(D);for(const m in D)if(u.call(D,m)){const L=D[m];typeof L=="object"&&!Object.isFrozen(L)&&!(0,F.isTypedArray)(L)&&v.push(L)}}return _}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function R(_,v){return w(_,v,new Set)}t.cloneAndChange=R;function w(_,v,D){if((0,F.isUndefinedOrNull)(_))return _;const m=v(_);if(typeof m<"u")return m;if(Array.isArray(_)){const L=[];for(const r of _)L.push(w(r,v,D));return L}if((0,F.isObject)(_)){if(D.has(_))throw new Error("Cannot clone recursive data-structure");D.add(_);const L={};for(const r in _)u.call(_,r)&&(L[r]=w(_[r],v,D));return D.delete(_),L}return _}function a(_,v,D=!0){return(0,F.isObject)(_)?((0,F.isObject)(v)&&Object.keys(v).forEach(m=>{m in _?D&&((0,F.isObject)(_[m])&&(0,F.isObject)(v[m])?a(_[m],v[m],D):_[m]=v[m]):_[m]=v[m]}),_):v}t.mixin=a;function l(_,v){if(_===v)return!0;if(_==null||v===null||v===void 0||typeof _!=typeof v||typeof _!="object"||Array.isArray(_)!==Array.isArray(v))return!1;let D,m;if(Array.isArray(_)){if(_.length!==v.length)return!1;for(D=0;D<_.length;D++)if(!l(_[D],v[D]))return!1}else{const L=[];for(m in _)L.push(m);L.sort();const r=[];for(m in v)r.push(m);if(r.sort(),!l(L,r))return!1;for(D=0;D<L.length;D++)if(!l(_[L[D]],v[L[D]]))return!1}return!0}t.equals=l;function g(_){const v=new Set;return JSON.stringify(_,(D,m)=>{if((0,F.isObject)(m)||Array.isArray(m)){if(v.has(m))return"[Circular]";v.add(m)}return m})}t.safeStringify=g;function M(_,v){const D=Object.create(null);return!_||!v||Object.keys(v).forEach(L=>{const r=_[L],s=v[L];l(r,s)||(D[L]=s)}),D}t.distinct=M;function h(_,v){const D=v.toLowerCase(),m=Object.keys(_).find(L=>L.toLowerCase()===D);return m?_[m]:_[v]}t.getCaseInsensitive=h;function d(_,v){const D=Object.create(null);for(const[m,L]of Object.entries(_))v(m,L)&&(D[m]=L);return D}t.filter=d;function e(_){let v=[],D=Object.getPrototypeOf(_);for(;Object.prototype!==D;)v=v.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return v}t.getAllPropertyNames=e;function A(_){const v=[];for(const D of e(_))typeof _[D]=="function"&&v.push(D);return v}t.getAllMethodNames=A;function y(_,v){const D=L=>function(){const r=Array.prototype.slice.call(arguments,0);return v(L,r)},m={};for(const L of _)m[L]=D(L);return m}t.createProxyObject=y}),J(K[21],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var F;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F||(t.Constants=F={}));function T(u){return u<0?0:u>255?255:u|0}t.toUint8=T;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),J(K[13],ee([0,1,33,8]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,R=/^\/\//;function w(b,f){if(!b.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${b.authority}", path: "${b.path}", query: "${b.query}", fragment: "${b.fragment}"}`);if(b.scheme&&!i.test(b.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(b.path){if(b.authority){if(!u.test(b.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(b.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(b,f){return!b&&!f?"file":b}function l(b,f){switch(b){case"https":case"http":case"file":f?f[0]!==M&&(f=M+f):f=M;break}return f}const g="",M="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(f){return f instanceof d?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,p,c,o,N,P=!1){typeof f=="object"?(this.scheme=f.scheme||g,this.authority=f.authority||g,this.path=f.path||g,this.query=f.query||g,this.fragment=f.fragment||g):(this.scheme=a(f,P),this.authority=p||g,this.path=l(this.scheme,c||g),this.query=o||g,this.fragment=N||g,w(this,P))}get fsPath(){return D(this,!1)}with(f){if(!f)return this;let{scheme:p,authority:c,path:o,query:N,fragment:P}=f;return p===void 0?p=this.scheme:p===null&&(p=g),c===void 0?c=this.authority:c===null&&(c=g),o===void 0?o=this.path:o===null&&(o=g),N===void 0?N=this.query:N===null&&(N=g),P===void 0?P=this.fragment:P===null&&(P=g),p===this.scheme&&c===this.authority&&o===this.path&&N===this.query&&P===this.fragment?this:new A(p,c,o,N,P)}static parse(f,p=!1){const c=h.exec(f);return c?new A(c[2]||g,s(c[4]||g),s(c[5]||g),s(c[7]||g),s(c[9]||g),p):new A(g,g,g,g,g)}static file(f){let p=g;if(T.isWindows&&(f=f.replace(/\\/g,M)),f[0]===M&&f[1]===M){const c=f.indexOf(M,2);c===-1?(p=f.substring(2),f=M):(p=f.substring(2,c),f=f.substring(c)||M)}return new A("file",p,f,g,g)}static from(f){const p=new A(f.scheme,f.authority,f.path,f.query,f.fragment);return w(p,!0),p}static joinPath(f,...p){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return T.isWindows&&f.scheme==="file"?c=d.file(F.win32.join(D(f,!0),...p)).path:c=F.posix.join(f.path,...p),f.with({path:c})}toString(f=!1){return m(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof d)return f;{const p=new A(f);return p._formatted=f.external,p._fsPath=f._sep===e?f.fsPath:null,p}}else return f}}t.URI=d;const e=T.isWindows?1:void 0;class A extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(f=!1){return f?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=e),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(b,f,p){let c,o=-1;for(let N=0;N<b.length;N++){const P=b.charCodeAt(N);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||f&&P===47||p&&P===91||p&&P===93||p&&P===58)o!==-1&&(c+=encodeURIComponent(b.substring(o,N)),o=-1),c!==void 0&&(c+=b.charAt(N));else{c===void 0&&(c=b.substr(0,N));const S=y[P];S!==void 0?(o!==-1&&(c+=encodeURIComponent(b.substring(o,N)),o=-1),c+=S):o===-1&&(o=N)}}return o!==-1&&(c+=encodeURIComponent(b.substring(o))),c!==void 0?c:b}function v(b){let f;for(let p=0;p<b.length;p++){const c=b.charCodeAt(p);c===35||c===63?(f===void 0&&(f=b.substr(0,p)),f+=y[c]):f!==void 0&&(f+=b[p])}return f!==void 0?f:b}function D(b,f){let p;return b.authority&&b.path.length>1&&b.scheme==="file"?p=`//${b.authority}${b.path}`:b.path.charCodeAt(0)===47&&(b.path.charCodeAt(1)>=65&&b.path.charCodeAt(1)<=90||b.path.charCodeAt(1)>=97&&b.path.charCodeAt(1)<=122)&&b.path.charCodeAt(2)===58?f?p=b.path.substr(1):p=b.path[1].toLowerCase()+b.path.substr(2):p=b.path,T.isWindows&&(p=p.replace(/\//g,"\\")),p}t.uriToFsPath=D;function m(b,f){const p=f?v:_;let c="",{scheme:o,authority:N,path:P,query:S,fragment:E}=b;if(o&&(c+=o,c+=":"),(N||o==="file")&&(c+=M,c+=M),N){let I=N.indexOf("@");if(I!==-1){const q=N.substr(0,I);N=N.substr(I+1),I=q.lastIndexOf(":"),I===-1?c+=p(q,!1,!1):(c+=p(q.substr(0,I),!1,!1),c+=":",c+=p(q.substr(I+1),!1,!0)),c+="@"}N=N.toLowerCase(),I=N.lastIndexOf(":"),I===-1?c+=p(N,!1,!0):(c+=p(N.substr(0,I),!1,!0),c+=N.substr(I))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const I=P.charCodeAt(1);I>=65&&I<=90&&(P=`/${String.fromCharCode(I+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const I=P.charCodeAt(0);I>=65&&I<=90&&(P=`${String.fromCharCode(I+32)}:${P.substr(2)}`)}c+=p(P,!0,!1)}return S&&(c+="?",c+=p(S,!1,!1)),E&&(c+="#",c+=f?E:_(E,!1,!1)),c}function L(b){try{return decodeURIComponent(b)}catch{return b.length>3?b.substr(0,3)+L(b.substr(3)):b}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(b){return b.match(r)?b.replace(r,f=>L(f)):b}}),J(K[58],ee([0,1,2,9,7,12,8,5]),function(j,t,F,T,i,u,R,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let l=!1;function g(b){R.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(b.message))}t.logOnceWebWorkerWarning=g;var M;(function(b){b[b.Request=0]="Request",b[b.Reply=1]="Reply",b[b.SubscribeEvent=2]="SubscribeEvent",b[b.Event=3]="Event",b[b.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class h{constructor(f,p,c,o){this.vsWorker=f,this.req=p,this.method=c,this.args=o,this.type=0}}class d{constructor(f,p,c,o){this.vsWorker=f,this.seq=p,this.res=c,this.err=o,this.type=1}}class e{constructor(f,p,c,o){this.vsWorker=f,this.req=p,this.eventName=c,this.arg=o,this.type=2}}class A{constructor(f,p,c){this.vsWorker=f,this.req=p,this.event=c,this.type=3}}class y{constructor(f,p){this.vsWorker=f,this.req=p,this.type=4}}class _{constructor(f){this.a=-1,this.g=f,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(f){this.a=f}sendMessage(f,p){const c=String(++this.b);return new Promise((o,N)=>{this.c[c]={resolve:o,reject:N},this.o(new h(this.a,c,f,p))})}listen(f,p){let c=null;const o=new T.Emitter({onWillAddFirstListener:()=>{c=String(++this.b),this.d.set(c,o),this.o(new e(this.a,c,f,p))},onDidRemoveLastListener:()=>{this.d.delete(c),this.o(new y(this.a,c)),c=null}});return o.event}handleMessage(f){!f||!f.vsWorker||this.a!==-1&&f.vsWorker!==this.a||this.h(f)}h(f){switch(f.type){case 1:return this.j(f);case 0:return this.k(f);case 2:return this.l(f);case 3:return this.m(f);case 4:return this.n(f)}}j(f){if(!this.c[f.seq]){console.warn("Got reply to unknown seq");return}const p=this.c[f.seq];if(delete this.c[f.seq],f.err){let c=f.err;f.err.$isError&&(c=new Error,c.name=f.err.name,c.message=f.err.message,c.stack=f.err.stack),p.reject(c);return}p.resolve(f.res)}k(f){const p=f.req;this.g.handleMessage(f.method,f.args).then(o=>{this.o(new d(this.a,p,o,void 0))},o=>{o.detail instanceof Error&&(o.detail=(0,F.transformErrorForSerialization)(o.detail)),this.o(new d(this.a,p,void 0,(0,F.transformErrorForSerialization)(o)))})}l(f){const p=f.req,c=this.g.handleEvent(f.eventName,f.arg)(o=>{this.o(new A(this.a,p,o))});this.f.set(p,c)}m(f){if(!this.d.has(f.req)){console.warn("Got event for unknown req");return}this.d.get(f.req).fire(f.event)}n(f){if(!this.f.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(f.req).dispose(),this.f.delete(f.req)}o(f){const p=[];if(f.type===0)for(let c=0;c<f.args.length;c++)f.args[c]instanceof ArrayBuffer&&p.push(f.args[c]);else f.type===1&&f.res instanceof ArrayBuffer&&p.push(f.res);this.g.sendMessage(f,p)}}class v extends i.Disposable{constructor(f,p,c){super();let o=null;this.a=this.B(f.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{o?.(q)})),this.c=new _({sendMessage:(q,W)=>{this.a.postMessage(q,W)},handleMessage:(q,W)=>{if(typeof c[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(c[q].apply(c,W))}catch(z){return Promise.reject(z)}},handleEvent:(q,W)=>{if(m(q)){const z=c[q].call(c,W);if(typeof z!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return z}if(D(q)){const z=c[q];if(typeof z!="function")throw new Error(`Missing event ${q} on main thread host.`);return z}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let N=null;const P=globalThis.require;typeof P<"u"&&typeof P.getConfig=="function"?N=P.getConfig():typeof globalThis.requirejs<"u"&&(N=globalThis.requirejs.s.contexts._.config);const S=(0,u.getAllMethodNames)(c);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(N)),p,S]);const E=(q,W)=>this.g(q,W),I=(q,W)=>this.c.listen(q,W);this.f=new Promise((q,W)=>{o=W,this.b.then(z=>{q(L(z,E,I))},z=>{W(z),this.h("Worker failed to load "+p,z)})})}getProxyObject(){return this.f}g(f,p){return new Promise((c,o)=>{this.b.then(()=>{this.c.sendMessage(f,p).then(c,o)},o)})}h(f,p){console.error(f),console.info(p)}}t.SimpleWorkerClient=v;function D(b){return b[0]==="o"&&b[1]==="n"&&w.isUpperAsciiLetter(b.charCodeAt(2))}function m(b){return/^onDynamic/.test(b)&&w.isUpperAsciiLetter(b.charCodeAt(9))}function L(b,f,p){const c=P=>function(){const S=Array.prototype.slice.call(arguments,0);return f(P,S)},o=P=>function(S){return p(P,S)},N={};for(const P of b){if(m(P)){N[P]=o(P);continue}if(D(P)){N[P]=p(P,void 0);continue}N[P]=c(P)}return N}class r{constructor(f,p){this.a=p,this.b=null,this.c=new _({sendMessage:(c,o)=>{f(c,o)},handleMessage:(c,o)=>this.d(c,o),handleEvent:(c,o)=>this.f(c,o)})}onmessage(f){this.c.handleMessage(f)}d(f,p){if(f===a)return this.g(p[0],p[1],p[2],p[3]);if(!this.b||typeof this.b[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this.b[f].apply(this.b,p))}catch(c){return Promise.reject(c)}}f(f,p){if(!this.b)throw new Error("Missing requestHandler");if(m(f)){const c=this.b[f].call(this.b,p);if(typeof c!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return c}if(D(f)){const c=this.b[f];if(typeof c!="function")throw new Error(`Missing event ${f} on request handler.`);return c}throw new Error(`Malformed event name ${f}`)}g(f,p,c,o){this.c.setWorkerId(f);const S=L(o,(E,I)=>this.c.sendMessage(E,I),(E,I)=>this.c.listen(E,I));return this.a?(this.b=this.a(S),Promise.resolve((0,u.getAllMethodNames)(this.b))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,globalThis.require.config(p)),new Promise((E,I)=>{(globalThis.require||j)([c],W=>{if(this.b=W.create(S),!this.b){I(new Error("No RequestHandler!"));return}E((0,u.getAllMethodNames)(this.b))},I)}))}}t.SimpleWorkerServer=r;function s(b){return new r(b,null)}t.create=s}),J(K[22],ee([0,1,21]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class T{constructor(w){const a=(0,F.toUint8)(w);this.c=a,this.a=T.d(a),this.b=new Map}static d(w){const a=new Uint8Array(256);return a.fill(w),a}set(w,a){const l=(0,F.toUint8)(a);w>=0&&w<256?this.a[w]=l:this.b.set(w,l)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=T;var i;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(i||(i={}));class u{constructor(){this.a=new T(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}t.CharacterSet=u}),J(K[23],ee([0,1,2]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class T{static joinMany(u){if(u.length===0)return[];let R=u[0];for(let w=1;w<u.length;w++)R=this.join(R,u[w]);return R}static join(u,R){if(u.length===0)return R;if(R.length===0)return u;const w=[];let a=0,l=0,g=null;for(;a<u.length||l<R.length;){let M=null;if(a<u.length&&l<R.length){const h=u[a],d=R[l];h.startLineNumber<d.startLineNumber?(M=h,a++):(M=d,l++)}else a<u.length?(M=u[a],a++):(M=R[l],l++);g===null?g=M:g.endLineNumberExclusive>=M.startLineNumber?g=new T(g.startLineNumber,Math.max(g.endLineNumberExclusive,M.endLineNumberExclusive)):(w.push(g),g=M)}return g!==null&&w.push(g),w}constructor(u,R){if(u>R)throw new F.BugIndicatingError(`startLineNumber ${u} cannot be after endLineNumberExclusive ${R}`);this.startLineNumber=u,this.endLineNumberExclusive=R}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new T(this.startLineNumber+u,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new T(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const R=Math.max(this.startLineNumber,u.startLineNumber),w=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(R<=w)return new T(R,w)}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}}t.LineRange=T}),J(K[6],ee([0,1,2]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=void 0;class T{static addRange(u,R){let w=0;for(;w<R.length&&R[w].endExclusive<u.start;)w++;let a=w;for(;a<R.length&&R[a].start<=u.endExclusive;)a++;if(w===a)R.splice(w,0,u);else{const l=Math.min(u.start,R[w].start),g=Math.max(u.endExclusive,R[a-1].endExclusive);R.splice(w,a-w,new T(l,g))}}static tryCreate(u,R){if(!(u>R))return new T(u,R)}constructor(u,R){if(this.start=u,this.endExclusive=R,u>R)throw new F.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(u){return new T(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(u){return this.start===u.start&&this.endExclusive===u.endExclusive}containsRange(u){return this.start<=u.start&&u.endExclusive<=this.endExclusive}contains(u){return this.start<=u&&u<this.endExclusive}join(u){return new T(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}intersect(u){const R=Math.max(this.start,u.start),w=Math.min(this.endExclusive,u.endExclusive);if(R<=w)return new T(R,w)}}t.OffsetRange=T}),J(K[4],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class F{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new F(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return F.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return F.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return F.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const R=i.lineNumber|0,w=u.lineNumber|0;if(R===w){const a=i.column|0,l=u.column|0;return a-l}return R-w}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new F(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=F}),J(K[3],ee([0,1,4]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class T{constructor(u,R,w,a){u>w||u===w&&R>a?(this.startLineNumber=w,this.startColumn=a,this.endLineNumber=u,this.endColumn=R):(this.startLineNumber=u,this.startColumn=R,this.endLineNumber=w,this.endColumn=a)}isEmpty(){return T.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return T.containsPosition(this,u)}static containsPosition(u,R){return!(R.lineNumber<u.startLineNumber||R.lineNumber>u.endLineNumber||R.lineNumber===u.startLineNumber&&R.column<u.startColumn||R.lineNumber===u.endLineNumber&&R.column>u.endColumn)}static strictContainsPosition(u,R){return!(R.lineNumber<u.startLineNumber||R.lineNumber>u.endLineNumber||R.lineNumber===u.startLineNumber&&R.column<=u.startColumn||R.lineNumber===u.endLineNumber&&R.column>=u.endColumn)}containsRange(u){return T.containsRange(this,u)}static containsRange(u,R){return!(R.startLineNumber<u.startLineNumber||R.endLineNumber<u.startLineNumber||R.startLineNumber>u.endLineNumber||R.endLineNumber>u.endLineNumber||R.startLineNumber===u.startLineNumber&&R.startColumn<u.startColumn||R.endLineNumber===u.endLineNumber&&R.endColumn>u.endColumn)}strictContainsRange(u){return T.strictContainsRange(this,u)}static strictContainsRange(u,R){return!(R.startLineNumber<u.startLineNumber||R.endLineNumber<u.startLineNumber||R.startLineNumber>u.endLineNumber||R.endLineNumber>u.endLineNumber||R.startLineNumber===u.startLineNumber&&R.startColumn<=u.startColumn||R.endLineNumber===u.endLineNumber&&R.endColumn>=u.endColumn)}plusRange(u){return T.plusRange(this,u)}static plusRange(u,R){let w,a,l,g;return R.startLineNumber<u.startLineNumber?(w=R.startLineNumber,a=R.startColumn):R.startLineNumber===u.startLineNumber?(w=R.startLineNumber,a=Math.min(R.startColumn,u.startColumn)):(w=u.startLineNumber,a=u.startColumn),R.endLineNumber>u.endLineNumber?(l=R.endLineNumber,g=R.endColumn):R.endLineNumber===u.endLineNumber?(l=R.endLineNumber,g=Math.max(R.endColumn,u.endColumn)):(l=u.endLineNumber,g=u.endColumn),new T(w,a,l,g)}intersectRanges(u){return T.intersectRanges(this,u)}static intersectRanges(u,R){let w=u.startLineNumber,a=u.startColumn,l=u.endLineNumber,g=u.endColumn;const M=R.startLineNumber,h=R.startColumn,d=R.endLineNumber,e=R.endColumn;return w<M?(w=M,a=h):w===M&&(a=Math.max(a,h)),l>d?(l=d,g=e):l===d&&(g=Math.min(g,e)),w>l||w===l&&a>g?null:new T(w,a,l,g)}equalsRange(u){return T.equalsRange(this,u)}static equalsRange(u,R){return!u&&!R?!0:!!u&&!!R&&u.startLineNumber===R.startLineNumber&&u.startColumn===R.startColumn&&u.endLineNumber===R.endLineNumber&&u.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(u){return new F.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(u){return new F.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,R){return new T(this.startLineNumber,this.startColumn,u,R)}setStartPosition(u,R){return new T(u,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(u){return new T(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(u){return new T(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new T(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,R=u){return new T(u.lineNumber,u.column,R.lineNumber,R.column)}static lift(u){return u?new T(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,R){return!(u.endLineNumber<R.startLineNumber||u.endLineNumber===R.startLineNumber&&u.endColumn<R.startColumn||R.endLineNumber<u.startLineNumber||R.endLineNumber===u.startLineNumber&&R.endColumn<u.startColumn)}static areIntersecting(u,R){return!(u.endLineNumber<R.startLineNumber||u.endLineNumber===R.startLineNumber&&u.endColumn<=R.startColumn||R.endLineNumber<u.startLineNumber||R.endLineNumber===u.startLineNumber&&R.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,R){if(u&&R){const l=u.startLineNumber|0,g=R.startLineNumber|0;if(l===g){const M=u.startColumn|0,h=R.startColumn|0;if(M===h){const d=u.endLineNumber|0,e=R.endLineNumber|0;if(d===e){const A=u.endColumn|0,y=R.endColumn|0;return A-y}return d-e}return M-h}return l-g}return(u?1:0)-(R?1:0)}static compareRangesUsingEnds(u,R){return u.endLineNumber===R.endLineNumber?u.endColumn===R.endColumn?u.startLineNumber===R.startLineNumber?u.startColumn-R.startColumn:u.startLineNumber-R.startLineNumber:u.endColumn-R.endColumn:u.endLineNumber-R.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=T}),J(K[37],ee([0,1,4,3]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class u extends T.Range{constructor(w,a,l,g){super(w,a,l,g),this.selectionStartLineNumber=w,this.selectionStartColumn=a,this.positionLineNumber=l,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return u.selectionsEqual(this,w)}static selectionsEqual(w,a){return w.selectionStartLineNumber===a.selectionStartLineNumber&&w.selectionStartColumn===a.selectionStartColumn&&w.positionLineNumber===a.positionLineNumber&&w.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,w,a):new u(w,a,this.startLineNumber,this.startColumn)}getPosition(){return new F.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,a){return this.getDirection()===0?new u(w,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,w,a)}static fromPositions(w,a=w){return new u(w.lineNumber,w.column,a.lineNumber,a.column)}static fromRange(w,a){return a===0?new u(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new u(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new u(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,a){if(w&&!a||!w&&a)return!1;if(!w&&!a)return!0;if(w.length!==a.length)return!1;for(let l=0,g=w.length;l<g;l++)if(!this.selectionsEqual(w[l],a[l]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,a,l,g,M){return M===0?new u(w,a,l,g):new u(l,g,w,a)}}t.Selection=u}),J(K[38],ee([0,1,22]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(t.WordCharacterClass=T={}));class i extends F.CharacterClassifier{constructor(w){super(0);for(let a=0,l=w.length;a<l;a++)this.set(w.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(R){const w={};return a=>(w.hasOwnProperty(a)||(w[a]=R(a)),w[a])}t.getMapForWordSeparators=u(R=>new i(R))}),J(K[24],ee([0,1,15,7,16]),function(j,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(M=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const d of t.USUAL_WORD_SEPARATORS)M.indexOf(d)>=0||(h+="\\"+d);return h+="\\s]+)",new RegExp(h,"g")}t.DEFAULT_WORD_REGEXP=u();function R(M){let h=t.DEFAULT_WORD_REGEXP;if(M&&M instanceof RegExp)if(M.global)h=M;else{let d="g";M.ignoreCase&&(d+="i"),M.multiline&&(d+="m"),M.unicode&&(d+="u"),h=new RegExp(M.source,d)}return h.lastIndex=0,h}t.ensureValidWordDefinition=R;const w=new i.LinkedList;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(M){const h=w.unshift(M);return(0,T.toDisposable)(h)}t.setDefaultGetWordAtTextConfig=a;function l(M,h,d,e,A){if(A||(A=F.Iterable.first(w)),d.length>A.maxLen){let m=M-A.maxLen/2;return m<0?m=0:e+=m,d=d.substring(m,M+A.maxLen/2),l(M,h,d,e,A)}const y=Date.now(),_=M-1-e;let v=-1,D=null;for(let m=1;!(Date.now()-y>=A.timeBudget);m++){const L=_-A.windowSize*m;h.lastIndex=Math.max(0,L);const r=g(h,d,_,v);if(!r&&D||(D=r,L<=0))break;v=L}if(D){const m={word:D[0],startColumn:e+1+D.index,endColumn:e+1+D.index+D[0].length};return h.lastIndex=0,m}return null}t.getWordAtText=l;function g(M,h,d,e){let A;for(;A=M.exec(h);){const y=A.index||0;if(y<=d&&M.lastIndex>=d)return A;if(e>0&&y>e)return null}return null}}),J(K[10],ee([0,1,2,6]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class i{static trivial(l,g){return new i([new u(new T.OffsetRange(0,l.length),new T.OffsetRange(0,g.length))],!1)}static trivialTimedOut(l,g){return new i([new u(new T.OffsetRange(0,l.length),new T.OffsetRange(0,g.length))],!0)}constructor(l,g){this.diffs=l,this.hitTimeout=g}}t.DiffAlgorithmResult=i;class u{constructor(l,g){this.seq1Range=l,this.seq2Range=g}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(l){return new u(this.seq1Range.join(l.seq1Range),this.seq2Range.join(l.seq2Range))}}t.SequenceDiff=u;class R{isValid(){return!0}}t.InfiniteTimeout=R,R.instance=new R;class w{constructor(l){if(this.c=l,this.a=Date.now(),this.b=!0,l<=0)throw new F.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.DateTimeout=w}),J(K[39],ee([0,1,6,10]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function i(l,g,M){let h=M;return h=R(l,g,h),h=w(l,g,h),h}t.optimizeSequenceDiffs=i;function u(l,g,M){const h=[];for(const d of M){const e=h[h.length-1];if(!e){h.push(d);continue}d.seq1Range.start-e.seq1Range.endExclusive<=2||d.seq2Range.start-e.seq2Range.endExclusive<=2?h[h.length-1]=new T.SequenceDiff(e.seq1Range.join(d.seq1Range),e.seq2Range.join(d.seq2Range)):h.push(d)}return h}t.smoothenSequenceDiffs=u;function R(l,g,M){const h=[];M.length>0&&h.push(M[0]);for(let d=1;d<M.length;d++){const e=h[h.length-1],A=M[d];if(A.seq1Range.isEmpty){let y=!0;const _=A.seq1Range.start-e.seq1Range.endExclusive;for(let v=1;v<=_;v++)if(g.getElement(A.seq2Range.start-v)!==g.getElement(A.seq2Range.endExclusive-v)){y=!1;break}if(y){h[h.length-1]=new T.SequenceDiff(e.seq1Range,new F.OffsetRange(e.seq2Range.start,A.seq2Range.endExclusive-_));continue}}h.push(A)}return h}t.joinSequenceDiffs=R;function w(l,g,M){if(!l.getBoundaryScore||!g.getBoundaryScore)return M;for(let h=0;h<M.length;h++){const d=M[h];if(d.seq1Range.isEmpty){const e=h>0?M[h-1].seq2Range.endExclusive:-1,A=h+1<M.length?M[h+1].seq2Range.start:g.length;M[h]=a(d,l,g,A,e)}else if(d.seq2Range.isEmpty){const e=h>0?M[h-1].seq1Range.endExclusive:-1,A=h+1<M.length?M[h+1].seq1Range.start:l.length;M[h]=a(d.reverse(),g,l,A,e).reverse()}}return M}t.shiftSequenceDiffs=w;function a(l,g,M,h,d){let A=1;for(;l.seq2Range.start-A>d&&M.getElement(l.seq2Range.start-A)===M.getElement(l.seq2Range.endExclusive-A)&&A<20;)A++;A--;let y=0;for(;l.seq2Range.start+y<h&&M.getElement(l.seq2Range.start+y)===M.getElement(l.seq2Range.endExclusive+y)&&y<20;)y++;if(A===0&&y===0)return l;let _=0,v=-1;for(let D=-A;D<=y;D++){const m=l.seq2Range.start+D,L=l.seq2Range.endExclusive+D,r=l.seq1Range.start+D,s=g.getBoundaryScore(r)+M.getBoundaryScore(m)+M.getBoundaryScore(L);s>v&&(v=s,_=D)}return _!==0?new T.SequenceDiff(l.seq1Range.delta(_),l.seq2Range.delta(_)):l}}),J(K[40],ee([0,1,6,10]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class i{compute(l,g,M=T.InfiniteTimeout.instance){if(l.length===0||g.length===0)return T.DiffAlgorithmResult.trivial(l,g);function h(L,r){for(;L<l.length&&r<g.length&&l.getElement(L)===g.getElement(r);)L++,r++;return L}let d=0;const e=new R;e.set(0,h(0,0));const A=new w;A.set(0,e.get(0)===0?null:new u(null,0,0,e.get(0)));let y=0;e:for(;;)for(d++,y=-d;y<=d;y+=2){if(!M.isValid())return T.DiffAlgorithmResult.trivialTimedOut(l,g);const L=y===d?-1:e.get(y+1),r=y===-d?-1:e.get(y-1)+1,s=Math.min(Math.max(L,r),l.length),b=s-y,f=h(s,b);e.set(y,f);const p=s===L?A.get(y+1):A.get(y-1);if(A.set(y,f!==s?new u(p,s,b,f-s):p),e.get(y)===l.length&&e.get(y)-y===g.length)break e}let _=A.get(y);const v=[];let D=l.length,m=g.length;for(;;){const L=_?_.x+_.length:0,r=_?_.y+_.length:0;if((L!==D||r!==m)&&v.push(new T.SequenceDiff(new F.OffsetRange(L,D),new F.OffsetRange(r,m))),!_)break;D=_.x,m=_.y,_=_.prev}return v.reverse(),new T.DiffAlgorithmResult(v,!1)}}t.MyersDiffAlgorithm=i;class u{constructor(l,g,M,h){this.prev=l,this.x=g,this.y=M,this.length=h}}class R{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,g){if(l<0){if(l=-l-1,l>=this.b.length){const M=this.b;this.b=new Int32Array(M.length*2),this.b.set(M)}this.b[l]=g}else{if(l>=this.a.length){const M=this.a;this.a=new Int32Array(M.length*2),this.a.set(M)}this.a[l]=g}}}class w{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,g){l<0?(l=-l-1,this.b[l]=g):this.a[l]=g}}}),J(K[41],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class F{constructor(i,u){this.width=i,this.height=u,this.a=[],this.a=new Array(i*u)}get(i,u){return this.a[i+u*this.width]}set(i,u,R){this.a[i+u*this.width]=R}}t.Array2D=F}),J(K[42],ee([0,1,6,10,41]),function(j,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class u{compute(w,a,l=T.InfiniteTimeout.instance,g){if(w.length===0||a.length===0)return T.DiffAlgorithmResult.trivial(w,a);const M=new i.Array2D(w.length,a.length),h=new i.Array2D(w.length,a.length),d=new i.Array2D(w.length,a.length);for(let m=0;m<w.length;m++)for(let L=0;L<a.length;L++){if(!l.isValid())return T.DiffAlgorithmResult.trivialTimedOut(w,a);const r=m===0?0:M.get(m-1,L),s=L===0?0:M.get(m,L-1);let b;w.getElement(m)===a.getElement(L)?(m===0||L===0?b=0:b=M.get(m-1,L-1),m>0&&L>0&&h.get(m-1,L-1)===3&&(b+=d.get(m-1,L-1)),b+=g?g(m,L):1):b=-1;const f=Math.max(r,s,b);if(f===b){const p=m>0&&L>0?d.get(m-1,L-1):0;d.set(m,L,p+1),h.set(m,L,3)}else f===r?(d.set(m,L,0),h.set(m,L,1)):f===s&&(d.set(m,L,0),h.set(m,L,2));M.set(m,L,f)}const e=[];let A=w.length,y=a.length;function _(m,L){(m+1!==A||L+1!==y)&&e.push(new T.SequenceDiff(new F.OffsetRange(m+1,A),new F.OffsetRange(L+1,y))),A=m,y=L}let v=w.length-1,D=a.length-1;for(;v>=0&&D>=0;)h.get(v,D)===3?(_(v,D),v--,D--):h.get(v,D)===1?v--:D--;return _(-1,-1),e.reverse(),new T.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=u}),J(K[25],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.LineRangeMapping=t.LinesDiff=void 0;class F{constructor(R,w){this.changes=R,this.hitTimeout=w}}t.LinesDiff=F;class T{constructor(R,w,a){this.originalRange=R,this.modifiedRange=w,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}}t.LineRangeMapping=T;class i{constructor(R,w){this.originalRange=R,this.modifiedRange=w}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=i}),J(K[26],ee([0,1,19,25,5,3,11,23]),function(j,t,F,T,i,u,R,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const a=3;class l{computeDiff(L,r,s){const f=new y(L,r,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let c=null;for(const o of f.changes){let N;o.originalEndLineNumber===0?N=new w.LineRange(o.originalStartLineNumber+1,o.originalStartLineNumber+1):N=new w.LineRange(o.originalStartLineNumber,o.originalEndLineNumber+1);let P;o.modifiedEndLineNumber===0?P=new w.LineRange(o.modifiedStartLineNumber+1,o.modifiedStartLineNumber+1):P=new w.LineRange(o.modifiedStartLineNumber,o.modifiedEndLineNumber+1);let S=new T.LineRangeMapping(N,P,o.charChanges?.map(E=>new T.RangeMapping(new u.Range(E.originalStartLineNumber,E.originalStartColumn,E.originalEndLineNumber,E.originalEndColumn),new u.Range(E.modifiedStartLineNumber,E.modifiedStartColumn,E.modifiedEndLineNumber,E.modifiedEndColumn))));c&&(c.modifiedRange.endLineNumberExclusive===S.modifiedRange.startLineNumber||c.originalRange.endLineNumberExclusive===S.originalRange.startLineNumber)&&(S=new T.LineRangeMapping(c.originalRange.join(S.originalRange),c.modifiedRange.join(S.modifiedRange),c.innerChanges&&S.innerChanges?c.innerChanges.concat(S.innerChanges):void 0),p.pop()),p.push(S),c=S}return(0,R.assertFn)(()=>(0,R.checkAdjacentItems)(p,(o,N)=>N.originalRange.startLineNumber-o.originalRange.endLineNumberExclusive===N.modifiedRange.startLineNumber-o.modifiedRange.endLineNumberExclusive&&o.originalRange.endLineNumberExclusive<N.originalRange.startLineNumber&&o.modifiedRange.endLineNumberExclusive<N.modifiedRange.startLineNumber)),new T.LinesDiff(p,f.quitEarly)}}t.SmartLinesDiffComputer=l;function g(m,L,r,s){return new F.LcsDiff(m,L,r).ComputeDiff(s)}class M{constructor(L){const r=[],s=[];for(let b=0,f=L.length;b<f;b++)r[b]=_(L[b],1),s[b]=v(L[b],1);this.lines=L,this.a=r,this.b=s}getElements(){const L=[];for(let r=0,s=this.lines.length;r<s;r++)L[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return L}getStrictElement(L){return this.lines[L]}getStartLineNumber(L){return L+1}getEndLineNumber(L){return L+1}createCharSequence(L,r,s){const b=[],f=[],p=[];let c=0;for(let o=r;o<=s;o++){const N=this.lines[o],P=L?this.a[o]:1,S=L?this.b[o]:N.length+1;for(let E=P;E<S;E++)b[c]=N.charCodeAt(E-1),f[c]=o+1,p[c]=E,c++;!L&&o<s&&(b[c]=10,f[c]=o+1,p[c]=N.length+1,c++)}return new h(b,f,p)}}class h{constructor(L,r,s){this.a=L,this.b=r,this.d=s}toString(){return"["+this.a.map((L,r)=>(L===10?"\\n":String.fromCharCode(L))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(L,r){if(L<0||L>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(L){return L>0&&L===this.b.length?this.getEndLineNumber(L-1):(this.e(L,this.b),this.b[L])}getEndLineNumber(L){return L===-1?this.getStartLineNumber(L+1):(this.e(L,this.b),this.a[L]===10?this.b[L]+1:this.b[L])}getStartColumn(L){return L>0&&L===this.d.length?this.getEndColumn(L-1):(this.e(L,this.d),this.d[L])}getEndColumn(L){return L===-1?this.getStartColumn(L+1):(this.e(L,this.d),this.a[L]===10?1:this.d[L]+1)}}class d{constructor(L,r,s,b,f,p,c,o){this.originalStartLineNumber=L,this.originalStartColumn=r,this.originalEndLineNumber=s,this.originalEndColumn=b,this.modifiedStartLineNumber=f,this.modifiedStartColumn=p,this.modifiedEndLineNumber=c,this.modifiedEndColumn=o}static createFromDiffChange(L,r,s){const b=r.getStartLineNumber(L.originalStart),f=r.getStartColumn(L.originalStart),p=r.getEndLineNumber(L.originalStart+L.originalLength-1),c=r.getEndColumn(L.originalStart+L.originalLength-1),o=s.getStartLineNumber(L.modifiedStart),N=s.getStartColumn(L.modifiedStart),P=s.getEndLineNumber(L.modifiedStart+L.modifiedLength-1),S=s.getEndColumn(L.modifiedStart+L.modifiedLength-1);return new d(b,f,p,c,o,N,P,S)}}function e(m){if(m.length<=1)return m;const L=[m[0]];let r=L[0];for(let s=1,b=m.length;s<b;s++){const f=m[s],p=f.originalStart-(r.originalStart+r.originalLength),c=f.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(p,c)<a?(r.originalLength=f.originalStart+f.originalLength-r.originalStart,r.modifiedLength=f.modifiedStart+f.modifiedLength-r.modifiedStart):(L.push(f),r=f)}return L}class A{constructor(L,r,s,b,f){this.originalStartLineNumber=L,this.originalEndLineNumber=r,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=b,this.charChanges=f}static createFromDiffResult(L,r,s,b,f,p,c){let o,N,P,S,E;if(r.originalLength===0?(o=s.getStartLineNumber(r.originalStart)-1,N=0):(o=s.getStartLineNumber(r.originalStart),N=s.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(P=b.getStartLineNumber(r.modifiedStart)-1,S=0):(P=b.getStartLineNumber(r.modifiedStart),S=b.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),p&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&f()){const I=s.createCharSequence(L,r.originalStart,r.originalStart+r.originalLength-1),q=b.createCharSequence(L,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(I.getElements().length>0&&q.getElements().length>0){let W=g(I,q,f,!0).changes;c&&(W=e(W)),E=[];for(let z=0,Z=W.length;z<Z;z++)E.push(d.createFromDiffChange(W[z],I,q))}}return new A(o,N,P,S,E)}}class y{constructor(L,r,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=L,this.g=r,this.h=new M(L),this.j=new M(r),this.k=D(s.maxComputationTime),this.l=D(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const L=g(this.h,this.j,this.k,this.e),r=L.changes,s=L.quitEarly;if(this.d){const c=[];for(let o=0,N=r.length;o<N;o++)c.push(A.createFromDiffResult(this.d,r[o],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:c}}const b=[];let f=0,p=0;for(let c=-1,o=r.length;c<o;c++){const N=c+1<o?r[c+1]:null,P=N?N.originalStart:this.f.length,S=N?N.modifiedStart:this.g.length;for(;f<P&&p<S;){const E=this.f[f],I=this.g[p];if(E!==I){{let q=_(E,1),W=_(I,1);for(;q>1&&W>1;){const z=E.charCodeAt(q-2),Z=I.charCodeAt(W-2);if(z!==Z)break;q--,W--}(q>1||W>1)&&this.m(b,f+1,1,q,p+1,1,W)}{let q=v(E,1),W=v(I,1);const z=E.length+1,Z=I.length+1;for(;q<z&&W<Z;){const Y=E.charCodeAt(q-1),G=E.charCodeAt(W-1);if(Y!==G)break;q++,W++}(q<z||W<Z)&&this.m(b,f+1,q,z,p+1,W,Z)}}f++,p++}N&&(b.push(A.createFromDiffResult(this.d,N,this.h,this.j,this.l,this.a,this.b)),f+=N.originalLength,p+=N.modifiedLength)}return{quitEarly:s,changes:b}}m(L,r,s,b,f,p,c){if(this.n(L,r,s,b,f,p,c))return;let o;this.a&&(o=[new d(r,s,r,b,f,p,f,c)]),L.push(new A(r,r,f,f,o))}n(L,r,s,b,f,p,c){const o=L.length;if(o===0)return!1;const N=L[o-1];return N.originalEndLineNumber===0||N.modifiedEndLineNumber===0?!1:N.originalEndLineNumber===r&&N.modifiedEndLineNumber===f?(this.a&&N.charChanges&&N.charChanges.push(new d(r,s,r,b,f,p,f,c)),!0):N.originalEndLineNumber+1===r&&N.modifiedEndLineNumber+1===f?(N.originalEndLineNumber=r,N.modifiedEndLineNumber=f,this.a&&N.charChanges&&N.charChanges.push(new d(r,s,r,b,f,p,f,c)),!0):!1}}t.DiffComputer=y;function _(m,L){const r=i.firstNonWhitespaceIndex(m);return r===-1?L:r+1}function v(m,L){const r=i.lastNonWhitespaceIndex(m);return r===-1?L:r+2}function D(m){if(m===0)return()=>!0;const L=Date.now();return()=>Date.now()-L<m}}),J(K[43],ee([0,1,11,23,6,4,3,10,42,39,40,25]),function(j,t,F,T,i,u,R,w,a,l,g,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class h{constructor(){this.b=new a.DynamicProgrammingDiffing,this.c=new g.MyersDiffAlgorithm}computeDiff(o,N,P){const S=P.maxComputationTimeMs===0?w.InfiniteTimeout.instance:new w.DateTimeout(P.maxComputationTimeMs),E=!P.ignoreTrimWhitespace,I=new Map;function q(le){let oe=I.get(le);return oe===void 0&&(oe=I.size,I.set(le,oe)),oe}const W=o.map(le=>q(le.trim())),z=N.map(le=>q(le.trim())),Z=new v(W,o),Y=new v(z,N),G=(()=>Z.length+Y.length<1500?this.b.compute(Z,Y,S,(le,oe)=>o[le]===N[oe]?N[oe].length===0?.1:1+Math.log(1+N[oe].length):.99):this.c.compute(Z,Y))();let se=G.diffs,n=G.hitTimeout;se=(0,l.optimizeSequenceDiffs)(Z,Y,se);const me=[],de=le=>{if(E)for(let oe=0;oe<le;oe++){const Ae=be+oe,ve=we+oe;if(o[Ae]!==N[ve]){const De=this.f(o,N,new w.SequenceDiff(new i.OffsetRange(Ae,Ae+1),new i.OffsetRange(ve,ve+1)),S,E);for(const Fe of De.mappings)me.push(Fe);De.hitTimeout&&(n=!0)}}};let be=0,we=0;for(const le of se){(0,F.assertFn)(()=>le.seq1Range.start-be===le.seq2Range.start-we);const oe=le.seq1Range.start-be;de(oe),be=le.seq1Range.endExclusive,we=le.seq2Range.endExclusive;const Ae=this.f(o,N,le,S,E);Ae.hitTimeout&&(n=!0);for(const ve of Ae.mappings)me.push(ve)}de(o.length-be);const Ne=A(me,o,N);return new M.LinesDiff(Ne,n)}f(o,N,P,S,E){const I=new m(o,P.seq1Range,E),q=new m(N,P.seq2Range,E),W=I.length+q.length<500?this.b.compute(I,q,S):this.c.compute(I,q,S);let z=W.diffs;return z=(0,l.optimizeSequenceDiffs)(I,q,z),z=d(I,q,z),z=(0,l.smoothenSequenceDiffs)(I,q,z),{mappings:z.map(Y=>new M.RangeMapping(I.translateRange(Y.seq1Range),q.translateRange(Y.seq2Range))),hitTimeout:W.hitTimeout}}}t.StandardLinesDiffComputer=h;function d(c,o,N){const P=[];let S;function E(){if(!S)return;const q=S.s1Range.length-S.deleted,W=S.s2Range.length-S.added;Math.max(S.deleted,S.added)+(S.count-1)>q&&P.push(new w.SequenceDiff(S.s1Range,S.s2Range)),S=void 0}for(const q of N){let W=function(se,n){if(!S||!S.s1Range.containsRange(se)||!S.s2Range.containsRange(n))if(S&&!(S.s1Range.endExclusive<se.start&&S.s2Range.endExclusive<n.start)){const be=i.OffsetRange.tryCreate(S.s1Range.endExclusive,se.start),we=i.OffsetRange.tryCreate(S.s2Range.endExclusive,n.start);S.deleted+=be?.length??0,S.added+=we?.length??0,S.s1Range=S.s1Range.join(se),S.s2Range=S.s2Range.join(n)}else E(),S={added:0,deleted:0,count:0,s1Range:se,s2Range:n};const me=se.intersect(q.seq1Range),de=n.intersect(q.seq2Range);S.count++,S.deleted+=me?.length??0,S.added+=de?.length??0};const z=c.findWordContaining(q.seq1Range.start-1),Z=o.findWordContaining(q.seq2Range.start-1),Y=c.findWordContaining(q.seq1Range.endExclusive),G=o.findWordContaining(q.seq2Range.endExclusive);z&&Y&&Z&&G&&z.equals(Y)&&Z.equals(G)?W(z,Z):(z&&Z&&W(z,Z),Y&&G&&W(Y,G))}return E(),e(N,P)}function e(c,o){const N=[];for(;c.length>0||o.length>0;){const P=c[0],S=o[0];let E;P&&(!S||P.seq1Range.start<S.seq1Range.start)?E=c.shift():E=o.shift(),N.length>0&&N[N.length-1].seq1Range.endExclusive>=E.seq1Range.start?N[N.length-1]=N[N.length-1].join(E):N.push(E)}return N}function A(c,o,N){const P=[];for(const S of _(c.map(E=>y(E,o,N)),(E,I)=>E.originalRange.overlapOrTouch(I.originalRange)||E.modifiedRange.overlapOrTouch(I.modifiedRange))){const E=S[0],I=S[S.length-1];P.push(new M.LineRangeMapping(E.originalRange.join(I.originalRange),E.modifiedRange.join(I.modifiedRange),S.map(q=>q.innerChanges[0])))}return(0,F.assertFn)(()=>(0,F.checkAdjacentItems)(P,(S,E)=>E.originalRange.startLineNumber-S.originalRange.endLineNumberExclusive===E.modifiedRange.startLineNumber-S.modifiedRange.endLineNumberExclusive&&S.originalRange.endLineNumberExclusive<E.originalRange.startLineNumber&&S.modifiedRange.endLineNumberExclusive<E.modifiedRange.startLineNumber)),P}t.lineRangeMappingFromRangeMappings=A;function y(c,o,N){let P=0,S=0;c.modifiedRange.startColumn-1>=N[c.modifiedRange.startLineNumber-1].length&&c.originalRange.startColumn-1>=o[c.originalRange.startLineNumber-1].length&&(P=1),c.modifiedRange.endColumn===1&&c.originalRange.endColumn===1&&c.originalRange.startLineNumber+P<=c.originalRange.endLineNumber&&c.modifiedRange.startLineNumber+P<=c.modifiedRange.endLineNumber&&(S=-1);const E=new T.LineRange(c.originalRange.startLineNumber+P,c.originalRange.endLineNumber+1+S),I=new T.LineRange(c.modifiedRange.startLineNumber+P,c.modifiedRange.endLineNumber+1+S);return new M.LineRangeMapping(E,I,[c])}t.getLineRangeMapping=y;function*_(c,o){let N,P;for(const S of c)P!==void 0&&o(P,S)?N.push(S):(N&&(yield N),N=[S]),P=S;N&&(yield N)}class v{constructor(o,N){this.b=o,this.c=N}getElement(o){return this.b[o]}get length(){return this.b.length}getBoundaryScore(o){const N=o===0?0:D(this.c[o-1]),P=o===this.c.length?0:D(this.c[o]);return 1e3-(N+P)}}t.LineSequence=v;function D(c){let o=0;for(;o<c.length&&(c.charCodeAt(o)===32||c.charCodeAt(o)===9);)o++;return o}class m{constructor(o,N,P){this.lines=o,this.considerWhitespaceChanges=P,this.b=[],this.c=[],this.f=[];let S=!1;N.start>0&&N.endExclusive>=o.length&&(N=new i.OffsetRange(N.start-1,N.endExclusive),S=!0),this.lineRange=N;for(let E=this.lineRange.start;E<this.lineRange.endExclusive;E++){let I=o[E],q=0;if(S)q=I.length,I="",S=!1;else if(!P){const W=I.trimStart();q=I.length-W.length,I=W.trimEnd()}this.f.push(q);for(let W=0;W<I.length;W++)this.b.push(I.charCodeAt(W));E<o.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[E-this.lineRange.start]=this.b.length)}this.f.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.b].map(o=>String.fromCharCode(o)).join("")}getElement(o){return this.b[o]}get length(){return this.b.length}getBoundaryScore(o){const N=f(o>0?this.b[o-1]:-1),P=f(o<this.b.length?this.b[o]:-1);if(N===6&&P===7)return 0;let S=0;return N!==P&&(S+=10,P===1&&(S+=1)),S+=b(N),S+=b(P),S}translateOffset(o){if(this.lineRange.isEmpty)return new u.Position(this.lineRange.start+1,1);let N=0,P=this.c.length;for(;N<P;){const E=Math.floor((N+P)/2);this.c[E]>o?P=E:N=E+1}const S=N===0?0:this.c[N-1];return new u.Position(this.lineRange.start+N+1,o-S+1+this.f[N])}translateRange(o){return R.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}findWordContaining(o){if(o<0||o>=this.b.length||!L(this.b[o]))return;let N=o;for(;N>0&&L(this.b[N-1]);)N--;let P=o;for(;P<this.b.length&&L(this.b[P]);)P++;return new i.OffsetRange(N,P)}}function L(c){return c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57}var r;(function(c){c[c.WordLower=0]="WordLower",c[c.WordUpper=1]="WordUpper",c[c.WordNumber=2]="WordNumber",c[c.End=3]="End",c[c.Other=4]="Other",c[c.Space=5]="Space",c[c.LineBreakCR=6]="LineBreakCR",c[c.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const s={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function b(c){return s[c]}function f(c){return c===10?7:c===13?6:p(c)?5:c>=97&&c<=122?0:c>=65&&c<=90?1:c>=48&&c<=57?2:c===-1?3:4}function p(c){return c===32||c===9}}),J(K[44],ee([0,1,26,43]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={legacy:new F.SmartLinesDiffComputer,advanced:new T.StandardLinesDiffComputer}}),J(K[45],ee([0,1,27]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function T(h){const d=[];for(const e of h){const A=Number(e);(A||A===0&&e.replace(/\s/g,"")!=="")&&d.push(A)}return d}function i(h,d,e,A){return{red:h/255,blue:e/255,green:d/255,alpha:A}}function u(h,d){const e=d.index,A=d[0].length;if(!e)return;const y=h.positionAt(e);return{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:y.lineNumber,endColumn:y.column+A}}function R(h,d){if(!h)return;const e=F.Color.Format.CSS.parseHex(d);if(e)return{range:h,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function w(h,d,e){if(!h||d.length!==1)return;const y=d[0].values(),_=T(y);return{range:h,color:i(_[0],_[1],_[2],e?_[3]:1)}}function a(h,d,e){if(!h||d.length!==1)return;const y=d[0].values(),_=T(y),v=new F.Color(new F.HSLA(_[0],_[1]/100,_[2]/100,e?_[3]:1));return{range:h,color:i(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function l(h,d){return typeof h=="string"?[...h.matchAll(d)]:h.findMatches(d)}function g(h){const d=[],A=l(h,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(A.length>0)for(const y of A){const _=y.filter(L=>L!==void 0),v=_[1],D=_[2];if(!D)continue;let m;if(v==="rgb"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;m=w(u(h,y),l(D,L),!1)}else if(v==="rgba"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;m=w(u(h,y),l(D,L),!0)}else if(v==="hsl"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;m=a(u(h,y),l(D,L),!1)}else if(v==="hsla"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;m=a(u(h,y),l(D,L),!0)}else v==="#"&&(m=R(u(h,y),v+D));m&&d.push(m)}return d}function M(h){return!h||typeof h.getValue!="function"||typeof h.positionAt!="function"?[]:g(h)}t.computeDefaultDocumentColors=M}),J(K[46],ee([0,1,22]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var T;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(T||(t.State=T={}));class i{constructor(e,A,y){const _=new Uint8Array(e*A);for(let v=0,D=e*A;v<D;v++)_[v]=y;this.a=_,this.rows=e,this.cols=A}get(e,A){return this.a[e*this.cols+A]}set(e,A,y){this.a[e*this.cols+A]=y}}class u{constructor(e){let A=0,y=0;for(let v=0,D=e.length;v<D;v++){const[m,L,r]=e[v];L>A&&(A=L),m>y&&(y=m),r>y&&(y=r)}A++,y++;const _=new i(y,A,0);for(let v=0,D=e.length;v<D;v++){const[m,L,r]=e[v];_.set(m,L,r)}this.a=_,this.b=A}nextState(e,A){return A<0||A>=this.b?0:this.a.get(e,A)}}t.StateMachine=u;let R=null;function w(){return R===null&&(R=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var a;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let l=null;function g(){if(l===null){l=new F.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<d.length;A++)l.set(d.charCodeAt(A),1);const e=".,;:";for(let A=0;A<e.length;A++)l.set(e.charCodeAt(A),2)}return l}class M{static a(e,A,y,_,v){let D=v-1;do{const m=A.charCodeAt(D);if(e.get(m)!==2)break;D--}while(D>_);if(_>0){const m=A.charCodeAt(_-1),L=A.charCodeAt(D);(m===40&&L===41||m===91&&L===93||m===123&&L===125)&&D--}return{range:{startLineNumber:y,startColumn:_+1,endLineNumber:y,endColumn:D+2},url:A.substring(_,D+1)}}static computeLinks(e,A=w()){const y=g(),_=[];for(let v=1,D=e.getLineCount();v<=D;v++){const m=e.getLineContent(v),L=m.length;let r=0,s=0,b=0,f=1,p=!1,c=!1,o=!1,N=!1;for(;r<L;){let P=!1;const S=m.charCodeAt(r);if(f===13){let E;switch(S){case 40:p=!0,E=0;break;case 41:E=p?0:1;break;case 91:o=!0,c=!0,E=0;break;case 93:o=!1,E=c?0:1;break;case 123:N=!0,E=0;break;case 125:E=N?0:1;break;case 39:case 34:case 96:b===S?E=1:b===39||b===34||b===96?E=0:E=1;break;case 42:E=b===42?1:0;break;case 124:E=b===124?1:0;break;case 32:E=o?0:1;break;default:E=y.get(S)}E===1&&(_.push(M.a(y,m,v,s,r)),P=!0)}else if(f===12){let E;S===91?(c=!0,E=0):E=y.get(S),E===1?P=!0:f=13}else f=A.nextState(f,S),f===0&&(P=!0);P&&(f=1,p=!1,c=!1,N=!1,s=r+1,b=S),r++}f===13&&_.push(M.a(y,m,v,s,L))}return _}}t.LinkComputer=M;function h(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:M.computeLinks(d)}t.computeLinks=h}),J(K[47],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,R,w,a){if(i&&u){const l=this.a(u,a);if(l)return{range:i,value:l}}if(R&&w){const l=this.a(w,a);if(l)return{range:R,value:l}}return null}a(i,u){const R=this.b(i,u);return R!==null?R:this.d(i,u)}b(i,u){const R=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let w=Number(i);const a=parseFloat(i);return!isNaN(w)&&!isNaN(a)&&w===a?w===0&&!u?null:(w=Math.floor(w*R),w+=u?R:-R,String(w/R)):null}d(i,u){return this.e(this.c,i,u)}e(i,u,R){let w=null;for(let a=0,l=i.length;w===null&&a<l;a++)w=this.f(i[a],u,R);return w}f(i,u,R){let w=i.indexOf(u);return w>=0?(w+=R?1:-1,w<0?w=i.length-1:w%=i.length,i[w]):null}}t.BasicInplaceReplace=F,F.INSTANCE=new F}),J(K[48],ee([0,1,12]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T||(t.OverviewRulerLane=T={}));var i;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var u;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(u||(t.MinimapPosition=u={}));var R;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(R||(t.InjectedTextCursorStops=R={}));var w;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(w||(t.EndOfLinePreference=w={}));var a;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var l;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(L){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,L.tabSize|0),L.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,L.indentSize|0),this.a=!1),this.insertSpaces=!!L.insertSpaces,this.defaultEOL=L.defaultEOL|0,this.trimAutoWhitespace=!!L.trimAutoWhitespace,this.bracketPairColorizationOptions=L.bracketPairColorizationOptions}equals(L){return this.tabSize===L.tabSize&&this.a===L.a&&this.indentSize===L.indentSize&&this.insertSpaces===L.insertSpaces&&this.defaultEOL===L.defaultEOL&&this.trimAutoWhitespace===L.trimAutoWhitespace&&(0,F.equals)(this.bracketPairColorizationOptions,L.bracketPairColorizationOptions)}createChangeEvent(L){return{tabSize:this.tabSize!==L.tabSize,indentSize:this.indentSize!==L.indentSize,insertSpaces:this.insertSpaces!==L.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==L.trimAutoWhitespace}}}t.TextModelResolvedOptions=g;class M{constructor(L,r){this._findMatchBrand=void 0,this.range=L,this.matches=r}}t.FindMatch=M;var h;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(h||(t.TrackedRangeStickiness=h={}));function d(m){return m&&typeof m.read=="function"}t.isITextSnapshot=d;var e;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var A;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A||(t.ModelConstants=A={}));class y{constructor(L,r,s,b,f,p){this.identifier=L,this.range=r,this.text=s,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=f,this._isTracked=p}}t.ValidAnnotatedEditOperation=y;class _{constructor(L,r,s){this.regex=L,this.wordSeparators=r,this.simpleSearch=s}}t.SearchData=_;class v{constructor(L,r,s){this.reverseEdits=L,this.changes=r,this.trimAutoWhitespaceLineNumbers=s}}t.ApplyEditsResult=v;function D(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}t.shouldSynchronizeModel=D}),J(K[49],ee([0,1,29,21]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,l){a=(0,T.toUint32)(a);const g=this.a,M=this.b,h=l.length;return h===0?!1:(this.a=new Uint32Array(g.length+h),this.a.set(g.subarray(0,a),0),this.a.set(g.subarray(a),a+h),this.a.set(l,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(M.subarray(0,this.c[0]+1)),!0)}setValue(a,l){return a=(0,T.toUint32)(a),l=(0,T.toUint32)(l),this.a[a]===l?!1:(this.a[a]=l,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,l){a=(0,T.toUint32)(a),l=(0,T.toUint32)(l);const g=this.a,M=this.b;if(a>=g.length)return!1;const h=g.length-a;return l>=h&&(l=h),l===0?!1:(this.a=new Uint32Array(g.length-l),this.a.set(g.subarray(0,a),0),this.a.set(g.subarray(a+l),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(M.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,T.toUint32)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),a>=this.a.length&&(a=this.a.length-1);for(let g=l;g<=a;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let l=0,g=this.a.length-1,M=0,h=0,d=0;for(;l<=g;)if(M=l+(g-l)/2|0,h=this.b[M],d=h-this.a[M],a<d)g=M-1;else if(a>=h)l=M+1;else break;return new R(M,a-d)}}t.PrefixSumComputer=i;class u{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const l=this.e[a],g=l>0?this.d[l-1]:0;return new R(l,a-g)}removeValues(a,l){this.a.splice(a,l),this.f(a)}insertValues(a,l){this.a=(0,F.arrayInsert)(this.a,a,l),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,l=this.a.length;a<l;a++){const g=this.a[a],M=a>0?this.d[a-1]:0;this.d[a]=M+g;for(let h=0;h<g;h++)this.e[M+h]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,l){this.a[a]!==l&&(this.a[a]=l,this.f(a))}}t.ConstantTimePrefixSumComputer=u;class R{constructor(a,l){this.index=a,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=l}}t.PrefixSumIndexOfResult=R}),J(K[50],ee([0,1,5,4,49]),function(j,t,F,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(w,a,l,g){this.d=w,this.f=a,this.g=l,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const a=w.changes;for(const l of a)this.o(l.range),this.p(new T.Position(l.range.startLineNumber,l.range.startColumn),l.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,a=this.f.length,l=new Uint32Array(a);for(let g=0;g<a;g++)l[g]=this.f[g].length+w;this.j=new i.PrefixSumComputer(l)}}n(w,a){this.f[w]=a,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,a){if(a.length===0)return;const l=(0,F.splitLines)(a);if(l.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+l[0]+this.f[w.lineNumber-1].substring(w.column-1));return}l[l.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+l[0]);const g=new Uint32Array(l.length-1);for(let M=1;M<l.length;M++)this.f.splice(w.lineNumber+M-1,0,l[M]),g[M-1]=l[M].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,g)}}t.MirrorTextModel=u}),J(K[51],ee([0,1,5,38,4,3,48]),function(j,t,F,T,i,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const w=999;class a{constructor(v,D,m,L){this.searchString=v,this.isRegex=D,this.matchCase=m,this.wordSeparators=L}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=l(this.searchString):v=this.searchString.indexOf(`
`)>=0;let D=null;try{D=F.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!D)return null;let m=!this.isRegex&&!v;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new R.SearchData(D,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}t.SearchParams=a;function l(_){if(!_||_.length===0)return!1;for(let v=0,D=_.length;v<D;v++){const m=_.charCodeAt(v);if(m===10)return!0;if(m===92){if(v++,v>=D)break;const L=_.charCodeAt(v);if(L===110||L===114||L===87)return!0}}return!1}t.isMultilineRegexSource=l;function g(_,v,D){if(!D)return new R.FindMatch(_,null);const m=[];for(let L=0,r=v.length;L<r;L++)m[L]=v[L];return new R.FindMatch(_,m)}t.createFindMatch=g;class M{constructor(v){const D=[];let m=0;for(let L=0,r=v.length;L<r;L++)v.charCodeAt(L)===10&&(D[m++]=L);this.a=D}findLineFeedCountBeforeOffset(v){const D=this.a;let m=0,L=D.length-1;if(L===-1||v<=D[0])return 0;for(;m<L;){const r=m+((L-m)/2>>0);D[r]>=v?L=r-1:D[r+1]>=v?(m=r,L=r):m=r+1}return m+1}}class h{static findMatches(v,D,m,L,r){const s=D.parseSearchRequest();return s?s.regex.multiline?this.b(v,m,new y(s.wordSeparators,s.regex),L,r):this.c(v,m,s,L,r):[]}static a(v,D,m,L,r,s){let b,f=0;L?(f=L.findLineFeedCountBeforeOffset(r),b=D+r+f):b=D+r;let p;if(L){const P=L.findLineFeedCountBeforeOffset(r+s.length)-f;p=b+s.length+P}else p=b+s.length;const c=v.getPositionAt(b),o=v.getPositionAt(p);return new u.Range(c.lineNumber,c.column,o.lineNumber,o.column)}static b(v,D,m,L,r){const s=v.getOffsetAt(D.getStartPosition()),b=v.getValueInRange(D,1),f=v.getEOL()===`\r
`?new M(b):null,p=[];let c=0,o;for(m.reset(0);o=m.next(b);)if(p[c++]=g(this.a(v,s,b,f,o.index,o[0]),o,L),c>=r)return p;return p}static c(v,D,m,L,r){const s=[];let b=0;if(D.startLineNumber===D.endLineNumber){const p=v.getLineContent(D.startLineNumber).substring(D.startColumn-1,D.endColumn-1);return b=this.d(m,p,D.startLineNumber,D.startColumn-1,b,s,L,r),s}const f=v.getLineContent(D.startLineNumber).substring(D.startColumn-1);b=this.d(m,f,D.startLineNumber,D.startColumn-1,b,s,L,r);for(let p=D.startLineNumber+1;p<D.endLineNumber&&b<r;p++)b=this.d(m,v.getLineContent(p),p,0,b,s,L,r);if(b<r){const p=v.getLineContent(D.endLineNumber).substring(0,D.endColumn-1);b=this.d(m,p,D.endLineNumber,0,b,s,L,r)}return s}static d(v,D,m,L,r,s,b,f){const p=v.wordSeparators;if(!b&&v.simpleSearch){const N=v.simpleSearch,P=N.length,S=D.length;let E=-P;for(;(E=D.indexOf(N,E+P))!==-1;)if((!p||A(p,D,S,E,P))&&(s[r++]=new R.FindMatch(new u.Range(m,E+1+L,m,E+1+P+L),null),r>=f))return r;return r}const c=new y(v.wordSeparators,v.regex);let o;c.reset(0);do if(o=c.next(D),o&&(s[r++]=g(new u.Range(m,o.index+1+L,m,o.index+1+o[0].length+L),o,b),r>=f))return r;while(o);return r}static findNextMatch(v,D,m,L){const r=D.parseSearchRequest();if(!r)return null;const s=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.e(v,m,s,L):this.f(v,m,s,L)}static e(v,D,m,L){const r=new i.Position(D.lineNumber,1),s=v.getOffsetAt(r),b=v.getLineCount(),f=v.getValueInRange(new u.Range(r.lineNumber,r.column,b,v.getLineMaxColumn(b)),1),p=v.getEOL()===`\r
`?new M(f):null;m.reset(D.column-1);const c=m.next(f);return c?g(this.a(v,s,f,p,c.index,c[0]),c,L):D.lineNumber!==1||D.column!==1?this.e(v,new i.Position(1,1),m,L):null}static f(v,D,m,L){const r=v.getLineCount(),s=D.lineNumber,b=v.getLineContent(s),f=this.g(m,b,s,D.column,L);if(f)return f;for(let p=1;p<=r;p++){const c=(s+p-1)%r,o=v.getLineContent(c+1),N=this.g(m,o,c+1,1,L);if(N)return N}return null}static g(v,D,m,L,r){v.reset(L-1);const s=v.next(D);return s?g(new u.Range(m,s.index+1,m,s.index+1+s[0].length),s,r):null}static findPreviousMatch(v,D,m,L){const r=D.parseSearchRequest();if(!r)return null;const s=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.h(v,m,s,L):this.j(v,m,s,L)}static h(v,D,m,L){const r=this.b(v,new u.Range(1,1,D.lineNumber,D.column),m,L,10*w);if(r.length>0)return r[r.length-1];const s=v.getLineCount();return D.lineNumber!==s||D.column!==v.getLineMaxColumn(s)?this.h(v,new i.Position(s,v.getLineMaxColumn(s)),m,L):null}static j(v,D,m,L){const r=v.getLineCount(),s=D.lineNumber,b=v.getLineContent(s).substring(0,D.column-1),f=this.k(m,b,s,L);if(f)return f;for(let p=1;p<=r;p++){const c=(r+s-p-1)%r,o=v.getLineContent(c+1),N=this.k(m,o,c+1,L);if(N)return N}return null}static k(v,D,m,L){let r=null,s;for(v.reset(0);s=v.next(D);)r=g(new u.Range(m,s.index+1,m,s.index+1+s[0].length),s,L);return r}}t.TextModelSearch=h;function d(_,v,D,m,L){if(m===0)return!0;const r=v.charCodeAt(m-1);if(_.get(r)!==0||r===13||r===10)return!0;if(L>0){const s=v.charCodeAt(m);if(_.get(s)!==0)return!0}return!1}function e(_,v,D,m,L){if(m+L===D)return!0;const r=v.charCodeAt(m+L);if(_.get(r)!==0||r===13||r===10)return!0;if(L>0){const s=v.charCodeAt(m+L-1);if(_.get(s)!==0)return!0}return!1}function A(_,v,D,m,L){return d(_,v,D,m,L)&&e(_,v,D,m,L)}t.isValidMatch=A;class y{constructor(v,D){this._wordSeparators=v,this.a=D,this.b=-1,this.c=0}reset(v){this.a.lastIndex=v,this.b=-1,this.c=0}next(v){const D=v.length;let m;do{if(this.b+this.c===D||(m=this.a.exec(v),!m))return null;const L=m.index,r=m[0].length;if(L===this.b&&r===this.c){if(r===0){F.getNextCodePoint(v,D,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=L,this.c=r,!this._wordSeparators||A(this._wordSeparators,v,D,L,r))return m}while(m);return null}}t.Searcher=y}),J(K[52],ee([0,1,3,51,5,11,24]),function(j,t,F,T,i,u,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class w{static computeUnicodeHighlights(e,A,y){const _=y?y.startLineNumber:1,v=y?y.endLineNumber:e.getLineCount(),D=new g(A),m=D.getCandidateCodePoints();let L;m==="allNonBasicAscii"?L=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):L=new RegExp(`${a(Array.from(m))}`,"g");const r=new T.Searcher(null,L),s=[];let b=!1,f,p=0,c=0,o=0;e:for(let N=_,P=v;N<=P;N++){const S=e.getLineContent(N),E=S.length;r.reset(0);do if(f=r.next(S),f){let I=f.index,q=f.index+f[0].length;if(I>0){const Y=S.charCodeAt(I-1);i.isHighSurrogate(Y)&&I--}if(q+1<E){const Y=S.charCodeAt(q-1);i.isHighSurrogate(Y)&&q++}const W=S.substring(I,q);let z=(0,R.getWordAtText)(I+1,R.DEFAULT_WORD_REGEXP,S,0);z&&z.endColumn<=I+1&&(z=null);const Z=D.shouldHighlightNonBasicASCII(W,z?z.word:null);if(Z!==0){Z===3?p++:Z===2?c++:Z===1?o++:(0,u.assertNever)(Z);const Y=1e3;if(s.length>=Y){b=!0;break e}s.push(new F.Range(N,I+1,N,q+1))}}while(f)}return{ranges:s,hasMore:b,ambiguousCharacterCount:p,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:o}}static computeUnicodeHighlightReason(e,A){const y=new g(A);switch(y.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=e.codePointAt(0),D=y.ambiguousCharacters.getPrimaryConfusable(v),m=i.AmbiguousCharacters.getLocales().filter(L=>!i.AmbiguousCharacters.getInstance(new Set([...A.allowedLocales,L])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(D),notAmbiguousInLocales:m}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=w;function a(d,e){return`[${i.escapeRegExpCharacters(d.map(y=>String.fromCodePoint(y)).join(""))}]`}var l;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const A of i.InvisibleCharacters.codePoints)M(String.fromCodePoint(A))||e.add(A);if(this.b.ambiguousCharacters)for(const A of this.ambiguousCharacters.getConfusableCodePoints())e.add(A);for(const A of this.a)e.delete(A);return e}shouldHighlightNonBasicASCII(e,A){const y=e.codePointAt(0);if(this.a.has(y))return 0;if(this.b.nonBasicASCII)return 1;let _=!1,v=!1;if(A)for(const D of A){const m=D.codePointAt(0),L=i.isBasicASCII(D);_=_||L,!L&&!this.ambiguousCharacters.isAmbiguous(m)&&!i.InvisibleCharacters.isInvisibleCharacter(m)&&(v=!0)}return!_&&v?0:this.b.invisibleCharacters&&!M(e)&&i.InvisibleCharacters.isInvisibleCharacter(y)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(y)?3:0}}function M(d){return d===" "||d===`
`||d==="	"}var h;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(h||(h={}))}),J(K[53],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F||(t.AccessibilitySupport=F={}));var T;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(T||(t.CodeActionTriggerType=T={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u||(t.CompletionItemKind=u={}));var R;(function(n){n[n.Deprecated=1]="Deprecated"})(R||(t.CompletionItemTag=R={}));var w;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(t.CompletionTriggerKind=w={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var M;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(M||(t.DocumentHighlightKind=M={}));var h;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(h||(t.EditorAutoIndentStrategy=h={}));var d;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.parameterHints=82]="parameterHints",n[n.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",n[n.quickSuggestions=85]="quickSuggestions",n[n.quickSuggestionsDelay=86]="quickSuggestionsDelay",n[n.readOnly=87]="readOnly",n[n.renameOnType=88]="renameOnType",n[n.renderControlCharacters=89]="renderControlCharacters",n[n.renderFinalNewline=90]="renderFinalNewline",n[n.renderLineHighlight=91]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=93]="renderValidationDecorations",n[n.renderWhitespace=94]="renderWhitespace",n[n.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",n[n.roundedSelection=96]="roundedSelection",n[n.rulers=97]="rulers",n[n.scrollbar=98]="scrollbar",n[n.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=100]="scrollBeyondLastLine",n[n.scrollPredominantAxis=101]="scrollPredominantAxis",n[n.selectionClipboard=102]="selectionClipboard",n[n.selectionHighlight=103]="selectionHighlight",n[n.selectOnLineNumbers=104]="selectOnLineNumbers",n[n.showFoldingControls=105]="showFoldingControls",n[n.showUnused=106]="showUnused",n[n.snippetSuggestions=107]="snippetSuggestions",n[n.smartSelect=108]="smartSelect",n[n.smoothScrolling=109]="smoothScrolling",n[n.stickyScroll=110]="stickyScroll",n[n.stickyTabStops=111]="stickyTabStops",n[n.stopRenderingLineAfter=112]="stopRenderingLineAfter",n[n.suggest=113]="suggest",n[n.suggestFontSize=114]="suggestFontSize",n[n.suggestLineHeight=115]="suggestLineHeight",n[n.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",n[n.suggestSelection=117]="suggestSelection",n[n.tabCompletion=118]="tabCompletion",n[n.tabIndex=119]="tabIndex",n[n.unicodeHighlighting=120]="unicodeHighlighting",n[n.unusualLineTerminators=121]="unusualLineTerminators",n[n.useShadowDOM=122]="useShadowDOM",n[n.useTabStops=123]="useTabStops",n[n.wordBreak=124]="wordBreak",n[n.wordSeparators=125]="wordSeparators",n[n.wordWrap=126]="wordWrap",n[n.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=129]="wordWrapColumn",n[n.wordWrapOverride1=130]="wordWrapOverride1",n[n.wordWrapOverride2=131]="wordWrapOverride2",n[n.wrappingIndent=132]="wrappingIndent",n[n.wrappingStrategy=133]="wrappingStrategy",n[n.showDeprecated=134]="showDeprecated",n[n.inlayHints=135]="inlayHints",n[n.editorClassName=136]="editorClassName",n[n.pixelRatio=137]="pixelRatio",n[n.tabFocusMode=138]="tabFocusMode",n[n.layoutInfo=139]="layoutInfo",n[n.wrappingInfo=140]="wrappingInfo",n[n.defaultColorDecorators=141]="defaultColorDecorators"})(d||(t.EditorOption=d={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var A;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(A||(t.EndOfLineSequence=A={}));var y;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(y||(t.GlyphMarginLane=y={}));var _;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(_||(t.IndentAction=_={}));var v;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var D;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(D||(t.InlayHintKind=D={}));var m;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(m||(t.InlineCompletionTriggerKind=m={}));var L;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(L||(t.KeyCode=L={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var s;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(s||(t.MarkerTag=s={}));var b;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(b||(t.MinimapPosition=b={}));var f;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(f||(t.MouseTargetType=f={}));var p;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(p||(t.OverlayWidgetPositionPreference=p={}));var c;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(c||(t.OverviewRulerLane=c={}));var o;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(o||(t.PositionAffinity=o={}));var N;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(N||(t.RenderLineNumbersType=N={}));var P;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(P||(t.RenderMinimap=P={}));var S;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(S||(t.ScrollType=S={}));var E;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(E||(t.ScrollbarVisibility=E={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var W;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(W||(t.SymbolKind=W={}));var z;(function(n){n[n.Deprecated=1]="Deprecated"})(z||(t.SymbolTag=z={}));var Z;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(Z||(t.TextEditorCursorBlinkingStyle=Z={}));var Y;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Y||(t.TextEditorCursorStyle=Y={}));var G;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G||(t.TrackedRangeStickiness=G={}));var se;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(se||(t.WrappingIndent=se={}))}),J(K[54],ee([0,1,9,7]),function(j,t,F,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new F.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,a){return this.a.set(w,a),this.handleChange([w]),(0,T.toDisposable)(()=>{this.a.get(w)===a&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,a){this.b.get(w)?.dispose();const l=new u(this,w,a);return this.b.set(w,l),(0,T.toDisposable)(()=>{const g=this.b.get(w);!g||g!==l||(this.b.delete(w),g.dispose())})}async getOrCreate(w){const a=this.get(w);if(a)return a;const l=this.b.get(w);return!l||l.isResolved?null:(await l.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const l=this.b.get(w);return!!(!l||l.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.TokenizationRegistry=i;class u extends T.Disposable{get isResolved(){return this.c}constructor(w,a,l){super(),this.f=w,this.g=a,this.h=l,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),J(K[55],ee([0,1,36,13,3,54]),function(j,t,F,T,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class R{constructor(I,q,W){this.offset=I,this.type=q,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=R;class w{constructor(I,q){this.tokens=I,this.endState=q,this._tokenizationResultBrand=void 0}}t.TokenizationResult=w;class a{constructor(I,q){this.tokens=I,this.endState=q,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=a;var l;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(l||(t.CompletionItemKind=l={}));var g;(function(E){const I=new Map;I.set(0,F.Codicon.symbolMethod),I.set(1,F.Codicon.symbolFunction),I.set(2,F.Codicon.symbolConstructor),I.set(3,F.Codicon.symbolField),I.set(4,F.Codicon.symbolVariable),I.set(5,F.Codicon.symbolClass),I.set(6,F.Codicon.symbolStruct),I.set(7,F.Codicon.symbolInterface),I.set(8,F.Codicon.symbolModule),I.set(9,F.Codicon.symbolProperty),I.set(10,F.Codicon.symbolEvent),I.set(11,F.Codicon.symbolOperator),I.set(12,F.Codicon.symbolUnit),I.set(13,F.Codicon.symbolValue),I.set(15,F.Codicon.symbolEnum),I.set(14,F.Codicon.symbolConstant),I.set(15,F.Codicon.symbolEnum),I.set(16,F.Codicon.symbolEnumMember),I.set(17,F.Codicon.symbolKeyword),I.set(27,F.Codicon.symbolSnippet),I.set(18,F.Codicon.symbolText),I.set(19,F.Codicon.symbolColor),I.set(20,F.Codicon.symbolFile),I.set(21,F.Codicon.symbolReference),I.set(22,F.Codicon.symbolCustomColor),I.set(23,F.Codicon.symbolFolder),I.set(24,F.Codicon.symbolTypeParameter),I.set(25,F.Codicon.account),I.set(26,F.Codicon.issues);function q(Z){let Y=I.get(Z);return Y||(console.info("No codicon found for CompletionItemKind "+Z),Y=F.Codicon.symbolProperty),Y}E.toIcon=q;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function z(Z,Y){let G=W.get(Z);return typeof G>"u"&&!Y&&(G=9),G}E.fromString=z})(g||(t.CompletionItemKinds=g={}));var M;(function(E){E[E.Deprecated=1]="Deprecated"})(M||(t.CompletionItemTag=M={}));var h;(function(E){E[E.None=0]="None",E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(h||(t.CompletionItemInsertTextRule=h={}));var d;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var e;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(e||(t.InlineCompletionTriggerKind=e={}));class A{constructor(I,q,W,z){this.range=I,this.text=q,this.completionKind=W,this.isSnippetText=z}equals(I){return i.Range.lift(this.range).equalsRange(I.range)&&this.text===I.text&&this.completionKind===I.completionKind&&this.isSnippetText===I.isSnippetText}}t.SelectedSuggestionInfo=A;var y;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(y||(t.CodeActionTriggerType=y={}));var _;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var v;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(v||(t.DocumentHighlightKind=v={}));function D(E){return E&&T.URI.isUri(E.uri)&&i.Range.isIRange(E.range)&&(i.Range.isIRange(E.originSelectionRange)||i.Range.isIRange(E.targetSelectionRange))}t.isLocationLink=D;var m;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(m||(t.SymbolKind=m={}));var L;(function(E){E[E.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var r;(function(E){const I=new Map;I.set(0,F.Codicon.symbolFile),I.set(1,F.Codicon.symbolModule),I.set(2,F.Codicon.symbolNamespace),I.set(3,F.Codicon.symbolPackage),I.set(4,F.Codicon.symbolClass),I.set(5,F.Codicon.symbolMethod),I.set(6,F.Codicon.symbolProperty),I.set(7,F.Codicon.symbolField),I.set(8,F.Codicon.symbolConstructor),I.set(9,F.Codicon.symbolEnum),I.set(10,F.Codicon.symbolInterface),I.set(11,F.Codicon.symbolFunction),I.set(12,F.Codicon.symbolVariable),I.set(13,F.Codicon.symbolConstant),I.set(14,F.Codicon.symbolString),I.set(15,F.Codicon.symbolNumber),I.set(16,F.Codicon.symbolBoolean),I.set(17,F.Codicon.symbolArray),I.set(18,F.Codicon.symbolObject),I.set(19,F.Codicon.symbolKey),I.set(20,F.Codicon.symbolNull),I.set(21,F.Codicon.symbolEnumMember),I.set(22,F.Codicon.symbolStruct),I.set(23,F.Codicon.symbolEvent),I.set(24,F.Codicon.symbolOperator),I.set(25,F.Codicon.symbolTypeParameter);function q(W){let z=I.get(W);return z||(console.info("No codicon found for SymbolKind "+W),z=F.Codicon.symbolProperty),z}E.toIcon=q})(r||(t.SymbolKinds=r={}));class s{static fromValue(I){switch(I){case"comment":return s.Comment;case"imports":return s.Imports;case"region":return s.Region}return new s(I)}constructor(I){this.value=I}}t.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var b;(function(E){function I(q){return!q||typeof q!="object"?!1:typeof q.id=="string"&&typeof q.title=="string"}E.is=I})(b||(t.Command=b={}));var f;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(f||(t.CommentThreadCollapsibleState=f={}));var p;(function(E){E[E.Unresolved=0]="Unresolved",E[E.Resolved=1]="Resolved"})(p||(t.CommentThreadState=p={}));var c;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(c||(t.CommentMode=c={}));var o;(function(E){E[E.Published=0]="Published",E[E.Draft=1]="Draft"})(o||(t.CommentState=o={}));var N;(function(E){E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(N||(t.InlayHintKind=N={}));class P{constructor(I){this.b=I,this.a=null}dispose(){this.a&&this.a.then(I=>{I&&I.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.LazyTokenizationSupport=P,t.TokenizationRegistry=new u.TokenizationRegistry;var S;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(S||(t.ExternalUriOpenerPriority=S={}))}),J(K[56],ee([0,1,18,9,30,13,4,3,37,55,53]),function(j,t,F,T,i,u,R,w,a,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class M{static chord(e,A){return(0,i.KeyChord)(e,A)}}t.KeyMod=M,M.CtrlCmd=2048,M.Shift=1024,M.Alt=512,M.WinCtrl=256;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.CancellationTokenSource,Emitter:T.Emitter,KeyCode:g.KeyCode,KeyMod:M,Position:R.Position,Range:w.Range,Selection:a.Selection,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:u.URI,Token:l.Token}}t.createMonacoBaseAPI=h}),J(K[59],ee([0,1,19,13,4,3,50,24,46,47,56,17,52,26,44,12,2,45]),function(j,t,F,T,i,u,R,w,a,l,g,M,h,d,e,A,y,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class v extends R.MirrorTextModel{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const s=[];for(let b=0;b<this.f.length;b++){const f=this.f[b],p=this.offsetAt(new i.Position(b+1,1)),c=f.matchAll(r);for(const o of c)(o.index||o.index===0)&&(o.index=o.index+p),s.push(o)}return s}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,s){const b=(0,w.getWordAtText)(r.column,(0,w.ensureValidWordDefinition)(s),this.f[r.lineNumber-1],0);return b?new u.Range(r.lineNumber,b.startColumn,r.lineNumber,b.endColumn):null}getWordUntilPosition(r,s){const b=this.getWordAtPosition(r,s);return b?{word:this.f[r.lineNumber-1].substring(b.startColumn-1,r.column-1),startColumn:b.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const s=this.f,b=this.q.bind(this);let f=0,p="",c=0,o=[];return{*[Symbol.iterator](){for(;;)if(c<o.length){const N=p.substring(o[c].start,o[c].end);c+=1,yield N}else if(f<s.length)p=s[f],o=b(p,r),c=0,f+=1;else break}}}getLineWords(r,s){const b=this.f[r-1],f=this.q(b,s),p=[];for(const c of f)p.push({word:b.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return p}q(r,s){const b=[];let f;for(s.lastIndex=0;(f=s.exec(r))&&f[0].length!==0;)b.push({start:f.index,end:f.index+f[0].length});return b}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const s=this.g,b=r.startLineNumber-1,f=r.endLineNumber-1,p=[];p.push(this.f[b].substring(r.startColumn-1));for(let c=b+1;c<f;c++)p.push(this.f[c]);return p.push(this.f[f].substring(0,r.endColumn-1)),p.join(s)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),b=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,b)}}r(r){const s=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),b=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return s.lineNumber!==r.startLineNumber||s.column!==r.startColumn||b.lineNumber!==r.endLineNumber||b.column!==r.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:b.lineNumber,endColumn:b.column}:r}s(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:s,column:b}=r,f=!1;if(s<1)s=1,b=1,f=!0;else if(s>this.f.length)s=this.f.length,b=this.f[s-1].length+1,f=!0;else{const p=this.f[s-1].length+1;b<1?(b=1,f=!0):b>p&&(b=p,f=!0)}return f?{lineNumber:s,column:b}:r}}class D{constructor(r,s){this.d=r,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(s=>r.push(this.f[s])),r}acceptNewModel(r){this.f[r.url]=new v(T.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,s){if(!this.f[r])return;this.f[r].onEvents(s)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,s,b){const f=this.j(r);return f?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(f,s,b):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,s,b,f){const p=this.j(r),c=this.j(s);return!p||!c?null:D.l(p,c,b,f)}static l(r,s,b,f){const p=f==="advanced"?e.linesDiffComputers.advanced:e.linesDiffComputers.legacy,c=r.getLinesContent(),o=s.getLinesContent(),N=p.computeDiff(c,o,b);return{identical:N.changes.length>0?!1:this.n(r,s),quitEarly:N.hitTimeout,changes:N.changes.map(S=>[S.originalRange.startLineNumber,S.originalRange.endLineNumberExclusive,S.modifiedRange.startLineNumber,S.modifiedRange.endLineNumberExclusive,S.innerChanges?.map(E=>[E.originalRange.startLineNumber,E.originalRange.startColumn,E.originalRange.endLineNumber,E.originalRange.endColumn,E.modifiedRange.startLineNumber,E.modifiedRange.startColumn,E.modifiedRange.endLineNumber,E.modifiedRange.endColumn])])}}static n(r,s){const b=r.getLineCount(),f=s.getLineCount();if(b!==f)return!1;for(let p=1;p<=b;p++){const c=r.getLineContent(p),o=s.getLineContent(p);if(c!==o)return!1}return!0}async computeDirtyDiff(r,s,b){const f=this.j(r),p=this.j(s);if(!f||!p)return null;const c=f.getLinesContent(),o=p.getLinesContent();return new d.DiffComputer(c,o,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:b,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,s,b){const f=this.j(r);if(!f)return s;const p=[];let c;s=s.slice(0).sort((o,N)=>{if(o.range&&N.range)return u.Range.compareRangesUsingStarts(o.range,N.range);const P=o.range?0:1,S=N.range?0:1;return P-S});for(let{range:o,text:N,eol:P}of s){if(typeof P=="number"&&(c=P),u.Range.isEmpty(o)&&!N)continue;const S=f.getValueInRange(o);if(N=N.replace(/\r\n|\n|\r/g,f.eol),S===N)continue;if(Math.max(N.length,S.length)>D.o){p.push({range:o,text:N});continue}const E=(0,F.stringDiff)(S,N,b),I=f.offsetAt(u.Range.lift(o).getStartPosition());for(const q of E){const W=f.positionAt(I+q.originalStart),z=f.positionAt(I+q.originalStart+q.originalLength),Z={text:N.substr(q.modifiedStart,q.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:z.lineNumber,endColumn:z.column}};f.getValueInRange(Z.range)!==Z.text&&p.push(Z)}}return typeof c=="number"&&p.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),p}async computeHumanReadableDiff(r,s,b){const f=this.j(r);if(!f)return s;const p=[];let c;s=s.slice(0).sort((o,N)=>{if(o.range&&N.range)return u.Range.compareRangesUsingStarts(o.range,N.range);const P=o.range?0:1,S=N.range?0:1;return P-S});for(let{range:o,text:N,eol:P}of s){let z=function(Y,G){return new i.Position(Y.lineNumber+G.lineNumber-1,G.lineNumber===1?Y.column+G.column-1:G.column)},Z=function(Y,G){const se=[];for(let n=G.startLineNumber;n<=G.endLineNumber;n++){const me=Y[n-1];n===G.startLineNumber&&n===G.endLineNumber?se.push(me.substring(G.startColumn-1,G.endColumn-1)):n===G.startLineNumber?se.push(me.substring(G.startColumn-1)):n===G.endLineNumber?se.push(me.substring(0,G.endColumn-1)):se.push(me)}return se};if(typeof P=="number"&&(c=P),u.Range.isEmpty(o)&&!N)continue;const S=f.getValueInRange(o);if(N=N.replace(/\r\n|\n|\r/g,f.eol),S===N)continue;if(Math.max(N.length,S.length)>D.o){p.push({range:o,text:N});continue}const E=S.split(/\r\n|\n|\r/),I=N.split(/\r\n|\n|\r/),q=e.linesDiffComputers.advanced.computeDiff(E,I,b),W=u.Range.lift(o).getStartPosition();for(const Y of q.changes)if(Y.innerChanges)for(const G of Y.innerChanges)p.push({range:u.Range.fromPositions(z(W,G.originalRange.getStartPosition()),z(W,G.originalRange.getEndPosition())),text:Z(I,G.modifiedRange).join(f.eol)});else throw new y.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof c=="number"&&p.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),p}async computeLinks(r){const s=this.j(r);return s?(0,a.computeLinks)(s):null}async computeDefaultDocumentColors(r){const s=this.j(r);return s?(0,_.computeDefaultDocumentColors)(s):null}async textualSuggest(r,s,b,f){const p=new M.StopWatch(!0),c=new RegExp(b,f),o=new Set;e:for(const N of r){const P=this.j(N);if(P){for(const S of P.words(c))if(!(S===s||!isNaN(Number(S)))&&(o.add(S),o.size>D.p))break e}}return{words:Array.from(o),duration:p.elapsed()}}async computeWordRanges(r,s,b,f){const p=this.j(r);if(!p)return Object.create(null);const c=new RegExp(b,f),o=Object.create(null);for(let N=s.startLineNumber;N<s.endLineNumber;N++){const P=p.getLineWords(N,c);for(const S of P){if(!isNaN(Number(S.word)))continue;let E=o[S.word];E||(E=[],o[S.word]=E),E.push({startLineNumber:N,startColumn:S.startColumn,endLineNumber:N,endColumn:S.endColumn})}}return o}async navigateValueSet(r,s,b,f,p){const c=this.j(r);if(!c)return null;const o=new RegExp(f,p);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const N=c.getValueInRange(s),P=c.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},o);if(!P)return null;const S=c.getValueInRange(P);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(s,N,P,S,b)}loadForeignModule(r,s,b){const f=(o,N)=>this.d.fhr(o,N),c={host:(0,A.createProxyObject)(b,f),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(c,s),Promise.resolve((0,A.getAllMethodNames)(this.h))):new Promise((o,N)=>{j([r],P=>{this.h=P.create(c,s),o((0,A.getAllMethodNames)(this.h))},N)})}fmr(r,s){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,s))}catch(b){return Promise.reject(b)}}}t.EditorSimpleWorker=D,D.o=1e5,D.p=1e4;function m(L){return new D(L,null)}t.create=m,typeof importScripts=="function"&&(globalThis.monaco=(0,g.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
