"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/objects","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","os","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/server/node/serverEnvironmentService","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/uriIpc","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","vs/base/common/hash","vs/base/common/glob","path","net","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/unc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","vs/server/node/server.main"],ve=function(oe){for(var e=[],w=0,L=oe.length;w<L;w++)e[w]=pe[oe[w]];return e};define(pe[140],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class w{static get(){const o=new Map,C=new Map,D=new Map,A=new Map;function v(m,g){m.has(g.detail)||m.set(g.detail,-g.timestamp)}function d(m,g){const b=m.get(g.detail);b&&(b>=0||m.set(g.detail,b+g.timestamp))}let R=[];typeof oe.getStats=="function"&&(R=oe.getStats().slice(0).sort((m,g)=>m.timestamp-g.timestamp));for(const m of R)switch(m.type){case 10:v(o,m);break;case 11:case 12:d(o,m);break;case 21:v(C,m);break;case 22:d(C,m);break;case 33:v(D,m);break;case 34:d(D,m);break;case 31:v(A,m);break;case 32:d(A,m);break}let y=0;D.forEach(m=>y+=m);function E(m){const g=[];return m.forEach((b,s)=>g.push([s,b])),g}return{amdLoad:E(o),amdInvoke:E(C),nodeRequire:E(D),nodeEval:E(A),nodeRequireTotal:y}}static toMarkdownTable(o,C){let D="";const A=[];return o.forEach((v,d)=>{A[d]=v.length}),C.forEach(v=>{v.forEach((d,R)=>{typeof d>"u"&&(d=v[R]="-");const y=d.toString().length;A[R]=Math.max(y,A[R])})}),o.forEach((v,d)=>{D+=`| ${v+" ".repeat(A[d]-v.toString().length)} `}),D+=`|
`,o.forEach((v,d)=>{D+=`| ${"-".repeat(A[d])} `}),D+=`|
`,C.forEach(v=>{v.forEach((d,R)=>{typeof d<"u"&&(D+=`| ${d+" ".repeat(A[R]-d.toString().length)} `)}),D+=`|
`}),D}}e.LoaderStats=w}),define(pe[92],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function w(D){return(A,v,d)=>{let R=null,y=null;if(typeof d.value=="function"?(R="value",y=d.value):typeof d.get=="function"&&(R="get",y=d.get),!y)throw new Error("not supported");d[R]=D(y,v)}}function L(D,A,v){let d=null,R=null;if(typeof v.value=="function"?(d="value",R=v.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(d="get",R=v.get),!R)throw new Error("not supported");const y=`$memoize$${A}`;v[d]=function(...E){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[y]}}e.memoize=L;function o(D,A,v){return w((d,R)=>{const y=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...m){this[E]||(this[E]=v?v():void 0),clearTimeout(this[y]),A&&(this[E]=A(this[E],...m),m=[this[E]]),this[y]=setTimeout(()=>{d.apply(this,m),this[E]=v?v():void 0},D)}})}e.debounce=o;function C(D,A,v){return w((d,R)=>{const y=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,m=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...b){if(this[E]||(this[E]=v?v():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),A&&(this[E]=A(this[E],...b)),this[g])return;const s=this[m]+D;s<=Date.now()?(this[m]=Date.now(),d.apply(this,[this[E]]),this[E]=v?v():void 0):(this[g]=!0,this[y]=setTimeout(()=>{this[g]=!1,this[m]=Date.now(),d.apply(this,[this[E]]),this[E]=v?v():void 0},s-Date.now()))}})}e.throttle=C}),define(pe[9],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?S.isErrorNoTelemetry(n)?new S(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=w,e.errorHandler=new w;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function o(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=o;function C(t){d(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=C;function D(t){d(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function A(t){if(t instanceof Error){const{name:n,message:r}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=A;const v="Canceled";function d(t){return t instanceof R?!0:t instanceof Error&&t.name===v&&t.message===v}e.isCancellationError=d;class R extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=R;function y(){const t=new Error(v);return t.name=t.message,t}e.canceled=y;function E(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=E;function m(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=m;function g(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function b(t){const n=new Error(`${t} has been disposed`);return n.name="DISPOSED",n}e.disposed=b;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class h extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=h;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class S extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof S)return n;const r=new S;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class O extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype);debugger}}e.BugIndicatingError=O}),define(pe[18],ve([1,0,9]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(z,j=0){return z[z.length-(1+j)]}e.tail=L;function o(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=o;function C(z,j,Y=(x,Z)=>x===Z){if(z===j)return!0;if(!z||!j||z.length!==j.length)return!1;for(let x=0,Z=z.length;x<Z;x++)if(!Y(z[x],j[x]))return!1;return!0}e.equals=C;function D(z,j){const Y=z.length-1;j<Y&&(z[j]=z[Y]),z.pop()}e.removeFastWithoutKeepingOrder=D;function A(z,j,Y){return v(z.length,x=>Y(z[x],j))}e.binarySearch=A;function v(z,j){let Y=0,x=z-1;for(;Y<=x;){const Z=(Y+x)/2|0,J=j(Z);if(J<0)Y=Z+1;else if(J>0)x=Z-1;else return Z}return-(Y+1)}e.binarySearch2=v;function d(z,j){let Y=0,x=z.length;if(x===0)return 0;for(;Y<x;){const Z=Math.floor((Y+x)/2);j(z[Z])?x=Z:Y=Z+1}return Y}e.findFirstInSorted=d;function R(z,j,Y){if(z=z|0,z>=j.length)throw new TypeError("invalid index");const x=j[Math.floor(j.length*Math.random())],Z=[],J=[],_=[];for(const le of j){const Ee=Y(le,x);Ee<0?Z.push(le):Ee>0?J.push(le):_.push(le)}return z<Z.length?R(z,Z,Y):z<Z.length+_.length?_[0]:R(z-(Z.length+_.length),J,Y)}e.quickSelect=R;function y(z,j){const Y=[];let x;for(const Z of z.slice(0).sort(j))!x||j(x[0],Z)!==0?(x=[Z],Y.push(x)):x.push(Z);return Y}e.groupBy=y;function E(z,j,Y){const x=[];function Z(le,Ee,Ce){if(Ee===0&&Ce.length===0)return;const ke=x[x.length-1];ke&&ke.start+ke.deleteCount===le?(ke.deleteCount+=Ee,ke.toInsert.push(...Ce)):x.push({start:le,deleteCount:Ee,toInsert:Ce})}let J=0,_=0;for(;;){if(J===z.length){Z(J,0,j.slice(_));break}if(_===j.length){Z(J,z.length-J,[]);break}const le=z[J],Ee=j[_],Ce=Y(le,Ee);Ce===0?(J+=1,_+=1):Ce<0?(Z(J,1,[]),J+=1):Ce>0&&(Z(J,0,[Ee]),_+=1)}return x}e.sortedDiff=E;function m(z,j,Y){const x=E(z,j,Y),Z=[],J=[];for(const _ of x)Z.push(...z.slice(_.start,_.start+_.deleteCount)),J.push(..._.toInsert);return{removed:Z,added:J}}e.delta=m;function g(z,j,Y){if(Y===0)return[];const x=z.slice(0,Y).sort(j);return s(z,j,x,Y,z.length),x}e.top=g;function b(z,j,Y,x,Z){return Y===0?Promise.resolve([]):new Promise((J,_)=>{(async()=>{const le=z.length,Ee=z.slice(0,Y).sort(j);for(let Ce=Y,ke=Math.min(Y+x,le);Ce<le;Ce=ke,ke=Math.min(ke+x,le)){if(Ce>Y&&await new Promise(Ue=>setTimeout(Ue)),Z&&Z.isCancellationRequested)throw new w.CancellationError;s(z,j,Ee,Ce,ke)}return Ee})().then(J,_)})}e.topAsync=b;function s(z,j,Y,x,Z){for(const J=Y.length;x<Z;x++){const _=z[x];if(j(_,Y[J-1])<0){Y.pop();const le=d(Y,Ee=>j(_,Ee)<0);Y.splice(le,0,_)}}}function h(z){return z.filter(j=>!!j)}e.coalesce=h;function u(z){let j=0;for(let Y=0;Y<z.length;Y++)z[Y]&&(z[j]=z[Y],j+=1);z.length=j}e.coalesceInPlace=u;function f(z,j,Y){z.splice(Y,0,z.splice(j,1)[0])}e.move=f;function S(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=S;function O(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=O;function t(z,j=Y=>Y){const Y=new Set;return z.filter(x=>{const Z=j(x);return Y.has(Z)?!1:(Y.add(Z),!0)})}e.distinct=t;function n(z){const j=new Set;return Y=>{const x=z(Y);return j.has(x)?!1:(j.add(x),!0)}}e.uniqueFilter=n;function r(z,j){const Y=i(z,j);if(Y!==-1)return z[Y]}e.findLast=r;function i(z,j){for(let Y=z.length-1;Y>=0;Y--){const x=z[Y];if(j(x))return Y}return-1}e.lastIndex=i;function a(z,j){return z.length>0?z[0]:j}e.firstOrDefault=a;function l(z,j){return z.length>0?z[z.length-1]:j}e.lastOrDefault=l;function c(z,j,Y=(x,Z)=>x===Z){let x=0;for(let Z=0,J=Math.min(z.length,j.length);Z<J&&Y(z[Z],j[Z]);Z++)x++;return x}e.commonPrefixLength=c;function p(z){return[].concat(...z)}e.flatten=p;function P(z,j){let Y=typeof j=="number"?z:0;typeof j=="number"?Y=z:(Y=0,j=z);const x=[];if(Y<=j)for(let Z=Y;Z<j;Z++)x.push(Z);else for(let Z=Y;Z>j;Z--)x.push(Z);return x}e.range=P;function T(z,j,Y){return z.reduce((x,Z)=>(x[j(Z)]=Y?Y(Z):Z,x),Object.create(null))}e.index=T;function I(z,j){return z.push(j),()=>F(z,j)}e.insert=I;function F(z,j){const Y=z.indexOf(j);if(Y>-1)return z.splice(Y,1),j}e.remove=F;function H(z,j,Y){const x=z.slice(0,j),Z=z.slice(j);return x.concat(Y,Z)}e.arrayInsert=H;function ee(z,j){let Y;if(typeof j=="number"){let x=j;Y=()=>{const Z=Math.sin(x++)*179426549;return Z-Math.floor(Z)}}else Y=Math.random;for(let x=z.length-1;x>0;x-=1){const Z=Math.floor(Y()*(x+1)),J=z[x];z[x]=z[Z],z[Z]=J}}e.shuffle=ee;function ce(z,j){const Y=z.indexOf(j);Y>-1&&(z.splice(Y,1),z.unshift(j))}e.pushToStart=ce;function ae(z,j){const Y=z.indexOf(j);Y>-1&&(z.splice(Y,1),z.push(j))}e.pushToEnd=ae;function ue(z,j){for(const Y of j)z.push(Y)}e.pushMany=ue;function ge(z,j){return Array.isArray(z)?z.map(j):j(z)}e.mapArrayOrNot=ge;function G(z){return Array.isArray(z)?z:[z]}e.asArray=G;function te(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=te;function W(z,j){for(const Y of z){const x=j(Y);if(x!==void 0)return x}}e.mapFind=W;function K(z,j,Y){const x=ie(z,j),Z=z.length,J=Y.length;z.length=Z+J;for(let _=Z-1;_>=x;_--)z[_+J]=z[_];for(let _=0;_<J;_++)z[_+x]=Y[_]}e.insertInto=K;function q(z,j,Y,x){const Z=ie(z,j),J=z.splice(Z,Y);return K(z,Z,x),J}e.splice=q;function ie(z,j){return j<0?Math.max(j+z.length,0):Math.min(j,z.length)}var re;(function(z){function j(Z){return Z<0}z.isLessThan=j;function Y(Z){return Z>0}z.isGreaterThan=Y;function x(Z){return Z===0}z.isNeitherLessOrGreaterThan=x,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function de(z,j){return(Y,x)=>j(z(Y),z(x))}e.compareBy=de;function $(...z){return(j,Y)=>{for(const x of z){const Z=x(j,Y);if(!re.isNeitherLessOrGreaterThan(Z))return Z}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const V=(z,j)=>z-j;e.numberComparator=V;function N(z,j){if(z.length===0)return;let Y=z[0];for(let x=1;x<z.length;x++){const Z=z[x];j(Z,Y)>0&&(Y=Z)}return Y}e.findMaxBy=N;function k(z,j){if(z.length===0)return;let Y=z[0];for(let x=1;x<z.length;x++){const Z=z[x];j(Z,Y)>=0&&(Y=Z)}return Y}e.findLastMaxBy=k;function U(z,j){return N(z,(Y,x)=>-j(Y,x))}e.findMinBy=U;class X{constructor(j){this.f=j,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(j){let Y=this.c;for(;Y<this.f.length&&j(this.f[Y]);)Y++;const x=Y===this.c?null:this.f.slice(this.c,Y);return this.c=Y,x}takeFromEndWhile(j){let Y=this.d;for(;Y>=0&&j(this.f[Y]);)Y--;const x=Y===this.d?null:this.f.slice(Y+1,this.d+1);return this.d=Y,x}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const j=this.f[this.c];return this.c++,j}removeLast(){const j=this.f[this.d];return this.d--,j}takeCount(j){const Y=this.f.slice(this.c,this.c+j);return this.c+=j,Y}}e.ArrayQueue=X;class ne{constructor(j){this.iterate=j}forEach(j){this.iterate(Y=>(j(Y),!0))}toArray(){const j=[];return this.iterate(Y=>(j.push(Y),!0)),j}filter(j){return new ne(Y=>this.iterate(x=>j(x)?Y(x):!0))}map(j){return new ne(Y=>this.iterate(x=>Y(j(x))))}some(j){let Y=!1;return this.iterate(x=>(Y=j(x),!Y)),Y}findFirst(j){let Y;return this.iterate(x=>j(x)?(Y=x,!1):!0),Y}findLast(j){let Y;return this.iterate(x=>(j(x)&&(Y=x),!0)),Y}findLastMaxBy(j){let Y,x=!0;return this.iterate(Z=>((x||re.isGreaterThan(j(Z,Y)))&&(x=!1,Y=Z),!0)),Y}}e.CallbackIterable=ne,ne.empty=new ne(z=>{})}),define(pe[93],ve([1,0,9]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(v,d){if(!v)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=L;function o(v,d="Unreachable"){throw new Error(d)}e.assertNever=o;function C(v){if(!v)throw new w.BugIndicatingError("Assertion Failed")}e.assert=C;function D(v){if(!v()){debugger;v(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function A(v,d){let R=0;for(;R<v.length-1;){const y=v[R],E=v[R+1];if(!d(y,E))return!1;R++}return!0}e.checkAdjacentItems=A}),define(pe[71],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(L){const o=this;let C=!1,D;return function(){return C||(C=!0,D=L.apply(o,arguments)),D}}e.once=w}),define(pe[46],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function o(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}L.is=o;const C=Object.freeze([]);function D(){return C}L.empty=D;function*A(S){yield S}L.single=A;function v(S){return o(S)?S:A(S)}L.wrap=v;function d(S){return S||C}L.from=d;function R(S){return!S||S[Symbol.iterator]().next().done===!0}L.isEmpty=R;function y(S){return S[Symbol.iterator]().next().value}L.first=y;function E(S,O){for(const t of S)if(O(t))return!0;return!1}L.some=E;function m(S,O){for(const t of S)if(O(t))return t}L.find=m;function*g(S,O){for(const t of S)O(t)&&(yield t)}L.filter=g;function*b(S,O){let t=0;for(const n of S)yield O(n,t++)}L.map=b;function*s(...S){for(const O of S)for(const t of O)yield t}L.concat=s;function h(S,O,t){let n=t;for(const r of S)n=O(n,r);return n}L.reduce=h;function*u(S,O,t=S.length){for(O<0&&(O+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);O<t;O++)yield S[O]}L.slice=u;function f(S,O=Number.POSITIVE_INFINITY){const t=[];if(O===0)return[t,S];const n=S[Symbol.iterator]();for(let r=0;r<O;r++){const i=n.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return n}}]}L.consume=f})(w||(e.Iterable=w={}))}),define(pe[72],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var o;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(o||(e.ParseErrorCode=o={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C||(e.ParseOptions=C={}));function D(t,n=!1){let r=0;const i=t.length;let a="",l=0,c=16,p=0;function P(ae){let ue=0,ge=0;for(;ue<ae;){const G=t.charCodeAt(r);if(G>=48&&G<=57)ge=ge*16+G-48;else if(G>=65&&G<=70)ge=ge*16+G-65+10;else if(G>=97&&G<=102)ge=ge*16+G-97+10;else break;r++,ue++}return ue<ae&&(ge=-1),ge}function T(ae){r=ae,a="",l=0,c=16,p=0}function I(){const ae=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&d(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&d(t.charCodeAt(r)))for(r++;r<t.length&&d(t.charCodeAt(r));)r++;else return p=3,t.substring(ae,r);let ue=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&d(t.charCodeAt(r))){for(r++;r<t.length&&d(t.charCodeAt(r));)r++;ue=r}else p=3;return t.substring(ae,ue)}function F(){let ae="",ue=r;for(;;){if(r>=i){ae+=t.substring(ue,r),p=2;break}const ge=t.charCodeAt(r);if(ge===34){ae+=t.substring(ue,r),r++;break}if(ge===92){if(ae+=t.substring(ue,r),r++,r>=i){p=2;break}switch(t.charCodeAt(r++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const te=P(4);te>=0?ae+=String.fromCharCode(te):p=4;break}default:p=5}ue=r;continue}if(ge>=0&&ge<=31)if(v(ge)){ae+=t.substring(ue,r),p=2;break}else p=6;r++}return ae}function H(){if(a="",p=0,l=r,r>=i)return l=i,c=17;let ae=t.charCodeAt(r);if(A(ae)){do r++,a+=String.fromCharCode(ae),ae=t.charCodeAt(r);while(A(ae));return c=15}if(v(ae))return r++,a+=String.fromCharCode(ae),ae===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),c=14;switch(ae){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,a=F(),c=10;case 47:{const ue=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!v(t.charCodeAt(r));)r++;return a=t.substring(ue,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const ge=i-1;let G=!1;for(;r<ge;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,p=1),a=t.substring(ue,r),c=13}return a+=String.fromCharCode(ae),r++,c=16}case 45:if(a+=String.fromCharCode(ae),r++,r===i||!d(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=I(),c=11;default:for(;r<i&&ee(ae);)r++,ae=t.charCodeAt(r);if(l!==r){switch(a=t.substring(l,r),a){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return a+=String.fromCharCode(ae),r++,c=16}}function ee(ae){if(A(ae)||v(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let ae;do ae=H();while(ae>=12&&ae<=15);return ae}return{setPosition:T,getPosition:()=>r,scan:n?ce:H,getToken:()=>c,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>p}}e.createScanner=D;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function y(t,n){const r=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function p(P,T,I,F){l.value=P,l.offset=T,l.length=I,l.type=F,l.colonOffset=void 0,a=l}try{f(t,{onObjectBegin:(P,T)=>{if(n<=P)throw i;a=void 0,c=n>P,r.push("")},onObjectProperty:(P,T,I)=>{if(n<T||(p(P,T,I,"property"),r[r.length-1]=P,n<=T+I))throw i},onObjectEnd:(P,T)=>{if(n<=P)throw i;a=void 0,r.pop()},onArrayBegin:(P,T)=>{if(n<=P)throw i;a=void 0,r.push(0)},onArrayEnd:(P,T)=>{if(n<=P)throw i;a=void 0,r.pop()},onLiteralValue:(P,T,I)=>{if(n<T||(p(P,T,I,O(P)),n<=T+I))throw i},onSeparator:(P,T,I)=>{if(n<=T)throw i;if(P===":"&&a&&a.type==="property")a.colonOffset=T,c=!1,a=void 0;else if(P===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(c=!0,r[r.length-1]=""),a=void 0}}})}catch(P){if(P!==i)throw P}return{path:r,previousNode:a,isAtPropertyKey:c,matches:P=>{let T=0;for(let I=0;T<P.length&&I<r.length;I++)if(P[T]===r[I]||P[T]==="*")T++;else if(P[T]!=="**")return!1;return T===P.length}}}e.getLocation=y;function E(t,n=[],r=C.DEFAULT){let i=null,a=[];const l=[];function c(P){Array.isArray(a)?a.push(P):i!==null&&(a[i]=P)}return f(t,{onObjectBegin:()=>{const P={};c(P),l.push(a),a=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const P=[];c(P),l.push(a),a=P,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:c,onError:(P,T,I)=>{n.push({error:P,offset:T,length:I})}},r),a[0]}e.parse=E;function m(t,n=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){i.type==="property"&&(i.length=P-i.offset,i=i.parent)}function l(P){return i.children.push(P),P}f(t,{onObjectBegin:P=>{i=l({type:"object",offset:P,length:-1,parent:i,children:[]})},onObjectProperty:(P,T,I)=>{i=l({type:"property",offset:T,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:P,offset:T,length:I,parent:i})},onObjectEnd:(P,T)=>{i.length=P+T-i.offset,i=i.parent,a(P+T)},onArrayBegin:(P,T)=>{i=l({type:"array",offset:P,length:-1,parent:i,children:[]})},onArrayEnd:(P,T)=>{i.length=P+T-i.offset,i=i.parent,a(P+T)},onLiteralValue:(P,T,I)=>{l({type:O(P),offset:T,length:I,parent:i,value:P}),a(T+I)},onSeparator:(P,T,I)=>{i.type==="property"&&(P===":"?i.colonOffset=T:P===","&&a(T))},onError:(P,T,I)=>{n.push({error:P,offset:T,length:I})}},r);const p=i.children[0];return p&&delete p.parent,p}e.parseTree=m;function g(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=g;function b(t){if(!t.parent||!t.parent.children)return[];const n=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=b;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=s(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function h(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=h;function u(t,n,r=!1){if(h(t,n,r)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=u(i[a],n,r);if(l)return l}return t}}e.findNodeAtOffset=u;function f(t,n,r=C.DEFAULT){const i=D(t,!1);function a(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(de){return de?$=>de($,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=a(n.onObjectBegin),p=l(n.onObjectProperty),P=a(n.onObjectEnd),T=a(n.onArrayBegin),I=a(n.onArrayEnd),F=l(n.onLiteralValue),H=l(n.onSeparator),ee=a(n.onComment),ce=l(n.onError),ae=r&&r.disallowComments,ue=r&&r.allowTrailingComma;function ge(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ae||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(de){case 12:case 13:ae?G(10):ee();break;case 16:G(1);break;case 15:case 14:break;default:return de}}}function G(de,$=[],V=[]){if(ce(de),$.length+V.length>0){let N=i.getToken();for(;N!==17;){if($.indexOf(N)!==-1){ge();break}else if(V.indexOf(N)!==-1)break;N=ge()}}}function te(de){const $=i.getTokenValue();return de?F($):p($),ge(),!0}function W(){switch(i.getToken()){case 11:{let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(G(2),de=0)}catch{G(2)}F(de);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ge(),!0}function K(){return i.getToken()!==10?(G(3,[],[2,5]),!1):(te(!1),i.getToken()===6?(H(":"),ge(),re()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function q(){c(),ge();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||G(4,[],[]),H(","),ge(),i.getToken()===2&&ue)break}else de&&G(6,[],[]);K()||G(4,[],[2,5]),de=!0}return P(),i.getToken()!==2?G(7,[2],[]):ge(),!0}function ie(){T(),ge();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||G(4,[],[]),H(","),ge(),i.getToken()===4&&ue)break}else de&&G(6,[],[]);re()||G(4,[],[4,5]),de=!0}return I(),i.getToken()!==4?G(8,[4],[]):ge(),!0}function re(){switch(i.getToken()){case 3:return ie();case 1:return q();case 10:return te(!0);default:return W()}}return ge(),i.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):re()?(i.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=f;function S(t,n){const r=D(t),i=[];let a,l=0,c;do switch(c=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:l!==c&&i.push(t.substring(l,c)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(a!==17);return i.join("")}e.stripComments=S;function O(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=O}),define(pe[141],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(o){this.d=o,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(o){this.c=o}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=w}),define(pe[2],ve([1,0,71,46]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const o=!1;let C=null;function D(l){C=l}if(e.setDisposableTracker=D,o){const l="__is_disposable_tracked__";D(new class{trackDisposable(c){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[l]||console.log(p)},3e3)}setParent(c,p){if(c&&c!==u.None)try{c[l]=!0}catch{}}markAsDisposed(c){if(c&&c!==u.None)try{c[l]=!0}catch{}}markAsSingleton(c){}})}function A(l){return C?.trackDisposable(l),l}function v(l){C?.markAsDisposed(l)}function d(l,c){C?.setParent(l,c)}function R(l,c){if(C)for(const p of l)C.setParent(p,c)}function y(l){return C?.markAsSingleton(l),l}e.markAsSingleton=y;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function m(l){if(L.Iterable.is(l)){const c=[];for(const p of l)if(p)try{p.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=m;function g(l){for(const c of l)E(c)&&c.dispose();return[]}e.disposeIfDisposable=g;function b(...l){const c=s(()=>m(l));return R(l,c),c}e.combinedDisposable=b;function s(l){const c=A({dispose:(0,w.once)(()=>{v(c),l()})});return c}e.toDisposable=s;class h{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return d(c,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(c),c}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new h,A(this),d(this.q,this)}dispose(){v(this),this.q.dispose()}B(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class f{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&d(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&d(c,null),c}}e.MutableDisposable=f;class S{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(c){let p=c;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,v(this))},this}}e.SafeDisposable=O;class t{constructor(){this.a=new Map}acquire(c,...p){let P=this.a.get(c);P||(P={counter:0,object:this.b(c,...p)},this.a.set(c,P));const{object:T}=P,I=(0,w.once)(()=>{--P.counter===0&&(this.c(c,P.object),this.a.delete(c))});return P.counter++,{object:T,dispose:I}}}e.ReferenceCollection=t;class n{constructor(c){this.a=c}async acquire(c,...p){const P=this.a.acquire(c,...p);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(T){throw P.dispose(),T}}}e.AsyncReferenceCollection=n;class r{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=r;function i(l){const c=new h;try{l(c)}finally{c.dispose()}}e.disposeOnReturn=i;class a{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get(c){return this.a.get(c)}set(c,p,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(c)?.dispose(),this.a.set(c,p)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(pe[94],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(C){this.element=C,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class L{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let C=this.a;for(;C!==w.Undefined;){const D=C.next;C.prev=w.Undefined,C.next=w.Undefined,C=D}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(C){return this.d(C,!1)}push(C){return this.d(C,!0)}d(C,D){const A=new w(C);if(this.a===w.Undefined)this.a=A,this.b=A;else if(D){const d=this.b;this.b=A,A.prev=d,d.next=A}else{const d=this.a;this.a=A,A.next=d,d.prev=A}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(A))}}shift(){if(this.a!==w.Undefined){const C=this.a.element;return this.e(this.a),C}}pop(){if(this.b!==w.Undefined){const C=this.b.element;return this.e(this.b),C}}e(C){if(C.prev!==w.Undefined&&C.next!==w.Undefined){const D=C.prev;D.next=C.next,C.next.prev=D}else C.prev===w.Undefined&&C.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):C.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):C.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let C=this.a;for(;C!==w.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),define(pe[28],ve([1,0]),function(oe,e){"use strict";var w,L,o;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function C(b,s,h){let u=b.get(s);return u===void 0&&(u=h,b.set(s,u)),u}e.getOrSet=C;function D(b){const s=[];return b.forEach((h,u)=>{s.push(`${u} => ${h}`)}),`Map(${b.size}) {${s.join(", ")}}`}e.mapToString=D;function A(b){const s=[];return b.forEach(h=>{s.push(h)}),`Set(${b.size}) {${s.join(", ")}}`}e.setToString=A;class v{constructor(s,h){this.uri=s,this.value=h}}class d{constructor(s,h){this[w]="ResourceMap",s instanceof d?(this.b=new Map(s.b),this.c=h??d.a):(this.b=new Map,this.c=s??d.a)}set(s,h){return this.b.set(this.c(s),new v(s,h)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,h){typeof h<"u"&&(s=s.bind(h));for(const[u,f]of this.b)s(f.value,f.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.ResourceMap=d,d.a=b=>b.toString();class R{constructor(s,h){this[L]="ResourceSet",!s||typeof s=="function"?this.a=new d(s):(this.a=new d(h),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,h){this.a.forEach((u,f)=>s.call(h,f,f,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var y;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class E{constructor(){this[o]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,h=0){const u=this.a.get(s);if(u)return h!==0&&this.j(u,h),u.value}set(s,h,u=0){let f=this.a.get(s);if(f)f.value=h,u!==0&&this.j(f,u);else{switch(f={key:s,value:h,next:void 0,previous:void 0},u){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(s,f),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const h=this.a.get(s);if(h)return this.a.delete(s),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,h){const u=this.e;let f=this.b;for(;f;){if(h?s.bind(h)(f.value,f.key,this):s(f.value,f.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,h=this.e;let u=this.b;const f={[Symbol.iterator](){return f},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.key,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return f}values(){const s=this,h=this.e;let u=this.b;const f={[Symbol.iterator](){return f},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.value,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return f}entries(){const s=this,h=this.e;let u=this.b;const f={[Symbol.iterator](){return f},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:[u.key,u.value],done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return f}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>s;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const h=s.next,u=s.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}s.next=void 0,s.previous=void 0,this.e++}j(s,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(s===this.b)return;const u=s.next,f=s.previous;s===this.c?(f.next=void 0,this.c=f):(u.previous=f,f.next=u),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(h===2){if(s===this.c)return;const u=s.next,f=s.previous;s===this.b?(u.previous=void 0,this.b=u):(u.previous=f,f.next=u),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((h,u)=>{s.push([u,h])}),s}fromJSON(s){this.clear();for(const[h,u]of s)this.set(h,u)}}e.LinkedMap=E;class m extends E{constructor(s,h=1){super(),this.k=s,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,h=2){return super.get(s,h)}peek(s){return super.get(s,0)}set(s,h){return super.set(s,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=m;class g{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let h=this.a.get(s)||0;return h===0?!1:(h--,h===0?this.a.delete(s):this.a.set(s,h),!0)}has(s){return this.a.has(s)}}e.CounterSet=g}),function(oe,e){typeof define=="function"&&define.amd?define(pe[142],ve([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(z,j){for(var Y=0;Y<j.length;Y++){var x=j[Y];x.enumerable=x.enumerable||!1,x.configurable=!0,"value"in x&&(x.writable=!0),Object.defineProperty(z,x.key,x)}}function w(z,j,Y){return j&&e(z.prototype,j),Y&&e(z,Y),Object.defineProperty(z,"prototype",{writable:!1}),z}function L(z,j){if(z){if(typeof z=="string")return o(z,j);var Y=Object.prototype.toString.call(z).slice(8,-1);if(Y==="Object"&&z.constructor&&(Y=z.constructor.name),Y==="Map"||Y==="Set")return Array.from(z);if(Y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Y))return o(z,j)}}function o(z,j){(j==null||j>z.length)&&(j=z.length);for(var Y=0,x=new Array(j);Y<j;Y++)x[Y]=z[Y];return x}function C(z,j){var Y=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(Y)return(Y=Y.call(z)).next.bind(Y);if(Array.isArray(z)||(Y=L(z))||j&&z&&typeof z.length=="number"){Y&&(z=Y);var x=0;return function(){return x>=z.length?{done:!0}:{done:!1,value:z[x++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=D();function A(z){oe.defaults=z}var v=/[&<>"']/,d=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(j){return E[j]};function g(z,j){if(j){if(v.test(z))return z.replace(d,m)}else if(R.test(z))return z.replace(y,m);return z}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(z){return z.replace(b,function(j,Y){return Y=Y.toLowerCase(),Y==="colon"?":":Y.charAt(0)==="#"?Y.charAt(1)==="x"?String.fromCharCode(parseInt(Y.substring(2),16)):String.fromCharCode(+Y.substring(1)):""})}var h=/(^|[^\[])\^/g;function u(z,j){z=typeof z=="string"?z:z.source,j=j||"";var Y={replace:function(Z,J){return J=J.source||J,J=J.replace(h,"$1"),z=z.replace(Z,J),Y},getRegex:function(){return new RegExp(z,j)}};return Y}var f=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function O(z,j,Y){if(z){var x;try{x=decodeURIComponent(s(Y)).replace(f,"").toLowerCase()}catch{return null}if(x.indexOf("javascript:")===0||x.indexOf("vbscript:")===0||x.indexOf("data:")===0)return null}j&&!S.test(Y)&&(Y=a(j,Y));try{Y=encodeURI(Y).replace(/%25/g,"%")}catch{return null}return Y}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(z,j){t[" "+z]||(n.test(z)?t[" "+z]=z+"/":t[" "+z]=P(z,"/",!0)),z=t[" "+z];var Y=z.indexOf(":")===-1;return j.substring(0,2)==="//"?Y?j:z.replace(r,"$1")+j:j.charAt(0)==="/"?Y?j:z.replace(i,"$1")+j:z+j}var l={exec:function(){}};function c(z){for(var j=1,Y,x;j<arguments.length;j++){Y=arguments[j];for(x in Y)Object.prototype.hasOwnProperty.call(Y,x)&&(z[x]=Y[x])}return z}function p(z,j){var Y=z.replace(/\|/g,function(J,_,le){for(var Ee=!1,Ce=_;--Ce>=0&&le[Ce]==="\\";)Ee=!Ee;return Ee?"|":" |"}),x=Y.split(/ \|/),Z=0;if(x[0].trim()||x.shift(),x.length>0&&!x[x.length-1].trim()&&x.pop(),x.length>j)x.splice(j);else for(;x.length<j;)x.push("");for(;Z<x.length;Z++)x[Z]=x[Z].trim().replace(/\\\|/g,"|");return x}function P(z,j,Y){var x=z.length;if(x===0)return"";for(var Z=0;Z<x;){var J=z.charAt(x-Z-1);if(J===j&&!Y)Z++;else if(J!==j&&Y)Z++;else break}return z.slice(0,x-Z)}function T(z,j){if(z.indexOf(j[1])===-1)return-1;for(var Y=z.length,x=0,Z=0;Z<Y;Z++)if(z[Z]==="\\")Z++;else if(z[Z]===j[0])x++;else if(z[Z]===j[1]&&(x--,x<0))return Z;return-1}function I(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(z,j){if(j<1)return"";for(var Y="";j>1;)j&1&&(Y+=z),j>>=1,z+=z;return Y+z}function H(z,j,Y,x){var Z=j.href,J=j.title?g(j.title):null,_=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){x.state.inLink=!0;var le={type:"link",raw:Y,href:Z,title:J,text:_,tokens:x.inlineTokens(_)};return x.state.inLink=!1,le}return{type:"image",raw:Y,href:Z,title:J,text:g(_)}}function ee(z,j){var Y=z.match(/^(\s+)(?:```)/);if(Y===null)return j;var x=Y[1];return j.split(`
`).map(function(Z){var J=Z.match(/^\s+/);if(J===null)return Z;var _=J[0];return _.length>=x.length?Z.slice(x.length):Z}).join(`
`)}var ce=function(){function z(Y){this.options=Y||oe.defaults}var j=z.prototype;return j.space=function(x){var Z=this.rules.block.newline.exec(x);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},j.code=function(x){var Z=this.rules.block.code.exec(x);if(Z){var J=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?J:P(J,`
`)}}},j.fences=function(x){var Z=this.rules.block.fences.exec(x);if(Z){var J=Z[0],_=ee(J,Z[3]||"");return{type:"code",raw:J,lang:Z[2]?Z[2].trim():Z[2],text:_}}},j.heading=function(x){var Z=this.rules.block.heading.exec(x);if(Z){var J=Z[2].trim();if(/#$/.test(J)){var _=P(J,"#");(this.options.pedantic||!_||/ $/.test(_))&&(J=_.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:J,tokens:this.lexer.inline(J)}}},j.hr=function(x){var Z=this.rules.block.hr.exec(x);if(Z)return{type:"hr",raw:Z[0]}},j.blockquote=function(x){var Z=this.rules.block.blockquote.exec(x);if(Z){var J=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},j.list=function(x){var Z=this.rules.block.list.exec(x);if(Z){var J,_,le,Ee,Ce,ke,Ue,je,me,Se,we,Ne,ze=Z[1].trim(),tt=ze.length>1,Ve={type:"list",raw:"",ordered:tt,start:tt?+ze.slice(0,-1):"",loose:!1,items:[]};ze=tt?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=tt?ze:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");x&&(Ne=!1,!(!(Z=Xe.exec(x))||this.rules.block.hr.test(x)));){if(J=Z[0],x=x.substring(J.length),je=Z[2].split(`
`,1)[0],me=x.split(`
`,1)[0],this.options.pedantic?(Ee=2,we=je.trimLeft()):(Ee=Z[2].search(/[^ ]/),Ee=Ee>4?1:Ee,we=je.slice(Ee),Ee+=Z[1].length),ke=!1,!je&&/^ *$/.test(me)&&(J+=me+`
`,x=x.substring(me.length+1),Ne=!0),!Ne)for(var Qe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),Ye=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");x&&(Se=x.split(`
`,1)[0],je=Se,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(je)||Ye.test(je)||Qe.test(je)||it.test(x)));){if(je.search(/[^ ]/)>=Ee||!je.trim())we+=`
`+je.slice(Ee);else if(!ke)we+=`
`+je;else break;!ke&&!je.trim()&&(ke=!0),J+=Se+`
`,x=x.substring(Se.length+1)}Ve.loose||(Ue?Ve.loose=!0:/\n *\n *$/.test(J)&&(Ue=!0)),this.options.gfm&&(_=/^\[[ xX]\] /.exec(we),_&&(le=_[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:J,task:!!_,checked:le,loose:!1,text:we}),Ve.raw+=J}Ve.items[Ve.items.length-1].raw=J.trimRight(),Ve.items[Ve.items.length-1].text=we.trimRight(),Ve.raw=Ve.raw.trimRight();var he=Ve.items.length;for(Ce=0;Ce<he;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var De=Ve.items[Ce].tokens.filter(function(Re){return Re.type==="space"}),Te=De.every(function(Re){for(var Oe=Re.raw.split(""),$e=0,qe=C(Oe),xe;!(xe=qe()).done;){var _e=xe.value;if(_e===`
`&&($e+=1),$e>1)return!0}return!1});!Ve.loose&&De.length&&Te&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},j.html=function(x){var Z=this.rules.block.html.exec(x);if(Z){var J={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var _=this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]);J.type="paragraph",J.text=_,J.tokens=this.lexer.inline(_)}return J}},j.def=function(x){var Z=this.rules.block.def.exec(x);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var J=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:Z[0],href:Z[2],title:Z[3]}}},j.table=function(x){var Z=this.rules.block.table.exec(x);if(Z){var J={type:"table",header:p(Z[1]).map(function(Ue){return{text:Ue}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=Z[0];var _=J.align.length,le,Ee,Ce,ke;for(le=0;le<_;le++)/^ *-+: *$/.test(J.align[le])?J.align[le]="right":/^ *:-+: *$/.test(J.align[le])?J.align[le]="center":/^ *:-+ *$/.test(J.align[le])?J.align[le]="left":J.align[le]=null;for(_=J.rows.length,le=0;le<_;le++)J.rows[le]=p(J.rows[le],J.header.length).map(function(Ue){return{text:Ue}});for(_=J.header.length,Ee=0;Ee<_;Ee++)J.header[Ee].tokens=this.lexer.inline(J.header[Ee].text);for(_=J.rows.length,Ee=0;Ee<_;Ee++)for(ke=J.rows[Ee],Ce=0;Ce<ke.length;Ce++)ke[Ce].tokens=this.lexer.inline(ke[Ce].text);return J}}},j.lheading=function(x){var Z=this.rules.block.lheading.exec(x);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},j.paragraph=function(x){var Z=this.rules.block.paragraph.exec(x);if(Z){var J=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:J,tokens:this.lexer.inline(J)}}},j.text=function(x){var Z=this.rules.block.text.exec(x);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},j.escape=function(x){var Z=this.rules.inline.escape.exec(x);if(Z)return{type:"escape",raw:Z[0],text:g(Z[1])}},j.tag=function(x){var Z=this.rules.inline.tag.exec(x);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):g(Z[0]):Z[0]}},j.link=function(x){var Z=this.rules.inline.link.exec(x);if(Z){var J=Z[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var _=P(J.slice(0,-1),"\\");if((J.length-_.length)%2===0)return}else{var le=T(Z[2],"()");if(le>-1){var Ee=Z[0].indexOf("!")===0?5:4,Ce=Ee+Z[1].length+le;Z[2]=Z[2].substring(0,le),Z[0]=Z[0].substring(0,Ce).trim(),Z[3]=""}}var ke=Z[2],Ue="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);je&&(ke=je[1],Ue=je[3])}else Ue=Z[3]?Z[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(J)?ke=ke.slice(1):ke=ke.slice(1,-1)),H(Z,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},j.reflink=function(x,Z){var J;if((J=this.rules.inline.reflink.exec(x))||(J=this.rules.inline.nolink.exec(x))){var _=(J[2]||J[1]).replace(/\s+/g," ");if(_=Z[_.toLowerCase()],!_||!_.href){var le=J[0].charAt(0);return{type:"text",raw:le,text:le}}return H(J,_,J[0],this.lexer)}},j.emStrong=function(x,Z,J){J===void 0&&(J="");var _=this.rules.inline.emStrong.lDelim.exec(x);if(_&&!(_[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=_[1]||_[2]||"";if(!le||le&&(J===""||this.rules.inline.punctuation.exec(J))){var Ee=_[0].length-1,Ce,ke,Ue=Ee,je=0,me=_[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,Z=Z.slice(-1*x.length+Ee);(_=me.exec(Z))!=null;)if(Ce=_[1]||_[2]||_[3]||_[4]||_[5]||_[6],!!Ce){if(ke=Ce.length,_[3]||_[4]){Ue+=ke;continue}else if((_[5]||_[6])&&Ee%3&&!((Ee+ke)%3)){je+=ke;continue}if(Ue-=ke,!(Ue>0)){if(ke=Math.min(ke,ke+Ue+je),Math.min(Ee,ke)%2){var Se=x.slice(1,Ee+_.index+ke);return{type:"em",raw:x.slice(0,Ee+_.index+ke+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var we=x.slice(2,Ee+_.index+ke-1);return{type:"strong",raw:x.slice(0,Ee+_.index+ke+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},j.codespan=function(x){var Z=this.rules.inline.code.exec(x);if(Z){var J=Z[2].replace(/\n/g," "),_=/[^ ]/.test(J),le=/^ /.test(J)&&/ $/.test(J);return _&&le&&(J=J.substring(1,J.length-1)),J=g(J,!0),{type:"codespan",raw:Z[0],text:J}}},j.br=function(x){var Z=this.rules.inline.br.exec(x);if(Z)return{type:"br",raw:Z[0]}},j.del=function(x){var Z=this.rules.inline.del.exec(x);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},j.autolink=function(x,Z){var J=this.rules.inline.autolink.exec(x);if(J){var _,le;return J[2]==="@"?(_=g(this.options.mangle?Z(J[1]):J[1]),le="mailto:"+_):(_=g(J[1]),le=_),{type:"link",raw:J[0],text:_,href:le,tokens:[{type:"text",raw:_,text:_}]}}},j.url=function(x,Z){var J;if(J=this.rules.inline.url.exec(x)){var _,le;if(J[2]==="@")_=g(this.options.mangle?Z(J[0]):J[0]),le="mailto:"+_;else{var Ee;do Ee=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(Ee!==J[0]);_=g(J[0]),J[1]==="www."?le="http://"+_:le=_}return{type:"link",raw:J[0],text:_,href:le,tokens:[{type:"text",raw:_,text:_}]}}},j.inlineText=function(x,Z){var J=this.rules.inline.text.exec(x);if(J){var _;return this.lexer.state.inRawBlock?_=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):g(J[0]):J[0]:_=g(this.options.smartypants?Z(J[0]):J[0]),{type:"text",raw:J[0],text:_}}},z}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=u(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=u(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=u(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=u(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=u(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=u(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=c({},ae),ae.gfm=c({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=u(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=u(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=c({},ae.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:u(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=u(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=u(ae._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=u(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=u(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=u(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=u(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=u(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=u(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=u(ue.reflink).replace("label",ue._label).replace("ref",ae._label).getRegex(),ue.nolink=u(ue.nolink).replace("ref",ae._label).getRegex(),ue.reflinkSearch=u(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=c({},ue),ue.pedantic=c({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=c({},ue.normal,{escape:u(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=u(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=c({},ue.gfm,{br:u(ue.br).replace("{2,}","*").getRegex(),text:u(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(z){var j="",Y,x,Z=z.length;for(Y=0;Y<Z;Y++)x=z.charCodeAt(Y),Math.random()>.5&&(x="x"+x.toString(16)),j+="&#"+x+";";return j}var te=function(){function z(Y){this.tokens=[],this.tokens.links=Object.create(null),this.options=Y||oe.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var x={block:ae.normal,inline:ue.normal};this.options.pedantic?(x.block=ae.pedantic,x.inline=ue.pedantic):this.options.gfm&&(x.block=ae.gfm,this.options.breaks?x.inline=ue.breaks:x.inline=ue.gfm),this.tokenizer.rules=x}z.lex=function(x,Z){var J=new z(Z);return J.lex(x)},z.lexInline=function(x,Z){var J=new z(Z);return J.inlineTokens(x)};var j=z.prototype;return j.lex=function(x){x=x.replace(/\r\n|\r/g,`
`),this.blockTokens(x,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},j.blockTokens=function(x,Z){var J=this;Z===void 0&&(Z=[]),this.options.pedantic?x=x.replace(/\t/g,"    ").replace(/^ +$/gm,""):x=x.replace(/^( *)(\t+)/gm,function(Ue,je,me){return je+"    ".repeat(me.length)});for(var _,le,Ee,Ce;x;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(_=Ue.call({lexer:J},x,Z))?(x=x.substring(_.raw.length),Z.push(_),!0):!1}))){if(_=this.tokenizer.space(x)){x=x.substring(_.raw.length),_.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(_);continue}if(_=this.tokenizer.code(x)){x=x.substring(_.raw.length),le=Z[Z.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+_.raw,le.text+=`
`+_.text,this.inlineQueue[this.inlineQueue.length-1].src=le.text):Z.push(_);continue}if(_=this.tokenizer.fences(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.heading(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.hr(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.blockquote(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.list(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.html(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.def(x)){x=x.substring(_.raw.length),le=Z[Z.length-1],le&&(le.type==="paragraph"||le.type==="text")?(le.raw+=`
`+_.raw,le.text+=`
`+_.raw,this.inlineQueue[this.inlineQueue.length-1].src=le.text):this.tokens.links[_.tag]||(this.tokens.links[_.tag]={href:_.href,title:_.title});continue}if(_=this.tokenizer.table(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.lheading(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(Ee=x,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,je=x.slice(1),me=void 0;J.options.extensions.startBlock.forEach(function(Se){me=Se.call({lexer:this},je),typeof me=="number"&&me>=0&&(Ue=Math.min(Ue,me))}),Ue<1/0&&Ue>=0&&(Ee=x.substring(0,Ue+1))}(),this.state.top&&(_=this.tokenizer.paragraph(Ee))){le=Z[Z.length-1],Ce&&le.type==="paragraph"?(le.raw+=`
`+_.raw,le.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):Z.push(_),Ce=Ee.length!==x.length,x=x.substring(_.raw.length);continue}if(_=this.tokenizer.text(x)){x=x.substring(_.raw.length),le=Z[Z.length-1],le&&le.type==="text"?(le.raw+=`
`+_.raw,le.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=le.text):Z.push(_);continue}if(x){var ke="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,Z},j.inline=function(x,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:x,tokens:Z}),Z},j.inlineTokens=function(x,Z){var J=this;Z===void 0&&(Z=[]);var _,le,Ee,Ce=x,ke,Ue,je;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)me.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,ke.index)+"["+F("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"["+F("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;x;)if(Ue||(je=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(_=we.call({lexer:J},x,Z))?(x=x.substring(_.raw.length),Z.push(_),!0):!1}))){if(_=this.tokenizer.escape(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.tag(x)){x=x.substring(_.raw.length),le=Z[Z.length-1],le&&_.type==="text"&&le.type==="text"?(le.raw+=_.raw,le.text+=_.text):Z.push(_);continue}if(_=this.tokenizer.link(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.reflink(x,this.tokens.links)){x=x.substring(_.raw.length),le=Z[Z.length-1],le&&_.type==="text"&&le.type==="text"?(le.raw+=_.raw,le.text+=_.text):Z.push(_);continue}if(_=this.tokenizer.emStrong(x,Ce,je)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.codespan(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.br(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.del(x)){x=x.substring(_.raw.length),Z.push(_);continue}if(_=this.tokenizer.autolink(x,G)){x=x.substring(_.raw.length),Z.push(_);continue}if(!this.state.inLink&&(_=this.tokenizer.url(x,G))){x=x.substring(_.raw.length),Z.push(_);continue}if(Ee=x,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ne=x.slice(1),ze=void 0;J.options.extensions.startInline.forEach(function(tt){ze=tt.call({lexer:this},Ne),typeof ze=="number"&&ze>=0&&(we=Math.min(we,ze))}),we<1/0&&we>=0&&(Ee=x.substring(0,we+1))}(),_=this.tokenizer.inlineText(Ee,ge)){x=x.substring(_.raw.length),_.raw.slice(-1)!=="_"&&(je=_.raw.slice(-1)),Ue=!0,le=Z[Z.length-1],le&&le.type==="text"?(le.raw+=_.raw,le.text+=_.text):Z.push(_);continue}if(x){var Se="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return Z},w(z,null,[{key:"rules",get:function(){return{block:ae,inline:ue}}}]),z}(),W=function(){function z(Y){this.options=Y||oe.defaults}var j=z.prototype;return j.code=function(x,Z,J){var _=(Z||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(x,_);le!=null&&le!==x&&(J=!0,x=le)}return x=x.replace(/\n$/,"")+`
`,_?'<pre><code class="'+this.options.langPrefix+g(_,!0)+'">'+(J?x:g(x,!0))+`</code></pre>
`:"<pre><code>"+(J?x:g(x,!0))+`</code></pre>
`},j.blockquote=function(x){return`<blockquote>
`+x+`</blockquote>
`},j.html=function(x){return x},j.heading=function(x,Z,J,_){if(this.options.headerIds){var le=this.options.headerPrefix+_.slug(J);return"<h"+Z+' id="'+le+'">'+x+"</h"+Z+`>
`}return"<h"+Z+">"+x+"</h"+Z+`>
`},j.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},j.list=function(x,Z,J){var _=Z?"ol":"ul",le=Z&&J!==1?' start="'+J+'"':"";return"<"+_+le+`>
`+x+"</"+_+`>
`},j.listitem=function(x){return"<li>"+x+`</li>
`},j.checkbox=function(x){return"<input "+(x?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},j.paragraph=function(x){return"<p>"+x+`</p>
`},j.table=function(x,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+x+`</thead>
`+Z+`</table>
`},j.tablerow=function(x){return`<tr>
`+x+`</tr>
`},j.tablecell=function(x,Z){var J=Z.header?"th":"td",_=Z.align?"<"+J+' align="'+Z.align+'">':"<"+J+">";return _+x+("</"+J+`>
`)},j.strong=function(x){return"<strong>"+x+"</strong>"},j.em=function(x){return"<em>"+x+"</em>"},j.codespan=function(x){return"<code>"+x+"</code>"},j.br=function(){return this.options.xhtml?"<br/>":"<br>"},j.del=function(x){return"<del>"+x+"</del>"},j.link=function(x,Z,J){if(x=O(this.options.sanitize,this.options.baseUrl,x),x===null)return J;var _='<a href="'+g(x)+'"';return Z&&(_+=' title="'+Z+'"'),_+=">"+J+"</a>",_},j.image=function(x,Z,J){if(x=O(this.options.sanitize,this.options.baseUrl,x),x===null)return J;var _='<img src="'+x+'" alt="'+J+'"';return Z&&(_+=' title="'+Z+'"'),_+=this.options.xhtml?"/>":">",_},j.text=function(x){return x},z}(),K=function(){function z(){}var j=z.prototype;return j.strong=function(x){return x},j.em=function(x){return x},j.codespan=function(x){return x},j.del=function(x){return x},j.html=function(x){return x},j.text=function(x){return x},j.link=function(x,Z,J){return""+J},j.image=function(x,Z,J){return""+J},j.br=function(){return""},z}(),q=function(){function z(){this.seen={}}var j=z.prototype;return j.serialize=function(x){return x.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},j.getNextSafeSlug=function(x,Z){var J=x,_=0;if(this.seen.hasOwnProperty(J)){_=this.seen[x];do _++,J=x+"-"+_;while(this.seen.hasOwnProperty(J))}return Z||(this.seen[x]=_,this.seen[J]=0),J},j.slug=function(x,Z){Z===void 0&&(Z={});var J=this.serialize(x);return this.getNextSafeSlug(J,Z.dryrun)},z}(),ie=function(){function z(Y){this.options=Y||oe.defaults,this.options.renderer=this.options.renderer||new W,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new q}z.parse=function(x,Z){var J=new z(Z);return J.parse(x)},z.parseInline=function(x,Z){var J=new z(Z);return J.parseInline(x)};var j=z.prototype;return j.parse=function(x,Z){Z===void 0&&(Z=!0);var J="",_,le,Ee,Ce,ke,Ue,je,me,Se,we,Ne,ze,tt,Ve,Xe,Qe,it,Ge,Ye,he=x.length;for(_=0;_<he;_++){if(we=x[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Ye=this.options.extensions.renderers[we.type].call({parser:this},we),Ye!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){J+=Ye||"";continue}switch(we.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(we.tokens),we.depth,s(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(me="",je="",Ce=we.header.length,le=0;le<Ce;le++)je+=this.renderer.tablecell(this.parseInline(we.header[le].tokens),{header:!0,align:we.align[le]});for(me+=this.renderer.tablerow(je),Se="",Ce=we.rows.length,le=0;le<Ce;le++){for(Ue=we.rows[le],je="",ke=Ue.length,Ee=0;Ee<ke;Ee++)je+=this.renderer.tablecell(this.parseInline(Ue[Ee].tokens),{header:!1,align:we.align[Ee]});Se+=this.renderer.tablerow(je)}J+=this.renderer.table(me,Se);continue}case"blockquote":{Se=this.parse(we.tokens),J+=this.renderer.blockquote(Se);continue}case"list":{for(Ne=we.ordered,ze=we.start,tt=we.loose,Ce=we.items.length,Se="",le=0;le<Ce;le++)Xe=we.items[le],Qe=Xe.checked,it=Xe.task,Ve="",Xe.task&&(Ge=this.renderer.checkbox(Qe),tt?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=Ge+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=Ge+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:Ge}):Ve+=Ge),Ve+=this.parse(Xe.tokens,tt),Se+=this.renderer.listitem(Ve,it,Qe);J+=this.renderer.list(Se,Ne,ze);continue}case"html":{J+=this.renderer.html(we.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Se=we.tokens?this.parseInline(we.tokens):we.text;_+1<he&&x[_+1].type==="text";)we=x[++_],Se+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);J+=Z?this.renderer.paragraph(Se):Se;continue}default:{var De='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(De);return}else throw new Error(De)}}}return J},j.parseInline=function(x,Z){Z=Z||this.renderer;var J="",_,le,Ee,Ce=x.length;for(_=0;_<Ce;_++){if(le=x[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(Ee=this.options.extensions.renderers[le.type].call({parser:this},le),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(le.type))){J+=Ee||"";continue}switch(le.type){case"escape":{J+=Z.text(le.text);break}case"html":{J+=Z.html(le.text);break}case"link":{J+=Z.link(le.href,le.title,this.parseInline(le.tokens,Z));break}case"image":{J+=Z.image(le.href,le.title,le.text);break}case"strong":{J+=Z.strong(this.parseInline(le.tokens,Z));break}case"em":{J+=Z.em(this.parseInline(le.tokens,Z));break}case"codespan":{J+=Z.codespan(le.text);break}case"br":{J+=Z.br();break}case"del":{J+=Z.del(this.parseInline(le.tokens,Z));break}case"text":{J+=Z.text(le.text);break}default:{var ke='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return J},z}();function re(z,j,Y){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof j=="function"&&(Y=j,j=null),j=c({},re.defaults,j||{}),I(j),Y){var x=j.highlight,Z;try{Z=te.lex(z,j)}catch(Ce){return Y(Ce)}var J=function(ke){var Ue;if(!ke)try{j.walkTokens&&re.walkTokens(Z,j.walkTokens),Ue=ie.parse(Z,j)}catch(je){ke=je}return j.highlight=x,ke?Y(ke):Y(null,Ue)};if(!x||x.length<3||(delete j.highlight,!Z.length))return J();var _=0;re.walkTokens(Z,function(Ce){Ce.type==="code"&&(_++,setTimeout(function(){x(Ce.text,Ce.lang,function(ke,Ue){if(ke)return J(ke);Ue!=null&&Ue!==Ce.text&&(Ce.text=Ue,Ce.escaped=!0),_--,_===0&&J()})},0))}),_===0&&J();return}function le(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var Ee=te.lex(z,j);if(j.walkTokens){if(j.async)return Promise.all(re.walkTokens(Ee,j.walkTokens)).then(function(){return ie.parse(Ee,j)}).catch(le);re.walkTokens(Ee,j.walkTokens)}return ie.parse(Ee,j)}catch(Ce){le(Ce)}}re.options=re.setOptions=function(z){return c(re.defaults,z),A(re.defaults),re},re.getDefaults=D,re.defaults=oe.defaults,re.use=function(){for(var z=arguments.length,j=new Array(z),Y=0;Y<z;Y++)j[Y]=arguments[Y];var x=c.apply(void 0,[{}].concat(j)),Z=re.defaults.extensions||{renderers:{},childTokens:{}},J;j.forEach(function(_){if(_.extensions&&(J=!0,_.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var Ce=Z.renderers?Z.renderers[Ee.name]:null;Ce?Z.renderers[Ee.name]=function(){for(var ke=arguments.length,Ue=new Array(ke),je=0;je<ke;je++)Ue[je]=arguments[je];var me=Ee.renderer.apply(this,Ue);return me===!1&&(me=Ce.apply(this,Ue)),me}:Z.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[Ee.level]?Z[Ee.level].unshift(Ee.tokenizer):Z[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?Z.startBlock?Z.startBlock.push(Ee.start):Z.startBlock=[Ee.start]:Ee.level==="inline"&&(Z.startInline?Z.startInline.push(Ee.start):Z.startInline=[Ee.start]))}Ee.childTokens&&(Z.childTokens[Ee.name]=Ee.childTokens)})),_.renderer&&function(){var Ee=re.defaults.renderer||new W,Ce=function(je){var me=Ee[je];Ee[je]=function(){for(var Se=arguments.length,we=new Array(Se),Ne=0;Ne<Se;Ne++)we[Ne]=arguments[Ne];var ze=_.renderer[je].apply(Ee,we);return ze===!1&&(ze=me.apply(Ee,we)),ze}};for(var ke in _.renderer)Ce(ke);x.renderer=Ee}(),_.tokenizer&&function(){var Ee=re.defaults.tokenizer||new ce,Ce=function(je){var me=Ee[je];Ee[je]=function(){for(var Se=arguments.length,we=new Array(Se),Ne=0;Ne<Se;Ne++)we[Ne]=arguments[Ne];var ze=_.tokenizer[je].apply(Ee,we);return ze===!1&&(ze=me.apply(Ee,we)),ze}};for(var ke in _.tokenizer)Ce(ke);x.tokenizer=Ee}(),_.walkTokens){var le=re.defaults.walkTokens;x.walkTokens=function(Ee){var Ce=[];return Ce.push(_.walkTokens.call(this,Ee)),le&&(Ce=Ce.concat(le.call(this,Ee))),Ce}}J&&(x.extensions=Z),re.setOptions(x)})},re.walkTokens=function(z,j){for(var Y=[],x=function(){var le=J.value;switch(Y=Y.concat(j.call(re,le)),le.type){case"table":{for(var Ee=C(le.header),Ce;!(Ce=Ee()).done;){var ke=Ce.value;Y=Y.concat(re.walkTokens(ke.tokens,j))}for(var Ue=C(le.rows),je;!(je=Ue()).done;)for(var me=je.value,Se=C(me),we;!(we=Se()).done;){var Ne=we.value;Y=Y.concat(re.walkTokens(Ne.tokens,j))}break}case"list":{Y=Y.concat(re.walkTokens(le.items,j));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[le.type]?re.defaults.extensions.childTokens[le.type].forEach(function(ze){Y=Y.concat(re.walkTokens(le[ze],j))}):le.tokens&&(Y=Y.concat(re.walkTokens(le.tokens,j)))}},Z=C(z),J;!(J=Z()).done;)x();return Y},re.parseInline=function(z,j){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");j=c({},re.defaults,j||{}),I(j);try{var Y=te.lexInline(z,j);return j.walkTokens&&re.walkTokens(Y,j.walkTokens),ie.parseInline(Y,j)}catch(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+g(x.message+"",!0)+"</pre>";throw x}},re.Parser=ie,re.parser=ie.parse,re.Renderer=W,re.TextRenderer=K,re.Lexer=te,re.lexer=te.lex,re.Tokenizer=ce,re.Slugger=q,re.parse=re;var de=re.options,$=re.setOptions,V=re.use,N=re.walkTokens,k=re.parseInline,U=re,X=ie.parse,ne=te.lex;oe.Lexer=te,oe.Parser=ie,oe.Renderer=W,oe.Slugger=q,oe.TextRenderer=K,oe.Tokenizer=ce,oe.getDefaults=D,oe.lexer=ne,oe.marked=re,oe.options=de,oe.parse=U,oe.parseInline=k,oe.parser=X,oe.setOptions=$,oe.use=V,oe.walkTokens=N,Object.defineProperty(oe,"__esModule",{value:!0})}),define(pe[95],ve([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new w.LRUCache(1e4);function o(d){return v(d,"NFC",L)}e.normalizeNFC=o;const C=new w.LRUCache(1e4);function D(d){return v(d,"NFD",C)}e.normalizeNFD=D;const A=/[^\u0000-\u0080]/;function v(d,R,y){if(!d)return d;const E=y.get(d);if(E)return E;let m;return A.test(d)?m=d.normalize(R):m=d,y.set(d,m),m}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(R){return D(R).replace(d,"")}}()}),define(pe[143],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(A,v,d){return Math.min(Math.max(A,v),d)}e.clamp=w;function L(A,v){return(v+A%v)%v}e.rot=L;class o{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=o;class C{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=C;class D{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const d=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function oe(o){const C=[];typeof o=="number"&&C.push("code/timeOrigin",o);function D(v){C.push(v,Date.now())}function A(){const v=[];for(let d=0;d<C.length;d+=2)v.push({name:C[d],startTime:C[d+1]});return v}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(o){performance.mark(o)},getMarks(){let o=performance.timeOrigin;typeof o!="number"&&(o=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(o)}];for(const D of performance.getEntriesByType("mark"))C.push({name:D.name,startTime:Math.round(o+D.startTime)});return C}};if(typeof process=="object"){const o=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(o)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(o){return o.MonacoPerformanceMarks||(o.MonacoPerformanceMarks=e()),o.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),define(pe[3],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let w=!1,L=!1,o=!1,C=!1,D=!1,A=!1,v=!1,d=!1,R=!1,y=!1,E,m=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT,b,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const u=typeof h?.versions?.electron=="string",f=u&&h?.type==="renderer";if(typeof navigator=="object"&&!f){s=navigator.userAgent,w=s.indexOf("Windows")>=0,L=s.indexOf("Macintosh")>=0,d=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=s.indexOf("Linux")>=0,y=s?.indexOf("Mobi")>=0,A=!0,E=e.LANGUAGE_DEFAULT,m=E,g=navigator.language;const c=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),p=c&&c.getAttribute("data-settings");if(p)try{const P=JSON.parse(p),T=P.availableLanguages["*"];E=P.locale,g=P.osLocale,m=T||e.LANGUAGE_DEFAULT,b=P._translationsConfigFile}catch{}}else if(typeof h=="object"){w=h.platform==="win32",L=h.platform==="darwin",o=h.platform==="linux",C=o&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,v=u,R=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const c=h.env.VSCODE_NLS_CONFIG;if(c)try{const p=JSON.parse(c),P=p.availableLanguages["*"];E=p.locale,g=p.osLocale,m=P||e.LANGUAGE_DEFAULT,b=p._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var S;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(S||(e.Platform=S={}));function O(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=O;let t=0;L?t=1:w?t=3:o&&(t=2),e.isWindows=w,e.isMacintosh=L,e.isLinux=o,e.isLinuxSnap=C,e.isNative=D,e.isElectron=v,e.isWeb=A,e.isWebWorker=A&&typeof e.globals.importScripts=="function",e.isIOS=d,e.isMobile=y,e.isCI=R,e.platform=t,e.userAgent=s,e.language=m;var n;(function(c){function p(){return e.language}c.value=p;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=P;function T(){return e.language==="en"}c.isDefault=T})(n||(e.Language=n={})),e.locale=E,e.platformLocale=g,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let T=0,I=c.length;T<I;T++){const F=c[T];if(F.id===P.data.vscodeScheduleAsyncWork){c.splice(T,1),F.callback();return}}});let p=0;return P=>{const T=++p;c.push({id:T,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return c=>setTimeout(c)})();var r;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=L||d?2:w?1:3;let i=!0,a=!1;function l(){if(!a){a=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,i=new Uint16Array(c.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[29],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const o=w.globals.vscode.process;L={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(pe[7],ve([1,0,29]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,o=97,C=90,D=122,A=46,v=47,d=92,R=58,y=63;class E extends Error{constructor(n,r,i){let a;typeof r=="string"&&r.indexOf("not ")===0?(a="must not be",r=r.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let c=`The "${n}" ${l} ${a} of type ${r}`;c+=`. Received type ${typeof i}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,n){if(t===null||typeof t!="object")throw new E(n,"Object",t)}function g(t,n){if(typeof t!="string")throw new E(n,"string",t)}const b=w.platform==="win32";function s(t){return t===v||t===d}function h(t){return t===v}function u(t){return t>=L&&t<=C||t>=o&&t<=D}function f(t,n,r,i){let a="",l=0,c=-1,p=0,P=0;for(let T=0;T<=t.length;++T){if(T<t.length)P=t.charCodeAt(T);else{if(i(P))break;P=v}if(i(P)){if(!(c===T-1||p===1))if(p===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==A||a.charCodeAt(a.length-2)!==A){if(a.length>2){const I=a.lastIndexOf(r);I===-1?(a="",l=0):(a=a.slice(0,I),l=a.length-1-a.lastIndexOf(r)),c=T,p=0;continue}else if(a.length!==0){a="",l=0,c=T,p=0;continue}}n&&(a+=a.length>0?`${r}..`:"..",l=2)}else a.length>0?a+=`${r}${t.slice(c+1,T)}`:a=t.slice(c+1,T),l=T-c-1;c=T,p=0}else P===A&&p!==-1?++p:p=-1}return a}function S(t,n){m(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.win32={resolve(...t){let n="",r="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],g(l,"path"),l.length===0)continue}else n.length===0?l=w.cwd():(l=w.env[`=${n}`]||w.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===d)&&(l=`${n}\\`));const c=l.length;let p=0,P="",T=!1;const I=l.charCodeAt(0);if(c===1)s(I)&&(p=1,T=!0);else if(s(I))if(T=!0,s(l.charCodeAt(1))){let F=2,H=F;for(;F<c&&!s(l.charCodeAt(F));)F++;if(F<c&&F!==H){const ee=l.slice(H,F);for(H=F;F<c&&s(l.charCodeAt(F));)F++;if(F<c&&F!==H){for(H=F;F<c&&!s(l.charCodeAt(F));)F++;(F===c||F!==H)&&(P=`\\\\${ee}\\${l.slice(H,F)}`,p=F)}}}else p=1;else u(I)&&l.charCodeAt(1)===R&&(P=l.slice(0,2),p=2,c>2&&s(l.charCodeAt(2))&&(T=!0,p=3));if(P.length>0)if(n.length>0){if(P.toLowerCase()!==n.toLowerCase())continue}else n=P;if(i){if(n.length>0)break}else if(r=`${l.slice(p)}\\${r}`,i=T,T&&n.length>0)break}return r=f(r,!i,"\\",s),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){g(t,"path");const n=t.length;if(n===0)return".";let r=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return h(l)?"\\":t;if(s(l))if(a=!0,s(t.charCodeAt(1))){let p=2,P=p;for(;p<n&&!s(t.charCodeAt(p));)p++;if(p<n&&p!==P){const T=t.slice(P,p);for(P=p;p<n&&s(t.charCodeAt(p));)p++;if(p<n&&p!==P){for(P=p;p<n&&!s(t.charCodeAt(p));)p++;if(p===n)return`\\\\${T}\\${t.slice(P)}\\`;p!==P&&(i=`\\\\${T}\\${t.slice(P,p)}`,r=p)}}}else r=1;else u(l)&&t.charCodeAt(1)===R&&(i=t.slice(0,2),r=2,n>2&&s(t.charCodeAt(2))&&(a=!0,r=3));let c=r<n?f(t.slice(r),!a,"\\",s):"";return c.length===0&&!a&&(c="."),c.length>0&&s(t.charCodeAt(n-1))&&(c+="\\"),i===void 0?a?`\\${c}`:c:a?`${i}\\${c}`:`${i}${c}`},isAbsolute(t){g(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return s(r)||n>2&&u(r)&&t.charCodeAt(1)===R&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let l=0;l<t.length;++l){const c=t[l];g(c,"path"),c.length>0&&(n===void 0?n=r=c:n+=`\\${c}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof r=="string"&&s(r.charCodeAt(0))){++a;const l=r.length;l>1&&s(r.charCodeAt(1))&&(++a,l>2&&(s(r.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&s(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.win32.normalize(n)},relative(t,n){if(g(t,"from"),g(n,"to"),t===n)return"";const r=e.win32.resolve(t),i=e.win32.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===d;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===d;)l--;const c=l-a;let p=0;for(;p<n.length&&n.charCodeAt(p)===d;)p++;let P=n.length;for(;P-1>p&&n.charCodeAt(P-1)===d;)P--;const T=P-p,I=c<T?c:T;let F=-1,H=0;for(;H<I;H++){const ce=t.charCodeAt(a+H);if(ce!==n.charCodeAt(p+H))break;ce===d&&(F=H)}if(H!==I){if(F===-1)return i}else{if(T>I){if(n.charCodeAt(p+H)===d)return i.slice(p+H+1);if(H===2)return i.slice(p+H)}c>I&&(t.charCodeAt(a+H)===d?F=H:H===2&&(F=3)),F===-1&&(F=0)}let ee="";for(H=a+F+1;H<=l;++H)(H===l||t.charCodeAt(H)===d)&&(ee+=ee.length===0?"..":"\\..");return p+=F,ee.length>0?`${ee}${i.slice(p,P)}`:(i.charCodeAt(p)===d&&++p,i.slice(p,P))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===d){if(n.charCodeAt(1)===d){const r=n.charCodeAt(2);if(r!==y&&r!==A)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(u(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===d)return`\\\\?\\${n}`;return t},dirname(t){g(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const a=t.charCodeAt(0);if(n===1)return s(a)?t:".";if(s(a)){if(r=i=1,s(t.charCodeAt(1))){let p=2,P=p;for(;p<n&&!s(t.charCodeAt(p));)p++;if(p<n&&p!==P){for(P=p;p<n&&s(t.charCodeAt(p));)p++;if(p<n&&p!==P){for(P=p;p<n&&!s(t.charCodeAt(p));)p++;if(p===n)return t;p!==P&&(r=i=p+1)}}}}else u(a)&&t.charCodeAt(1)===R&&(r=n>2&&s(t.charCodeAt(2))?3:2,i=r);let l=-1,c=!0;for(let p=n-1;p>=i;--p)if(s(t.charCodeAt(p))){if(!c){l=p;break}}else c=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,n){n!==void 0&&g(n,"ext"),g(t,"path");let r=0,i=-1,a=!0,l;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let c=n.length-1,p=-1;for(l=t.length-1;l>=r;--l){const P=t.charCodeAt(l);if(s(P)){if(!a){r=l+1;break}}else p===-1&&(a=!1,p=l+1),c>=0&&(P===n.charCodeAt(c)?--c===-1&&(i=l):(c=-1,i=p))}return r===i?i=p:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(s(t.charCodeAt(l))){if(!a){r=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){g(t,"path");let n=0,r=-1,i=0,a=-1,l=!0,c=0;t.length>=2&&t.charCodeAt(1)===R&&u(t.charCodeAt(0))&&(n=i=2);for(let p=t.length-1;p>=n;--p){const P=t.charCodeAt(p);if(s(P)){if(!l){i=p+1;break}continue}a===-1&&(l=!1,a=p+1),P===A?r===-1?r=p:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||a===-1||c===0||c===1&&r===a-1&&r===i+1?"":t.slice(r,a)},format:S.bind(null,"\\"),parse(t){g(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,a=t.charCodeAt(0);if(r===1)return s(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(s(a)){if(i=1,s(t.charCodeAt(1))){let F=2,H=F;for(;F<r&&!s(t.charCodeAt(F));)F++;if(F<r&&F!==H){for(H=F;F<r&&s(t.charCodeAt(F));)F++;if(F<r&&F!==H){for(H=F;F<r&&!s(t.charCodeAt(F));)F++;F===r?i=F:F!==H&&(i=F+1)}}}}else if(u(a)&&t.charCodeAt(1)===R){if(r<=2)return n.root=n.dir=t,n;if(i=2,s(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,c=i,p=-1,P=!0,T=t.length-1,I=0;for(;T>=i;--T){if(a=t.charCodeAt(T),s(a)){if(!P){c=T+1;break}continue}p===-1&&(P=!1,p=T+1),a===A?l===-1?l=T:I!==1&&(I=1):l!==-1&&(I=-1)}return p!==-1&&(l===-1||I===0||I===1&&l===p-1&&l===c+1?n.base=n.name=t.slice(c,p):(n.name=t.slice(c,l),n.base=t.slice(c,p),n.ext=t.slice(l,p))),c>0&&c!==i?n.dir=t.slice(0,c-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const O=(()=>{if(b){const t=/\\/g;return()=>{const n=w.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>w.cwd()})();e.posix={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const a=i>=0?t[i]:O();g(a,"path"),a.length!==0&&(n=`${a}/${n}`,r=a.charCodeAt(0)===v)}return n=f(n,!r,"/",h),r?`/${n}`:n.length>0?n:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v,r=t.charCodeAt(t.length-1)===v;return t=f(t,!n,"/",h),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];g(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(g(t,"from"),g(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const r=1,i=t.length,a=i-r,l=1,c=n.length-l,p=a<c?a:c;let P=-1,T=0;for(;T<p;T++){const F=t.charCodeAt(r+T);if(F!==n.charCodeAt(l+T))break;F===v&&(P=T)}if(T===p)if(c>p){if(n.charCodeAt(l+T)===v)return n.slice(l+T+1);if(T===0)return n.slice(l+T)}else a>p&&(t.charCodeAt(r+T)===v?P=T:T===0&&(P=0));let I="";for(T=r+P+1;T<=i;++T)(T===i||t.charCodeAt(T)===v)&&(I+=I.length===0?"..":"/..");return`${I}${n.slice(l+P)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v;let r=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===v){if(!i){r=a;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&g(n,"ext"),g(t,"path");let r=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let c=n.length-1,p=-1;for(l=t.length-1;l>=0;--l){const P=t.charCodeAt(l);if(P===v){if(!a){r=l+1;break}}else p===-1&&(a=!1,p=l+1),c>=0&&(P===n.charCodeAt(c)?--c===-1&&(i=l):(c=-1,i=p))}return r===i?i=p:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===v){if(!a){r=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){g(t,"path");let n=-1,r=0,i=-1,a=!0,l=0;for(let c=t.length-1;c>=0;--c){const p=t.charCodeAt(c);if(p===v){if(!a){r=c+1;break}continue}i===-1&&(a=!1,i=c+1),p===A?n===-1?n=c:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:S.bind(null,"/"),parse(t){g(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===v;let i;r?(n.root="/",i=1):i=0;let a=-1,l=0,c=-1,p=!0,P=t.length-1,T=0;for(;P>=i;--P){const I=t.charCodeAt(P);if(I===v){if(!p){l=P+1;break}continue}c===-1&&(p=!1,c=P+1),I===A?a===-1?a=P:T!==1&&(T=1):a!==-1&&(T=-1)}if(c!==-1){const I=l===0&&r?1:l;a===-1||T===0||T===1&&a===c-1&&a===l+1?n.base=n.name=t.slice(I,c):(n.name=t.slice(I,a),n.base=t.slice(I,c),n.ext=t.slice(a,c))}return l>0?n.dir=t.slice(0,l-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(pe[57],ve([1,0,7]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(R){const y=(0,w.extname)(R),E=L[y.toLowerCase()];return E!==void 0?E:D(R)}e.getMediaOrTextMime=C;function D(R){const y=(0,w.extname)(R);return o[y.toLowerCase()]}e.getMediaMime=D;function A(R){for(const y in o)if(o[y]===R)return y}e.getExtensionForMimeType=A;const v=/^(.+)\/(.+?)(;.+)?$/;function d(R,y){const E=v.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:y?void 0:R}e.normalizeMimeType=d}),define(pe[58],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(L||(e.Source=L={}));var o;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(o||(e.TerminateResponseCode=o={}));function C(A,...v){const d=v.reduce((E,m)=>(E[m]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter(E=>!d[E]).forEach(E=>{for(let m=0;m<R.length;m++)if(E.search(R[m])!==-1){delete A[E];break}})}e.sanitizeProcessEnvironment=C;function D(A){A&&(delete A.DEBUG,w.isMacintosh&&delete A.DYLD_LIBRARY_PATH,w.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var L in w)(typeof exports=="object"?exports:oe)[L]=w[L]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(L){if(e[L])return e[L].exports;var o=e[L]={i:L,l:!1,exports:{}};return oe[L].call(o.exports,o,o.exports,w),o.l=!0,o.exports}return w.m=oe,w.c=e,w.d=function(L,o,C){w.o(L,o)||Object.defineProperty(L,o,{enumerable:!0,get:C})},w.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},w.t=function(L,o){if(1&o&&(L=w(L)),8&o||4&o&&typeof L=="object"&&L&&L.__esModule)return L;var C=Object.create(null);if(w.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:L}),2&o&&typeof L!="string")for(var D in L)w.d(C,D,function(A){return L[A]}.bind(null,D));return C},w.n=function(L){var o=L&&L.__esModule?function(){return L.default}:function(){return L};return w.d(o,"a",o),o},w.o=function(L,o){return Object.prototype.hasOwnProperty.call(L,o)},w.p="",w(w.s=0)}([function(oe,e,w){(function(L){var o;e=oe.exports=V,o=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],v=e.src=[],d=0,R=d++;v[R]="0|[1-9]\\d*";var y=d++;v[y]="[0-9]+";var E=d++;v[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=d++;v[m]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var g=d++;v[g]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var b=d++;v[b]="(?:"+v[R]+"|"+v[E]+")";var s=d++;v[s]="(?:"+v[y]+"|"+v[E]+")";var h=d++;v[h]="(?:-("+v[b]+"(?:\\."+v[b]+")*))";var u=d++;v[u]="(?:-?("+v[s]+"(?:\\."+v[s]+")*))";var f=d++;v[f]="[0-9A-Za-z-]+";var S=d++;v[S]="(?:\\+("+v[f]+"(?:\\."+v[f]+")*))";var O=d++,t="v?"+v[m]+v[h]+"?"+v[S]+"?";v[O]="^"+t+"$";var n="[v=\\s]*"+v[g]+v[u]+"?"+v[S]+"?",r=d++;v[r]="^"+n+"$";var i=d++;v[i]="((?:<|>)?=?)";var a=d++;v[a]=v[y]+"|x|X|\\*";var l=d++;v[l]=v[R]+"|x|X|\\*";var c=d++;v[c]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[h]+")?"+v[S]+"?)?)?";var p=d++;v[p]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[u]+")?"+v[S]+"?)?)?";var P=d++;v[P]="^"+v[i]+"\\s*"+v[c]+"$";var T=d++;v[T]="^"+v[i]+"\\s*"+v[p]+"$";var I=d++;v[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=d++;v[F]="(?:~>?)";var H=d++;v[H]="(\\s*)"+v[F]+"\\s+",A[H]=new RegExp(v[H],"g");var ee=d++;v[ee]="^"+v[F]+v[c]+"$";var ce=d++;v[ce]="^"+v[F]+v[p]+"$";var ae=d++;v[ae]="(?:\\^)";var ue=d++;v[ue]="(\\s*)"+v[ae]+"\\s+",A[ue]=new RegExp(v[ue],"g");var ge=d++;v[ge]="^"+v[ae]+v[c]+"$";var G=d++;v[G]="^"+v[ae]+v[p]+"$";var te=d++;v[te]="^"+v[i]+"\\s*("+n+")$|^$";var W=d++;v[W]="^"+v[i]+"\\s*("+t+")$|^$";var K=d++;v[K]="(\\s*)"+v[i]+"\\s*("+n+"|"+v[c]+")",A[K]=new RegExp(v[K],"g");var q=d++;v[q]="^\\s*("+v[c]+")\\s+-\\s+("+v[c]+")\\s*$";var ie=d++;v[ie]="^\\s*("+v[p]+")\\s+-\\s+("+v[p]+")\\s*$";var re=d++;v[re]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)o(de,v[de]),A[de]||(A[de]=new RegExp(v[de]));function $(me,Se){if(me instanceof V)return me;if(typeof me!="string"||me.length>C||!(Se?A[r]:A[O]).test(me))return null;try{return new V(me,Se)}catch{return null}}function V(me,Se){if(me instanceof V){if(me.loose===Se)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof V))return new V(me,Se);o("SemVer",me,Se),this.loose=Se;var we=me.trim().match(Se?A[r]:A[O]);if(!we)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var ze=+Ne;if(ze>=0&&ze<D)return ze}return Ne}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=$,e.valid=function(me,Se){var we=$(me,Se);return we?we.version:null},e.clean=function(me,Se){var we=$(me.trim().replace(/^[=v]+/,""),Se);return we?we.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(me){return o("SemVer.compare",this.version,this.loose,me),me instanceof V||(me=new V(me,this.loose)),this.compareMain(me)||this.comparePre(me)},V.prototype.compareMain=function(me){return me instanceof V||(me=new V(me,this.loose)),k(this.major,me.major)||k(this.minor,me.minor)||k(this.patch,me.patch)},V.prototype.comparePre=function(me){if(me instanceof V||(me=new V(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Se=0;do{var we=this.prerelease[Se],Ne=me.prerelease[Se];if(o("prerelease compare",Se,we,Ne),we===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(we===void 0)return-1;if(we!==Ne)return k(we,Ne)}while(++Se)},V.prototype.inc=function(me,Se){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Se,we,Ne){typeof we=="string"&&(Ne=we,we=void 0);try{return new V(me,we).inc(Se,Ne).version}catch{return null}},e.diff=function(me,Se){if(z(me,Se))return null;var we=$(me),Ne=$(Se);if(we.prerelease.length||Ne.prerelease.length){for(var ze in we)if((ze==="major"||ze==="minor"||ze==="patch")&&we[ze]!==Ne[ze])return"pre"+ze;return"prerelease"}for(var ze in we)if((ze==="major"||ze==="minor"||ze==="patch")&&we[ze]!==Ne[ze])return ze},e.compareIdentifiers=k;var N=/^[0-9]+$/;function k(me,Se){var we=N.test(me),Ne=N.test(Se);return we&&Ne&&(me=+me,Se=+Se),we&&!Ne?-1:Ne&&!we?1:me<Se?-1:me>Se?1:0}function U(me,Se,we){return new V(me,we).compare(new V(Se,we))}function X(me,Se,we){return U(me,Se,we)>0}function ne(me,Se,we){return U(me,Se,we)<0}function z(me,Se,we){return U(me,Se,we)===0}function j(me,Se,we){return U(me,Se,we)!==0}function Y(me,Se,we){return U(me,Se,we)>=0}function x(me,Se,we){return U(me,Se,we)<=0}function Z(me,Se,we,Ne){var ze;switch(Se){case"===":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),ze=me===we;break;case"!==":typeof me=="object"&&(me=me.version),typeof we=="object"&&(we=we.version),ze=me!==we;break;case"":case"=":case"==":ze=z(me,we,Ne);break;case"!=":ze=j(me,we,Ne);break;case">":ze=X(me,we,Ne);break;case">=":ze=Y(me,we,Ne);break;case"<":ze=ne(me,we,Ne);break;case"<=":ze=x(me,we,Ne);break;default:throw new TypeError("Invalid operator: "+Se)}return ze}function J(me,Se){if(me instanceof J){if(me.loose===Se)return me;me=me.value}if(!(this instanceof J))return new J(me,Se);o("comparator",me,Se),this.loose=Se,this.parse(me),this.semver===_?this.value="":this.value=this.operator+this.semver.version,o("comp",this)}e.rcompareIdentifiers=function(me,Se){return k(Se,me)},e.major=function(me,Se){return new V(me,Se).major},e.minor=function(me,Se){return new V(me,Se).minor},e.patch=function(me,Se){return new V(me,Se).patch},e.compare=U,e.compareLoose=function(me,Se){return U(me,Se,!0)},e.rcompare=function(me,Se,we){return U(Se,me,we)},e.sort=function(me,Se){return me.sort(function(we,Ne){return e.compare(we,Ne,Se)})},e.rsort=function(me,Se){return me.sort(function(we,Ne){return e.rcompare(we,Ne,Se)})},e.gt=X,e.lt=ne,e.eq=z,e.neq=j,e.gte=Y,e.lte=x,e.cmp=Z,e.Comparator=J;var _={};function le(me,Se){if(me instanceof le)return me.loose===Se?me:new le(me.raw,Se);if(me instanceof J)return new le(me.value,Se);if(!(this instanceof le))return new le(me,Se);if(this.loose=Se,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function Ee(me){return!me||me.toLowerCase()==="x"||me==="*"}function Ce(me,Se,we,Ne,ze,tt,Ve,Xe,Qe,it,Ge,Ye,he){return((Se=Ee(we)?"":Ee(Ne)?">="+we+".0.0":Ee(ze)?">="+we+"."+Ne+".0":">="+Se)+" "+(Xe=Ee(Qe)?"":Ee(it)?"<"+(+Qe+1)+".0.0":Ee(Ge)?"<"+Qe+"."+(+it+1)+".0":Ye?"<="+Qe+"."+it+"."+Ge+"-"+Ye:"<="+Xe)).trim()}function ke(me,Se){for(var we=0;we<me.length;we++)if(!me[we].test(Se))return!1;if(Se.prerelease.length){for(we=0;we<me.length;we++)if(o(me[we].semver),me[we].semver!==_&&me[we].semver.prerelease.length>0){var Ne=me[we].semver;if(Ne.major===Se.major&&Ne.minor===Se.minor&&Ne.patch===Se.patch)return!0}return!1}return!0}function Ue(me,Se,we){try{Se=new le(Se,we)}catch{return!1}return Se.test(me)}function je(me,Se,we,Ne){var ze,tt,Ve,Xe,Qe;switch(me=new V(me,Ne),Se=new le(Se,Ne),we){case">":ze=X,tt=x,Ve=ne,Xe=">",Qe=">=";break;case"<":ze=ne,tt=Y,Ve=X,Xe="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(me,Se,Ne))return!1;for(var it=0;it<Se.set.length;++it){var Ge=Se.set[it],Ye=null,he=null;if(Ge.forEach(function(De){De.semver===_&&(De=new J(">=0.0.0")),Ye=Ye||De,he=he||De,ze(De.semver,Ye.semver,Ne)?Ye=De:Ve(De.semver,he.semver,Ne)&&(he=De)}),Ye.operator===Xe||Ye.operator===Qe||(!he.operator||he.operator===Xe)&&tt(me,he.semver)||he.operator===Qe&&Ve(me,he.semver))return!1}return!0}J.prototype.parse=function(me){var Se=this.loose?A[te]:A[W],we=me.match(Se);if(!we)throw new TypeError("Invalid comparator: "+me);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new V(we[2],this.loose):this.semver=_},J.prototype.toString=function(){return this.value},J.prototype.test=function(me){return o("Comparator.test",me,this.loose),this.semver===_||(typeof me=="string"&&(me=new V(me,this.loose)),Z(me,this.operator,this.semver,this.loose))},J.prototype.intersects=function(me,Se){if(!(me instanceof J))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new le(me.value,Se),Ue(this.value,we,Se);if(me.operator==="")return we=new le(this.value,Se),Ue(me.semver,we,Se);var Ne=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),tt=this.semver.version===me.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Xe=Z(this.semver,"<",me.semver,Se)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Qe=Z(this.semver,">",me.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Ne||ze||tt&&Ve||Xe||Qe},e.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(me){var Se=this.loose;me=me.trim(),o("range",me,Se);var we=Se?A[ie]:A[q];me=me.replace(we,Ce),o("hyphen replace",me),me=me.replace(A[K],"$1$2$3"),o("comparator trim",me,A[K]),me=(me=(me=me.replace(A[H],"$1~")).replace(A[ue],"$1^")).split(/\s+/).join(" ");var Ne=Se?A[te]:A[W],ze=me.split(" ").map(function(tt){return function(Ve,Xe){return o("comp",Ve),Ve=function(Qe,it){return Qe.trim().split(/\s+/).map(function(Ge){return function(Ye,he){o("caret",Ye,he);var De=he?A[G]:A[ge];return Ye.replace(De,function(Te,Re,Oe,$e,qe){var xe;return o("caret",Ye,Te,Re,Oe,$e,qe),Ee(Re)?xe="":Ee(Oe)?xe=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee($e)?xe=Re==="0"?">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+".0 <"+(+Re+1)+".0.0":qe?(o("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),xe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+$e+qe+" <"+Re+"."+Oe+"."+(+$e+1):">="+Re+"."+Oe+"."+$e+qe+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+$e+qe+" <"+(+Re+1)+".0.0"):(o("no pr"),xe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+$e+" <"+Re+"."+Oe+"."+(+$e+1):">="+Re+"."+Oe+"."+$e+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+$e+" <"+(+Re+1)+".0.0"),o("caret return",xe),xe})}(Ge,it)}).join(" ")}(Ve,Xe),o("caret",Ve),Ve=function(Qe,it){return Qe.trim().split(/\s+/).map(function(Ge){return function(Ye,he){var De=he?A[ce]:A[ee];return Ye.replace(De,function(Te,Re,Oe,$e,qe){var xe;return o("tilde",Ye,Te,Re,Oe,$e,qe),Ee(Re)?xe="":Ee(Oe)?xe=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee($e)?xe=">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":qe?(o("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),xe=">="+Re+"."+Oe+"."+$e+qe+" <"+Re+"."+(+Oe+1)+".0"):xe=">="+Re+"."+Oe+"."+$e+" <"+Re+"."+(+Oe+1)+".0",o("tilde return",xe),xe})}(Ge,it)}).join(" ")}(Ve,Xe),o("tildes",Ve),Ve=function(Qe,it){return o("replaceXRanges",Qe,it),Qe.split(/\s+/).map(function(Ge){return function(Ye,he){Ye=Ye.trim();var De=he?A[T]:A[P];return Ye.replace(De,function(Te,Re,Oe,$e,qe,xe){o("xRange",Ye,Te,Re,Oe,$e,qe,xe);var _e=Ee(Oe),Ke=_e||Ee($e),Je=Ke||Ee(qe);return Re==="="&&Je&&(Re=""),_e?Te=Re===">"||Re==="<"?"<0.0.0":"*":Re&&Je?(Ke&&($e=0),Je&&(qe=0),Re===">"?(Re=">=",Ke?(Oe=+Oe+1,$e=0,qe=0):Je&&($e=+$e+1,qe=0)):Re==="<="&&(Re="<",Ke?Oe=+Oe+1:$e=+$e+1),Te=Re+Oe+"."+$e+"."+qe):Ke?Te=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Je&&(Te=">="+Oe+"."+$e+".0 <"+Oe+"."+(+$e+1)+".0"),o("xRange return",Te),Te})}(Ge,it)}).join(" ")}(Ve,Xe),o("xrange",Ve),Ve=function(Qe,it){return o("replaceStars",Qe,it),Qe.trim().replace(A[re],"")}(Ve,Xe),o("stars",Ve),Ve}(tt,Se)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(tt){return!!tt.match(Ne)})),ze=ze.map(function(tt){return new J(tt,Se)})},le.prototype.intersects=function(me,Se){if(!(me instanceof le))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ne){return me.set.some(function(ze){return ze.every(function(tt){return Ne.intersects(tt,Se)})})})})},e.toComparators=function(me,Se){return new le(me,Se).set.map(function(we){return we.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},le.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new V(me,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ke(this.set[Se],me))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(me,Se,we){var Ne=null,ze=null;try{var tt=new le(Se,we)}catch{return null}return me.forEach(function(Ve){tt.test(Ve)&&(Ne&&ze.compare(Ve)!==-1||(ze=new V(Ne=Ve,we)))}),Ne},e.minSatisfying=function(me,Se,we){var Ne=null,ze=null;try{var tt=new le(Se,we)}catch{return null}return me.forEach(function(Ve){tt.test(Ve)&&(Ne&&ze.compare(Ve)!==1||(ze=new V(Ne=Ve,we)))}),Ne},e.validRange=function(me,Se){try{return new le(me,Se).range||"*"}catch{return null}},e.ltr=function(me,Se,we){return je(me,Se,"<",we)},e.gtr=function(me,Se,we){return je(me,Se,">",we)},e.outside=je,e.prerelease=function(me,Se){var we=$(me,Se);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(me,Se,we){return me=new le(me,we),Se=new le(Se,we),me.intersects(Se)},e.coerce=function(me){if(me instanceof V)return me;if(typeof me!="string")return null;var Se=me.match(A[I]);return Se==null?null:$((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,L,o=oe.exports={};function C(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function A(s){if(w===setTimeout)return setTimeout(s,0);if((w===C||!w)&&setTimeout)return w=setTimeout,setTimeout(s,0);try{return w(s,0)}catch{try{return w.call(null,s,0)}catch{return w.call(this,s,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:C}catch{w=C}try{L=typeof clearTimeout=="function"?clearTimeout:D}catch{L=D}})();var v,d=[],R=!1,y=-1;function E(){R&&v&&(R=!1,v.length?d=v.concat(d):y=-1,d.length&&m())}function m(){if(!R){var s=A(E);R=!0;for(var h=d.length;h;){for(v=d,d=[];++y<h;)v&&v[y].run();y=-1,h=d.length}v=null,R=!1,function(u){if(L===clearTimeout)return clearTimeout(u);if((L===D||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(u);try{L(u)}catch{try{return L.call(null,u)}catch{return L.call(this,u)}}}(s)}}function g(s,h){this.fun=s,this.array=h}function b(){}o.nextTick=function(s){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];d.push(new g(s,h)),d.length!==1||R||A(m)},g.prototype.run=function(){this.fun.apply(null,this.array)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=b,o.addListener=b,o.once=b,o.off=b,o.removeListener=b,o.removeAllListeners=b,o.emit=b,o.prependListener=b,o.prependOnceListener=b,o.listeners=function(s){return[]},o.binding=function(s){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(s){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}}])}),define(pe[144],ve([1,0]),function(oe,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(A,v,d){this.level=A,this.key=v,this.value=d,this.forward=[]}}const o=void 0;class C{constructor(A,v=2**16){this.comparator=A,this[w]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new L(this.c,o,o)}get size(){return this.f}clear(){this.e=new L(this.c,o,o)}has(A){return!!C.g(this,A,this.comparator)}get(A){return C.g(this,A,this.comparator)?.value}set(A,v){return C.h(this,A,v,this.comparator)&&(this.f+=1),this}delete(A){const v=C.k(this,A,this.comparator);return v&&(this.f-=1),v}forEach(A,v){let d=this.e.forward[0];for(;d;)A.call(v,d.value,d.key,this),d=d.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",v=this.e.forward[0];for(;v;)A+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return A}static g(A,v,d){let R=A.e;for(let y=A.d-1;y>=0;y--)for(;R.forward[y]&&d(R.forward[y].key,v)<0;)R=R.forward[y];if(R=R.forward[0],R&&d(R.key,v)===0)return R}static h(A,v,d,R){const y=[];let E=A.e;for(let m=A.d-1;m>=0;m--){for(;E.forward[m]&&R(E.forward[m].key,v)<0;)E=E.forward[m];y[m]=E}if(E=E.forward[0],E&&R(E.key,v)===0)return E.value=d,!1;{const m=C.j(A);if(m>A.d){for(let g=A.d;g<m;g++)y[g]=A.e;A.d=m}E=new L(m,v,d);for(let g=0;g<m;g++)E.forward[g]=y[g].forward[g],y[g].forward[g]=E;return!0}}static j(A,v=.5){let d=1;for(;Math.random()<v&&d<A.c;)d+=1;return d}static k(A,v,d){const R=[];let y=A.e;for(let E=A.d-1;E>=0;E--){for(;y.forward[E]&&d(y.forward[E].key,v)<0;)y=y.forward[E];R[E]=y}if(y=y.forward[0],!y||d(y.key,v)!==0)return!1;for(let E=0;E<A.d&&R[E].forward[E]===y;E++)R[E].forward[E]=y.forward[E];for(;A.d>0&&A.e.forward[A.d-1]===o;)A.d-=1;return!0}}e.SkipList=C}),define(pe[96],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=w.globals.performance&&typeof w.globals.performance.now=="function";class o{static create(D=!0){return new o(D)}constructor(D){this.a=L&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?w.globals.performance.now():Date.now()}}e.StopWatch=o}),define(pe[6],ve([1,0,9,71,2,94,96]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,v=!1;var d;(function(l){l.None=()=>o.Disposable.None;function c(X){if(v){const{onDidAddListener:ne}=X,z=g.create();let j=0;X.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),ne?.()}}}function p(X,ne){return ue(X,()=>{},0,void 0,!0,void 0,ne)}l.defer=p;function P(X){return(ne,z=null,j)=>{let Y=!1,x;return x=X(Z=>{if(!Y)return x?x.dispose():Y=!0,ne.call(z,Z)},null,j),Y&&x.dispose(),x}}l.once=P;function T(X,ne,z){return ae((j,Y=null,x)=>X(Z=>j.call(Y,ne(Z)),null,x),z)}l.map=T;function I(X,ne,z){return ae((j,Y=null,x)=>X(Z=>{ne(Z),j.call(Y,Z)},null,x),z)}l.forEach=I;function F(X,ne,z){return ae((j,Y=null,x)=>X(Z=>ne(Z)&&j.call(Y,Z),null,x),z)}l.filter=F;function H(X){return X}l.signal=H;function ee(...X){return(ne,z=null,j)=>(0,o.combinedDisposable)(...X.map(Y=>Y(x=>ne.call(z,x),null,j)))}l.any=ee;function ce(X,ne,z,j){let Y=z;return T(X,x=>(Y=ne(Y,x),Y),j)}l.reduce=ce;function ae(X,ne){let z;const j={onWillAddFirstListener(){z=X(Y.fire,Y)},onDidRemoveLastListener(){z?.dispose()}};ne||c(j);const Y=new s(j);return ne?.add(Y),Y.event}function ue(X,ne,z=100,j=!1,Y=!1,x,Z){let J,_,le,Ee=0,Ce;const ke={leakWarningThreshold:x,onWillAddFirstListener(){J=X(je=>{Ee++,_=ne(_,je),j&&!le&&(Ue.fire(_),_=void 0),Ce=()=>{const me=_;_=void 0,le=void 0,(!j||Ee>1)&&Ue.fire(me),Ee=0},typeof z=="number"?(clearTimeout(le),le=setTimeout(Ce,z)):le===void 0&&(le=0,queueMicrotask(Ce))})},onWillRemoveListener(){Y&&Ee>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,J.dispose()}};Z||c(ke);const Ue=new s(ke);return Z?.add(Ue),Ue.event}l.debounce=ue;function ge(X,ne=0,z){return l.debounce(X,(j,Y)=>j?(j.push(Y),j):[Y],ne,void 0,!0,void 0,z)}l.accumulate=ge;function G(X,ne=(j,Y)=>j===Y,z){let j=!0,Y;return F(X,x=>{const Z=j||!ne(x,Y);return j=!1,Y=x,Z},z)}l.latch=G;function te(X,ne,z){return[l.filter(X,ne,z),l.filter(X,j=>!ne(j),z)]}l.split=te;function W(X,ne=!1,z=[]){let j=z.slice(),Y=X(J=>{j?j.push(J):Z.fire(J)});const x=()=>{j?.forEach(J=>Z.fire(J)),j=null},Z=new s({onWillAddFirstListener(){Y||(Y=X(J=>Z.fire(J)))},onDidAddFirstListener(){j&&(ne?setTimeout(x):x())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return Z.event}l.buffer=W;class K{constructor(ne){this.event=ne,this.c=new o.DisposableStore}map(ne){return new K(T(this.event,ne,this.c))}forEach(ne){return new K(I(this.event,ne,this.c))}filter(ne){return new K(F(this.event,ne,this.c))}reduce(ne,z){return new K(ce(this.event,ne,z,this.c))}latch(){return new K(G(this.event,void 0,this.c))}debounce(ne,z=100,j=!1,Y=!1,x){return new K(ue(this.event,ne,z,j,Y,x,this.c))}on(ne,z,j){return this.event(ne,z,j)}once(ne,z,j){return P(this.event)(ne,z,j)}dispose(){this.c.dispose()}}function q(X){return new K(X)}l.chain=q;function ie(X,ne,z=j=>j){const j=(...J)=>Z.fire(z(...J)),Y=()=>X.on(ne,j),x=()=>X.removeListener(ne,j),Z=new s({onWillAddFirstListener:Y,onDidRemoveLastListener:x});return Z.event}l.fromNodeEventEmitter=ie;function re(X,ne,z=j=>j){const j=(...J)=>Z.fire(z(...J)),Y=()=>X.addEventListener(ne,j),x=()=>X.removeEventListener(ne,j),Z=new s({onWillAddFirstListener:Y,onDidRemoveLastListener:x});return Z.event}l.fromDOMEventEmitter=re;function de(X){return new Promise(ne=>P(X)(ne))}l.toPromise=de;function $(X,ne){return ne(void 0),X(z=>ne(z))}l.runAndSubscribe=$;function V(X,ne){let z=null;function j(x){z?.dispose(),z=new o.DisposableStore,ne(x,z)}j(void 0);const Y=X(x=>j(x));return(0,o.toDisposable)(()=>{Y.dispose(),z?.dispose()})}l.runAndSubscribeWithStore=V;class N{constructor(ne,z){this._observable=ne,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};z||c(j),this.emitter=new s(j),z&&z.add(this.emitter)}beginUpdate(ne){this.c++}handlePossibleChange(ne){}handleChange(ne,z){this.d=!0}endUpdate(ne){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function k(X,ne){return new N(X,ne).emitter.event}l.fromObservable=k;function U(X){return ne=>{let z=0,j=!1;const Y={beginUpdate(){z++},endUpdate(){z--,z===0&&(X.reportChanges(),j&&(j=!1,ne()))},handlePossibleChange(){},handleChange(){j=!0}};return X.addObserver(Y),{dispose(){X.removeObserver(Y)}}}}l.fromObservableLight=U})(d||(e.Event=d={}));class R{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${R.c++}`,R.all.add(this)}start(c){this.d=new D.StopWatch(!0),this.listenerCount=c}stop(){if(this.d){const c=this.d.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let y=-1;function E(l){const c=y;return y=l,{dispose(){y=c}}}e.setGlobalLeakWarningThreshold=E;class m{constructor(c,p=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=p,this.d=0}dispose(){this.c?.clear()}check(c,p){const P=this.threshold;if(P<=0||p<P)return;this.c||(this.c=new Map);const T=this.c.get(c.value)||0;if(this.c.set(c.value,T+1),this.d-=1,this.d<=0){this.d=P*.5;let I,F=0;for(const[H,ee]of this.c)(!I||F<ee)&&(I=H,F=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${F}):`),console.warn(I)}return()=>{const I=this.c.get(c.value)||0;this.c.set(c.value,I-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,p,P){this.callback=c,this.callbackThis=p,this.stack=P,this.subscription=new o.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class s{constructor(c){this.j=!1,this.d=c,this.f=y>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const c=Array.from(this.q);queueMicrotask(()=>{for(const p of c)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(c,p,P)=>{if(this.q||(this.q=new C.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),o.Disposable.None;const T=this.q.isEmpty();T&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let I,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=g.create(),I=this.f.check(F,this.q.size+1)),A&&(F=F??g.create());const H=new b(c,p,F),ee=this.q.push(H);T&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,c,p);const ce=H.subscription.set(()=>{I?.(),this.j||(this.d?.onWillRemoveListener?.(this),ee(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return P instanceof o.DisposableStore?P.add(ce):Array.isArray(P)&&P.push(ce),ce}),this.l}fire(c){if(this.q){this.m||(this.m=new u(this.d?.onListenerError));for(const p of this.q)this.m.push(this,p,c);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=s;class h{constructor(c=w.onUnexpectedError){this.d=c,this.c=new C.LinkedList}get size(){return this.c.size}push(c,p,P){this.c.push(new f(c,p,P))}clear(c){const p=new C.LinkedList;for(const P of this.c)P.emitter!==c&&p.push(P);this.c=p}deliver(){for(;this.c.size>0;){const c=this.c.shift();try{c.listener.invoke(c.event)}catch(p){this.d(p)}}}}e.EventDeliveryQueue=h;class u extends h{clear(c){this.c.clear()}}class f{constructor(c,p,P){this.emitter=c,this.listener=p,this.event=P}}class S extends s{async fireAsync(c,p,P){if(this.q){this.c||(this.c=new C.LinkedList);for(const T of this.q)this.c.push([T,c]);for(;this.c.size>0&&!p.isCancellationRequested;){const[T,I]=this.c.shift(),F=[],H={...I,token:p,waitUntil:ee=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");P&&(ee=P(ee,T.callback)),F.push(ee)}};try{T.invoke(H)}catch(ee){(0,w.onUnexpectedError)(ee);continue}Object.freeze(F),await Promise.allSettled(F).then(ee=>{for(const ce of ee)ce.status==="rejected"&&(0,w.onUnexpectedError)(ce.reason)})}}}}e.AsyncEmitter=S;class O extends s{constructor(c){super(c),this.h=0,this.s=new C.LinkedList,this.t=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.t(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.q&&(this.h!==0?this.s.push(c):super.fire(c))}}e.PauseableEmitter=O;class t extends O{constructor(c){super(c),this.c=c.delay??100}fire(c){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(c)}}e.DebounceEmitter=t;class n extends s{constructor(c){super(c),this.c=[],this.h=c?.merge}fire(c){this.hasListeners()&&(this.c.push(c),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(p=>super.fire(p)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new s({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(c){const p={event:c,listener:null};this.f.push(p),this.d&&this.j(p);const P=()=>{this.d&&this.k(p);const T=this.f.indexOf(p);this.f.splice(T,1)};return(0,o.toDisposable)((0,L.once)(P))}g(){this.d=!0,this.f.forEach(c=>this.j(c))}h(){this.d=!1,this.f.forEach(c=>this.k(c))}j(c){c.listener=c.event(p=>this.c.fire(p))}k(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class i{constructor(){this.c=[]}wrapEvent(c){return(p,P,T)=>c(I=>{const F=this.c[this.c.length-1];F?F.push(()=>p.call(P,I)):p.call(P,I)},void 0,T)}bufferEvents(c){const p=[];this.c.push(p);const P=c();return this.c.pop(),p.forEach(T=>T()),P}}e.EventBufferer=i;class a{constructor(){this.c=!1,this.d=d.None,this.f=o.Disposable.None,this.g=new s({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(c){this.d=c,this.c&&(this.f.dispose(),this.f=c(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(pe[20],ve([1,0,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(A,v){const d=setTimeout(A.bind(v),0);return{dispose(){clearTimeout(d)}}});var o;(function(A){function v(d){return d===A.None||d===A.Cancelled||d instanceof C?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}A.isCancellationToken=v,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(o||(e.CancellationToken=o={}));class C{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new w.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(v){this.a=void 0,this.b=void 0,this.b=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new C),this.a}cancel(){this.a?this.a instanceof C&&this.a.cancel():this.a=o.Cancelled}dispose(v=!1){v&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof C&&this.a.dispose():this.a=o.None}}e.CancellationTokenSource=D}),define(pe[145],ve([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new w.CancellationTokenSource,v=this.b(A.token);return this.a={promise:v,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=L;class o{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const v=JSON.stringify(A);return this.b!==v&&(this.b=v,this.a=this.c(A)),this.a}}e.LRUCachedFunction=o;class C{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const v=this.b(A);return this.a.set(A,v),v}}e.CachedFunction=C}),define(pe[47],ve([1,0,9,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function o(S){const O=S;return O?typeof O.read=="function":!1}e.isReadable=o;function C(S){const O=S;return O?[O.on,O.pause,O.resume,O.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=C;function D(S){const O=S;return O?C(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(S,O){return new v(S,O)}e.newWriteableStream=A;class v{constructor(O,t){this.e=O,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(t=>t(O))}h(O){this.c.error.length===0?(0,w.onUnexpectedError)(O):this.c.error.slice(0).forEach(t=>t(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,t){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(O,t){if(this.a.destroyed)return;let n;switch(O){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(S,O){const t=[];let n;for(;(n=S.read())!==null;)t.push(n);return O(t)}e.consumeReadable=d;function R(S,O,t){const n=[];let r;for(;(r=S.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?O(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return S.read()}}}e.peekReadable=R;function y(S,O){return new Promise((t,n)=>{const r=[];E(S,{onData:i=>{O&&r.push(i)},onError:i=>{O?n(i):t(void 0)},onEnd:()=>{t(O?O(r):void 0)}})})}e.consumeStream=y;function E(S,O){let t=!1;return S.on("error",n=>{t||O.onError(n)}),S.on("end",()=>{t||O.onEnd()}),S.on("data",n=>{t||O.onData(n)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=E;function m(S,O){return new Promise((t,n)=>{const r=new L.DisposableStore,i=[],a=p=>{if(i.push(p),i.length>O)return r.dispose(),S.pause(),t({stream:S,buffer:i,ended:!1})},l=p=>n(p),c=()=>t({stream:S,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>S.removeListener("error",l))),S.on("error",l),r.add((0,L.toDisposable)(()=>S.removeListener("end",c))),S.on("end",c),r.add((0,L.toDisposable)(()=>S.removeListener("data",a))),S.on("data",a)})}e.peekStream=m;function g(S,O){const t=A(O);return t.end(S),t}e.toStream=g;function b(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=b;function s(S){let O=!1;return{read:()=>O?null:(O=!0,S)}}e.toReadable=s;function h(S,O,t){const n=A(t);return E(S,{onData:r=>n.write(O.data(r)),onError:r=>n.error(O.error?O.error(r):r),onEnd:()=>n.end()}),n}e.transform=h;function u(S,O,t){let n=!1;return{read:()=>{const r=O.read();return n?r:(n=!0,r!==null?t([S,r]):S)}}}e.prefixedReadable=u;function f(S,O,t){let n=!1;const r=A(t);return E(O,{onData:i=>n?r.write(i):(n=!0,r.write(t([S,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(S)),r.end()}}),r}e.prefixedStream=f}),define(pe[15],ve([1,0,47]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let o,C;class D{static alloc(p){return L?new D(Buffer.allocUnsafe(p)):new D(new Uint8Array(p))}static wrap(p){return L&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new D(p)}static fromString(p,P){return!(P?.dontUseNodeBuffer||!1)&&L?new D(Buffer.from(p)):(o||(o=new TextEncoder),new D(o.encode(p)))}static fromByteArray(p){const P=D.alloc(p.length);for(let T=0,I=p.length;T<I;T++)P.buffer[T]=p[T];return P}static concat(p,P){if(typeof P>"u"){P=0;for(let F=0,H=p.length;F<H;F++)P+=p[F].byteLength}const T=D.alloc(P);let I=0;for(let F=0,H=p.length;F<H;F++){const ee=p[F];T.set(ee,I),I+=ee.byteLength}return T}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=D.alloc(this.byteLength);return p.set(this),p}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(p,P){return new D(this.buffer.subarray(p,P))}set(p,P){if(p instanceof D)this.buffer.set(p.buffer,P);else if(p instanceof Uint8Array)this.buffer.set(p,P);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),P);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return d(this.buffer,p)}writeUInt32BE(p,P){R(this.buffer,p,P)}readUInt32LE(p){return y(this.buffer,p)}writeUInt32LE(p,P){E(this.buffer,p,P)}readUInt8(p){return m(this.buffer,p)}writeUInt8(p,P){g(this.buffer,p,P)}}e.VSBuffer=D;function A(c,p){return c[p+0]<<0>>>0|c[p+1]<<8>>>0}e.readUInt16LE=A;function v(c,p,P){c[P+0]=p&255,p=p>>>8,c[P+1]=p&255}e.writeUInt16LE=v;function d(c,p){return c[p]*2**24+c[p+1]*2**16+c[p+2]*2**8+c[p+3]}e.readUInt32BE=d;function R(c,p,P){c[P+3]=p,p=p>>>8,c[P+2]=p,p=p>>>8,c[P+1]=p,p=p>>>8,c[P]=p}e.writeUInt32BE=R;function y(c,p){return c[p+0]<<0>>>0|c[p+1]<<8>>>0|c[p+2]<<16>>>0|c[p+3]<<24>>>0}e.readUInt32LE=y;function E(c,p,P){c[P+0]=p&255,p=p>>>8,c[P+1]=p&255,p=p>>>8,c[P+2]=p&255,p=p>>>8,c[P+3]=p&255}e.writeUInt32LE=E;function m(c,p){return c[p]}e.readUInt8=m;function g(c,p,P){c[P]=p}e.writeUInt8=g;function b(c){return w.consumeReadable(c,p=>D.concat(p))}e.readableToBuffer=b;function s(c){return w.toReadable(c)}e.bufferToReadable=s;function h(c){return w.consumeStream(c,p=>D.concat(p))}e.streamToBuffer=h;async function u(c){return c.ended?D.concat(c.buffer):D.concat([...c.buffer,await h(c.stream)])}e.bufferedStreamToBuffer=u;function f(c){return w.toStream(c,p=>D.concat(p))}e.bufferToStream=f;function S(c){return w.transform(c,{data:p=>typeof p=="string"?D.fromString(p):D.wrap(p)},p=>D.concat(p))}e.streamToBufferReadableStream=S;function O(c){return w.newWriteableStream(p=>D.concat(p),c)}e.newWriteableBufferStream=O;function t(c,p){return w.prefixedReadable(c,p,P=>D.concat(P))}e.prefixedBufferReadable=t;function n(c,p){return w.prefixedStream(c,p,P=>D.concat(P))}e.prefixedBufferStream=n;function r(c){let p=0,P=0,T=0;const I=new Uint8Array(Math.floor(c.length/4*3)),F=ee=>{switch(P){case 3:I[T++]=p|ee,P=0;break;case 2:I[T++]=p|ee>>>2,p=ee<<6,P=3;break;case 1:I[T++]=p|ee>>>4,p=ee<<4,P=2;break;default:p=ee<<2,P=1}};for(let ee=0;ee<c.length;ee++){const ce=c.charCodeAt(ee);if(ce>=65&&ce<=90)F(ce-65);else if(ce>=97&&ce<=122)F(ce-97+26);else if(ce>=48&&ce<=57)F(ce-48+52);else if(ce===43||ce===45)F(62);else if(ce===47||ce===95)F(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ee]}`)}}const H=T;for(;P>0;)F(0);return D.wrap(I).slice(0,H)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:c},p=!0,P=!1){const T=P?a:i;let I="";const F=c.byteLength%3;let H=0;for(;H<c.byteLength-F;H+=3){const ee=c[H+0],ce=c[H+1],ae=c[H+2];I+=T[ee>>>2],I+=T[(ee<<4|ce>>>4)&63],I+=T[(ce<<2|ae>>>6)&63],I+=T[ae&63]}if(F===1){const ee=c[H+0];I+=T[ee>>>2],I+=T[ee<<4&63],p&&(I+="==")}else if(F===2){const ee=c[H+0],ce=c[H+1];I+=T[ee>>>2],I+=T[(ee<<4|ce>>>4)&63],I+=T[ce<<2&63],p&&(I+="=")}return I}e.encodeBase64=l}),define(pe[17],ve([1,0,145,141]),function(oe,e,w,L){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(he){return!he||typeof he!="string"?!0:he.trim().length===0}e.isFalsyOrWhitespace=C;const D=/{(\d+)}/g;function A(he,...De){return De.length===0?he:he.replace(D,function(Te,Re){const Oe=parseInt(Re,10);return isNaN(Oe)||Oe<0||Oe>=De.length?Te:De[Oe]})}e.format=A;const v=/{([^}]+)}/g;function d(he,De){return he.replace(v,(Te,Re)=>De[Re]??Te)}e.format2=d;function R(he){return he.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.escape=R;function y(he){return he.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function E(he,De){let Te=0;const Re=De.charCodeAt(0);for(let Oe=he.length-1;Oe>=0;Oe--)he.charCodeAt(Oe)===Re&&Te++;return Te}e.count=E;function m(he,De,Te="\u2026"){return he.length<=De?he:`${he.substr(0,De)}${Te}`}e.truncate=m;function g(he,De=" "){const Te=b(he,De);return s(Te,De)}e.trim=g;function b(he,De){if(!he||!De)return he;const Te=De.length;if(Te===0||he.length===0)return he;let Re=0;for(;he.indexOf(De,Re)===Re;)Re=Re+Te;return he.substring(Re)}e.ltrim=b;function s(he,De){if(!he||!De)return he;const Te=De.length,Re=he.length;if(Te===0||Re===0)return he;let Oe=Re,$e=-1;for(;$e=he.lastIndexOf(De,Oe-1),!($e===-1||$e+Te!==Oe);){if($e===0)return"";Oe=$e}return he.substring(0,Oe)}e.rtrim=s;function h(he){return he.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function u(he){return he.replace(/\*/g,"")}e.stripWildcards=u;function f(he,De,Te={}){if(!he)throw new Error("Cannot create regex from empty string");De||(he=y(he)),Te.wholeWord&&(/\B/.test(he.charAt(0))||(he="\\b"+he),/\B/.test(he.charAt(he.length-1))||(he=he+"\\b"));let Re="";return Te.global&&(Re+="g"),Te.matchCase||(Re+="i"),Te.multiline&&(Re+="m"),Te.unicode&&(Re+="u"),new RegExp(he,Re)}e.createRegExp=f;function S(he){return he.source==="^"||he.source==="^$"||he.source==="$"||he.source==="^\\s*$"?!1:!!(he.exec("")&&he.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function O(he){return!!he.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=O;function t(he){return(he.global?"g":"")+(he.ignoreCase?"i":"")+(he.multiline?"m":"")+(he.unicode?"u":"")}e.regExpFlags=t;function n(he){return he.split(/\r\n|\r|\n/)}e.splitLines=n;function r(he){for(let De=0,Te=he.length;De<Te;De++){const Re=he.charCodeAt(De);if(Re!==32&&Re!==9)return De}return-1}e.firstNonWhitespaceIndex=r;function i(he,De=0,Te=he.length){for(let Re=De;Re<Te;Re++){const Oe=he.charCodeAt(Re);if(Oe!==32&&Oe!==9)return he.substring(De,Re)}return he.substring(De,Te)}e.getLeadingWhitespace=i;function a(he,De=he.length-1){for(let Te=De;Te>=0;Te--){const Re=he.charCodeAt(Te);if(Re!==32&&Re!==9)return Te}return-1}e.lastNonWhitespaceIndex=a;function l(he,De,Te){const Re=[];let Oe=0;for(const $e of he.matchAll(De)){if(Re.push(he.slice(Oe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Oe=$e.index+$e[0].length,Re.push(Te($e[0],...$e.slice(1),$e.index,he,$e.groups))}return Re.push(he.slice(Oe)),Promise.all(Re).then($e=>$e.join(""))}e.replaceAsync=l;function c(he,De){return he<De?-1:he>De?1:0}e.compare=c;function p(he,De,Te=0,Re=he.length,Oe=0,$e=De.length){for(;Te<Re&&Oe<$e;Te++,Oe++){const _e=he.charCodeAt(Te),Ke=De.charCodeAt(Oe);if(_e<Ke)return-1;if(_e>Ke)return 1}const qe=Re-Te,xe=$e-Oe;return qe<xe?-1:qe>xe?1:0}e.compareSubstring=p;function P(he,De){return T(he,De,0,he.length,0,De.length)}e.compareIgnoreCase=P;function T(he,De,Te=0,Re=he.length,Oe=0,$e=De.length){for(;Te<Re&&Oe<$e;Te++,Oe++){let _e=he.charCodeAt(Te),Ke=De.charCodeAt(Oe);if(_e===Ke)continue;if(_e>=128||Ke>=128)return p(he.toLowerCase(),De.toLowerCase(),Te,Re,Oe,$e);F(_e)&&(_e-=32),F(Ke)&&(Ke-=32);const Je=_e-Ke;if(Je!==0)return Je}const qe=Re-Te,xe=$e-Oe;return qe<xe?-1:qe>xe?1:0}e.compareSubstringIgnoreCase=T;function I(he){return he>=48&&he<=57}e.isAsciiDigit=I;function F(he){return he>=97&&he<=122}e.isLowerAsciiLetter=F;function H(he){return he>=65&&he<=90}e.isUpperAsciiLetter=H;function ee(he,De){return he.length===De.length&&T(he,De)===0}e.equalsIgnoreCase=ee;function ce(he,De){const Te=De.length;return De.length>he.length?!1:T(he,De,0,Te)===0}e.startsWithIgnoreCase=ce;function ae(he,De){const Te=Math.min(he.length,De.length);let Re;for(Re=0;Re<Te;Re++)if(he.charCodeAt(Re)!==De.charCodeAt(Re))return Re;return Te}e.commonPrefixLength=ae;function ue(he,De){const Te=Math.min(he.length,De.length);let Re;const Oe=he.length-1,$e=De.length-1;for(Re=0;Re<Te;Re++)if(he.charCodeAt(Oe-Re)!==De.charCodeAt($e-Re))return Re;return Te}e.commonSuffixLength=ue;function ge(he){return 55296<=he&&he<=56319}e.isHighSurrogate=ge;function G(he){return 56320<=he&&he<=57343}e.isLowSurrogate=G;function te(he,De){return(he-55296<<10)+(De-56320)+65536}e.computeCodePoint=te;function W(he,De,Te){const Re=he.charCodeAt(Te);if(ge(Re)&&Te+1<De){const Oe=he.charCodeAt(Te+1);if(G(Oe))return te(Re,Oe)}return Re}e.getNextCodePoint=W;function K(he,De){const Te=he.charCodeAt(De-1);if(G(Te)&&De>1){const Re=he.charCodeAt(De-2);if(ge(Re))return te(Re,Te)}return Te}class q{get offset(){return this.e}constructor(De,Te=0){this.c=De,this.d=De.length,this.e=Te}setOffset(De){this.e=De}prevCodePoint(){const De=K(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=W(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.CodePointIterator=q;class ie{get offset(){return this.c.offset}constructor(De,Te=0){this.c=new q(De,Te)}nextGraphemeLength(){const De=ze.getInstance(),Te=this.c,Re=Te.offset;let Oe=De.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const $e=Te.offset,qe=De.getGraphemeBreakType(Te.nextCodePoint());if(we(Oe,qe)){Te.setOffset($e);break}Oe=qe}return Te.offset-Re}prevGraphemeLength(){const De=ze.getInstance(),Te=this.c,Re=Te.offset;let Oe=De.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const $e=Te.offset,qe=De.getGraphemeBreakType(Te.prevCodePoint());if(we(qe,Oe)){Te.setOffset($e);break}Oe=qe}return Re-Te.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ie;function re(he,De){return new ie(he,De).nextGraphemeLength()}e.nextCharLength=re;function de(he,De){return new ie(he,De).prevGraphemeLength()}e.prevCharLength=de;function $(he,De){De>0&&G(he.charCodeAt(De))&&De--;const Te=De+re(he,De);return[Te-de(he,Te),Te]}e.getCharContainingOffset=$;function V(he){const De=new ie(he);let Te=0;for(;!De.eol();)Te++,De.nextGraphemeLength();return Te}e.charCount=V;let N;function k(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(he){return N||(N=k()),N.test(he)}e.containsRTL=U;const X=/^[\t\n\r\x20-\x7E]*$/;function ne(he){return X.test(he)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(he){return e.UNUSUAL_LINE_TERMINATORS.test(he)}e.containsUnusualLineTerminators=z;function j(he){return he>=11904&&he<=55215||he>=63744&&he<=64255||he>=65281&&he<=65374}e.isFullWidthCharacter=j;function Y(he){return he>=127462&&he<=127487||he===8986||he===8987||he===9200||he===9203||he>=9728&&he<=10175||he===11088||he===11093||he>=127744&&he<=128591||he>=128640&&he<=128764||he>=128992&&he<=129008||he>=129280&&he<=129535||he>=129648&&he<=129782}e.isEmojiImprecise=Y;function x(he,De){if(he.length<De)return he;const Te=/\b/g;let Re=0;for(;Te.test(he)&&!(he.length-Te.lastIndex<De);)Re=Te.lastIndex,Te.lastIndex+=1;return he.substring(Re).replace(/^\s/,"")}e.lcut=x;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,J=/\x1b\].*?\x07/g;function _(he){return he&&(he=he.replace(Z,"").replace(J,"")),he}e.removeAnsiEscapeCodes=_,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(he){return!!(he&&he.length>0&&he.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function Ee(he){return le(he)?he.substr(1):he}e.stripUTF8BOM=Ee;function Ce(he,De){if(!he||!De||he.length<De.length)return!1;const Te=De.length,Re=he.toLowerCase();let Oe=0,$e=-1;for(;Oe<Te;){const qe=Re.indexOf(De[Oe],$e+1);if(qe<0)return!1;$e=qe,Oe++}return!0}e.fuzzyContains=Ce;function ke(he,De=!1){return he?(De&&(he=he.replace(/\\./g,"")),he.toLowerCase()!==he):!1}e.containsUppercaseCharacter=ke;function Ue(he){return he.charAt(0).toUpperCase()+he.slice(1)}e.uppercaseFirstLetter=Ue;function je(he,De=1){if(De===0)return"";let Te=-1;do Te=he.indexOf(`
`,Te+1),De--;while(De>0&&Te>=0);return Te===-1?he:(he[Te-1]==="\r"&&Te--,he.substr(0,Te))}e.getNLines=je;function me(he){return he=he%(2*26),he<26?String.fromCharCode(97+he):String.fromCharCode(65+he-26)}e.singleLetterHash=me;function Se(he){return ze.getInstance().getGraphemeBreakType(he)}e.getGraphemeBreakType=Se;function we(he,De){return he===0?De!==5&&De!==7:he===2&&De===3?!1:he===4||he===2||he===3||De===4||De===2||De===3?!0:!(he===8&&(De===8||De===9||De===11||De===12)||(he===11||he===9)&&(De===9||De===10)||(he===12||he===10)&&De===10||De===5||De===13||De===7||he===1||he===13&&De===14||he===6&&De===6)}var Ne;(function(he){he[he.Other=0]="Other",he[he.Prepend=1]="Prepend",he[he.CR=2]="CR",he[he.LF=3]="LF",he[he.Control=4]="Control",he[he.Extend=5]="Extend",he[he.Regional_Indicator=6]="Regional_Indicator",he[he.SpacingMark=7]="SpacingMark",he[he.L=8]="L",he[he.V=9]="V",he[he.T=10]="T",he[he.LV=11]="LV",he[he.LVT=12]="LVT",he[he.ZWJ=13]="ZWJ",he[he.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class ze{static getInstance(){return ze.c||(ze.c=new ze),ze.c}constructor(){this.d=tt()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Te=this.d,Re=Te.length/3;let Oe=1;for(;Oe<=Re;)if(De<Te[3*Oe])Oe=2*Oe;else if(De>Te[3*Oe+1])Oe=2*Oe+1;else return Te[3*Oe+2];return 0}}ze.c=null;function tt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(he,De){if(he===0)return 0;const Te=Xe(he,De);if(Te!==void 0)return Te;const Re=new q(De,he);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=Ve;function Xe(he,De){const Te=new q(De,he);let Re=Te.prevCodePoint();for(;Qe(Re)||Re===65039||Re===8419;){if(Te.offset===0)return;Re=Te.prevCodePoint()}if(!Y(Re))return;let Oe=Te.offset;return Oe>0&&Te.prevCodePoint()===8205&&(Oe=Te.offset),Oe}function Qe(he){return 127995<=he&&he<=127999}var it;(function(he){he[he.zwj=8205]="zwj",he[he.emojiVariantSelector=65039]="emojiVariantSelector",he[he.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class Ge{static getInstance(De){return Ge.d.get(Array.from(De))}static getLocales(){return Ge.e.value}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Ge,o=Ge,Ge.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.d=new w.LRUCachedFunction(he=>{function De(Ke){const Je=new Map;for(let at=0;at<Ke.length;at+=2)Je.set(Ke[at],Ke[at+1]);return Je}function Te(Ke,Je){const at=new Map(Ke);for(const[vt,ot]of Je)at.set(vt,ot);return at}function Re(Ke,Je){if(!Ke)return Je;const at=new Map;for(const[vt,ot]of Ke)Je.has(vt)&&at.set(vt,ot);return at}const Oe=o.c.value;let $e=he.filter(Ke=>!Ke.startsWith("_")&&Ke in Oe);$e.length===0&&($e=["_default"]);let qe;for(const Ke of $e){const Je=De(Oe[Ke]);qe=Re(qe,Je)}const xe=De(Oe._common),_e=Te(xe,qe);return new Ge(_e)}),Ge.e=new L.Lazy(()=>Object.keys(Ge.c.value).filter(he=>!he.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(De){return Ye.e().has(De)}static get codePoints(){return Ye.e()}}e.InvisibleCharacters=Ye,Ye.d=void 0}),define(pe[146],ve([1,0,28,17]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function o(...J){return function(_,le){for(let Ee=0,Ce=J.length;Ee<Ce;Ee++){const ke=J[Ee](_,le);if(ke)return ke}return null}}e.or=o,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(J,_,le){if(!le||le.length<_.length)return null;let Ee;return J?Ee=L.startsWithIgnoreCase(le,_):Ee=le.indexOf(_)===0,Ee?_.length>0?[{start:0,end:_.length}]:[]:null}function D(J,_){const le=_.toLowerCase().indexOf(J.toLowerCase());return le===-1?null:[{start:le,end:le+J.length}]}e.matchesContiguousSubString=D;function A(J,_){return v(J.toLowerCase(),_.toLowerCase(),0,0)}e.matchesSubString=A;function v(J,_,le,Ee){if(le===J.length)return[];if(Ee===_.length)return null;if(J[le]===_[Ee]){let Ce=null;return(Ce=v(J,_,le+1,Ee+1))?h({start:Ee,end:Ee+1},Ce):null}return v(J,_,le,Ee+1)}function d(J){return 97<=J&&J<=122}function R(J){return 65<=J&&J<=90}e.isUpper=R;function y(J){return 48<=J&&J<=57}function E(J){return J===32||J===9||J===10||J===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>m.add(J.charCodeAt(0)));function g(J){return E(J)||m.has(J)}function b(J,_){return J===_||g(J)&&g(_)}function s(J){return d(J)||R(J)||y(J)}function h(J,_){return _.length===0?_=[J]:J.end===_[0].start?_[0].start=J.start:_.unshift(J),_}function u(J,_){for(let le=_;le<J.length;le++){const Ee=J.charCodeAt(le);if(R(Ee)||y(Ee)||le>0&&!s(J.charCodeAt(le-1)))return le}return J.length}function f(J,_,le,Ee){if(le===J.length)return[];if(Ee===_.length)return null;if(J[le]!==_[Ee].toLowerCase())return null;{let Ce=null,ke=Ee+1;for(Ce=f(J,_,le+1,Ee+1);!Ce&&(ke=u(_,ke))<_.length;)Ce=f(J,_,le+1,ke),ke++;return Ce===null?null:h({start:Ee,end:Ee+1},Ce)}}function S(J){let _=0,le=0,Ee=0,Ce=0,ke=0;for(let we=0;we<J.length;we++)ke=J.charCodeAt(we),R(ke)&&_++,d(ke)&&le++,s(ke)&&Ee++,y(ke)&&Ce++;const Ue=_/J.length,je=le/J.length,me=Ee/J.length,Se=Ce/J.length;return{upperPercent:Ue,lowerPercent:je,alphaPercent:me,numericPercent:Se}}function O(J){const{upperPercent:_,lowerPercent:le}=J;return le===0&&_>.6}function t(J){const{upperPercent:_,lowerPercent:le,alphaPercent:Ee,numericPercent:Ce}=J;return le>.2&&_<.8&&Ee>.6&&Ce<.2}function n(J){let _=0,le=0,Ee=0,Ce=0;for(let ke=0;ke<J.length;ke++)Ee=J.charCodeAt(ke),R(Ee)&&_++,d(Ee)&&le++,E(Ee)&&Ce++;return(_===0||le===0)&&Ce===0?J.length<=30:_<=5}function r(J,_){if(!_||(_=_.trim(),_.length===0)||!n(J)||_.length>60)return null;const le=S(_);if(!t(le)){if(!O(le))return null;_=_.toLowerCase()}let Ee=null,Ce=0;for(J=J.toLowerCase();Ce<_.length&&(Ee=f(J,_,0,Ce))===null;)Ce=u(_,Ce+1);return Ee}e.matchesCamelCase=r;function i(J,_,le=!1){if(!_||_.length===0)return null;let Ee=null,Ce=0;for(J=J.toLowerCase(),_=_.toLowerCase();Ce<_.length&&(Ee=a(J,_,0,Ce,le))===null;)Ce=l(_,Ce+1);return Ee}e.matchesWords=i;function a(J,_,le,Ee,Ce){if(le===J.length)return[];if(Ee===_.length)return null;if(b(J.charCodeAt(le),_.charCodeAt(Ee))){let ke=null,Ue=Ee+1;if(ke=a(J,_,le+1,Ee+1,Ce),!Ce)for(;!ke&&(Ue=l(_,Ue))<_.length;)ke=a(J,_,le+1,Ue,Ce),Ue++;return ke?J.charCodeAt(le)!==_.charCodeAt(Ee)?ke:h({start:Ee,end:Ee+1},ke):null}else return null}function l(J,_){for(let le=_;le<J.length;le++)if(g(J.charCodeAt(le))||le>0&&g(J.charCodeAt(le-1)))return le;return J.length}const c=o(e.matchesPrefix,r,D),p=o(e.matchesPrefix,r,A),P=new w.LRUCache(1e4);function T(J,_,le=!1){if(typeof J!="string"||typeof _!="string")return null;let Ee=P.get(J);Ee||(Ee=new RegExp(L.convertSimple2RegExpPattern(J),"i"),P.set(J,Ee));const Ce=Ee.exec(_);return Ce?[{start:Ce.index,end:Ce.index+Ce[0].length}]:le?p(J,_):c(J,_)}e.matchesFuzzy=T;function I(J,_){const le=X(J,J.toLowerCase(),0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return le?H(le):null}e.matchesFuzzy2=I;function F(J,_,le,Ee,Ce,ke){const Ue=Math.min(13,J.length);for(;le<Ue;le++){const je=X(J,_,le,Ee,Ce,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(je)return je}return[0,ke]}e.anyScore=F;function H(J){if(typeof J>"u")return[];const _=[],le=J[1];for(let Ee=J.length-1;Ee>1;Ee--){const Ce=J[Ee]+le,ke=_[_.length-1];ke&&ke.end===Ce?ke.end=Ce+1:_.push({start:Ce,end:Ce+1})}return _}e.createMatches=H;const ee=128;function ce(){const J=[],_=[];for(let le=0;le<=ee;le++)_[le]=0;for(let le=0;le<=ee;le++)J.push(_.slice(0));return J}function ae(J){const _=[];for(let le=0;le<=J;le++)_[le]=0;return _}const ue=ae(2*ee),ge=ae(2*ee),G=ce(),te=ce(),W=ce(),K=!1;function q(J,_,le,Ee,Ce){function ke(je,me,Se=" "){for(;je.length<me;)je=Se+je;return je}let Ue=` |   |${Ee.split("").map(je=>ke(je,3)).join("|")}
`;for(let je=0;je<=le;je++)je===0?Ue+=" |":Ue+=`${_[je-1]}|`,Ue+=J[je].slice(0,Ce+1).map(me=>ke(me.toString(),3)).join("|")+`
`;return Ue}function ie(J,_,le,Ee){J=J.substr(_),le=le.substr(Ee),console.log(q(te,J,J.length,le,le.length)),console.log(q(W,J,J.length,le,le.length)),console.log(q(G,J,J.length,le,le.length))}function re(J,_){if(_<0||_>=J.length)return!1;const le=J.codePointAt(_);switch(le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(le)}}function de(J,_){if(_<0||_>=J.length)return!1;switch(J.charCodeAt(_)){case 32:case 9:return!0;default:return!1}}function $(J,_,le){return _[J]!==le[J]}function V(J,_,le,Ee,Ce,ke,Ue=!1){for(;_<le&&Ce<ke;)J[_]===Ee[Ce]&&(Ue&&(ue[_]=Ce),_+=1),Ce+=1;return _===le}e.isPatternInWord=V;var N;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(N||(N={}));var k;(function(J){J.Default=[-100,0];function _(le){return!le||le.length===2&&le[0]===-100&&le[1]===0}J.isDefault=_})(k||(e.FuzzyScore=k={}));class U{constructor(_,le){this.firstMatchCanBeWeak=_,this.boostFullMatch=le}}e.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function X(J,_,le,Ee,Ce,ke,Ue=U.default){const je=J.length>ee?ee:J.length,me=Ee.length>ee?ee:Ee.length;if(le>=je||ke>=me||je-le>me-ke||!V(_,le,je,Ce,ke,me,!0))return;ne(je,me,le,ke,_,Ce);let Se=1,we=1,Ne=le,ze=ke;const tt=[!1];for(Se=1,Ne=le;Ne<je;Se++,Ne++){const Ge=ue[Ne],Ye=ge[Ne],he=Ne+1<je?ge[Ne+1]:me;for(we=Ge-ke+1,ze=Ge;ze<he;we++,ze++){let De=Number.MIN_SAFE_INTEGER,Te=!1;ze<=Ye&&(De=z(J,_,Ne,le,Ee,Ce,ze,me,ke,G[Se-1][we-1]===0,tt));let Re=0;De!==Number.MAX_SAFE_INTEGER&&(Te=!0,Re=De+te[Se-1][we-1]);const Oe=ze>Ge,$e=Oe?te[Se][we-1]+(G[Se][we-1]>0?-5:0):0,qe=ze>Ge+1&&G[Se][we-1]>0,xe=qe?te[Se][we-2]+(G[Se][we-2]>0?-5:0):0;if(qe&&(!Oe||xe>=$e)&&(!Te||xe>=Re))te[Se][we]=xe,W[Se][we]=3,G[Se][we]=0;else if(Oe&&(!Te||$e>=Re))te[Se][we]=$e,W[Se][we]=2,G[Se][we]=0;else if(Te)te[Se][we]=Re,W[Se][we]=1,G[Se][we]=G[Se-1][we-1]+1;else throw new Error("not possible")}}if(K&&ie(J,le,Ee,ke),!tt[0]&&!Ue.firstMatchCanBeWeak)return;Se--,we--;const Ve=[te[Se][we],ke];let Xe=0,Qe=0;for(;Se>=1;){let Ge=we;do{const Ye=W[Se][Ge];if(Ye===3)Ge=Ge-2;else if(Ye===2)Ge=Ge-1;else break}while(Ge>=1);Xe>1&&_[le+Se-1]===Ce[ke+we-1]&&!$(Ge+ke-1,Ee,Ce)&&Xe+1>G[Se][Ge]&&(Ge=we),Ge===we?Xe++:Xe=1,Qe||(Qe=Ge),Se--,we=Ge-1,Ve.push(we)}me===je&&Ue.boostFullMatch&&(Ve[0]+=2);const it=Qe-je;return Ve[0]-=it,Ve}e.fuzzyScore=X;function ne(J,_,le,Ee,Ce,ke){let Ue=J-1,je=_-1;for(;Ue>=le&&je>=Ee;)Ce[Ue]===ke[je]&&(ge[Ue]=je,Ue--),je--}function z(J,_,le,Ee,Ce,ke,Ue,je,me,Se,we){if(_[le]!==ke[Ue])return Number.MIN_SAFE_INTEGER;let Ne=1,ze=!1;return Ue===le-Ee?Ne=J[le]===Ce[Ue]?7:5:$(Ue,Ce,ke)&&(Ue===0||!$(Ue-1,Ce,ke))?(Ne=J[le]===Ce[Ue]?7:5,ze=!0):re(ke,Ue)&&(Ue===0||!re(ke,Ue-1))?Ne=5:(re(ke,Ue-1)||de(ke,Ue-1))&&(Ne=5,ze=!0),Ne>1&&le===Ee&&(we[0]=!0),ze||(ze=$(Ue,Ce,ke)||re(ke,Ue-1)||de(ke,Ue-1)),le===Ee?Ue>me&&(Ne-=ze?3:5):Se?Ne+=ze?2:0:Ne+=ze?0:1,Ue+1===je&&(Ne-=ze?3:5),Ne}function j(J,_,le,Ee,Ce,ke,Ue){return x(J,_,le,Ee,Ce,ke,!0,Ue)}e.fuzzyScoreGracefulAggressive=j;function Y(J,_,le,Ee,Ce,ke,Ue){return x(J,_,le,Ee,Ce,ke,!1,Ue)}e.fuzzyScoreGraceful=Y;function x(J,_,le,Ee,Ce,ke,Ue,je){let me=X(J,_,le,Ee,Ce,ke,je);if(me&&!Ue)return me;if(J.length>=3){const Se=Math.min(7,J.length-1);for(let we=le+1;we<Se;we++){const Ne=Z(J,we);if(Ne){const ze=X(Ne,Ne.toLowerCase(),le,Ee,Ce,ke,je);ze&&(ze[0]-=3,(!me||ze[0]>me[0])&&(me=ze))}}}return me}function Z(J,_){if(_+1>=J.length)return;const le=J[_],Ee=J[_+1];if(le!==Ee)return J.slice(0,_)+Ee+le+J.slice(_+2)}}),define(pe[73],ve([1,0,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(h){return o(h,0)}e.hash=L;function o(h,u){switch(typeof h){case"object":return h===null?C(349,u):Array.isArray(h)?v(h,u):d(h,u);case"string":return A(h,u);case"boolean":return D(h,u);case"number":return C(h,u);case"undefined":return C(937,u);default:return C(617,u)}}e.doHash=o;function C(h,u){return(u<<5)-u+h|0}e.numberHash=C;function D(h,u){return C(h?433:863,u)}function A(h,u){u=C(149417,u);for(let f=0,S=h.length;f<S;f++)u=C(h.charCodeAt(f),u);return u}e.stringHash=A;function v(h,u){return u=C(104579,u),h.reduce((f,S)=>o(S,f),u)}function d(h,u){return u=C(181387,u),Object.keys(h).sort().reduce((f,S)=>(f=A(S,f),o(h[S],f)),u)}class R{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=o(u,this.g),this.g}}e.Hasher=R;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(h,u,f=32){const S=f-u,O=~((1<<S)-1);return(h<<u|(O&h)>>>S)>>>0}function m(h,u=0,f=h.byteLength,S=0){for(let O=0;O<f;O++)h[u+O]=S}function g(h,u,f="0"){for(;h.length<u;)h=f+h;return h}function b(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(f=>f.toString(16).padStart(2,"0")).join(""):g((h>>>0).toString(16),u/4)}e.toHexString=b;class s{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const f=u.length;if(f===0)return;const S=this.p;let O=this.r,t=this.u,n,r;for(t!==0?(n=t,r=-1,t=0):(n=u.charCodeAt(0),r=0);;){let i=n;if(w.isHighSurrogate(n))if(r+1<f){const a=u.charCodeAt(r+1);w.isLowSurrogate(a)?(r++,i=w.computeCodePoint(n,a)):i=65533}else{t=n;break}else w.isLowSurrogate(n)&&(i=65533);if(O=this.w(S,O,i),r++,r<f)n=u.charCodeAt(r);else break}this.r=O,this.u=t}w(u,f,S){return S<128?u[f++]=S:S<2048?(u[f++]=192|(S&1984)>>>6,u[f++]=128|(S&63)>>>0):S<65536?(u[f++]=224|(S&61440)>>>12,u[f++]=128|(S&4032)>>>6,u[f++]=128|(S&63)>>>0):(u[f++]=240|(S&1835008)>>>18,u[f++]=128|(S&258048)>>>12,u[f++]=128|(S&4032)>>>6,u[f++]=128|(S&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=s.g,f=this.q;for(let c=0;c<64;c+=4)u.setUint32(c,f.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)u.setUint32(c,E(u.getUint32(c-12,!1)^u.getUint32(c-32,!1)^u.getUint32(c-56,!1)^u.getUint32(c-64,!1),1),!1);let S=this.h,O=this.l,t=this.m,n=this.n,r=this.o,i,a,l;for(let c=0;c<80;c++)c<20?(i=O&t|~O&n,a=1518500249):c<40?(i=O^t^n,a=1859775393):c<60?(i=O&t|O&n|t&n,a=2400959708):(i=O^t^n,a=3395469782),l=E(S,5)+i+r+a+u.getUint32(c*4,!1)&4294967295,r=n,n=t,t=E(O,30),O=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+O&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=s,s.g=new DataView(new ArrayBuffer(320))}),define(pe[59],ve([1,0,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(o){o[o.Ignore=0]="Ignore",o[o.Info=1]="Info",o[o.Warning=2]="Warning",o[o.Error=3]="Error"})(L||(L={})),function(o){const C="error",D="warning",A="warn",v="info",d="ignore";function R(E){return E?w.equalsIgnoreCase(C,E)?o.Error:w.equalsIgnoreCase(D,E)||w.equalsIgnoreCase(A,E)?o.Warning:w.equalsIgnoreCase(v,E)?o.Info:o.Ignore:o.Ignore}o.fromValue=R;function y(E){switch(E){case o.Error:return C;case o.Warning:return D;case o.Info:return v;default:return d}}o.toString=y}(L||(L={})),e.default=L}),define(pe[147],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[60],ve([1,0,18,17]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class o{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const g=m.charCodeAt(0),b=this.b.charCodeAt(this.c);return g-b}value(){return this.b[this.c]}}e.StringIterator=o;class C{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,L.compareSubstring)(m,this.b,0,m.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=C;class D{constructor(m=!0,g=!0){this.f=m,this.g=g}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let g=m.length-1;g>=0;g--,this.c--){const b=this.b.charCodeAt(g);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,L.compareSubstring)(m,this.b,0,m.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var A;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(A||(A={}));class v{constructor(m,g){this.f=m,this.g=g,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(m,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,L.compare)(m,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=v;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class y{static forUris(m=()=>!1,g=()=>!1){return new y(new v(m,g))}static forPaths(m=!1){return new y(new D(void 0,!m))}static forStrings(){return new y(new o)}static forConfigKeys(){return new y(new C)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,g){if(g){const b=g.slice(0);(0,w.shuffle)(b);for(const s of b)this.set(s,m)}else{const b=m.slice(0);(0,w.shuffle)(b);for(const s of b)this.set(s[0],s[1])}}set(m,g){const b=this.b.reset(m);let s;this.c||(this.c=new d,this.c.segment=b.value());const h=[];for(s=this.c;;){const f=b.cmp(s.segment);if(f>0)s.left||(s.left=new d,s.left.segment=b.value()),h.push([-1,s]),s=s.left;else if(f<0)s.right||(s.right=new d,s.right.segment=b.value()),h.push([1,s]),s=s.right;else if(b.hasNext())b.next(),s.mid||(s.mid=new d,s.mid.segment=b.value()),h.push([0,s]),s=s.mid;else break}const u=s.value;s.value=g,s.key=m;for(let f=h.length-1;f>=0;f--){const S=h[f][1];S.updateHeight();const O=S.balanceFactor();if(O<-1||O>1){const t=h[f][0],n=h[f+1][0];if(t===1&&n===1)h[f][1]=S.rotateLeft();else if(t===-1&&n===-1)h[f][1]=S.rotateRight();else if(t===1&&n===-1)S.right=h[f+1][1]=h[f+1][1].rotateRight(),h[f][1]=S.rotateLeft();else if(t===-1&&n===1)S.left=h[f+1][1]=h[f+1][1].rotateLeft(),h[f][1]=S.rotateRight();else throw new Error;if(f>0)switch(h[f-1][0]){case-1:h[f-1][1].left=h[f][1];break;case 1:h[f-1][1].right=h[f][1];break;case 0:h[f-1][1].mid=h[f][1];break}else this.c=h[0][1]}}return u}get(m){return this.d(m)?.value}d(m){const g=this.b.reset(m);let b=this.c;for(;b;){const s=g.cmp(b.segment);if(s>0)b=b.left;else if(s<0)b=b.right;else if(g.hasNext())g.next(),b=b.mid;else break}return b}has(m){const g=this.d(m);return!(g?.value===void 0&&g?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,g){const b=this.b.reset(m),s=[];let h=this.c;for(;h;){const u=b.cmp(h.segment);if(u>0)s.push([-1,h]),h=h.left;else if(u<0)s.push([1,h]),h=h.right;else if(b.hasNext())b.next(),s.push([0,h]),h=h.mid;else break}if(h){if(g?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this.f(h.right);if(u.key){const{key:f,value:S,segment:O}=u;this.e(u.key,!1),h.key=f,h.value=S,h.segment=O}}else{const u=h.left??h.right;if(s.length>0){const[f,S]=s[s.length-1];switch(f){case-1:S.left=u;break;case 0:S.mid=u;break;case 1:S.right=u;break}}else this.c=u}for(let u=s.length-1;u>=0;u--){const f=s[u][1];f.updateHeight();const S=f.balanceFactor();if(S>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),s[u][1]=f.rotateLeft()):S<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),s[u][1]=f.rotateRight()),u>0)switch(s[u-1][0]){case-1:s[u-1][1].left=s[u][1];break;case 1:s[u-1][1].right=s[u][1];break;case 0:s[u-1][1].mid=s[u][1];break}else this.c=s[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const g=this.b.reset(m);let b=this.c,s;for(;b;){const h=g.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if(g.hasNext())g.next(),s=b.value||s,b=b.mid;else break}return b&&b.value||s}findSuperstr(m){return this.g(m,!1)}g(m,g){const b=this.b.reset(m);let s=this.c;for(;s;){const h=b.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(b.hasNext())b.next(),s=s.mid;else return s.mid?this.h(s.mid):g?s.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[g,b]of this)m(b,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const g=[];return this.j(m,g),g[Symbol.iterator]()}j(m,g){m&&(m.left&&this.j(m.left,g),m.value&&g.push([m.key,m.value]),m.mid&&this.j(m.mid,g),m.right&&this.j(m.right,g))}_isBalanced(){const m=g=>{if(!g)return!0;const b=g.balanceFactor();return b<-1||b>1?!1:m(g.left)&&m(g.right)};return m(this.c)}}e.TernarySearchTree=y}),define(pe[8],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(n){return typeof n=="string"}e.isString=w;function L(n){return Array.isArray(n)&&n.every(r=>w(r))}e.isStringArray=L;function o(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=o;function C(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=C;function D(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=D;function A(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=A;function v(n){return n===!0||n===!1}e.isBoolean=v;function d(n){return typeof n>"u"}e.isUndefined=d;function R(n){return!y(n)}e.isDefined=R;function y(n){return d(n)||n===null}e.isUndefinedOrNull=y;function E(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=E;function m(n){if(y(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=m;function g(...n){const r=[];for(let i=0;i<n.length;i++){const a=n[i];if(y(a))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);r.push(a)}return r}e.assertAllDefined=g;const b=Object.prototype.hasOwnProperty;function s(n){if(!o(n))return!1;for(const r in n)if(b.call(n,r))return!1;return!0}e.isEmptyObject=s;function h(n){return typeof n=="function"}e.isFunction=h;function u(...n){return n.length>0&&n.every(h)}e.areFunctions=u;function f(n,r){const i=Math.min(n.length,r.length);for(let a=0;a<i;a++)S(n[a],r[a])}e.validateConstraints=f;function S(n,r){if(w(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(n instanceof r)return}catch{}if(!y(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function O(n){return n===null?void 0:n}e.withNullAsUndefined=O;function t(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=t}),define(pe[48],ve([1,0,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function o(A,v){if((0,w.isString)(v)){const d=L[v];if(d===void 0)throw new Error(`${A} references an unknown codicon: ${v}`);v=d}return L[A]=v,{id:A}}function C(){return L}e.getCodiconFontCharacters=C;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),bracket:o("bracket",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),send:o("send",60431),sparkle:o("sparkle",60432),insert:o("insert",60433),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(pe[38],ve([1,0,7,3,17,8]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(l){return l===47||l===92}e.isPathSeparator=D;function A(l){return l.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=A;function v(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=v;function d(l,c=w.posix.sep){if(!l)return"";const p=l.length,P=l.charCodeAt(0);if(D(P)){if(D(l.charCodeAt(1))&&!D(l.charCodeAt(2))){let I=3;const F=I;for(;I<p&&!D(l.charCodeAt(I));I++);if(F!==I&&!D(l.charCodeAt(I+1))){for(I+=1;I<p;I++)if(D(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,c)}}return c}else if(h(P)&&l.charCodeAt(1)===58)return D(l.charCodeAt(2))?l.slice(0,2)+c:l.slice(0,2);let T=l.indexOf("://");if(T!==-1){for(T+=3;T<p;T++)if(D(l.charCodeAt(T)))return l.slice(0,T+1)}return""}e.getRoot=d;function R(l){if(!L.isWindows||!l||l.length<5)return!1;let c=l.charCodeAt(0);if(c!==92||(c=l.charCodeAt(1),c!==92))return!1;let p=2;const P=p;for(;p<l.length&&(c=l.charCodeAt(p),c!==92);p++);return!(P===p||(c=l.charCodeAt(p+1),isNaN(c)||c===92))}e.isUNC=R;const y=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(l,c=L.isWindows){const p=c?y:E;return!(!l||l.length===0||/^\s+$/.test(l)||(p.lastIndex=0,p.test(l))||c&&m.test(l)||l==="."||l===".."||c&&l[l.length-1]==="."||c&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=g;function b(l,c,p){const P=l===c;return!p||P?P:!l||!c?!1:(0,o.equalsIgnoreCase)(l,c)}e.isEqual=b;function s(l,c,p,P=w.sep){if(l===c)return!0;if(!l||!c||c.length>l.length)return!1;if(p){if(!(0,o.startsWithIgnoreCase)(l,c))return!1;if(c.length===l.length)return!0;let I=c.length;return c.charAt(c.length-1)===P&&I--,l.charAt(I)===P}return c.charAt(c.length-1)!==P&&(c+=P),l.indexOf(c)===0}e.isEqualOrParent=s;function h(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=h;function u(l,c){return L.isWindows&&l.endsWith(":")&&(l+=w.sep),(0,w.isAbsolute)(l)||(l=(0,w.join)(c,l)),l=(0,w.normalize)(l),L.isWindows?(l=(0,o.rtrim)(l,w.sep),l.endsWith(":")&&(l+=w.sep)):(l=(0,o.rtrim)(l,w.sep),l||(l=w.sep)),l}e.sanitizeFilePath=u;function f(l){const c=(0,w.normalize)(l);return L.isWindows?l.length>3?!1:S(c)&&(l.length===2||c.charCodeAt(2)===92):c===w.posix.sep}e.isRootOrDriveLetter=f;function S(l,c=L.isWindows){return c?h(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function O(l){return S(l)?l[0]:void 0}e.getDriveLetter=O;function t(l,c,p){return c.length>l.length?-1:l===c?0:(p&&(l=l.toLowerCase(),c=c.toLowerCase()),l.indexOf(c))}e.indexOfPath=t;function n(l){const c=l.split(":");let p,P,T;for(const I of c){const F=Number(I);(0,C.isNumber)(F)?P===void 0?P=F:T===void 0&&(T=F):p=p?[p,I].join(":"):I}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:P!==void 0?P:void 0,column:T!==void 0?T:P!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,c,p=8){let P="";for(let I=0;I<p;I++){let F;I===0&&L.isWindows&&!c&&(p===3||p===4)?F=i:F=r,P+=F.charAt(Math.floor(Math.random()*F.length))}let T;return c?T=`${c}-${P}`:T=P,l?(0,w.join)(l,T):T}e.randomPath=a}),define(pe[22],ve([1,0,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([f,S])=>{u[f]=S&&typeof S=="object"?L(S):S}),u}e.deepClone=L;function o(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const f=u.shift();Object.freeze(f);for(const S in f)if(C.call(f,S)){const O=f[S];typeof O=="object"&&!Object.isFrozen(O)&&!(0,w.isTypedArray)(O)&&u.push(O)}}return h}e.deepFreeze=o;const C=Object.prototype.hasOwnProperty;function D(h,u){return A(h,u,new Set)}e.cloneAndChange=D;function A(h,u,f){if((0,w.isUndefinedOrNull)(h))return h;const S=u(h);if(typeof S<"u")return S;if(Array.isArray(h)){const O=[];for(const t of h)O.push(A(t,u,f));return O}if((0,w.isObject)(h)){if(f.has(h))throw new Error("Cannot clone recursive data-structure");f.add(h);const O={};for(const t in h)C.call(h,t)&&(O[t]=A(h[t],u,f));return f.delete(h),O}return h}function v(h,u,f=!0){return(0,w.isObject)(h)?((0,w.isObject)(u)&&Object.keys(u).forEach(S=>{S in h?f&&((0,w.isObject)(h[S])&&(0,w.isObject)(u[S])?v(h[S],u[S],f):h[S]=u[S]):h[S]=u[S]}),h):u}e.mixin=v;function d(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let f,S;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(f=0;f<h.length;f++)if(!d(h[f],u[f]))return!1}else{const O=[];for(S in h)O.push(S);O.sort();const t=[];for(S in u)t.push(S);if(t.sort(),!d(O,t))return!1;for(f=0;f<O.length;f++)if(!d(h[O[f]],u[O[f]]))return!1}return!0}e.equals=d;function R(h){const u=new Set;return JSON.stringify(h,(f,S)=>{if((0,w.isObject)(S)||Array.isArray(S)){if(u.has(S))return"[Circular]";u.add(S)}return S})}e.safeStringify=R;function y(h,u){const f=Object.create(null);return!h||!u||Object.keys(u).forEach(O=>{const t=h[O],n=u[O];d(t,n)||(f[O]=n)}),f}e.distinct=y;function E(h,u){const f=u.toLowerCase(),S=Object.keys(h).find(O=>O.toLowerCase()===f);return S?h[S]:h[u]}e.getCaseInsensitive=E;function m(h,u){const f=Object.create(null);for(const[S,O]of Object.entries(h))u(S,O)&&(f[S]=O);return f}e.filter=m;function g(h){let u=[],f=Object.getPrototypeOf(h);for(;Object.prototype!==f;)u=u.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return u}e.getAllPropertyNames=g;function b(h){const u=[];for(const f of g(h))typeof h[f]=="function"&&u.push(f);return u}e.getAllMethodNames=b;function s(h,u){const f=O=>function(){const t=Array.prototype.slice.call(arguments,0);return u(O,t)},S={};for(const O of h)S[O]=f(O);return S}e.createProxyObject=s}),define(pe[97],ve([1,0,48]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(D){function A(v){return v&&typeof v=="object"&&typeof v.id=="string"}D.isThemeColor=A})(L||(e.ThemeColor=L={}));function o(D){return{id:D}}e.themeColorFromId=o;var C;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function v(u){const f=A.exec(u.id);if(!f)return v(w.Codicon.error);const[,S,O]=f,t=["codicon","codicon-"+S];return O&&t.push("codicon-modifier-"+O.substring(1)),t}D.asClassNameArray=v;function d(u){return v(u).join(" ")}D.asClassName=d;function R(u){return"."+v(u).join(".")}D.asCSSSelector=R;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||L.isThemeColor(u.color))}D.isThemeIcon=y;const E=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function m(u){const f=E.exec(u);if(!f)return;const[,S]=f;return{id:S}}D.fromString=m;function g(u){return{id:u}}D.fromId=g;function b(u,f){let S=u.id;const O=S.lastIndexOf("~");return O!==-1&&(S=S.substring(0,O)),f&&(S=`${S}~${f}`),{id:S}}D.modify=b;function s(u){const f=u.id.lastIndexOf("~");if(f!==-1)return u.id.substring(f+1)}D.getModifier=s;function h(u,f){return u.id===f.id&&u.color?.id===f.color?.id}D.isEqual=h})(C||(e.ThemeIcon=C={}))}),define(pe[148],ve([1,0,146,17,97]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const C="$(",D=new RegExp(`\\$\\(${o.ThemeIcon.iconNameExpression}(?:${o.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${D.source}`,"g");function v(h){return h.replace(A,(u,f)=>f?u:`\\${u}`)}e.escapeIcons=v;const d=new RegExp(`\\\\${D.source}`,"g");function R(h){return h.replace(d,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=R;const y=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function E(h){return h.indexOf(C)===-1?h:h.replace(y,(u,f,S,O)=>S?u:f||O||"")}e.stripIcons=E;function m(h){return h?h.replace(/\$\((.*?)\)/g,(u,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=m;const g=new RegExp(`\\$\\(${o.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(h){g.lastIndex=0;let u="";const f=[];let S=0;for(;;){const O=g.lastIndex,t=g.exec(h),n=h.substring(O,t?.index);if(n.length>0){u+=n;for(let r=0;r<n.length;r++)f.push(S)}if(!t)break;S+=t[0].length}return{text:u,iconOffsets:f}}e.parseLabelWithIcons=b;function s(h,u,f=!1){const{text:S,iconOffsets:O}=u;if(!O||O.length===0)return(0,w.matchesFuzzy)(h,S,f);const t=(0,L.ltrim)(S," "),n=S.length-t.length,r=(0,w.matchesFuzzy)(h,t,f);if(r)for(const i of r){const a=O[i.start+n]+n;i.start+=a,i.end+=a}return r}e.matchesFuzzyIconAware=s}),define(pe[4],ve([1,0,7,3]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const o=/^\w[\w\d+.-]*$/,C=/^\//,D=/^\/\//;function A(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!o.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(r,i){return!r&&!i?"file":r}function d(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const R="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,l,c,p,P=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=v(i,P),this.authority=a||R,this.path=d(this.scheme,l||R),this.query=c||R,this.fragment=p||R,A(this,P))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:l,path:c,query:p,fragment:P}=i;return a===void 0?a=this.scheme:a===null&&(a=R),l===void 0?l=this.authority:l===null&&(l=R),c===void 0?c=this.path:c===null&&(c=R),p===void 0?p=this.query:p===null&&(p=R),P===void 0?P=this.fragment:P===null&&(P=R),a===this.scheme&&l===this.authority&&c===this.path&&p===this.query&&P===this.fragment?this:new b(a,l,c,p,P)}static parse(i,a=!1){const l=E.exec(i);return l?new b(l[2]||R,n(l[4]||R),n(l[5]||R),n(l[7]||R),n(l[9]||R),a):new b(R,R,R,R,R)}static file(i){let a=R;if(L.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const l=i.indexOf(y,2);l===-1?(a=i.substring(2),i=y):(a=i.substring(2,l),i=i.substring(l)||y)}return new b("file",a,i,R,R)}static from(i){const a=new b(i.scheme,i.authority,i.path,i.query,i.fragment);return A(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&i.scheme==="file"?l=m.file(w.win32.join(f(i,!0),...a)).path:l=w.posix.join(i.path,...a),i.with({path:l})}toString(i=!1){return S(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const a=new b(i);return a._formatted=i.external,a._fsPath=i._sep===g?i.fsPath:null,a}}else return i}}e.URI=m;const g=L.isWindows?1:void 0;class b extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=g),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(r,i,a){let l,c=-1;for(let p=0;p<r.length;p++){const P=r.charCodeAt(p);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||i&&P===47||a&&P===91||a&&P===93||a&&P===58)c!==-1&&(l+=encodeURIComponent(r.substring(c,p)),c=-1),l!==void 0&&(l+=r.charAt(p));else{l===void 0&&(l=r.substr(0,p));const T=s[P];T!==void 0?(c!==-1&&(l+=encodeURIComponent(r.substring(c,p)),c=-1),l+=T):c===-1&&(c=p)}}return c!==-1&&(l+=encodeURIComponent(r.substring(c))),l!==void 0?l:r}function u(r){let i;for(let a=0;a<r.length;a++){const l=r.charCodeAt(a);l===35||l===63?(i===void 0&&(i=r.substr(0,a)),i+=s[l]):i!==void 0&&(i+=r[a])}return i!==void 0?i:r}function f(r,i){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function S(r,i){const a=i?u:h;let l="",{scheme:c,authority:p,path:P,query:T,fragment:I}=r;if(c&&(l+=c,l+=":"),(p||c==="file")&&(l+=y,l+=y),p){let F=p.indexOf("@");if(F!==-1){const H=p.substr(0,F);p=p.substr(F+1),F=H.lastIndexOf(":"),F===-1?l+=a(H,!1,!1):(l+=a(H.substr(0,F),!1,!1),l+=":",l+=a(H.substr(F+1),!1,!0)),l+="@"}p=p.toLowerCase(),F=p.lastIndexOf(":"),F===-1?l+=a(p,!1,!0):(l+=a(p.substr(0,F),!1,!0),l+=p.substr(F))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const F=P.charCodeAt(1);F>=65&&F<=90&&(P=`/${String.fromCharCode(F+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const F=P.charCodeAt(0);F>=65&&F<=90&&(P=`${String.fromCharCode(F+32)}:${P.substr(2)}`)}l+=a(P,!0,!1)}return T&&(l+="?",l+=a(T,!1,!1)),I&&(l+="#",l+=i?I:h(I,!1,!1)),l}function O(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+O(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,i=>O(i)):r}}),define(pe[149],ve([1,0,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(d){const R=d;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=L;function o(d){const R=[];let y;try{const E=JSON.parse(d.arguments),m=E[E.length-1];m&&m.__$stack&&(E.pop(),y=m.__$stack),R.push(...E)}catch{R.push("Unable to log remote console arguments",d.arguments)}return{args:R,stack:y}}e.parse=o;function C(d){if(typeof d!="string")return C(o(d).stack);const R=d;if(R){const y=D(R),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:w.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=C;function D(d){if(!d)return d;const R=d.indexOf(`
`);return R===-1?d:d.substring(0,R)}function A(d,R){const{args:y,stack:E}=o(d),m=typeof y[0]=="string"&&y.length===1;let g=D(E);g&&(g=`(${g.trim()})`);let b=[];if(typeof y[0]=="string"?g&&m?b=[`%c[${R}] %c${y[0]} %c${g}`,v("blue"),v(""),v("grey")]:b=[`%c[${R}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:b=[`%c[${R}]%`,v("blue"),...y],g&&!m&&b.push(g),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,b)}e.log=A;function v(d){return`color: ${d}`}}),define(pe[61],ve([1,0,15,17,4]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(d){return JSON.stringify(d,A)}e.stringify=C;function D(d){let R=JSON.parse(d);return R=v(R),R}e.parse=D;function A(d,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,L.regExpFlags)(R)}:R}function v(d,R=0){if(!d||R>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return o.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof w.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let y=0;y<d.length;++y)d[y]=v(d[y],R+1);else for(const y in d)Object.hasOwnProperty.call(d,y)&&(d[y]=v(d[y],R+1))}return d}e.revive=v}),define(pe[13],ve([1,0,9,3,4]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeInteractiveSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(C||(e.Schemas=C={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${C.vscodeRemoteResource}`}set(R,y,E){this.a[R]=y,this.b[R]=E}setConnectionToken(R,y){this.c[R]=y}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(s){return w.onUnexpectedError(s),R}const y=R.authority;let E=this.a[y];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const m=this.b[y],g=this.c[y];let b=`path=${encodeURIComponent(R.path)}`;return typeof g=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),o.URI.from({scheme:L.isWeb?this.d:C.vscodeRemoteResource,authority:`${E}:${m}`,path:L.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:b})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(R){const y=this.b(R,oe);return this.uriToBrowserUri(y)}uriToBrowserUri(R){return R.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===C.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${C.vscodeFileResource}://${A.a}`)?R.with({scheme:C.vscodeFileResource,authority:R.authority||A.a,query:null,fragment:null}):R}asFileUri(R){const y=this.b(R,oe);return this.uriToFileUri(y)}uriToFileUri(R){return R.scheme===C.vscodeFileResource?R.with({scheme:C.file,authority:R.authority!==A.a?R.authority:null,query:null,fragment:null}):R}b(R,y){return o.URI.isUri(R)?R:o.URI.parse(y.toUrl(R))}}A.a="vscode-app",e.FileAccess=new A;var v;(function(d){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(R.get("3"));const y="vscode-coi";function E(g){let b;typeof g=="string"?b=new URL(g).searchParams:g instanceof URL?b=g.searchParams:o.URI.isUri(g)&&(b=new URL(g.toString(!0)).searchParams);const s=b?.get(y);if(s)return R.get(s)}d.getHeadersFromQuery=E;function m(g,b,s){if(!globalThis.crossOriginIsolated)return;const h=b&&s?"3":s?"2":"1";g instanceof URLSearchParams?g.set(y,h):g[y]=h}d.addSearchParam=m})(v||(e.COI=v={}))}),define(pe[19],ve([1,0,38,13,7,3,17,4]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=v;class d{constructor(g){this.a=g}compare(g,b,s=!1){return g===b?0:(0,D.compare)(this.getComparisonKey(g,s),this.getComparisonKey(b,s))}isEqual(g,b,s=!1){return g===b?!0:!g||!b?!1:this.getComparisonKey(g,s)===this.getComparisonKey(b,s)}getComparisonKey(g,b=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,b,s=!1){if(g.scheme===b.scheme){if(g.scheme===L.Schemas.file)return w.isEqualOrParent(v(g),v(b),this.a(g))&&g.query===b.query&&(s||g.fragment===b.fragment);if((0,e.isEqualAuthority)(g.authority,b.authority))return w.isEqualOrParent(g.path,b.path,this.a(g),"/")&&g.query===b.query&&(s||g.fragment===b.fragment)}return!1}joinPath(g,...b){return A.URI.joinPath(g,...b)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return o.posix.basename(g.path)}extname(g){return o.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let b;return g.scheme===L.Schemas.file?b=A.URI.file(o.dirname(v(g))).path:(b=o.posix.dirname(g.path),g.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),b="/")),g.with({path:b})}normalizePath(g){if(!g.path.length)return g;let b;return g.scheme===L.Schemas.file?b=A.URI.file(o.normalize(v(g))).path:b=o.posix.normalize(g.path),g.with({path:b})}relativePath(g,b){if(g.scheme!==b.scheme||!(0,e.isEqualAuthority)(g.authority,b.authority))return;if(g.scheme===L.Schemas.file){const u=o.relative(v(g),v(b));return C.isWindows?w.toSlashes(u):u}let s=g.path||"/";const h=b.path||"/";if(this.a(g)){let u=0;for(const f=Math.min(s.length,h.length);u<f&&!(s.charCodeAt(u)!==h.charCodeAt(u)&&s.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);s=h.substr(0,u)+s.substr(u)}return o.posix.relative(s,h)}resolvePath(g,b){if(g.scheme===L.Schemas.file){const s=A.URI.file(o.resolve(v(g),b));return g.with({authority:s.authority,path:s.path})}return b=w.toPosixPath(b),g.with({path:o.posix.resolve(g.path,b)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,b){return g===b||g!==void 0&&b!==void 0&&(0,D.equalsIgnoreCase)(g,b)}hasTrailingPathSeparator(g,b=o.sep){if(g.scheme===L.Schemas.file){const s=v(g);return s.length>w.getRoot(s).length&&s[s.length-1]===b}else{const s=g.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,b=o.sep){return(0,e.hasTrailingPathSeparator)(g,b)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,b=o.sep){let s=!1;if(g.scheme===L.Schemas.file){const h=v(g);s=h!==void 0&&h.length===w.getRoot(h).length&&h[h.length-1]===b}else{b="/";const h=g.path;s=h.length===1&&h.charCodeAt(h.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(g,b)?g.with({path:g.path+"/"}):g}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(m=>m.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new d(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(m,g){const b=[];for(let s=0;s<m.length;s++){const h=g(m[s]);m.some((u,f)=>f===s?!1:(0,e.isEqualOrParent)(h,g(u)))||b.push(m[s])}return b}e.distinctParents=R;var y;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function g(b){const s=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[S,O]=f.split(":");S&&O&&s.set(S,O)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&s.set(m.META_DATA_MIME,u),s}m.parseMetaData=g})(y||(e.DataUri=y={}));function E(m,g,b){if(g){let s=m.path;return s&&s[0]!==o.posix.sep&&(s=o.posix.sep+s),m.with({scheme:b,authority:g,path:s})}return m.with({scheme:b})}e.toLocalResource=E}),define(pe[14],ve([1,0,20,9,6,2,19,3,147]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(V){return!!V&&typeof V.then=="function"}e.isThenable=d;function R(V){const N=new w.CancellationTokenSource,k=V(N.token),U=new Promise((X,ne)=>{const z=N.token.onCancellationRequested(()=>{z.dispose(),N.dispose(),ne(new L.CancellationError)});Promise.resolve(k).then(j=>{z.dispose(),N.dispose(),X(j)},j=>{z.dispose(),N.dispose(),ne(j)})});return new class{cancel(){N.cancel()}then(X,ne){return U.then(X,ne)}catch(X){return this.then(void 0,X)}finally(X){return U.finally(X)}}}e.createCancelablePromise=R;function y(V,N,k){return new Promise((U,X)=>{const ne=N.onCancellationRequested(()=>{ne.dispose(),U(k)});V.then(U,X).finally(()=>ne.dispose())})}e.raceCancellation=y;function E(V,N){return new Promise((k,U)=>{const X=N.onCancellationRequested(()=>{X.dispose(),U(new L.CancellationError)});V.then(k,U).finally(()=>X.dispose())})}e.raceCancellationError=E;async function m(V){let N=-1;const k=V.map((U,X)=>U.then(ne=>(N=X,ne)));try{return await Promise.race(k)}finally{V.forEach((U,X)=>{X!==N&&U.cancel()})}}e.raceCancellablePromises=m;function g(V,N,k){let U;const X=setTimeout(()=>{U?.(void 0),k?.()},N);return Promise.race([V.finally(()=>clearTimeout(X)),new Promise(ne=>U=ne)])}e.raceTimeout=g;function b(V){return new Promise((N,k)=>{const U=V();d(U)?U.then(N,k):N(U)})}e.asPromise=b;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const k=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(k,k).then(U)})}return new Promise((k,U)=>{this.b.then(k,U)})}return this.a=N(),new Promise((k,U)=>{this.a.then(X=>{this.a=null,k(X)},X=>{this.a=null,U(X)})})}}e.Throttler=s;class h{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=h;class u{constructor(){this.a=new Map}queue(N,k){const X=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.a.get(N)===X&&this.a.delete(N)});return this.a.set(N,X),X}}e.SequencerByKey=u;const f=(V,N)=>{let k=!0;const U=setTimeout(()=>{k=!1,N()},V);return{isTriggered:()=>k,dispose:()=>{clearTimeout(U),k=!1}}},S=V=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,V())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class O{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,k=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((X,ne)=>{this.d=X,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const X=this.g;return this.g=null,X()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=k===v.MicrotaskDelay?S(U):f(k,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=O;class t{constructor(N){this.a=new O(N),this.b=new s}trigger(N,k){return this.a.trigger(()=>this.b.queue(N),k)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this.a=!1,this.b=new Promise((N,k)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function i(V,N){return N?new Promise((k,U)=>{const X=setTimeout(()=>{ne.dispose(),k()},V),ne=N.onCancellationRequested(()=>{clearTimeout(X),ne.dispose(),U(new L.CancellationError)})}):R(k=>i(V,k))}e.timeout=i;function a(V,N=0){const k=setTimeout(V,N);return(0,C.toDisposable)(()=>clearTimeout(k))}e.disposableTimeout=a;function l(V){const N=[];let k=0;const U=V.length;function X(){return k<U?V[k++]():null}function ne(z){z!=null&&N.push(z);const j=X();return j?j.then(ne):Promise.resolve(N)}return Promise.resolve(null).then(ne)}e.sequence=l;function c(V,N=U=>!!U,k=null){let U=0;const X=V.length,ne=()=>{if(U>=X)return Promise.resolve(k);const z=V[U++];return Promise.resolve(z()).then(Y=>N(Y)?Promise.resolve(Y):ne())};return ne()}e.first=c;function p(V,N=U=>!!U,k=null){if(V.length===0)return Promise.resolve(k);let U=V.length;const X=()=>{U=-1;for(const ne of V)ne.cancel?.()};return new Promise((ne,z)=>{for(const j of V)j.then(Y=>{--U>=0&&N(Y)?(X(),ne(Y)):U===0&&ne(k)}).catch(Y=>{--U>=0&&(X(),z(Y))})})}e.firstParallel=p;class P{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new o.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((k,U)=>{this.f.push({factory:N,c:k,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const k=N.factory();k.then(N.c,N.e),k.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=P;class T extends P{constructor(){super(1)}}e.Queue=T;class I{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new K;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,k=D.extUri){const U=k.getComparisonKey(N);let X=this.a.get(U);return X||(X=new T,o.Event.once(X.onDrained)(()=>{X?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,X)),X}f(){this.d()&&this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=I;class F{constructor(N,k){this.a=-1,typeof N=="function"&&typeof k=="number"&&this.setIfNotSet(N,k)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,k){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},k)}setIfNotSet(N,k){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},k))}}e.TimeoutTimer=F;class H{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,k){this.cancel(),this.a=setInterval(()=>{N()},k)}}e.IntervalTimer=H;class ee{constructor(N,k){this.b=-1,this.a=N,this.d=k,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ee;class ce{constructor(N,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.a=N,this.b=k,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ce;class ae extends ee{constructor(N,k){super(N,k),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ae;class ue extends C.Disposable{constructor(N,k){super(),this.g=N,this.h=k,this.a=[],this.b=this.B(new C.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const k of N)this.a.push(k);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,A.setTimeout0)(()=>{if(N)return;const k=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(V,N)=>{const k=requestIdleCallback(V,typeof N=="number"?{timeout:N}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(k))}}}}();class ge{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(k){this.g=k}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ge;async function G(V,N,k){let U;for(let X=0;X<k;X++)try{return await V()}catch(ne){U=ne,await i(N)}throw U}e.retry=G;class te{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,k,U){return this.a={taskId:N,cancel:()=>U?.(),promise:k},k.then(()=>this.d(N),()=>this.d(N)),k}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let k,U;const X=new Promise((ne,z)=>{k=ne,U=z});this.b={run:N,promise:X,promiseResolve:k,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=te;class W{constructor(N,k=()=>Date.now()){this.d=N,this.f=k,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=W;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,k)=>{this.a=N,this.b=k})}complete(N){return new Promise(k=>{this.a(N),this.f=!0,k()})}error(N){return new Promise(k=>{this.b(N),this.d=!0,k()})}cancel(){new Promise(N=>{this.b(new L.CancellationError),this.d=!0,N()})}}e.DeferredPromise=K;var q;(function(V){async function N(U){let X;const ne=await Promise.all(U.map(z=>z.then(j=>j,j=>{X||(X=j)})));if(typeof X<"u")throw X;return ne}V.settled=N;function k(U){return new Promise(async(X,ne)=>{try{await U(X,ne)}catch(z){ne(z)}})}V.withAsyncBody=k})(q||(e.Promises=q={}));var ie;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(ie||(ie={}));class re{static fromArray(N){return new re(k=>{k.emitMany(N)})}static fromPromise(N){return new re(async k=>{k.emitMany(await N)})}static fromPromises(N){return new re(async k=>{await Promise.all(N.map(async U=>k.emitOne(await U)))})}static merge(N){return new re(async k=>{await Promise.all(N.map(async U=>{for await(const X of U)k.emitOne(X)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new o.Emitter,queueMicrotask(async()=>{const k={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(N(k)),this.j()}catch(U){this.k(U)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await o.Event.toPromise(this.f.event)}while(!0)}}}static map(N,k){return new re(async U=>{for await(const X of N)U.emitOne(k(X))})}map(N){return re.map(this,N)}static filter(N,k){return new re(async U=>{for await(const X of N)k(X)&&U.emitOne(X)})}filter(N){return re.filter(this,N)}static coalesce(N){return re.filter(N,k=>!!k)}coalesce(){return re.coalesce(this)}static async toPromise(N){const k=[];for await(const U of N)k.push(U);return k}toPromise(){return re.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class de extends re{constructor(N,k){super(k),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function $(V){const N=new w.CancellationTokenSource,k=V(N.token);return new de(N,async U=>{const X=N.token.onCancellationRequested(()=>{X.dispose(),N.dispose(),U.reject(new L.CancellationError)});try{for await(const ne of k){if(N.token.isCancellationRequested)return;U.emitOne(ne)}X.dispose(),N.dispose()}catch(ne){X.dispose(),N.dispose(),U.reject(ne)}})}e.createCancelableAsyncIterable=$}),define(pe[74],ve([1,0,18,14,38,28,7,3,17]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",y="[^/\\\\]",E=/\//g;function m(W,K){switch(W){case 0:return"";case 1:return`${y}*?`;default:return`(?:${R}|${y}+${R}${K?`|${R}${y}+`:""})*?`}}function g(W,K){if(!W)return[];const q=[];let ie=!1,re=!1,de="";for(const $ of W){switch($){case K:if(!ie&&!re){q.push(de),de="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}de+=$}return de&&q.push(de),q}e.splitGlobAware=g;function b(W){if(!W)return"";let K="";const q=g(W,e.GLOB_SPLIT);if(q.every(ie=>ie===e.GLOBSTAR))K=".*";else{let ie=!1;q.forEach((re,de)=>{if(re===e.GLOBSTAR){if(ie)return;K+=m(2,de===q.length-1)}else{let $=!1,V="",N=!1,k="";for(const U of re){if(U!=="}"&&$){V+=U;continue}if(N&&(U!=="]"||!k)){let X;U==="-"?X=U:(U==="^"||U==="!")&&!k?X="^":U===e.GLOB_SPLIT?X="":X=(0,v.escapeRegExpCharacters)(U),k+=X;continue}switch(U){case"{":$=!0;continue;case"[":N=!0;continue;case"}":{const ne=`(?:${g(V,",").map(z=>b(z)).join("|")})`;K+=ne,$=!1,V="";break}case"]":{K+="["+k+"]",N=!1,k="";break}case"?":K+=y;continue;case"*":K+=m(1);continue;default:K+=(0,v.escapeRegExpCharacters)(U)}}de<q.length-1&&(q[de+1]!==e.GLOBSTAR||de+2<q.length)&&(K+=R)}ie=re===e.GLOBSTAR})}return K}const s=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,O=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),n=function(){return!1},r=function(){return null};function i(W,K){if(!W)return r;let q;typeof W!="string"?q=W.pattern:q=W,q=q.trim();const ie=`${q}_${!!K.trimForExclusions}`;let re=t.get(ie);if(re)return a(re,W);let de;return s.test(q)?re=c(q.substr(4),q):(de=h.exec(l(q,K)))?re=p(de[1],q):(K.trimForExclusions?f:u).test(q)?re=P(q,K):(de=S.exec(l(q,K)))?re=T(de[1].substr(1),q,!0):(de=O.exec(l(q,K)))?re=T(de[1],q,!1):re=I(q),t.set(ie,re),a(re,W)}function a(W,K){if(typeof K=="string")return W;const q=function(ie,re){return(0,o.isEqualOrParent)(ie,K.base,!A.isLinux)?W((0,v.ltrim)(ie.substr(K.base.length),D.sep),re):null};return q.allBasenames=W.allBasenames,q.allPaths=W.allPaths,q.basenames=W.basenames,q.patterns=W.patterns,q}function l(W,K){return K.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function c(W,K){return function(q,ie){return typeof q=="string"&&q.endsWith(W)?K:null}}function p(W,K){const q=`/${W}`,ie=`\\${W}`,re=function($,V){return typeof $!="string"?null:V?V===W?K:null:$===W||$.endsWith(q)||$.endsWith(ie)?K:null},de=[W];return re.basenames=de,re.patterns=[K],re.allBasenames=de,re}function P(W,K){const q=G(W.slice(1,-1).split(",").map(V=>i(V,K)).filter(V=>V!==r),W),ie=q.length;if(!ie)return r;if(ie===1)return q[0];const re=function(V,N){for(let k=0,U=q.length;k<U;k++)if(q[k](V,N))return W;return null},de=q.find(V=>!!V.allBasenames);de&&(re.allBasenames=de.allBasenames);const $=q.reduce((V,N)=>N.allPaths?V.concat(N.allPaths):V,[]);return $.length&&(re.allPaths=$),re}function T(W,K,q){const ie=D.sep===D.posix.sep,re=ie?W:W.replace(E,D.sep),de=D.sep+re,$=D.posix.sep+W;let V;return q?V=function(N,k){return typeof N=="string"&&(N===re||N.endsWith(de)||!ie&&(N===W||N.endsWith($)))?K:null}:V=function(N,k){return typeof N=="string"&&(N===re||!ie&&N===W)?K:null},V.allPaths=[(q?"*/":"./")+W],V}function I(W){try{const K=new RegExp(`^${b(W)}$`);return function(q){return K.lastIndex=0,typeof q=="string"&&K.test(q)?W:null}}catch{return r}}function F(W,K,q){return!W||typeof K!="string"?!1:H(W)(K,void 0,q)}e.match=F;function H(W,K={}){if(!W)return n;if(typeof W=="string"||ee(W)){const q=i(W,K);if(q===r)return n;const ie=function(re,de){return!!q(re,de)};return q.allBasenames&&(ie.allBasenames=q.allBasenames),q.allPaths&&(ie.allPaths=q.allPaths),ie}return ue(W,K)}e.parse=H;function ee(W){const K=W;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=ee;function ce(W){return W.allBasenames||[]}e.getBasenameTerms=ce;function ae(W){return W.allPaths||[]}e.getPathTerms=ae;function ue(W,K){const q=G(Object.getOwnPropertyNames(W).map(V=>ge(V,W[V],K)).filter(V=>V!==r)),ie=q.length;if(!ie)return r;if(!q.some(V=>!!V.requiresSiblings)){if(ie===1)return q[0];const V=function(U,X){let ne;for(let z=0,j=q.length;z<j;z++){const Y=q[z](U,X);if(typeof Y=="string")return Y;(0,L.isThenable)(Y)&&(ne||(ne=[]),ne.push(Y))}return ne?(async()=>{for(const z of ne){const j=await z;if(typeof j=="string")return j}return null})():null},N=q.find(U=>!!U.allBasenames);N&&(V.allBasenames=N.allBasenames);const k=q.reduce((U,X)=>X.allPaths?U.concat(X.allPaths):U,[]);return k.length&&(V.allPaths=k),V}const re=function(V,N,k){let U,X;for(let ne=0,z=q.length;ne<z;ne++){const j=q[ne];j.requiresSiblings&&k&&(N||(N=(0,D.basename)(V)),U||(U=N.substr(0,N.length-(0,D.extname)(V).length)));const Y=j(V,N,U,k);if(typeof Y=="string")return Y;(0,L.isThenable)(Y)&&(X||(X=[]),X.push(Y))}return X?(async()=>{for(const ne of X){const z=await ne;if(typeof z=="string")return z}return null})():null},de=q.find(V=>!!V.allBasenames);de&&(re.allBasenames=de.allBasenames);const $=q.reduce((V,N)=>N.allPaths?V.concat(N.allPaths):V,[]);return $.length&&(re.allPaths=$),re}function ge(W,K,q){if(K===!1)return r;const ie=i(W,q);if(ie===r)return r;if(typeof K=="boolean")return ie;if(K){const re=K.when;if(typeof re=="string"){const de=($,V,N,k)=>{if(!k||!ie($,V))return null;const U=re.replace("$(basename)",()=>N),X=k(U);return(0,L.isThenable)(X)?X.then(ne=>ne?W:null):X?W:null};return de.requiresSiblings=!0,de}}return ie}function G(W,K){const q=W.filter(V=>!!V.basenames);if(q.length<2)return W;const ie=q.reduce((V,N)=>{const k=N.basenames;return k?V.concat(k):V},[]);let re;if(K){re=[];for(let V=0,N=ie.length;V<N;V++)re.push(K)}else re=q.reduce((V,N)=>{const k=N.patterns;return k?V.concat(k):V},[]);const de=function(V,N){if(typeof V!="string")return null;if(!N){let U;for(U=V.length;U>0;U--){const X=V.charCodeAt(U-1);if(X===47||X===92)break}N=V.substr(U)}const k=ie.indexOf(N);return k!==-1?re[k]:null};de.basenames=ie,de.patterns=re,de.allBasenames=ie;const $=W.filter(V=>!V.basenames);return $.push(de),$}function te(W,K){return(0,w.equals)(W,K,(q,ie)=>typeof q=="string"&&typeof ie=="string"?q===ie:typeof q!="string"&&typeof ie!="string"?q.base===ie.base&&q.pattern===ie.pattern:!1)}e.patternsEquals=te}),define(pe[98],ve([1,0,9,148,19,17,4]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class v{constructor(h="",u=!1){if(this.value=h,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(h,u=0){return this.value+=E(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(f,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,u){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(h,u,f){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(h),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(h,u){const f=new RegExp((0,C.escapeRegExpCharacters)(u),"g");return h.replace(f,(S,O)=>h.charAt(O-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=v;function d(s){return R(s)?!s.value:Array.isArray(s)?s.every(d):!0}e.isEmptyMarkdownString=d;function R(s){return s instanceof v?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function y(s,h){return s===h?!0:!s||!h?!1:s.value===h.value&&s.isTrusted===h.isTrusted&&s.supportThemeIcons===h.supportThemeIcons&&s.supportHtml===h.supportHtml&&(s.baseUri===h.baseUri||!!s.baseUri&&!!h.baseUri&&(0,o.isEqual)(D.URI.from(s.baseUri),D.URI.from(h.baseUri)))}e.markdownStringEqual=y;function E(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function m(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=m;function g(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function b(s){const h=[],u=s.split("|").map(S=>S.trim());s=u[0];const f=u[1];if(f){const S=/height=(\d+)/.exec(f),O=/width=(\d+)/.exec(f),t=S?S[1]:"",n=O?O[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&h.push(`width="${n}"`),i&&h.push(`height="${t}"`)}return{href:s,dimensions:h}}e.parseHrefAndDimensions=b}),define(pe[150],ve([1,0,18,38,7,3,19,17]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function v(r,i){const{os:a,tildify:l,relative:c}=i;if(c){const T=d(r,c,a);if(typeof T=="string")return T}let p=r.fsPath;if(a===1&&!C.isWindows?p=p.replace(/\//g,"\\"):a!==1&&C.isWindows&&(p=p.replace(/\\/g,"/")),a!==1&&l?.userHome){const T=l.userHome.fsPath;let I;r.scheme!==l.userHome.scheme&&r.path.startsWith(o.posix.sep)?I=l.userHome.with({path:r.path}).fsPath:I=r.fsPath,p=E(I,T,a)}return(a===1?o.win32:o.posix).normalize(R(p,a===1))}e.getPathLabel=v;function d(r,i,a){const l=a===1?o.win32:o.posix,c=a===3?D.extUri:D.extUriIgnorePathCase,p=i.getWorkspace(),P=(0,w.firstOrDefault)(p.folders);if(!P)return;r.scheme!==P.uri.scheme&&r.path.startsWith(o.posix.sep)&&(r=P.uri.with({path:r.path}));const T=i.getWorkspaceFolder(r);if(!T)return;let I;if(c.isEqual(T.uri,r)?I="":I=c.relativePath(T.uri,r)??"",I&&(I=l.normalize(I)),p.folders.length>1&&!i.noPrefix){const F=T.name?T.name:c.basenameOrAuthority(T.uri);I=I?`${F} \u2022 ${I}`:F}return I}function R(r,i=C.isWindows){return(0,L.hasDriveLetter)(r,i)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let y=Object.create(null);function E(r,i,a=C.OS){if(a===1||!r||!i)return r;let l=y.original===i?y.normalized:void 0;l||(l=i,C.isWindows&&(l=(0,L.toSlashes)(l)),l=`${(0,A.rtrim)(l,o.posix.sep)}${o.posix.sep}`,y={original:i,normalized:l});let c=r;return C.isWindows&&(c=(0,L.toSlashes)(c)),(a===3?c.startsWith(l):(0,A.startsWithIgnoreCase)(c,l))?`~/${c.substr(l.length)}`:r}e.tildify=E;function m(r,i){return r.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=m;const g="\u2026",b="\\\\",s="~";function h(r,i=o.sep){const a=new Array(r.length);let l=!1;for(let c=0;c<r.length;c++){const p=r[c];if(p===""){a[c]=`.${i}`;continue}if(!p){a[c]=p;continue}l=!0;let P="",T=p;T.indexOf(b)===0?(P=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(i)===0?(P=T.substr(0,T.indexOf(i)+i.length),T=T.substr(T.indexOf(i)+i.length)):T.indexOf(s)===0&&(P=T.substr(0,T.indexOf(s)+s.length),T=T.substr(T.indexOf(s)+s.length));const I=T.split(i);for(let F=1;l&&F<=I.length;F++)for(let H=I.length-F;l&&H>=0;H--){l=!1;let ee=I.slice(H,H+F).join(i);for(let ce=0;!l&&ce<r.length;ce++)if(ce!==c&&r[ce]&&r[ce].indexOf(ee)>-1){const ae=H+F===I.length,ue=H>0&&r[ce].indexOf(i)>-1?i+ee:ee,ge=r[ce].endsWith(ue);l=!ae||ge}if(!l){let ce="";(I[0].endsWith(":")||P!=="")&&(H===1&&(H=0,F++,ee=I[0]+i+ee),H>0&&(ce=I[0]+i),ce=P+ce),H>0&&(ce=ce+g+i),ce=ce+ee,H+F<I.length&&(ce=ce+i+g),a[c]=ce}}l&&(a[c]=p)}return a}e.shorten=h;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function f(r,i=Object.create(null)){const a=[];let l=!1,c="";for(const p of r)if(p==="$"||l&&p==="{")c&&a.push({value:c,type:u.TEXT}),c="",l=!0;else if(p==="}"&&l){const P=i[c];if(typeof P=="string")P.length&&a.push({value:P,type:u.VARIABLE});else if(P){const T=a[a.length-1];(!T||T.type!==u.SEPARATOR)&&a.push({value:P.label,type:u.SEPARATOR})}c="",l=!1}else c+=p;return c&&!l&&a.push({value:c,type:u.TEXT}),a.filter((p,P)=>{if(p.type===u.SEPARATOR){const T=a[P-1],I=a[P+1];return[T,I].every(F=>F&&(F.type===u.VARIABLE||F.type===u.TEXT)&&F.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=f;function S(r,i){return C.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function O(r,i){return C.isMacintosh||i?r.replace(/\(&&\w\)|&&/g,""):C.isWindows?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=O;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(r){const i=r.indexOf("/")!==-1?o.posix:o.win32,a=i.basename(r),l=i.dirname(r);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=n}),define(pe[49],ve([1,0,15,4]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function o(y){return y.toJSON()}class C{constructor(E){this.a=E}transformIncoming(E){const m=this.a.transformIncoming(E);return m===E?E:o(L.URI.from(m))}transformOutgoing(E){const m=this.a.transformOutgoing(E);return m===E?E:o(L.URI.from(m))}transformOutgoingURI(E){const m=this.a.transformOutgoing(E);return m===E?E:L.URI.from(m)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function D(y,E,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof L.URI)return E.transformOutgoing(y);for(const g in y)if(Object.hasOwnProperty.call(y,g)){const b=D(y[g],E,m+1);b!==null&&(y[g]=b)}}return null}function A(y,E){const m=D(y,E,0);return m===null?y:m}e.transformOutgoingURIs=A;function v(y,E,m,g){if(!y||g>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?L.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);if(y instanceof w.VSBuffer)return null;for(const b in y)if(Object.hasOwnProperty.call(y,b)){const s=v(y[b],E,m,g+1);s!==null&&(y[b]=s)}}return null}function d(y,E){const m=v(y,E,!1,0);return m===null?y:m}e.transformIncomingURIs=d;function R(y,E){const m=v(y,E,!0,0);return m===null?y:m}e.transformAndReviveIncomingURIs=R}),define(pe[21],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(o){return w.test(o)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let o;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?o=crypto.getRandomValues.bind(crypto):o=function(A){for(let v=0;v<A.length;v++)A[v]=Math.floor(Math.random()*256);return A};const C=new Uint8Array(16),D=[];for(let A=0;A<256;A++)D.push(A.toString(16).padStart(2,"0"));return function(){o(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let v=0,d="";return d+=D[C[v++]],d+=D[C[v++]],d+=D[C[v++]],d+=D[C[v++]],d+="-",d+=D[C[v++]],d+=D[C[v++]],d+="-",d+=D[C[v++]],d+=D[C[v++]],d+="-",d+=D[C[v++]],d+=D[C[v++]],d+="-",d+=D[C[v++]],d+=D[C[v++]],d+=D[C[v++]],d+=D[C[v++]],d+=D[C[v++]],d+=D[C[v++]],d}}()}),define(pe[151],ve([1,0,18,46,21]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function C(v){return{id:(0,o.generateUuid)(),asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}e.createStringDataTransferItem=C;function D(v,d,R){return{id:(0,o.generateUuid)(),asString:async()=>"",asFile:()=>({name:v,uri:d,data:R}),value:void 0}}e.createFileDataTransferItem=D;class A{constructor(){this.a=new Map}get size(){let d=0;return this.forEach(()=>d++),d}has(d){return this.a.has(this.b(d))}matches(d){if(this.has(d))return!0;if(d.toLowerCase()==="files")return L.Iterable.some(this.values(),g=>g.asFile());if(d==="*/*")return this.a.size>0;const R=this.b(d).match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!R)return!1;const[y,E,m]=R;return m==="*"?L.Iterable.some(this.a.keys(),g=>g.startsWith(E+"/")):!1}get(d){return this.a.get(this.b(d))?.[0]}append(d,R){const y=this.a.get(d);y?y.push(R):this.a.set(this.b(d),[R])}replace(d,R){this.a.set(this.b(d),[R])}delete(d){this.a.delete(this.b(d))}*entries(){for(const[d,R]of this.a.entries())for(const y of R)yield[d,y]}values(){return Array.from(this.a.values()).flat()}forEach(d){for(const[R,y]of this.entries())d(y,R)}b(d){return d.toLowerCase()}}e.VSDataTransfer=A,e.UriList=Object.freeze({create:v=>(0,w.distinct)(v.map(d=>d.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.UriList.split(v).filter(d=>!d.startsWith("#"))})}),function(){"use strict";function oe(e,w,L){function o(m){return new Promise(g=>w.exists(m,g))}function C(m){return new Promise((g,b)=>{const s=new Date;w.utimes(m,s,s,h=>h?b(h):g())})}function D(m){return new Promise((g,b)=>w.mkdir(m,{recursive:!0},s=>s&&s.code!=="EEXIST"?b(s):g(m)))}function A(m){return new Promise((g,b)=>w.rm(m,{recursive:!0,force:!0,maxRetries:3},s=>s?b(s):g()))}function v(m){return new Promise((g,b)=>w.readFile(m,"utf8",(s,h)=>s?b(s):g(h)))}function d(m,g){return new Promise((b,s)=>w.writeFile(m,g,"utf8",h=>h?s(h):b()))}async function R(m){const g=e.join(m,"languagepacks.json");try{return JSON.parse(await v(g))}catch{}}function y(m,g){try{for(;g;){if(m[g])return g;{const b=g.lastIndexOf("-");if(b>0)g=g.substring(0,b);else return}}}catch(b){console.error("Resolving language pack configuration failed.",b)}}function E(m,g,b,s,h){const u=function(S){return L.mark("code/didGenerateNls"),Promise.resolve({locale:S,osLocale:h,availableLanguages:{}})};if(L.mark("code/willGenerateNls"),s==="pseudo")return Promise.resolve({locale:s,osLocale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:s,osLocale:h,availableLanguages:{}});if(s&&(s==="en"||s==="en-us"))return Promise.resolve({locale:s,osLocale:h,availableLanguages:{}});const f=s;try{return m?R(g).then(S=>{if(!S)return u(f);const O=y(S,s);if(!O)return u(f);s=O;const t=S[s];let n;return!t||typeof t.hash!="string"||!t.translations||typeof(n=t.translations.vscode)!="string"?u(f):o(n).then(r=>{if(!r)return u(f);const i=t.hash+"."+s,a=e.join(g,"clp",i),l=e.join(a,m),c=e.join(a,"tcf.json"),p=e.join(a,"corrupted.info"),P={locale:f,osLocale:h,availableLanguages:{"*":s},_languagePackId:i,_translationsConfigFile:c,_cacheRoot:a,_resolvedLanguagePackCoreLocation:l,_corruptedFile:p};return o(p).then(T=>{let I;return T?I=A(a):I=Promise.resolve(void 0),I.then(()=>o(l).then(F=>F?(C(l).catch(()=>{}),L.mark("code/didGenerateNls"),P):D(l).then(()=>Promise.all([v(b),v(n)])).then(H=>{const ee=JSON.parse(H[0]),ce=JSON.parse(H[1]).contents,ae=Object.keys(ee.bundles),ue=[];for(const ge of ae){const G=ee.bundles[ge],te=Object.create(null);for(const W of G){const K=ee.keys[W],q=ee.messages[W],ie=ce[W];let re;if(ie){re=[];for(let de=0;de<K.length;de++){const $=K[de],V=typeof $=="string"?$:$.key;let N=ie[V];N===void 0&&(N=q[de]),re.push(N)}}else re=q;te[W]=re}ue.push(d(e.join(l,ge.replace(/\//g,"!")+".nls.json"),JSON.stringify(te)))}return ue.push(d(c,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(L.mark("code/didGenerateNls"),P)).catch(H=>(console.error("Generating translation files failed.",H),u(s)))))})})}):u(f)}catch(S){return console.error("Generating translation files failed.",S),u(s)}}return{getNLSConfiguration:E}}if(typeof define=="function")define(pe[152],ve([75,33,42]),function(e,w,L){return oe(e,w,L)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("fs"),L=require("../common/performance");module.exports=oe(e,w,L)}else throw new Error("Unknown context")}(),define(pe[153],ve([1,0,26]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(D){const A=D.replace(/\-/g,":").toLowerCase();return!L.has(A)}function C(){const D=(0,w.networkInterfaces)();for(const A in D){const v=D[A];if(v){for(const{mac:d}of v)if(o(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(pe[99],ve([1,0,26,60,21,153]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(d){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,R=0;const y=(0,w.networkInterfaces)();for(const E in y){const m=y[E];if(m)for(const{mac:g,internal:b}of m)b||(R+=1,this.c(g.toUpperCase())&&(d+=1))}this.b=R>0?d/R:0}return this.b}};let D;async function A(d){return D||(D=(async()=>await v(d)||o.generateUuid())()),D}e.getMachineId=A;async function v(d){try{const R=await new Promise((E,m)=>{oe(["crypto"],E,m)}),y=(0,C.getMac)();return R.createHash("sha256").update(y,"utf8").digest("hex")}catch(R){d(R);return}}}),define(pe[23],ve([1,0,33,26,294,14,38,95,7,3,19,4]),function(oe,e,w,L,o,C,D,A,v,d,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(ue){ue[ue.UNLINK=0]="UNLINK",ue[ue.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function m(ue,ge=E.UNLINK){if((0,D.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");return ge===E.UNLINK?b(ue):g(ue)}async function g(ue){try{const ge=(0,D.randomPath)((0,L.tmpdir)());try{await w.promises.rename(ue,ge)}catch(G){return G.code==="ENOENT"?void 0:b(ue)}b(ge).catch(G=>{})}catch(ge){if(ge.code!=="ENOENT")throw ge}}async function b(ue){return(0,o.promisify)(w.rm)(ue,{recursive:!0,force:!0,maxRetries:3})}function s(ue){if((0,D.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(ue,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function h(ue,ge){return S(await(ge?u(ue):(0,o.promisify)(w.readdir)(ue)))}async function u(ue){try{return await(0,o.promisify)(w.readdir)(ue,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const ge=[],G=await h(ue);for(const te of G){let W=!1,K=!1,q=!1;try{const ie=await e.Promises.lstat((0,v.join)(ue,te));W=ie.isFile(),K=ie.isDirectory(),q=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}ge.push({name:te,isFile:()=>W,isDirectory:()=>K,isSymbolicLink:()=>q})}return ge}function f(ue){return S(w.readdirSync(ue))}e.readdirSync=f;function S(ue){return ue.map(ge=>typeof ge=="string"?d.isMacintosh?(0,A.normalizeNFC)(ge):ge:(ge.name=d.isMacintosh?(0,A.normalizeNFC)(ge.name):ge.name,ge))}async function O(ue){const ge=await h(ue),G=[];for(const te of ge)await n.existsDirectory((0,v.join)(ue,te))&&G.push(te);return G}function t(ue,ge=1e3){return new Promise(G=>{let te=!1;const W=setInterval(()=>{te||(te=!0,w.access(ue,K=>{te=!1,K&&(clearInterval(W),G(void 0))}))},ge)})}e.whenDeleted=t;var n;(function(ue){async function ge(W){let K;try{if(K=await e.Promises.lstat(W),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(d.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ie}throw q}}ue.stat=ge;async function G(W){try{const{stat:K,symbolicLink:q}=await ue.stat(W);return K.isFile()&&q?.dangling!==!0}catch{}return!1}ue.existsFile=G;async function te(W){try{const{stat:K,symbolicLink:q}=await ue.stat(W);return K.isDirectory()&&q?.dangling!==!0}catch{}return!1}ue.existsDirectory=te})(n||(e.SymlinkSupport=n={}));const r=new C.ResourceQueue;function i(ue,ge,G){return r.queueFor(y.URI.file(ue),R.extUriBiasedIgnorePathCase).queue(()=>{const te=P(G);return new Promise((W,K)=>c(ue,ge,te,q=>q?K(q):W()))})}let a=!0;function l(ue){a=ue}e.configureFlushOnWrite=l;function c(ue,ge,G,te){if(!a)return w.writeFile(ue,ge,{mode:G.mode,flag:G.flag},te);w.open(ue,G.flag,G.mode,(W,K)=>{if(W)return te(W);w.writeFile(K,ge,q=>{if(q)return w.close(K,()=>te(q));w.fdatasync(K,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),l(!1)),w.close(K,re=>te(re))))})})}function p(ue,ge,G){const te=P(G);if(!a)return w.writeFileSync(ue,ge,{mode:te.mode,flag:te.flag});const W=w.openSync(ue,te.flag,te.mode);try{w.writeFileSync(W,ge);try{w.fdatasyncSync(W)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),l(!1)}}finally{w.closeSync(W)}}e.writeFileSync=p;function P(ue){return ue?{mode:typeof ue.mode=="number"?ue.mode:438,flag:typeof ue.flag=="string"?ue.flag:"w"}:{mode:438,flag:"w"}}async function T(ue,ge){if(ue!==ge)try{await e.Promises.rename(ue,ge)}catch(G){if(ue.toLowerCase()!==ge.toLowerCase()&&G.code==="EXDEV"||ue.endsWith("."))await I(ue,ge,{preserveSymlinks:!1}),await m(ue,E.MOVE);else throw G}}async function I(ue,ge,G){return H(ue,ge,{root:{source:ue,target:ge},options:G,handledSourcePaths:new Set})}const F=511;async function H(ue,ge,G){if(G.handledSourcePaths.has(ue))return;G.handledSourcePaths.add(ue);const{stat:te,symbolicLink:W}=await n.stat(ue);if(W){if(G.options.preserveSymlinks)try{return await ae(ue,ge,G)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}if(W.dangling)return}return te.isDirectory()?ee(ue,ge,te.mode&F,G):ce(ue,ge,te.mode&F)}async function ee(ue,ge,G,te){await e.Promises.mkdir(ge,{recursive:!0,mode:G});const W=await h(ue);for(const K of W)await H((0,v.join)(ue,K),(0,v.join)(ge,K),te)}async function ce(ue,ge,G){await e.Promises.copyFile(ue,ge),await e.Promises.chmod(ge,G)}async function ae(ue,ge,G){let te=await e.Promises.readlink(ue);(0,D.isEqualOrParent)(te,G.root.source,!d.isLinux)&&(te=(0,v.join)(G.root.target,te.substr(G.root.source.length+1))),await e.Promises.symlink(te,ge)}e.Promises=new class{get access(){return(0,o.promisify)(w.access)}get stat(){return(0,o.promisify)(w.stat)}get lstat(){return(0,o.promisify)(w.lstat)}get utimes(){return(0,o.promisify)(w.utimes)}get read(){return(ue,ge,G,te,W)=>new Promise((K,q)=>{w.read(ue,ge,G,te,W,(ie,re,de)=>ie?q(ie):K({bytesRead:re,buffer:de}))})}get readFile(){return(0,o.promisify)(w.readFile)}get write(){return(ue,ge,G,te,W)=>new Promise((K,q)=>{w.write(ue,ge,G,te,W,(ie,re,de)=>ie?q(ie):K({bytesWritten:re,buffer:de}))})}get appendFile(){return(0,o.promisify)(w.appendFile)}get fdatasync(){return(0,o.promisify)(w.fdatasync)}get truncate(){return(0,o.promisify)(w.truncate)}get rename(){return(0,o.promisify)(w.rename)}get copyFile(){return(0,o.promisify)(w.copyFile)}get open(){return(0,o.promisify)(w.open)}get close(){return(0,o.promisify)(w.close)}get symlink(){return(0,o.promisify)(w.symlink)}get readlink(){return(0,o.promisify)(w.readlink)}get chmod(){return(0,o.promisify)(w.chmod)}get mkdir(){return(0,o.promisify)(w.mkdir)}get unlink(){return(0,o.promisify)(w.unlink)}get rmdir(){return(0,o.promisify)(w.rmdir)}get realpath(){return(0,o.promisify)(w.realpath)}async exists(ue){try{return await e.Promises.access(ue),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return O}get writeFile(){return i}get rm(){return m}get move(){return T}get copy(){return I}}}),define(pe[154],ve([1,0,33,7,3,17,23]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(E){if(o.isLinux)return E;const m=(0,L.dirname)(E);if(E===m)return E;const g=((0,L.basename)(E)||E).toLowerCase();try{const s=(0,D.readdirSync)(m).filter(h=>h.toLowerCase()===g);if(s.length===1){const h=A(m);if(h)return(0,L.join)(h,s[0])}else if(s.length>1){const h=s.indexOf(g);if(h>=0){const u=A(m);if(u)return(0,L.join)(u,s[h])}}}catch{}return null}e.realcaseSync=A;async function v(E){if(o.isLinux)return E;const m=(0,L.dirname)(E);if(E===m)return E;const g=((0,L.basename)(E)||E).toLowerCase();try{const s=(await D.Promises.readdir(m)).filter(h=>h.toLowerCase()===g);if(s.length===1){const h=await v(m);if(h)return(0,L.join)(h,s[0])}else if(s.length>1){const h=s.indexOf(g);if(h>=0){const u=await v(m);if(u)return(0,L.join)(u,s[h])}}}catch{}return null}e.realcase=v;async function d(E){try{return await D.Promises.realpath(E)}catch{const g=y(E);return await D.Promises.access(g,w.constants.R_OK),g}}e.realpath=d;function R(E){try{return w.realpathSync(E)}catch{const g=y(E);return w.accessSync(g,w.constants.R_OK),g}}e.realpathSync=R;function y(E){return(0,C.rtrim)((0,L.normalize)(E),L.sep)}}),define(pe[155],ve([1,0,76]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(A,v,d,R=1){let y=!1;return new Promise(E=>{const m=setTimeout(()=>{if(!y)return y=!0,E(0)},d);o(A,v,R,g=>{if(!y)return y=!0,clearTimeout(m),E(g)})})}e.findFreePort=L;function o(A,v,d,R){if(v===0)return R(0);const y=new w.Socket;y.once("connect",()=>(D(y),o(A+d,v-1,d,R))),y.once("data",()=>{}),y.once("error",E=>(D(y),E.code!=="ECONNREFUSED"?o(A+d,v-1,d,R):R(A))),y.connect(A,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(A,v,d,R="127.0.0.1"){let y=!1,E,m=1;const g=w.createServer({pauseOnConnect:!0});function b(s,h){y||(y=!0,g.removeAllListeners(),g.close(),E&&clearTimeout(E),h(s))}return new Promise(s=>{E=setTimeout(()=>{b(0,s)},d),g.on("listening",()=>{b(A,s)}),g.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&m<v?(A++,m++,g.listen(A,R)):b(0,s)}),g.on("close",()=>{b(0,s)}),g.listen(A,R)})}e.findFreePortFaster=C;function D(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(v){console.error(v)}}}),define(pe[100],ve([1,0,26,7,23]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,D=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var v;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(v||(v={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class y{constructor(O,t,n){this.exePath=O,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await o.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:S=!1}={}){return S?d===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:S=!1,findPreview:O=!1}={}){const t=E({useAlternateBitness:S});if(!t)return null;const n=L.join(t,"PowerShell");if(!await o.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const c of await o.Promises.readdir(n)){let p=-1;if(O){const T=c.indexOf("-");if(T<0)continue;const I=c.substring(0,T);if(!C.test(I)||c.substring(T+1)!=="preview")continue;p=parseInt(I,10)}else{if(!C.test(c))continue;p=parseInt(c,10)}if(p<=r)continue;const P=L.join(n,c,"pwsh.exe");await o.SymlinkSupport.existsFile(P)&&(i=P,r=p)}if(!i)return null;const a=t.includes("x86")?" (x86)":"",l=O?" Preview":"";return new y(i,`PowerShell${l}${a}`,!0)}async function g({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const O=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await o.SymlinkSupport.existsDirectory(O))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=S?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await o.Promises.readdir(O))if(t.test(r)){const i=L.join(O,r,"pwsh.exe");return new y(i,n)}return null}function b(){const S=L.join(w.homedir(),".dotnet","tools","pwsh.exe");return new y(S,".NET Core PowerShell Global Tool")}function s(){const S=L.join(process.env.windir,d===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(S,"Windows PowerShell",!0)}async function*h(){let S=await m();S&&(yield S),S=await m({useAlternateBitness:!0}),S&&(yield S),S=await g(),S&&(yield S),S=b(),S&&(yield S),S=await m({findPreview:!0}),S&&(yield S),S=await g({findPreview:!0}),S&&(yield S),S=await m({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=s(),S&&(yield S)}async function*u(){for await(const S of h())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=u;async function f(){for await(const S of u())return S;return null}e.getFirstAvailablePowerShellInstallation=f}),define(pe[101],ve([1,0,7,3,29,58,8,23]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function v(y=o.env){return y.comspec||"cmd.exe"}e.getWindowsShell=v;function d(y){let E=[],m=!1;const g=function(b){if(m){E.push(b);return}(!y.send(b,h=>{if(h&&console.error(h),m=!1,E.length>0){const u=E.slice(0);E=[],u.forEach(f=>g(f))}})||L.isWindows)&&(m=!0)};return{send:g}}e.createQueuedSender=d;var R;(function(y){async function E(m,g,b){if(w.isAbsolute(m))return m;if(g===void 0&&(g=o.cwd()),w.dirname(m)!=="."||(b===void 0&&D.isString(o.env.PATH)&&(b=o.env.PATH.split(w.delimiter)),b===void 0||b.length===0))return w.join(g,m);async function h(u){if(await A.Promises.exists(u)){let f;try{f=await A.Promises.stat(u)}catch(S){S.message.startsWith("EACCES")&&(f=await A.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(const u of b){let f;if(w.isAbsolute(u)?f=w.join(u,m):f=w.join(g,u,m),await h(f))return f;let S=f+".com";if(await h(S)||(S=f+".exe",await h(S)))return S}return w.join(g,m)}y.findExecutable=E})(R||(e.win32=R={}))}),define(pe[102],ve([1,0,50,13]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function o(D){return new Promise((A,v)=>{let d;const R=new Map;function y(m,g,b,s,h){const u=R.get(g);if(m===D||u){const f={name:E(b),cmd:b,pid:m,ppid:g,load:s,mem:h};R.set(m,f),m===D&&(d=f),u&&(u.children||(u.children=[]),u.children.push(f),u.children.length>1&&(u.children=u.children.sort((S,O)=>S.pid-O.pid)))}}function E(m){const g=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,s=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,f=/--type=([a-zA-Z-]+)/;if(s.exec(m))return"electron-crash-reporter";if(h.exec(m))return"winpty-process";if(u.exec(m))return"console-window-host (Windows internal process)";let S=f.exec(m);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?g.exec(m)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const O=/[a-zA-Z-]+\.js/g;let t="";do S=O.exec(m),S&&(t+=S+" ");while(S);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(m)?`electron-nodejs (${m})`:m}if(process.platform==="win32"){const m=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,b)=>{oe(["@vscode/windows-process-tree"],g,b)}).then(g=>{g.getProcessList(D,b=>{if(!b){v(new Error(`Root process ${D} not found`));return}g.getProcessCpuUsage(b,s=>{const h=new Map;s.forEach(u=>{const f=m(u.commandLine||"");h.set(u.pid,{name:E(f),cmd:f,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),d=h.get(D),d?(h.forEach(u=>{const f=h.get(u.ppid);f&&(f.children||(f.children=[]),f.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((f,S)=>f.pid-S.pid))}),A(d)):v(new Error(`Root process ${D} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let m=function(){let g=[d];const b=[];for(;g.length;){const h=g.shift();h&&(b.push(h.pid),h.children&&(g=g.concat(h.children)))}let s=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+b.join(" "),(0,w.exec)(s,{},(h,u,f)=>{if(h||f)v(h||new Error(f.toString()));else{const S=u.toString().split(`
`);for(let O=0;O<b.length;O++){const t=R.get(b[O]);t.load=parseFloat(S[O])}if(!d){v(new Error(`Root process ${D} not found`));return}A(d)}})};(0,w.exec)("which ps",{},(g,b,s)=>{if(g||s)if(process.platform!=="linux")v(g||new Error(s.toString()));else{const h=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(h,{},(u,f,S)=>{u||S?v(u||new Error(S.toString())):(C(f,y),m())})}else{const h=b.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,S,O)=>{f||O&&!O.includes("screen size is bogus")?v(f||new Error(O.toString())):(C(S,y),process.platform==="linux"?m():d?A(d):v(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=o;function C(D,A){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const R of d){const y=v.exec(R.trim());y&&y.length===6&&A(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(pe[156],ve([1,0,26,3,100,101]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(y,E){return y===1?L.isWindows?R():C.getWindowsShell(E):v(y,E)}e.getSystemShell=D;let A=null;function v(y,E){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!A){let m;if(L.isWindows)m="/bin/bash";else{if(m=E.SHELL,!m)try{m=(0,w.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}A=m}return A}let d=null;async function R(){return d||(d=(await(0,o.getFirstAvailablePowerShellInstallation)()).exePath),d}}),define(pe[103],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUNCHostAllowlist=e.addUNCHostToAllowlist=e.getUNCHostAllowlist=e.setUNCHostAllowlist=void 0;function L(){return process.uncHostAllowlist}function o(v){if(!w.isWindows)return;const d=L();if(d)for(const R of v)d.add(R)}e.setUNCHostAllowlist=o;function C(){const v=L();return v?Array.from(v):[]}e.getUNCHostAllowlist=C;function D(v){if(!w.isWindows)return;const d=L();d&&d.add(v)}e.addUNCHostToAllowlist=D;function A(v){const d=new Set;if(Array.isArray(v))for(const R of v)typeof R=="string"&&d.add(R);return Array.from(d)}e.toUNCHostAllowlist=A});var Le=this&&this.__decorate||function(oe,e,w,L){var o=arguments.length,C=o<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(oe,e,w,L);else for(var A=oe.length-1;A>=0;A--)(D=oe[A])&&(C=(o<3?D(C):o>3?D(e,w,C):D(e,w))||C);return o>3&&C&&Object.defineProperty(e,w,C),C};define(pe[43],ve([1,0,18,14,15,20,92,9,6,2,61,17,8]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(m||(m={}));function g(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(b||(b={}));function s(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(h||(h={}));function u(K){let q=0;for(let ie=0;;ie+=7){const re=K.read(1);if(q|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return q}}const f=r(0);function S(K,q){if(q===0){K.write(f);return}let ie=0;for(let de=q;de!==0;de=de>>>7)ie++;const re=o.VSBuffer.alloc(ie);for(let de=0;q!==0;de++)re.buffer[de]=q&127,q=q>>>7,q>0&&(re.buffer[de]|=128);K.write(re)}class O{constructor(q){this.b=q,this.a=0}read(q){const ie=this.b.slice(this.a,this.a+q);return this.a+=ie.byteLength,ie}}e.BufferReader=O;class t{constructor(){this.a=[]}get buffer(){return o.VSBuffer.concat(this.a)}write(q){this.a.push(q)}}e.BufferWriter=t;var n;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object",K[K.Int=6]="Int"})(n||(n={}));function r(K){const q=o.VSBuffer.alloc(1);return q.writeUInt8(K,0),q}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},a=typeof Buffer<"u";function l(K,q){if(typeof q>"u")K.write(i.Undefined);else if(typeof q=="string"){const ie=o.VSBuffer.fromString(q);K.write(i.String),S(K,ie.byteLength),K.write(ie)}else if(a&&Buffer.isBuffer(q)){const ie=o.VSBuffer.wrap(q);K.write(i.Buffer),S(K,ie.byteLength),K.write(ie)}else if(q instanceof o.VSBuffer)K.write(i.VSBuffer),S(K,q.byteLength),K.write(q);else if(Array.isArray(q)){K.write(i.Array),S(K,q.length);for(const ie of q)l(K,ie)}else if(typeof q=="number"&&(q|0)===q)K.write(i.Uint),S(K,q);else{const ie=o.VSBuffer.fromString(JSON.stringify(q));K.write(i.Object),S(K,ie.byteLength),K.write(ie)}}e.serialize=l;function c(K){switch(K.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return K.read(u(K)).toString();case n.Buffer:return K.read(u(K)).buffer;case n.VSBuffer:return K.read(u(K));case n.Array:{const ie=u(K),re=[];for(let de=0;de<ie;de++)re.push(c(K));return re}case n.Object:return JSON.parse(K.read(u(K)).toString());case n.Int:return u(K)}}e.deserialize=c;class p{constructor(q,ie,re=null,de=1e3){this.h=q,this.j=ie,this.k=re,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($=>this.q($)),this.m({type:200})}registerChannel(q,ie){this.b.set(q,ie),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const ie=this.o([q.type]);this.k?.logOutgoing(ie,0,1,s(q.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([q.type,q.id],q.data);this.k?.logOutgoing(ie,q.id,1,s(q.type),q.data);return}}}o(q,ie=void 0){const re=new t;return l(re,q),l(re,ie),this.p(re.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const ie=new O(q),re=c(ie),de=c(ie),$=re[0];switch($){case 100:return this.k?.logIncoming(q.byteLength,re[1],1,`${g($)}: ${re[2]}.${re[3]}`,de),this.s({type:$,id:re[1],channelName:re[2],name:re[3],arg:de});case 102:return this.k?.logIncoming(q.byteLength,re[1],1,`${g($)}: ${re[2]}.${re[3]}`,de),this.t({type:$,id:re[1],channelName:re[2],name:re[3],arg:de});case 101:return this.k?.logIncoming(q.byteLength,re[1],1,`${g($)}`),this.u({type:$,id:re[1]});case 103:return this.k?.logIncoming(q.byteLength,re[1],1,`${g($)}`),this.u({type:$,id:re[1]})}}s(q){const ie=this.b.get(q.channelName);if(!ie){this.v(q);return}const re=new C.CancellationTokenSource;let de;try{de=ie.call(this.j,q.name,q.arg,re.token)}catch(N){de=Promise.reject(N)}const $=q.id;de.then(N=>{this.m({id:$,data:N,type:201}),this.d.delete(q.id)},N=>{N instanceof Error?this.m({id:$,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:$,data:N,type:203}),this.d.delete(q.id)});const V=(0,d.toDisposable)(()=>re.cancel());this.d.set(q.id,V)}t(q){const ie=this.b.get(q.channelName);if(!ie){this.v(q);return}const re=q.id,$=ie.listen(this.j,q.name,q.arg)(V=>this.m({id:re,data:V,type:204}));this.d.set(q.id,$)}u(q){const ie=this.d.get(q.id);ie&&(ie.dispose(),this.d.delete(q.id))}v(q){let ie=this.g.get(q.channelName);ie||(ie=[],this.g.set(q.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:q,timeoutTimer:re})}w(q){const ie=this.g.get(q);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=p;var P;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class T{constructor(q,ie=null){this.l=q,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(q){const ie=this;return{call(re,de,$){return ie.a?Promise.reject(new A.CancellationError):ie.m(q,re,de,$)},listen(re,de){return ie.a?v.Event.None:ie.o(q,re,de)}}}m(q,ie,re,de=C.CancellationToken.None){const $=this.g++,N={id:$,type:100,channelName:q,name:ie,arg:re};if(de.isCancellationRequested)return Promise.reject(new A.CancellationError);let k;return new Promise((X,ne)=>{if(de.isCancellationRequested)return ne(new A.CancellationError);const z=()=>{const Z=J=>{switch(J.type){case 201:this.f.delete($),X(J.data);break;case 202:{this.f.delete($);const _=new Error(J.data.message);_.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,_.name=J.data.name,ne(_);break}case 203:this.f.delete($),ne(J.data);break}};this.f.set($,Z),this.p(N)};let j=null;this.b===h.Idle?z():(j=(0,L.createCancelablePromise)(Z=>this.u()),j.then(()=>{j=null,z()}));const Y=()=>{j?(j.cancel(),j=null):this.p({id:$,type:101}),ne(new A.CancellationError)},x=de.onCancellationRequested(Y);k=(0,d.combinedDisposable)((0,d.toDisposable)(Y),x),this.d.add(k)}).finally(()=>{this.d.delete(k)})}o(q,ie,re){const de=this.g++,V={id:de,type:102,channelName:q,name:ie,arg:re};let N=null;const k=new v.Emitter({onWillAddFirstListener:()=>{N=(0,L.createCancelablePromise)(X=>this.u()),N.then(()=>{N=null,this.d.add(k),this.p(V)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(k),this.p({id:de,type:103}))}}),U=X=>k.fire(X.data);return this.f.set(de,U),k.event}p(q){switch(q.type){case 100:case 102:{const ie=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(ie,q.id,0,`${g(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const ie=this.q([q.type,q.id]);this.j?.logOutgoing(ie,q.id,0,g(q.type));return}}}q(q,ie=void 0){const re=new t;return l(re,q),l(re,ie),this.r(re.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const ie=new O(q),re=c(ie),de=c(ie),$=re[0];switch($){case 200:return this.j?.logIncoming(q.byteLength,0,0,s($)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,re[1],0,s($),de),this.t({type:re[0],id:re[1],data:de})}}t(q){if(q.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=T,Le([D.memoize],T.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this.f.forEach(ie=>q.push(ie)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new v.Emitter,this.onDidAddConnection=this.g.event,this.h=new v.Emitter,this.onDidRemoveConnection=this.h.event,q(({protocol:ie,onDidClientDisconnect:re})=>{v.Event.once(ie.onMessage)($=>{const V=new O($),N=c(V),k=new p(ie,N),U=new T(ie);this.a.forEach((ne,z)=>k.registerChannel(z,ne));const X={channelServer:k,channelClient:U,ctx:N};this.f.add(X),this.g.fire(X),re(()=>{k.dispose(),U.dispose(),this.f.delete(X),this.h.fire(X)})})})}getChannel(q,ie){const re=this;return{call(de,$,V){let N;if((0,E.isFunction)(ie)){const U=(0,w.getRandomElement)(re.connections.filter(ie));N=U?Promise.resolve(U):v.Event.toPromise(v.Event.filter(re.onDidAddConnection,ie))}else N=ie.routeCall(re,de,$);const k=N.then(U=>U.channelClient.getChannel(q));return H(k).call(de,$,V)},listen(de,$){if((0,E.isFunction)(ie))return re.j(q,ie,de,$);const V=ie.routeEvent(re,de,$).then(N=>N.channelClient.getChannel(q));return H(V).listen(de,$)}}}j(q,ie,re,de){const $=this;let V=new d.DisposableStore;const N=new v.Emitter({onWillAddFirstListener:()=>{V=new d.DisposableStore;const k=new v.EventMultiplexer,U=new Map,X=z=>{const Y=z.channelClient.getChannel(q).listen(re,de),x=k.add(Y);U.set(z,x)},ne=z=>{const j=U.get(z);j&&(j.dispose(),U.delete(z))};$.connections.filter(ie).forEach(X),v.Event.filter($.onDidAddConnection,ie)(X,void 0,V),$.onDidRemoveConnection(ne,void 0,V),k.event(N.fire,N,V),V.add(k)},onDidRemoveLastListener:()=>{V.dispose()}});return N.event}registerChannel(q,ie){this.a.set(q,ie),this.f.forEach(re=>{re.channelServer.registerChannel(q,ie)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=I;class F{constructor(q,ie,re=null){const de=new t;l(de,ie),q.send(de.buffer),this.a=new T(q,re),this.d=new p(q,ie,re)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,ie){this.d.registerChannel(q,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function H(K){return{call(q,ie,re){return K.then(de=>de.call(q,ie,re))},listen(q,ie){const re=new v.Relay;return K.then(de=>re.input=de.listen(q,ie)),re.event}}}e.getDelayedChannel=H;function ee(K){let q=!1;return{call(ie,re,de){return q?K.call(ie,re,de):(0,L.timeout)(0).then(()=>q=!0).then(()=>K.call(ie,re,de))},listen(ie,re){if(q)return K.listen(ie,re);const de=new v.Relay;return(0,L.timeout)(0).then(()=>q=!0).then(()=>de.input=K.listen(ie,re)),de.event}}}e.getNextTickChannel=ee;class ce{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const ie of q.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await v.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.StaticRouter=ce;var ae;(function(K){function q($,V){const N=$,k=V&&V.disableMarshalling,U=new Map;for(const X in N)re(X)&&U.set(X,v.Event.buffer(N[X],!0));return new class{listen(X,ne,z){const j=U.get(ne);if(j)return j;if(de(ne)){const Y=N[ne];if(typeof Y=="function")return Y.call(N,z)}throw new Error(`Event not found: ${ne}`)}call(X,ne,z){const j=N[ne];if(typeof j=="function"){if(!k&&Array.isArray(z))for(let Y=0;Y<z.length;Y++)z[Y]=(0,R.revive)(z[Y]);return j.apply(N,z)}throw new Error(`Method not found: ${ne}`)}}}K.fromService=q;function ie($,V){const N=V&&V.disableMarshalling;return new Proxy({},{get(k,U){if(typeof U=="string")return V?.properties?.has(U)?V.properties.get(U):de(U)?function(X){return $.listen(U,X)}:re(U)?$.listen(U):async function(...X){let ne;V&&!(0,E.isUndefinedOrNull)(V.context)?ne=[V.context,...X]:ne=X;const z=await $.call(U,ne);return N?z:(0,R.revive)(z)};throw new Error(`Property not found: ${String(U)}`)}})}K.toService=ie;function re($){return $[0]==="o"&&$[1]==="n"&&y.isUpperAsciiLetter($.charCodeAt(2))}function de($){return/^onDynamic/.test($)&&y.isUpperAsciiLetter($.charCodeAt(9))}})(ae||(e.ProxyChannel=ae={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const q=K.toString();if(q!=="[object Object]")return q}return K}function G(K){return Array.isArray(K)?K.map(ge):ge(K)}function te(K,q,ie,re,de,$,V){V=G(V);const N=ue[de],k=N[re%N.length];let U=[`%c[${K}]%c[${String(q).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test($)?(U=U.concat(V),U.push(")")):U.push(V),console.log.apply(console,U)}class W{constructor(q,ie){this.d=q,this.f=ie,this.a=0,this.b=0}logOutgoing(q,ie,re,de,$){this.b+=q,te(this.d,this.b,q,ie,re,de,$)}logIncoming(q,ie,re,de,$){this.a+=q,te(this.f,this.a,q,ie,re,de,$)}}e.IPCLogger=W}),define(pe[104],ve([1,0,14,15,6,2,43]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(T){T.Created="created",T.Read="read",T.Write="write",T.Open="open",T.Error="error",T.Close="close",T.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",T.NodeEndReceived="nodeEndReceived",T.NodeEndSent="nodeEndSent",T.NodeDrainBegin="nodeDrainBegin",T.NodeDrainEnd="nodeDrainEnd",T.zlibInflateError="zlibInflateError",T.zlibInflateData="zlibInflateData",T.zlibInflateInitialWrite="zlibInflateInitialWrite",T.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",T.zlibInflateWrite="zlibInflateWrite",T.zlibInflateFlushFired="zlibInflateFlushFired",T.zlibDeflateError="zlibDeflateError",T.zlibDeflateData="zlibDeflateData",T.zlibDeflateWrite="zlibDeflateWrite",T.zlibDeflateFlushFired="zlibDeflateFlushFired",T.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",T.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",T.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",T.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",T.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",T.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",T.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",T.ProtocolHeaderRead="protocolHeaderRead",T.ProtocolMessageRead="protocolMessageRead",T.ProtocolHeaderWrite="protocolHeaderWrite",T.ProtocolMessageWrite="protocolMessageWrite",T.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var v;(function(T){T.enableDiagnostics=!1,T.records=[];const I=new WeakMap;let F=0;function H(ce,ae){if(!I.has(ce)){const ue=String(++F);I.set(ce,ue)}return I.get(ce)}function ee(ce,ae,ue,ge){if(!T.enableDiagnostics)return;const G=H(ce,ae);if(ge instanceof L.VSBuffer||ge instanceof Uint8Array||ge instanceof ArrayBuffer||ArrayBuffer.isView(ge)){const te=L.VSBuffer.alloc(ge.byteLength);te.set(ge),T.records.push({timestamp:Date.now(),id:G,label:ae,type:ue,buff:te})}else T.records.push({timestamp:Date.now(),id:G,label:ae,type:ue,data:ge})}T.traceSocketEvent=ee})(v||(e.SocketDiagnostics=v={}));var d;(function(T){T[T.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",T[T.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let R=null;function y(){return R||(R=L.VSBuffer.alloc(0)),R}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(I){this.a.push(I),this.b+=I.byteLength}read(I){return this.c(I,!0)}peek(I){return this.c(I,!1)}c(I,F){if(I===0)return y();if(I>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===I){const ae=this.a[0];return F&&(this.a.shift(),this.b-=I),ae}if(this.a[0].byteLength>I){const ae=this.a[0].slice(0,I);return F&&(this.a[0]=this.a[0].slice(I),this.b-=I),ae}const H=L.VSBuffer.alloc(I);let ee=0,ce=0;for(;I>0;){const ae=this.a[ce];if(ae.byteLength>I){const ue=ae.slice(0,I);H.set(ue,ee),ee+=I,F&&(this.a[ce]=ae.slice(I),this.b-=I),I-=I}else H.set(ae,ee),ee+=ae.byteLength,F?(this.a.shift(),this.b-=ae.byteLength):ce++,I-=ae.byteLength}return H}}e.ChunkStream=E;var m;(function(T){T[T.None=0]="None",T[T.Regular=1]="Regular",T[T.Control=2]="Control",T[T.Ack=3]="Ack",T[T.Disconnect=5]="Disconnect",T[T.ReplayRequest=6]="ReplayRequest",T[T.Pause=7]="Pause",T[T.Resume=8]="Resume",T[T.KeepAlive=9]="KeepAlive",T[T.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",T[T.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(m||(m={}));function g(T){switch(T){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(T){T[T.HeaderLength=13]="HeaderLength",T[T.AcknowledgeTime=2e3]="AcknowledgeTime",T[T.TimeoutTime=2e4]="TimeoutTime",T[T.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",T[T.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",T[T.KeepAliveSendTime=5e3]="KeepAliveSendTime",T[T.LatencySampleTime=6e4]="LatencySampleTime",T[T.LatencySampleCount=5]="LatencySampleCount",T[T.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",T[T.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b||(e.ProtocolConstants=b={}));class s{constructor(I,F,H,ee){this.type=I,this.id=F,this.ack=H,this.data=ee,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends C.Disposable{constructor(I){super(),this.f=this.B(new o.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=I,this.b=!1,this.c=new E,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(I){if(!(!I||I.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(I);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const H=this.g.messageType,ee=this.g.id,ce=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new s(H,ee,ce,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(I){this.k=null,this.a=!1,this.b=!1,this.c=I,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(I){if(this.a)return;I.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=L.VSBuffer.alloc(13);F.writeUInt8(I.type,0),F.writeUInt32BE(I.id,1),F.writeUInt32BE(I.ack,5),F.writeUInt32BE(I.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(I.type),id:I.id,ack:I.ack,messageSize:I.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",I.data),this.j(F,I.data)}g(I,F){const H=this.f===0;return this.d.push(I,F),this.f+=I.byteLength+F.byteLength,H}h(){const I=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,I}j(I,F){this.g(I,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const I=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:I.byteLength}),this.c.write(I)}}class f extends C.Disposable{constructor(I){super(),this.f=new o.Emitter,this.onMessage=this.f.event,this.g=new o.Emitter,this.onDidDispose=this.g.event,this.a=I,this.b=this.B(new u(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(I){this.b.write(new s(1,0,0,I))}}e.Protocol=f;class S extends D.IPCClient{static fromSocket(I,F){return new S(new f(I),F)}get onDidDispose(){return this.b.onDidDispose}constructor(I,F,H=null){super(I,F,H),this.b=I}dispose(){super.dispose();const I=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),I.end()}}e.Client=S;class O{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(I){this.b?this.d.length>0?this.d.push(I):this.a.fire(I):this.d.push(I)}flushBuffer(){this.d=[]}}e.BufferedEmitter=O;class t{constructor(I){this.data=I,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let I=0,F=this.a;for(;F;)F=F.next,I++;return I}peek(){return this.a?this.a.data:null}toArray(){const I=[];let F=0,H=this.a;for(;H;)I[F++]=H.data,H=H.next;return I}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(I){const F=new t(I);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const I=Date.now();for(let F=0;F<r.a;F++)this.c[F]=I-1e3*F;setInterval(()=>{for(let F=r.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const I=Date.now(),F=(1+r.a)*1e3;let H=0;for(let ee=0;ee<r.a;ee++)I-this.c[ee]<=F&&H++;return 1-H/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var i;(function(T){T[T.Good=0]="Good",T[T.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function a(T){switch(T){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class l{constructor(I){this.connectionHealth=I}}e.ConnectionHealthChangedEvent=l;class c{constructor(I,F){this.roundTripTime=I,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=c;class p{get unacknowledgedCount(){return this.c-this.d}constructor(I){this.x=new O,this.onControlMessage=this.x.event,this.y=new O,this.onMessage=this.y.event,this.z=new O,this.onDidDispose=this.z.event,this.A=new O,this.onSocketClose=this.A.event,this.B=new O,this.onSocketTimeout=this.B.event,this.C=new O,this.onHighRoundTripTime=this.C.event,this.D=new O,this.onDidChangeConnectionHealth=this.D.event,this.u=I.loadEstimator??r.getInstance(),this.v=I.measureRoundTripTime??!1,this.w=I.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new C.DisposableStore,this.o=I.socket,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),I.initialChunk&&this.q.acceptChunk(I.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const I=new s(5,0,0,y());this.p.write(I),this.p.flush()}sendPause(){const I=new s(7,0,0,y());this.p.write(I)}sendResume(){const I=new s(8,0,0,y());this.p.write(I)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(I,F){this.a=!0,this.t.dispose(),this.t=new C.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=I,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(H=>this.E(H))),this.t.add(this.o.onClose(H=>this.A.fire(H))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(H=>this.J(H))),this.t.add(this.r.onHighRoundTripTime(H=>this.C.fire(H))),this.t.add(this.r.onDidChangeConnectionHealth(H=>this.D.fire(H))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const I=new s(3,0,this.h,y());this.p.write(I);const F=this.b.toArray();for(let H=0,ee=F.length;H<ee;H++)this.p.write(F[H]);this.G()}acceptDisconnect(){this.z.fire()}E(I){if(I.ack>this.d){this.d=I.ack;do{const F=this.b.peek();if(F&&F.id<=I.ack)this.b.pop();else break}while(!0)}switch(I.type){case 0:break;case 1:{if(I.id>this.g)if(I.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new s(6,0,0,y())))}else this.g=I.id,this.j=Date.now(),this.F(),this.y.fire(I.data);break}case 2:{this.x.fire(I.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let H=0,ee=F.length;H<ee;H++)this.p.write(F[H]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(I.data);break}case 11:{this.r.handleResponse(I.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(I){const F=++this.c;this.h=this.g;const H=new s(1,F,this.h,I);this.b.push(H),this.a||(this.p.write(H),this.G())}sendControl(I){const F=new s(2,0,0,I);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const I=Date.now()-this.j;if(I>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-I+5)}G(){if(this.c<=this.d||this.f||this.a)return;const I=this.b.peek(),F=Date.now()-I.writtenTime,H=Date.now()-this.q.lastReadTime,ee=Date.now()-this.n;if(F>=2e4&&H>=2e4&&ee>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:H});return}const ce=Math.max(2e4-F,2e4-H,2e4-ee,500);this.f=setTimeout(()=>{this.f=null,this.G()},ce)}H(){if(this.g<=this.h)return;this.h=this.g;const I=new s(3,0,this.h,y());this.p.write(I)}I(){this.h=this.g;const I=new s(9,0,this.h,y());this.p.write(I)}J(I){this.h=this.g;const F=new s(10,0,this.h,I);this.p.write(F)}K(I){this.h=this.g;const F=new s(11,0,this.h,I);this.p.write(F)}}e.PersistentProtocol=p;class P extends C.Disposable{constructor(){super(),this.a=this.B(new o.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new o.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new o.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new w.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},I=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const I=++this.h,F=L.VSBuffer.alloc(4);F.writeUInt32BE(I,0),this.a.fire(F)},6e4)}handleResponse(I){if(I.byteLength!==4)return;const F=I.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const H=Date.now()-this.g,ee=this.k++;this.j[ee%this.j.length]=H;const ce=this.l,ae=this.j.filter(ue=>ue>=1e3).length;this.l=ae>=3?1:0,H>1e3&&this.b.fire(new c(H,ae)),ce!==this.l&&this.c.fire(this.l)}}}),define(pe[105],ve([1,0,50,14,15,20,149,9,6,2,22,101,58,43]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends m.ChannelServer{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",u=>o.VSBuffer.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=g;class b{constructor(h,u){this.i=h,this.j=u,this.c=new Set,this.g=new Map,this.h=new v.Emitter,this.onDidProcessExit=this.h.event;const f=u&&u.timeout?u.timeout:6e4;this.b=new L.Delayer(f),this.d=null,this.f=null}getChannel(h){const u=this;return{call(f,S,O){return u.k(h,f,S,O)},listen(f,S){return u.l(h,f,S)}}}k(h,u,f,S=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(A.canceled());this.b.cancel();const O=this.n(h),t=(0,L.createCancelablePromise)(i=>O.call(u,f,i)),n=S.onCancellationRequested(()=>t.cancel()),r=(0,d.toDisposable)(()=>t.cancel());return this.c.add(r),t.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,u,f){if(!this.b)return v.Event.None;this.b.cancel();let S;const O=new v.Emitter({onWillAddFirstListener:()=>{S=this.n(h).listen(u,f)(O.fire,O),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return O.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,E.removeDangerousEnvVariables)(u.env),this.d=(0,w.fork)(this.i,h,u);const f=new v.Emitter;v.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.j.serverName}`);return}f.fire(o.VSBuffer.wrap(Buffer.from(a,"base64")))});const O=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,t=a=>this.d&&this.d.connected&&O.send(a.buffer.toString("base64")),n=f.event,r={send:t,onMessage:n};this.f=new m.ChannelClient(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,d.dispose)(c)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(h){let u=this.g.get(h);return u||(u=this.m.getChannel(h),this.g.set(h,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(pe[157],ve([1,0,14,6,2,8]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D||(e.StorageHint=D={}));function A(y){const E=y;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=A;var v;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(v||(e.StorageState=v={}));class d extends o.Disposable{constructor(E,m=Object.create(null)){super(),this.m=E,this.n=m,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=new w.ThrottledDelayer(d.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(E=>this.r(E)))}r(E){E.changed?.forEach((m,g)=>this.s(g,m)),E.deleted?.forEach(m=>this.s(m,void 0))}s(E,m){if(this.c===v.Closed)return;let g=!1;(0,C.isUndefinedOrNull)(m)?g=this.f.delete(E):this.f.get(E)!==m&&(this.f.set(E,m),g=!0),g&&this.b.fire(E)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(E,m){const g=this.f.get(E);return(0,C.isUndefinedOrNull)(g)?m:g}getBoolean(E,m){const g=this.get(E);return(0,C.isUndefinedOrNull)(g)?m:g==="true"}getNumber(E,m){const g=this.get(E);return(0,C.isUndefinedOrNull)(g)?m:parseInt(g,10)}async set(E,m){if(this.c===v.Closed)return;if((0,C.isUndefinedOrNull)(m))return this.delete(E);const g=String(m);if(this.f.get(E)!==g)return this.f.set(E,g),this.j.set(E,g),this.h.delete(E),this.b.fire(E),this.w()}async delete(E){if(!(this.c===v.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire(E),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=v.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(E).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(E){if(this.u)return this.w(E)}async w(E){return this.g.trigger(()=>this.v(),E)}async whenFlushed(){if(this.u)return new Promise(E=>this.l.push(E))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=d,d.a=100;class R{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((m,g)=>this.a.set(g,m)),E.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.InMemoryStorageDatabase=R}),define(pe[106],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(o,C){this.lineNumber=o,this.column=C}with(o=this.lineNumber,C=this.column){return o===this.lineNumber&&C===this.column?this:new w(o,C)}delta(o=0,C=0){return this.with(this.lineNumber+o,this.column+C)}equals(o){return w.equals(this,o)}static equals(o,C){return!o&&!C?!0:!!o&&!!C&&o.lineNumber===C.lineNumber&&o.column===C.column}isBefore(o){return w.isBefore(this,o)}static isBefore(o,C){return o.lineNumber<C.lineNumber?!0:C.lineNumber<o.lineNumber?!1:o.column<C.column}isBeforeOrEqual(o){return w.isBeforeOrEqual(this,o)}static isBeforeOrEqual(o,C){return o.lineNumber<C.lineNumber?!0:C.lineNumber<o.lineNumber?!1:o.column<=C.column}static compare(o,C){const D=o.lineNumber|0,A=C.lineNumber|0;if(D===A){const v=o.column|0,d=C.column|0;return v-d}return D-A}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(o){return new w(o.lineNumber,o.column)}static isIPosition(o){return o&&typeof o.lineNumber=="number"&&typeof o.column=="number"}}e.Position=w}),define(pe[51],ve([1,0,106]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,D,A,v){C>A||C===A&&D>v?(this.startLineNumber=A,this.startColumn=v,this.endLineNumber=C,this.endColumn=D):(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=A,this.endColumn=v)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,D){return!(D.lineNumber<C.startLineNumber||D.lineNumber>C.endLineNumber||D.lineNumber===C.startLineNumber&&D.column<C.startColumn||D.lineNumber===C.endLineNumber&&D.column>C.endColumn)}static strictContainsPosition(C,D){return!(D.lineNumber<C.startLineNumber||D.lineNumber>C.endLineNumber||D.lineNumber===C.startLineNumber&&D.column<=C.startColumn||D.lineNumber===C.endLineNumber&&D.column>=C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,D){return!(D.startLineNumber<C.startLineNumber||D.endLineNumber<C.startLineNumber||D.startLineNumber>C.endLineNumber||D.endLineNumber>C.endLineNumber||D.startLineNumber===C.startLineNumber&&D.startColumn<C.startColumn||D.endLineNumber===C.endLineNumber&&D.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,D){return!(D.startLineNumber<C.startLineNumber||D.endLineNumber<C.startLineNumber||D.startLineNumber>C.endLineNumber||D.endLineNumber>C.endLineNumber||D.startLineNumber===C.startLineNumber&&D.startColumn<=C.startColumn||D.endLineNumber===C.endLineNumber&&D.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,D){let A,v,d,R;return D.startLineNumber<C.startLineNumber?(A=D.startLineNumber,v=D.startColumn):D.startLineNumber===C.startLineNumber?(A=D.startLineNumber,v=Math.min(D.startColumn,C.startColumn)):(A=C.startLineNumber,v=C.startColumn),D.endLineNumber>C.endLineNumber?(d=D.endLineNumber,R=D.endColumn):D.endLineNumber===C.endLineNumber?(d=D.endLineNumber,R=Math.max(D.endColumn,C.endColumn)):(d=C.endLineNumber,R=C.endColumn),new L(A,v,d,R)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,D){let A=C.startLineNumber,v=C.startColumn,d=C.endLineNumber,R=C.endColumn;const y=D.startLineNumber,E=D.startColumn,m=D.endLineNumber,g=D.endColumn;return A<y?(A=y,v=E):A===y&&(v=Math.max(v,E)),d>m?(d=m,R=g):d===m&&(R=Math.min(R,g)),A>d||A===d&&v>R?null:new L(A,v,d,R)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,D){return!C&&!D?!0:!!C&&!!D&&C.startLineNumber===D.startLineNumber&&C.startColumn===D.startColumn&&C.endLineNumber===D.endLineNumber&&C.endColumn===D.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new w.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new w.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,D){return new L(this.startLineNumber,this.startColumn,C,D)}setStartPosition(C,D){return new L(C,D,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(C){return new L(C.endLineNumber,C.endColumn,C.endLineNumber,C.endColumn)}delta(C){return new L(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static fromPositions(C,D=C){return new L(C.lineNumber,C.column,D.lineNumber,D.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,D){return!(C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<D.startColumn||D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<C.startColumn)}static areIntersecting(C,D){return!(C.endLineNumber<D.startLineNumber||C.endLineNumber===D.startLineNumber&&C.endColumn<=D.startColumn||D.endLineNumber<C.startLineNumber||D.endLineNumber===C.startLineNumber&&D.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,D){if(C&&D){const d=C.startLineNumber|0,R=D.startLineNumber|0;if(d===R){const y=C.startColumn|0,E=D.startColumn|0;if(y===E){const m=C.endLineNumber|0,g=D.endLineNumber|0;if(m===g){const b=C.endColumn|0,s=D.endColumn|0;return b-s}return m-g}return y-E}return d-R}return(C?1:0)-(D?1:0)}static compareRangesUsingEnds(C,D){return C.endLineNumber===D.endLineNumber?C.endColumn===D.endColumn?C.startLineNumber===D.startLineNumber?C.startColumn-D.startColumn:C.startLineNumber-D.startLineNumber:C.endColumn-D.endColumn:C.endLineNumber-D.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=L}),define(pe[158],ve([1,0,6,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class o{constructor(){this.a=new Map,this.b=new Map,this.c=new w.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,v){return this.a.set(A,v),this.handleChange([A]),(0,L.toDisposable)(()=>{this.a.get(A)===v&&(this.a.delete(A),this.handleChange([A]))})}get(A){return this.a.get(A)||null}registerFactory(A,v){this.b.get(A)?.dispose();const d=new C(this,A,v);return this.b.set(A,d),(0,L.toDisposable)(()=>{const R=this.b.get(A);!R||R!==d||(this.b.delete(A),R.dispose())})}async getOrCreate(A){const v=this.get(A);if(v)return v;const d=this.b.get(A);return!d||d.isResolved?null:(await d.resolve(),this.get(A))}isResolved(A){if(this.get(A))return!0;const d=this.b.get(A);return!!(!d||d.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=o;class C extends L.Disposable{get isResolved(){return this.c}constructor(A,v,d){super(),this.f=A,this.g=v,this.h=d,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await this.h.tokenizationSupport;this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(pe[159],ve([1,0,48,4,51,158]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(F,H,ee){this.offset=F,this.type=H,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class A{constructor(F,H){this.tokens=F,this.endState=H,this._tokenizationResultBrand=void 0}}e.TokenizationResult=A;class v{constructor(F,H){this.tokens=F,this.endState=H,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=v;var d;(function(I){I[I.Method=0]="Method",I[I.Function=1]="Function",I[I.Constructor=2]="Constructor",I[I.Field=3]="Field",I[I.Variable=4]="Variable",I[I.Class=5]="Class",I[I.Struct=6]="Struct",I[I.Interface=7]="Interface",I[I.Module=8]="Module",I[I.Property=9]="Property",I[I.Event=10]="Event",I[I.Operator=11]="Operator",I[I.Unit=12]="Unit",I[I.Value=13]="Value",I[I.Constant=14]="Constant",I[I.Enum=15]="Enum",I[I.EnumMember=16]="EnumMember",I[I.Keyword=17]="Keyword",I[I.Text=18]="Text",I[I.Color=19]="Color",I[I.File=20]="File",I[I.Reference=21]="Reference",I[I.Customcolor=22]="Customcolor",I[I.Folder=23]="Folder",I[I.TypeParameter=24]="TypeParameter",I[I.User=25]="User",I[I.Issue=26]="Issue",I[I.Snippet=27]="Snippet"})(d||(e.CompletionItemKind=d={}));var R;(function(I){const F=new Map;F.set(0,w.Codicon.symbolMethod),F.set(1,w.Codicon.symbolFunction),F.set(2,w.Codicon.symbolConstructor),F.set(3,w.Codicon.symbolField),F.set(4,w.Codicon.symbolVariable),F.set(5,w.Codicon.symbolClass),F.set(6,w.Codicon.symbolStruct),F.set(7,w.Codicon.symbolInterface),F.set(8,w.Codicon.symbolModule),F.set(9,w.Codicon.symbolProperty),F.set(10,w.Codicon.symbolEvent),F.set(11,w.Codicon.symbolOperator),F.set(12,w.Codicon.symbolUnit),F.set(13,w.Codicon.symbolValue),F.set(15,w.Codicon.symbolEnum),F.set(14,w.Codicon.symbolConstant),F.set(15,w.Codicon.symbolEnum),F.set(16,w.Codicon.symbolEnumMember),F.set(17,w.Codicon.symbolKeyword),F.set(27,w.Codicon.symbolSnippet),F.set(18,w.Codicon.symbolText),F.set(19,w.Codicon.symbolColor),F.set(20,w.Codicon.symbolFile),F.set(21,w.Codicon.symbolReference),F.set(22,w.Codicon.symbolCustomColor),F.set(23,w.Codicon.symbolFolder),F.set(24,w.Codicon.symbolTypeParameter),F.set(25,w.Codicon.account),F.set(26,w.Codicon.issues);function H(ae){let ue=F.get(ae);return ue||(console.info("No codicon found for CompletionItemKind "+ae),ue=w.Codicon.symbolProperty),ue}I.toIcon=H;const ee=new Map;ee.set("method",0),ee.set("function",1),ee.set("constructor",2),ee.set("field",3),ee.set("variable",4),ee.set("class",5),ee.set("struct",6),ee.set("interface",7),ee.set("module",8),ee.set("property",9),ee.set("event",10),ee.set("operator",11),ee.set("unit",12),ee.set("value",13),ee.set("constant",14),ee.set("enum",15),ee.set("enum-member",16),ee.set("enumMember",16),ee.set("keyword",17),ee.set("snippet",27),ee.set("text",18),ee.set("color",19),ee.set("file",20),ee.set("reference",21),ee.set("customcolor",22),ee.set("folder",23),ee.set("type-parameter",24),ee.set("typeParameter",24),ee.set("account",25),ee.set("issue",26);function ce(ae,ue){let ge=ee.get(ae);return typeof ge>"u"&&!ue&&(ge=9),ge}I.fromString=ce})(R||(e.CompletionItemKinds=R={}));var y;(function(I){I[I.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var E;(function(I){I[I.None=0]="None",I[I.KeepWhitespace=1]="KeepWhitespace",I[I.InsertAsSnippet=4]="InsertAsSnippet"})(E||(e.CompletionItemInsertTextRule=E={}));var m;(function(I){I[I.Invoke=0]="Invoke",I[I.TriggerCharacter=1]="TriggerCharacter",I[I.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var g;(function(I){I[I.Automatic=0]="Automatic",I[I.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class b{constructor(F,H,ee,ce){this.range=F,this.text=H,this.completionKind=ee,this.isSnippetText=ce}equals(F){return o.Range.lift(this.range).equalsRange(F.range)&&this.text===F.text&&this.completionKind===F.completionKind&&this.isSnippetText===F.isSnippetText}}e.SelectedSuggestionInfo=b;var s;(function(I){I[I.Invoke=1]="Invoke",I[I.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var h;(function(I){I[I.Invoke=1]="Invoke",I[I.TriggerCharacter=2]="TriggerCharacter",I[I.ContentChange=3]="ContentChange"})(h||(e.SignatureHelpTriggerKind=h={}));var u;(function(I){I[I.Text=0]="Text",I[I.Read=1]="Read",I[I.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function f(I){return I&&L.URI.isUri(I.uri)&&o.Range.isIRange(I.range)&&(o.Range.isIRange(I.originSelectionRange)||o.Range.isIRange(I.targetSelectionRange))}e.isLocationLink=f;var S;(function(I){I[I.File=0]="File",I[I.Module=1]="Module",I[I.Namespace=2]="Namespace",I[I.Package=3]="Package",I[I.Class=4]="Class",I[I.Method=5]="Method",I[I.Property=6]="Property",I[I.Field=7]="Field",I[I.Constructor=8]="Constructor",I[I.Enum=9]="Enum",I[I.Interface=10]="Interface",I[I.Function=11]="Function",I[I.Variable=12]="Variable",I[I.Constant=13]="Constant",I[I.String=14]="String",I[I.Number=15]="Number",I[I.Boolean=16]="Boolean",I[I.Array=17]="Array",I[I.Object=18]="Object",I[I.Key=19]="Key",I[I.Null=20]="Null",I[I.EnumMember=21]="EnumMember",I[I.Struct=22]="Struct",I[I.Event=23]="Event",I[I.Operator=24]="Operator",I[I.TypeParameter=25]="TypeParameter"})(S||(e.SymbolKind=S={}));var O;(function(I){I[I.Deprecated=1]="Deprecated"})(O||(e.SymbolTag=O={}));var t;(function(I){const F=new Map;F.set(0,w.Codicon.symbolFile),F.set(1,w.Codicon.symbolModule),F.set(2,w.Codicon.symbolNamespace),F.set(3,w.Codicon.symbolPackage),F.set(4,w.Codicon.symbolClass),F.set(5,w.Codicon.symbolMethod),F.set(6,w.Codicon.symbolProperty),F.set(7,w.Codicon.symbolField),F.set(8,w.Codicon.symbolConstructor),F.set(9,w.Codicon.symbolEnum),F.set(10,w.Codicon.symbolInterface),F.set(11,w.Codicon.symbolFunction),F.set(12,w.Codicon.symbolVariable),F.set(13,w.Codicon.symbolConstant),F.set(14,w.Codicon.symbolString),F.set(15,w.Codicon.symbolNumber),F.set(16,w.Codicon.symbolBoolean),F.set(17,w.Codicon.symbolArray),F.set(18,w.Codicon.symbolObject),F.set(19,w.Codicon.symbolKey),F.set(20,w.Codicon.symbolNull),F.set(21,w.Codicon.symbolEnumMember),F.set(22,w.Codicon.symbolStruct),F.set(23,w.Codicon.symbolEvent),F.set(24,w.Codicon.symbolOperator),F.set(25,w.Codicon.symbolTypeParameter);function H(ee){let ce=F.get(ee);return ce||(console.info("No codicon found for SymbolKind "+ee),ce=w.Codicon.symbolProperty),ce}I.toIcon=H})(t||(e.SymbolKinds=t={}));class n{static fromValue(F){switch(F){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(F)}constructor(F){this.value=F}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var r;(function(I){function F(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}I.is=F})(r||(e.Command=r={}));var i;(function(I){I[I.Collapsed=0]="Collapsed",I[I.Expanded=1]="Expanded"})(i||(e.CommentThreadCollapsibleState=i={}));var a;(function(I){I[I.Unresolved=0]="Unresolved",I[I.Resolved=1]="Resolved"})(a||(e.CommentThreadState=a={}));var l;(function(I){I[I.Editing=0]="Editing",I[I.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var c;(function(I){I[I.Published=0]="Published",I[I.Draft=1]="Draft"})(c||(e.CommentState=c={}));var p;(function(I){I[I.Type=1]="Type",I[I.Parameter=2]="Parameter"})(p||(e.InlayHintKind=p={}));class P{constructor(F){this.b=F,this.a=null}dispose(){this.a&&this.a.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=P,e.TokenizationRegistry=new C.TokenizationRegistry;var T;(function(I){I[I.None=0]="None",I[I.Option=1]="Option",I[I.Default=2]="Default",I[I.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}))}),define(pe[160],ve([10,11]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(pe[161],ve([1,0,6,2,160]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class C extends L.Disposable{constructor(E,m="",g="",b=!0,s){super(),this.h=this.B(new w.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=E,this.m=m,this.u=g,this.w=b,this.C=s}get id(){return this.j}get label(){return this.m}set label(E){this.D(E)}D(E){this.m!==E&&(this.m=E,this.h.fire({label:E}))}get tooltip(){return this.n||""}set tooltip(E){this.F(E)}F(E){this.n!==E&&(this.n=E,this.h.fire({tooltip:E}))}get class(){return this.u}set class(E){this.G(E)}G(E){this.u!==E&&(this.u=E,this.h.fire({class:E}))}get enabled(){return this.w}set enabled(E){this.H(E)}H(E){this.w!==E&&(this.w=E,this.h.fire({enabled:E}))}get checked(){return this.z}set checked(E){this.I(E)}I(E){this.z!==E&&(this.z=E,this.h.fire({checked:E}))}async run(E,m){this.C&&await this.C(E)}}e.Action=C;class D extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new w.Emitter),this.onWillRun=this.f.event,this.h=this.B(new w.Emitter),this.onDidRun=this.h.event}async run(E,m){if(!E.enabled)return;this.f.fire({action:E});let g;try{await this.k(E,m)}catch(b){g=b}this.h.fire({action:E,error:g})}async k(E,m){await E.run(m)}}e.ActionRunner=D;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...E){let m=[];for(const g of E)g.length&&(m.length?m=[...m,new A,...g]:m=g);return m}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class v{get actions(){return this.a}constructor(E,m,g,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=E,this.label=m,this.class=b,this.a=g}async run(){}}e.SubmenuAction=v;class d extends C{constructor(){super(d.ID,o.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=d,d.ID="vs.actions.empty";function R(y){return{id:y.id,label:y.label,class:void 0,enabled:y.enabled??!0,checked:y.checked??!1,run:async()=>y.run(),tooltip:y.label}}e.toAction=R}),define(pe[162],ve([10,11]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(pe[163],ve([1,0,162]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,o=L*60,C=o*24,D=C*7,A=C*30,v=C*365;function d(y,E,m,g){typeof y!="number"&&(y=y.getTime());const b=Math.round((new Date().getTime()-y)/1e3);if(b<-30)return(0,w.localize)(0,null,d(new Date().getTime()+b*1e3,!1));if(!g&&b<30)return(0,w.localize)(1,null);let s;return b<L?(s=b,E?s===1?m?(0,w.localize)(2,null,s):(0,w.localize)(3,null,s):m?(0,w.localize)(4,null,s):(0,w.localize)(5,null,s):s===1?m?(0,w.localize)(6,null,s):(0,w.localize)(7,null,s):m?(0,w.localize)(8,null,s):(0,w.localize)(9,null,s)):b<o?(s=Math.floor(b/L),E?s===1?m?(0,w.localize)(10,null,s):(0,w.localize)(11,null,s):m?(0,w.localize)(12,null,s):(0,w.localize)(13,null,s):s===1?m?(0,w.localize)(14,null,s):(0,w.localize)(15,null,s):m?(0,w.localize)(16,null,s):(0,w.localize)(17,null,s)):b<C?(s=Math.floor(b/o),E?s===1?m?(0,w.localize)(18,null,s):(0,w.localize)(19,null,s):m?(0,w.localize)(20,null,s):(0,w.localize)(21,null,s):s===1?m?(0,w.localize)(22,null,s):(0,w.localize)(23,null,s):m?(0,w.localize)(24,null,s):(0,w.localize)(25,null,s)):b<D?(s=Math.floor(b/C),E?s===1?(0,w.localize)(26,null,s):(0,w.localize)(27,null,s):s===1?(0,w.localize)(28,null,s):(0,w.localize)(29,null,s)):b<A?(s=Math.floor(b/D),E?s===1?m?(0,w.localize)(30,null,s):(0,w.localize)(31,null,s):m?(0,w.localize)(32,null,s):(0,w.localize)(33,null,s):s===1?m?(0,w.localize)(34,null,s):(0,w.localize)(35,null,s):m?(0,w.localize)(36,null,s):(0,w.localize)(37,null,s)):b<v?(s=Math.floor(b/A),E?s===1?m?(0,w.localize)(38,null,s):(0,w.localize)(39,null,s):m?(0,w.localize)(40,null,s):(0,w.localize)(41,null,s):s===1?m?(0,w.localize)(42,null,s):(0,w.localize)(43,null,s):m?(0,w.localize)(44,null,s):(0,w.localize)(45,null,s)):(s=Math.floor(b/v),E?s===1?m?(0,w.localize)(46,null,s):(0,w.localize)(47,null,s):m?(0,w.localize)(48,null,s):(0,w.localize)(49,null,s):s===1?m?(0,w.localize)(50,null,s):(0,w.localize)(51,null,s):m?(0,w.localize)(52,null,s):(0,w.localize)(53,null,s))}e.fromNow=d;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[164],ve([10,11]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(pe[39],ve([1,0,18,8,164]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(y,E){return E&&(y.stack||y.stacktrace)?o.localize(0,null,A(y),D(y.stack)||D(y.stacktrace)):A(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?o.localize(1,null,y.message):y.message||o.localize(2,null)}function v(y=null,E=!1){if(!y)return o.localize(3,null);if(Array.isArray(y)){const m=w.coalesce(y),g=v(m[0],E);return m.length>1?o.localize(4,null,g,m.length):g}if(L.isString(y))return y;if(y.detail){const m=y.detail;if(m.error)return C(m.error,E);if(m.exception)return C(m.exception,E)}return y.stack?C(y,E):y.message?y.message:o.localize(5,null)}e.toErrorMessage=v;function d(y){const E=y;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=d;function R(y,E){let m;return typeof y=="string"?m=new Error(y):m=y,m.actions=E,m}e.createErrorWithActions=R}),define(pe[165],ve([10,11]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(pe[166],ve([1,0,165]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(o){switch(o){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(pe[167],ve([10,11]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(pe[168],ve([10,11]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[169],ve([10,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[170],ve([10,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(pe[171],ve([10,11]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(pe[172],ve([10,11]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(pe[173],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[174],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[175],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[176],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[177],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[178],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[179],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[180],ve([10,11]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[181],ve([10,11]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(pe[182],ve([10,11]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(pe[183],ve([10,11]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(pe[184],ve([10,11]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[185],ve([10,11]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[186],ve([10,11]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(pe[187],ve([10,11]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(pe[188],ve([10,11]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(pe[189],ve([10,11]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[190],ve([10,11]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[191],ve([10,11]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[192],ve([10,11]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[193],ve([10,11]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(pe[194],ve([10,11]),function(oe,e){return oe.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[195],ve([10,11]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(pe[196],ve([10,11]),function(oe,e){return oe.create("vs/server/node/serverServices",e)}),define(pe[197],ve([10,11]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[198],ve([10,11]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(pe[199],ve([10,11]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[200],ve([10,11]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[201],ve([1,0,9,170]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var o;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(o||(e.TokenType=o={}));function C(...d){switch(d.length){case 1:return(0,L.localize)(0,null,d[0]);case 2:return(0,L.localize)(1,null,d[0],d[1]);case 3:return(0,L.localize)(2,null,d[0],d[1],d[2]);default:return}}const D=(0,L.localize)(3,null),A=(0,L.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,w.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(C("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(C("&&"));break;case 124:this.h(124)?this.k(16):this.l(C("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const y=this.d,E=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:E};this.g.push({offset:y,lexeme:E,additionalInfo:R}),this.f.push(m)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const y=this.c.substring(this.d,this.e),E=v.b.get(y);E?this.k(E):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,y=!1,E=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(A);return}const g=this.c.charCodeAt(R);if(y)y=!1;else if(g===47&&!E){R++;break}else g===91?E=!0:g===92?y=!0:g===93&&(E=!1);R++}for(;R<this.c.length&&v.a.has(this.c.charCodeAt(R));)R++;this.e=R;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=v,v.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(pe[202],ve([1,0,6,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class o{constructor(){this.a=new w.Emitter,this.b=new w.Emitter,this.c=new w.Emitter,this.d=new w.Emitter}call(A,v,d){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(A,v,d){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=o,o.ChannelName="extensionhostdebugservice";class C extends L.Disposable{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,v,d){this.b.call("attach",[A,v,d])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,v){this.b.call("terminate",[A,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,v){return this.b.call("openExtensionDevelopmentHostWindow",[A,v])}}e.ExtensionHostDebugChannelClient=C}),define(pe[203],ve([1,0,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class L{constructor(D){this.a=D}listen(D,A,v){throw new Error("Invalid listen")}call(D,A,v){switch(A){case"download":return this.a.download(w.URI.revive(v[0]),w.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=L;class o{constructor(D,A){this.a=D,this.b=A}async download(D,A){const v=this.b();v&&(D=v.transformOutgoingURI(D),A=v.transformOutgoingURI(A)),await this.a.call("download",[D,A])}}e.DownloadServiceChannelClient=o}),define(pe[204],ve([1,0,163,92,13,7,29,19,4]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,C.dirname)(o.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,A.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",m)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(v.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=D.env.VSCODE_PORTABLE;return m?v.URI.file((0,C.join)(m,"argv.json")):(0,A.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,C.resolve)(m):(0,C.normalize)((0,C.join)(o.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?v.URI.file((0,C.resolve)(m)):v.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,C.resolve)(m);const g=D.env.VSCODE_EXTENSIONS;if(g)return g;const b=D.env.VSCODE_PORTABLE;return b?(0,C.join)(b,"extensions"):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(g=>/^[^:/?#]+?:\/\//.test(g)?v.URI.parse(g):v.URI.file((0,C.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?v.URI.parse(m):v.URI.file((0,C.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const g of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);b&&b[1]&&b[2]&&m.push([b[1],b[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,A.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=D.env.VSCODE_PORTABLE;return m?v.URI.file((0,C.join)(m,"policy.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,g,b){this.a=m,this.b=g,this.c=b,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=d,Le([L.memoize],d.prototype,"appRoot",null),Le([L.memoize],d.prototype,"userHome",null),Le([L.memoize],d.prototype,"userDataPath",null),Le([L.memoize],d.prototype,"appSettingsHome",null),Le([L.memoize],d.prototype,"tmpDir",null),Le([L.memoize],d.prototype,"cacheHome",null),Le([L.memoize],d.prototype,"stateResource",null),Le([L.memoize],d.prototype,"userRoamingDataHome",null),Le([L.memoize],d.prototype,"userDataSyncHome",null),Le([L.memoize],d.prototype,"sync",null),Le([L.memoize],d.prototype,"machineSettingsResource",null),Le([L.memoize],d.prototype,"workspaceStorageHome",null),Le([L.memoize],d.prototype,"localHistoryHome",null),Le([L.memoize],d.prototype,"keyboardLayoutResource",null),Le([L.memoize],d.prototype,"argvResource",null),Le([L.memoize],d.prototype,"isExtensionDevelopment",null),Le([L.memoize],d.prototype,"untitledWorkspacesHome",null),Le([L.memoize],d.prototype,"builtinExtensionsPath",null),Le([L.memoize],d.prototype,"extensionsPath",null),Le([L.memoize],d.prototype,"extensionDevelopmentLocationURI",null),Le([L.memoize],d.prototype,"extensionDevelopmentKind",null),Le([L.memoize],d.prototype,"extensionTestsLocationURI",null),Le([L.memoize],d.prototype,"debugExtensionHost",null),Le([L.memoize],d.prototype,"logLevel",null),Le([L.memoize],d.prototype,"extensionLogLevel",null),Le([L.memoize],d.prototype,"serviceMachineIdResource",null),Le([L.memoize],d.prototype,"disableTelemetry",null),Le([L.memoize],d.prototype,"disableWorkspaceTrust",null),Le([L.memoize],d.prototype,"policyFile",null);function R(E,m){return y(E["inspect-extensions"],E["inspect-brk-extensions"],5870,m,E.debugId,E.extensionEnvironment)}e.parseExtensionHostDebugPort=R;function y(E,m,g,b,s,h){const f=Number(m||E)||(b?null:g),S=f?!!m:!1;let O;if(h)try{O=JSON.parse(h)}catch{}return{port:f,break:S,debugId:s,env:O}}e.parseDebugParams=y}),define(pe[62],ve([1,0,295,3,171]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,o.localize)(0,null),e:(0,o.localize)(1,null),t:(0,o.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,o.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,o.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,o.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,o.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,o.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,o.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,o.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,o.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,o.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,o.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,o.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,o.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,o.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,o.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,o.localize)(17,null)},category:{type:"string",cat:"e",description:(0,o.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,o.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,o.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,o.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,o.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,o.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,o.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,o.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,o.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,o.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,o.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,o.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,o.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,o.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,o.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,o.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,o.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(b,s,h=D){const u=b.find(l=>l.length>0&&l[0]!=="-"),f={},S=["_"],O=[],t={};let n;for(const l in s){const c=s[l];c.type==="subcommand"?l===u&&(n=c):(c.alias&&(f[l]=c.alias),c.type==="string"||c.type==="string[]"?(S.push(l),c.deprecates&&S.push(...c.deprecates)):c.type==="boolean"&&(O.push(l),c.deprecates&&O.push(...c.deprecates)),c.global&&(t[l]=c))}if(n&&u){const l=t;for(const T in n.options)l[T]=n.options[T];const c=b.filter(T=>T!==u),p=h.getSubcommandReporter?h.getSubcommandReporter(u):void 0,P=A(c,l,p);return{[u]:P,_:[]}}const r=w(b,{string:S,boolean:O,alias:f}),i={},a=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in s){const c=s[l];if(c.type==="subcommand")continue;c.alias&&delete a[c.alias];let p=a[l];if(c.deprecates)for(const P of c.deprecates)a.hasOwnProperty(P)&&(p||(p=a[P],p&&h.onDeprecatedOption(P,c.deprecationMessage||(0,o.localize)(35,null,l))),delete a[P]);if(typeof p<"u"){if(c.type==="string[]"){if(Array.isArray(p)||(p=[p]),!c.allowEmptyValue){const P=p.filter(T=>T.length>0);P.length!==p.length&&(h.onEmptyValue(l),p=P.length>0?P:void 0)}}else c.type==="string"&&(Array.isArray(p)?(p=p.pop(),h.onMultipleValues(l,p)):!p&&!c.allowEmptyValue&&(h.onEmptyValue(l),p=void 0));i[l]=p,c.deprecationMessage&&h.onDeprecatedOption(l,c.deprecationMessage)}delete a[l]}for(const l in a)h.onUnknownOption(l);return i}e.parseArgs=A;function v(b,s){let h="";return s.args&&(Array.isArray(s.args)?h=` <${s.args.join("> <")}>`:h=` <${s.args}>`),s.alias?`-${s.alias} --${b}${h}`:`--${b}${h}`}function d(b,s){const h=[];for(const u in b){const f=b[u],S=v(u,f);h.push([S,f.description])}return R(h,s)}e.formatOptions=d;function R(b,s){const u=b.reduce((O,t)=>Math.max(O,t[0].length),12)+2+1;if(s-u<25)return b.reduce((O,t)=>O.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=s-u-1,S=[];for(const O of b){const t=O[0],n=E(O[1],f),r=y(u-t.length-2);S.push("  "+t+r+n[0]);for(let i=1;i<n.length;i++)S.push(y(u)+n[i])}return S}function y(b){return" ".repeat(b)}function E(b,s){const h=[];for(;b.length;){const u=b.length<s?b.length:b.lastIndexOf(" ",s),f=b.slice(0,u).trim();b=b.slice(u),h.push(f)}return h}function m(b,s,h,u,f){const S=process.stdout.isTTY&&process.stdout.columns||80,O=f?.noInputFiles!==!0?`[${(0,o.localize)(36,null)}...]`:"",t=[`${b} ${h}`];t.push(""),t.push(`${(0,o.localize)(37,null)}: ${s} [${(0,o.localize)(38,null)}]${O}`),t.push(""),f?.noPipe!==!0&&(L.isWindows?t.push((0,o.localize)(39,null,s)):t.push((0,o.localize)(40,null,s)),t.push(""));const n={},r=[];for(const i in u){const a=u[i];if(a.type==="subcommand")a.description&&r.push({command:i,description:a.description});else if(a.description&&a.cat){let l=n[a.cat];l||(n[a.cat]=l={}),l[i]=a}}for(const i in n){const a=i,l=n[a];l&&(t.push(C[a]),t.push(...d(l,S)),t.push(""))}return r.length&&(t.push((0,o.localize)(41,null)),t.push(...R(r.map(i=>[i.command,i.description]),S)),t.push("")),t.join(`
`)}e.buildHelpMessage=m;function g(b,s){return`${b||(0,o.localize)(42,null)}
${s||(0,o.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=g}),define(pe[205],ve([1,0,296,172,62]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function C(y,E){const m=(f,S)=>{console.warn((0,L.localize)(0,null,f,S))},g=f=>{console.warn((0,L.localize)(1,null,f))},b=(f,S)=>{console.warn((0,L.localize)(2,null,f,S))},s=f=>({onUnknownOption:S=>{f!=="tunnel"&&console.warn((0,L.localize)(3,null,S,f))},onMultipleValues:m,onEmptyValue:g,onDeprecatedOption:b,getSubcommandReporter:f!=="tunnel"?s:void 0}),h={onUnknownOption:f=>{console.warn((0,L.localize)(4,null,f))},onMultipleValues:m,onEmptyValue:g,onDeprecatedOption:b,getSubcommandReporter:s},u=(0,o.parseArgs)(y,o.OPTIONS,E?h:void 0);return u.goto&&u._.forEach(f=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(5,null))),u}function D(y){const E=y.findIndex(m=>!/^-/.test(m));if(E>-1)return[...y.slice(0,E),...y.slice(E+1)]}function A(y){let[,...E]=y;process.env.VSCODE_DEV&&(E=D(E)||[]);const m=!R(process.env);return C(E,m)}e.parseMainProcessArgv=A;function v(y){let[,,...E]=y;return process.env.VSCODE_DEV&&(E=D(E)||[]),C(E,!0)}e.parseCLIProcessArgv=v;function d(y,...E){const m=y.indexOf("--");return m===-1?y.push(...E):y.splice(m,0,...E),y}e.addArg=d;function R(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function oe(e,w,L){function o(D,A){const v=C(D,A),d=[v];return e.isAbsolute(v)||d.unshift(L),e.resolve(...d)}function C(D,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,A);const R=D["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(y,"AppData","Roaming")}break;case"darwin":d=e.join(w.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,A)}return{getUserDataPath:o}}if(typeof define=="function")define(pe[206],ve([75,26,29]),function(e,w,L){return oe(e,w,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=oe(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[107],ve([1,0,26,204,206]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class C extends L.AbstractNativeEnvironmentService{constructor(d,R){super(d,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,o.getUserDataPath)(d,R.nameShort)},R)}}e.NativeEnvironmentService=C;function D(v,d){return(0,L.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,d,v.extensionEnvironment)}e.parsePtyHostDebugPort=D;function A(v,d){return(0,L.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,d,v.extensionEnvironment)}e.parseSharedProcessDebugPort=A}),define(pe[207],ve([1,0,8,176]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function o(D,A,v){try{C(D,A,v)}catch(d){console.error(d?.message??d)}return D}e.localizeManifest=o;function C(D,A,v){const d=(R,y,E)=>{const m=R[y];if((0,w.isString)(m)){const g=m,b=g.length;if(b>1&&g[0]==="%"&&g[b-1]==="%"){const s=g.substr(1,b-2);let h=A[s];h===void 0&&v&&(h=v[s]);const u=typeof h=="string"?h:h?.message,f=v?.[s],S=typeof f=="string"?f:f?.message;if(!u){S||console.warn(`[${D.name}]: ${(0,L.localize)(0,null,s)}`);return}if(E&&(y==="title"||y==="category")&&S&&S!==u){const O={value:u,original:S};R[y]=O}else R[y]=u}}else if((0,w.isObject)(m))for(const g in m)m.hasOwnProperty(g)&&(g==="commands"?d(m,g,!0):d(m,g,E));else if(Array.isArray(m))for(let g=0;g<m.length;g++)d(m,g,E)};for(const R in D)D.hasOwnProperty(R)&&d(D,R)}}),define(pe[77],ve([1,0,19,59,180,52]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function v(h){return h=h.trim(),h==="*"||D.test(h)}e.isValidVersionStr=v;function d(h){if(!v(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(D);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=d;function R(h){if(!h)return null;const u=h.majorBase,f=h.majorMustEqual,S=h.minorBase;let O=h.minorMustEqual;const t=h.patchBase;let n=h.patchMustEqual;h.hasCaret&&(u===0||(O=!1),n=!1);let r=0;if(h.preRelease){const i=A.exec(h.preRelease);if(i){const[,a,l,c]=i;r=Date.UTC(Number(a),Number(l)-1,Number(c))}}return{majorBase:u,majorMustEqual:f,minorBase:S,minorMustEqual:O,patchBase:t,patchMustEqual:n,isMinimum:h.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function y(h,u,f){let S;typeof h=="string"?S=R(d(h)):S=h;let O;u instanceof Date?O=u.getTime():typeof u=="string"&&(O=new Date(u).getTime());let t;if(typeof f=="string"?t=R(d(f)):t=f,!S||!t)return!1;const n=S.majorBase,r=S.minorBase,i=S.patchBase;let a=t.majorBase,l=t.minorBase,c=t.patchBase;const p=t.notBefore;let P=t.majorMustEqual,T=t.minorMustEqual,I=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:r>l?!0:r<l||O&&O<p?!1:i>=c:(n===1&&a===0&&(!P||!T||!I)&&(a=1,l=0,c=0,P=!0,T=!1,I=!1),n<a?!1:n>a?!P:r<l?!1:r>l?!T:i<c?!1:i>c?!I:!(O&&O<p))}e.isValidVersion=y;function E(h,u,f,S,O){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([L.default.Error,o.localize(0,null)]),t;if(typeof S.name!="string")return t.push([L.default.Error,o.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([L.default.Error,o.localize(2,null,"version")]),t;if(!S.engines)return t.push([L.default.Error,o.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([L.default.Error,o.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!s(S.extensionDependencies))return t.push([L.default.Error,o.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!s(S.activationEvents))return t.push([L.default.Error,o.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([L.default.Error,o.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([L.default.Warning,o.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([L.default.Error,o.localize(9,null,"main")]),t;{const i=(0,w.joinPath)(f,S.main);(0,w.isEqualOrParent)(i,f)||t.push([L.default.Warning,o.localize(10,null,i.path,f.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([L.default.Error,o.localize(11,null,"browser")]),t;{const i=(0,w.joinPath)(f,S.browser);(0,w.isEqualOrParent)(i,f)||t.push([L.default.Warning,o.localize(12,null,i.path,f.path)])}}if(!C.valid(S.version))return t.push([L.default.Error,o.localize(13,null)]),t;const n=[];if(!m(h,u,S,O,n))for(const i of n)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=E;function m(h,u,f,S,O){return S||typeof f.main>"u"&&typeof f.browser>"u"?!0:b(h,u,f.engines.vscode,O)}e.isValidExtensionVersion=m;function g(h,u,f){return h==="*"||b(u,f,h)}e.isEngineValid=g;function b(h,u,f,S=[]){const O=R(d(f));if(!O)return S.push(o.localize(14,null,f)),!1;if(O.majorBase===0){if(!O.majorMustEqual||!O.minorMustEqual)return S.push(o.localize(15,null,f)),!1}else if(!O.majorMustEqual)return S.push(o.localize(16,null,f)),!1;return y(h,u,O)?!0:(S.push(o.localize(17,null,h,f)),!1)}function s(h){if(!Array.isArray(h))return!1;for(let u=0,f=h.length;u<f;u++)if(typeof h[u]!="string")return!1;return!0}}),define(pe[208],ve([1,0,15,21]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function o(C,D,A){let v=A&&A.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const R=(await D.readFile(C.serviceMachineIdResource)).value.toString();v=(0,L.isUUID)(R)?R:null}catch{v=null}if(!v){v=(0,L.generateUuid)();try{await D.writeFile(C.serviceMachineIdResource,w.VSBuffer.fromString(v))}catch{}}return A?.store("storage.serviceMachineId",v,-1,1),v}e.getServiceMachineId=o}),define(pe[63],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(o,C=[],D=!1){this.ctor=o,this.staticArguments=C,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w}),define(pe[209],ve([1,0,63]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var o;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(o||(e.InstantiationType=o={}));function C(A,v,d){v instanceof w.SyncDescriptor||(v=new w.SyncDescriptor(v,[],!!d)),L.push([A,v])}e.registerSingleton=C;function D(){return L}e.getSingletonServiceDescriptors=D}),define(pe[210],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(C,D){this.key=C,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class L{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const D of this.a.values())D.outgoing.size===0&&C.push(D);return C}insertEdge(C,D){const A=this.lookupOrInsertNode(C),v=this.lookupOrInsertNode(D);A.outgoing.set(v.key,v),v.incoming.set(A.key,A)}removeNode(C){const D=this.b(C);this.a.delete(D);for(const A of this.a.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(C){const D=this.b(C);let A=this.a.get(D);return A||(A=new w(D,C),this.a.set(D,A)),A}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[D,A]of this.a)C.push(`${D}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,D]of this.a){const A=new Set([C]),v=this.c(D,A);if(v)return v}}c(C,D){for(const[A,v]of C.outgoing){if(D.has(A))return[...D,A].join(" -> ");D.add(A);const d=this.c(v,D);if(d)return d;D.delete(A)}}}e.Graph=L}),define(pe[5],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(v){return v[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(w||(e._util=w={})),e.IInstantiationService=o("instantiationService");function L(D,A,v){A[w.DI_TARGET]===A?A[w.DI_DEPENDENCIES].push({id:D,index:v}):(A[w.DI_DEPENDENCIES]=[{id:D,index:v}],A[w.DI_TARGET]=A)}function o(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const A=function(v,d,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(A,v,R)};return A.toString=()=>D,w.serviceIds.set(D,A),A}e.createDecorator=o;function C(D){return D}e.refineServiceDecorator=C}),define(pe[24],ve([1,0,8,4,5]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,o.createDecorator)("configurationService");function C(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationOverrides=C;function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=D;var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function v(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=v;function d(s,h){const u=Object.create(null);for(const f in s)R(u,f,s[f],h);return u}e.toValuesTree=d;function R(s,h,u,f){const S=h.split("."),O=S.pop();let t=s;for(let n=0;n<S.length;n++){const r=S[n];let i=t[r];switch(typeof i){case"undefined":i=t[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${h} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[O]=u}catch{f(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(t)}`)}else f(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=R;function y(s,h){const u=h.split(".");E(s,u)}e.removeFromValueTree=y;function E(s,h){const u=h.shift();if(h.length===0){delete s[u];return}if(Object.keys(s).indexOf(u)!==-1){const f=s[u];typeof f=="object"&&!Array.isArray(f)&&(E(f,h),Object.keys(f).length===0&&delete s[u])}}function m(s,h,u){function f(t,n){let r=t;for(const i of n){if(typeof r!="object"||r===null)return;r=r[i]}return r}const S=h.split("."),O=f(s,S);return typeof O>"u"?u:O}e.getConfigurationValue=m;function g(s,h,u){Object.keys(h).forEach(f=>{f!=="__proto__"&&(f in s?w.isObject(s[f])&&w.isObject(h[f])?g(s[f],h[f],u):u&&(s[f]=h[f]):s[f]=h[f])})}e.merge=g;function b(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(pe[64],ve([1,0,3,17,201,5,169,9]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",w.isMacintosh),v.set("isLinux",w.isLinux),v.set("isWindows",w.isWindows),v.set("isWeb",w.isWeb),v.set("isMacNative",w.isMacintosh&&!w.isWeb),v.set("isEdge",w.isEdge),v.set("isFirefox",w.isFirefox),v.set("isChrome",w.isChrome),v.set("isSafari",w.isSafari);function d(N,k){if(v.get(N)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(N,k)}e.setConstant=d;const R=Object.prototype.hasOwnProperty;var y;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const E={regexParsingWithErrorRecovery:!0},m=(0,D.localize)(0,null),g=(0,D.localize)(1,null),b=(0,D.localize)(2,null),s=(0,D.localize)(3,null),h=(0,D.localize)(4,null),u=(0,D.localize)(5,null),f=(0,D.localize)(6,null),S=(0,D.localize)(7,null);class O{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=E){this.k=k,this.d=new o.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const X=this.D(),ne=X.type===17?u:void 0;throw this.h.push({message:h,offset:X.offset,lexeme:o.Scanner.getLexeme(X),additionalInfo:ne}),O.c}return U}catch(U){if(U!==O.c)throw U;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const U=this.o();k.push(U)}return k.length===1?k[0]:t.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const U=this.s();k.push(U)}return k.length===1?k[0]:t.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,s),U?.negate()}case 17:return this.z(),F.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,s),U}case 17:{const U=k.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const z=ne.lexeme,j=z.lastIndexOf("/"),Y=j===z.length-1?void 0:this.w(z.substring(j+1));let x;try{x=new RegExp(z.substring(1,j),Y)}catch{throw this.B("REGEX",ne)}return ge.create(U,x)}switch(ne.type){case 10:case 19:{const z=[ne.lexeme];this.z();let j=this.D(),Y=0;for(let le=0;le<ne.lexeme.length;le++)ne.lexeme.charCodeAt(le)===40?Y++:ne.lexeme.charCodeAt(le)===41&&Y--;for(;!this.E()&&j.type!==15&&j.type!==16;){switch(j.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let le=0;le<j.lexeme.length;le++)j.lexeme.charCodeAt(le)===40?Y++:ne.lexeme.charCodeAt(le)===41&&Y--}if(Y<0)break;z.push(o.Scanner.getLexeme(j)),this.z(),j=this.D()}const x=z.join(""),Z=x.lastIndexOf("/"),J=Z===x.length-1?void 0:this.w(x.substring(Z+1));let _;try{_=new RegExp(x.substring(1,Z),J)}catch{throw this.B("REGEX",ne)}return t.regex(U,_)}case 18:{const z=ne.lexeme;this.z();let j=null;if(!(0,L.isFalsyOrWhitespace)(z)){const Y=z.indexOf("/"),x=z.lastIndexOf("/");if(Y!==x&&Y>=0){const Z=z.slice(Y+1,x),J=z[x+1]==="i"?"i":"";try{j=new RegExp(Z,J)}catch{throw this.B("REGEX",ne)}}}if(j===null)throw this.B("REGEX",ne);return ge.create(U,j)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const ne=this.u();return t.notIn(U,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(U,ne);switch(ne){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(U,ne);switch(ne){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,ne)}}case 5:return this.z(),ae.create(U,this.u());case 6:return this.z(),ue.create(U,this.u());case 7:return this.z(),ee.create(U,this.u());case 8:return this.z(),ce.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:f,offset:k.offset,lexeme:"",additionalInfo:S}),O.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,U){if(this.C(k))return this.z();throw this.B(U,this.D())}B(k,U,X){const ne=(0,D.localize)(8,null,k,o.Scanner.getLexeme(U)),z=U.offset,j=o.Scanner.getLexeme(U);return this.h.push({message:ne,offset:z,lexeme:j,additionalInfo:X}),O.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=O,O.c=new Error;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(k){return c.create(k)}static equals(k,U){return p.create(k,U)}static notEquals(k,U){return I.create(k,U)}static regex(k,U){return ge.create(k,U)}static in(k,U){return P.create(k,U)}static notIn(k,U){return T.create(k,U)}static not(k){return F.create(k)}static and(...k){return W.create(k,null,!0)}static or(...k){return K.create(k,null,!0)}static greater(k,U){return ee.create(k,U)}static greaterEquals(k,U){return ce.create(k,U)}static smaller(k,U){return ae.create(k,U)}static smallerEquals(k,U){return ue.create(k,U)}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.ContextKeyExpr=t,t.c=new O({regexParsingWithErrorRecovery:!1});function n(N){const k=new O({regexParsingWithErrorRecovery:!1});return N.map(U=>(k.parse(U),k.lexingErrors.length>0?k.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,D.localize)(9,null,X.additionalInfo):(0,D.localize)(10,null),offset:X.offset,length:X.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}e.validateWhenClauses=n;function r(N,k){const U=N?N.substituteConstants():void 0,X=k?k.substituteConstants():void 0;return!U&&!X?!0:!U||!X?!1:U.equals(X)}e.expressionsAreEqualWithConstantSubstitution=r;function i(N,k){return N.cmp(k)}class a{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class l{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class c{static create(k,U=null){const X=v.get(k);return typeof X=="boolean"?X?l.INSTANCE:a.INSTANCE:new c(k,U)}constructor(k,U){this.key=k,this.c=U,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:ie(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=v.get(this.key);return typeof k=="boolean"?k?l.INSTANCE:a.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class p{static create(k,U,X=null){if(typeof U=="boolean")return U?c.create(k,X):F.create(k,X);const ne=v.get(k);return typeof ne=="boolean"?U===(ne?"true":"false")?l.INSTANCE:a.INSTANCE:new p(k,U,X)}constructor(k,U,X){this.c=k,this.d=U,this.f=X,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:re(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=v.get(this.c);if(typeof k=="boolean"){const U=k?"true":"false";return this.d===U?l.INSTANCE:a.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=p;class P{static create(k,U){return new P(k,U)}constructor(k,U){this.d=k,this.f=U,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:re(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.f),X=k.getValue(this.d);return Array.isArray(U)?U.includes(X):typeof X=="string"&&typeof U=="object"&&U!==null?R.call(U,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=P;class T{static create(k,U){return new T(k,U)}constructor(k,U){this.d=k,this.f=U,this.type=11,this.c=P.create(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=T;class I{static create(k,U,X=null){if(typeof U=="boolean")return U?F.create(k,X):c.create(k,X);const ne=v.get(k);return typeof ne=="boolean"?U===(ne?"true":"false")?a.INSTANCE:l.INSTANCE:new I(k,U,X)}constructor(k,U,X){this.c=k,this.d=U,this.f=X,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:re(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=v.get(this.c);if(typeof k=="boolean"){const U=k?"true":"false";return this.d===U?a.INSTANCE:l.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=I;class F{static create(k,U=null){const X=v.get(k);return typeof X=="boolean"?X?a.INSTANCE:l.INSTANCE:new F(k,U)}constructor(k,U){this.c=k,this.d=U,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:ie(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=v.get(this.c);return typeof k=="boolean"?k?a.INSTANCE:l.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=F;function H(N,k){if(typeof N=="string"){const U=parseFloat(N);isNaN(U)||(N=U)}return typeof N=="string"||typeof N=="number"?k(N):a.INSTANCE}class ee{static create(k,U,X=null){return H(U,ne=>new ee(k,ne,X))}constructor(k,U,X){this.c=k,this.d=U,this.f=X,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:re(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=ee;class ce{static create(k,U,X=null){return H(U,ne=>new ce(k,ne,X))}constructor(k,U,X){this.c=k,this.d=U,this.f=X,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:re(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=ce;class ae{static create(k,U,X=null){return H(U,ne=>new ae(k,ne,X))}constructor(k,U,X){this.c=k,this.d=U,this.f=X,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:re(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ae;class ue{static create(k,U,X=null){return H(U,ne=>new ue(k,ne,X))}constructor(k,U,X){this.c=k,this.d=U,this.f=X,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:re(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ue;class ge{static create(k,U){return new ge(k,U)}constructor(k,U){this.d=k,this.f=U,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const U=this.f?this.f.source:"",X=k.f?k.f.source:"";return U<X?-1:U>X?1:0}equals(k){if(k.type===this.type){const U=this.f?this.f.source:"",X=k.f?k.f.source:"";return this.d===k.d&&U===X}return!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.ContextKeyRegexExpr=ge;class G{static create(k){return new G(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new G(this.c.map(k))}negate(){return this.c}}e.ContextKeyNotRegexExpr=G;function te(N){let k=null;for(let U=0,X=N.length;U<X;U++){const ne=N[U].substituteConstants();if(N[U]!==ne&&k===null){k=[];for(let z=0;z<U;z++)k[z]=N[z]}k!==null&&(k[U]=ne)}return k===null?N:k}class W{static create(k,U,X){return W.d(k,U,X)}constructor(k,U){this.expr=k,this.c=U,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,X=this.expr.length;U<X;U++){const ne=i(this.expr[U],k.expr[U]);if(ne!==0)return ne}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=te(this.expr);return k===this.expr?this:W.create(k,this.c,!1)}evaluate(k){for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static d(k,U,X){const ne=[];let z=!1;for(const j of k)if(j){if(j.type===1){z=!0;continue}if(j.type===0)return a.INSTANCE;if(j.type===6){ne.push(...j.expr);continue}ne.push(j)}if(ne.length===0&&z)return l.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(i);for(let j=1;j<ne.length;j++)ne[j-1].equals(ne[j])&&(ne.splice(j,1),j--);if(ne.length===1)return ne[0];for(;ne.length>1;){const j=ne[ne.length-1];if(j.type!==9)break;ne.pop();const Y=ne.pop(),x=ne.length===0,Z=K.create(j.expr.map(J=>W.create([J,Y],null,X)),null,x);Z&&(ne.push(Z),ne.sort(i))}if(ne.length===1)return ne[0];if(X){for(let j=0;j<ne.length;j++)for(let Y=j+1;Y<ne.length;Y++)if(ne[j].negate().equals(ne[Y]))return a.INSTANCE;if(ne.length===1)return ne[0]}return new W(ne,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new W(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.c){const k=[];for(const U of this.expr)k.push(U.negate());this.c=K.create(k,this,!0)}return this.c}}e.ContextKeyAndExpr=W;class K{static create(k,U,X){return K.d(k,U,X)}constructor(k,U){this.expr=k,this.c=U,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,X=this.expr.length;U<X;U++){const ne=i(this.expr[U],k.expr[U]);if(ne!==0)return ne}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,X=this.expr.length;U<X;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=te(this.expr);return k===this.expr?this:K.create(k,this.c,!1)}evaluate(k){for(let U=0,X=this.expr.length;U<X;U++)if(this.expr[U].evaluate(k))return!0;return!1}static d(k,U,X){let ne=[],z=!1;if(k){for(let j=0,Y=k.length;j<Y;j++){const x=k[j];if(x){if(x.type===0){z=!0;continue}if(x.type===1)return l.INSTANCE;if(x.type===9){ne=ne.concat(x.expr);continue}ne.push(x)}}if(ne.length===0&&z)return a.INSTANCE;ne.sort(i)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let j=1;j<ne.length;j++)ne[j-1].equals(ne[j])&&(ne.splice(j,1),j--);if(ne.length===1)return ne[0];if(X){for(let j=0;j<ne.length;j++)for(let Y=j+1;Y<ne.length;Y++)if(ne[j].negate().equals(ne[Y]))return l.INSTANCE;if(ne.length===1)return ne[0]}return new K(ne,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new K(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.c){const k=[];for(const U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),X=k.shift(),ne=[];for(const z of V(U))for(const j of V(X))ne.push(W.create([z,j],null,!1));k.unshift(K.create(ne,null,!1))}this.c=K.create(k,this,!0)}return this.c}}e.ContextKeyOrExpr=K;class q extends c{static all(){return q.d.values()}constructor(k,U,X){super(k,null),this.f=U,typeof X=="object"?q.d.push({...X,key:k}):X!==!0&&q.d.push({key:k,description:X,type:U!=null?typeof U:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return p.create(this.key,k)}notEqualsTo(k){return I.create(this.key,k)}}e.RawContextKey=q,q.d=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService");function ie(N,k){return N<k?-1:N>k?1:0}function re(N,k,U,X){return N<U?-1:N>U?1:k<X?-1:k>X?1:0}function de(N,k){if(N.type===0||k.type===1)return!0;if(N.type===9)return k.type===9?$(N.expr,k.expr):!1;if(k.type===9){for(const U of k.expr)if(de(N,U))return!0;return!1}if(N.type===6){if(k.type===6)return $(k.expr,N.expr);for(const U of N.expr)if(de(U,k))return!0;return!1}return N.equals(k)}e.implies=de;function $(N,k){let U=0,X=0;for(;U<N.length&&X<k.length;){const ne=N[U].cmp(k[X]);if(ne<0)return!1;ne===0&&U++,X++}return U===N.length}function V(N){return N.type===9?N.expr:[N]}}),define(pe[78],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(C,D){return this.a[C]?.[D]??null}async setPassword(C,D,A){this.a[C]=this.a[C]??{},this.a[C][D]=A}async deletePassword(C,D){return this.a[C]?.[D]?(delete this.a[C][D],Object.keys(this.a[C]).length===0&&delete this.a[C],!0):!1}async findPassword(C){return JSON.stringify(this.a[C])??null}async findCredentials(C){const D=[];for(const A of Object.keys(this.a[C]||{}))D.push({account:A,password:this.a[C][A]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(pe[211],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function L(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=L;class o{async getPerformanceInfo(D,A){return{}}async getSystemInfo(D,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,A){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=o}),define(pe[79],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,w.createDecorator)("downloadService")}),define(pe[212],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(pe[25],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[30],ve([1,0,174,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function o(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=o;function C(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function D(u,f){switch(u){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function A(u,f){return f==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function v(u,f,S){return A(f,S)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===S?!0:d(S).includes(u)}e.isTargetPlatformCompatible=v;function d(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function R(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=R;var y;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var E;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var m;(function(u){u.Install="install",u.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var s;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class h extends Error{constructor(f,S){super(f),this.code=S,this.name=S}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,w.localize)(1,null),original:"Preferences"}}),define(pe[213],ve([1,0,6,2,22,4,49,30]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(s,h){return s?C.URI.revive(h?h.transformIncoming(s):s):void 0}function d(s,h){return h?h.transformOutgoingURI(s):s}function R(s,h){h=h||D.DefaultURITransformer;const u=s.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...s,manifest:void 0},h),manifest:u}}function y(s,h){return s?.profileLocation?(0,D.transformAndReviveIncomingURIs)(s,h??D.DefaultURITransformer):s}function E(s,h){return h?(0,o.cloneAndChange)(s,u=>u instanceof C.URI?h.transformOutgoingURI(u):void 0):s}class m{constructor(h,u){this.a=h,this.b=u,this.onInstallExtension=w.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=w.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=w.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=w.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=w.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const f=this.b(h);switch(u){case"onInstallExtension":return w.Event.map(this.onInstallExtension,S=>({...S,profileLocation:S.profileLocation?d(S.profileLocation,f):S.profileLocation}));case"onDidInstallExtensions":return w.Event.map(this.onDidInstallExtensions,S=>S.map(O=>({...O,local:O.local?E(O.local,f):O.local,profileLocation:O.profileLocation?d(O.profileLocation,f):O.profileLocation})));case"onUninstallExtension":return w.Event.map(this.onUninstallExtension,S=>({...S,profileLocation:S.profileLocation?d(S.profileLocation,f):S.profileLocation}));case"onDidUninstallExtension":return w.Event.map(this.onDidUninstallExtension,S=>({...S,profileLocation:S.profileLocation?d(S.profileLocation,f):S.profileLocation}));case"onDidUpdateExtensionMetadata":return w.Event.map(this.onDidUpdateExtensionMetadata,S=>E(S,f))}throw new Error("Invalid listen")}async call(h,u,f){const S=this.b(h);switch(u){case"zip":{const O=R(f[0],S),t=await this.a.zip(O);return d(t,S)}case"unzip":return this.a.unzip(v(f[0],S));case"install":return this.a.install(v(f[0],S),y(f[1],S));case"installFromLocation":return this.a.installFromLocation(v(f[0],S),v(f[1],S));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],v(f[1],S),v(f[2],S));case"getManifest":return this.a.getManifest(v(f[0],S));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],y(f[1],S));case"uninstall":return this.a.uninstall(R(f[0],S),y(f[1],S));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(f[0],S));case"getInstalled":return(await this.a.getInstalled(f[0],v(f[1],S))).map(t=>E(t,S));case"copyExtensions":return this.a.copyExtensions(v(f[0],S),v(f[1],S));case"updateMetadata":{const O=await this.a.updateMetadata(R(f[0],S),f[1],v(f[2],S));return E(O,S)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1],f[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class g extends L.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new w.Emitter),this.f=this.B(new w.Emitter),this.g=this.B(new w.Emitter),this.h=this.B(new w.Emitter),this.j=this.B(new w.Emitter),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?C.URI.revive(u.source):u.source,profileLocation:C.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(f=>({...f,local:f.local?R(f.local,null):f.local,source:this.m(f.source)?C.URI.revive(f.source):f.source,profileLocation:C.URI.revive(f.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:C.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:C.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(R(u,null))))}l(h,u){h.fire(u)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(f=>(0,A.isTargetPlatformCompatible)(f,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(u=>C.URI.revive(u)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,u){return Promise.resolve(this.k.call("install",[h,u])).then(f=>R(f,null))}installFromLocation(h,u){return Promise.resolve(this.k.call("installFromLocation",[h,u])).then(f=>R(f,null))}async installExtensionsFromProfile(h,u,f){return(await this.k.call("installExtensionsFromProfile",[h,u,f])).map(O=>R(O,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.k.call("installFromGallery",[h,u])).then(f=>R(f,null))}uninstall(h,u){return Promise.resolve(this.k.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(u=>R(u,null))}getInstalled(h=null,u){return Promise.resolve(this.k.call("getInstalled",[h,u])).then(f=>f.map(S=>R(S,null)))}updateMetadata(h,u,f){return Promise.resolve(this.k.call("updateMetadata",[h,u,f])).then(S=>R(S,null))}copyExtensions(h,u){return this.k.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,u,f){const S=await this.k.call("download",[h,u,f]);return C.URI.revive(S)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class b{constructor(h){this.a=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,f){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(C.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(pe[80],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,w.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((C,D)=>oe(["node-vsce-sign"],async A=>C(A),D))),this.a}async verify(C,D,A){let v;try{v=await this.b()}catch{return!1}return v.verify(C,D,A)}}e.ExtensionSignatureVerificationService=L}),define(pe[16],ve([1,0,60,7,17,8,4,182,5,3,13]),function(oe,e,w,L,o,C,D,A,v,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,v.createDecorator)("fileService");function y(W){return W.create===!0}e.isFileOpenForWriteOptions=y;var E;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var m;(function(W){W[W.Readonly=1]="Readonly"})(m||(e.FilePermission=m={}));var g;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function b(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=b;function s(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=s;function h(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=h;function u(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function f(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=f;function S(W){return b(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var O;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(O||(e.FileSystemProviderErrorCode=O={}));class t extends Error{static create(K,q){const ie=new t(K.toString(),q);return i(ie,q),ie}constructor(K,q){super(K),this.code=q}}e.FileSystemProviderError=t;function n(W,K){return t.create(W,K)}e.createFileSystemProviderError=n;function r(W){return W||n((0,A.localize)(0,null),O.Unknown)}e.ensureFileSystemProviderError=r;function i(W,K){return W.name=K?`${K} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=i;function a(W){if(!W)return O.Unknown;if(W instanceof t)return W.code;const K=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!K)return O.Unknown;switch(K[1]){case O.FileExists:return O.FileExists;case O.FileIsADirectory:return O.FileIsADirectory;case O.FileNotADirectory:return O.FileNotADirectory;case O.FileNotFound:return O.FileNotFound;case O.FileTooLarge:return O.FileTooLarge;case O.FileWriteLocked:return O.FileWriteLocked;case O.NoPermissions:return O.NoPermissions;case O.Unavailable:return O.Unavailable}return O.Unknown}e.toFileSystemProviderErrorCode=a;function l(W){if(W instanceof F)return W.fileOperationResult;switch(a(W)){case O.FileNotFound:return 1;case O.FileIsADirectory:return 0;case O.FileNotADirectory:return 9;case O.FileWriteLocked:return 5;case O.NoPermissions:return 6;case O.FileExists:return 4;case O.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=l;var c;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class p{constructor(K,q,ie){this.resource=K,this.operation=q,this.target=ie}isOperation(K){return this.operation===K}}e.FileOperationEvent=p;var P;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class T{constructor(K,q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const re of K){const de=ie.get(re.type);switch(de?de.push([re.resource,re]):ie.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,de]of ie)switch(re){case 1:this.a=w.TernarySearchTree.forUris(()=>q),this.a.fill(de);break;case 0:this.b=w.TernarySearchTree.forUris(()=>q),this.b.fill(de);break;case 2:this.c=w.TernarySearchTree.forUris(()=>q),this.c.fill(de);break}}contains(K,...q){return this.d(K,{includeChildren:!1},...q)}affects(K,...q){return this.d(K,{includeChildren:!0},...q)}d(K,q,...ie){if(!K)return!1;const re=ie.length>0;return!!((!re||ie.includes(1))&&(this.a?.get(K)||q.includeChildren&&this.a?.findSuperstr(K))||(!re||ie.includes(0))&&(this.b?.get(K)||q.includeChildren&&this.b?.findSuperstr(K))||(!re||ie.includes(2))&&(this.c?.findSubstr(K)||q.includeChildren&&this.c?.findSuperstr(K)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=T;function I(W,K,q){return!W||!K||W===K||K.length>W.length?!1:(K.charAt(K.length-1)!==L.sep&&(K+=L.sep),q?(0,o.startsWithIgnoreCase)(W,K):W.indexOf(K)===0)}e.isParent=I;class F extends Error{constructor(K,q,ie){super(K),this.fileOperationResult=q,this.options=ie}}e.FileOperationError=F;class H extends F{constructor(K,q,ie,re){super(K,q,re),this.fileOperationResult=q,this.size=ie}}e.TooLargeFileOperationError=H;class ee extends F{constructor(K,q,ie){super(K,2,ie),this.stat=q}}e.NotModifiedSinceFileOperationError=ee;var ce;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.ETAG_DISABLED="";function ue(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=ue;async function ge(W,K){if(!K.hasProvider(D.URI.from({scheme:W.scheme})))return new Promise(q=>{const ie=K.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===W.scheme&&re.added&&(ie.dispose(),q())})})}e.whenProviderRegistered=ge;class G{static formatSize(K){return(0,C.isNumber)(K)||(K=0),K<G.KB?(0,A.localize)(1,null,K.toFixed(0)):K<G.MB?(0,A.localize)(2,null,(K/G.KB).toFixed(2)):K<G.GB?(0,A.localize)(3,null,(K/G.MB).toFixed(2)):K<G.TB?(0,A.localize)(4,null,(K/G.GB).toFixed(2)):(0,A.localize)(5,null,(K/G.TB).toFixed(2))}}e.ByteSize=G,G.KB=1024,G.MB=G.KB*G.KB,G.GB=G.MB*G.KB,G.TB=G.GB*G.KB;function te(W){const K=typeof W=="string"||W?.scheme===R.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===R.Schemas.file?1024*G.MB:K?10*G.MB:d.isWeb?50*G.MB:1024*G.MB}e.getLargeFileConfirmationLimit=te}),define(pe[214],ve([1,0,15,39,9,6,2,47,4,21,16]),function(oe,e,w,L,o,C,D,A,v,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends D.Disposable{constructor(m,g){super(),this.a=m,this.b=g,this.onDidChangeCapabilities=C.Event.None,this.f=this.B(new C.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.h=(0,d.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,g){const{buffer:b}=await this.a.call("readFile",[m,g]);return b}readFileStream(m,g,b){const s=(0,A.newWriteableStream)(u=>w.VSBuffer.concat(u.map(f=>w.VSBuffer.wrap(f))).buffer),h=this.a.listen("readFileStream",[m,g])(u=>{if(u instanceof w.VSBuffer)s.write(u.buffer);else{if(u==="end")s.end();else{let f;if(u instanceof Error)f=u;else{const S=u;f=(0,R.createFileSystemProviderError)(S.message??(0,L.toErrorMessage)(S),S.code??R.FileSystemProviderErrorCode.Unknown)}s.error(f),s.end()}h.dispose()}});return b.onCancellationRequested(()=>{s.error((0,o.canceled)()),s.end(),h.dispose()}),s}writeFile(m,g,b){return this.a.call("writeFile",[m,w.VSBuffer.wrap(g),b])}open(m,g){return this.a.call("open",[m,g])}close(m){return this.a.call("close",[m])}async read(m,g,b,s,h){const[u,f]=await this.a.call("read",[m,g,h]);return b.set(u.buffer.slice(0,f),s),f}write(m,g,b,s,h){return this.a.call("write",[m,g,w.VSBuffer.wrap(b),s,h])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,g){return this.a.call("delete",[m,g])}rename(m,g,b){return this.a.call("rename",[m,g,b])}copy(m,g,b){return this.a.call("copy",[m,g,b])}cloneFile(m,g){return this.a.call("cloneFile",[m,g])}i(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const g=m;this.f.fire(g.map(b=>({resource:v.URI.revive(b.resource),type:b.type})))}else{const g=m;this.g.fire(g)}}))}watch(m,g){const b=(0,d.generateUuid)();return this.a.call("watch",[this.h,b,m,g]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,b]))}}e.DiskFileSystemProviderClient=y}),define(pe[108],ve([1,0,15,9,183,16]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(R,y,E,m,g,b){let s;try{await A(R,y,E,m,g,b)}catch(h){s=h}finally{s&&g.errorTransformer&&(s=g.errorTransformer(s)),typeof s<"u"&&E.error(s),E.end()}}e.readFileIntoStream=D;async function A(R,y,E,m,g,b){v(b);const s=await R.open(y,{create:!1});try{v(b);let h=0,u=0,f=g&&typeof g.length=="number"?g.length:void 0,S=w.VSBuffer.alloc(Math.min(g.bufferSize,typeof f=="number"?f:g.bufferSize)),O=g&&typeof g.position=="number"?g.position:0,t=0;do u=await R.read(s,O,S.buffer,t,S.byteLength-t),O+=u,t+=u,h+=u,typeof f=="number"&&(f-=u),t===S.byteLength&&(await E.write(m(S)),S=w.VSBuffer.alloc(Math.min(g.bufferSize,typeof f=="number"?f:g.bufferSize)),t=0);while(u>0&&(typeof f!="number"||f>0)&&v(b)&&d(h,g));if(t>0){let n=t;typeof f=="number"&&(n=Math.min(t,f)),E.write(m(S.slice(0,n)))}}catch(h){throw(0,C.ensureFileSystemProviderError)(h)}finally{await R.close(s)}}function v(R){if(R.isCancellationRequested)throw(0,L.canceled)();return!0}function d(R,y){if(typeof y?.limits?.size=="number"&&R>y.limits.size)throw(0,C.createFileSystemProviderError)((0,o.localize)(0,null),C.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(pe[65],ve([1,0,74,2,7,3,4,16]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(h){return h.recursive===!0}e.isRecursiveWatchRequest=v;class d extends L.Disposable{constructor(u,f,S,O){super(),this.h=u,this.i=f,this.j=S,this.k=O,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const u=new L.DisposableStore;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(f=>this.h(f))),u.add(this.b.onDidLogMessage(f=>this.i(f))),u.add(this.b.onDidError(f=>this.n(f)))}n(u){this.k.restartOnError?this.g<d.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=d,d.a=5;class R extends d{constructor(u,f,S){super(u,f,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class y extends d{constructor(u,f,S){super(u,f,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function E(h){return h.map(u=>({type:u.type,resource:D.URI.file(u.path)}))}e.toFileChanges=E;function m(h){const u=new s;for(const f of h)u.processEvent(f);return u.coalesce()}e.coalesceEvents=m;function g(h,u){return typeof u=="string"&&!u.startsWith(w.GLOBSTAR)&&!(0,o.isAbsolute)(u)?{base:h,pattern:u}:u}e.normalizeWatcherPattern=g;function b(h,u){const f=[];for(const S of u)f.push((0,w.parse)(g(h,S)));return f}e.parseWatcherPatterns=b;class s{constructor(){this.a=new Set,this.b=new Map}c(u){return C.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const f=this.b.get(this.c(u));let S=!1;if(f){const O=f.type,t=u.type;f.path!==u.path&&(u.type===2||u.type===1)?S=!0:O===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(f)):O===2&&t===1?f.type=0:O===1&&t===0||(f.type=t)}else S=!0;S&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],f=[];return Array.from(this.a).filter(S=>S.type!==2?(u.push(S),!1):!0).sort((S,O)=>S.path.length-O.path.length).filter(S=>f.some(O=>(0,A.isParent)(S.path,O,!C.isLinux))?!1:(f.push(S.path),!0)).concat(u)}}}),define(pe[215],ve([1,0,33,14,20,38,2,95,7,3,154,23,65]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends D.Disposable{constructor(s,h,u,f){super(),this.j=s,this.k=h,this.l=u,this.m=f,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new L.RunOnceWorker(S=>this.u(S),m.b)),this.g=(0,E.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,E.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new o.CancellationTokenSource,this.ready=this.n()}async n(){try{const s=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await y.Promises.stat(s);this.B(await this.s(s,h.isDirectory()))}catch(s){s.code!=="ENOENT"?this.w(s):this.z(s)}}async r(s){let h=s.path;try{h=await y.Promises.realpath(s.path),s.path===h&&(h=await(0,R.realcase)(s.path)??s.path),s.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${h})`)}catch{}return h}async s(s,h){if(d.isMacintosh&&(0,C.isEqualOrParent)(s,"/Volumes/",!0))return this.w(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const u=new o.CancellationTokenSource(this.i.token),f=new D.DisposableStore;try{const S=(0,v.basename)(s),O=(0,w.watch)(s);f.add((0,D.toDisposable)(()=>{O.removeAllListeners(),O.close()})),this.z(`Started watching: '${s}'`);const t=new Set;if(h)try{for(const r of await y.Promises.readdir(s))t.add(r)}catch(r){this.w(r)}const n=new Map;f.add((0,D.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),O.on("error",(r,i)=>{this.w(`Failed to watch ${s} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),O.on("change",(r,i)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${i}`);let a="";if(i&&(a=i.toString(),d.isMacintosh&&(a=(0,A.normalizeNFC)(a))),!(!a||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){n.get(a)?.dispose();const l=setTimeout(async()=>{if(n.delete(a),a===S&&!await y.Promises.exists(s)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.v((0,v.join)(s,a));if(u.token.isCancellationRequested)return;let p;c?t.has(a)?p=0:(p=1,t.add(a)):(t.delete(a),p=2),this.t({path:(0,v.join)(this.j.path,a),type:p})},m.a);n.set(a,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(a)?l=0:(l=1,t.add(a)),this.t({path:(0,v.join)(this.j.path,a),type:l})}else if(r==="rename"||a!==S){const l=setTimeout(async()=>{const c=await y.Promises.exists(s);u.token.isCancellationRequested||(c?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(s,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},m.a);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await y.Promises.exists(s)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${s} for changes using fs.watch() (${S.toString()})`)}return(0,D.toDisposable)(()=>{u.dispose(!0),f.dispose()})}t(s,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!h&&this.g.some(u=>u(s.path))?this.m&&this.z(` >> ignored (excluded) ${s.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(u=>u(s.path))?this.m&&this.z(` >> ignored (not included) ${s.path}`):this.f.work(s))}u(s){const h=(0,E.coalesceEvents)(s);if(h.length>0){if(this.m)for(const f of h)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(s){if(d.isLinux)return y.Promises.exists(s);try{const h=(0,v.basename)(s);return(await y.Promises.readdir((0,v.dirname)(s))).some(f=>f===h)}catch(h){return this.z(h),!1}}setVerboseLogging(s){this.m=s}w(s){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}y(s){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}z(s){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.a=100,m.b=75;async function g(b,s,h,u,f=512){const S=await y.Promises.open(b,"r"),O=Buffer.allocUnsafe(f),t=new o.CancellationTokenSource(u);let n,r=!1;const i={path:b,excludes:[],recursive:!1},a=new m(i,l=>{(async()=>{for(const{type:c}of l)if(c===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:p}=await y.Promises.read(S,O,0,f,null);if(!p||t.token.isCancellationRequested)break;s(O.slice(0,p))}}catch(p){n=new Error(p),t.dispose(!0)}finally{r=!1}}})()});return await a.ready,h(),new Promise((l,c)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await y.Promises.close(S)}catch(p){n=new Error(p)}n?c(n):l()})})}e.watchFileContents=g}),define(pe[216],ve([1,0,6,74,2,3,215]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class A extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new w.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new w.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=w.Event.None,this.c=new Map,this.f=!1}async watch(d){const R=this.i(d),y=R.filter(m=>{const g=this.c.get(m.path);return g?!(0,L.patternsEquals)(g.request.excludes,m.excludes)||!(0,L.patternsEquals)(g.request.includes,m.includes):!0}),E=Array.from(this.c.values()).filter(({request:m})=>!R.find(g=>g.path===m.path&&(0,L.patternsEquals)(g.excludes,m.excludes)&&(0,L.patternsEquals)(g.includes,m.includes))).map(({request:m})=>m.path);y.length&&this.j(`Request to start watching: ${y.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),E.length&&this.j(`Request to stop watching: ${E.join(",")}`);for(const m of E)this.h(m);for(const m of y)this.g(m)}g(d){const R=new D.NodeJSFileWatcherLibrary(d,E=>this.a.fire(E),E=>this.b.fire(E),this.f),y={request:d,instance:R};this.c.set(d.path,y)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const R=this.c.get(d);R&&(this.c.delete(d),R.instance.dispose())}i(d){const R=new Map;for(const y of d){const E=C.isLinux?y.path:y.path.toLowerCase();R.set(E,y)}return Array.from(R.values())}async setVerboseLogging(d){this.f=d;for(const[,R]of this.c)R.instance.setVerboseLogging(d)}j(d){this.f&&this.b.fire({type:"trace",message:this.k(d)})}k(d,R){return R?`[File Watcher (node.js)] ${d} (path: ${R.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=A}),define(pe[217],ve([1,0,65,216]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class o extends w.AbstractNonRecursiveWatcherClient{constructor(D,A,v){super(D,A,v),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=o}),define(pe[218],ve([1,0,13,43,105,65]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends C.AbstractUniversalWatcherClient{constructor(v,d,R){super(v,d,R),this.m()}l(v){const d=v.add(new o.Client(w.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(d.onDidProcessExit(({code:R,signal:y})=>this.n(`terminated by itself with code ${R}, signal: ${y}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(pe[81],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...o){this.a=new Map;for(const[C,D]of o)this.set(C,D)}set(o,C){const D=this.a.get(o);return this.a.set(o,C),D}has(o){return this.a.has(o)}get(o){return this.a.get(o)}}e.ServiceCollection=w}),define(pe[109],ve([1,0,14,9,2,63,210,5,81,94]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class E{constructor(s=new v.ServiceCollection,h=!1,u,f=R){this.f=s,this.g=h,this.h=u,this.i=f,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=f?u?._globalGraph??new D.Graph(S=>S):void 0}createChild(s){return new E(s,this.g,this,this.i)}invokeFunction(s,...h){const u=g.traceInvocation(this.i,s);let f=!1;try{return s({get:O=>{if(f)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(O,u);if(!t)throw new Error(`[invokeFunction] unknown service '${O}'`);return t}},...h)}finally{f=!0,u.stop()}}createInstance(s,...h){let u,f;return s instanceof C.SyncDescriptor?(u=g.traceCreation(this.i,s.ctor),f=this.j(s.ctor,s.staticArguments.concat(h),u)):(u=g.traceCreation(this.i,s),f=this.j(s,h,u)),u.stop(),f}j(s,h=[],u){const f=A._util.getServiceDependencies(s).sort((t,n)=>t.index-n.index),S=[];for(const t of f){const n=this.m(t.id,u);n||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(n)}const O=f.length>0?f[0].index:h.length;if(h.length!==O){console.trace(`[createInstance] First service dependency of ${s.name} at position ${O+1} conflicts with ${h.length} static arguments`);const t=O-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,O)}return Reflect.construct(s,h.concat(S))}k(s,h){if(this.f.get(s)instanceof C.SyncDescriptor)this.f.set(s,h);else if(this.h)this.h.k(s,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const h=this.f.get(s);return!h&&this.h?this.h.l(s):h}m(s,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const u=this.l(s);return u instanceof C.SyncDescriptor?this.q(s,u,h.branch(s,!0)):(h.branch(s,!1),u)}q(s,h,u){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,h,u)}finally{this.o.delete(s)}}r(s,h,u){const f=new D.Graph(t=>t.id.toString());let S=0;const O=[{id:s,desc:h,_trace:u}];for(;O.length;){const t=O.pop();if(f.lookupOrInsertNode(t),S++>1e3)throw new y(f);for(const n of A._util.getServiceDependencies(t.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${s} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof C.SyncDescriptor){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};f.insertEdge(t,i),O.push(i)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new y(f);break}for(const{data:n}of t){if(this.l(n.id)instanceof C.SyncDescriptor){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}f.removeNode(n)}}return this.l(s)}s(s,h,u=[],f,S){if(this.f.get(s)instanceof C.SyncDescriptor)return this.t(s,h,u,f,S);if(this.h)return this.h.s(s,h,u,f,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(s,h,u=[],f,S){if(f){const O=new E(void 0,this.g,this,this.i);O.c=String(s);const t=new Map,n=new w.IdleValue(()=>{const r=O.j(h,u,S);for(const[i,a]of t){const l=r[i];if(typeof l=="function")for(const c of a)l.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=t.get(i);return c||(c=new d.LinkedList,t.set(i,c)),(P,T,I)=>{const F=c.push([P,T,I]);return(0,o.toDisposable)(F)}}if(i in r)return r[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),r[i]=l),l},set(r,i,a){return n.value[i]=a,!0},getPrototypeOf(r){return h.prototype}})}else return this.j(h,u,S)}u(s,h){if(h&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=E;var m;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(m||(m={}));class g{static traceInvocation(s,h){return s?new g(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(s,h){return s?new g(1,h.name):g.c}constructor(s,h){this.type=s,this.name=h,this.g=Date.now(),this.h=[]}branch(s,h){const u=new g(3,s.toString());return this.h.push([s,h,u]),u}stop(){const s=Date.now()-this.g;g.f+=s;let h=!1;function u(S,O){const t=[],n=new Array(S+1).join("	");for(const[r,i,a]of O.h)if(i&&a){h=!0,t.push(`${n}CREATES -> ${r}`);const l=u(S+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(s>2||h)&&g.all.add(f.join(`
`))}}e.Trace=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(pe[219],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,w.createDecorator)("labelService");var L;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(L||(e.Verbosity=L={}))});var Ae=this&&this.__param||function(oe,e){return function(w,L){e(w,L,oe)}};define(pe[82],ve([1,0,20,2,3,185,30,5]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function v(R){return R.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=v,e.ILanguagePackService=(0,A.createDecorator)("languagePackService");let d=e.LanguagePackBaseService=class extends L.Disposable{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new w.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let E;try{E=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const g=E.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(s=>s.startsWith("lp-"))).map(b=>{const s=b.properties.localizedLanguages?.[0],h=v(b);return{...this.f(h,s,b),extensionId:b.identifier.id,galleryExtension:b}});return g.push(this.f("en","English")),g}f(y,E,m){const g=E??y;let b;if(g!==y&&(b=`(${y})`),y.toLowerCase()===o.language.toLowerCase()&&(b??="",b+=(0,C.localize)(0,null)),m?.installCount){b??="";const s=m.installCount;let h;s>1e6?h=`${Math.floor(s/1e5)/10}M`:s>1e3?h=`${Math.floor(s/1e3)}K`:h=String(s),b+=` $(cloud-download) ${h}`}return{id:y,label:g,description:b}}};e.LanguagePackBaseService=d=Le([Ae(0,D.IExtensionGalleryService)],d)}),define(pe[12],ve([1,0,39,6,73,2,28,3,19,8,4,64,5]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function m(){return new Date().toISOString()}function g(P){return(0,d.isNumber)(P)}e.isLogLevel=g;var b;(function(P){P[P.Off=0]="Off",P[P.Trace=1]="Trace",P[P.Debug=2]="Debug",P[P.Info=3]="Info",P[P.Warning=4]="Warning",P[P.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function s(P,T,I){switch(T){case b.Trace:P.trace(I);break;case b.Debug:P.debug(I);break;case b.Info:P.info(I);break;case b.Warning:P.warn(I);break;case b.Error:P.error(I);break;case b.Off:break;default:throw new Error(`Invalid log level ${T}`)}}e.log=s;function h(P,T=!1){let I="";for(let F=0;F<P.length;F++){let H=P[F];if(H instanceof Error&&(H=(0,w.toErrorMessage)(H,T)),typeof H=="object")try{H=JSON.stringify(H)}catch{}I+=(F>0?" ":"")+H}return I}class u extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(T){this.b!==T&&(this.b=T,this.c.fire(this.b))}getLevel(){return this.b}f(T){return this.b!==b.Off&&this.b<=T}}e.AbstractLogger=u;class f extends u{constructor(T){super(),this.h=T}f(T){return this.h||super.f(T)}trace(T,...I){this.f(b.Trace)&&this.g(b.Trace,h([T,...I],!0))}debug(T,...I){this.f(b.Debug)&&this.g(b.Debug,h([T,...I]))}info(T,...I){this.f(b.Info)&&this.g(b.Info,h([T,...I]))}warn(T,...I){this.f(b.Warning)&&this.g(b.Warning,h([T,...I]))}error(T,...I){if(this.f(b.Error))if(T instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=T.stack,this.g(b.Error,h(F))}else this.g(b.Error,h([T,...I]))}flush(){}}e.AbstractMessageLogger=f;class S extends u{constructor(T=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(T),this.g=!A.isWindows}trace(T,...I){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...I):console.log(`[main ${m()}]`,T,...I))}debug(T,...I){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...I):console.log(`[main ${m()}]`,T,...I))}info(T,...I){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...I):console.log(`[main ${m()}]`,T,...I))}warn(T,...I){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,T,...I):console.warn(`[main ${m()}]`,T,...I))}error(T,...I){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,T,...I):console.error(`[main ${m()}]`,T,...I))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class O extends u{constructor(T=e.DEFAULT_LOG_LEVEL,I=!0){super(),this.g=I,this.setLevel(T)}trace(T,...I){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",T,...I):console.log(T,...I))}debug(T,...I){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",T,...I):console.log(T,...I))}info(T,...I){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",T,...I):console.log(T,...I))}warn(T,...I){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",T,...I):console.log(T,...I))}error(T,...I){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",T,...I):console.error(T,...I))}dispose(){}flush(){}}e.ConsoleLogger=O;class t extends u{constructor(T,I=e.DEFAULT_LOG_LEVEL){super(),this.g=T,this.setLevel(I)}trace(T,...I){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(T),...I])}debug(T,...I){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(T),...I])}info(T,...I){this.f(b.Info)&&this.g.log(b.Info,[this.h(T),...I])}warn(T,...I){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(T),...I])}error(T,...I){this.f(b.Error)&&this.g.log(b.Error,[this.h(T),...I])}h(T){return typeof T=="string"?T:(0,w.toErrorMessage)(T,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends u{constructor(T){super(),this.g=T,T.length&&this.setLevel(T[0].getLevel())}setLevel(T){for(const I of this.g)I.setLevel(T);super.setLevel(T)}trace(T,...I){for(const F of this.g)F.trace(T,...I)}debug(T,...I){for(const F of this.g)F.debug(T,...I)}info(T,...I){for(const F of this.g)F.info(T,...I)}warn(T,...I){for(const F of this.g)F.warn(T,...I)}error(T,...I){for(const F of this.g)F.error(T,...I)}flush(){for(const T of this.g)T.flush()}dispose(){for(const T of this.g)T.dispose()}}e.MultiplexLogger=n;class r extends C.Disposable{constructor(T,I,F){if(super(),this.h=T,this.j=I,this.b=new D.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,F)for(const H of F)this.b.set(H.resource,{logger:void 0,info:H})}k(T){return(0,d.isString)(T)?[...this.b.values()].find(I=>I.info.id===T):this.b.get(T)}getLogger(T){return this.k(T)?.logger}createLogger(T,I){const F=this.l(T),H=(0,d.isString)(T)?T:I?.id??(0,o.hash)(F.toString()).toString(16);let ee=this.b.get(F)?.logger;const ce=I?.logLevel==="always"?b.Trace:I?.logLevel;ee||(ee=this.m(F,ce??this.getLogLevel(F)??this.h,{...I,id:H}));const ae={logger:ee,info:{resource:F,id:H,logLevel:ce,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(ae.info),this.b.set(F,ae),ee}l(T){return(0,d.isString)(T)?(0,v.joinPath)(this.j,`${T}.log`):T}setLogLevel(T,I){if(R.URI.isUri(T)){const F=T,H=I,ee=this.b.get(F);ee&&H!==ee.info.logLevel&&(ee.info.logLevel=H===this.h?void 0:H,ee.logger?.setLevel(H),this.b.set(ee.info.resource,ee),this.f.fire([F,H]))}else{this.h=T;for(const[F,H]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(T,I){const F=this.k(T);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(T){let I;return T&&(I=this.b.get(T)?.info.logLevel),I??this.h}registerLogger(T){const I=this.b.get(T.resource);I?I.info.hidden!==T.hidden&&this.setVisibility(T.resource,!T.hidden):(this.b.set(T.resource,{info:T,logger:void 0}),this.c.fire({added:[T],removed:[]}))}deregisterLogger(T){const I=this.b.get(T);I&&(I.logger&&I.logger.dispose(),this.b.delete(T),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const T of this.b.values())yield T.info}getRegisteredLogger(T){return this.b.get(T)?.info}dispose(){this.b.forEach(T=>T.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(T){}getLevel(){return b.Info}trace(T,...I){}debug(T,...I){}info(T,...I){}warn(T,...I){}error(T,...I){}critical(T,...I){}dispose(){}flush(){}}e.NullLogger=i;class a extends i{}e.NullLogService=a;function l(P){if(P.verbose)return b.Trace;if(typeof P.logLevel=="string"){const T=p(P.logLevel.toLowerCase());if(T!==void 0)return T}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(P){switch(P){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=c;function p(P){switch(P){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=p,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",c(b.Info))}),define(pe[220],ve([1,0,78,6,2,12,3,14]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=e.BaseCredentialsMainService=class Gt extends o.Disposable{constructor(R){super(),this.h=R,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new A.SequencerByKey}async getPassword(R,y){this.h.trace("Going to get password from keytar:",R,y);let E;try{E=await this.i()}catch{return null}return await this.g.queue(R+y,()=>this.k(E,R,y))}async k(R,y,E){this.h.trace("Doing get password from keytar:",y,E);const m=await(0,A.retry)(()=>R.getPassword(y,E),50,3);if(!m)return this.h.trace("Did not get a password from keytar for account:",E),m;let g,b;try{const s=JSON.parse(m);g=s.content,b=s.hasNextChunk}catch{}if(!g||!b)return this.h.trace("Got password from keytar for account:",E),m;try{let s=1;for(;b;){const h=await(0,A.retry)(()=>R.getPassword(y,`${E}-${s}`),50,3),u=JSON.parse(h);g+=u.content,b=u.hasNextChunk,s++}return this.h.trace(`Got ${s}-chunked password from keytar for account:`,E),g}catch(s){return this.h.error(s),m}}async setPassword(R,y,E){this.h.trace("Going to set password using keytar:",R,y);let m;try{m=await this.i()}catch(g){throw this.j?.(g),g}await this.g.queue(R+y,()=>this.l(m,R,y,E)),this.c.fire({service:R,account:y})}async l(R,y,E,m){if(this.h.trace("Doing set password from keytar:",y,E),!D.isWindows){await(0,A.retry)(()=>R.setPassword(y,E,m),50,3),this.h.trace("Set password from keytar for account:",E);return}if(await this.m(R,y,E),m.length<=Gt.b){await(0,A.retry)(()=>R.setPassword(y,E,m),50,3),this.h.trace("Set password from keytar for account:",E);return}let g=0,b=0,s=!0;for(;s;){const h=m.substring(g,g+Gt.b);g+=Gt.b,s=m.length-g>0;const u={content:h,hasNextChunk:s};await(0,A.retry)(()=>R.setPassword(y,b?`${E}-${b}`:E,JSON.stringify(u)),50,3),b++}this.h.trace(`Set${b?` ${b}-chunked`:""} password from keytar for account:`,E)}async deletePassword(R,y){this.h.trace("Going to delete password using keytar:",R,y);let E;try{E=await this.i()}catch(g){throw this.j?.(g),g}const m=await this.g.queue(R+y,()=>this.m(E,R,y));return m&&this.c.fire({service:R,account:y}),m}async m(R,y,E){this.h.trace("Doing delete password from keytar:",y,E);const m=await R.getPassword(y,E);if(!m)return this.h.trace("Did not get a password to delete from keytar for account:",E),!1;let g,b;try{const h=JSON.parse(m);g=h.content,b=h.hasNextChunk}catch{}let s=0;if(g&&b)try{for(s++;b;){const h=`${E}-${s}`,u=await R.getPassword(y,h);await R.deletePassword(y,h),b=JSON.parse(u).hasNextChunk,s++}}catch(h){this.h.error(h)}return await R.deletePassword(y,E)?(this.h.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,E),!0):(this.h.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,E),!1)}async findPassword(R){let y;try{y=await this.i()}catch{return null}return await y.findPassword(R)}async findCredentials(R){let y;try{y=await this.i()}catch{return[]}return await y.findCredentials(R)}clear(){return this.f instanceof w.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};v.a=2500,v.b=v.a-100,e.BaseCredentialsMainService=v=Le([Ae(0,C.ILogService)],v)}),define(pe[221],ve([1,0,12]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(C,D){this.a=C,this.b=D}c(){return new Promise((C,D)=>oe(["vscode-encrypt"],C,D))}async encrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.encrypt(this.a,C)}catch(A){return this.b.error(A),C}}async decrypt(C){let D;try{D=await this.c()}catch{return C}try{return D.decrypt(this.a,C)}catch(A){return this.b.error(A),C}}};e.EncryptionMainService=L=Le([Ae(1,w.ILogService)],L)}),define(pe[222],ve([1,0,18,14,9,6,2,7,65,12]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends D.Disposable{constructor(E,m){super(),this.a=E,this.b=m,this.c=this.B(new C.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new C.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(E,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(E,m):this.u(E,m)}l(E,m){const g={path:this.C(E),excludes:m.excludes,includes:m.includes,recursive:m.recursive},b=(0,w.insert)(this.j,g);return this.m(),(0,D.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(E=>(0,o.onUnexpectedError)(E))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,v.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const m of this.j)(0,v.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const m of this.j)(0,v.isRecursiveWatchRequest)(m)&&E.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(E,m){const g={path:this.C(E),excludes:m.excludes,includes:m.includes,recursive:!1},b=(0,w.insert)(this.s,g);return this.v(),(0,D.toDisposable)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(E=>(0,o.onUnexpectedError)(E))}w(){return this.r||(this.r=this.B(this.y(E=>this.c.fire((0,v.toFileChanges)(E)),E=>this.z(E),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.r.watch(this.s)}z(E){E.type==="error"&&this.g.fire(E.message),this.a[E.type](E.message)}C(E){return(0,A.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(pe[110],ve([1,0,18,14,15,20,6,73,46,2,60,13,42,19,47,181,16,108,12,9]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=e.FileService=class extends d.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,n){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${t}`);const r=new d.DisposableStore;return this.h.set(t,n),this.c.fire({added:!0,scheme:t,provider:n}),r.add(n.onDidChangeFile(i=>this.R.fire(new s.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:t}))),(0,d.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:n}),this.h.delete(t),(0,d.dispose)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const n=[];this.f.fire({scheme:t,join(r){n.push(r)}}),!this.h.has(t)&&await L.Promises.settled(n)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,n){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([t,n])=>({scheme:t,capabilities:n.capabilities}))}async j(t){if(!(0,m.isAbsolutePath)(t))throw new s.FileOperationError((0,b.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const n=this.h.get(t.scheme);if(!n){const r=new f.ErrorNoTelemetry;throw r.message=(0,b.localize)(1,null,t.toString()),r}return n}async k(t){const n=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(n)||(0,s.hasReadWriteCapability)(n)||(0,s.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const n=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(n)||(0,s.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,n){try{return await this.n(t,n)}catch(r){throw(0,s.toFileSystemProviderErrorCode)(r)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,b.localize)(2,null,this.nb(t)),1):(0,s.ensureFileSystemProviderError)(r)}}async n(t,n){const r=await this.j(t),i=this.O(r),a=n?.resolveTo,l=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,p=await r.stat(t);let P;return this.p(r,t,p,void 0,!!c,(T,I)=>(P||(P=R.TernarySearchTree.forUris(()=>!i),P.set(t,!0),a&&P.fill(!0,a)),P.get(T.resource)||P.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&l?I===1:!1))}async p(t,n,r,i,a,l){const{providerExtUri:c}=this.N(t),p={resource:n,name:c.basename(n),isFile:(r.type&s.FileType.File)!==0,isDirectory:(r.type&s.FileType.Directory)!==0,isSymbolicLink:(r.type&s.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&s.FilePermission.Readonly)||!!(t.capabilities&2048),etag:(0,s.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(p.isDirectory&&l(p,i)){try{const P=await t.readdir(n),T=await L.Promises.settled(P.map(async([I,F])=>{try{const H=c.joinPath(n,I),ee=a?await t.stat(H):{type:F};return await this.p(t,H,ee,P.length,a,l)}catch(H){return this.b.trace(H),null}}));p.children=(0,w.coalesce)(T)}catch(P){this.b.trace(P),p.children=[]}return p}return p}async resolveAll(t){return L.Promises.settled(t.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const n=await this.j(t),r=await n.stat(t);return this.p(n,t,r,void 0,!0,()=>!1)}async exists(t){const n=await this.j(t);try{return!!await n.stat(t)}catch{return!1}}async canCreateFile(t,n){try{await this.r(t,n)}catch(r){return r}return!0}async r(t,n){if(!n?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,b.localize)(3,null,this.nb(t)),3,n)}async createFile(t,n=o.VSBuffer.fromString(""),r){await this.r(t,r);const i=await this.writeFile(t,n);return this.m.fire(new s.FileOperationEvent(t,0,i)),i}async writeFile(t,n,r){const i=this.lb(await this.l(t),t),{providerExtUri:a}=this.N(i);try{await this.s(i,t,r)||await this.P(i,a.dirname(t));let c;if((0,s.hasReadWriteCapability)(i)&&!(n instanceof o.VSBuffer))if((0,g.isReadableStream)(n)){const p=await(0,g.peekStream)(n,3);p.ended?c=o.VSBuffer.concat(p.buffer):c=p}else c=(0,g.peekReadable)(n,p=>o.VSBuffer.concat(p),3);else c=n;!(0,s.hasOpenReadWriteCloseCapability)(i)||(0,s.hasReadWriteCapability)(i)&&c instanceof o.VSBuffer?await this.cb(i,t,r,c):await this.Y(i,t,r,c instanceof o.VSBuffer?(0,o.bufferToReadable)(c):c),this.m.fire(new s.FileOperationEvent(t,4))}catch(l){throw new s.FileOperationError((0,b.localize)(4,null,this.nb(t),(0,s.ensureFileSystemProviderError)(l).toString()),(0,s.toFileOperationResult)(l),r)}return this.resolve(t,{resolveMetadata:!0})}async s(t,n,r){if(!!r?.unlock&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.nb(n)));let a;try{a=await t.stat(n)}catch{return}if(a.type&s.FileType.Directory)throw new s.FileOperationError((0,b.localize)(6,null,this.nb(n)),0,r);if(this.mb(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==s.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,s.etag)({mtime:r.mtime,size:a.size}))throw new s.FileOperationError((0,b.localize)(7,null),3,r);return a}async readFile(t,n,r){const i=await this.k(t);return n?.atomic?this.t(i,t,n,r):this.u(i,t,n,r)}async t(t,n,r,i){return new Promise((a,l)=>{this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{try{const c=await this.u(t,n,r,i);a(c)}catch(c){l(c)}})})}async u(t,n,r,i){const a=await this.v(t,n,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,o.streamToBuffer)(a.value)}}async readFileStream(t,n,r){const i=await this.k(t);return this.v(i,t,n,r)}async v(t,n,r,i){const a=new C.CancellationTokenSource(i),l=this.F(n,r).then(p=>p,p=>{throw a.cancel(),p});let c;try{return typeof r?.etag=="string"&&r.etag!==s.ETAG_DISABLED&&await l,r?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&r?.preferUnbuffered?c=this.D(t,n,r):(0,s.hasFileReadStreamCapability)(t)?c=this.z(t,n,a.token,r):c=this.C(t,n,a.token,r),{...await l,value:c}}catch(p){throw c&&await(0,g.consumeStream)(c),this.w(p,n,r)}}w(t,n,r){const i=(0,b.localize)(8,null,this.nb(n),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(i,t.stat,r):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new s.FileOperationError(i,(0,s.toFileOperationResult)(t),r)}z(t,n,r,i=Object.create(null)){const a=t.readFileStream(n,i,r);return(0,g.transform)(a,{data:l=>l instanceof o.VSBuffer?l:o.VSBuffer.wrap(l),error:l=>this.w(l,n,i)},l=>o.VSBuffer.concat(l))}C(t,n,r,i=Object.create(null)){const a=(0,o.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,n,a,l=>l,{...i,bufferSize:this.a,errorTransformer:l=>this.w(l,n,i)},r),a}D(t,n,r){const i=(0,g.newWriteableStream)(a=>o.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?a=await t.readFile(n,{atomic:!0}):a=await t.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.G(n,a.byteLength,r),i.end(o.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async F(t,n){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new s.FileOperationError((0,b.localize)(9,null,this.nb(t)),0,n);if(typeof n?.etag=="string"&&n.etag!==s.ETAG_DISABLED&&n.etag===r.etag)throw new s.NotModifiedSinceFileOperationError((0,b.localize)(10,null),r,n);return this.G(t,r.size,n),r}G(t,n,r){if(typeof r?.limits?.size=="number"&&n>r.limits.size)throw new s.TooLargeFileOperationError((0,b.localize)(11,null,this.nb(t)),7,n,r)}async canMove(t,n,r){return this.H(t,n,"move",r)}async canCopy(t,n,r){return this.H(t,n,"copy",r)}async H(t,n,r,i){if(t.toString()!==n.toString())try{const a=r==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(n),n);await this.M(a,t,l,n,r,i)}catch(a){return a}return!0}async move(t,n,r){const i=this.lb(await this.l(t),t),a=this.lb(await this.l(n),n),l=await this.I(i,t,a,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,l==="move"?2:3,c)),c}async copy(t,n,r){const i=await this.k(t),a=this.lb(await this.l(n),n),l=await this.I(i,t,a,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,l==="copy"?3:2,c)),c}async I(t,n,r,i,a,l){if(n.toString()===i.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:p}=await this.M(t,n,r,i,a,l);if(c&&!p&&l&&await this.del(i,{recursive:!0}),await this.P(r,this.N(r).providerExtUri.dirname(i)),a==="copy"){if(t===r&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(n,i,{overwrite:l});else{const P=await this.resolve(n);P.isDirectory?await this.L(t,P,r,i):await this.J(t,n,r,i)}return a}else return t===r?(await t.rename(n,i,{overwrite:l}),a):(await this.I(t,n,r,i,"copy",l),await this.del(n,{recursive:!0}),"copy")}async J(t,n,r,i){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(r))return this.eb(t,n,r,i);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(r))return this.kb(t,n,r,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(r))return this.ib(t,n,r,i);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(r))return this.gb(t,n,r,i)}async L(t,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async a=>{const l=this.N(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.L(t,await this.resolve(a.resource),r,l):this.J(t,a.resource,r,l)}))}async M(t,n,r,i,a,l){let c=!1;if(t===r){const{providerExtUri:P,isPathCaseSensitive:T}=this.N(t);if(T||(c=P.isEqual(n,i)),c&&a==="copy")throw new Error((0,b.localize)(12,null,this.nb(n),this.nb(i)));if(!c&&P.isEqualOrParent(i,n))throw new Error((0,b.localize)(13,null,this.nb(n),this.nb(i)))}const p=await this.exists(i);if(p&&!c){if(!l)throw new s.FileOperationError((0,b.localize)(14,null,this.nb(n),this.nb(i)),4);if(t===r){const{providerExtUri:P}=this.N(t);if(P.isEqualOrParent(n,i))throw new Error((0,b.localize)(15,null,this.nb(n),this.nb(i)))}}return{exists:p,isSameResourceWithDifferentPathCase:c}}N(t){const n=this.O(t);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const n=this.lb(await this.j(t),t);await this.P(n,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,0,r)),r}async P(t,n){const r=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&s.FileType.Directory))throw new Error((0,b.localize)(16,null,this.nb(n)));break}catch(a){if((0,s.toFileSystemProviderErrorCode)(a)!==s.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(n)),n=i.dirname(n)}for(let a=r.length-1;a>=0;a--){n=i.joinPath(n,r[a]);try{await t.mkdir(n)}catch(l){if((0,s.toFileSystemProviderErrorCode)(l)!==s.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,n){try{await this.Q(t,n)}catch(r){return r}return!0}async Q(t,n){const r=this.lb(await this.j(t),t);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,b.localize)(17,null,this.nb(t)));let a;try{a=await r.stat(t)}catch{}if(a)this.mb(t,a);else throw new s.FileOperationError((0,b.localize)(18,null,this.nb(t)),1);if(!!!n?.recursive){const c=await this.resolve(t);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,b.localize)(19,null,this.nb(t)))}return r}async del(t,n){const r=await this.Q(t,n),i=!!n?.useTrash,a=!!n?.recursive;await r.delete(t,{recursive:a,useTrash:i}),this.m.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,n){const r=await this.j(t),i=this.lb(await this.l(n),n);if(r===i&&this.N(r).providerExtUri.isEqual(t,n))return;if(r===i&&(0,s.hasFileCloneCapability)(r))return r.cloneFile(t,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const a=this.X.queueFor(t,this.N(r).providerExtUri);return r===i&&(0,s.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(t,n,{overwrite:!0})):a.queue(()=>this.J(r,t,i,n))}watch(t,n={recursive:!1,excludes:[]}){const r=new d.DisposableStore;let i=!1,a=()=>{i=!0};return r.add((0,d.toDisposable)(()=>a())),(async()=>{try{const l=await this.W(t,n);i?(0,d.dispose)(l):a=()=>(0,d.dispose)(l)}catch(l){this.b.error(l)}})(),r}async W(t,n){const r=await this.j(t),i=(0,A.hash)([this.N(r).providerExtUri.getComparisonKey(t),n]);let a=this.U.get(i);return a||(a={count:0,disposable:r.watch(t,n)},this.U.set(i,a)),a.count+=1,(0,d.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,d.dispose)(a.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,d.dispose)(t.disposable);this.U.clear()}async Y(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{const a=await t.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,g.isReadableStream)(i)||(0,g.isReadableBufferedStream)(i)?await this.Z(t,a,i):await this.ab(t,a,i)}catch(l){throw(0,s.ensureFileSystemProviderError)(l)}finally{await t.close(a)}})}async Z(t,n,r){let i=0,a;if((0,g.isReadableBufferedStream)(r)){if(r.buffer.length>0){const l=o.VSBuffer.concat(r.buffer);await this.bb(t,n,l,l.byteLength,i,0),i+=l.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((l,c)=>{(0,g.listenStream)(a,{onData:async p=>{a.pause();try{await this.bb(t,n,p,p.byteLength,i,0)}catch(P){return c(P)}i+=p.byteLength,setTimeout(()=>a.resume())},onError:p=>c(p),onEnd:()=>l()})})}async ab(t,n,r){let i=0,a;for(;(a=r.read())!==null;)await this.bb(t,n,a,a.byteLength,i,0),i+=a.byteLength}async bb(t,n,r,i,a,l){let c=0;for(;c<i;){const p=await t.write(n,a+c,r.buffer,l+c,i-c);c+=p}}async cb(t,n,r,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.db(t,n,r,i))}async db(t,n,r,i){let a;i instanceof o.VSBuffer?a=i:(0,g.isReadableStream)(i)?a=await(0,o.streamToBuffer)(i):(0,g.isReadableBufferedStream)(i)?a=await(0,o.bufferedStreamToBuffer)(i):a=(0,o.readableToBuffer)(i),await t.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async eb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.fb(t,n,r,i))}async fb(t,n,r,i){let a,l;try{a=await t.open(n,{create:!1}),l=await r.open(i,{create:!0,unlock:!1});const c=o.VSBuffer.alloc(this.a);let p=0,P=0,T=0;do T=await t.read(a,p,c.buffer,P,c.byteLength-P),await this.bb(r,l,c,T,p,P),p+=T,P+=T,P===c.byteLength&&(P=0);while(T>0)}catch(c){throw(0,s.ensureFileSystemProviderError)(c)}finally{await L.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof l=="number"?r.close(l):Promise.resolve()])}}async gb(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.hb(t,n,r,i))}async hb(t,n,r,i){return r.writeFile(i,await t.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async ib(t,n,r,i){return this.X.queueFor(i,this.N(r).providerExtUri).queue(()=>this.jb(t,n,r,i))}async jb(t,n,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const l=await t.readFile(n);await this.bb(r,a,o.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,s.ensureFileSystemProviderError)(l)}finally{await r.close(a)}}async kb(t,n,r,i){const a=await(0,o.streamToBuffer)(this.C(t,n,C.CancellationToken.None));await this.cb(r,i,void 0,a)}lb(t,n){if(t.capabilities&2048)throw new s.FileOperationError((0,b.localize)(20,null,this.nb(n)),6);return t}mb(t,n){if((n.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,b.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=S=Le([Ae(0,u.ILogService)],S)}),define(pe[66],ve([1,0,33,297,14,28,15,6,38,2,7,3,19,47,23,184,16,108,222,39,218,217]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(w)}catch(n){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(n)}`)}})();class t extends u.AbstractDiskFileSystemProvider{constructor(r,i){super(r,i),this.onDidChangeCapabilities=A.Event.None,this.H=new C.ResourceMap(a=>E.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:i,symbolicLink:a}=await g.SymlinkSupport.stat(this.C(r));return{type:this.G(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(r){try{const i=await g.Promises.readdir(this.C(r),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let c;l.isSymbolicLink()?c=(await this.stat((0,E.joinPath)(r,l.name))).type:c=this.G(l),a.push([l.name,c])}catch(c){this.a.trace(c)}})),a}catch(i){throw this.Y(i)}}G(r,i){let a;return i?.dangling?a=s.FileType.Unknown:r.isFile()?a=s.FileType.File:r.isDirectory()?a=s.FileType.Directory:a=s.FileType.Unknown,i&&(a|=s.FileType.SymbolicLink),a}async I(r){const i=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new o.Barrier;return this.H.set(r,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(r)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let a;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),a=await this.I(r));const l=this.C(r);return await g.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{a?.dispose()}}J(r){t.D&&this.a.trace(r)}readFileStream(r,i,a){const l=(0,m.newWriteableStream)(c=>D.VSBuffer.concat(c.map(p=>D.VSBuffer.wrap(p))).buffer);return(0,h.readFileIntoStream)(this,r,l,c=>c.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(r,i,a){let l;try{const c=this.C(r);if(!a.create||!a.overwrite){if(await g.Promises.exists(c)){if(!a.overwrite)throw(0,s.createFileSystemProviderError)((0,b.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,s.createFileSystemProviderError)((0,b.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(r,{create:!0,unlock:a.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(c){throw await this.Z(r,c)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(r){t.O=r}async open(r,i){const a=this.C(r);let l;(0,s.isFileOpenForWriteOptions)(i)&&(l=await this.I(r));let c;try{if((0,s.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await g.SymlinkSupport.stat(a);P.mode&128||await g.Promises.chmod(a,P.mode|128)}catch(P){this.a.trace(P)}let p;if((0,s.isFileOpenForWriteOptions)(i)){if(y.isWindows)try{await g.Promises.truncate(a,0),p="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}p||(p="w")}else p="r";c=await g.Promises.open(a,p)}catch(p){throw l?.dispose(),(0,s.isFileOpenForWriteOptions)(i)?await this.Z(r,p):this.Y(p)}if(this.L.set(c,0),(0,s.isFileOpenForWriteOptions)(i)&&this.N.set(c,r),l){const p=this.M.get(c);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${a})`),this.M.set(c,l),p&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${a})`),p.dispose())}return c}async close(r){const i=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&t.O)try{await g.Promises.fdatasync(r)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await g.Promises.close(r)}catch(a){throw this.Y(a)}finally{i&&(this.M.get(r)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,a,l,c){const p=this.P(r,i);let P=null;try{P=(await g.Promises.read(r,a,l,c,p)).bytesRead}catch(T){throw this.Y(T)}finally{this.Q(r,p,P)}return P}P(r,i){return i===this.L.get(r)?null:i}Q(r,i,a){const l=this.L.get(r);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.L.set(r,l+a):this.L.delete(r)))}async write(r,i,a,l,c){return(0,o.retry)(()=>this.R(r,i,a,l,c),100,3)}async R(r,i,a,l,c){const p=this.P(r,i);let P=null;try{P=(await g.Promises.write(r,a,l,c,p)).bytesWritten}catch(T){throw await this.Z(this.N.get(r),T)}finally{this.Q(r,p,P)}return P}async mkdir(r){try{await g.Promises.mkdir(this.C(r))}catch(i){throw this.Y(i)}}async delete(r,i){try{const a=this.C(r);i.recursive?await g.Promises.rm(a,g.RimRafMode.MOVE):await g.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(r,i,a){const l=this.C(r),c=this.C(i);if(l!==c)try{await this.S(r,i,"move",a.overwrite),await g.Promises.move(l,c)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,b.localize)(2,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(c)),p.toString()))),this.Y(p)}}async copy(r,i,a){const l=this.C(r),c=this.C(i);if(l!==c)try{await this.S(r,i,"copy",a.overwrite),await g.Promises.copy(l,c,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,b.localize)(3,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(c)),p.toString()))),this.Y(p)}}async S(r,i,a,l){const c=this.C(r),p=this.C(i);let P=!1;if(!!(this.capabilities&1024)||(P=(0,v.isEqual)(c,p,!0)),P&&a==="copy")throw(0,s.createFileSystemProviderError)((0,b.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(!P&&await g.Promises.exists(p)){if(!l)throw(0,s.createFileSystemProviderError)((0,b.localize)(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(r,i){return this.U(r,i,!1)}async U(r,i,a){const l=this.C(r),c=this.C(i),p=!!(this.capabilities&1024);if((0,v.isEqual)(l,c,!p))return;const P=new d.DisposableStore;try{const[T,I]=await Promise.all([this.I(r),this.I(i)]);P.add(T),P.add(I),a&&await g.Promises.mkdir((0,R.dirname)(c),{recursive:!0}),await g.Promises.copyFile(l,c)}catch(T){if(T.code==="ENOENT"&&!a)return this.U(r,i,!0);throw this.Y(T)}finally{P.dispose()}}p(r,i,a){return new S.UniversalWatcherClient(l=>r(l),l=>i(l),a)}y(r,i,a){return new O.NodeJSWatcherClient(l=>r(l),l=>i(l),a)}Y(r){if(r instanceof s.FileSystemProviderError)return r;let i=r,a;switch(r.code){case"ENOENT":a=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=s.FileSystemProviderErrorCode.Unknown;break;default:a=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,a)}async Z(r,i){let a=this.Y(i);if(r&&a.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await g.SymlinkSupport.stat(this.C(r));l.mode&128||(a=(0,s.createFileSystemProviderError)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(pe[223],ve([1,0,6,66,2,15,47,20]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends o.Disposable{constructor(y,E){super(),this.a=y,this.b=E,this.w=new Map,this.y=new Map}call(y,E,m){const g=this.c(y);switch(E){case"stat":return this.g(g,m[0]);case"readdir":return this.h(g,m[0]);case"open":return this.l(g,m[0],m[1]);case"close":return this.m(m[0]);case"read":return this.n(m[0],m[1],m[2]);case"readFile":return this.i(g,m[0],m[1]);case"write":return this.p(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.k(g,m[0],m[1],m[2]);case"rename":return this.t(g,m[0],m[1],m[2]);case"copy":return this.u(g,m[0],m[1],m[2]);case"cloneFile":return this.v(g,m[0],m[1]);case"mkdir":return this.r(g,m[0]);case"delete":return this.s(g,m[0],m[1]);case"watch":return this.C(g,m[0],m[1],m[2],m[3]);case"unwatch":return this.D(m[0],m[1])}throw new Error(`IPC Command ${E} not found`)}listen(y,E,m){const g=this.c(y);switch(E){case"fileChange":return this.z(g,m[0]);case"readFileStream":return this.j(g,m[0],m[1])}throw new Error(`Unknown event ${E}`)}g(y,E){const m=this.f(y,E,!0);return this.a.stat(m)}h(y,E){const m=this.f(y,E);return this.a.readdir(m)}async i(y,E,m){const g=this.f(y,E,!0),b=await this.a.readFile(g,m);return C.VSBuffer.wrap(b)}j(y,E,m){const g=this.f(y,E,!0),b=new A.CancellationTokenSource,s=new w.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),h=this.a.readFileStream(g,m,b.token);return(0,D.listenStream)(h,{onData:u=>s.fire(C.VSBuffer.wrap(u)),onError:u=>s.fire(u),onEnd:()=>{s.fire("end"),s.dispose(),b.dispose()}}),s.event}k(y,E,m,g){const b=this.f(y,E);return this.a.writeFile(b,m.buffer,g)}l(y,E,m){const g=this.f(y,E,!0);return this.a.open(g,m)}m(y){return this.a.close(y)}async n(y,E,m){const g=C.VSBuffer.alloc(m),b=0,s=await this.a.read(y,E,g.buffer,b,m);return[g,s]}p(y,E,m,g,b){return this.a.write(y,E,m.buffer,g,b)}r(y,E){const m=this.f(y,E);return this.a.mkdir(m)}s(y,E,m){const g=this.f(y,E);return this.a.delete(g,m)}t(y,E,m,g){const b=this.f(y,E),s=this.f(y,m);return this.a.rename(b,s,g)}u(y,E,m,g){const b=this.f(y,E),s=this.f(y,m);return this.a.copy(b,s,g)}v(y,E,m){const g=this.f(y,E),b=this.f(y,m);return this.a.cloneFile(g,b)}z(y,E){const m=new w.Emitter({onWillAddFirstListener:()=>{this.w.set(E,this.F(y,m))},onDidRemoveLastListener:()=>{(0,o.dispose)(this.w.get(E)),this.w.delete(E)}});return m.event}async C(y,E,m,g,b){const s=this.w.get(E);if(s){const h=this.f(y,g),u=s.watch(m,h,b);this.y.set(E+m,u)}}async D(y,E){const m=y+E,g=this.y.get(m);g&&((0,o.dispose)(g),this.y.delete(m))}dispose(){super.dispose();for(const[,y]of this.y)y.dispose();this.y.clear();for(const[,y]of this.w)y.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class d extends o.Disposable{constructor(y,E,m,g){super(),this.c=y,this.f=m,this.g=g,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(E)}h(y){const E=this.B(new w.Emitter);this.B(E.event(m=>{y.fire(m.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type})))})),this.B(this.b.onDidChangeFile(m=>E.fire(m))),this.B(this.b.onDidWatchError(m=>y.fire(m)))}i(y){}j(y){}watch(y,E,m){const g=this.j(this.g);return Array.isArray(g)&&(m.excludes=[...m.excludes,...g]),this.a.set(y,this.b.watch(E,m)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.a.get(y)),this.a.delete(y)})}dispose(){super.dispose();for(const[,y]of this.a)y.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=d}),define(pe[111],ve([1,0,4,6,12,2]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class D extends o.AbstractLoggerService{constructor(y,E,m,g,b){super(E,m,g),this.n=y,this.p=b,this.B(b.listen("onDidChangeLogLevel",y)(s=>{(0,o.isLogLevel)(s)?super.setLogLevel(s):super.setLogLevel(w.URI.revive(s[0]),s[1])})),this.B(b.listen("onDidChangeVisibility",y)(([s,h])=>super.setVisibility(w.URI.revive(s),h))),this.B(b.listen("onDidChangeLoggers",y)(({added:s,removed:h})=>{for(const u of s)super.registerLogger({...u,resource:w.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new o.AdapterLogger({log:(y,E)=>{this.p.call("consoleLog",[y,E])}})}registerLogger(y){super.registerLogger(y),this.p.call("registerLogger",[y,this.n])}deregisterLogger(y){super.deregisterLogger(y),this.p.call("deregisterLogger",[y,this.n])}setLogLevel(y,E){super.setLogLevel(y,E),this.p.call("setLogLevel",[y,E])}setVisibility(y,E){super.setVisibility(y,E),this.p.call("setVisibility",[this.l(y),E])}m(y,E,m){return new A(this.p,y,E,m,this.n)}static setLogLevel(y,E,m){return y.call("setLogLevel",[E,m])}}e.LoggerChannelClient=D;class A extends o.AbstractMessageLogger{constructor(y,E,m,g,b){super(g?.logLevel==="always"),this.m=y,this.n=E,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[E,g,b]).then(()=>{this.r(this.l),this.k=!0})}g(y,E){const m=[[y,E]];this.k?this.r(m):this.l.push(...m)}r(y){this.m.call("log",[this.n,y])}}class v{constructor(y,E){this.a=y,this.b=E}listen(y,E){const m=this.b(y);switch(E){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(b=>this.c(b,m)),removed:[...g.removed].map(b=>this.c(b,m))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,g=>[m.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,g=>(0,o.isLogLevel)(g)?g:[m.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${E}`)}async call(y,E,m){const g=this.b(y);switch(E){case"setLogLevel":return(0,o.isLogLevel)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(w.URI.revive(g.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,g)))}throw new Error(`Call not found: ${E}`)}c(y,E){return{...y,resource:E.transformOutgoingURI(y.resource)}}}e.LoggerChannel=v;class d extends C.Disposable{constructor(y,E){super(),E.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(m=>E.call("setLogLevel",[m]))),E.call("getRegisteredLoggers").then(m=>{for(const g of m)y.registerLogger({...g,resource:w.URI.revive(g.resource)})}),this.B(E.listen("onDidChangeVisibility")(([m,g])=>y.setVisibility(w.URI.revive(m),g))),this.B(E.listen("onDidChangeLoggers")(({added:m,removed:g})=>{for(const b of m)y.registerLogger({...b,resource:w.URI.revive(b.resource)});for(const b of g)y.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=d}),define(pe[112],ve([1,0,2,12]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class o extends w.Disposable{constructor(D,A=[]){super(),this.a=new L.MultiplexLogger([D,...A]),this.B(D.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...A){this.a.trace(D,...A)}debug(D,...A){this.a.debug(D,...A)}info(D,...A){this.a.info(D,...A)}warn(D,...A){this.a.warn(D,...A)}error(D,...A){this.a.error(D,...A)}flush(){this.a.flush()}}e.LogService=o}),define(pe[224],ve([1,0,16,12]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var o;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(o||(o={}));async function C(d,R,y,E,m){try{const g=await new Promise((s,h)=>{oe(["@vscode/spdlog"],s,h)});g.setFlushOn(o.Trace);const b=await g.createAsyncRotatingLogger(d,R,y,E);return m?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(g){console.error(g)}return null}function D(d,R,y){switch(R){case L.LogLevel.Trace:d.trace(y);break;case L.LogLevel.Debug:d.debug(y);break;case L.LogLevel.Info:d.info(y);break;case L.LogLevel.Warning:d.warn(y);break;case L.LogLevel.Error:d.error(y);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function A(d,R){switch(R){case L.LogLevel.Trace:d.setLevel(o.Trace);break;case L.LogLevel.Debug:d.setLevel(o.Debug);break;case L.LogLevel.Info:d.setLevel(o.Info);break;case L.LogLevel.Warning:d.setLevel(o.Warning);break;case L.LogLevel.Error:d.setLevel(o.Error);break;case L.LogLevel.Off:d.setLevel(o.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class v extends L.AbstractMessageLogger{constructor(R,y,E,m,g){super(),this.k=[],this.setLevel(g),this.l=this.n(R,y,E,m),this.B(this.onDidChangeLogLevel(b=>{this.m&&A(this.m,b)}))}async n(R,y,E,m){const g=E?6:1,b=30/g*w.ByteSize.MB,s=await C(R,y,b,g,m);if(s){this.m=s,A(this.m,this.getLevel());for(const{level:h,message:u}of this.k)D(this.m,h,u);this.k=[]}}g(R,y){this.m?D(this.m,R,y):this.getLevel()<=R&&this.k.push({level:R,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=v}),define(pe[113],ve([1,0,21,12,224]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends L.AbstractLoggerService{m(A,v,d){return new o.SpdLogLogger((0,w.generateUuid)(),A.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,v)}}e.LoggerService=C}),define(pe[225],ve([1,0,59,186,5]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(C||(e.MarkerTag=C={}));var D;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(D||(e.MarkerSeverity=D={})),function(v){function d(g,b){return b-g}v.compare=d;const R=Object.create(null);R[v.Error]=(0,L.localize)(0,null),R[v.Warning]=(0,L.localize)(1,null),R[v.Info]=(0,L.localize)(2,null);function y(g){return R[g]||""}v.toString=y;function E(g){switch(g){case w.default.Error:return v.Error;case w.default.Warning:return v.Warning;case w.default.Info:return v.Info;case w.default.Ignore:return v.Hint}}v.fromSeverity=E;function m(g){switch(g){case v.Error:return w.default.Error;case v.Warning:return w.default.Warning;case v.Info:return w.default.Info;case v.Hint:return w.default.Ignore}}v.toSeverity=m}(D||(e.MarkerSeverity=D={}));var A;(function(v){const d="";function R(E){return y(E,!0)}v.makeKey=R;function y(E,m){const g=[d];return E.source?g.push(E.source.replace("\xA6","\\\xA6")):g.push(d),E.code?typeof E.code=="string"?g.push(E.code.replace("\xA6","\\\xA6")):g.push(E.code.value.replace("\xA6","\\\xA6")):g.push(d),E.severity!==void 0&&E.severity!==null?g.push(D.toString(E.severity)):g.push(d),E.message&&m?g.push(E.message.replace("\xA6","\\\xA6")):g.push(d),E.startLineNumber!==void 0&&E.startLineNumber!==null?g.push(E.startLineNumber.toString()):g.push(d),E.startColumn!==void 0&&E.startColumn!==null?g.push(E.startColumn.toString()):g.push(d),E.endLineNumber!==void 0&&E.endLineNumber!==null?g.push(E.endLineNumber.toString()):g.push(d),E.endColumn!==void 0&&E.endColumn!==null?g.push(E.endColumn.toString()):g.push(d),g.push(d),g.join("\xA6")}v.makeKeyOptionalMessage=y})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,o.createDecorator)("markerService")}),define(pe[67],ve([1,0,6,46,2,5]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class D extends o.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new w.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const R=Object.keys(this.f).length;return this.f={...d,...this.f},R!==Object.keys(this.f).length&&await this.i(d),L.Iterable.reduce(this.g.entries(),(y,[E,m])=>({...y,[E]:m}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(d,[R,y])=>({...d,[R]:{definition:y,value:this.g.get(R)}}),{})}}e.AbstractPolicyService=D;class A{constructor(){this.onDidChange=w.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=A}),define(pe[53],ve([1,0,3,29]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.context<"u"){const C=w.globals.vscode.context.configuration();if(C)o=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:C.version})}Object.assign(o,{extensionsGallery:L.env.EXTENSIONS_GALLERY?JSON.parse(L.env.EXTENSIONS_GALLERY):o.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else o={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodetunnelserviceoss",win32TunnelMutex:"vscodetunneloss",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.78.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.78.2",commit:"b3e4e68a0bc097f0ae7907b217c1119af9e03435",date:"2023-05-15T23:49:06.683Z"},Object.keys(o).length===0&&Object.assign(o,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(pe[27],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(pe[40],ve([1,0,93,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class o{constructor(){this.a=new Map}add(D,A){w.ok(L.isString(D)),w.ok(L.isObject(A)),w.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,A)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new o}),define(pe[226],ve([1,0,6,40]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function o(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class C{constructor(){this.b=new w.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,d){this.a[o(v)]=d,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const D=new C;L.Registry.add(e.Extensions.JSONContribution,D)}),define(pe[54],ve([1,0,18,6,8,168,24,226,40]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(O){O.Multiline="multilineText",O.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(O){O[O.APPLICATION=1]="APPLICATION",O[O.MACHINE=2]="MACHINE",O[O.WINDOW=3]="WINDOW",O[O.RESOURCE=4]="RESOURCE",O[O.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",O[O.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=v.Registry.as(A.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.n(t,n,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.o(t,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.o(n,r),this.n(t,!1,r),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const r=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const c=this.a.get(l),p=c?.valuesSources??new Map;if(a)for(const F of Object.keys(i[l]))p.set(F,a);const P={...c?.value||{},...i[l]};this.a.set(l,{source:a,value:P,valuesSources:p});const T=(0,D.getLanguageTagSettingPlainKey)(l),I={type:"object",default:P,description:C.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:o.isString(a)?void 0:a,defaultValueSource:a};r.push(...b(l)),this.d[l]=I,this.b.properties[l]=I}else{this.a.set(l,{value:i[l],source:a});const c=this.d[l];c&&(this.w(l,c),this.r(l,c))}this.m(r)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:r,source:i}of t)for(const a in r){const l=this.a.get(a),c=o.isString(i)?i:i?.id,p=o.isString(l?.source)?l?.source:l?.source?.id;if(c===p)if(n.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const P=this.d[a];P&&(this.w(a,P),this.r(a,P))}}this.u()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,r){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,n){const r=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>r(a))};for(const i of t){r(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,r,i,a=3,l){a=o.isUndefinedOrNull(t.scope)?a:t.scope;const c=t.properties;if(c)for(const P in c){const T=c[P];if(n&&f(P,T)){delete c[P];continue}if(T.source=r,T.defaultDefaultValue=c[P].default,this.w(P,T),e.OVERRIDE_PROPERTY_REGEX.test(P)?T.scope=void 0:(T.scope=o.isUndefinedOrNull(T.scope)?a:T.scope,T.restricted=o.isUndefinedOrNull(T.restricted)?!!i?.includes(P):T.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.f[P]=c[P],delete c[P];continue}else this.d[P]=c[P],c[P].policy?.name&&this.e.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),l.add(P)}const p=t.allOf;if(p)for(const P of p)this.p(P,n,r,i,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(n)};n(t)}r(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,r={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}}v(){const t={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,n){const r=this.a.get(t);let i=r?.value,a=r?.source;o.isUndefined(i)&&(i=n.defaultDefaultValue,a=void 0),o.isUndefined(i)&&(i=h(n.type)),n.default=i,n.defaultValueSource=a}}const m="\\[([^\\]]+)\\]",g=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(O){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(O)){let n=g.exec(O);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=g.exec(O)}}return(0,w.distinct)(t)}e.overrideIdentifiersFromKey=b;function s(O){return O.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=s;function h(O){switch(Array.isArray(O)?O[0]:O){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new E;v.Registry.add(e.Extensions.Configuration,u);function f(O,t){return O.trim()?e.OVERRIDE_PROPERTY_REGEX.test(O)?C.localize(7,null,O):u.getConfigurationProperties()[O]!==void 0?C.localize(8,null,O):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?C.localize(9,null,O,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:C.localize(6,null)}e.validateProperty=f;function S(){const O=[],t=u.getConfigurationProperties();for(const n of Object.keys(t))O.push([n,t[n].scope]);return O.push(["launch",4]),O.push(["task",4]),O}e.getScopes=S}),define(pe[114],ve([1,0,18,6,72,2,28,22,8,4,24,54,40]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(n){return Object.isFrozen(n)?n:A.deepFreeze(n)}class g{constructor(r={},i=[],a=[],l){this.b=r,this.c=i,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof g)return i;const a=new b("");return a.parseRaw(i),a.configurationModel});this.f=r.reduce((i,a)=>a===i?a:i.merge(a),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const a=this.rawConfiguration.getValue(r),l=i?this.rawConfiguration.getOverrideValue(r,i):void 0,c=i?this.rawConfiguration.override(i).getValue(r):a;return{value:a,override:l,merged:c}}getOverrideValue(r,i){const a=this.i(i);return a?r?(0,R.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return w.distinct(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),a=A.deepClone(this.overrides),l=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const p of r)if(c.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.h(i,p.contents);for(const P of p.overrides){const[T]=a.filter(I=>w.equals(I.identifiers,P.identifiers));T?(this.h(T.contents,P.contents),T.keys.push(...P.keys),T.keys=w.distinct(T.keys)):a.push(A.deepClone(P))}for(const P of p.keys)l.indexOf(P)===-1&&l.push(P)}return new g(i,l,a,c.every(p=>p instanceof g)?void 0:c)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[l];const p=i[l];p&&(typeof c=="object"&&typeof p=="object"?(c=A.deepClone(c),this.h(c,p)):c=p),a[l]=c}return new g(a,this.keys,this.overrides)}h(r,i){for(const a of Object.keys(i)){if(a in r&&v.isObject(r[a])&&v.isObject(i[a])){this.h(r[a],i[a]);continue}r[a]=A.deepClone(i[a])}}i(r){let i=null,a=null;const l=c=>{c&&(a?this.h(a,c):a=A.deepClone(c))};for(const c of this.overrides)w.equals(c.identifiers,[r])?i=c.contents:c.identifiers.includes(r)&&l(c.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,R.removeFromValueTree)(this.contents,r),y.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(a=>w.equals(a.identifiers,(0,y.overrideIdentifiersFromKey)(r))),1))}j(r,i,a){(0,R.addToValueTree)(this.contents,r,i,l=>console.error(l)),a=a||this.keys.indexOf(r)===-1,a&&this.keys.push(r),y.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,R.toValuesTree)(this.contents[r],l=>console.error(l))})}}e.ConfigurationModel=g;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!v.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:a,keys:l,overrides:c,restricted:p,hasExcludedProperties:P}=this.h(r,i);this.b=new g(a,l,c,P?[r]:void 0),this.c=p||[]}g(r){let i={},a=null,l=[];const c=[],p=[];function P(I){Array.isArray(l)?l.push(I):a!==null&&(l[a]=I)}const T={onObjectBegin:()=>{const I={};P(I),c.push(l),l=I,a=null},onObjectProperty:I=>{a=I},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const I=[];P(I),c.push(l),l=I,a=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:P,onError:(I,F,H)=>{p.push({error:I,offset:F,length:H})}};if(r)try{o.visit(r,T),i=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return i}h(r,i){const a=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),l=this.i(r,a,!0,i);r=l.raw;const c=(0,R.toValuesTree)(r,T=>console.error(`Conflict in settings file ${this.f}: ${T}`)),p=Object.keys(r),P=this.j(r,T=>console.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:c,keys:p,overrides:P,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,i,a,l){let c=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const p={},P=[];for(const T in r)if(y.OVERRIDE_PROPERTY_REGEX.test(T)&&a){const I=this.i(r[T],i,!1,l);p[T]=I.raw,c=c||I.hasExcludedProperties,P.push(...I.restricted)}else{const I=i[T],F=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&P.push(T),(F===void 0||l.scopes===void 0||l.scopes.includes(F))&&!(l.skipRestricted&&I?.restricted)?p[T]=r[T]:c=!0}return{raw:p,restricted:P,hasExcludedProperties:c}}j(r,i){const a=[];for(const l of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(l)){const c={};for(const p in r[l])c[p]=r[l][p];a.push({identifiers:(0,y.overrideIdentifiersFromKey)(l),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,i)})}return a}}e.ConfigurationModelParser=b;class s extends C.Disposable{constructor(r,i,a,l){super(),this.f=r,this.g=i,this.h=l,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class h{constructor(r,i,a,l,c,p,P,T,I,F,H,ee,ce){this.a=r,this.b=i,this.c=a,this.overrideIdentifiers=l,this.d=c,this.f=p,this.g=P,this.h=T,this.i=I,this.j=F,this.k=H,this.l=ee,this.m=ce}get value(){return m(this.c)}n(r,i,a){const l=r.inspect(i,a);return{get value(){return m(l.value)},get override(){return m(l.override)},get merged(){return m(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(r,i,a,l,c=new g,p=new g,P=new D.ResourceMap,T=new g,I=new D.ResourceMap){this.c=r,this.d=i,this.f=a,this.g=l,this.h=c,this.i=p,this.j=P,this.l=T,this.m=I,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(r,i,a){return this.q(r,i,a).getValue(r)}updateValue(r,i,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new g,this.m.set(a.resource,l))):l=this.l,i===void 0?l.removeValue(r):l.setValue(r,i),a.resource||(this.a=null)}inspect(r,i,a){const l=this.q(r,i,a),c=this.u(i.resource,a),p=i.resource?this.m.get(i.resource)||this.l:this.l,P=new Set;for(const T of l.overrides)for(const I of T.identifiers)l.getOverrideValue(r,I)!==void 0&&P.add(I);return new h(r,i,l.getValue(r),P.size?[...P]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,c||void 0,p)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:l,updated:c,removed:p}=O(this.c,r);i=[...l,...c,...p]}for(const l of i)for(const c of(0,y.overrideIdentifiersFromKey)(l)){const p=this.c.getKeysForOverrideIdentifier(c),P=r.getKeysForOverrideIdentifier(c),T=[...P.filter(I=>p.indexOf(I)===-1),...p.filter(I=>P.indexOf(I)===-1),...p.filter(I=>!A.equals(this.c.override(c).getValue(I),r.override(c).getValue(I)))];a.push([c,T])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:l}=O(this.d,r),c=[...i,...a,...l];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.applicationConfiguration,r),p=[...i,...a,...l];return p.length&&this.updateApplicationConfiguration(r),{keys:p,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.localUserConfiguration,r),p=[...i,...a,...l];return p.length&&this.updateLocalUserConfiguration(r),{keys:p,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.remoteUserConfiguration,r),p=[...i,...a,...l];return p.length&&this.updateRemoteUserConfiguration(r),{keys:p,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:l,overrides:c}=O(this.workspaceConfiguration,r),p=[...i,...a,...l];return p.length&&this.updateWorkspaceConfiguration(r),{keys:p,overrides:c}}compareAndUpdateFolderConfiguration(r,i){const a=this.p.get(r),{added:l,updated:c,removed:p,overrides:P}=O(a,i),T=[...l,...c,...p];return(T.length||!a)&&this.updateFolderConfiguration(r,i),{keys:T,overrides:P}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:l,removed:c,overrides:p}=O(i,void 0);return{keys:[...a,...l,...c],overrides:p}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,a){let l=this.r(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}r({resource:r},i){let a=this.s();if(i&&r){const l=i.getFolder(r);l&&(a=this.t(l.uri)||a);const c=this.m.get(r);c&&(a=a.merge(c))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const a=this.s(),l=this.j.get(r);l?(i=a.merge(l),this.b.set(r,i)):i=a}return i}u(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:a,overrides:l,keys:c}=this.j.get(i);return r.push([i,{contents:a,overrides:l,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(a=>r.add(a))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r){const i=this.x(r.defaults),a=this.x(r.policy),l=this.x(r.application),c=this.x(r.user),p=this.x(r.workspace),P=r.folders.reduce((T,I)=>(T.set(d.URI.revive(I[0]),this.x(I[1])),T),new D.ResourceMap);return new u(i,a,l,c,new g,p,P,new g,new D.ResourceMap)}static x(r){return new g(r.contents,r.keys,r.overrides)}}e.Configuration=u;function f(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const l of n)l.keys.forEach(c=>r.add(c)),l.overrides.forEach(([c,p])=>{const P=(0,D.getOrSet)(i,c,new Set);p.forEach(T=>P.add(T))});const a=[];return i.forEach((l,c)=>a.push([c,[...l.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=f;class S{constructor(r,i,a,l){this.change=r,this.f=i,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const p of c)this.affectedKeys.add(p);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(r,i){const a=this.a+r,l=this.d.indexOf(a);if(l<0)return!1;const c=l+a.length;if(c>=this.d.length)return!1;const p=this.d.charCodeAt(c);if(p!==this.b&&p!==this.c)return!1;if(i){const P=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,T=this.g.getValue(r,i,this.h);return!A.equals(P,T)}return!0}}e.ConfigurationChangeEvent=S;function O(n,r){const{added:i,removed:a,updated:l}=t(r?.rawConfiguration,n?.rawConfiguration),c=[],p=n?.getAllOverrideIdentifiers()||[],P=r?.getAllOverrideIdentifiers()||[];if(r){const T=P.filter(I=>!p.includes(I));for(const I of T)c.push([I,r.getKeysForOverrideIdentifier(I)])}if(n){const T=p.filter(I=>!P.includes(I));for(const I of T)c.push([I,n.getKeysForOverrideIdentifier(I)])}if(r&&n){for(const T of p)if(P.includes(T)){const I=t({contents:n.getOverrideValue(void 0,T)||{},keys:n.getKeysForOverrideIdentifier(T)},{contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)});c.push([T,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:a,updated:l,overrides:c}}function t(n,r){const i=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],a=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],l=[];if(n&&r){for(const c of r.keys)if(n.keys.indexOf(c)!==-1){const p=(0,R.getConfigurationValue)(r.contents,c),P=(0,R.getConfigurationValue)(n.contents,c);A.equals(p,P)||l.push(c)}}return{added:i,removed:a,updated:l}}}),define(pe[227],ve([1,0,18,6,2,22,8,114,54,12,67,40]),function(oe,e,w,L,o,C,D,A,v,d,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class E extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new A.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:h})=>this.c(Array.from(s),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(s,h){this.h(s,y.Registry.as(v.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:s})}f(){return{}}g(){this.b=new A.ConfigurationModel;const s=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(s),s)}h(s,h){const u=this.f();for(const f of s){const S=u[f],O=h[f];S!==void 0?this.b.addValue(f,S):O?this.b.addValue(f,O.default):this.b.removeValue(f)}}}e.DefaultConfiguration=E;class m{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new A.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let g=e.PolicyConfiguration=class extends o.Disposable{get configurationModel(){return this.b}constructor(s,h,u){super(),this.c=s,this.f=h,this.g=u,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new A.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(s=>this.i(s))),this.B(this.c.onDidChangeConfiguration(async({properties:s})=>this.j(await this.h(s),!0))),this.b}async h(s){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",s);const h={},u=[],f=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const S of s){const O=f[S];if(!O){u.push(S);continue}if(O.policy){if(O.type!=="string"&&O.type!=="number"){this.g.warn(`Policy ${O.policy.name} has unsupported type ${O.type}`);continue}u.push(S),h[O.policy.name]={type:O.type}}}return(0,D.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),u}i(s){this.g.trace("PolicyConfiguration#onDidChangePolicies",s);const h=y.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),u=(0,w.coalesce)(s.map(f=>h.get(f)));this.j(u,!0)}j(s,h){this.g.trace("PolicyConfiguration#update",s);const u=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),f=[],S=this.b.isEmpty();for(const O of s){const t=u[O]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(S?n!==void 0:!(0,C.equals)(this.b.getValue(O),n))&&f.push([O,n])}else this.b.getValue(O)!==void 0&&f.push([O,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const O=this.b;this.b=new A.ConfigurationModel;for(const t of O.keys)this.b.setValue(t,O.getValue(t));for(const[t,n]of f)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);h&&this.a.fire(this.b)}}};e.PolicyConfiguration=g=Le([Ae(1,R.IPolicyService),Ae(2,d.ILogService)],g)}),define(pe[115],ve([1,0,14,6,2,19,24,114,227,67]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends o.Disposable{constructor(E,m,g,b){super(),this.i=E,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.DefaultConfiguration),this.c=g instanceof d.NullPolicyService?new v.NullPolicyConfiguration:this.B(new v.PolicyConfiguration(this.b,g,b)),this.f=this.B(new A.UserSettings(this.i,void 0,C.extUriBiasedIgnorePathCase,m)),this.a=new A.Configuration(this.b.configurationModel,this.c.configurationModel,new A.ConfigurationModel,new A.ConfigurationModel),this.g=this.B(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:h})=>this.k(s,h))),this.B(this.c.onDidChangeConfiguration(s=>this.l(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[E,m,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new A.Configuration(E,m,new A.ConfigurationModel,g)}getConfigurationData(){return this.a.toData()}getValue(E,m){const g=typeof E=="string"?E:void 0,b=(0,D.isConfigurationOverrides)(E)?E:(0,D.isConfigurationOverrides)(m)?m:{};return this.a.getValue(g,b,void 0)}updateValue(E,m,g,b){return Promise.reject(new Error("not supported"))}inspect(E){return this.a.inspect(E,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const E=await this.f.loadConfiguration();this.j(E)}j(E){const m=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(E);this.m(g,m,2)}k(E,m){const g=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(E,m);this.m(b,g,7)}l(E){const m=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(E);this.m(g,m,7)}m(E,m,g){const b=new A.ConfigurationChangeEvent(E,{data:m},this.a);b.source=g,b.sourceConfig=this.n(g),this.h.fire(b)}n(E){switch(E){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(pe[116],ve([1,0,9,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var o;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(o||(e.RemoteAuthorityResolverErrorCode=o={}));class C extends w.ErrorNoTelemetry{static isNotAvailable(v){return v instanceof C&&v._code===o.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof C&&v._code===o.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof C&&v._code===o.NoResolverFound}static isHandled(v){return v instanceof C&&v.isHandled}constructor(v,d=o.Unknown,R){super(v),this._message=v,this._code=d,this._detail=R,this.isHandled=d===o.NotAvailable&&R===!0,Object.setPrototypeOf(this,C.prototype)}}e.RemoteAuthorityResolverError=C;function D(A){const v=A.indexOf("+");return v===-1?A:A.substring(0,v)}e.getRemoteAuthorityPrefix=D}),define(pe[228],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,w.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(pe[55],ve([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(d){return d.scheme===w.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=L;function o(d){if(!d)return;const R=d.indexOf("+");return R<0?d:d.substr(0,R)}e.getRemoteName=o;function C(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=C;function D(d){const{host:R,port:y}=v(d);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:y}}e.parseAuthorityWithPort=D;function A(d,R){let{host:y,port:E}=v(d);return typeof E>"u"&&(E=R),{host:y,port:E}}e.parseAuthorityWithOptionalPort=A;function v(d){const R=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const y=d.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const E=d.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:d,port:void 0}}}),define(pe[36],ve([1,0,17,5,55]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var A;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class v{constructor(s){this.value=s,this.c=s.toLowerCase()}static equals(s,h){if(typeof s>"u"||s===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof s=="string"||typeof h=="string"){const u=typeof s=="string"?s:s.value,f=typeof h=="string"?h:h.value;return w.equalsIgnoreCase(u,f)}return s.c===h.c}static toKey(s){return typeof s=="string"?s.toLowerCase():s.c}}e.ExtensionIdentifier=v;class d{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const h of s)this.add(h)}add(s){this.c.add(v.toKey(s))}delete(s){return this.c.delete(v.toKey(s))}has(s){return this.c.has(v.toKey(s))}}e.ExtensionIdentifierSet=d;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(v.toKey(s))}get(s){return this.c.get(v.toKey(s))}has(s){return this.c.has(v.toKey(s))}set(s,h){this.c.set(v.toKey(s),h)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function y(b){return E(b)}e.isApplicationScopedExtension=y;function E(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function m(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function g(b,s){if(s){const h=`onResolveRemoteAuthority:${(0,o.getRemoteName)(s)}`;return!!b.activationEvents?.includes(h)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[229],ve([1,0,9,36]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class o{constructor(){this.a=new Map,this.b=new WeakMap}register(D,A){this.a.set(D,A)}readActivationEvents(D){return this.b.has(D)||this.b.set(D,this.c(D)),this.b.get(D)}createActivationEventsMap(D){const A=Object.create(null);for(const v of D){const d=this.readActivationEvents(v);d.length>0&&(A[L.ExtensionIdentifier.toKey(v.identifier)]=d)}return A}c(D){if(typeof D.main>"u"&&typeof D.browser>"u")return[];const A=Array.isArray(D.activationEvents)?D.activationEvents.slice(0):[];if(!D.contributes)return A;for(const v in D.contributes){const d=this.a.get(v);if(!d)continue;const R=D.contributes[v],y=Array.isArray(R)?R:[R];try{d(y,A)}catch(E){(0,w.onUnexpectedError)(E)}}return A}}e.ImplicitActivationEventsImpl=o,e.ImplicitActivationEvents=new o}),define(pe[230],ve([1,0,2,36,16]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class C extends w.Disposable{constructor(A,v,d,R,y){super(),this.a=A,this.b=v,this.c=d,this.f=y,this.B(R.onDidInstallExtensions(E=>this.g(E))),this.B(R.onDidUninstallExtension(E=>this.h(E)))}g(A){for(const v of A)v.local&&this.invalidate(v.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,A)&&await this.i(v);else await this.i(this.a.defaultProfile)}async i(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,L.USER_MANIFEST_CACHE_FILE))}catch(v){(0,o.toFileOperationResult)(v)!==1&&this.f.error(v)}}}e.ExtensionsManifestCache=C}),define(pe[44],ve([1,0,15,9,2,187,54,5,12,40]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");class R{constructor(O){this.b=O}toJSON(){if(!this.a){const O=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?O[t]="*****":O[t]=this.b[t];this.a=O}return this.a}}class y extends o.Disposable{constructor(O,t){super(),this.b=0,this.a=t.createLogger(O?"remotenetwork":"network",{name:O?(0,C.localize)(0,null):(0,C.localize)(1,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async c(O,t,n){const r=`${O} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new R(t.headers??{}));try{const i=await n();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=y;function E(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=E;function m(S){return S.res.statusCode===204}async function g(S){return m(S)?null:(await(0,w.streamToBuffer)(S.stream)).toString()}e.asText=g;async function b(S){if(!E(S))throw new Error("Server returned "+S.res.statusCode);return g(S)}e.asTextOrError=b;async function s(S){if(!E(S))throw new Error("Server returned "+S.res.statusCode);if(m(S))return null;const t=(await(0,w.streamToBuffer)(S.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}e.asJson=s;function h(S){f(S)}e.updateProxyConfigurationsScope=h;let u;function f(S){const O=d.Registry.as(D.Extensions.Configuration),t=u;u={id:"http",order:15,title:(0,C.localize)(2,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(6,null),(0,C.localize)(7,null),(0,C.localize)(8,null),(0,C.localize)(9,null)],default:"override",description:(0,C.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(11,null),restricted:!0}}},O.updateConfigurations({add:[u],remove:t?[t]:[]})}f(1)}),define(pe[231],ve([1,0,20,13,16,44]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=e.DownloadService=class{constructor(v,d){this.a=v,this.b=d}async download(v,d,R=w.CancellationToken.None){if(v.scheme===L.Schemas.file||v.scheme===L.Schemas.vscodeRemote){await this.b.copy(v,d);return}const y={type:"GET",url:v.toString(!0)},E=await this.a.request(y,R);if(E.res.statusCode===200)await this.b.writeFile(d,E.stream);else{const m=await(0,C.asTextOrError)(E);throw new Error(`Expected 200, got back ${E.res.statusCode} instead.

${m}`)}}};e.DownloadService=D=Le([Ae(0,C.IRequestService),Ae(1,o.IFileService)],D)}),define(pe[232],ve([1,0,15,20]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class o{constructor(A){this.a=A}listen(A,v){throw new Error("Invalid listen")}call(A,v,d,R=L.CancellationToken.None){switch(v){case"request":return this.a.request(d[0],R).then(async({res:y,stream:E})=>{const m=await(0,w.streamToBuffer)(E);return[{statusCode:y.statusCode,headers:y.headers},m]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.RequestChannel=o;class C{constructor(A){this.a=A}async request(A,v){const[d,R]=await this.a.call("request",[A],v);return{res:d,stream:(0,w.bufferToStream)(R)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}}e.RequestChannelClient=C}),define(pe[233],ve([1,0,83,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function o(D,A){return D.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:D.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function C(D,A,v={}){const d=(0,w.parse)(D),R=v.proxyUrl||o(d,A);if(!R)return null;const y=(0,w.parse)(R);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,L.isBoolean)(v.strictSSL)?v.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((m,g)=>{oe(["http-proxy-agent"],m,g)}))(E):new(await new Promise((m,g)=>{oe(["https-proxy-agent"],m,g)}))(E)}e.getProxyAgent=C}),define(pe[84],ve([1,0,50,7,188,20,39,9,3,21,156,205,14,143]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let g;async function b(h,u,f,S){return f["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(S)&&!f["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(S)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=E.Promises.withAsyncBody(async(O,t)=>{const n=new C.CancellationTokenSource;let r=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,m.clamp)(i,1,120)*1e3);const a=setTimeout(()=>{n.dispose(!0),t(new Error((0,o.localize)(0,null)))},r);try{O(await s(u,n.token))}catch(l){!(0,A.isCancellationError)(l)&&!n.token.isCancellationRequested?t(new Error((0,o.localize)(1,null,(0,D.toErrorMessage)(l)))):O({})}finally{clearTimeout(a),n.dispose()}})),g)}e.getResolvedShellEnv=b;async function s(h,u){const f=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",f);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",S);const O=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(O+"({.*})"+O),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",n);const r=await(0,R.getSystemShell)(v.OS,n);return h.trace("getUnixShellEnvironment#shell",r),new Promise((i,a)=>{if(u.isCancellationRequested)return a(new A.CancellationError);const l=(0,L.basename)(r);let c,p;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(c=`& '${process.execPath}' ${P} -p '''${O}'' + JSON.stringify(process.env) + ''${O}'''`,p=["-Login","-Command"]):(c=`'${process.execPath}' ${P} -p '"${O}" + JSON.stringify(process.env) + "${O}"'`,l==="tcsh"||l==="csh"?p=["-ic"]:p=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),c);const T=(0,w.spawn)(r,[...p,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(T.kill(),a(new A.CancellationError))),T.on("error",H=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(H)),a(H)});const I=[];T.stdout.on("data",H=>I.push(H));const F=[];T.stderr.on("data",H=>F.push(H)),T.on("close",(H,ee)=>{const ce=Buffer.concat(I).toString("utf8");h.trace("getUnixShellEnvironment#raw",ce);const ae=Buffer.concat(F).toString("utf8");if(ae.trim()&&h.trace("getUnixShellEnvironment#stderr",ae),H||ee)return a(new Error((0,o.localize)(2,null,H,ee)));const ue=t.exec(ce),ge=ue?ue[1]:"{}";try{const G=JSON.parse(ge);f?G.ELECTRON_RUN_AS_NODE=f:delete G.ELECTRON_RUN_AS_NODE,S?G.ELECTRON_NO_ATTACH_CONSOLE=S:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.VSCODE_RESOLVING_ENVIRONMENT,delete G.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",G),i(G)}catch(G){h.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(G)),a(G)}})})}}),define(pe[234],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,w.createDecorator)("stateReadService"),e.IStateService=(0,w.createDecorator)("stateService")}),define(pe[235],ve([1,0,14,15,8,25,16,12]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var v;(function(E){E[E.IMMEDIATE=0]="IMMEDIATE",E[E.DELAYED=1]="DELAYED"})(v||(e.SaveStrategy=v={}));class d{constructor(m,g,b,s){this.f=m,this.g=b,this.h=s,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=g===0?void 0:new w.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.g.error(m)}}getItem(m,g){const b=this.a[m];return(0,o.isUndefinedOrNull)(b)?g:b}setItem(m,g){this.setItems([{key:m,data:g}])}setItems(m){let g=!1;for(const{key:b,data:s}of m)this.a[b]!==s&&((0,o.isUndefinedOrNull)(s)?(0,o.isUndefined)(this.a[b])||(this.a[b]=void 0,g=!0):(this.a[b]=s,g=!0));g&&this.j()}removeItem(m){(0,o.isUndefined)(this.a[m])||(this.a[m]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(m)),this.b=m}catch(g){this.g.error(g)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=d;let R=e.StateReadonlyService=class{constructor(m,g,b,s){this.a=new d(g.stateResource,m,b,s)}async init(){await this.a.init()}getItem(m,g){return this.a.getItem(m,g)}};e.StateReadonlyService=R=Le([Ae(1,C.IEnvironmentService),Ae(2,A.ILogService),Ae(3,D.IFileService)],R);class y extends R{setItem(m,g){this.a.setItem(m,g)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.StateService=y}),define(pe[117],ve([1,0,3,29,21]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(v){if(w.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function D(v,d,R,y,E,m,g,b){const s=Object.create(null);s["common.machineId"]=m,s.sessionID=(0,o.generateUuid)()+Date.now(),s.commitHash=y,s.version=E,s["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,w.PlatformToString)(w.platform),s["common.nodePlatform"]=L.platform,s["common.nodeArch"]=R,s["common.product"]=b||"desktop",g&&(s["common.msftInternal"]=g);let h=0;const u=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),w.isLinuxSnap&&(s["common.snap"]="true");const f=C(d);return f&&(s["common.platformDetail"]=f),s}e.resolveCommonProperties=D;function A(v){const d=L.env.USERDNSDOMAIN;if(!d)return!1;const R=d.toLowerCase();return v.some(y=>R===y)}e.verifyMicrosoftInternalDomain=A}),define(pe[236],ve([1,0,18,9,2,22,16]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(d){function R(y,E){return y.callstack<E.callstack?-1:y.callstack>E.callstack?1:0}d.compare=R})(A||(e.ErrorEvent=A={}));class v{constructor(R,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new o.DisposableStore,this.c=R,this.d=y;const E=L.errorHandler.addListener(m=>this.j(m));this.h.add((0,o.toDisposable)(E)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(R){if(!R||(R.detail&&R.detail.stack&&(R=R.detail),L.ErrorNoTelemetry.isErrorNoTelemetry(R)||R instanceof D.FileOperationError||R?.message?.includes("Unable to read file")))return;const y=Array.isArray(R.stack)?R.stack.join(`
`):R.stack,E=R.message?R.message:(0,C.safeStringify)(R);y&&this.k({msg:E,callstack:y})}k(R){const y=(0,w.binarySearch)(this.g,R,A.compare);y<0?(R.count=1,this.g.splice(~y,0,R)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const R of this.g)this.c.publicLogError2("UnhandledError",R);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(pe[237],ve([1,0,2]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class L extends w.Disposable{constructor(C,D){super(),this.a=C,this.b=D}async call(C,D,A){switch(D){case"updateTelemetryLevel":{const{telemetryLevel:v}=A;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:d}=A;return this.b?this.b.log(v,d):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${D} not found`)}listen(C,D,A){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=L}),define(pe[31],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var o;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(o||(e.TelemetryConfiguration=o={}))}),define(pe[238],ve([1,0,26,14,72,13,7,3,4,99,23,102,211,16,27,31]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function h(t,n){const r=`${t}::${n.join(":")}`,i=s.get(r);if(i)return i;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,c=new Map,p=2e4;function P(I,F,H,ee){const ce=F.substring(I.length+1);return L.Promises.withAsyncBody(async ae=>{let ue;try{ue=await R.Promises.readdir(F,{withFileTypes:!0})}catch{ae();return}if(ee.count>=p){ee.count+=ue.length,ee.maxReached=!0,ae();return}let ge=ue.length;if(ge===0){ae();return}let G=ue;ee.count+ue.length>p&&(ee.maxReached=!0,ge=p-ee.count,G=ue.slice(0,ge)),ee.count+=ue.length;for(const te of G)if(te.isDirectory()){if(H.includes(te.name)||await P(I,(0,D.join)(F,te.name),H,ee),--ge===0){ae();return}}else{const W=te.name.lastIndexOf(".");if(W>=0){const K=te.name.substring(W+1);K&&l.set(K,(l.get(K)??0)+1)}for(const K of a)K.relativePathPattern?.test(ce)!==!1&&K.filePattern.test(te.name)&&c.set(K.tag,(c.get(K.tag)??0)+1);if(--ge===0){ae();return}}})}const T=L.Promises.withAsyncBody(async I=>{const F={count:0,maxReached:!1};await P(t,t,n,F);const H=await S(t);I({configFiles:u(c),fileTypes:u(l),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:H})});return s.set(r,T),T}e.collectWorkspaceStats=h;function u(t){return Array.from(t.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function f(){const t={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},n=w.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=f;async function S(t){try{const n=new Map,r=(0,D.join)(t,".vscode","launch.json"),i=await R.Promises.readFile(r),a=[],l=(0,o.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,o.getNodeType)(l)==="object"&&l.configurations)for(const c of l.configurations){const p=c.type;p&&(n.has(p)?n.set(p,n.get(p)+1):n.set(p,1))}return u(n)}catch{return[]}}e.collectLaunchConfigs=S;let O=e.DiagnosticsService=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),A.isWindows||r.push(`Load (avg):       ${w.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,y.listProcesses)(n.mainPID),this.k(n)]).then(async i=>{let[a,l]=i,c=this.m(n,a);return r.forEach(p=>{if((0,E.isRemoteDiagnosticError)(p))c+=`
${p.errorMessage}`,l+=`
${p.errorMessage}`;else if(c+=`

Remote: ${p.hostName}`,p.processes&&(c+=`
${this.m(n,p.processes)}`),p.workspaceMetadata){l+=`
|  Remote: ${p.hostName}`;for(const P of Object.keys(p.workspaceMetadata)){const T=p.workspaceMetadata[P];let I=`${T.fileCount} files`;T.maxFilesReached&&(I=`more than ${I}`),l+=`|    Folder (${P}): ${I}`,l+=this.h(T)}}}),{processInfo:c,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:i,vmHint:a,os:l,cpus:c}=f(),p={os:l,memory:i,cpus:c,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return A.isWindows||(p.load=`${w.loadavg().map(P=>Math.round(P)).join(", ")}`),A.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(n,r){const i=[];return(0,y.listProcesses)(n.mainPID).then(async a=>(i.push(""),i.push(this.g(n)),i.push(""),i.push(this.m(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(n))),r.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(n,l.processes)),l.workspaceMetadata)for(const c of Object.keys(l.workspaceMetadata)){const p=l.workspaceMetadata[c];let P=`${p.fileCount} files`;p.maxFilesReached&&(P=`more than ${P}`),i.push(`Folder (${c}): ${P}`),i.push(this.h(p))}}),i.push(""),i.push(""),i.join(`
`)))}h(n){const r=[];let a=0;const l=(T,I)=>{const F=` ${T}(${I})`;a+F.length>60?(r.push(c),c="|                 ",a=c.length):a+=F.length,c+=F};let c="|      File types:";const p=10,P=n.fileTypes.length>p?p:n.fileTypes.length;for(let T=0;T<P;T++){const I=n.fileTypes[T];l(I.name,I.count)}if(r.push(c),n.configFiles.length>=0&&(c="|      Conf files:",a=0,n.configFiles.forEach(T=>{l(T.name,T.count)}),r.push(c)),n.launchConfigFiles.length>0){let T="|      Launch Configs:";n.launchConfigFiles.forEach(I=>{const F=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;T+=F}),r.push(T)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(i=>i.length));return Object.keys(n).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${n[i]}`).join(`
                  `)}k(n){const r=[],i=[];return n.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const c=v.URI.revive(l);if(c.scheme===C.Schemas.file){const p=c.fsPath;i.push(h(p,["node_modules",".git"]).then(P=>{let T=`${P.fileCount} files`;P.maxFilesReached&&(T=`more than ${T}`),r.push(`|    Folder (${(0,D.basename)(p)}): ${T}`),r.push(this.h(P))}).catch(P=>{r.push(`|      Error: Unable to collect workspace stats for folder ${p} (${P.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(n,r){const i=new Map;n.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),n.pidToNames.forEach(({pid:l,name:c})=>i.set(l,c));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,i,a,r,0),a.join(`
`)}n(n,r,i,a,l){const c=l===0;let p;c?p=a.pid===n?`${this.d.applicationName} main`:"remote agent":r.has(a.pid)?p=r.get(a.pid):p=`${"  ".repeat(l)} ${a.name}`;const P=process.platform==="win32"?a.mem:w.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(P/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(a.children)&&a.children.forEach(T=>this.n(n,r,i,T,l+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:i}of n.folders){const a=v.URI.revive(i);if(a.scheme!==C.Schemas.file)continue;const l=a.fsPath;try{(await h(l,["node_modules",".git"])).fileTypes.forEach(p=>r.add(p.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const i=v.URI.revive(r);if(i.scheme!==C.Schemas.file)continue;const a=i.fsPath;try{const l=await h(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(c=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:c.name,count:c.count})}),l.launchConfigFiles.forEach(c=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:c.name,count:c.count})}),l.configFiles.forEach(c=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.DiagnosticsService=O=Le([Ae(0,b.ITelemetryService),Ae(1,g.IProductService)],O)}),define(pe[37],ve([1,0,22,8,6,24,55,117,31]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class d{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=d;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class y{async publicLog(a,l,c){}async publicLogError(a,l,c){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(i,a){return o.Event.debounce(a.onDidChangeConfiguration,(c,p)=>{const P=c?new Set([...c.affectedKeys,...p.affectedKeys]):p.affectedKeys;return{...p,affectedKeys:P}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=E;function m(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=m;function g(i,a){return!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=g;function b(i){const a=i.getValue(v.TELEMETRY_SETTING_ID),l=i.getValue(v.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function s(i){const a={},l={},c={};f(i,c);for(let p in c){p=p.length>150?p.substr(p.length-149):p;const P=c[p];typeof P=="number"?l[p]=P:typeof P=="boolean"?l[p]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${P.length}`),a[p]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(a[p]=P)}return{properties:a,measurements:l}}e.validateTelemetryData=s;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const a=(0,D.getRemoteName)(i);return h.has(a)?a:"other"}e.cleanRemoteAuthority=u;function f(i,a,l=0,c){if(i)for(const p of Object.getOwnPropertyNames(i)){const P=i[p],T=c?c+p:p;Array.isArray(P)?a[T]=(0,w.safeStringify)(P):P instanceof Date?a[T]=P.toISOString():(0,L.isObject)(P)?l<2?f(P,a,l+1,T+"."):a[T]=(0,w.safeStringify)(P):a[T]=P}}function S(i,a){const l=i.msftInternalDomains||[],c=a.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(l)||c}e.isInternalTelemetry=S;function O(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=O;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const c=[];for(const I of a)for(;;){const F=I.exec(i);if(!F)break;c.push([F.index,I.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let T=0;for(l="";;){const I=P.exec(i);if(!I)break;const F=c.some(([H,ee])=>I.index<ee&&H<P.lastIndex);!p.test(I[0])&&!F&&(l+=i.substring(T,I.index)+"<REDACTED: user-file-path>",T=P.lastIndex)}return T<i.length&&(l+=i.substr(T)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function r(i,a){return(0,w.cloneAndChange)(i,l=>{if(l instanceof d||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let c=l.replaceAll("%20"," ");c=t(c,a);for(const p of a)c=c.replace(p,"");return c=n(c),c}})}e.cleanData=r}),define(pe[34],ve([1,0,17,30,36,3,4,9,29,37]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,w.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=R;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,a,l)}static parse(i){const a=y.exec(i);return a&&a[1]&&a[2]?new E({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(r){const i=m.exec(r);return i&&i[1]?[s(i[1]),i[2]]:[s(r),void 0]}e.getIdAndVersion=g;function b(r,i){return`${r}.${i}`}e.getExtensionId=b;function s(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=s;function h(r,i){return s(b(r??o.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=h;function u(r,i){const a=[],l=c=>{for(const p of a)if(p.some(P=>R(i(P),i(c))))return p;return null};for(const c of r){const p=l(c);p?p.push(c):a.push([c])}return a}e.groupByExtension=u;function f(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function S(r){return{id:new d.TelemetryTrustedValue(r.identifier.id),name:new d.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new o.ExtensionIdentifier("pprice.better-merge");function O(r,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const c=l.shift();if(c&&a.every(p=>!R(p.identifier,{id:c}))){const p=r.filter(P=>R(P.identifier,{id:c}));p.length===1&&(a.push(p[0]),l.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=O;async function t(r,i){if(!C.isLinux)return!1;let a;try{a=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const a=await t(r,i),l=(0,L.getTargetPlatform)(a?"alpine":C.platform,v.arch);return i.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=n}),define(pe[118],ve([1,0,20,9,13,19,52,4,175,30,34,36]),function(oe,e,w,L,o,C,D,A,v,d,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const E=s=>(0,v.localize)(0,null,s),m=(0,v.localize)(1,null,"ms-dotnettools.csharp");function g(s,h){return h?`${s.publisher}.${s.name}@${s.version}`:`${s.publisher}.${s.name}`}let b=e.ExtensionManagementCLI=class{constructor(h,u,f){this.a=h,this.b=u,this.d=f}get f(){}async listExtensions(h,u,f){let S=await this.b.getInstalled(1,f);const O=y.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(u&&u!==""){if(O.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}S=S.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),O.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),S=S.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let t;for(const n of S)t!==n.identifier.id&&(t=n.identifier.id,this.a.info(g(n.manifest,h)))}async installExtensions(h,u,f,S){const O=[];try{const t=[];h.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const n=[];let r=[];const i=(l,c,p)=>{r.push({id:l,version:c!=="prerelease"?c:void 0,installOptions:{...f,isBuiltin:p,installPreReleaseVersion:c==="prerelease"||f.installPreReleaseVersion}})};for(const l of h)if(l instanceof A.URI)n.push({vsix:l,installOptions:f});else{const[c,p]=(0,R.getIdAndVersion)(l);i(c,p,!1)}for(const l of u)if(l instanceof A.URI)n.push({vsix:l,installOptions:{...f,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,p]=(0,R.getIdAndVersion)(l);i(c,p,!0)}const a=await this.b.getInstalled(1,f.profileLocation);if(n.length&&await Promise.all(n.map(async({vsix:l,installOptions:c})=>{try{const p=await this.g(l,c,S,a);p&&t.push(p)}catch(p){this.a.error(p),O.push(l.toString())}})),r.length&&(r=r.filter(({id:l,version:c})=>{const p=a.find(P=>(0,R.areSameExtensions)(P.identifier,{id:l}));if(p){if(!S&&(!c||c==="prerelease"&&p.preRelease))return this.a.info((0,v.localize)(5,null,l,p.manifest.version,l)),!1;if(c&&p.manifest.version===c)return this.a.info((0,v.localize)(6,null,`${l}@${c}`)),!1}return!0}),r.length)){const l=await this.h(r);await Promise.all(r.map(async c=>{const p=l.get(c.id.toLowerCase());if(p)try{const P=await this.j(c,p,a);P&&t.push(P)}catch(P){this.a.error(P.message||P.stack||P),O.push(c.id)}else this.a.error(`${E(c.version?`${c.id}@${c.version}`:c.id)}
${m}`),O.push(c.id)}))}}catch(t){throw this.a.error((0,v.localize)(7,null,(0,L.getErrorMessage)(t))),t}if(O.length)throw new Error((0,v.localize)(8,null,O.join(", ")))}async g(h,u,f,S){const O=await this.b.getManifest(h);if(!O)throw new Error("Invalid vsix");if(await this.l(O,f,u.profileLocation,S))try{return await this.b.install(h,u),this.a.info((0,v.localize)(9,null,(0,C.basename)(h))),O}catch(n){if((0,L.isCancellationError)(n))return this.a.info((0,v.localize)(10,null,(0,C.basename)(h))),null;throw n}return null}async h(h){const u=new Map,f=h.some(t=>t.installOptions.installPreReleaseVersion),S=await this.b.getTargetPlatform(),O=[];for(const t of h)d.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&O.push({...t,preRelease:f});if(O.length){const t=await this.d.getExtensions(O,{targetPlatform:S},w.CancellationToken.None);for(const n of t)u.set(n.identifier.id.toLowerCase(),n)}return u}async j({id:h,version:u,installOptions:f},S,O){const t=await this.d.getManifest(S,w.CancellationToken.None);if(t&&!this.k(t))return null;const n=O.find(r=>(0,R.areSameExtensions)(r.identifier,S.identifier));if(n){if(S.version===n.manifest.version)return this.a.info((0,v.localize)(11,null,u?`${h}@${u}`:h)),null;this.a.info((0,v.localize)(12,null,h,S.version))}try{f.isBuiltin?this.a.info(u?(0,v.localize)(13,null,h,u):(0,v.localize)(14,null,h)):this.a.info(u?(0,v.localize)(15,null,h,u):(0,v.localize)(16,null,h));const r=await this.b.installFromGallery(S,{...f,installGivenVersion:!!u});return this.a.info((0,v.localize)(17,null,h,r.manifest.version)),t}catch(r){if((0,L.isCancellationError)(r))return this.a.info((0,v.localize)(18,null,h)),null;throw r}}k(h){return!0}async l(h,u,f,S){if(!u){const O={id:(0,R.getGalleryExtensionId)(h.publisher,h.name)},t=S.find(n=>(0,R.areSameExtensions)(O,n.identifier)&&(0,D.gt)(n.manifest.version,h.version));if(t)return this.a.info((0,v.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,u,f){const S=async t=>{if(t instanceof A.URI){const n=await this.b.getManifest(t);return g(n)}return t},O=[];for(const t of h){const n=await S(t),i=(await this.b.getInstalled(void 0,f)).filter(a=>(0,R.areSameExtensions)(a.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${m}`);if(i.some(a=>a.type===0)){this.a.info((0,v.localize)(20,null,n));return}if(!u&&i.some(a=>a.isBuiltin)){this.a.info((0,v.localize)(21,null,n));return}this.a.info((0,v.localize)(22,null,n));for(const a of i)await this.b.uninstall(a,{profileLocation:f}),O.push(a);this.f?this.a.info((0,v.localize)(23,null,n,this.f)):this.a.info((0,v.localize)(24,null,n))}}async locateExtension(h){const u=await this.b.getInstalled();h.forEach(f=>{u.forEach(S=>{if(S.identifier.id===f&&S.location.scheme===o.Schemas.file){this.a.info(S.location.fsPath);return}})})}m(h){return this.f?(0,v.localize)(25,null,h,this.f):(0,v.localize)(26,null,h)}};e.ExtensionManagementCLI=b=Le([Ae(1,d.IExtensionManagementService),Ae(2,d.IExtensionGalleryService)],b)}),define(pe[239],ve([1,0,6,2,28,34,36]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class A extends L.Disposable{constructor(d,R,y,E,m,g,b){super(),this.f=d,this.g=R,this.h=y,this.i=E,this.j=m,this.k=g,this.l=b,this.a=this.B(new w.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,s=>b.error(s))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(d=>this.p(d.added,d.removed))),this.B(this.i.onAddExtensions(d=>this.r(d))),this.B(this.i.onDidAddExtensions(d=>this.s(d))),this.B(this.i.onRemoveExtensions(d=>this.t(d))),this.B(this.i.onDidRemoveExtensions(d=>this.u(d))),this.B(this.k.onDidFilesChange(d=>this.v(d)))}async p(d,R){try{await Promise.all(R.map(y=>(this.c.deleteAndDispose(y.id),this.z(y.extensionsResource)))),d.length&&await Promise.all(d.map(y=>(this.c.set(y.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(y.extensionsResource)),this.k.watch(y.extensionsResource))),this.y(y.extensionsResource))))}catch(y){throw this.l.error(y),y}}async r(d){for(const R of d.extensions)this.D(this.G(R.identifier,R.version),d.profileLocation)}async s(d){for(const R of d.extensions){const y=this.G(R.identifier,R.version);d.error?this.F(y,d.profileLocation):this.D(y,d.profileLocation)}}async t(d){for(const R of d.extensions)this.F(this.G(R.identifier,R.version),d.profileLocation)}async u(d){const R=[],y=[];for(const E of d.extensions){const m=this.G(E.identifier,E.version);d.error?this.D(m,d.profileLocation):(this.F(m,d.profileLocation),this.b.has(m)||(this.l.debug("Extension is removed from all profiles",E.identifier.id,E.version),y.push(this.f.scanInstalledExtensionAtLocation(E.location).then(g=>{g?R.push(g):this.l.info("Extension not found at the location",E.location.toString())},g=>this.l.error(g)))))}try{await Promise.all(y),R.length&&await this.C(R)}catch(E){this.l.error(E)}}v(d){for(const R of this.h.profiles)d.contains(R.extensionsResource,0,1)&&this.w(R.extensionsResource)}async w(d){const R=[],y=[],E=await this.i.scanProfileExtensions(d),m=new Set,g=new Set;for(const[b,s]of this.b)s.has(d)&&g.add(b);for(const b of E){const s=this.G(b.identifier,b.version);m.add(s),g.has(s)||(R.push(b.identifier),this.D(s,d))}for(const b of g)if(!m.has(b)){const s=this.H(b);s&&(y.push(s.identifier),this.F(b,d))}(R.length||y.length)&&this.a.fire({added:R.length?{extensions:R,profileLocation:d}:void 0,removed:y.length?{extensions:y,profileLocation:d}:void 0})}async y(d){const R=await this.i.scanProfileExtensions(d);for(const y of R)this.D(this.G(y.identifier,y.version),d)}async z(d){for(const R of[...this.b.keys()])this.F(R,d);await this.C()}async C(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.G(y.identifier,y.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}D(d,R){let y=this.b.get(d);y||this.b.set(d,y=new o.ResourceSet(E=>this.j.extUri.getComparisonKey(E))),y.add(R)}F(d,R){const y=this.b.get(d);y&&y.delete(R),y?.size||this.b.delete(d)}G(d,R){return`${D.ExtensionIdentifier.toKey(d.id)}@${R}`}H(d){const[R,y]=(0,C.getIdAndVersion)(d);return y?{identifier:{id:R},version:y}:void 0}}e.ExtensionsWatcher=A}),define(pe[240],ve([1,0,208,37]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function o(C,D,A,v,d,R,y){const E={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${D.nameShort})`};if((0,L.supportsTelemetry)(D,A)&&(0,L.getTelemetryLevel)(v)===3){const m=await(0,w.getServiceMachineId)(A,d,R);E["X-Market-User-Id"]=m,E["VSCode-SessionId"]=y.machineId||m}return E}e.resolveMarketplaceHeaders=o}),define(pe[119],ve([1,0,85,18,14,2,13,7,23,25,30,34,12,82,4]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let b=e.NativeLanguagePackService=class extends m.LanguagePackBaseService{constructor(f,S,O,t){super(O),this.h=f,this.i=t,this.g=this.B(new s(S,t)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(f,S){const t=(await this.g.getLanguagePacks())[S];if(!t){this.i.warn(`No language pack found for ${S}`);return}const n=t.translations[f];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),S=Object.keys(f).map(O=>{const t=f[O];return{...this.f(O,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return S.push(this.f("en","English")),S.sort((O,t)=>O.label.localeCompare(t.label)),S}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const S=await this.g.getLanguagePacks();Object.keys(S).some(O=>S[O]&&S[O].extensions.some(t=>(0,y.areSameExtensions)(t.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,S]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),O=await this.g.update(S);return!(0,L.equals)(Object.keys(f),Object.keys(O))}};e.NativeLanguagePackService=b=Le([Ae(0,R.IExtensionManagementService),Ae(1,d.INativeEnvironmentService),Ae(2,R.IExtensionGalleryService),Ae(3,E.ILogService)],b);let s=class extends C.Disposable{constructor(f,S){super(),this.i=S,this.c={},this.f=(0,A.join)(f.userDataPath,"languagepacks.json"),this.g=new o.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(S=>{Object.keys(S).forEach(O=>delete S[O]),this.j(S,...f)}).then(()=>this.c)}j(f,...S){for(const O of S)O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&this.k(f,O);Object.keys(f).forEach(O=>this.l(f[O]))}k(f,S){const O=S.identifier,t=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const n of t)if(S.location.scheme===D.Schemas.file&&h(n)){let r=f[n.languageId];r||(r={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},f[n.languageId]=r);const i=r.extensions.filter(a=>(0,y.areSameExtensions)(a.extensionIdentifier,O))[0];i?i.version=S.manifest.version:r.extensions.push({extensionIdentifier:O,version:S.manifest.version});for(const a of n.translations)r.translations[a.id]=(0,A.join)(S.location.fsPath,a.path)}}l(f){if(f){const S=(0,w.createHash)("md5");for(const O of f.extensions)S.update(O.extensionIdentifier.uuid||O.extensionIdentifier.id).update(O.version);f.hash=S.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let S=null;return v.Promises.readFile(this.f,"utf8").then(void 0,O=>O.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(O)).then(O=>{try{return JSON.parse(O)}catch{return{}}}).then(O=>(S=f(O),O)).then(O=>{for(const n of Object.keys(O))O[n]||delete O[n];this.c=O,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>S,O=>this.i.error(O))})}};s=Le([Ae(0,d.INativeEnvironmentService),Ae(1,E.ILogService)],s);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const f of u.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(pe[241],ve([1,0,9,22,37]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function A(d,R,y){const E=await new Promise((h,u)=>{oe(["@microsoft/1ds-core-js"],h,u)}),m=await new Promise((h,u)=>{oe(["@microsoft/1ds-post-js"],h,u)}),g=new E.AppInsightsCore,b=new m.PostChannel,s={instrumentationKey:d,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(y){s.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:y};s.extensionConfig[b.identifier]=h}return g.initialize(s,[]),g.addTelemetryInitializer(h=>{R&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),g}class v{constructor(R,y,E,m,g){this.e=R,this.f=y,this.g=E,this.h=g,this.c=C,this.d=D,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(y=>{R(y)},y=>{(0,w.onUnexpectedError)(y),console.error(y)})}}log(R,y){if(!this.a)return;y=(0,L.mixin)(y,this.g),y=(0,o.validateTelemetryData)(y);const E=this.f+"/"+R;try{this.i(m=>{m.pluginVersionString=y?.properties.version??"Unknown",m.track({name:E,baseData:{name:E,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(pe[242],ve([1,0,2,22,3,17,189,24,54,53,27,40,31,37]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=e.TelemetryService=class{constructor(h,u,f){this.k=u,this.l=f,this.d={},this.i=new w.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,C.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(E.TELEMETRY_SETTING_ID)||S.affectsConfiguration(E.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(E.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,u){this.d[h]=u}m(){let h=(0,m.getTelemetryLevel)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const f=u.usage?3:u.error?2:0;h=Math.min(h,f)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,u,f){this.g<u||(f=(0,L.mixin)(f,this.d),f=(0,m.cleanData)(f,this.j),f=(0,L.mixin)(f,this.c),this.b.forEach(S=>S.log(h,f)))}publicLog(h,u){this.n(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this.h&&this.n(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=g=Le([Ae(1,A.IConfigurationService),Ae(2,R.IProductService)],g);function b(){const s=(0,D.localize)(0,null,d.default.nameLong),h=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=o.isWeb?"":(0,D.localize)(3,null),f=(0,D.localize)(4,null),S=(0,D.localize)(5,null),O=(0,D.localize)(6,null),t=(0,D.localize)(7,null),n=`
|       | ${f} | ${S} | ${O} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${s} ${h} ${u}

&nbsp;

${t}
${n}

&nbsp;

${r}
`}y.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[243],ve([1,0,24,5,27,31,242,37]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=e.ServerTelemetryService=class extends D.TelemetryService{constructor(R,y,E,m){super(R,E,m),this.o=y}publicLog(R,y){if(!(this.o<3))return super.publicLog(R,y)}publicLog2(R,y){return this.publicLog(R,y)}publicLogError(R,y){return this.o<2?Promise.resolve(void 0):super.publicLogError(R,y)}publicLogError2(R,y){return this.publicLogError(R,y)}async updateInjectedTelemetryLevel(R){if(R===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,R):R,this.o===0&&this.dispose()}};e.ServerTelemetryService=v=Le([Ae(2,w.IConfigurationService),Ae(3,o.IProductService)],v),e.ServerNullTelemetryService=new class extends A.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,L.refineServiceDecorator)(C.ITelemetryService)}),define(pe[244],ve([1,0,245,241]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class o extends L.AbstractOneDataSystemAppender{constructor(D,A,v,d){const R={sendPOST:(y,E)=>{const m={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const g=w.request(y.urlString,m,b=>{b.on("data",function(s){E(b.statusCode??200,b.headers,s.toString())}),b.on("error",function(s){E(0,{})})});g.write(y.data),g.end()}catch{E(0,{})}}};super(D,A,v,d,R)}}e.OneDataSystemAppender=o}),define(pe[246],ve([1,0,9,236]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class o extends L.default{i(){(0,w.setUnexpectedErrorHandler)(A=>console.error(A));const D=[];process.on("unhandledRejection",(A,v)=>{D.push(v),setTimeout(()=>{const d=D.indexOf(v);d>=0&&v.catch(R=>{D.splice(d,1),(0,w.isCancellationError)(R)||(console.warn(`rejected promise not handled within 1 second: ${R}`),R.stack&&console.warn(`stack trace: ${R.stack}`),A&&(0,w.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const v=D.indexOf(A);v>=0&&D.splice(v,1)}),process.on("uncaughtException",A=>{(0,w.isSigPipeError)(A)||(0,w.onUnexpectedError)(A)})}}e.default=o}),define(pe[120],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(w||(e.EnvironmentVariableMutatorType=w={}))}),define(pe[121],ve([1,0,3,120]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class o{constructor(d){this.collections=d,this.a=new Map,this.b=new Map,d.forEach((R,y)=>{this.c(R,y);const E=R.map.entries();let m=E.next();for(;!m.done;){const g=m.value[1],b=m.value[0];let s=this.a.get(b);if(s||(s=[],this.a.set(b,s)),s.length>0&&s[0].type===L.EnvironmentVariableMutatorType.Replace){m=E.next();continue}const h={extensionIdentifier:y,value:g.value,type:g.type,scope:g.scope,variable:g.variable};h.scope||delete h.scope,s.unshift(h),m=E.next()}})}async applyToProcessEnvironment(d,R,y){let E;w.isWindows&&(E={},Object.keys(d).forEach(m=>E[m.toLowerCase()]=m));for(const[m,g]of this.getVariableMap(R)){const b=w.isWindows&&E[m.toLowerCase()]||m;for(const s of g){const h=y?await y(s.value):s.value;switch(s.type){case L.EnvironmentVariableMutatorType.Append:d[b]=(d[b]||"")+h;break;case L.EnvironmentVariableMutatorType.Prepend:d[b]=h+(d[b]||"");break;case L.EnvironmentVariableMutatorType.Replace:d[b]=h;break}}}}diff(d,R){const y=new Map,E=new Map,m=new Map;if(d.getVariableMap(R).forEach((g,b)=>{const s=this.getVariableMap(R).get(b),h=D(g,s);h&&y.set(b,h)}),this.getVariableMap(R).forEach((g,b)=>{const s=d.getVariableMap(R).get(b),h=D(g,s);h&&m.set(b,h)}),this.getVariableMap(R).forEach((g,b)=>{const s=d.getVariableMap(R).get(b),h=A(g,s);h&&E.set(b,h)}),!(y.size===0&&E.size===0&&m.size===0))return{added:y,changed:E,removed:m}}getVariableMap(d){const R=new Map;return this.a.forEach((y,E)=>{const m=y.filter(g=>C(g,d));m.length>0&&R.set(m[0].variable,m)}),R}getDescriptionMap(d){const R=new Map;return this.b.forEach((y,E)=>{const m=y.filter(g=>C(g,d));m.length>0&&R.set(m[0].extensionIdentifier,m[0].description)}),R}c(d,R){if(!d.descriptionMap)return;const y=d.descriptionMap.entries();let E=y.next();for(;!E.done;){const m=E.value[1],g=E.value[0];let b=this.b.get(g);b||(b=[],this.b.set(g,b));const s={extensionIdentifier:R,scope:m.scope,description:m.description};s.scope||delete s.scope,b.push(s),E=y.next()}}}e.MergedEnvironmentVariableCollection=o;function C(v,d){return!!(!v.scope||v.scope.workspaceFolder&&d?.workspaceFolder&&v.scope.workspaceFolder.index===d.workspaceFolder.index)}function D(v,d){if(!d)return v;const R=new Set;d.forEach(E=>R.add(E.extensionIdentifier));const y=[];return v.forEach(E=>{R.has(E.extensionIdentifier)||y.push(E)}),y.length===0?void 0:y}function A(v,d){if(!d)return;const R=new Map;d.forEach(E=>R.set(E.extensionIdentifier,E));const y=[];return v.forEach(E=>{const m=R.get(E.extensionIdentifier);m&&(E.type!==m.type||E.value!==m.value||E.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&y.push(m)}),y.length===0?void 0:y}}),define(pe[86],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function w(v){return[...v.entries()]}e.serializeEnvironmentVariableCollection=w;function L(v){return v?[...v.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function o(v){return new Map(v)}e.deserializeEnvironmentVariableCollection=o;function C(v){return new Map(v??[])}e.deserializeEnvironmentDescriptionMap=C;function D(v){return Array.from(v.entries()).map(d=>[d[0],w(d[1].map),L(d[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=D;function A(v){return new Map(v.map(d=>[d[0],{map:o(d[1]),descriptionMap:C(d[2])}]))}e.deserializeEnvironmentVariableCollections=A}),define(pe[247],ve([1,0,14,20,6,2,12]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let A=e.RequestStore=class extends C.Disposable{constructor(d,R){super(),this.h=R,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new o.Emitter),this.onCreateRequest=this.g.event,this.b=d===void 0?15e3:d}createRequest(d){return new Promise((R,y)=>{const E=++this.a;this.c.set(E,R),this.g.fire({requestId:E,...d});const m=new L.CancellationTokenSource;(0,w.timeout)(this.b,m.token).then(()=>y(`Request ${E} timed out (${this.b}ms)`)),this.f.set(E,[(0,C.toDisposable)(()=>m.cancel())])})}acceptReply(d,R){const y=this.c.get(d);y?(this.c.delete(d),(0,C.dispose)(this.f.get(d)||[]),this.f.delete(d),y(R)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${d}`)}};e.RequestStore=A=Le([Ae(1,D.ILogService)],A)}),define(pe[122],ve([1,0,5,64]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var o;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(o||(e.TerminalSettingPrefix=o={}));var C;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(C||(e.TerminalSettingId=C={}));var D;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(D||(e.PosixShellType=D={}));var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A||(e.WindowsShellType=A={}));var v;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var d;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Logger="logger",f.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={})),e.IPtyService=(0,w.createDecorator)("ptyService");var R;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(R||(e.ProcessPropertyType=R={}));var y;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var E;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var m;(function(f){f.TerminalView="view",f.Editor="editor"})(m||(e.TerminalLocationString=m={}));var g;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var b;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var s;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var h;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var u;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(u||(e.TerminalExitReason=u={}))}),define(pe[248],ve([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function L(D){let A=D;A.includes("\\")&&(A=A.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return A=A.replace(v,""),`'${A}'`}e.escapeNonWindowsPath=L;function o(D,A,v){if(!D)return"";if(!A)return D;A.match(/[\/\\]$/)&&(A=A.slice(0,A.length-1));const d=D.replace(/\\/g,"/").toLowerCase(),R=A.replace(/\\/g,"/").toLowerCase();return d.includes(R)?`~${v}${D.slice(A.length+1)}`:D}e.collapseTildePath=o;function C(D){return D.match(/^['"].*['"]$/)&&(D=D.substring(1,D.length-1)),w.OS===1&&D&&D[1]===":"?D[0].toUpperCase()+D.substring(1):D}e.sanitizeCwd=C}),define(pe[249],ve([1,0,48,4,191,97]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function D(E,m){const g=[{name:null,description:(0,o.localize)(0,null)}];return g.push(...E.map(b=>({name:b.profileName,description:A(b)}))),m&&g.push(...m.map(b=>({name:b.title,description:v(b)}))),{values:g.map(b=>b.name),markdownDescriptions:g.map(b=>b.description)}}e.createProfileSchemaEnums=D;function A(E){let m=`$(${C.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:w.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?m+=`
- args: "${E.args}"`:m+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(m+=`
- overrideName: ${E.overrideName}`),E.color&&(m+=`
- color: ${E.color}`),E.env&&(m+=`
- env: ${JSON.stringify(E.env)}`),m}function v(E){return`$(${C.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:w.Codicon.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function d(E,m){if(!E&&!m)return!0;if(typeof E=="string"&&typeof m=="string")return E===m;if(Array.isArray(E)&&Array.isArray(m)){if(E.length!==m.length)return!1;for(let g=0;g<E.length;g++)if(E[g]!==m[g])return!1;return!0}return!1}e.terminalProfileArgsMatch=d;function R(E,m){if(!E&&!m)return!0;if(!E||!m)return!1;if(C.ThemeIcon.isThemeIcon(E)&&C.ThemeIcon.isThemeIcon(m))return E.id===m.id&&E.color===m.color;if(typeof E=="object"&&"light"in E&&"dark"in E&&typeof m=="object"&&"light"in m&&"dark"in m){const g=E,b=m;if((L.URI.isUri(g.light)||y(g.light))&&(L.URI.isUri(g.dark)||y(g.dark))&&(L.URI.isUri(b.light)||y(b.light))&&(L.URI.isUri(b.dark)||y(b.dark)))return g.light.path===b.light.path&&g.dark.path===b.dark.path}if(L.URI.isUri(E)&&L.URI.isUri(m)||y(E)||y(m)){const g=E,b=m;return g.path===b.path&&g.scheme===b.scheme}return!1}e.terminalIconsEqual=R;function y(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=y}),define(pe[250],ve([1,0,48,190,54,40,249]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,w.getAllCodicons)(),S=>S.id),markdownEnumDescriptions:Array.from((0,w.getAllCodicons)(),S=>`$(${S.id})`)};const A={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),...e.terminalIconSchema},color:{description:(0,L.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...A}},d={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(6,null),type:["string"],items:{type:"string"}},...A}},R=(0,L.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),y=(0,L.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,L.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,L.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),g=(0,L.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,L.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),s={id:"terminal",order:100,title:(0,L.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(26,null)}},{type:"string",markdownDescription:(0,L.localize)(27,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(29,null),enum:["PowerShell","Git Bash"]},...A}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(30,null),type:"string"},id:{description:(0,L.localize)(31,null),type:"string"},title:{description:(0,L.localize)(32,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(34,null),type:"string"},id:{description:(0,L.localize)(35,null),type:"string"},title:{description:(0,L.localize)(36,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(38,null),type:"string"},id:{description:(0,L.localize)(39,null),type:"string"},title:{description:(0,L.localize)(40,null),type:"string"},...A}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){C.Registry.as(o.Extensions.Configuration).registerConfiguration(s),f()}e.registerTerminalPlatformConfiguration=h;let u;function f(S,O){const t=C.Registry.as(o.Extensions.Configuration);let n;S&&(n=(0,D.createProfileSchemaEnums)(S?.profiles,O));const r=u;u={id:"terminal",order:100,title:(0,L.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?n?.values:void 0,markdownEnumDescriptions:S?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?n?.values:void 0,markdownEnumDescriptions:S?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?n?.values:void 0,markdownEnumDescriptions:S?.os===1?n?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[u],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(pe[251],ve([1,0,26,13,22,7,3,29,17,8,23,120,86,121]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function g(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let a=0;return i&&i.length===4&&(a=parseInt(i[3])),a}e.getWindowsBuildNumber=g;async function b(i,a,l,c=A.env,p=R.Promises.exists){if(C.isAbsolute(i))return await p(i)?i:void 0;if(a===void 0&&(a=A.cwd()),C.dirname(i)!=="."){const F=C.join(a,i);return await p(F)?F:void 0}const T=(0,o.getCaseInsensitive)(c,"PATH");if(l===void 0&&(0,d.isString)(T)&&(l=T.split(C.delimiter)),l===void 0||l.length===0){const F=C.join(a,i);return await p(F)?F:void 0}for(const F of l){let H;if(C.isAbsolute(F)?H=C.join(F,i):H=C.join(a,F,i),await p(H))return H;if(D.isWindows){let ee=H+".com";if(await p(ee)||(ee=H+".exe",await p(ee)))return ee}}const I=C.join(a,i);return await p(I)?I:void 0}e.findExecutable=b;function s(i,a,l,c,p){const P=D.isWindows&&(!a.windowsEnableConpty||g()<18309);if(!a.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||P)return;const T=i.args,I=A.platform==="win32"?C.basename(i.executable).toLowerCase():C.basename(i.executable),F=C.dirname(L.FileAccess.asFileUri("").fsPath);let H;const ee={VSCODE_INJECTION:"1"};if(D.isWindows){if(I==="pwsh.exe"||I==="powershell.exe")return!T||n(T)?H=f.get(u.WindowsPwsh):t(T)&&(H=f.get(u.WindowsPwshLogin)),H?(H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F,""),a.shellIntegration.suggestEnabled&&(ee.VSCODE_SUGGEST="1"),{newArgs:H,envMixin:ee}):void 0;c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(I){case"bash":return!T||T.length===0?H=f.get(u.Bash):r(T)&&(ee.VSCODE_SHELL_LOGIN="1",h(a,ee),H=f.get(u.Bash)),H?(H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F),{newArgs:H,envMixin:ee}):void 0;case"fish":{const ce=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ae=C.join(F,"out/vs/workbench/contrib/xdg_data");return ee.XDG_DATA_DIRS=`${ce}:${ae}`,h(a,ee),{newArgs:void 0,envMixin:ee}}case"pwsh":return!T||n(T)?H=f.get(u.Pwsh):t(T)&&(H=f.get(u.PwshLogin)),H?(a.shellIntegration.suggestEnabled&&(ee.VSCODE_SUGGEST="1"),H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F,""),{newArgs:H,envMixin:ee}):void 0;case"zsh":{if(!T||T.length===0?H=f.get(u.Zsh):r(T)?(H=f.get(u.ZshLogin),h(a,ee)):(T===f.get(u.Zsh)||T===f.get(u.ZshLogin))&&(H=T),!H)return;H=[...H],H[H.length-1]=(0,v.format)(H[H.length-1],F);let ce;try{ce=w.userInfo().username}catch{ce="unknown"}const ae=C.join(w.tmpdir(),`${ce}-${p.applicationName}-zsh`);ee.ZDOTDIR=ae;const ue=l?.ZDOTDIR??w.homedir()??"~";ee.USER_ZDOTDIR=ue;const ge=[];return ge.push({source:C.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.join(ae,".zshrc")}),ge.push({source:C.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.join(ae,".zprofile")}),ge.push({source:C.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.join(ae,".zshenv")}),ge.push({source:C.join(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.join(ae,".zlogin")}),{newArgs:H,envMixin:ee,filesToCopy:ge}}}c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=s;function h(i,a){if(D.isMacintosh&&i.environmentVariableCollections){const l=(0,E.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),p=new m.MergedEnvironmentVariableCollection(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),P=[];if(p)for(const T of p)T.type===y.EnvironmentVariableMutatorType.Prepend&&P.push(T.value);P.length>0&&(a.VSCODE_PATH_PREFIX=P.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const f=new Map;f.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(u.Zsh,["-i"]),f.set(u.ZshLogin,["-il"]),f.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],O=["-nol","-nologo"];function t(i){return typeof i=="string"?S.includes(i.toLowerCase()):i.length===1&&S.includes(i[0].toLowerCase())||i.length===2&&(S.includes(i[0].toLowerCase())||S.includes(i[1].toLowerCase()))&&(O.includes(i[0].toLowerCase())||O.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?O.includes(i.toLowerCase()):i.length===0||i?.length===1&&O.includes(i[0].toLowerCase())}function r(i){return i==="string"&&S.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&S.includes(i[0].toLowerCase())}}),define(pe[252],ve([1,0,50,48,7,3,8,23,100,251,75]),function(oe,e,w,L,o,C,D,A,v,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let y,E=!0;function m(i,a,l,c,p=process.env,P,T,I,F){return P=P||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},C.isWindows?g(l,P,p,T,c.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:c.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:c.getValue("terminal.integrated.defaultProfile.windows"),F,I):t(P,T,l,i&&typeof i=="object"?{...i}:c.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:c.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,I,p)}e.detectAvailableProfiles=m;async function g(i,a,l,c,p,P,T,I,F){const H=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ee=`${process.env.windir}\\${H?"Sysnative":"System32"}`;let ce=!1;(0,d.getWindowsBuildNumber)()>=16299&&(ce=!0),await h(I);const ae=new Map;if(i){ae.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${ee}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${ee}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const ge=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${ee}\\cmd.exe`,args:["/K",ge],requiresPath:process.env.CMDER_ROOT?ge:{path:ge,isUnsafe:!0},isAutoDetected:!0})}n(P,ae);const ue=await b(ae.entries(),T,a,l,c,F);if(i||p)try{const ge=await S(`${ee}\\${ce?"wsl":"bash"}.exe`,T);for(const G of ge)(!P||!(G.profileName in P))&&ue.push(G)}catch{E&&(c?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return ue}async function b(i,a,l,c=process.env,p,P){const T=[];for(const[I,F]of i){if(F===null)continue;let H,ee,ce;if("source"in F){const G=y?.get(F.source);if(!G)continue;H=G.paths,ee=F.args||G.args,F.icon?ce=s(F.icon):G.icon&&(ce=G.icon)}else H=Array.isArray(F.path)?F.path:[F.path],ee=C.isWindows||Array.isArray(F.args)?F.args:void 0,ce=s(F.icon);let ae;if(P){const G=H.map(W=>typeof W=="string"?W:W.path),te=await P(G);ae=new Array(H.length);for(let W=0;W<H.length;W++)typeof H[W]=="string"?ae[W]=te[W]:ae[W]={path:te[W],isUnsafe:!0}}else ae=H.slice();let ue;if(F.requiresPath){let G;if((0,D.isString)(F.requiresPath)?G=F.requiresPath:(G=F.requiresPath.path,F.requiresPath.isUnsafe&&(ue=G)),!await l.existsFile(G))continue}const ge=await r(I,a,ae,l,c,ee,F.env,F.overrideName,F.isAutoDetected,ue);ge?(ge.isAutoDetected=F.isAutoDetected,ge.icon=ce,ge.color=F.color,T.push(ge)):p?.debug("Terminal profile not validated",I,H)}return p?.debug("Validated terminal profiles",T),T}function s(i){return typeof i=="string"?{id:i}:i}async function h(i){if(y&&!i)return;const[a,l]=await Promise.all([u(),i||f()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:l,icon:L.Codicon.terminalPowershell})}async function u(){const i=new Set,a=await(0,d.findExecutable)("git.exe");if(a){const p=(0,R.dirname)(a);i.add((0,R.resolve)(p,"../.."))}function l(p,P){P&&p.add(P)}l(i,process.env.ProgramW6432),l(i,process.env.ProgramFiles),l(i,process.env["ProgramFiles(X86)"]),l(i,`${process.env.LocalAppData}\\Program`);const c=[];for(const p of i)c.push(`${p}\\Git\\bin\\bash.exe`,`${p}\\Git\\usr\\bin\\bash.exe`,`${p}\\usr\\bin\\bash.exe`);return c.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),c}async function f(){const i=[];for await(const a of(0,v.enumeratePowerShellInstallations)())i.push(a.exePath);return i}async function S(i,a){const l=[],c=await new Promise((T,I)=>{w.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,H)=>{if(F)return I("Problem occurred when getting wsl distros");T(H)})});if(!c)return[];const p=new RegExp(/[\r?\n]/),P=c.split(p).filter(T=>T.trim().length>0&&T!=="");for(const T of P){if(T===""||T.startsWith("docker-desktop"))continue;const I=`${T} (WSL)`,F={profileName:I,path:i,args:["-d",`${T}`],isDefault:I===a,icon:O(T),isAutoDetected:!1};l.push(F)}return l}function O(i){return i.includes("Ubuntu")?L.Codicon.terminalUbuntu:i.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function t(i,a,l,c,p,P,T,I){const F=new Map;if(l){const H=(await i.readFile("/etc/shells")).toString(),ee=P||H.split(`
`).filter(ae=>ae.trim().includes("#")&&ae.trim().length>0),ce=new Map;for(const ae of ee){let ue=(0,o.basename)(ae),ge=ce.get(ue)||0;ge++,ge>1&&(ue=`${ue} (${ge})`),ce.set(ue,ge),F.set(ue,{path:ae,isAutoDetected:!0})}}return n(c,F),await b(F.entries(),p,i,I,a,T)}function n(i,a){if(i)for(const[l,c]of Object.entries(i))c===null||typeof c!="object"||!("path"in c)&&!("source"in c)?a.delete(l):(c.icon=c.icon||a.get(l)?.icon,a.set(l,c))}async function r(i,a,l,c,p,P,T,I,F,H){if(l.length===0)return Promise.resolve(void 0);const ee=l.shift();if(ee==="")return r(i,a,l,c,p,P,T,I,F);const ce=typeof ee!="string"&&ee.isUnsafe,ae=typeof ee=="string"?ee:ee.path,ue={profileName:i,path:ae,args:P,env:T,overrideName:I,isAutoDetected:F,isDefault:i===a,isUnsafePath:ce,requiresUnsafePath:H};if((0,o.basename)(ae)===ae){const G=p.PATH?p.PATH.split(o.delimiter):void 0,te=await(0,d.findExecutable)(ae,void 0,G,void 0,c.existsFile);return te?(ue.path=te,ue.isFromPath=!0,ue):r(i,a,l,c,p,P)}return await c.existsFile((0,o.normalize)(ae))?ue:r(i,a,l,c,p,P,T,I,F)}}),define(pe[253],ve([1,0,6,2,13,3,43,105,24,25,107,84,12,247,122,250,252,111]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(O){O[O.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let f=0,S=e.PtyHostService=class extends L.Disposable{constructor(t,n,r,i,a,l){super(),this.C=t,this.D=n,this.F=r,this.G=i,this.H=a,this.I=l,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new w.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new w.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new w.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new w.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new w.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new w.Emitter),this.onProcessData=this.s.event,this.t=this.B(new w.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new w.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new w.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new w.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new w.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new w.Emitter),this.onProcessExit=this.z.event,(0,b.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,L.toDisposable)(()=>this.O())),this.f=this.B(new m.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(C.isWindows)return process.env;try{return await(0,y.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:f,VSCODE_PTY_REMOTE:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},n=(0,R.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);n&&(n.break&&n.port?t.debugBrk=n.port:!n.break&&n.port&&(t.debug=n.port));const r=new A.Client(o.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),D.ProxyChannel.toService(r.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(r.onDidProcessExit(l=>{this.l.fire(l.code),this.i||(this.g<=u.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))})),this.B(new h.RemoteLoggerChannelClient(this.I,r.getChannel(g.TerminalIpcChannels.Logger)));const a=D.ProxyChannel.toService(r.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(a.onProcessData(l=>this.s.fire(l))),this.B(a.onProcessReady(l=>this.t.fire(l))),this.B(a.onProcessExit(l=>this.z.fire(l))),this.B(a.onDidChangeProperty(l=>this.y.fire(l))),this.B(a.onProcessReplay(l=>this.u.fire(l))),this.B(a.onProcessOrphanQuestion(l=>this.v.fire(l))),this.B(a.onDidRequestDetach(l=>this.w.fire(l))),[r,a]}dispose(){this.i=!0,super.dispose()}async createProcess(t,n,r,i,a,l,c,p,P,T,I){const F=setTimeout(()=>this.S(),g.HeartbeatConstants.CreateProcessTimeout),H=await this.b.createProcess(t,n,r,i,a,l,c,p,P,T,I);return clearTimeout(F),f=Math.max(f,H),H}updateTitle(t,n,r){return this.b.updateTitle(t,n,r)}updateIcon(t,n,r,i){return this.b.updateIcon(t,n,r,i)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,n){return this.b.detachFromProcess(t,n)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,n){return this.b.shutdown(t,n)}input(t,n){return this.b.input(t,n)}processBinary(t,n){return this.b.processBinary(t,n)}resize(t,n,r){return this.b.resize(t,n,r)}acknowledgeDataEvent(t,n){return this.b.acknowledgeDataEvent(t,n)}setUnicodeVersion(t,n){return this.b.setUnicodeVersion(t,n)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,n){return this.b.installAutoReply(t,n)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,n,r,i=!1){const a=await this.c;return(0,s.detectAvailableProfiles)(n,r,i,this.F,a,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,n){return this.b.getWslPath(t,n)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,n){return this.b.requestDetachInstance(t,n)}async acceptDetachInstanceReply(t,n){return this.b.acceptDetachInstanceReply(t,n)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,n){return this.b.reviveTerminalProcesses(t,n)}async refreshProperty(t,n){return this.b.refreshProperty(t,n)}async updateProperty(t,n,r){return this.b.updateProperty(t,n,r)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,n){return this.f.createRequest({workspaceId:t,originalText:n})}async acceptPtyHostResolvedVariables(t,n){this.f.acceptReply(t,n)}};e.PtyHostService=S=Le([Ae(2,v.IConfigurationService),Ae(3,d.IEnvironmentService),Ae(4,E.ILogService),Ae(5,E.ILoggerService)],S)}),define(pe[35],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(pe[123],ve([1,0,35,209,16,19,144,6,2]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{constructor(E){this.uri=E,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let R=e.UriIdentityService=class{constructor(E){this.g=E,this.c=new v.DisposableStore,this.f=2**16;const m=new Map,g=b=>{let s=m.get(b.scheme);return s===void 0&&(s=E.hasProvider(b)&&!this.g.hasCapability(b,1024),m.set(b.scheme,s)),s};this.c.add(A.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(b=>{m.delete(b.scheme)})),this.extUri=new C.ExtUri(g),this.d=new D.SkipList((b,s)=>this.extUri.compare(b,s,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,C.normalizePath)(E));const m=this.d.get(E);return m?m.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new d(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((g,b)=>g[1].time<b[1].time?1:g[1].time>b[1].time?-1:0);d._clock=0,this.d.clear();const m=this.f*.5;for(let g=0;g<m;g++)this.d.set(E[g][0],E[g][1].touch())}};e.UriIdentityService=R=Le([Ae(0,o.IFileService)],R),(0,L.registerSingleton)(w.IUriIdentityService,R,1)}),define(pe[87],ve([1,0,193,7,60,19,4,5,13]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function d(i){const a=i;return typeof a?.id=="string"&&D.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=d;function R(i){return typeof i?.id=="string"&&!d(i)&&!E(i)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=y;function E(i){const a=i;return typeof a?.id=="string"&&D.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=E;function m(i){const a=i;if(a?.uri)return{id:a.id,uri:D.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:D.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function b(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=b;function s(i){const a=i;return!!(a&&typeof a=="object"&&D.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=s;class h{constructor(a,l,c,p,P){this.h=a,this.j=c,this.k=p,this.l=P,this.c=o.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=o.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,C.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function f(i){return new u({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,a){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function O(i){let a;return D.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=O,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,a){return!S(i,a)&&!O(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,L.extname)(i):(0,C.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(pe[32],ve([1,0,73,6,2,19,4,192,25,16,5,12,87,28,35,14,21,17,8]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function f(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function S(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:D.URI.revive(r.location).with({scheme:i}),globalStorageHome:D.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(r.extensionsResource).with({scheme:i}),cacheHome:D.URI.revive(r.cacheHome).with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=S;function O(r,i,a,l,c){return{id:r,name:i,location:a,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,C.joinPath)(a,"globalStorage"),settingsResource:(0,C.joinPath)(a,"settings.json"),keybindingsResource:(0,C.joinPath)(a,"keybindings.json"),tasksResource:(0,C.joinPath)(a,"tasks.json"),snippetsHome:(0,C.joinPath)(a,"snippets"),extensionsResource:(0,C.joinPath)(a,"extensions.json"),cacheHome:(0,C.joinPath)(l,r),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=O;let t=e.UserDataProfilesService=class extends o.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,a,l,c){super(),this.n=i,this.r=a,this.s=l,this.t=c,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,C.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const p of this.J()){if(!p.name||!(0,u.isString)(p.name)||!p.location){this.t.warn("Skipping the invalid stored profile",p.location||p.name);continue}i.push(O((0,C.basename)(p.location),p.name,p.location,this.g,{shortName:p.shortName,useDefaultFlags:p.useDefaultFlags}))}}catch(p){this.t.error(p)}const a=new m.ResourceMap,l=new Map,c=this.w();if(i.unshift({...c,extensionsResource:this.O()??c.extensionsResource,isDefault:!0}),i.length)try{const p=this.M();if(p.workspaces)for(const[P,T]of Object.entries(p.workspaces)){const I=D.URI.parse(P),F=i.find(H=>H.id===T);F&&a.set(I,F)}if(p.emptyWindows)for(const[P,T]of Object.entries(p.emptyWindows)){const I=i.find(F=>F.id===T);I&&l.set(P,I)}}catch(p){this.t.error(p)}this.u={profiles:i,workspaces:a,emptyWindows:l}}return this.u}w(){return O("__default__profile__",(0,A.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const a="Temp",l=new RegExp(`${(0,h.escapeRegExpCharacters)(a)}\\s(\\d+)`);let c=0;for(const P of this.profiles){const T=l.exec(P.name),I=T?parseInt(T[1]):0;c=I>c?I:c}const p=`${a} ${c+1}`;return this.createProfile((0,w.hash)((0,s.generateUuid)()).toString(16),p,{transient:!0},i)}async createNamedProfile(i,a,l){return this.createProfile((0,w.hash)((0,s.generateUuid)()).toString(16),i,a,l)}async createProfile(i,a,l,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.y(i,a,l);return c&&await this.setProfileForWorkspace(c,p),p}async y(i,a,l){if(!(0,u.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.l.get(a);return c||(c=(async()=>{try{const p=this.profiles.find(I=>I.name===a||I.id===i);if(p)return p;const P=O(i,a,(0,C.joinPath)(this.profilesHome,i),this.g,l);await this.r.createFolder(P.location);const T=[];return this.i.fire({profile:P,join(I){T.push(I)}}),await b.Promises.settled(T),this.D([P],[],[]),P}finally{this.l.delete(a)}})(),this.l.set(a,c)),c}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(c=>c.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);return l=O(l.id,a.name??l.name,l.location,this.g,{shortName:a.shortName??l.shortName,transient:a.transient??l.isTransient,useDefaultFlags:a.useDefaultFlags??l.useDefaultFlags}),this.D([],[],[l]),l}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(c=>c.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const l=[];this.j.fire({profile:a,join(c){l.push(c)}});try{await Promise.allSettled(l)}catch(c){this.t.error(c)}for(const c of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(c)?.id&&this.v.emptyWindows.delete(c);for(const c of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(c)?.id&&this.v.workspaces.delete(c);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(c){(0,d.toFileOperationResult)(c)!==1&&this.t.error(c)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(a.location,{recursive:!0})}catch(c){this.t.error(c)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(c=>c.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,l)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(l=>!this.s.extUri.isEqual(l.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.z(i);return D.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(i){return(0,E.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,E.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location)))}D(i,a,l){const c=[...this.profiles,...i],p=[];this.m.profiles=[];for(let P of c)P.isDefault||a.some(T=>P.id===T.id)||(P=l.find(T=>P.id===T.id)??P,P.isTransient?this.m.profiles.push(P):p.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.L(p),this.u=void 0,this.F(i,a,l)}F(i,a,l){this.h.fire({added:i,removed:a,updated:l,all:this.profiles})}G(i,a,l){l=a?.isTransient?!0:l,l||this.G(i,void 0,!0);const c=this.z(i),p=l?this.m:this.v;D.URI.isUri(c)?(p.workspaces.delete(c),a&&p.workspaces.set(c,a)):(p.emptyWindows.delete(c),a&&p.emptyWindows.set(c,a)),l||this.H()}H(){const i={};for(const[l,c]of this.v.workspaces.entries())i[l.toString()]=c.id;const a={};for(const[l,c]of this.v.emptyWindows.entries())a[l.toString()]=c.id;this.N({workspaces:i,emptyWindows:a}),this.u=void 0}I(i){const a={},l=this.w();if(i.workspaces)for(const[p,P]of Object.entries(i.workspaces)){const T=D.URI.parse(P);a[p]=this.s.extUri.isEqual(T,l.location)?l.id:this.s.extUri.basename(T)}const c={};if(i.emptyWindows)for(const[p,P]of Object.entries(i.emptyWindows)){const T=D.URI.parse(P);c[p]=this.s.extUri.isEqual(T,l.location)?l.id:this.s.extUri.basename(T)}return{workspaces:a,emptyWindows:c}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=Le([Ae(0,v.IEnvironmentService),Ae(1,d.IFileService),Ae(2,g.IUriIdentityService),Ae(3,y.ILogService)],t);class n extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=n}),define(pe[254],ve([1,0,18,14,20,9,6,2,3,8,4,173,30,34,36,12,27,31,32]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=e.AbstractExtensionManagementService=class extends A.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,a,l,c,p){super(),this.t=i,this.u=a,this.v=l,this.w=c,this.y=p,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new D.Emitter),this.m=this.B(new D.Emitter),this.n=this.B(new D.Emitter),this.p=this.B(new D.Emitter),this.s=[],this.B((0,A.toDisposable)(()=>{this.j.forEach(({task:P})=>P.cancel()),this.k.forEach(P=>P.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,E.isTargetPlatformCompatible)(l,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(y.localize(0,null),E.ExtensionManagementErrorCode.Internal);const l=await this.G(i,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.z(l.manifest,l.extension,a)}catch(l){throw t(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:l}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(l),O(l)}}async uninstall(i,a={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,a)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,a,l){const c=l.isApplicationScoped||l.isBuiltin||(0,g.isApplicationScopedExtension)(i),p={...l,installOnlyNewlyAddedFromExtensionPack:R.URI.isUri(a)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.y.defaultProfile.extensionsResource:l.profileLocation??this.P()},P=ce=>`${m.ExtensionKey.create(ce).toString()}${p.profileLocation?`-${p.profileLocation.toString()}`:""}`;if(!R.URI.isUri(a)){const ce=this.j.get(P(a));if(ce)return this.v.info("Extensions is already requested to install",a.identifier.id),ce.task.waitUntilTaskIsFinished()}const T=[],I=[],F=[],H=this.Q(i,a,p);R.URI.isUri(a)||this.j.set(P(a),{task:H,waitingTasks:[]}),this.l.fire({identifier:H.identifier,source:a,profileLocation:p.profileLocation}),this.v.info("Installing extension:",H.identifier.id),T.push({task:H,manifest:i});let ee=!1;try{if(p.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",H.identifier.id);else try{const ae=await this.F(H.identifier,i,!!p.installOnlyNewlyAddedFromExtensionPack,!!p.installPreReleaseVersion,p.profileLocation),ue=await this.getInstalled(void 0,p.profileLocation);for(const{gallery:ge,manifest:G}of(0,w.distinct)(ae,({gallery:te})=>te.identifier.id)){ee=ee||!!G.extensionDependencies?.some(K=>(0,m.areSameExtensions)({id:K},H.identifier));const te=P(ge),W=this.j.get(te);if(W){if(this.C(H,W.task)){const K=W.task.identifier;this.v.info("Waiting for already requested installing extension",K.id,H.identifier.id),W.waitingTasks.push(H),I.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,q=>q.some(ie=>(0,m.areSameExtensions)(ie.identifier,K)))).then(q=>{if(this.v.info("Finished waiting for already requested installing extension",K.id,H.identifier.id),!q.find(re=>(0,m.areSameExtensions)(re.identifier,K))?.local)throw new Error(`Extension ${K.id} is not installed`)}))}}else if(!ue.some(({identifier:K})=>(0,m.areSameExtensions)(K,ge.identifier))){const K=this.Q(G,ge,{...p,donotIncludePackAndDependencies:!0});this.j.set(te,{task:K,waitingTasks:[H]}),this.l.fire({identifier:K.identifier,source:ge,profileLocation:p.profileLocation}),this.v.info("Installing extension:",K.identifier.id,H.identifier.id),T.push({task:K,manifest:G})}}}catch(ae){if(R.URI.isUri(H.source))(0,w.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",H.identifier.id,ae.message),(0,w.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",H.identifier.id,ae.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",H.identifier.id),ae}const ce=T.reduce((ae,{task:ue,manifest:ge})=>(ae.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:ge}),ae),new Map);for(;ce.size;){let ae;const ue=[...ce.values()].filter(({manifest:ge})=>!ge.extensionDependencies?.some(G=>ce.has(G.toLowerCase())));ue.length?ae=ce.size===1?ue:ue.filter(({task:ge})=>!(ge===H&&!ee)):(this.v.info("Found extensions with circular dependencies",ue.map(({task:ge})=>ge.identifier.id)),ae=[...ce.values()]),await this.D(ae.map(async({task:ge})=>{const G=new Date().getTime();try{const te=await ge.run();if(await this.D(this.s.map(W=>W.postInstall(te,ge.source,p,o.CancellationToken.None))),!R.URI.isUri(ge.source)){const W=ge.operation===3,K=W?void 0:(new Date().getTime()-ge.source.lastUpdated)/1e3;if(t(this.u,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ge.source),verificationStatus:ge.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:K}),v.isWeb&&ge.operation!==3)try{await this.t.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch{}}F.push({local:te,identifier:ge.identifier,operation:ge.operation,source:ge.source,context:p.context,profileLocation:ge.profileLocation,applicationScoped:te.isApplicationScoped})}catch(te){throw R.URI.isUri(ge.source)||t(this.u,ge.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ge.source),verificationStatus:ge.verificationStatus,duration:new Date().getTime()-G,error:te}),this.v.error("Error while installing the extension:",ge.identifier.id),te}finally{ce.delete(ge.identifier.id.toLowerCase())}}))}return I.length&&await this.D(I),F.forEach(({identifier:ae})=>this.v.info("Extension installed successfully:",ae.id)),this.m.fire(F),F.filter(({identifier:ae})=>(0,m.areSameExtensions)(ae,H.identifier))[0].local}catch(ce){if(T.forEach(({task:ae})=>ae.cancel()),F.length)try{const ae=await Promise.allSettled(F.map(({local:ue})=>this.R(ue,{versionOnly:!0,profileLocation:p.profileLocation}).run()));for(let ue=0;ue<ae.length;ue++){const ge=ae[ue],{identifier:G}=F[ue];ge.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",G.id):this.v.warn("Rollback: Error while uninstalling extension",G.id,(0,C.getErrorMessage)(ge.reason))}}catch(ae){this.v.warn("Error while rolling back extensions",(0,C.getErrorMessage)(ae),F.map(({identifier:ue})=>ue.id))}throw this.m.fire(T.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:p.context,profileLocation:p.profileLocation}))),ce}finally{for(const{task:ce}of T)ce.source&&!R.URI.isUri(ce.source)&&this.j.delete(P(ce.source))}}C(i,a){for(const[,{task:l,waitingTasks:c}]of this.j.entries())if(l===i&&(c.includes(a)||c.some(p=>this.C(p,a)))||l===a&&c[0]&&!this.C(i,c[0]))return!1;return!0}async D(i){const a=[],l=[],c=await Promise.allSettled(i);for(const p of c)p.status==="fulfilled"?a.push(p.value):l.push(p.reason);if(l.length)throw S(l);return a}async F(i,a,l,c,p){if(!this.t.isEnabled())return[];const P=await this.getInstalled(void 0,p),T=[],I=[],F=async(H,ee)=>{T.push(H);const ce=ee.extensionDependencies||[],ae=[...ce];if(ee.extensionPack){const ue=l?P.find(ge=>(0,m.areSameExtensions)(ge.identifier,H)):void 0;for(const ge of ee.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(G=>(0,m.areSameExtensions)({id:G},{id:ge}))||ae.every(G=>!(0,m.areSameExtensions)({id:G},{id:ge}))&&ae.push(ge)}if(ae.length){const ue=ae.filter(ge=>T.every(G=>!(0,m.areSameExtensions)(G,{id:ge})));if(ue.length){const ge=await this.t.getExtensions(ue.map(G=>({id:G,preRelease:c})),o.CancellationToken.None);for(const G of ge){if(T.find(K=>(0,m.areSameExtensions)(K,G.identifier)))continue;const te=ce.some(K=>(0,m.areSameExtensions)({id:K},G.identifier));let W;try{W=await this.G(G,!1,c)}catch(K){if(K instanceof E.ExtensionManagementError&&K.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!te){this.v.info("Skipping the packed extension as it cannot be installed",G.identifier.id);continue}else throw K}I.push({gallery:W.extension,manifest:W.manifest}),await F(W.extension.identifier,W.manifest)}}}};return await F(i,a),I}async G(i,a,l){if((await this.getExtensionsControlManifest()).malicious.some(T=>(0,m.areSameExtensions)(i.identifier,T)))throw new E.ExtensionManagementError(y.localize(1,null,i.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const T=await this.getTargetPlatform();throw new E.ExtensionManagementError(y.localize(2,null,i.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(T)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const p=await this.H(i,a,l);if(p){if(l&&!a&&i.hasPreReleaseVersion&&!p.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],o.CancellationToken.None))[0]?new E.ExtensionManagementError(y.localize(4,null,i.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",p.identifier.id);const P=await this.t.getManifest(p,o.CancellationToken.None);if(P===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(P.version!==p.version)throw new E.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:p,manifest:P}}async H(i,a,l){const c=await this.getTargetPlatform();let p=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(p=(await this.t.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:c,compatible:!0},o.CancellationToken.None))[0]||null),!p&&await this.t.isExtensionCompatible(i,l,c)&&(p=i),p||(a?p=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},o.CancellationToken.None))[0]||null:p=await this.t.getCompatibleExtension(i,l,c)),p}async I(i,a){const l={...a,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},c=H=>`${H.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,p=this.k.get(c(i.identifier));if(p)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),p.waitUntilTaskIsFinished();const P=H=>{const ee=this.R(H,l);return this.k.set(c(ee.extension.identifier),ee),l.profileLocation?this.v.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,l.profileLocation.toString()):this.v.info("Uninstalling extension:",`${H.identifier.id}@${H.manifest.version}`),this.n.fire({identifier:H.identifier,profileLocation:l.profileLocation,applicationScoped:H.isApplicationScoped}),ee},T=(H,ee)=>{ee?l.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,l.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${H.identifier.id}@${H.manifest.version}`,ee.message):l.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,l.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${H.identifier.id}@${H.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(H),error:ee}),this.p.fire({identifier:H.identifier,error:ee?.code,profileLocation:l.profileLocation,applicationScoped:H.isApplicationScoped})},I=[],F=[];try{I.push(P(i));const H=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ee=this.M(i,H);for(const ce of ee)this.k.has(c(ce.identifier))?this.v.info("Extensions is already requested to uninstall",ce.identifier.id):I.push(P(ce))}l.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(I.map(ee=>ee.extension),H,i),await this.D(I.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(ce=>ce.postUninstall(ee.extension,l,o.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}T(ee.extension)}catch(ce){const ae=ce instanceof E.ExtensionManagementError?ce:new E.ExtensionManagementError((0,C.getErrorMessage)(ce),E.ExtensionManagementErrorCode.Internal);throw T(ee.extension,ae),ae}finally{F.push(ee)}}))}catch(H){const ee=H instanceof E.ExtensionManagementError?H:new E.ExtensionManagementError((0,C.getErrorMessage)(H),E.ExtensionManagementErrorCode.Internal);for(const ce of I){try{ce.cancel()}catch{}F.includes(ce)||T(ce.extension,ee)}throw ee}finally{for(const H of I)this.k.delete(c(H.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}J(i,a,l){for(const c of i){const p=this.N(c,a);if(p.length){const P=p.filter(T=>!i.some(I=>(0,m.areSameExtensions)(I.identifier,T.identifier)));if(P.length)throw new Error(this.L(c,P,l))}}}L(i,a,l){return l===i?a.length===1?y.localize(6,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?y.localize(7,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):y.localize(8,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?y.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?y.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):y.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}M(i,a,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const p=a.filter(T=>!T.isBuiltin&&c.some(I=>(0,m.areSameExtensions)({id:I},T.identifier))),P=[];for(const T of p)P.push(...this.M(T,a,l));return[...p,...P]}return[]}N(i,a){return a.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(c=>(0,m.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=f=Le([Ae(0,E.IExtensionGalleryService),Ae(1,h.ITelemetryService),Ae(2,b.ILogService),Ae(3,s.IProductService),Ae(4,u.IUserDataProfilesService)],f);function S(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,l)=>new Error(`${a.message}${a.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=S;function O(r){if(r instanceof E.ExtensionManagementError)return r;const i=new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function t(r,i,{extensionData:a,verificationStatus:l,duration:c,error:p,durationSinceUpdate:P}){let T,I;(0,d.isDefined)(l)&&(l===!0?l="Verified":(l===!1||(T=E.ExtensionManagementErrorCode.Signature,I=l),l="Unverified")),p&&(p instanceof E.ExtensionManagementError?(T=p.code,p.code===E.ExtensionManagementErrorCode.Signature&&(I=p.message)):T=E.ExtensionManagementErrorCode.Internal),r.publicLog(i,{...a,verificationStatus:l,success:!p,duration:c,errorcode:T,errorcodeDetail:I,durationSinceUpdate:P})}class n{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(i=>new Promise((a,l)=>{const c=i.onCancellationRequested(()=>{c.dispose(),l(new C.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(pe[45],ve([1,0,14,15,2,6,28,4,30,34,16,5,12,32,35,8,9,31]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class f extends Error{constructor(r,i){super(r),this.code=i}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let S=e.AbstractExtensionsProfileScannerService=class extends o.Disposable{constructor(r,i,a,l,c,p){super(),this.i=r,this.j=i,this.k=a,this.l=l,this.m=c,this.n=p,this.b=this.B(new C.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new C.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new C.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new C.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new D.ResourceMap}scanProfileExtensions(r,i){return this.p(r,void 0,i)}async addExtensionsToProfile(r,i){const a=[],l=[];try{return await this.p(i,c=>{const p=[];for(const P of c)r.some(([T])=>(0,d.areSameExtensions)(T.identifier,P.identifier)&&T.manifest.version!==P.version)?a.push(P):p.push(P);for(const[P,T]of r)if(!p.some(I=>(0,d.areSameExtensions)(I.identifier,P.identifier)&&I.version===P.manifest.version)){const I={identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:T};l.push(I),p.push(I)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),a.length&&this.f.fire({extensions:a,profileLocation:i}),p}),l.length&&this.c.fire({extensions:l,profileLocation:i}),a.length&&this.g.fire({extensions:a,profileLocation:i}),l}catch(c){throw l.length&&this.c.fire({extensions:l,error:c,profileLocation:i}),a.length&&this.g.fire({extensions:a,error:c,profileLocation:i}),c}}async updateMetadata(r,i){const a=[];return await this.p(i,l=>{const c=[];for(const p of l){const P=r.find(([T])=>(0,d.areSameExtensions)(T.identifier,p.identifier)&&T.manifest.version===p.version);P&&(p.metadata={...p.metadata,...P[1]},a.push(p)),c.push(p)}return c}),a}async removeExtensionFromProfile(r,i){const a=[];this.f.fire({extensions:a,profileLocation:i});try{await this.p(i,l=>{const c=[];for(const p of l)(0,d.areSameExtensions)(p.identifier,r.identifier)?a.push(p):c.push(p);return a.length&&this.f.fire({extensions:a,profileLocation:i}),c}),a.length&&this.g.fire({extensions:a,profileLocation:i})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:i}),l}}async p(r,i,a){return this.w(r).queue(async()=>{let l=[],c;try{const p=await this.j.readFile(r);c=JSON.parse(p.value.toString().trim()||"[]")}catch(p){if((0,R.toFileOperationResult)(p)!==1)throw p;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&a?.bailOutWhenFileNotFound)throw new f((0,s.getErrorMessage)(p),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(r);let p=!1;for(const P of c){O(P)||this.r(r);let T;if((0,b.isString)(P.relativeLocation)&&P.relativeLocation)T=this.t(P.relativeLocation);else if((0,b.isString)(P.location))T=this.t(P.location),p=!0,P.relativeLocation=P.location,P.location=T.toJSON();else{T=A.URI.revive(P.location);const I=this.s(T);I&&(p=!0,P.relativeLocation=I)}l.push({identifier:P.identifier,location:T,version:P.version,metadata:P.metadata})}p&&await this.j.writeFile(r,L.VSBuffer.fromString(JSON.stringify(c)))}if(i){l=i(l);const p=l.map(P=>({identifier:P.identifier,version:P.version,location:P.location.toJSON(),relativeLocation:this.s(P.location),metadata:P.metadata}));await this.j.writeFile(r,L.VSBuffer.fromString(JSON.stringify(p)))}return l})}r(r){const i=new f(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(r){return this.l.extUri.isEqual(this.l.extUri.dirname(r),this.i)?this.l.extUri.basename(r):void 0}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let a;try{a=(await this.j.readFile(r)).value.toString()}catch(c){if((0,R.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",r.toString());let l;try{const c=JSON.parse(a);Array.isArray(c)&&c.every(p=>O(p))?l=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,R.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(r)}catch(c){(0,R.toFileOperationResult)(c)!==1&&this.n.error(c)}try{await this.j.del(i)}catch(c){(0,R.toFileOperationResult)(c)!==1&&this.n.error(c)}return l})()),this.u}w(r){let i=this.h.get(r);return i||(i=new w.Queue,this.h.set(r,i)),i}};e.AbstractExtensionsProfileScannerService=S=Le([Ae(1,R.IFileService),Ae(2,m.IUserDataProfilesService),Ae(3,g.IUriIdentityService),Ae(4,h.ITelemetryService),Ae(5,E.ILogService)],S);function O(n){return(0,b.isObject)(n)&&(0,v.isIExtensionIdentifier)(n.identifier)&&(t(n.location)||(0,b.isString)(n.location)&&n.location)&&((0,b.isUndefined)(n.relativeLocation)||(0,b.isString)(n.relativeLocation))&&n.version&&(0,b.isString)(n.version)}function t(n){return n?(0,b.isString)(n.path)&&(0,b.isString)(n.scheme):!1}}),define(pe[56],ve([1,0,18,14,22,15,9,72,166,2,13,7,3,19,52,59,8,4,177,25,34,36,77,16,5,12,27,6,61,45,32,35,207]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t,n,r,i,a,l,c,p,P,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(G){function te(W,K){if(W===K)return!0;const q=Object.keys(W),ie=new Set;for(const re of Object.keys(K))ie.add(re);if(q.length!==ie.size)return!1;for(const re of q){if(W[re]!==K[re])return!1;ie.delete(re)}return ie.size===0}G.equals=te})(F||(e.Translations=F={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let H=e.AbstractExtensionsScannerService=class extends d.Disposable{constructor(te,W,K,q,ie,re,de,$,V,N,k,U){super(),this.systemExtensionsLocation=te,this.userExtensionsLocation=W,this.l=K,this.m=q,this.n=ie,this.r=re,this.s=de,this.t=$,this.u=V,this.v=N,this.w=k,this.y=U,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ae,this.m,this.h)),this.j=this.B(this.y.createInstance(ae,this.m,this.h)),this.k=this.B(this.y.createInstance(ce,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,S.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(te,W,K){const[q,ie]=await Promise.all([this.scanSystemExtensions(te),this.scanUserExtensions(W)]),re=K?await this.scanExtensionsUnderDevelopment(te,[...q,...ie]):[];return this.G(q,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(te){const W=[];W.push(this.H(!!te.useCache,te.language)),W.push(this.I(te.language,!!te.checkControlFile));const[K,q]=await Promise.all(W);return this.F([...K,...q],0,te,!1)}async scanUserExtensions(te){const W=te.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",W);const K=this.w.extUri.isEqual(te.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.L(W,!!te.profileLocation,1,!te.includeUninstalled,te.language,!0,K),ie=te.useCache&&!q.devMode&&q.excludeObsolete?this.j:this.k;let re;try{re=await ie.scanExtensions(q)}catch(de){if(de instanceof p.ExtensionsProfileScanningError&&de.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),re=await ie.scanExtensions(q);else throw de}return re=await this.F(re,1,te,!0),this.t.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(te,W){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const K=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(q=>q.scheme===R.Schemas.file).map(async q=>{const ie=await this.L(q,!1,1,!0,te.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ie)).map(de=>(de.type=W.find($=>(0,S.areSameExtensions)($.identifier,de.identifier))?.type??de.type,this.k.validate(de,ie)))}))).flat();return this.F(K,"development",te,!0)}return[]}async scanExistingExtension(te,W,K){const q=await this.L(te,!1,W,!0,K.language,!0,void 0),ie=await this.k.scanExtension(q);return!ie||!K.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(te,W,K){const q=await this.L(te,!1,W,!0,K.language,!0,void 0),ie=await this.k.scanOneOrMultipleExtensions(q);return this.F(ie,W,K,!0)}async scanMetadata(te){const W=(0,m.joinPath)(te,"package.json"),K=(await this.s.readFile(W)).value.toString();return JSON.parse(K).__metadata}async updateMetadata(te,W){const K=(0,m.joinPath)(te,"package.json"),q=(await this.s.readFile(K)).value.toString(),ie=JSON.parse(q);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,ie.__metadata={...ie.__metadata,...W},await this.s.writeFile((0,m.joinPath)(te,"package.json"),C.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(te){if(te instanceof p.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw te}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const te=await this.scanUserExtensions({includeInvalid:!0});if(te.length)await this.r.addExtensionsToProfile(te.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(W){(0,n.toFileOperationResult)(W)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(W))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(te){this.t.error(te)}finally{this.C=void 0}})()),this.C}async F(te,W,K,q){return K.includeAllVersions||(te=this.G(W===0?te:void 0,W===1?te:void 0,W==="development"?te:void 0,await this.getTargetPlatform(),q)),K.includeInvalid||(te=te.filter(ie=>ie.isValid)),te.sort((ie,re)=>{const de=y.basename(ie.location.fsPath),$=y.basename(re.location.fsPath);return de<$?-1:de>$?1:0})}G(te,W,K,q,ie){const re=($,V,N)=>{if($.isValid&&!V.isValid)return!1;if($.isValid===V.isValid){if(ie&&g.gt($.manifest.version,V.manifest.version))return this.t.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(g.eq($.manifest.version,V.manifest.version)){if($.type===0)return this.t.debug(`Skipping extension ${V.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===q)return this.t.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return N?this.t.warn(`Overwriting user extension ${$.location.path} with ${V.location.path}.`):this.t.debug(`Overwriting user extension ${$.location.path} with ${V.location.path}.`),!0},de=new O.ExtensionIdentifierMap;return te?.forEach($=>{const V=de.get($.identifier.id);(!V||re(V,$,!1))&&de.set($.identifier.id,$)}),W?.forEach($=>{const V=de.get($.identifier.id);if(!V&&te&&$.type===0){this.t.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!V||re(V,$,!1))&&de.set($.identifier.id,$)}),K?.forEach($=>{const V=de.get($.identifier.id);(!V||re(V,$,!0))&&de.set($.identifier.id,$),de.set($.identifier.id,$)}),[...de.values()]}async H(te,W){this.t.trace("Started scanning system extensions");const K=await this.L(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),ie=await(te&&!K.devMode?this.i:this.k).scanExtensions(K);return this.t.trace("Scanned system extensions:",ie.length),ie}async I(te,W){const K=this.u.isBuilt?[]:this.v.builtInExtensions;if(!K?.length)return[];this.t.trace("Started scanning dev system extensions");const q=W?await this.J():{},ie=[],re=h.URI.file(y.normalize(y.join(R.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $ of K){const V=q[$.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":ie.push((0,m.joinPath)(re,$.name));break;default:ie.push(h.URI.file(V));break}}const de=await Promise.all(ie.map(async $=>this.k.scanExtension(await this.L($,!1,0,!0,te,!0,void 0))));return this.t.trace("Scanned dev system extensions:",de.length),(0,w.coalesce)(de)}async J(){try{const te=await this.s.readFile(this.l);return JSON.parse(te.value.toString())}catch{return{}}}async L(te,W,K,q,ie,re,de){const $=await this.f(ie??E.language),V=await this.M(te),N=W&&!this.w.extUri.isEqual(te,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,k=N?await this.M(N):void 0;return new ee(te,V,N,k,W,de,K,q,re,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,ie,$)}async M(te){try{const W=await this.s.stat(te);if(typeof W.mtime=="number")return W.mtime}catch{}}};e.AbstractExtensionsScannerService=H=Le([Ae(4,P.IUserDataProfilesService),Ae(5,p.IExtensionsProfileScannerService),Ae(6,n.IFileService),Ae(7,i.ILogService),Ae(8,f.IEnvironmentService),Ae(9,a.IProductService),Ae(10,T.IUriIdentityService),Ae(11,r.IInstantiationService)],H);class ee{constructor(te,W,K,q,ie,re,de,$,V,N,k,U,X,ne,z){this.location=te,this.mtime=W,this.applicationExtensionslocation=K,this.applicationExtensionslocationMtime=q,this.profile=ie,this.profileScanOptions=re,this.type=de,this.excludeObsolete=$,this.validate=V,this.productVersion=N,this.productDate=k,this.productCommit=U,this.devMode=X,this.language=ne,this.translations=z}static createNlsConfiguration(te){return{language:te.language,pseudo:te.language==="pseudo",devMode:te.devMode,translations:te.translations}}static equals(te,W){return(0,m.isEqual)(te.location,W.location)&&te.mtime===W.mtime&&(0,m.isEqual)(te.applicationExtensionslocation,W.applicationExtensionslocation)&&te.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&te.profile===W.profile&&o.equals(te.profileScanOptions,W.profileScanOptions)&&te.type===W.type&&te.excludeObsolete===W.excludeObsolete&&te.validate===W.validate&&te.productVersion===W.productVersion&&te.productDate===W.productDate&&te.productCommit===W.productCommit&&te.devMode===W.devMode&&te.language===W.language&&F.equals(te.translations,W.translations)}}e.ExtensionScannerInput=ee;let ce=class extends d.Disposable{constructor(te,W,K,q,ie){super(),this.f=te,this.g=W,this.h=K,this.i=q,this.j=ie}async scanExtensions(te){const W=te.profile?await this.l(te):await this.k(te);let K={};if(te.excludeObsolete&&te.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();K=JSON.parse(q)}catch{}return(0,s.isEmptyObject)(K)?W:W.filter(q=>!K[S.ExtensionKey.create(q).toString()])}async k(te){const W=await this.i.resolve(te.location);if(!W.children?.length)return[];const K=await Promise.all(W.children.map(async q=>{if(!q.isDirectory||te.type===1&&(0,m.basename)(q.resource).indexOf(".")===0)return null;const ie=new ee(q.resource,te.mtime,te.applicationExtensionslocation,te.applicationExtensionslocationMtime,te.profile,te.profileScanOptions,te.type,te.excludeObsolete,te.validate,te.productVersion,te.productDate,te.productCommit,te.devMode,te.language,te.translations);return this.scanExtension(ie)}));return(0,w.coalesce)(K).sort((q,ie)=>q.location.path<ie.location.path?-1:1)}async l(te){let W=await this.m(te.location,()=>!0,te);if(te.applicationExtensionslocation&&!this.h.extUri.isEqual(te.location,te.applicationExtensionslocation)){W=W.filter(q=>!q.metadata?.isApplicationScoped);const K=await this.m(te.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,te);W.push(...K)}return W}async m(te,W,K){const q=await this.g.scanProfileExtensions(te,K.profileScanOptions);if(!q.length)return[];const ie=await Promise.all(q.map(async re=>{if(W(re)){const de=new ee(re.location,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(de,re.metadata)}return null}));return(0,w.coalesce)(ie)}async scanOneOrMultipleExtensions(te){try{if(await this.i.exists((0,m.joinPath)(te.location,"package.json"))){const W=await this.scanExtension(te);return W?[W]:[]}else return await this.scanExtensions(te)}catch(W){return this.j.error(`Error scanning extensions at ${te.location.path}:`,(0,D.getErrorMessage)(W)),[]}}async scanExtension(te,W){try{let K=await this.scanExtensionManifest(te.location);if(K){K.publisher||(K.publisher=O.UNDEFINED_PUBLISHER),W=W??K.__metadata,delete K.__metadata;const q=(0,S.getGalleryExtensionId)(K.publisher,K.name),ie=W?.id?{id:q,uuid:W.id}:{id:q},re=W?.isSystem?0:te.type,de=re===0||!!W?.isBuiltin;K=await this.n(te.location,K,ee.createNlsConfiguration(te));const $={type:re,identifier:ie,manifest:K,location:te.location,isBuiltin:de,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return te.validate?this.validate($,te):$}}catch(K){te.type!==0&&this.j.error(K)}return null}validate(te,W){let K=!0;const q=(0,t.validateExtensionManifest)(W.productVersion,W.productDate,W.location,te.manifest,te.isBuiltin);for(const[ie,re]of q)ie===b.default.Error&&(K=!1,this.j.error(this.u(W.location,re)));return te.isValid=K,te.validations=q,te}async scanExtensionManifest(te){const W=(0,m.joinPath)(te,"package.json");let K;try{K=(await this.i.readFile(W)).value.toString()}catch(ie){return(0,n.toFileOperationResult)(ie)!==1&&this.j.error(this.u(te,(0,u.localize)(0,null,W.path,ie.message))),null}let q;try{q=JSON.parse(K)}catch{const re=[];(0,A.parse)(K,re);for(const de of re)this.j.error(this.u(te,(0,u.localize)(1,null,W.path,de.offset,de.length,(0,v.getParseErrorMessage)(de.error))));return null}return(0,A.getNodeType)(q)!=="object"?(this.j.error(this.u(te,(0,u.localize)(2,null,W.path))),null):q}async n(te,W,K){const q=await this.r(te,W,K);if(q)try{const ie=[],re=await this.s(q.default,ie);if(ie.length>0)return ie.forEach($=>{this.j.error(this.u(te,(0,u.localize)(3,null,q.default?.path,(0,v.getParseErrorMessage)($.error))))}),W;if((0,A.getNodeType)(q)!=="object")return this.j.error(this.u(te,(0,u.localize)(4,null,q.default?.path))),W;const de=q.values||Object.create(null);return(0,I.localizeManifest)(W,de,re)}catch{}return W}async r(te,W,K){const q=(0,m.joinPath)(te,"package.nls.json"),ie=(V,N)=>{N.forEach(k=>{this.j.error(this.u(te,(0,u.localize)(5,null,V?.path,(0,v.getParseErrorMessage)(k.error))))})},re=V=>{this.j.error(this.u(te,(0,u.localize)(6,null,V?.path)))},de=`${W.publisher}.${W.name}`,$=K.translations[de];if($)try{const V=h.URI.file($),N=(await this.i.readFile(V)).value.toString(),k=[],U=(0,A.parse)(N,k);return k.length>0?(ie(V,k),{values:void 0,default:q}):(0,A.getNodeType)(U)!=="object"?(re(V),{values:void 0,default:q}):{values:U.contents?U.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let N;try{N=await this.t(te,K)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const k=(await this.i.readFile(N.localized)).value.toString(),U=[],X=(0,A.parse)(k,U);return U.length>0?(ie(N.localized,U),{values:void 0,default:N.original}):(0,A.getNodeType)(X)!=="object"?(re(N.localized),{values:void 0,default:N.original}):{values:X,default:N.original}}catch{return{values:void 0,default:N.original}}}}async s(te,W){if(te)try{const K=(await this.i.readFile(te)).value.toString();return(0,A.parse)(K,W)}catch{}}t(te,W){return new Promise((K,q)=>{const ie=re=>{const de=(0,m.joinPath)(te,`package.nls.${re}.json`);this.i.exists(de).then($=>{$&&K({localized:de,original:(0,m.joinPath)(te,"package.nls.json")});const V=re.lastIndexOf("-");V===-1?K({localized:(0,m.joinPath)(te,"package.nls.json"),original:null}):(re=re.substring(0,V),ie(re))})};if(W.devMode||W.pseudo||!W.language)return K({localized:(0,m.joinPath)(te,"package.nls.json"),original:null});ie(W.language)})}u(te,W){return`[${te.path}]: ${W}`}};ce=Le([Ae(1,p.IExtensionsProfileScannerService),Ae(2,T.IUriIdentityService),Ae(3,n.IFileService),Ae(4,i.ILogService)],ce);let ae=class extends ce{constructor(te,W,K,q,ie,re,de){super(W,q,ie,re,de),this.z=te,this.C=K,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new l.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(te){const W=this.H(te),K=await this.D(W);if(this.v=te,K&&K.input&&ee.equals(K.input,this.v))return this.j.debug("Using cached extensions scan result",te.location.toString()),this.w.trigger(()=>this.G()),K.result.map(ie=>(ie.location=h.URI.revive(ie.location),ie));const q=await super.scanExtensions(te);return await this.F(W,{input:te,result:q}),q}async D(te){try{const W=await this.i.readFile(te),K=JSON.parse(W.value.toString());return{result:K.result,input:(0,c.revive)(K.input)}}catch(W){this.j.debug("Error while reading the extension cache file:",te.path,(0,D.getErrorMessage)(W))}return null}async F(te,W){try{await this.i.writeFile(te,C.VSBuffer.fromString(JSON.stringify(W)))}catch(K){this.j.debug("Error while writing the extension cache file:",te.path,(0,D.getErrorMessage)(K))}}async G(){if(!this.v)return;const te=this.H(this.v),W=await this.D(te);if(!W)return;const K=W.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!o.equals(q,K))try{this.j.info("Invalidating Cache",K,q),await this.i.del(te),this.y.fire()}catch(ie){this.j.error(ie)}}H(te){const W=this.I(te);return this.h.extUri.joinPath(W.cacheHome,te.type===0?O.BUILTIN_MANIFEST_CACHE_FILE:O.USER_MANIFEST_CACHE_FILE)}I(te){return te.type===0?this.C.defaultProfile:te.profile?this.h.extUri.isEqual(te.location,this.z.extensionsResource)?this.z:this.C.profiles.find(W=>this.h.extUri.isEqual(te.location,W.extensionsResource))??this.z:this.C.defaultProfile}};ae=Le([Ae(2,P.IUserDataProfilesService),Ae(3,p.IExtensionsProfileScannerService),Ae(4,T.IUriIdentityService),Ae(5,n.IFileService),Ae(6,i.ILogService)],ae);function ue(G,te){const W=(0,S.getExtensionId)(G.manifest.publisher,G.manifest.name);return{id:W,identifier:new O.ExtensionIdentifier(W),isBuiltin:G.type===0,isUserBuiltin:G.type===1&&G.isBuiltin,isUnderDevelopment:te,extensionLocation:G.location,uuid:G.identifier.uuid,targetPlatform:G.targetPlatform,...G.manifest}}e.toExtensionDescription=ue;class ge extends H{constructor(te,W,K,q,ie,re,de,$,V,N,k,U){super(te,W,(0,m.joinPath)(K,".vscode-oss-dev","extensions","control.json"),q,ie,re,de,$,V,N,k,U),this.N=(async()=>{if(E.translationsConfigFile)try{const X=await this.s.readFile(h.URI.file(E.translationsConfigFile));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(te){return this.N}}e.NativeExtensionsScannerService=ge}),define(pe[255],ve([1,0,50,14,39,6,2,13,7,23,12,32]),function(oe,e,w,L,o,C,D,A,v,d,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=e.ExtensionsLifecycle=class extends D.Disposable{constructor(g,b){super(),this.b=g,this.f=b,this.a=new L.Limiter(5)}async postUninstall(g){const b=this.g(g,"uninstall");b&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(s){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(s)}}));try{await d.Promises.rm(this.j(g))}catch(s){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(s)}}g(g,b){const s=`vscode:${b}`;if(g.location.scheme===A.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[s]=="string"){const h=g.manifest.scripts[s].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${s} should be a node script`),null):{script:(0,v.join)(g.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(g,b,s,h,u){return new Promise((f,S)=>{const O=this.i(g,b,s,u);let t;const n=r=>{t&&(clearTimeout(t),t=null),r?S(r):f(void 0)};O.on("error",r=>{n((0,o.toErrorMessage)(r)||"Unknown")}),O.on("exit",(r,i)=>{n(r?`post-${b} process exited with code ${r}`:void 0)}),h&&(t=setTimeout(()=>{t=null,O.kill(),S("timed out")},5e3))})}i(g,b,s,h){const u={silent:!0,execArgv:void 0},f=(0,w.fork)(g,[`--type=extension-post-${b}`,...s],u);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const S=C.Event.fromNodeEventEmitter(f.stdout,"data"),O=C.Event.fromNodeEventEmitter(f.stderr,"data");S(r=>this.f.info(h.identifier.id,h.manifest.version,`post-${b}`,r)),O(r=>this.f.error(h.identifier.id,h.manifest.version,`post-${b}`,r));const t=C.Event.any(C.Event.map(S,r=>({data:`%c${r}`,format:[""]})),C.Event.map(O,r=>({data:`%c${r}`,format:["color: red"]})));return C.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(h.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),f}j(g){return(0,v.join)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=E=Le([Ae(0,y.IUserDataProfilesService),Ae(1,R.ILogService)],E)}),define(pe[124],ve([1,0,12,32,35,31,45,16,25,4]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let R=e.ExtensionsProfileScannerService=class extends D.AbstractExtensionsProfileScannerService{constructor(E,m,g,b,s,h){super(d.URI.file(E.extensionsPath),m,g,b,s,h)}};e.ExtensionsProfileScannerService=R=Le([Ae(0,v.INativeEnvironmentService),Ae(1,A.IFileService),Ae(2,L.IUserDataProfilesService),Ae(3,o.IUriIdentityService),Ae(4,C.ITelemetryService),Ae(5,w.ILogService)],R)}),define(pe[256],ve([1,0,14,6,2,42,8,157,5,32]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var R;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var E;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(E||(e.StorageTarget=E={}));function m(u){const f=u.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=m;class g extends o.Disposable{constructor(f={flushInterval:g.a}){super(),this.j=f,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new w.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new o.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,w.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,o.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.J()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(f,S){if(S===e.TARGET_KEY){switch(f){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:S,target:this.F(f)[S]})}r(f){this.f.fire({reason:f})}get(f,S,O){return this.L(S)?.get(f,O)}getBoolean(f,S,O){return this.L(S)?.getBoolean(f,O)}getNumber(f,S,O){return this.L(S)?.getNumber(f,O)}store(f,S,O,t){if((0,D.isUndefinedOrNull)(S)){this.remove(f,O);return}this.t(()=>{this.u(f,O,t),this.L(O)?.set(f,S)})}remove(f,S){this.t(()=>{this.u(f,S,void 0),this.L(S)?.delete(f)})}t(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,S){const O=[],t=this.F(f);for(const n of Object.keys(t))t[n]===S&&O.push(n);return O}u(f,S,O){const t=this.F(S);typeof O=="number"?t[f]!==O&&(t[f]=O,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[f]=="number"&&(delete t[f],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(f){switch(f){case-1:return this.D;case 0:return this.z;default:return this.w}}G(f){const S=this.L(f);return S?m(S):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=R.NONE){this.f.fire({reason:f});const S=this.L(-1),O=this.L(0),t=this.L(1);switch(f){case R.NONE:await w.Promises.settled([S?.whenFlushed()??Promise.resolve(),O?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await w.Promises.settled([S?.flush(0)??Promise.resolve(),O?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,O=this.L(1)?.items??new Map;return h(f,S,O,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(f,S){return this.r(R.NONE),(0,d.isUserDataProfile)(f)?this.N(f,S):this.O(f,S)}H(f,S){return!(f.id===S.id||b(S)&&b(f))}I(f,S,O,t){this.t(()=>{if(t)for(const[n,r]of f)S.set(n,r);else{const n=new Set;for(const[r,i]of f)n.add(r),S.get(r)!==i&&this.n(O,r);for(const[r]of S.items)n.has(r)||this.n(O,r)}})}}e.AbstractStorageService=g,g.a=60*1e3;function b(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class s extends g{constructor(){super(),this.p=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(f=>this.n(1,f))),this.B(this.P.onDidChangeStorage(f=>this.n(0,f))),this.B(this.p.onDidChangeStorage(f=>this.n(-1,f)))}L(f){switch(f){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(f){return!1}}e.InMemoryStorageService=s;async function h(u,f,S,O,t,n){const r=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,a=new Map;u.forEach((F,H)=>{i.set(H,F),a.set(H,r(F))});const l=new Map,c=new Map;f.forEach((F,H)=>{l.set(H,F),c.set(H,r(F))});const p=new Map,P=new Map;S.forEach((F,H)=>{p.set(H,F),P.set(H,r(F))}),console.group(O!==t?`Storage: Application (path: ${O})`:`Storage: Application & Profile (path: ${O}, default profile)`);const T=[];if(i.forEach((F,H)=>{T.push({key:H,value:F})}),console.table(T),console.groupEnd(),console.log(a),O!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const F=[];l.forEach((H,ee)=>{F.push({key:ee,value:H})}),console.table(F),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${n})`);const I=[];p.forEach((F,H)=>{I.push({key:H,value:F})}),console.table(I),console.groupEnd(),console.log(P)}e.logStorage=h}),define(pe[125],ve([1,0,18,20,9,3,29,8,4,24,25,30,34,77,16,12,27,44,240,256,31]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const O=C.isWeb?"web":(0,y.getTargetPlatform)(C.platform,D.arch),t="X-Market-Search-Activity-Id";var n;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...N){return String(N.reduce((k,U)=>k|U,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class P{constructor(k=p){this.d=k}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(k,U=this.d.pageSize){return new P({...this.d,pageNumber:k,pageSize:U})}withFilter(k,...U){const X=[...this.d.criteria,...U.length?U.map(ne=>({filterType:k,value:ne})):[{filterType:k}]];return new P({...this.d,criteria:X})}withSortBy(k){return new P({...this.d,sortBy:k})}withSortOrder(k){return new P({...this.d,sortOrder:k})}withFlags(...k){return new P({...this.d,flags:k.reduce((U,X)=>U|X,0)})}withAssetTypes(...k){return new P({...this.d,assetTypes:k})}withSource(k){return new P({...this.d,source:k})}get raw(){const{criteria:k,pageNumber:U,pageSize:X,sortBy:ne,sortOrder:z,flags:j,assetTypes:Y}=this.d;return{filters:[{criteria:k,pageNumber:U,pageSize:X,sortBy:ne,sortOrder:z}],assetTypes:Y,flags:j}}get searchText(){const k=this.d.criteria.filter(U=>U.filterType===i.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(k=>String(k.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function T(N,k){const U=(N||[]).filter(X=>X.statisticName===k)[0];return U?U.value:0}function I(N){const k="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(X=>X.assetType.indexOf(k)===0).reduce((X,ne)=>{const z=ee(N,ne.assetType);return z&&X.push([ne.assetType.substring(k.length),z]),X},[])}function F(N){if(N.properties){const k=N.properties.filter(ne=>ne.key===a.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=k.filter(ne=>U.test(ne.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return ee(N,a.Repository)}function H(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ee(N,k){return N.files.filter(X=>X.assetType===k)[0]?{uri:`${N.assetUri}/${k}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${k}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function ce(N,k){const U=N.properties?N.properties.filter(ne=>ne.key===k):[],X=U.length>0&&U[0].value;return X?X.split(",").map(ne=>(0,E.adoptToGalleryExtensionId)(ne)):[]}function ae(N){const k=N.properties?N.properties.filter(U=>U.key===l.Engine):[];return k.length>0&&k[0].value||""}function ue(N){const k=N.properties?N.properties.filter(U=>U.key===l.PreRelease):[];return k.length>0&&k[0].value==="true"}function ge(N){const k=N.properties?N.properties.filter(X=>X.key===l.LocalizedLanguages):[],U=k.length>0&&k[0].value||"";return U?U.split(","):[]}function G(N){return N.properties?.find(k=>k.key===l.SponsorLink)?.value}function te(N){return N.indexOf("preview")!==-1}function W(N){return N.targetPlatform?(0,y.toTargetPlatform)(N.targetPlatform):"undefined"}function K(N){const k=(0,w.distinct)(N.versions.map(W)),U=!!N.tags?.includes(y.WEB_EXTENSION_TAG),X=k.indexOf("web");return U?X===-1&&k.push("web"):X!==-1&&k.splice(X,1),k}function q(N,k){const U=(0,y.getFallbackTargetPlarforms)(k);for(let X=0;X<N.length;X++){const ne=N[X];if(ne.version===N[X-1]?.version){let z=X;const j=W(ne);if(j===k)for(;z>0&&N[z-1].version===ne.version;)z--;else if(U.includes(j))for(;z>0&&N[z-1].version===ne.version&&W(N[z-1])!==k;)z--;z!==X&&(N.splice(X,1),N.splice(z,0,ne))}}return N}e.sortExtensionVersions=q;function ie(N,k,U){N.telemetryData={index:k,querySource:U,queryActivityId:N.queryContext?.[t]}}function re(N,k,U,X){const ne=N.versions[0],z={manifest:ee(k,a.Manifest),readme:ee(k,a.Details),changelog:ee(k,a.Changelog),license:ee(k,a.License),repository:F(k),download:H(k),icon:ee(k,a.Icon),signature:ee(k,a.Signature),coreTranslations:I(k)};return{identifier:{id:(0,E.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:k.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(ne),description:N.shortDescription||"",installCount:T(N.statistics,"install"),rating:T(N.statistics,"averagerating"),ratingCount:T(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:U,assets:z,properties:{dependencies:ce(k,l.Dependency),extensionPack:ce(k,l.ExtensionPack),engine:ae(k),localizedLanguages:ge(k),targetPlatform:W(k),isPreReleaseVersion:ue(k)},hasPreReleaseVersion:ue(ne),hasReleaseVersion:!0,preview:te(N.flags),isSigned:!!z.signature,queryContext:X}}let de=class{constructor(k,U,X,ne,z,j,Y,x){this.k=U,this.l=X,this.n=ne,this.o=z,this.q=j,this.u=Y,this.w=x;const Z=Y.extensionsGallery,J=Z?.servicePPEUrl&&x.getValue("_extensionsGallery.enablePPE");this.d=J?Z.servicePPEUrl:Z?.serviceUrl,this.g=J?void 0:Z?.searchUrl,this.h=Z?.controlUrl,this.j=(0,u.resolveMarketplaceHeaders)(Y.version,Y,this.n,this.w,this.q,k,this.o)}x(k=""){return`${this.d}${k}`}isEnabled(){return!!this.d}async getExtensions(k,U,X){const ne=L.CancellationToken.isCancellationToken(U)?{}:U,z=L.CancellationToken.isCancellationToken(U)?U:X,j=[],Y=[],x=[],Z=[];let J=!0;for(const Ee of k){Ee.uuid?Y.push(Ee.uuid):j.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);x.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&Z.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),J=J&&!!Ee.hasPreRelease&&!Ce}if(!Y.length&&!j.length)return[];let _=new P().withPage(1,k.length);Y.length&&(_=_.withFilter(i.ExtensionId,...Y)),j.length&&(_=_.withFilter(i.ExtensionName,...j)),(ne.queryAllVersions||J)&&(_=_.withFlags(_.flags,n.IncludeVersions)),ne.source&&(_=_.withSource(ne.source));const{extensions:le}=await this.z(_,{targetPlatform:ne.targetPlatform??O,includePreRelease:x,versions:Z,compatible:!!ne.compatible},z);return ne.source&&le.forEach((Ee,Ce)=>ie(Ee,Ce,ne.source)),le}async getCompatibleExtension(k,U,X){if((0,y.isNotWebExtensionInWebTargetPlatform)(k.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(k,U,X))return k;const ne=new P().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,k.identifier.uuid),{extensions:z}=await this.z(ne,{targetPlatform:X,compatible:!0,includePreRelease:U},L.CancellationToken.None);return z[0]||null}async isExtensionCompatible(k,U,X){if(!(0,y.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,X)||!U&&k.properties.isPreReleaseVersion)return!1;let ne=k.properties.engine;if(!ne){const z=await this.getManifest(k,L.CancellationToken.None);if(!z)throw new Error("Manifest was not found");ne=z.engines.vscode}return(0,m.isEngineValid)(ne,this.u.version,this.u.date)}async y(k,U,X,ne,z){if(!(0,y.isTargetPlatformCompatible)(W(k),ne,z)||U!=="any"&&ue(k)!==(U==="prerelease"))return!1;if(X)try{const j=await this.E(k);if(!(0,m.isEngineValid)(j,this.u.version,this.u.date))return!1}catch(j){return this.l.error(`Error while getting the engine for the version ${k.version}.`,(0,o.getErrorMessage)(j)),!1}return!0}async query(k,U){let X=k.text||"";const ne=k.pageSize??50;let z=new P().withPage(1,ne);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,_,le)=>(z=z.withFilter(i.Category,le||_),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,_,le)=>(z=z.withFilter(i.Tag,le||_),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(i.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),z=z.withFilter(i.SearchText,X)),z=z.withSortBy(0)):k.ids?z=z.withFilter(i.ExtensionId,...k.ids):k.names?z=z.withFilter(i.ExtensionName,...k.names):z=z.withSortBy(4),typeof k.sortBy=="number"&&(z=z.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(z=z.withSortOrder(k.sortOrder)),k.source&&(z=z.withSource(k.source));const j=async(J,_)=>{const{extensions:le,total:Ee}=await this.z(J,{targetPlatform:O,compatible:!1,includePreRelease:!!k.includePreRelease},_);return le.forEach((Ce,ke)=>ie(Ce,(J.pageNumber-1)*J.pageSize+ke,k.source)),{extensions:le,total:Ee}},{extensions:Y,total:x}=await j(z,U),Z=async(J,_)=>{if(_.isCancellationRequested)throw new o.CancellationError;const{extensions:le}=await j(z.withPage(J+1),_);return le};return{firstPage:Y,total:x,pageSize:z.pageSize,getPage:Z}}async z(k,U,X){const ne=k.flags;k.flags&n.IncludeLatestVersionOnly&&k.flags&n.IncludeVersions&&(k=k.withFlags(k.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(k.flags&n.IncludeLatestVersionOnly)&&!(k.flags&n.IncludeVersions)&&(k=k.withFlags(k.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(k=k.withFlags(k.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),k=k.withFlags(k.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:z,total:j,context:Y}=await this.B(k,X);if(!(k.flags&n.IncludeLatestVersionOnly)){const _=[];for(const le of z){const Ee=await this.A(le,U,Y);Ee&&_.push(Ee)}return{extensions:_,total:j}}const Z=[],J=new Map;for(let _=0;_<z.length;_++){const le=z[_],Ee={id:(0,E.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),uuid:le.extensionId},Ce=(0,A.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ue=>(0,E.areSameExtensions)(Ue,Ee))?.includePreRelease;if(U.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(K(le),U.targetPlatform))continue;const ke=await this.A(le,U,Y);!ke||ke.properties.isPreReleaseVersion&&(!Ce||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==U.targetPlatform&&ke.hasPreReleaseVersion?J.set(le.extensionId,_):Z.push([_,ke])}if(J.size){const _=new Date().getTime(),le=new P().withFlags(ne&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,J.size).withFilter(i.ExtensionId,...J.keys()),{extensions:Ee}=await this.z(le,U,X);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-_,count:J.size});for(const Ce of Ee){const ke=J.get(Ce.identifier.uuid);Z.push([ke,Ce])}}return{extensions:Z.sort((_,le)=>_[0]-le[0]).map(([,_])=>_),total:j}}async A(k,U,X){const ne={id:(0,E.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},z=U.versions?.find(Z=>(0,E.areSameExtensions)(Z,ne))?.version,j=(0,A.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Z=>(0,E.areSameExtensions)(Z,ne))?.includePreRelease,Y=K(k),x=q(k.versions,U.targetPlatform);if(U.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(Y,U.targetPlatform))return null;for(let Z=0;Z<x.length;Z++){const J=x[Z];if(!(z&&J.version!==z)){if(await this.y(J,j?"any":"release",U.compatible,Y,U.targetPlatform))return re(k,J,Y,X);if(z&&J.version===z)return null}}return z||U.compatible?null:re(k,k.versions[0],Y)}async B(k,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(n.Unpublished));const X=await this.j,ne=JSON.stringify(k.raw),z={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ne.length)},j=new Date().getTime();let Y,x,Z=0;try{if(Y=await this.k.request({type:"POST",url:this.g&&k.criteria.some(_=>_.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ne,headers:z},U),Y.res.statusCode&&Y.res.statusCode>=400&&Y.res.statusCode<500)return{galleryExtensions:[],total:Z};const J=await(0,h.asJson)(Y);if(J){const _=J.results[0],le=_.extensions,Ee=_.resultMetadata&&_.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return Z=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:Z,context:{[t]:Y.res.headers.activityid}}}return{galleryExtensions:[],total:Z}}catch(J){throw x=J,J}finally{this.o.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(ne.length),duration:new Date().getTime()-j,success:!!Y&&(0,h.isSuccess)(Y),responseBodySize:Y?.res.headers["Content-Length"],statusCode:Y?String(Y.res.statusCode):void 0,errorCode:x?(0,o.isCancellationError)(x)?"canceled":(0,o.getErrorMessage)(x).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)})}}async reportStatistic(k,U,X,ne){if(!this.isEnabled())return;const z=C.isWeb?this.x(`/itemName/${k}.${U}/version/${X}/statType/${ne==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${k}/extensions/${U}/${X}/stats?statType=${ne}`),j=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",x={...await this.j,Accept:j};try{await this.k.request({type:"POST",url:z,headers:x},L.CancellationToken.None)}catch{}}async download(k,U,X){this.l.trace("ExtensionGalleryService#download",k.identifier.id);const ne=(0,E.getGalleryExtensionTelemetryData)(k),z=new Date().getTime(),j=_=>this.o.publicLog("galleryService:downloadVSIX",{...ne,duration:_}),Y=X===2?"install":X===3?"update":"",x=Y?{uri:`${k.assets.download.uri}${v.URI.parse(k.assets.download.uri).query?"&":"?"}${Y}=true`,fallbackUri:`${k.assets.download.fallbackUri}${v.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${Y}=true`}:k.assets.download,Z=k.queryContext?.[t]?{[t]:k.queryContext[t]}:void 0,J=await this.D(x,Z?{headers:Z}:void 0);await this.q.writeFile(U,J.stream),j(new Date().getTime()-z)}async downloadSignatureArchive(k,U){if(!k.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",k.identifier.id);const X=await this.D(k.assets.signature);await this.q.writeFile(U,X.stream)}async getReadme(k,U){if(k.assets.readme){const X=await this.D(k.assets.readme,{},U);return await(0,h.asTextOrError)(X)||""}return""}async getManifest(k,U){if(k.assets.manifest){const X=await this.D(k.assets.manifest,{},U),ne=await(0,h.asTextOrError)(X);return ne?JSON.parse(ne):null}return null}async C(k,U){const X=ee(k,a.Manifest);if(!X)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},z=await this.D(X,{headers:ne});return await(0,h.asJson)(z)}async getCoreTranslation(k,U){const X=k.assets.coreTranslations.filter(ne=>ne[0]===U.toUpperCase())[0];if(X){const ne=await this.D(X[1]),z=await(0,h.asTextOrError)(ne);return z?JSON.parse(z):null}return null}async getChangelog(k,U){if(k.assets.changelog){const X=await this.D(k.assets.changelog,{},U);return await(0,h.asTextOrError)(X)||""}return""}async getAllCompatibleVersions(k,U,X){let ne=new P().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);k.identifier.uuid?ne=ne.withFilter(i.ExtensionId,k.identifier.uuid):ne=ne.withFilter(i.ExtensionName,k.identifier.id);const{galleryExtensions:z}=await this.B(ne,L.CancellationToken.None);if(!z.length)return[];const j=K(z[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(j,X))return[];const Y=[];await Promise.all(z[0].versions.map(async J=>{try{await this.y(J,U?"any":"release",!0,j,X)&&Y.push(J)}catch{}}));const x=[],Z=new Set;for(const J of q(Y,X))Z.has(J.version)||(Z.add(J.version),x.push({version:J.version,date:J.lastUpdated,isPreReleaseVersion:ue(J)}));return x}async D(k,U={},X=L.CancellationToken.None){const ne=await this.j,z={type:"GET"},j={...ne,...U.headers||{}};U={...U,...z,headers:j};const Y=k.uri,x=k.fallbackUri,Z={...U,url:Y};try{const J=await this.k.request(Z,X);if(J.res.statusCode===200)return J;const _=await(0,h.asTextOrError)(J);throw new Error(`Expected 200, got back ${J.res.statusCode} instead.

${_}`)}catch(J){if((0,o.isCancellationError)(J))throw J;const _=(0,o.getErrorMessage)(J);this.o.publicLog2("galleryService:cdnFallback",{url:Y,message:_});const le={...U,url:x};return this.k.request(le,X)}}async E(k){let U=ae(k);if(!U){const X=await this.C(k,L.CancellationToken.None);if(!X)throw new Error("Manifest was not found");U=X.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const k=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.asJson)(k),X=[],ne={};if(U){for(const z of U.malicious)X.push({id:z});if(U.migrateToPreRelease)for(const[z,j]of Object.entries(U.migrateToPreRelease))(!j.engine||(0,m.isEngineValid)(j.engine,this.u.version,this.u.date))&&(ne[z.toLowerCase()]={disallowInstall:!0,extension:{id:j.id,displayName:j.displayName,autoMigrate:{storage:!!j.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[z,j]of Object.entries(U.deprecated))j&&(ne[z.toLowerCase()]=(0,A.isBoolean)(j)?{}:j)}return{malicious:X,deprecated:ne}}};de=Le([Ae(1,h.IRequestService),Ae(2,b.ILogService),Ae(3,R.IEnvironmentService),Ae(4,S.ITelemetryService),Ae(5,g.IFileService),Ae(6,s.IProductService),Ae(7,d.IConfigurationService)],de);let $=e.ExtensionGalleryService=class extends de{constructor(k,U,X,ne,z,j,Y,x){super(k,U,X,ne,z,j,Y,x)}};e.ExtensionGalleryService=$=Le([Ae(0,f.IStorageService),Ae(1,h.IRequestService),Ae(2,b.ILogService),Ae(3,R.IEnvironmentService),Ae(4,S.ITelemetryService),Ae(5,g.IFileService),Ae(6,s.IProductService),Ae(7,d.IConfigurationService)],$);let V=e.ExtensionGalleryServiceWithNoStorageService=class extends de{constructor(k,U,X,ne,z,j,Y){super(void 0,k,U,X,ne,z,j,Y)}};e.ExtensionGalleryServiceWithNoStorageService=V=Le([Ae(0,h.IRequestService),Ae(1,b.ILogService),Ae(2,R.IEnvironmentService),Ae(3,S.ITelemetryService),Ae(4,g.IFileService),Ae(5,s.IProductService),Ae(6,d.IConfigurationService)],V)}),define(pe[257],ve([1,0,6,2,32,49]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class D{constructor(d,R){this.a=d,this.b=R}listen(d,R){const y=this.b(d);switch(R){case"onDidChangeProfiles":return w.Event.map(this.a.onDidChangeProfiles,E=>({all:E.all.map(m=>(0,C.transformOutgoingURIs)({...m},y)),added:E.added.map(m=>(0,C.transformOutgoingURIs)({...m},y)),removed:E.removed.map(m=>(0,C.transformOutgoingURIs)({...m},y)),updated:E.updated.map(m=>(0,C.transformOutgoingURIs)({...m},y))}))}throw new Error(`Invalid listen ${R}`)}async call(d,R,y){const E=this.b(d);switch(R){case"createProfile":{const m=await this.a.createProfile(y[0],y[1],y[2]);return(0,C.transformOutgoingURIs)({...m},E)}case"updateProfile":{let m=(0,o.reviveProfile)((0,C.transformIncomingURIs)(y[0],E),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,y[1]),(0,C.transformOutgoingURIs)({...m},E)}case"removeProfile":{const m=(0,o.reviveProfile)((0,C.transformIncomingURIs)(y[0],E),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${R}`)}}e.RemoteUserDataProfilesServiceChannel=D;class A extends L.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,R,y){super(),this.profilesHome=R,this.f=y,this.a=[],this.b=this.B(new w.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(E=>(0,o.reviveProfile)(E,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(E=>{const m=E.added.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme)),g=E.removed.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme)),b=E.updated.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme));this.a=E.all.map(s=>(0,o.reviveProfile)(s,this.profilesHome.scheme)),this.b.fire({added:m,removed:g,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,R,y){const E=await this.f.call("createNamedProfile",[d,R,y]);return(0,o.reviveProfile)(E,this.profilesHome.scheme)}async createProfile(d,R,y,E){const m=await this.f.call("createProfile",[d,R,y,E]);return(0,o.reviveProfile)(m,this.profilesHome.scheme)}async createTransientProfile(d){const R=await this.f.call("createTransientProfile",[d]);return(0,o.reviveProfile)(R,this.profilesHome.scheme)}async setProfileForWorkspace(d,R){await this.f.call("setProfileForWorkspace",[d,R])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,R){const y=await this.f.call("updateProfile",[d,R]);return(0,o.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=A}),define(pe[126],ve([1,0,4,25,16,12,234,35,32,8,235]),function(oe,e,w,L,o,C,D,A,v,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let y=e.UserDataProfilesReadonlyService=class Kt extends v.UserDataProfilesService{constructor(b,s,h,u,f){super(h,u,s,f),this.P=b,this.Q=h}J(){return this.P.getItem(Kt.b,[]).map(s=>({...s,location:(0,d.isString)(s.location)?this.s.extUri.joinPath(this.profilesHome,s.location):w.URI.revive(s.location)}))}M(){const b=this.P.getItem(Kt.c,{});return this.P.getItem(Kt.a,!1)?b:this.I(b)}O(){return this.s.extUri.joinPath(w.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=y=Le([Ae(0,D.IStateReadService),Ae(1,A.IUriIdentityService),Ae(2,L.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,C.ILogService)],y);let E=e.UserDataProfilesService=class Nt extends y{constructor(b,s,h,u,f){super(b,s,h,u,f),this.W=b}L(b){b.length?this.W.setItem(Nt.b,b.map(s=>({...s,location:this.s.extUri.basename(s.location)}))):this.W.removeItem(Nt.b)}J(){const b=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(b),this.W.setItem("userDataProfilesMigration",!0)),b}N(b){b.emptyWindows||b.workspaces?this.W.setItem(Nt.c,b):this.W.removeItem(Nt.c)}M(){const b="workspaceAndProfileInfo",s=this.W.getItem(b,void 0);if(s){this.W.removeItem(b);const u=s.reduce((f,{workspace:S,profile:O})=>(f[w.URI.revive(S).toString()]=w.URI.revive(O).toString(),f),{});this.W.setItem(Nt.c,{workspaces:u})}const h=super.M();return this.W.getItem(Nt.a,!1)||(this.N(h),this.W.setItem(Nt.a,!0)),h}};e.UserDataProfilesService=E=Le([Ae(0,D.IStateService),Ae(1,A.IUriIdentityService),Ae(2,L.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,C.ILogService)],E);let m=e.ServerUserDataProfilesService=class extends E{constructor(b,s,h,u){super(new R.StateService(0,s,u,h),b,s,h,u)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=m=Le([Ae(0,A.IUriIdentityService),Ae(1,L.INativeEnvironmentService),Ae(2,o.IFileService),Ae(3,C.ILogService)],m)}),define(pe[127],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,w.createDecorator)("extensionHostStatusService");class L{constructor(){this.a=new Map}setExitInfo(C,D){this.a.set(C,D)}getExitInfo(C){return this.a.get(C)||null}}e.ExtensionHostStatusService=L}),define(pe[258],ve([1,0,6,14]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function o(D){let A=0,v=0,d=0;D>=1e3&&(d=Math.floor(D/1e3),D-=d*1e3),d>=60&&(v=Math.floor(d/60),d-=v*60),v>=60&&(A=Math.floor(v/60),v-=A*60);const R=A?`${A}h`:"",y=v?`${v}m`:"",E=d?`${d}s`:"",m=D?`${D}ms`:"";return`${R}${y}${E}${m}`}class C{constructor(A,v,d,R){this.i=A,this.j=v,this.a=new w.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=d,this.protocol=R,this.e=!1,this.f=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${o(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${o(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${o(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(A){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${A}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${o(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end(),this.a.fire(void 0)}acceptReconnection(A,v,d){this.d=A,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,d),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(pe[88],ve([1,0,33,13,7,152,53]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const A=o.join(L.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function d(g){return new Promise(b=>w.exists(g,b))}function R(g,b){return d(A).then(s=>{if(!s||!D.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const h=`${g}||${b}`;let u=v.get(h);return u||(u=C.getNLSConfiguration(D.default.commit,b,A,g,g).then(f=>(y.is(f)&&(f._languagePackSupport=!0),f.locale!=="en"&&f.locale!=="en-us"&&Object.keys(f.availableLanguages).length===0&&v.delete(h),f)),v.set(h,u)),u})}e.getNLSConfiguration=R;var y;(function(g){function b(s){const h=s;return h&&typeof h._languagePackId=="string"}g.is=b})(y||(e.InternalNLSConfiguration=y={}));const E=async g=>{try{const b=m(await w.promises.readFile(g,"utf8"));return JSON.parse(b).locale}catch(b){return b.code!=="ENOENT"&&console.warn(b),"en"}};e.getLocaleFromConfig=E;const m=g=>{const b=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return g.replace(b,(s,h,u,f,S)=>{if(f)return"";if(S){const O=S.length;return O>2&&S[O-1]===`
`?S[O-2]==="\r"?`\r
`:`
`:""}else return s})}}),define(pe[128],ve([1,0,19,4,25,45,56,16,5,12,27,35,32,88]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=e.ExtensionsScannerService=class extends D.AbstractExtensionsScannerService{constructor(s,h,u,f,S,O,t,n){super(L.URI.file(S.builtinExtensionsPath),L.URI.file(S.extensionsPath),(0,w.joinPath)(S.userHome,".vscode-oss-dev","extensions","control.json"),s.defaultProfile,s,h,u,f,S,O,t,n),this.N=S}async f(s){const h=await(0,m.getNLSConfiguration)(s,this.N.userDataPath);if(m.InternalNLSConfiguration.is(h))try{const u=await this.s.readFile(L.URI.file(h._translationsConfigFile));return JSON.parse(u.value.toString())}catch{}return Object.create(null)}};e.ExtensionsScannerService=g=Le([Ae(0,E.IUserDataProfilesService),Ae(1,C.IExtensionsProfileScannerService),Ae(2,A.IFileService),Ae(3,d.ILogService),Ae(4,o.INativeEnvironmentService),Ae(5,R.IProductService),Ae(6,y.IUriIdentityService),Ae(7,v.IInstantiationService)],g)}),define(pe[259],ve([1,0,260,33,7,21,13,23]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var d;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(d||(e.ServerConnectionTokenType=d={}));class R{constructor(){this.type=0}validate(u){return!0}}e.NoneServerConnectionToken=R;class y{constructor(u){this.value=u,this.type=1}validate(u){return u===this.value}}e.OptionalServerConnectionToken=y;class E{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.MandatoryServerConnectionToken=E;class m{constructor(u){this.message=u}}e.ServerConnectionTokenParseError=m;async function g(h,u){const f=h["without-connection-token"],S=h["connection-token"],O=h["connection-token-file"],t=h.compatibility==="1.63";if(f)return typeof S<"u"||typeof O<"u"?new m("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new R;if(typeof O<"u"){if(typeof S<"u")return new m("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let n;try{n=L.readFileSync(O).toString().replace(/\r?\n$/,"")}catch{return new m(`Unable to read the connection token file at '${O}'.`)}return v.test(n)?new E(n):new m(`The connection token defined in '${O} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof S<"u"?v.test(S)?t?new y(S):new E(S):new m(`The connection token '${S} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new y(await u())):new E(await u())}e.parseServerConnectionToken=g;async function b(h){return g(h,async()=>{if(!h["user-data-dir"])return(0,C.generateUuid)();const f=o.join(h["user-data-dir"],"token");try{const t=(await A.Promises.readFile(f)).toString().replace(/\r?\n$/,"");if(v.test(t))return t}catch{}const S=(0,C.generateUuid)();try{await A.Promises.writeFile(f,S,{mode:384})}catch{}return S})}e.determineServerConnectionToken=b;function s(h,u,f){if(h.validate(f.query[D.connectionTokenQueryName]))return!0;const S=w.parse(u.headers.cookie||"");return h.validate(S[D.connectionTokenCookieName])}e.requestHasValidConnectionToken=s}),define(pe[41],ve([1,0,195,107,62,5,25]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:w.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:w.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:w.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:w.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:w.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:w.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:w.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:w.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:w.localize(8,null)},"user-data-dir":o.OPTIONS["user-data-dir"],"enable-smoke-test-driver":o.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":o.OPTIONS["disable-telemetry"],"disable-workspace-trust":o.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:o.OPTIONS.log,logsPath:o.OPTIONS.logsPath,"force-disable-user-env":o.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:w.localize(9,null)},"default-workspace":{type:"string",description:w.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":o.OPTIONS["extensions-dir"],"extensions-download-dir":o.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":o.OPTIONS["builtin-extensions-dir"],"install-extension":o.OPTIONS["install-extension"],"install-builtin-extension":o.OPTIONS["install-builtin-extension"],"uninstall-extension":o.OPTIONS["uninstall-extension"],"list-extensions":o.OPTIONS["list-extensions"],"locate-extension":o.OPTIONS["locate-extension"],"show-versions":o.OPTIONS["show-versions"],category:o.OPTIONS.category,force:o.OPTIONS.force,"do-not-sync":o.OPTIONS["do-not-sync"],"pre-release":o.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:w.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:o.OPTIONS.help,version:o.OPTIONS.version,"locate-shell-integration-path":o.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:o.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(D.IEnvironmentService);class A extends L.NativeEnvironmentService{get isRemoteServer(){return!0}get args(){return super.args}}e.ServerEnvironmentService=A}),define(pe[261],ve([1,0,78,12,41,27,220,21,18]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let d=e.CredentialsWebMainService=class extends D.BaseCredentialsMainService{constructor(y,E,m){super(y),this.p=E,this.r=m,this.p.args["github-auth"]&&this.t(this.p.args["github-auth"]).catch(g=>{this.h.error("Failed to store provided GitHub token",g)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new w.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((y,E)=>{oe(["keytar"],y,E)}),await this.f.findCredentials("test-keytar-loads")}catch(y){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${y.message??y}`),this.f=new w.InMemoryCredentialsProvider}return this.f}async t(y){const E="vscode.github-authentication",m=`${await this.getSecretStoragePrefix()}${E}`,g="github.auth",s=[["read:user","user:email","repo"]].map(f=>({id:(0,A.generateUuid)(),scopes:f.sort(),accessToken:y})),h=await this.getPassword(m,g);let u;if(h)try{const f=JSON.parse(h);f.content=JSON.parse(f.content),u=f}catch(f){this.h.error("Failed to parse existing GitHub credentials",f)}return u?.content&&(u.content=u.content.filter(f=>{const S=f.scopes.sort();return!s.find(O=>(0,v.equals)(S,O.scopes)&&O.account?.label===f.account?.label)})),this.setPassword(m,g,JSON.stringify({extensionId:E,...u||{},content:JSON.stringify([...s,...u?.content||[]])}))}};e.CredentialsWebMainService=d=Le([Ae(0,L.ILogService),Ae(1,o.IServerEnvironmentService),Ae(2,C.IProductService)],d)}),define(pe[262],ve([1,0,298,245,263,26]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class D extends w.AppInsightsCore{constructor(v){super(),this.a=v}track(v){const d=v.baseData||{};d.properties||(d.properties={}),d.measurements||(d.measurements={});try{const R=C.cpus();d.measurements.cores=R.length,d.properties["common.cpuModel"]=R[0].model}catch{}try{d.measurements.memoryFree=C.freemem(),d.measurements.memoryTotal=C.totalmem()}catch{}try{d.properties["common.shell"]=C.userInfo().shell,d.properties["common.release"]=C.release(),d.properties["common.arch"]=C.arch()}catch{}try{const R=(/^http:/.test(this.a)?o:L).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});R.on("error",()=>{}),R.write(JSON.stringify(d)),R.end()}catch{}}}e.TelemetryClient=D}),define(pe[264],ve([1,0,33,75,83,260,85,38,57,3,12,41,7,13,21,27,44,20,4,15,8,88,55]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(F,H,ee,ce){H.writeHead(ee,{"Content-Type":"text/plain"}),H.end(ce)}e.serveError=r;var i;(function(F){F[F.NO_CACHING=0]="NO_CACHING",F[F.ETAG=1]="ETAG",F[F.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function a(F,H,ee,ce,ae,ue){try{const ge=await w.promises.stat(F);if(H===1){const G=`W/"${[ge.ino,ge.size,ge.mtime.getTime()].join("-")}"`;if(ce.headers["if-none-match"]===G)return ae.writeHead(304),void ae.end();ue.Etag=G}else H===2?ue["Cache-Control"]="public, max-age=31536000":H===0&&(ue["Cache-Control"]="no-store");ue["Content-Type"]=n[(0,E.extname)(F)]||(0,v.getMediaMime)(F)||"text/plain",ae.writeHead(200,ue),(0,w.createReadStream)(F).pipe(ae)}catch(ge){return ge.code!=="ENOENT"?(ee.error(ge),console.error(ge.toString())):console.error(`File not found: ${F}`),ae.writeHead(404,{"Content-Type":"text/plain"}),void ae.end("Not found")}}e.serveFile=a;const l=(0,E.dirname)(m.FileAccess.asFileUri("").fsPath);let c=e.WebClientServer=class{constructor(H,ee,ce,ae,ue){this.f=H,this.g=ee,this.h=ce,this.i=ae,this.j=ue,this.a=this.j.extensionsGallery?.resourceUrlTemplate?u.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const ge=(0,t.getRemoteServerRootPath)(ue);this.b=`${ge}/static`,this.c=`${ge}/callback`,this.d="/web-extension-resource"}async handle(H,ee,ce){try{const ae=ce.pathname;return ae.startsWith(this.b)&&ae.charCodeAt(this.b.length)===47?this.k(H,ee,ce):ae==="/"?this.n(H,ee,ce):ae===this.c?this.p(ee):ae.startsWith(this.d)&&ae.charCodeAt(this.d.length)===47?this.m(H,ee,ce):r(H,ee,404,"Not found.")}catch(ae){return this.h.error(ae),console.error(ae.toString()),r(H,ee,500,"Internal Server Error.")}}async k(H,ee,ce){const ae=Object.create(null),ge=decodeURIComponent(ce.pathname).substring(this.b.length+1),G=(0,E.join)(l,ge);return(0,A.isEqualOrParent)(G,l,!d.isLinux)?a(G,this.g.isBuilt?2:1,this.h,H,ee,ae):r(H,ee,400,"Bad request.")}l(H){const ee=H.authority.indexOf(".");return ee!==-1?H.authority.substring(ee+1):void 0}async m(H,ee,ce){if(!this.a)return r(H,ee,500,"No extension gallery service configured.");const ae=decodeURIComponent(ce.pathname),ue=(0,E.normalize)(ae.substring(this.d.length+1)),ge=u.URI.parse(ue).with({scheme:this.a.scheme,authority:ue.substring(0,ue.indexOf("/")),path:ue.substring(ue.indexOf("/")+1)});if(this.l(this.a)!==this.l(ge))return r(H,ee,403,"Request Forbidden");const G={},te=de=>{const $=H.headers[de];$&&((0,S.isString)($)||$[0])?G[de]=(0,S.isString)($)?$:$[0]:de!==de.toLowerCase()&&te(de.toLowerCase())};te("X-Client-Name"),te("X-Client-Version"),te("X-Machine-Id"),te("X-Client-Commit");const W=await this.i.request({type:"GET",url:ge.toString(!0),headers:G},h.CancellationToken.None),K=W.res.statusCode||500;if(K!==200){let de=null;try{de=await(0,s.asTextOrError)(W)}catch{}return r(H,ee,K,de||`Request failed with status ${K}`)}const q=Object.create(null),ie=de=>{const $=W.res.headers[de];$?q[de]=$:de!==de.toLowerCase()&&ie(de.toLowerCase())};ie("Cache-Control"),ie("Content-Type"),ee.writeHead(200,q);const re=await(0,f.streamToBuffer)(W.stream);return void ee.end(re.buffer)}async n(H,ee,ce){const ae=ce.query[m.connectionTokenQueryName];if(typeof ae=="string"){const z=Object.create(null);z["Set-Cookie"]=C.serialize(m.connectionTokenCookieName,ae,{sameSite:"lax",maxAge:60*60*24*7});const j=Object.create(null);for(const x in ce.query)x!==m.connectionTokenQueryName&&(j[x]=ce.query[x]);const Y=o.format({pathname:"/",query:j});return z.Location=Y,ee.writeHead(302,z),void ee.end()}const ue="remote";if(!ue)return r(H,ee,400,"Bad request.");function ge(z){return JSON.stringify(z).replace(/"/g,"&quot;")}let G;this.g.args["enable-smoke-test-driver"]&&(G=!1);const te=z=>z&&u.URI.file(L.resolve(z)).with({scheme:m.Schemas.vscodeRemote,authority:ue}),W=m.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,K=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,g.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,q=(0,e.relativeRoot)((0,e.getOriginalUrl)(H)),ie=(0,e.relativePath)((0,e.getOriginalUrl)(H)),re={codeServerVersion:this.j.codeServerVersion,rootEndpoint:q,updateEndpoint:this.g.args["disable-update-check"]?void 0:q+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?q+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??q+"/proxy/{{port}}/",serviceWorker:{scope:ie+"/",path:q+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const z=JSON.parse((await w.promises.readFile((0,E.join)(l,"product.overrides.json"))).toString());Object.assign(re,z)}catch{}const de={remoteAuthority:ue,webviewEndpoint:ie+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:G,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:te(this.g.args["default-folder"]),workspaceUri:te(this.g.args["default-workspace"]),productConfiguration:re,callbackRoute:this.c},$=this.g.args.locale||await(0,O.getLocaleFromConfig)(this.g.argvResource.fsPath),V=await(0,O.getNLSConfiguration)($,this.g.userDataPath),N=this.j.extensionsGallery?.nlsBaseUrl,k={WORKBENCH_WEB_CONFIGURATION:ge(de),WORKBENCH_AUTH_SESSION:K?ge(K):"",WORKBENCH_WEB_BASE_URL:ie+this.b,WORKBENCH_NLS_BASE_URL:ie+(N?`${N}${N.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:q,VS_BASE:ie,NLS_CONFIGURATION:ge(V)};let U;try{U=(await w.promises.readFile(W)).toString().replace(/\{\{([^}]+)\}\}/g,(j,Y)=>k[Y]??"undefined")}catch{return ee.writeHead(404,{"Content-Type":"text/plain"}),void ee.end("Not found")}const ne={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(U).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(ne["Set-Cookie"]=C.serialize(m.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),ee.writeHead(200,ne),void ee.end(U)}o(H){const ee=/<script>([\s\S]+?)<\/script>/img,ce=[];let ae;for(;ae=ee.exec(H);){const ue=D.createHash("sha256"),ge=ae[1].replace(/\r\n/g,`
`),G=ue.update(Buffer.from(ge)).digest().toString("base64");ce.push(`'sha256-${G}'`)}return ce}async p(H){const ee=m.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,ce=(await w.promises.readFile(ee)).toString(),ae=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(ce).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return H.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ae}),void H.end(ce)}};e.WebClientServer=c=Le([Ae(1,y.IServerEnvironmentService),Ae(2,R.ILogService),Ae(3,s.IRequestService),Ae(4,b.IProductService)],c);const p=(F,H=!1)=>F.replace(/\/\/+/g,"/").replace(/\/+$/,H?"/":"");e.normalizeUrlPath=p;const P=F=>{const H=(F.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(H>1?"../".repeat(H-1):""))};e.relativeRoot=P;const T=F=>{const H=F.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+H[H.length-1])};e.relativePath=T;const I=F=>F.originalUrl||F.url;e.getOriginalUrl=I}),define(pe[265],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(pe[266],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L}),define(pe[68],ve([1,0,49]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(C){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:C,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function o(C){return new w.URITransformer(L(C))}e.createURITransformer=o}),define(pe[267],ve([1,0,3,42,4,68,49,102,238,7,19]),function(oe,e,w,L,o,C,D,A,v,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class y{constructor(m,g,b,s){this.b=m,this.c=g,this.d=b,this.e=s}async call(m,g,b){switch(g){case"getEnvironmentData":{const s=b,h=(0,C.createURITransformer)(s.remoteAuthority);let u=await this.f(s.profile);return u=(0,D.transformOutgoingURIs)(u,h),u}case"getExtensionHostExitInfo":{const s=b;return this.e.getExitInfo(s.reconnectionToken)}case"getDiagnosticInfo":{const s=b,h={machineInfo:(0,v.getMachineInfo)()},u=s.includeProcesses?(0,A.listProcesses)(process.pid):Promise.resolve();let f=[];const S={};if(s.folders){const O=(0,C.createURITransformer)("");f=s.folders.map(n=>o.URI.revive(O.transformIncoming(n))).filter(n=>n.scheme==="file").map(n=>(0,v.collectWorkspaceStats)(n.fsPath,["node_modules",".git"]).then(r=>{S[(0,d.basename)(n.fsPath)]=r}))}return Promise.all([u,...f]).then(([O,t])=>(h.processes=O||void 0,h.workspaceMetadata=s.folders?S:void 0,h))}}throw new Error(`IPC Command ${g} not found`)}listen(m,g,b){throw new Error("Not supported")}async f(m){return m&&!this.d.profiles.some(g=>g.id===m)&&await this.d.createProfile(m,m),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:o.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,R.joinPath)(this.c.logsHome,`exthost${y.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:w.OS,arch:process.arch,marks:L.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.RemoteAgentEnvironmentChannel=y,y.a=1}),define(pe[268],ve([1,0,4,68,66,7,223]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class A extends D.AbstractDiskFileSystemProviderChannel{constructor(R,y){super(new o.DiskFileSystemProvider(R),R),this.H=y,this.G=new Map,this.B(this.a)}c(R){let y=this.G.get(R.remoteAuthority);return y||(y=(0,L.createURITransformer)(R.remoteAuthority),this.G.set(R.remoteAuthority,y)),y}f(R,y,E=!1){if(E&&y.path==="/vscode-resource"&&y.query){const m=JSON.parse(y.query).requestResourcePath;return w.URI.from({scheme:"file",path:m})}return w.URI.revive(R.transformIncoming(y))}F(R,y){return new v(R,y,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=A;class v extends D.AbstractSessionFileWatcher{constructor(R,y,E,m){super(R,y,E,m)}i(R){const y=R.args["file-watcher-polling"];if(y){const E=y.split(C.delimiter),m=Number(E[0]);if(m>0)return{usePolling:E.length>1?E.slice(1):!0,pollingInterval:m}}}j(R){if(R.extensionsPath)return[C.posix.join(R.extensionsPath,"**")]}}}),define(pe[89],ve([1,0,198,8,4,2,5,40,16,13,39,161,59]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var m;(function($){$[$.PROGRAMMATIC=1]="PROGRAMMATIC",$[$.USER=2]="USER",$[$.EDIT=3]="EDIT",$[$.NAVIGATION=4]="NAVIGATION",$[$.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var g;(function($){$[$.IDENTICAL=1]="IDENTICAL",$[$.SIMILAR=2]="SIMILAR",$[$.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function b($){const V=$;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=b;function s($,V,N){for(const k of N.visibleEditorPanes)if(k.group.id===V&&$.matches(k.input))return k.getViewState()}e.findViewStateForEditor=s;function h($){if(p($))return!1;const V=$;return o.URI.isUri(V?.resource)}e.isResourceEditorInput=h;function u($){if(p($))return!1;const V=$;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=u;function f($){if(p($)||u($))return!1;const V=$;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function S($){if(p($))return!1;const V=$;return V?V.resource===void 0||V.resource.scheme===d.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;const O=/Untitled-\d+/;function t($){return $.scheme===d.Schemas.untitled&&$.path.length>1&&!O.test($.path)}e.isUntitledWithAssociatedResource=t;function n($){if(p($))return!1;const V=$;return o.URI.isUri(V?.base?.resource)&&o.URI.isUri(V?.input1?.resource)&&o.URI.isUri(V?.input2?.resource)&&o.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=n;var r;(function($){$[$.SHORT=0]="SHORT",$[$.MEDIUM=1]="MEDIUM",$[$.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var i;(function($){$[$.EXPLICIT=1]="EXPLICIT",$[$.AUTO=2]="AUTO",$[$.FOCUS_CHANGE=3]="FOCUS_CHANGE",$[$.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class a{constructor(){this.a=new Map}registerSource(V,N){let k=this.a.get(V);return k||(k={source:V,label:N},this.a.set(V,k)),k.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.SaveSourceRegistry=new a;var l;(function($){$[$.None=0]="None",$[$.Readonly=2]="Readonly",$[$.Untitled=4]="Untitled",$[$.Singleton=8]="Singleton",$[$.RequiresTrust=16]="RequiresTrust",$[$.CanSplitInGroup=32]="CanSplitInGroup",$[$.ForceDescription=64]="ForceDescription",$[$.CanDropIntoEditor=128]="CanDropIntoEditor",$[$.MultipleEditors=256]="MultipleEditors"})(l||(e.EditorInputCapabilities=l={}));class c extends C.Disposable{}e.AbstractEditorInput=c;function p($){return $ instanceof c}e.isEditorInput=p;function P($){const V=$;return o.URI.isUri(V?.preferredResource)}function T($){const V=$;return p(V?.primary)&&p(V?.secondary)}e.isSideBySideEditorInput=T;function I($){const V=$;return p(V?.modified)&&p(V?.original)}e.isDiffEditorInput=I;function F($,V,N,k,U){return de(k,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const X={...N,limits:{size:Number.MAX_VALUE}};$.openEditor(V,X)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>U.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:E.default.Warning})}e.createTooLargeFileError=F;function H($){return p($?.editor)}e.isEditorInputWithOptions=H;function ee($){const V=$;return H($)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=ee;function ce($){const V=$;return typeof V?.groupId=="number"&&p(V.editor)}e.isEditorIdentifier=ce;var ae;(function($){$[$.UNKNOWN=0]="UNKNOWN",$[$.REPLACE=1]="REPLACE",$[$.MOVE=2]="MOVE",$[$.UNPIN=3]="UNPIN"})(ae||(e.EditorCloseContext=ae={}));var ue;(function($){$[$.GROUP_ACTIVE=0]="GROUP_ACTIVE",$[$.GROUP_INDEX=1]="GROUP_INDEX",$[$.GROUP_LOCKED=2]="GROUP_LOCKED",$[$.EDITOR_OPEN=3]="EDITOR_OPEN",$[$.EDITOR_CLOSE=4]="EDITOR_CLOSE",$[$.EDITOR_MOVE=5]="EDITOR_MOVE",$[$.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",$[$.EDITOR_LABEL=7]="EDITOR_LABEL",$[$.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",$[$.EDITOR_PIN=9]="EDITOR_PIN",$[$.EDITOR_STICKY=10]="EDITOR_STICKY",$[$.EDITOR_DIRTY=11]="EDITOR_DIRTY",$[$.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(ue||(e.GroupModelChangeKind=ue={}));var ge;(function($){$[$.PRIMARY=1]="PRIMARY",$[$.SECONDARY=2]="SECONDARY",$[$.BOTH=3]="BOTH",$[$.ANY=4]="ANY"})(ge||(e.SideBySideEditor=ge={}));class G{getOriginalUri(V,N){if(!V)return;if(n(V))return e.EditorResourceAccessor.getOriginalUri(V.result,N);if(N?.supportSideBySide){const{primary:U,secondary:X}=this.a(V);if(U&&X){if(N?.supportSideBySide===ge.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(X,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===ge.ANY)return this.getOriginalUri(U,{filterByScheme:N.filterByScheme})??this.getOriginalUri(X,{filterByScheme:N.filterByScheme});V=N.supportSideBySide===ge.PRIMARY?U:X}}if(u(V)||f(V)||n(V))return;const k=P(V)?V.preferredResource:V.resource;return!k||!N||!N.filterByScheme?k:this.b(k,N.filterByScheme)}a(V){return T(V)||f(V)?{primary:V.primary,secondary:V.secondary}:I(V)||u(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,N){if(!V)return;if(n(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,N);if(N?.supportSideBySide){const{primary:U,secondary:X}=this.a(V);if(U&&X){if(N?.supportSideBySide===ge.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(X,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===ge.ANY)return this.getCanonicalUri(U,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(X,{filterByScheme:N.filterByScheme});V=N.supportSideBySide===ge.PRIMARY?U:X}}if(u(V)||f(V)||n(V))return;const k=V.resource;return!k||!N||!N.filterByScheme?k:this.b(k,N.filterByScheme)}b(V,N){if(Array.isArray(N)){if(N.some(k=>V.scheme===k))return V}else if(N===V.scheme)return V}}e.EditorResourceAccessor=new G;var te;(function($){$[$.LEFT=0]="LEFT",$[$.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class W{constructor(){this.c=new Map,this.d=new Map}start(V){const N=this.a=V.get(D.IInstantiationService);for(const[k,U]of this.c)this.e(k,U,N);this.c.clear()}e(V,N,k){const U=k.createInstance(N);this.d.set(V,U)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,L.assertIsDefined)(this.b)}registerEditorSerializer(V,N){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,N,this.a):this.c.set(V,N),(0,C.toDisposable)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new W);async function K($,V,N){return!$||!$.length?[]:await Promise.all($.map(async k=>{const U=o.URI.revive(k.fileUri);if(!U){N.info("Cannot resolve the path because it is not valid.",k);return}if(!await V.canHandleResource(U)){N.info("Cannot resolve the path because it cannot be handled",k);return}let ne=k.exists,z=k.type;if(typeof ne!="boolean"||typeof z!="number")try{z=(await V.stat(U)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ne=!0}catch(Y){N.error(Y),ne=!1}if(!ne&&k.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",k);return}if(z===v.FileType.Directory){N.info("Cannot resolve the path because it is a directory",k);return}const j={...k.options,pinned:!0};return ne?{resource:U,options:j}:{resource:U,options:j,forceUntitled:!0}}))}e.pathsToEditors=K;var q;(function($){$[$.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",$[$.SEQUENTIAL=1]="SEQUENTIAL"})(q||(e.EditorsOrder=q={}));function ie($){const V=$;if(!V)return!1;const N=V;if(N.modified)return ie(N.modified);const k=V;return!!(k.contributionsState&&k.viewState&&Array.isArray(k.cursorState))}e.isTextEditorViewState=ie;function re($){return(0,R.isErrorWithActions)($)}e.isEditorOpenError=re;function de($,V,N){const k=(0,R.createErrorWithActions)($,V);return k.forceMessage=N?.forceMessage,k.forceSeverity=N?.forceSeverity,k.allowDialog=N?.allowDialog,k}e.createEditorOpenError=de}),define(pe[129],ve([1,0,15,74,46,57,13,7,3,64]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",C.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(y||(e.NotebookRunState=y={}));var E;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var m;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var g;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var b;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var s;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var h;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var u;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var f;(function(G){G.scheme=D.Schemas.vscodeNotebookCell;const te=["W","X","Y","Z","a","b","c","d","e","f"],W=new RegExp(`^[${te.join("")}]+`),K=7;function q(N,k){const U=k.toString(K),ne=`${U.length<te.length?te[U.length-1]:"z"}${U}s${(0,w.encodeBase64)(w.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:G.scheme,fragment:ne})}G.generate=q;function ie(N){if(N.scheme!==G.scheme)return;const k=N.fragment.indexOf("s");if(k<0)return;const U=parseInt(N.fragment.substring(0,k).replace(W,""),K),X=(0,w.decodeBase64)(N.fragment.substring(k+1)).toString();if(!isNaN(U))return{handle:U,notebook:N.with({scheme:X,fragment:null})}}G.parse=ie;function re(N,k){return N.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${k??""},${N.scheme!==D.Schemas.file?N.scheme:""}`})}G.generateCellOutputUri=re;function de(N){if(N.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const k=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!k)return;const U=k[1]&&k[1]!==""?k[1]:void 0,X=k[2];return{outputId:U,notebook:N.with({scheme:X||D.Schemas.file,fragment:null})}}G.parseCellOutputUri=de;function $(N,k,U){return G.generate(N,k).with({scheme:U})}G.generateCellPropertyUri=$;function V(N,k){if(N.scheme===k)return G.parse(N.with({scheme:G.scheme}))}G.parseCellPropertyUri=V})(f||(e.CellUri=f={}));const S=G=>v.isWindows?G.replace(/\//g,"\\"):G;class O{constructor(te=[],W=e.NOTEBOOK_DISPLAY_ORDER){this.e=W,this.d=[...new Set(te)].map(K=>({pattern:K,matches:L.parse(S(K))}))}sort(te){const W=new Map(o.Iterable.map(te,q=>[q,S(q)]));let K=[];for(const{matches:q}of this.d)for(const[ie,re]of W)if(q(re)){K.push(ie),W.delete(ie);break}return W.size&&(K=K.concat([...W.keys()].sort((q,ie)=>this.e.indexOf(q)-this.e.indexOf(ie)))),K}prioritize(te,W){const K=this.f(te);if(K===-1){this.d.unshift({pattern:te,matches:L.parse(S(te))});return}const q=new Set(W.map(re=>this.f(re,K)));q.delete(-1);const ie=Array.from(q).sort();this.d.splice(K+1,0,...ie.map(re=>this.d[re]));for(let re=ie.length-1;re>=0;re--)this.d.splice(ie[re],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,W=this.d.length){const K=S(te);for(let q=0;q<W;q++)if(this.d[q].matches(K))return q;return-1}}e.MimeTypeDisplayOrder=O;function t(G,te,W,K=(q,ie)=>q===ie){const q=[];function ie($,V,N){if(V===0&&N.length===0)return;const k=q[q.length-1];k&&k.start+k.deleteCount===$?(k.deleteCount+=V,k.toInsert.push(...N)):q.push({start:$,deleteCount:V,toInsert:N})}let re=0,de=0;for(;;){if(re===G.length){ie(re,0,te.slice(de));break}if(de===te.length){ie(re,G.length-re,[]);break}const $=G[re],V=te[de];if(K($,V)){re+=1,de+=1;continue}W(V)?(ie(re,1,[]),re+=1):(ie(re,0,[V]),de+=1)}return q}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new d.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(G){G.default="default",G.option="option"})(n||(e.NotebookEditorPriority=n={}));function r(G){const te=G;return!!((typeof te.include=="string"||L.isRelativePattern(te.include))&&(typeof te.exclude=="string"||L.isRelativePattern(te.exclude)))}e.isDocumentExcludePattern=r;function i(G,te,W){if(Array.isArray(G.viewType)&&G.viewType.indexOf(te)>=0||G.viewType===te)return!0;if(G.filenamePattern){const K=r(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,q=r(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(L.match(K,(0,A.basename)(W.fsPath).toLowerCase()))return!(q&&L.match(q,(0,A.basename)(W.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",codeActionsOnSave:"notebook.experimental.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var a;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static create(te){return`${l.d}${te}`}static parse(te){if(te.startsWith(l.d))return te.substring(l.d.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l.d="notebook/";function c(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}e.isTextStreamMime=c;const p=new TextDecoder;function P(G){const te=[];let W=!1;for(const K of G)(te.length===0||W)&&(te.push(K),W=!0);return H(te),ge(w.VSBuffer.concat(te.map(K=>w.VSBuffer.wrap(K))))}e.compressOutputItemStreams=P;const T=`${String.fromCharCode(27)}[A`,I=T.split("").map(G=>G.charCodeAt(0)),F=10;function H(G){G.forEach((te,W)=>{if(W===0||te.length<T.length)return;const K=G[W-1],q=te.subarray(0,T.length);if(q[0]===I[0]&&q[1]===I[1]&&q[2]===I[2]){const ie=K.lastIndexOf(F);if(ie===-1)return;G[W-1]=K.subarray(0,ie),G[W]=te.subarray(T.length)}})}function ee(G){let te=G;do G=te,te=G.replace(/[^\n]\x08/gm,"");while(te.length<G.length);return G}function ce(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const te=G.match(/^(.*)\r+/m)[1];let W=G.match(/\r+(.*)$/m)[1];W=W+te.slice(W.length,te.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return G}const ae="\b".charCodeAt(0),ue="\r".charCodeAt(0);function ge(G){return!G.buffer.includes(ae)&&!G.buffer.includes(ue)?G:w.VSBuffer.fromString(ce(ee(p.decode(G.buffer))))}}),define(pe[269],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,w.createDecorator)("environmentVariableService")}),define(pe[270],ve([1,0,7,58,3,248,8]),function(oe,e,w,L,o,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(t,n){if(n)if(o.isWindows)for(const r in n){let i=r;for(const l in t)if(r.toLowerCase()===l.toLowerCase()){i=l;break}const a=n[r];a!==void 0&&v(t,i,a)}else Object.keys(n).forEach(r=>{const i=n[r];i!==void 0&&v(t,r,i)})}e.mergeEnvironments=A;function v(t,n,r){typeof r=="string"?t[n]=r:delete t[n]}function d(t,n,r,i){t.TERM_PROGRAM="vscode",n&&(t.TERM_PROGRAM_VERSION=n),E(t,i)&&(t.LANG=m(r)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=d;function R(t,n){if(n)for(const r of Object.keys(n)){const i=n[r];i!=null&&(t[r]=i)}}async function y(t,n){return await Promise.all(Object.entries(n).map(async([r,i])=>{if(typeof i=="string")try{n[r]=await t(i)}catch{n[r]=i}})),n}function E(t,n){if(n==="on")return!0;if(n==="auto"){const r=t.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=E;function m(t){const n=t?t.split("-"):[],r=n.length;if(r===0)return"en_US.UTF-8";if(r===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in i&&n.push(i[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.getLangEnvVariable=m;async function g(t,n,r,i,a,l){if(t.cwd){const p=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,P=await b(p,r);return(0,C.sanitizeCwd)(P||p)}let c;return!t.ignoreConfigurationCwd&&a&&(r&&(a=await b(a,r,l)),a&&(w.isAbsolute(a)?c=a:i&&(c=w.join(i.fsPath,a)))),c||(c=i?i.fsPath:n||""),(0,C.sanitizeCwd)(c)}e.getCwd=g;async function b(t,n,r){if(n)try{return await n(t)}catch(i){r?.error("Could not resolve terminal cwd",i);return}return t}function s(t,n,r){if(r)return i=>r.resolveWithEnvironment(n,t,i)}e.createVariableResolver=s;async function h(t,n,r,i,a,l,c,p=o.platform){let P;c&&(P=f(t,"automationShell",p)),P||(P=f(t,"shell",p));let T=P||n;if(p===3&&!r&&i){const I=w.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();T&&T.toLowerCase().indexOf(I)===0&&(T=w.join(i,"System32",T.substr(I.length+1)))}if(T&&p===3&&(T=T.replace(/\//g,"\\")),a)try{T=await a(T)}catch(I){l.error("Could not resolve shell",I)}return T}e.getDefaultShell=h;async function u(t,n,r,i,a=o.platform){if(n&&f(t,"automationShell",a))return[];const l=a===3?"windows":a===1?"osx":"linux";let c=t(`terminal.integrated.shellArgs.${l}`);if(!c)return[];if(typeof c=="string"&&a===3)return r?await r(c):c;if(r){const p=[];for(const P of c)try{p.push(await r(P))}catch(T){i.error(`Could not resolve terminal.integrated.shellArgs.${l}`,T),p.push(P)}c=p}return c}e.getDefaultShellArgs=u;function f(t,n,r=o.platform){return t(`terminal.integrated.${n}.${r===3?"windows":r===1?"osx":"linux"}`)}async function S(t,n,r,i,a,l){const c={};if(t.strictEnv)R(c,t.env);else{R(c,l);const p={...n};r&&(p&&await y(r,p),t.env&&await y(r,t.env)),(0,L.sanitizeProcessEnvironment)(c,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),A(c,p),A(c,t.env),d(c,i,o.language,a)}return c}e.createTerminalEnvironment=S;async function O(t,n,r,i,a,l,c=o.isWindows){let p;if((0,D.isString)(t)?p=t:(p=t.fsPath,c&&l!==1?p=p.replace(/\\/g,"/"):!c&&l===1&&(p=p.replace(/\//g,"\\"))),!n)return p;const P=p.includes(" "),T=p.includes("(")||p.includes(")"),I=w.basename(n,".exe"),F=I==="pwsh"||r==="pwsh"||I==="powershell"||r==="powershell";if(F&&(P||p.includes("'")))return`& '${p.replace(/'/g,"''")}'`;if(T&&F)return`& '${p}'`;if(l===1){if(i!==void 0)return i==="gitbash"?(0,C.escapeNonWindowsPath)(p.replace(/\\/g,"/")):i==="wsl"?a?.getWslPath(p,"win-to-unix")||p:P?`"${p}"`:p;const H=n.toLowerCase();return H.includes("wsl")||H.includes("bash.exe")&&!H.toLowerCase().includes("git")?a?.getWslPath(p,"win-to-unix")||p:P?`"${p}"`:p}return(0,C.escapeNonWindowsPath)(p)}e.preparePathForShell=O}),define(pe[69],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(C){C.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class o{static fromExtHostTestItem(D,A,v=D.parent){if(D._isRoot)return new o([A]);const d=[D.id];for(let R=v;R&&R.id!==A;R=R.parent)d.push(R.id);return d.push(A),new o(d.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const A=D.indexOf("\0");return A===-1?D:D.slice(0,A)}static fromString(D){return new o(D.split("\0"))}static join(D,A){return new o([...D.path,A])}static joinToString(D,A){return D.toString()+"\0"+A}static parentId(D){const A=D.lastIndexOf("\0");return A===-1?void 0:D.slice(0,A)}static localId(D){const A=D.lastIndexOf("\0");return A===-1?D:D.slice(A+1)}static isChild(D,A){return A.startsWith(D)&&A[D.length]==="\0"}static compare(D,A){return D===A?0:o.isChild(D,A)?2:o.isChild(A,D)?3:1}constructor(D,A=D.length){if(this.path=D,this.d=A,D.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new o(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new o(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new o(this.path,D)}compare(D){if(typeof D=="string")return o.compare(this.toString(),D);for(let A=0;A<D.d&&A<this.d;A++)if(D.path[A]!==this.path[A])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=o}),define(pe[90],ve([1,0,4,51,69]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var C;(function(p){p[p.Unset=0]="Unset",p[p.Queued=1]="Queued",p[p.Running=2]="Running",p[p.Passed=3]="Passed",p[p.Failed=4]="Failed",p[p.Skipped=5]="Skipped",p[p.Errored=6]="Errored"})(C||(e.TestResultState=C={}));var D;(function(p){p[p.Run=1]="Run",p[p.Debug=2]="Debug",p[p.Coverage=3]="Coverage"})(D||(e.ExtTestRunProfileKind=D={}));var A;(function(p){p[p.Run=2]="Run",p[p.Debug=4]="Debug",p[p.Coverage=8]="Coverage",p[p.HasNonDefaultProfile=16]="HasNonDefaultProfile",p[p.HasConfigurable=32]="HasConfigurable",p[p.SupportsContinuousRun=64]="SupportsContinuousRun"})(A||(e.TestRunProfileBitset=A={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const v=p=>"runId"in p;e.isStartControllerTests=v;var d;(function(p){p.serialize=P=>({range:P.range.toJSON(),uri:P.uri.toJSON()}),p.deserialize=P=>({range:L.Range.lift(P.range),uri:w.URI.revive(P.uri)})})(d||(e.IRichLocation=d={}));var R;(function(p){p[p.Error=0]="Error",p[p.Output=1]="Output"})(R||(e.TestMessageType=R={}));var y;(function(p){p.serialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,location:P.location&&d.serialize(P.location)}),p.deserialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,location:P.location&&d.deserialize(P.location)})})(y||(e.ITestErrorMessage=y={}));const E=(p,P)=>`${P?"s":"e"}${p}`;e.getMarkId=E;var m;(function(p){p.serialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&d.serialize(P.location)}),p.deserialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&d.deserialize(P.location)})})(m||(e.ITestOutputMessage=m={}));var g;(function(p){p.serialize=P=>P.type===0?y.serialize(P):m.serialize(P),p.deserialize=P=>P.type===0?y.deserialize(P):m.deserialize(P)})(g||(e.ITestMessage=g={}));var b;(function(p){p.serializeWithoutMessages=P=>({state:P.state,duration:P.duration,messages:[]}),p.serialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(g.serialize)}),p.deserialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(g.deserialize)})})(b||(e.ITestTaskState=b={}));const s="\0",h=(p,P)=>p+s+P;e.namespaceTestTag=h;const u=p=>{const P=p.indexOf(s);return{ctrlId:p.slice(0,P),tagId:p.slice(P+1)}};e.denamespaceTestTag=u;var f;(function(p){p.serialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?.toJSON(),range:P.range?.toJSON()||null,description:P.description,error:P.error,sortText:P.sortText}),p.deserialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?w.URI.revive(P.uri):void 0,range:P.range?L.Range.lift(P.range):null,description:P.description,error:P.error,sortText:P.sortText})})(f||(e.ITestItem=f={}));var S;(function(p){p[p.NotExpandable=0]="NotExpandable",p[p.Expandable=1]="Expandable",p[p.BusyExpanding=2]="BusyExpanding",p[p.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var O;(function(p){p.serialize=P=>({expand:P.expand,item:f.serialize(P.item)}),p.deserialize=P=>({controllerId:o.TestId.root(P.item.extId),expand:P.expand,item:f.deserialize(P.item)})})(O||(e.InternalTestItem=O={}));var t;(function(p){p.serialize=P=>{let T;return P.item&&(T={},P.item.label!==void 0&&(T.label=P.item.label),P.item.tags!==void 0&&(T.tags=P.item.tags),P.item.busy!==void 0&&(T.busy=P.item.busy),P.item.uri!==void 0&&(T.uri=P.item.uri?.toJSON()),P.item.range!==void 0&&(T.range=P.item.range?.toJSON()),P.item.description!==void 0&&(T.description=P.item.description),P.item.error!==void 0&&(T.error=P.item.error),P.item.sortText!==void 0&&(T.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:T}},p.deserialize=P=>{let T;return P.item&&(T={},P.item.label!==void 0&&(T.label=P.item.label),P.item.tags!==void 0&&(T.tags=P.item.tags),P.item.busy!==void 0&&(T.busy=P.item.busy),P.item.range!==void 0&&(T.range=P.item.range?L.Range.lift(P.item.range):null),P.item.description!==void 0&&(T.description=P.item.description),P.item.error!==void 0&&(T.error=P.item.error),P.item.sortText!==void 0&&(T.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:T}}})(t||(e.ITestItemUpdate=t={}));const n=(p,P)=>{P.expand!==void 0&&(p.expand=P.expand),P.item!==void 0&&(p.item=p.item?Object.assign(p.item,P.item):P.item)};e.applyTestItemUpdate=n;var r;(function(p){p.serializeWithoutMessages=P=>({...O.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(b.serializeWithoutMessages),retired:P.retired}),p.serialize=P=>({...O.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(b.serialize),retired:P.retired}),p.deserialize=P=>({...O.deserialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(b.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var i;(function(p){p[p.Function=0]="Function",p[p.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(p){p[p.Add=0]="Add",p[p.Update=1]="Update",p[p.DocumentSynced=2]="DocumentSynced",p[p.Remove=3]="Remove",p[p.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",p[p.Retire=5]="Retire",p[p.AddTag=6]="AddTag",p[p.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(p){p.deserialize=P=>P.op===0?{op:P.op,item:O.deserialize(P.item)}:P.op===1?{op:P.op,item:t.deserialize(P.item)}:P.op===2?{op:P.op,uri:w.URI.revive(P.uri),docv:P.docv}:P,p.serialize=P=>P.op===0?{op:P.op,item:O.serialize(P.item)}:P.op===1?{op:P.op,item:t.serialize(P.item)}:P})(l||(e.TestsDiffOp=l={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(P){const T=this.o();for(const I of P)switch(I.op){case 0:this.j(O.deserialize(I.item),T);break;case 1:this.k(t.deserialize(I.item),T);break;case 3:this.l(I.itemId,T);break;case 5:this.m(I.itemId);break;case 4:this.updatePendingRoots(I.amount);break;case 6:this.c.set(I.tag.id,I.tag);break;case 7:this.c.delete(I.id);break}T.complete?.()}j(P,T){const I=o.TestId.parentId(P.item.extId)?.toString();let F;if(!I)F=this.p(P),this.f.add(F),this.d.set(P.item.extId,F);else if(this.d.has(I)){const H=this.d.get(I);H.children.add(P.item.extId),F=this.p(P,H),this.d.set(P.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(P)}`);return}return T.add?.(F),P.expand===2&&this.g++,F}k(P,T){const I=this.d.get(P.extId);if(I)return P.expand!==void 0&&(I.expand===2&&this.g--,P.expand===2&&this.g++),(0,e.applyTestItemUpdate)(I,P),T.update?.(I),I}l(P,T){const I=this.d.get(P);if(!I)return;const F=o.TestId.parentId(I.item.extId)?.toString();F?this.d.get(F).children.delete(I.item.extId):this.f.delete(I);const H=[[P]];for(;H.length;)for(const ee of H.pop()){const ce=this.d.get(ee);ce&&(H.push(ce.children),this.d.delete(ee),T.remove?.(ce,ce!==I),ce.expand===2&&this.g--)}}m(P){}updatePendingRoots(P){this.h+=P}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(pe[130],ve([1,0,14,6,2,93,90,69]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const d=(u,f)=>u===f,y=Object.entries({range:(u,f)=>u===f?!0:!u||!f?!1:u.equalsRange(f),busy:d,label:d,description:d,error:d,sortText:d,tags:(u,f)=>!(u.length!==f.length||u.some(S=>!f.includes(S)))}),E=(u,f)=>{let S;for(const[O,t]of y)t(u[O],f[O])||(S?S[O]=f[O]:S={[O]:f[O]});return S};class m extends o.Disposable{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new w.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new L.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const S of this.tree.values())this.G(S)}get resolveHandler(){return this.h}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===f.uri){S.docv=f.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===f.item.extId){(0,D.applyTestItemUpdate)(S.item,f.item);return}if(S.op===0&&S.item.item.extId===f.item.extId){(0,D.applyTestItemUpdate)(S.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,S){const O=this.tree.get(f);if(O){if((O.expandLevels===void 0||S>O.expandLevels)&&(O.expandLevels=S),O.expand===1){const t=this.I(O);return t.isOpen()?this.H(O,S-1):t.wait().then(()=>this.H(O,S-1))}else if(O.expand===3)return O.resolveBarrier?.isOpen()===!1?O.resolveBarrier.wait().then(()=>this.H(O,S-1)):this.H(O,S-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,S){switch(S.op){case 3:this.L(A.TestId.joinToString(f.fullId,S.id));break;case 0:this.u(S.item,f);break;case 5:for(const O of S.ops)this.p(f,O);break;case 1:this.w(S.new,S.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:S.update}});break;case 6:this.s(f.actual.uri);break;default:(0,C.assertNever)(S)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,S){const O=A.TestId.fromExtHostTestItem(f,this.root.id,S?.actual),t=this.m.getApiFor(f);t.parent&&t.parent!==S?.actual&&this.m.getChildren(t.parent).delete(f.id);let n=this.tree.get(O.toString());if(!n){n={fullId:O,actual:f,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(f,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(f)}}),this.F(f,n,S);return}if(n.actual===f){this.D(f,n,S);return}if(n.actual.uri?.toString()!==f.uri?.toString())return this.L(O.toString()),this.u(f,S);const r=this.m.getChildren(n.actual),i=n.actual,a=E(this.m.toITestItem(i),this.m.toITestItem(f));this.m.getApiFor(i).listener=void 0,n.actual=f,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(f.tags,i.tags,O.toString()),delete a.tags),this.p(n,{op:4,update:a})),this.F(f,n,S);for(const[l,c]of r)this.m.getChildren(f).get(c.id)||this.L(A.TestId.joinToString(O,c.id));this.s(n.actual.uri)}w(f,S,O){const t=new Set(S.map(n=>n.id));for(const n of f)t.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:O,item:{tags:f.map(n=>(0,D.namespaceTestTag)(this.m.controllerId,n.id))}}}),t.forEach(this.z,this)}y(f){const S=this.j.get(f.id);S?S.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,f.id)}}))}z(f){const S=this.j.get(f);S&&!--S.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,f)}))}C(f,S){this.m.getApiFor(f).parent=S&&S.actual!==this.root?S.actual:void 0}D(f,S,O){this.C(f,O);const t=this.m.getApiFor(f);t.parent=O?.actual,t.listener=n=>this.p(S,n),this.G(S)}F(f,S,O){this.D(f,S,O);for(const[t,n]of this.m.getChildren(f))this.u(n,S)}G(f){let S;this.h?f.resolveBarrier?S=f.resolveBarrier.isOpen()?3:2:S=f.actual.canResolveChildren?1:0:S=0,S!==f.expand&&(f.expand=S,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:S}}),S===1&&f.expandLevels!==void 0&&this.I(f))}H(f,S){if(S<0)return;const O=[];for(const[t,n]of this.m.getChildren(f.actual)){const r=this.expand(A.TestId.joinToString(f.fullId,n.id),S);(0,w.isThenable)(r)&&O.push(r)}if(O.length)return Promise.all(O).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const n=new w.Barrier;return n.open(),n}f.expand=2,this.J(f);const S=f.resolveBarrier=new w.Barrier,O=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(n){O(n)}return(0,w.isThenable)(t)?t.catch(O).then(()=>{S.open(),this.G(f)}):(S.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const S=this.tree.get(f);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const O=[S];for(;O.length;){const t=O.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.z(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.m.getChildren(t.actual))O.push(this.tree.get(A.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.TestItemCollection=m;class g extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=g;class b extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class s extends Error{constructor(f,S,O){super(`TestItem with ID "${f}" is from controller "${S}" and cannot be added as a child of an item from controller "${O}".`)}}e.MixedTestItemController=s;const h=(u,f,S)=>{let O=new Map;return{get size(){return O.size},forEach(t,n){for(const r of O.values())t.call(n,r,this)},[Symbol.iterator](){return O.entries()},replace(t){const n=new Map,r=new Set(O.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof S))throw new b(a.id);const l=f(a).controllerId;if(l!==u.controllerId)throw new s(a.id,l,u.controllerId);if(n.has(a.id))throw new g(a.id);n.set(a.id,a),r.delete(a.id),i.ops.push({op:0,item:a})}for(const a of r.keys())i.ops.push({op:3,id:a});u.listener?.(i),O=n},add(t){if(!(t instanceof S))throw new b(t.id);O.set(t.id,t),u.listener?.({op:0,item:t})},delete(t){O.delete(t)&&u.listener?.({op:3,id:t})},get(t){return O.get(t)},toJSON(){return Array.from(O.values())}}};e.createTestItemChildren=h}),define(pe[131],ve([1,0,130]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,o=(D,A)=>{const v={controllerId:A};return L.set(D,v),v};e.createPrivateApiFor=o;const C=D=>{const A=L.get(D);if(!A)throw new w.InvalidTestItemError(D?.id||"<unknown>");return A};e.getPrivateApiFor=C}),define(pe[271],ve([1,0,24,5]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,L.refineServiceDecorator)(w.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(pe[132],ve([1,0,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,w.createDecorator)("configurationResolverService");var L;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class o extends Error{constructor(D,A){super(A),this.variable=D}}e.VariableError=o}),define(pe[272],ve([1,0,7,29,8,22,3,150,199,132,17]),function(oe,e,w,L,o,C,D,A,v,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(m,g,b,s){this.h=new Map,this.a=m,this.b=g,this.g=b,s&&(this.c=s.then(h=>this.i(h)))}i(m){if(D.isWindows){const g=Object.create(null);return Object.keys(m).forEach(b=>{g[b.toLowerCase()]=m[b]}),g}return m}resolveWithEnvironment(m,g,b){return this.l({env:this.i(m),userHome:void 0},g?g.uri:void 0,b)}async resolveAsync(m,g){const b={env:await this.c,userHome:await this.g};return this.l(b,m?m.uri:void 0,g)}async j(m,g,b,s){const h=C.deepClone(g);D.isWindows&&h.windows?Object.keys(h.windows).forEach(f=>h[f]=h.windows[f]):D.isMacintosh&&h.osx?Object.keys(h.osx).forEach(f=>h[f]=h.osx[f]):D.isLinux&&h.linux&&Object.keys(h.linux).forEach(f=>h[f]=h.linux[f]),delete h.windows,delete h.osx,delete h.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,m?m.uri:void 0,h,b,s)}async resolveAnyAsync(m,g,b){return this.j(m,g,b)}async resolveAnyMap(m,g,b){const s=new Map;return{newConfig:await this.j(m,g,b,s),resolvedVariables:s}}resolveWithInteractionReplace(m,g,b,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,g,b,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,g){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,g)}async l(m,g,b,s,h){if(o.isString(b))return this.m(m,g,b,s,h);if(Array.isArray(b))return Promise.all(b.map(u=>this.l(m,g,u,s,h)));if(o.isObject(b)){const u=Object.create(null),f=await Promise.all(Object.keys(b).map(async S=>[await this.m(m,g,S,s,h),await this.l(m,g,b[S],s,h)]));for(const[S,O]of f)u[S]=O;return u}return b}m(m,g,b,s,h){return(0,R.replaceAsync)(b,y.VARIABLE_REGEXP,async(u,f)=>{if(f.includes(y.VARIABLE_LHS))return u;let S=await this.o(m,u,f,g,s);return h?.set(f,S),S!==u&&o.isString(S)&&S.match(y.VARIABLE_REGEXP)&&(S=await this.m(m,g,S,s,h)),S})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,g,b,s,h){let u;const f=b.split(":");f.length>1&&(b=f[0],u=f[1]);const S=n=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new d.VariableError(n,(0,v.localize)(0,null,g))},O=n=>{const r=S(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,A.normalizeDriveLetter)(i)}throw new d.VariableError(n,(0,v.localize)(1,null,g,w.basename(r)))},t=n=>{if(u){const r=this.a.getFolderUri(u);if(r)return r;throw new d.VariableError(n,(0,v.localize)(2,null,g,u))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new d.VariableError(n,(0,v.localize)(3,null,g)):new d.VariableError(n,(0,v.localize)(4,null,g))};switch(b){case"env":if(u){if(m.env){const n=m.env[D.isWindows?u.toLowerCase():u];if(o.isString(n))return n}return""}throw new d.VariableError(d.VariableKind.Env,(0,v.localize)(5,null,g));case"config":if(u){const n=this.a.getConfigurationValue(s,u);if(o.isUndefinedOrNull(n))throw new d.VariableError(d.VariableKind.Config,(0,v.localize)(6,null,g,u));if(o.isObject(n))throw new d.VariableError(d.VariableKind.Config,(0,v.localize)(7,null,g,u));return n}throw new d.VariableError(d.VariableKind.Config,(0,v.localize)(8,null,g));case"command":return this.p(d.VariableKind.Command,g,u,h,"command");case"input":return this.p(d.VariableKind.Input,g,u,h,"input");case"extensionInstallFolder":if(u){const n=await this.a.getExtension(u);if(!n)throw new d.VariableError(d.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,g,u));return this.n(n.extensionLocation)}throw new d.VariableError(d.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,g));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.n(t(d.VariableKind.WorkspaceFolder)));case"cwd":return s||u?(0,A.normalizeDriveLetter)(this.n(t(d.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(w.basename(this.n(t(d.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new d.VariableError(d.VariableKind.UserHome,(0,v.localize)(11,null,g))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new d.VariableError(d.VariableKind.LineNumber,(0,v.localize)(12,null,g))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new d.VariableError(d.VariableKind.SelectedText,(0,v.localize)(13,null,g))}case"file":return S(d.VariableKind.File);case"fileWorkspaceFolder":return O(d.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||u?w.relative(this.n(t(d.VariableKind.RelativeFile)),S(d.VariableKind.RelativeFile)):S(d.VariableKind.RelativeFile);case"relativeFileDirname":{const n=w.dirname(S(d.VariableKind.RelativeFileDirname));if(s||u){const r=w.relative(this.n(t(d.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return w.dirname(S(d.VariableKind.FileDirname));case"fileExtname":return w.extname(S(d.VariableKind.FileExtname));case"fileBasename":return w.basename(S(d.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=w.basename(S(d.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-w.extname(n).length)}case"fileDirnameBasename":return w.basename(w.dirname(S(d.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||g}case"execInstallFolder":{const n=this.a.getAppRoot();return n||g}case"pathSeparator":return w.sep;default:try{const n=u?`${b}:${u}`:b;return this.p(d.VariableKind.Unknown,g,n,h,void 0)}catch{return g}}}}p(m,g,b,s,h){if(b&&s){const u=h===void 0?s[b]:s[h+":"+b];if(typeof u=="string")return u;throw new d.VariableError(m,(0,v.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[273],ve([1,0,5,89]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var o;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(o||(e.GroupDirection=o={}));var C;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(C||(e.GroupOrientation=C={}));var D;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(D||(e.GroupLocation=D={}));var A;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(A||(e.GroupsArrangement=A={}));var v;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function d(g){const b=g;return(0,L.isEditorInput)(b?.editor)&&(0,L.isEditorInput)(b?.replacement)}e.isEditorReplacement=d;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var y;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function E(g){const b=g;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=E;function m(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=m}),define(pe[133],ve([1,0,5,273]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function o(C){const D=C;return typeof C=="number"||(0,L.isEditorGroup)(D)}e.isPreferredGroup=o}),define(pe[274],ve([1,0,8,271,12,116,87,86,132,89,133,13,219,269]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let g=e.RemoteTerminalChannelClient=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(s,h,u,f,S,O,t,n,r,i){this.a=s,this.b=h,this.c=u,this.d=f,this.e=S,this.f=O,this.g=t,this.h=n,this.i=r,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(s,h,u,f,S,O,t,n){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),i=u?(0,w.withNullAsUndefined)(this.d.getWorkspaceFolder(u)):void 0;let a;try{a=(await this.e.resolveAnyMap(i,{shellLaunchConfig:s,configuration:h})).resolvedVariables}catch(ee){this.h.error(ee)}if(a)for(const[ee,ce]of a.entries())(/^config:/.test(ee)||ee==="selectedText"||ee==="lineNumber")&&(r[ee]=ce);const l=[];for(const[ee,ce]of this.f.collections.entries())l.push([ee,(0,A.serializeEnvironmentVariableCollection)(ce.map),(0,A.serializeEnvironmentDescriptionMap)(ce.descriptionMap)]);const c=await this.g.resolveAuthority(this.a),p=c.options&&c.options.extensionHostEnv,P=this.d.getWorkspace(),T=P.folders,I=u?this.d.getWorkspaceFolder(u):null,F=d.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:d.SideBySideEditor.PRIMARY,filterByScheme:[y.Schemas.file,y.Schemas.vscodeUserData,y.Schemas.vscodeRemote]}),H={configuration:h,resolvedVariables:r,envVariableCollections:l,shellLaunchConfig:s,workspaceId:P.id,workspaceName:this.j.getWorkspaceLabel(P),workspaceFolders:T,activeWorkspaceFolder:I,activeFileResource:F,shouldPersistTerminal:S,options:f,cols:O,rows:t,unicodeVersion:n,resolverEnv:p};return await this.b.call("$createProcess",H)}requestDetachInstance(s,h){return this.b.call("$requestDetachInstance",[s,h])}acceptDetachInstanceReply(s,h){return this.b.call("$acceptDetachInstanceReply",[s,h])}attachToProcess(s){return this.b.call("$attachToProcess",[s])}detachFromProcess(s,h){return this.b.call("$detachFromProcess",[s,h])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(s,h){return this.b.call("$processBinary",[s,h])}start(s){return this.b.call("$start",[s])}input(s,h){return this.b.call("$input",[s,h])}acknowledgeDataEvent(s,h){return this.b.call("$acknowledgeDataEvent",[s,h])}setUnicodeVersion(s,h){return this.b.call("$setUnicodeVersion",[s,h])}shutdown(s,h){return this.b.call("$shutdown",[s,h])}resize(s,h,u){return this.b.call("$resize",[s,h,u])}getInitialCwd(s){return this.b.call("$getInitialCwd",[s])}getCwd(s){return this.b.call("$getCwd",[s])}orphanQuestionReply(s){return this.b.call("$orphanQuestionReply",[s])}sendCommandResult(s,h,u){return this.b.call("$sendCommandResult",[s,h,u])}freePortKillProcess(s){return this.b.call("$freePortKillProcess",[s])}installAutoReply(s,h){return this.b.call("$installAutoReply",[s,h])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(s){return this.b.call("$getDefaultSystemShell",[s])}getProfiles(s,h,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,s,h,u])}acceptPtyHostResolvedVariables(s,h){return this.b.call("$acceptPtyHostResolvedVariables",[s,h])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(s,h){return this.b.call("$getWslPath",[s,h])}setTerminalLayoutInfo(s){const u={workspaceId:this.d.getWorkspace().id,tabs:s?s.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(s,h,u){return this.b.call("$updateTitle",[s,h,u])}updateIcon(s,h,u,f){return this.b.call("$updateIcon",[s,h,u,f])}refreshProperty(s,h){return this.b.call("$refreshProperty",[s,h])}updateProperty(s,h,u){return this.b.call("$updateProperty",[s,h,u])}getTerminalLayoutInfo(){const h={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",h)}reviveTerminalProcesses(s,h){return this.b.call("$reviveTerminalProcesses",[s,h])}getRevivedPtyNewId(s){return this.b.call("$getRevivedPtyNewId",[s])}serializeTerminalState(s){return this.b.call("$serializeTerminalState",[s])}};e.RemoteTerminalChannelClient=g=Le([Ae(2,L.IWorkbenchConfigurationService),Ae(3,D.IWorkspaceContextService),Ae(4,v.IConfigurationResolverService),Ae(5,m.IEnvironmentVariableService),Ae(6,C.IRemoteAuthorityResolverService),Ae(7,o.ILogService),Ae(8,R.IEditorService),Ae(9,E.ILabelService)],g)}),define(pe[275],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var w;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(w||(e.ExtHostConnectionType=w={}));class L{constructor(y){this.pipeName=y,this.type=1}serialize(y){y[L.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=L,L.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class o{constructor(){this.type=2}serialize(y){y[o.ENV_KEY]="1"}}e.SocketExtHostConnection=o,o.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class C{constructor(){this.type=3}serialize(y){y[C.ENV_KEY]="1"}}e.MessagePortExtHostConnection=C,C.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(R){delete R[L.ENV_KEY],delete R[o.ENV_KEY],delete R[C.ENV_KEY]}function A(R,y){D(y),R.serialize(y)}e.writeExtHostConnection=A;function v(R){if(R[L.ENV_KEY])return d(R,new L(R[L.ENV_KEY]));if(R[o.ENV_KEY])return d(R,new o);if(R[C.ENV_KEY])return d(R,new C);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=v;function d(R,y){return D(R),y}}),define(pe[276],ve([1,0,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(L||(e.UIKind=L={}));var o;(function(d){d[d.VersionMismatch=55]="VersionMismatch",d[d.UnexpectedError=81]="UnexpectedError"})(o||(e.ExtensionHostExitCode=o={}));var C;(function(d){d[d.Initialized=0]="Initialized",d[d.Ready=1]="Ready",d[d.Terminate=2]="Terminate"})(C||(e.MessageType=C={}));function D(d){const R=w.VSBuffer.alloc(1);switch(d){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function A(d,R){if(d.byteLength!==1)return!1;switch(d.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var v;(function(d){d.Start="START_NATIVE_LOG",d.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(pe[277],ve([1,0,5,6,12,265,276,55,37,22,4,2,197]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let m=e.ExtHostTelemetry=class extends y.Disposable{constructor(h,u){super(),this.n=h,this.p=u,this.a=this.B(new L.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=R.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=u.createLogger(this.j,{id:v.extensionTelemetryLogChannelId,name:(0,E.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(f=>{(0,o.isLogLevel)(f)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===o.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,u,f){const S=this.getTelemetryDetails(),O=new g(u,f,h,this.k,this.i,this.getBuiltInCommonProperties(h),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),t=this.m.get(h.identifier.value)??[];return this.m.set(h.identifier.value,[...t,O]),O.apiTelemetryLogger}$initializeTelemetryLevel(h,u,f){this.f=h,this.g=u,this.c=f??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(h){const u=Object.create(null);switch(u["common.extname"]=`${h.publisher}.${h.name}`,u["common.extversion"]=h.version,u["common.vscodemachineid"]=this.n.telemetryInfo.machineId,u["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,u["common.vscodeversion"]=this.n.version,u["common.isnewappinstall"]=b(this.n.telemetryInfo.firstSessionDate),u["common.product"]=this.n.environment.appHost,this.n.uiKind){case D.UIKind.Web:u["common.uikind"]="web";break;case D.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,A.getRemoteName)((0,v.cleanRemoteAuthority)(this.n.remote.authority)),u}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const u=this.getTelemetryDetails();this.m.forEach((f,S)=>{const O=f.filter(t=>!t.isDisposed);O.length===0?this.m.delete(S):this.m.set(S,O)}),this.m.forEach(f=>{for(const S of f)S.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(h,u){const S=this.m.get(h.value)?.filter(t=>!t.isDisposed);if(!S)return this.m.delete(h.value),!1;let O=!1;for(const t of S)t.ignoreUnhandledExtHostErrors||(t.logError(u),O=!0);return O}};e.ExtHostTelemetry=m=Le([Ae(0,C.IExtHostInitDataService),Ae(1,o.ILoggerService)],m);class g{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,u,f,S,O,t,n){this.g=f,this.h=S,this.i=O,this.j=t,this.a=new L.Emitter,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(h,u){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let u="properties"in h?h.properties??{}:h;return u=(0,v.cleanData)(u,[]),this.c&&(u=(0,d.mixin)(u,this.c)),this.b||(u=(0,d.mixin)(u,this.j)),"properties"in h?h.properties=u:h=u,h}k(h,u){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(h,u),this.h.trace(h,u))}logUsage(h,u){this.d.isUsageEnabled&&this.k(h,u)}logError(h,u){!this.d.isErrorsEnabled||!this.f||(typeof h=="string"?this.k(h,u):this.f.sendErrorData(h,u))}get apiTelemetryLogger(){if(!this.e){const h=this,u={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function b(s){const h=Date.now()-new Date(s).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(pe[278],ve([1,0,6,4,34,229,36,5]),function(oe,e,w,L,o,C,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class v{constructor(O){this.dependency=O}}e.MissingExtensionDependency=v;var d;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(d||(e.ExtensionHostStartup=d={}));class R{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:C.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(O,t){const n=[],r=[],i=[],a=[],l=y(this.c),c=y(O),p=(H,ee)=>H.extensionLocation.toString()===ee.extensionLocation.toString()||H.isBuiltin===ee.isBuiltin||H.isUserBuiltin===ee.isUserBuiltin||H.isUnderDevelopment===ee.isUnderDevelopment;for(const H of this.c){const ee=c.get(H.identifier);if(!ee){n.push(H.identifier),l.delete(H.identifier);continue}if(!p(H,ee)){n.push(H.identifier),l.delete(H.identifier);continue}}for(const H of O){const ee=l.get(H.identifier);if(!ee){r.push(H);continue}if(!p(ee,H)){n.push(ee.identifier),l.delete(ee.identifier);continue}}const P=new D.ExtensionIdentifierSet(this.d),T=new D.ExtensionIdentifierSet(t);for(const H of this.d)T.has(H)||i.push(H);for(const H of t)P.has(H)||a.push(H);const I=C.ImplicitActivationEvents.createActivationEventsMap(r),F={toRemove:n,toAdd:r,addActivationEvents:I,myToRemove:i,myToAdd:a};return this.delta(F),F}delta(O){const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=O,a=new D.ExtensionIdentifierSet(t),l=new D.ExtensionIdentifierSet(r);for(let c=0;c<this.c.length;c++)a.has(this.c[c].identifier)&&(this.c.splice(c,1),c--);for(let c=0;c<this.d.length;c++)l.has(this.d[c])&&(this.d.splice(c,1),c--);for(const c of n)this.c.push(c);for(const c of i)this.d.push(c)}containsExtension(O){for(const t of this.d)if(D.ExtensionIdentifier.equals(t,O))return!0;return!1}}e.ExtensionHostExtensions=R;function y(S){const O=new D.ExtensionIdentifierMap;for(const t of S)O.set(t.identifier,t);return O}function E(S,O){return!0}e.isProposedApiEnabled=E;function m(S,O){if(!E(S,O))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${O}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${O}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.checkProposedApiEnabled=m;class g{constructor(O,t,n,r){this.codeLoadingTime=O,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.ActivationTimes=g;class b{constructor(O,t){this.description=O,this.value=t}}e.ExtensionPointContribution=b;var s;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function h(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,o.getGalleryExtensionId)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function u(S,O){return{identifier:new D.ExtensionIdentifier((0,o.getExtensionId)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!O,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.toExtensionDescription=u;class f{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(O){return Promise.resolve(void 0)}activationEventIsDone(O){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(O){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(O,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(O){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=f});var Ft=this&&this.__classPrivateFieldSet||function(oe,e,w,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!o:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(oe,w):o?o.value=w:e.set(oe,w),w},rt=this&&this.__classPrivateFieldGet||function(oe,e,w,L){if(w==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!L:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?L:w==="a"?L.call(oe):L?L.value:e.get(oe)};define(pe[134],ve([1,0,18,9,98,28,57,17,8,4,21,16,116,129,278]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g){"use strict";var b,s,h,u,f,S,O,t,n,r,i,a,l,c,p,P,T,I,F,H,ee,ce,ae,ue,ge;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function G(B){return Object.assign(B,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(B,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[se,...be]=arguments;return Reflect.construct(B,be,se.constructor)}}})}var te;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(te||(e.TerminalOutputAnchor=te={}));var W;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(W||(e.TerminalQuickFixType=W={}));let K=e.Disposable=t=class{static from(...M){let se=M;return new t(function(){if(se){for(const be of se)be&&typeof be.dispose=="function"&&be.dispose();se=void 0}})}constructor(M){b.set(this,void 0),Ft(this,b,M,"f")}dispose(){typeof rt(this,b,"f")=="function"&&(rt(this,b,"f").call(this),Ft(this,b,void 0,"f"))}};b=new WeakMap,e.Disposable=K=t=Le([G],K);let q=e.Position=n=class{static Min(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let be=1;be<M.length;be++){const Be=M[be];Be.isBefore(se)&&(se=Be)}return se}static Max(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let be=1;be<M.length;be++){const Be=M[be];Be.isAfter(se)&&(se=Be)}return se}static isPosition(M){if(!M)return!1;if(M instanceof n)return!0;const{line:se,character:be}=M;return typeof se=="number"&&typeof be=="number"}static of(M){if(M instanceof n)return M;if(this.isPosition(M))return new n(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,se){if(M<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this.c=M,this.e=se}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,se=0){if(M===null||se===null)throw(0,L.illegalArgument)();let be;return typeof M>"u"?be=0:typeof M=="number"?be=M:(be=typeof M.lineDelta=="number"?M.lineDelta:0,se=typeof M.characterDelta=="number"?M.characterDelta:0),be===0&&se===0?this:new n(this.line+be,this.character+se)}with(M,se=this.character){if(M===null||se===null)throw(0,L.illegalArgument)();let be;return typeof M>"u"?be=this.line:typeof M=="number"?be=M:(be=typeof M.line=="number"?M.line:this.line,se=typeof M.character=="number"?M.character:this.character),be===this.line&&se===this.character?this:new n(be,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=q=n=Le([G],q);let ie=e.Range=r=class{static isRange(M){return M instanceof r?!0:M?q.isPosition(M.start)&&q.isPosition(M.end):!1}static of(M){if(M instanceof r)return M;if(this.isRange(M))return new r(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,se,be,Be){let He,et;if(typeof M=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Be=="number"?(He=new q(M,se),et=new q(be,Be)):q.isPosition(M)&&q.isPosition(se)&&(He=q.of(M),et=q.of(se)),!He||!et)throw new Error("Invalid arguments");He.isBefore(et)?(this.c=He,this.e=et):(this.c=et,this.e=He)}contains(M){return r.isRange(M)?this.contains(M.start)&&this.contains(M.end):q.isPosition(M)?!(q.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const se=q.Max(M.start,this.c),be=q.Min(M.end,this.e);if(!se.isAfter(be))return new r(se,be)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const se=q.Min(M.start,this.c),be=q.Max(M.end,this.end);return new r(se,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,se=this.end){if(M===null||se===null)throw(0,L.illegalArgument)();let be;return M?q.isPosition(M)?be=M:(be=M.start||this.start,se=M.end||this.end):be=this.start,be.isEqual(this.c)&&se.isEqual(this.end)?this:new r(be,se)}toJSON(){return[this.start,this.end]}};e.Range=ie=r=Le([G],ie);let re=e.Selection=i=class extends ie{static isSelection(M){return M instanceof i?!0:M?ie.isRange(M)&&q.isPosition(M.anchor)&&q.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,se,be,Be){let He,et;if(typeof M=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Be=="number"?(He=new q(M,se),et=new q(be,Be)):q.isPosition(M)&&q.isPosition(se)&&(He=q.of(M),et=q.of(se)),!He||!et)throw new Error("Invalid arguments");super(He,et),this.f=He,this.g=et}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=re=i=Le([G],re);class de{constructor(M,se,be){if(typeof M!="string"||M.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,L.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(se),this.connectionToken=be}}e.ResolvedAuthority=de;class $ extends Error{static NotAvailable(M,se){return new $(M,E.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(M){return new $(M,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,se=E.RemoteAuthorityResolverErrorCode.Unknown,be){super(M),this._message=M,this._code=se,this._detail=be,Object.setPrototypeOf(this,$.prototype)}}e.RemoteAuthorityResolverError=$;var V;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var N;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(N||(e.EnvironmentVariableMutatorType=N={}));let k=e.TextEdit=a=class{static isTextEdit(M){return M instanceof a?!0:M?ie.isRange(M)&&typeof M.newText=="string":!1}static replace(M,se){return new a(M,se)}static insert(M,se){return a.replace(new ie(M,M),se)}static delete(M){return a.replace(M,"")}static setEndOfLine(M){const se=new a(new ie(new q(0,0),new q(0,0)),"");return se.newEol=M,se}get range(){return this.c}set range(M){if(M&&!ie.isRange(M))throw(0,L.illegalArgument)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,L.illegalArgument)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,L.illegalArgument)("newEol");this.f=M}constructor(M,se){this.c=M,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=k=a=Le([G],k);let U=e.NotebookEdit=l=class{static isNotebookCellEdit(M){return M instanceof l?!0:M?Ot.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,se){return new l(M,se)}static insertCells(M,se){return new l(new Ot(M,M),se)}static deleteCells(M){return new l(M,[])}static updateCellMetadata(M,se){const be=new l(new Ot(M,M),[]);return be.newCellMetadata=se,be}static updateNotebookMetadata(M){const se=new l(new Ot(0,0),[]);return se.newNotebookMetadata=M,se}constructor(M,se){this.range=M,this.newCells=se}};e.NotebookEdit=U=l=Le([G],U);class X{static isSnippetTextEdit(M){return M instanceof X?!0:M?ie.isRange(M.range)&&j.isSnippetString(M.snippet):!1}static replace(M,se){return new X(M,se)}static insert(M,se){return X.replace(new ie(M,M),se)}constructor(M,se){this.range=M,this.snippet=se}}e.SnippetTextEdit=X;var ne;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let z=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,se,be,Be){this.c.push({_type:1,from:M,to:se,options:be,metadata:Be})}createFile(M,se,be){this.c.push({_type:1,from:void 0,to:M,options:se,metadata:be})}deleteFile(M,se,be){this.c.push({_type:1,from:M,to:void 0,options:se,metadata:be})}e(M,se,be){this.c.push({_type:3,metadata:be,uri:M,edit:{editType:5,metadata:se},notebookMetadata:se})}f(M,se,be,Be){const He=se.start,et=se.end;(He!==et||be.length>0)&&this.c.push({_type:5,uri:M,index:He,count:et-He,cells:be,metadata:Be})}g(M,se,be,Be){this.c.push({_type:3,metadata:Be,uri:M,edit:{editType:8,index:se,metadata:be}})}replace(M,se,be,Be){this.c.push({_type:2,uri:M,edit:new k(se,be),metadata:Be})}insert(M,se,be,Be){this.replace(M,new ie(se,se),be,Be)}delete(M,se,be){this.replace(M,se,"",be)}has(M){return this.c.some(se=>se._type===2&&se.uri.toString()===M.toString())}set(M,se){if(se)for(const be of se){if(!be)continue;let Be,He;Array.isArray(be)?(Be=be[0],He=be[1]):Be=be,U.isNotebookCellEdit(Be)?Be.newCellMetadata?this.g(M,Be.range.start,Be.newCellMetadata,He):Be.newNotebookMetadata?this.e(M,Be.newNotebookMetadata,He):this.f(M,Be.range,Be.newCells,He):X.isSnippetTextEdit(Be)?this.c.push({_type:6,uri:M,range:Be.range,edit:Be.snippet,metadata:He}):this.c.push({_type:2,uri:M,edit:Be,metadata:He})}else{for(let be=0;be<this.c.length;be++){const Be=this.c[be];switch(Be._type){case 2:case 6:case 3:case 5:Be.uri.toString()===M.toString()&&(this.c[be]=void 0);break}}(0,w.coalesceInPlace)(this.c)}}get(M){const se=[];for(const be of this.c)be._type===2&&be.uri.toString()===M.toString()&&se.push(be.edit);return se}entries(){const M=new C.ResourceMap;for(const se of this.c)if(se._type===2){let be=M.get(se.uri);be||(be=[se.uri,[]],M.set(se.uri,be)),be[1].push(se.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=z=Le([G],z);let j=e.SnippetString=c=class{static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=c.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,se=this.e++){if(typeof M=="function"){const be=new c;be.e=this.e,M(be),this.e=be.e,M=be.value}else M=c.c(M);return this.value+="${",this.value+=se,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,se=this.e++){const be=M.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(M,se){if(typeof se=="function"){const be=new c;be.e=this.e,se(be),this.e=be.e,se=be.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=j=c=Le([G],j);var Y;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let Z=e.Location=p=class{static isLocation(M){return M instanceof p?!0:M?ie.isRange(M.range)&&d.URI.isUri(M.uri):!1}constructor(M,se){if(this.uri=M,se)if(ie.isRange(se))this.range=ie.of(se);else if(q.isPosition(se))this.range=new ie(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Z=p=Le([G],Z);let J=e.DiagnosticRelatedInformation=class{static is(M){return M?typeof M.message=="string"&&M.location&&ie.isRange(M.location.range)&&d.URI.isUri(M.location.uri):!1}constructor(M,se){this.location=M,this.message=se}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.location.range.isEqual(se.location.range)&&M.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=J=Le([G],J);let _=e.Diagnostic=class{constructor(M,se,be=x.Error){if(!ie.isRange(M))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=M,this.message=se,this.severity=be}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.severity===se.severity&&M.code===se.code&&M.severity===se.severity&&M.source===se.source&&M.range.isEqual(se.range)&&(0,w.equals)(M.tags,se.tags)&&(0,w.equals)(M.relatedInformation,se.relatedInformation,J.isEqual)}};e.Diagnostic=_=Le([G],_);let le=e.Hover=class{constructor(M,se){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=se}};e.Hover=le=Le([G],le);var Ee;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Ee||(e.DocumentHighlightKind=Ee={}));let Ce=e.DocumentHighlight=class{constructor(M,se=Ee.Text){this.range=M,this.kind=se}toJSON(){return{range:this.range,kind:Ee[this.kind]}}};e.DocumentHighlight=Ce=Le([G],Ce);var ke;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let je=e.SymbolInformation=P=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,se,be,Be,He){this.name=M,this.kind=se,this.containerName=He,typeof be=="string"&&(this.containerName=be),Be instanceof Z?this.location=Be:be instanceof ie&&(this.location=new Z(Be,be)),P.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=je=P=Le([G],je);let me=e.DocumentSymbol=T=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(T.validate)}constructor(M,se,be,Be,He){this.name=M,this.detail=se,this.kind=be,this.range=Be,this.selectionRange=He,this.children=[],T.validate(this)}};e.DocumentSymbol=me=T=Le([G],me);var Se;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Se||(e.CodeActionTriggerKind=Se={}));let we=e.CodeAction=class{constructor(M,se){this.title=M,this.kind=se}};e.CodeAction=we=Le([G],we);let Ne=e.CodeActionKind=I=class{constructor(M){this.value=M}append(M){return new I(this.value?this.value+I.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+I.c)}};Ne.c=".",e.CodeActionKind=Ne=I=Le([G],Ne),Ne.Empty=new Ne(""),Ne.QuickFix=Ne.Empty.append("quickfix"),Ne.Refactor=Ne.Empty.append("refactor"),Ne.RefactorExtract=Ne.Refactor.append("extract"),Ne.RefactorInline=Ne.Refactor.append("inline"),Ne.RefactorMove=Ne.Refactor.append("move"),Ne.RefactorRewrite=Ne.Refactor.append("rewrite"),Ne.Source=Ne.Empty.append("source"),Ne.SourceOrganizeImports=Ne.Source.append("organizeImports"),Ne.SourceFixAll=Ne.Source.append("fixAll");let ze=e.SelectionRange=class{constructor(M,se){if(this.range=M,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=ze=Le([G],ze);class tt{constructor(M,se,be,Be,He,et){this.kind=M,this.name=se,this.detail=be,this.uri=Be,this.range=He,this.selectionRange=et}}e.CallHierarchyItem=tt;class Ve{constructor(M,se){this.fromRanges=se,this.from=M}}e.CallHierarchyIncomingCall=Ve;class Xe{constructor(M,se){this.fromRanges=se,this.to=M}}e.CallHierarchyOutgoingCall=Xe;var Qe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let it=e.CodeLens=class{constructor(M,se){this.range=M,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=it=Le([G],it);let Ge=e.MarkdownString=F=class{static isMarkdownString(M){return M instanceof F?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,se=!1){s.set(this,void 0),Ft(this,s,new o.MarkdownString(M,{supportThemeIcons:se}),"f")}get value(){return rt(this,s,"f").value}set value(M){rt(this,s,"f").value=M}get isTrusted(){return rt(this,s,"f").isTrusted}set isTrusted(M){rt(this,s,"f").isTrusted=M}get supportThemeIcons(){return rt(this,s,"f").supportThemeIcons}set supportThemeIcons(M){rt(this,s,"f").supportThemeIcons=M}get supportHtml(){return rt(this,s,"f").supportHtml}set supportHtml(M){rt(this,s,"f").supportHtml=M}get baseUri(){return rt(this,s,"f").baseUri}set baseUri(M){rt(this,s,"f").baseUri=M}appendText(M){return rt(this,s,"f").appendText(M),this}appendMarkdown(M){return rt(this,s,"f").appendMarkdown(M),this}appendCodeblock(M,se){return rt(this,s,"f").appendCodeblock(se??"",M),this}};s=new WeakMap,e.MarkdownString=Ge=F=Le([G],Ge);let Ye=e.ParameterInformation=class{constructor(M,se){this.label=M,this.documentation=se}};e.ParameterInformation=Ye=Le([G],Ye);let he=e.SignatureInformation=class{constructor(M,se){this.label=M,this.documentation=se,this.parameters=[]}};e.SignatureInformation=he=Le([G],he);let De=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=De=Le([G],De);var Te;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Te||(e.SignatureHelpTriggerKind=Te={}));var Re;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Re||(e.InlayHintKind=Re={}));let Oe=e.InlayHintLabelPart=class{constructor(M){this.value=M}};e.InlayHintLabelPart=Oe=Le([G],Oe);let $e=e.InlayHint=class{constructor(M,se,be){this.position=M,this.label=se,this.kind=be}};e.InlayHint=$e=Le([G],$e);var qe;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe||(e.CompletionTriggerKind=qe={}));var xe;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(xe||(e.CompletionItemKind=xe={}));var _e;(function(B){B[B.Deprecated=1]="Deprecated"})(_e||(e.CompletionItemTag=_e={}));let Ke=e.CompletionItem=class{constructor(M,se){this.label=M,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ke=Le([G],Ke);let Je=e.CompletionList=class{constructor(M=[],se=!1){this.items=M,this.isIncomplete=se}};e.CompletionList=Je=Le([G],Je);let at=e.InlineSuggestion=class{constructor(M,se,be){this.insertText=M,this.range=se,this.command=be}};e.InlineSuggestion=at=Le([G],at);let vt=e.InlineSuggestionList=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=vt=Le([G],vt);var ot;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var Mt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Mt||(e.StatusBarAlignment=Mt={}));var Et;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Ct;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Ct||(e.TextDocumentSaveReason=Ct={}));var ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ht||(e.TextEditorRevealType=ht={}));var dt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(dt||(e.TextEditorSelectionChangeKind=dt={}));var At;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(At||(e.TextDocumentChangeReason=At={}));var Rt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Rt||(e.DecorationRangeBehavior=Rt={})),function(B){function M(se){switch(se){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=M}(dt||(e.TextEditorSelectionChangeKind=dt={}));let wt=e.DocumentLink=class{constructor(M,se){if(se&&!d.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!ie.isRange(M)||M.isEmpty)throw(0,L.illegalArgument)("range");this.range=M,this.target=se}};e.DocumentLink=wt=Le([G],wt);let Pt=e.Color=class{constructor(M,se,be,Be){this.red=M,this.green=se,this.blue=be,this.alpha=Be}};e.Color=Pt=Le([G],Pt);let Ut=e.ColorInformation=class{constructor(M,se){if(se&&!(se instanceof Pt))throw(0,L.illegalArgument)("color");if(!ie.isRange(M)||M.isEmpty)throw(0,L.illegalArgument)("range");this.range=M,this.color=se}};e.ColorInformation=Ut=Le([G],Ut);let gt=e.ColorPresentation=class{constructor(M){if(!M||typeof M!="string")throw(0,L.illegalArgument)("label");this.label=M}};e.ColorPresentation=gt=Le([G],gt);var Tt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Tt||(e.ColorFormat=Tt={}));var st;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(st||(e.SourceControlInputBoxValidationType=st={}));var yt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(yt||(e.TerminalExitReason=yt={}));class ye{constructor(M,se,be){if(this.startIndex=M,this.length=se,this.tooltip=be,typeof M!="number"||M<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Ie{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=Ie;class fe{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=fe;var Q;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Q||(e.TerminalLocation=Q={}));class Pe{constructor(M){if(this.options=M,typeof M!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=Pe;var Fe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Fe||(e.TaskRevealKind=Fe={}));var We;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(We||(e.TaskPanelKind=We={}));let Me=e.TaskGroup=H=class{static from(M){switch(M){case"clean":return H.Clean;case"build":return H.Build;case"rebuild":return H.Rebuild;case"test":return H.Test;default:return}}constructor(M,se){if(this.label=se,typeof M!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this.c=M}get id(){return this.c}};Me.Clean=new H("clean","Clean"),Me.Build=new H("build","Build"),Me.Rebuild=new H("rebuild","Rebuild"),Me.Test=new H("test","Test"),e.TaskGroup=Me=H=Le([G],Me);function Ze(B){let M="";for(let se=0;se<B.length;se++)M+=B[se].replace(/,/g,",,")+",";return M}let lt=e.ProcessExecution=class{constructor(M,se,be){if(typeof M!="string")throw(0,L.illegalArgument)("process");this.e=[],this.c=M,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=be):this.f=se)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,L.illegalArgument)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const se of this.e)M.push(se);return Ze(M)}};e.ProcessExecution=lt=Le([G],lt);let mt=e.ShellExecution=class{constructor(M,se,be){if(this.f=[],Array.isArray(se)){if(!M)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,L.illegalArgument)("command");this.e=M,this.f=se,this.g=be}else{if(typeof M!="string")throw(0,L.illegalArgument)("commandLine");this.c=M,this.g=se}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,L.illegalArgument)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,L.illegalArgument)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)M.push(typeof se=="string"?se:se.value);return Ze(M)}};e.ShellExecution=mt=Le([G],mt);var ut;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ut||(e.ShellQuoting=ut={}));var ct;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ct||(e.TaskScope=ct={}));class pt{constructor(M){this.c=M}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(M){this.c=M}get callback(){return this.c}}e.CustomExecution=pt;let Bt=e.Task=ee=class{constructor(M,se,be,Be,He,et){this.j=!1,this.k=this.definition=M;let nt;typeof se=="string"?(this.m=this.name=se,this.t=this.source=be,this.execution=Be,nt=He,this.j=!0):se===ct.Global||se===ct.Workspace?(this.target=se,this.m=this.name=be,this.t=this.source=Be,this.execution=He,nt=et):(this.target=se,this.m=this.name=be,this.t=this.source=Be,this.execution=He,nt=et),typeof nt=="string"?(this.o=[nt],this.q=!0):Array.isArray(nt)?(this.o=nt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:ee.e,id:this.n.computeId()}:this.n instanceof mt?this.k={type:ee.f,id:this.n.computeId()}:this.n instanceof pt?this.k={type:ee.c,id:this.n.computeId()}:this.k={type:ee.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,L.illegalArgument)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const se=this.k.type;(ee.g===se||ee.e===se||ee.f===se||ee.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};Bt.c="customExecution",Bt.e="process",Bt.f="shell",Bt.g="$empty",e.Task=Bt=ee=Le([G],Bt);var _t;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(_t||(e.ProgressLocation=_t={}));var ei;(function(B){function M(se){const be=se;return(0,v.isNumber)(be.value)?be.tooltip&&!(0,v.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}B.isViewBadge=M})(ei||(e.ViewBadge=ei={}));let ti=e.TreeItem=ce=class{static isTreeItem(M,se){const be=M;if(be.checkboxState!==void 0){(0,g.checkProposedApiEnabled)(se,"treeItemCheckbox");const Be=(0,v.isNumber)(be.checkboxState)?be.checkboxState:(0,v.isObject)(be.checkboxState)&&(0,v.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,He=!(0,v.isNumber)(be.checkboxState)&&(0,v.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Be===void 0||Be!==Vt.Checked&&Be!==Vt.Unchecked||He!==void 0&&!(0,v.isString)(He))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}if(M instanceof ce)return!0;if(be.label!==void 0&&!(0,v.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,v.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,v.isString)(be.iconPath)&&!d.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,v.isString)(be.iconPath.id))){const Be=be.iconPath;if(!Be||!(0,v.isString)(Be.light)&&!d.URI.isUri(Be.light)&&!(0,v.isString)(Be.dark)&&!d.URI.isUri(Be.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,v.isString)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!d.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,v.isString)(be.tooltip)&&!(be.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<zt.None&&be.collapsibleState>zt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,v.isString)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):!0}constructor(M,se=zt.None){this.collapsibleState=se,d.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=ti=ce=Le([G],ti);var zt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(zt||(e.TreeItemCollapsibleState=zt={}));var Vt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Vt||(e.TreeItemCheckboxState=Vt={}));let ii=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M,se){this.value=M,this.id=se??(0,R.generateUuid)()}};e.DataTransferItem=ii=Le([G],ii);class un{constructor(M,se,be,Be){this.name=M,this.uri=se,this._itemId=be,this.c=Be}data(){return this.c()}}e.DataTransferFile=un;let ni=e.DataTransfer=class{constructor(M){h.add(this),u.set(this,new Map);for(const[se,be]of M??[]){const Be=rt(this,u,"f").get(rt(this,h,"m",f).call(this,se));Be?Be.push(be):rt(this,u,"f").set(rt(this,h,"m",f).call(this,se),[be])}}get(M){return rt(this,u,"f").get(rt(this,h,"m",f).call(this,M))?.[0]}set(M,se){rt(this,u,"f").set(rt(this,h,"m",f).call(this,M),[se])}forEach(M,se){for(const[be,Be]of rt(this,u,"f"))for(const He of Be)M.call(se,He,be,this)}*[(u=new WeakMap,h=new WeakSet,Symbol.iterator)](){for(const[M,se]of rt(this,u,"f"))for(const be of se)yield[M,be]}};f=function(M){return M.toLowerCase()},e.DataTransfer=ni=Le([G],ni);let ri=e.DocumentDropEdit=class{constructor(M){this.insertText=M}};e.DocumentDropEdit=ri=Le([G],ri);let si=e.DocumentPasteEdit=class{constructor(M){this.insertText=M}};e.DocumentPasteEdit=si=Le([G],si);let Lt=e.ThemeIcon=class{constructor(M,se){this.id=M,this.color=se}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=Lt=Le([G],Lt),Lt.File=new Lt("file"),Lt.Folder=new Lt("folder");let oi=e.ThemeColor=class{constructor(M){this.id=M}};e.ThemeColor=oi=Le([G],oi);var ai;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ai||(e.ConfigurationTarget=ai={}));let li=e.RelativePattern=class{get base(){return this.c}set base(M){this.c=M,this.e=d.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,se){if(typeof M!="string"&&(!M||!d.URI.isUri(M)&&!d.URI.isUri(M.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof M=="string"?this.baseUri=d.URI.file(M):d.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=li=Le([G],li);const ci=new WeakMap;function hn(B,M){ci.set(B,M)}e.setBreakpointId=hn;let jt=e.Breakpoint=class{constructor(M,se,be,Be){this.enabled=typeof M=="boolean"?M:!0,typeof se=="string"&&(this.condition=se),typeof be=="string"&&(this.hitCondition=be),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this.c||(this.c=ci.get(this)??(0,R.generateUuid)()),this.c}};e.Breakpoint=jt=Le([G],jt);let ui=e.SourceBreakpoint=class extends jt{constructor(M,se,be,Be,He){if(super(se,be,Be,He),M===null)throw(0,L.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=ui=Le([G],ui);let hi=e.FunctionBreakpoint=class extends jt{constructor(M,se,be,Be,He){super(se,be,Be,He),this.functionName=M}};e.FunctionBreakpoint=hi=Le([G],hi);let fi=e.DataBreakpoint=class extends jt{constructor(M,se,be,Be,He,et,nt){if(super(Be,He,et,nt),!se)throw(0,L.illegalArgument)("dataId");this.label=M,this.dataId=se,this.canPersist=be}};e.DataBreakpoint=fi=Le([G],fi);let di=e.DebugAdapterExecutable=class{constructor(M,se,be){this.command=M,this.args=se||[],this.options=be}};e.DebugAdapterExecutable=di=Le([G],di);let mi=e.DebugAdapterServer=class{constructor(M,se){this.port=M,this.host=se}};e.DebugAdapterServer=mi=Le([G],mi);let gi=e.DebugAdapterNamedPipeServer=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=gi=Le([G],gi);let pi=e.DebugAdapterInlineImplementation=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=pi=Le([G],pi);let vi=e.EvaluatableExpression=class{constructor(M,se){this.range=M,this.expression=se}};e.EvaluatableExpression=vi=Le([G],vi);var bi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(bi||(e.InlineCompletionTriggerKind=bi={}));let Ei=e.InlineValueText=class{constructor(M,se){this.range=M,this.text=se}};e.InlineValueText=Ei=Le([G],Ei);let wi=e.InlineValueVariableLookup=class{constructor(M,se,be=!0){this.range=M,this.variableName=se,this.caseSensitiveLookup=be}};e.InlineValueVariableLookup=wi=Le([G],wi);let yi=e.InlineValueEvaluatableExpression=class{constructor(M,se){this.range=M,this.expression=se}};e.InlineValueEvaluatableExpression=yi=Le([G],yi);let Si=e.InlineValueContext=class{constructor(M,se){this.frameId=M,this.stoppedLocation=se}};e.InlineValueContext=Si=Le([G],Si);var Ii;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ii||(e.FileChangeType=Ii={}));let Di=e.FileSystemError=ae=class extends Error{static FileExists(M){return new ae(M,y.FileSystemProviderErrorCode.FileExists,ae.FileExists)}static FileNotFound(M){return new ae(M,y.FileSystemProviderErrorCode.FileNotFound,ae.FileNotFound)}static FileNotADirectory(M){return new ae(M,y.FileSystemProviderErrorCode.FileNotADirectory,ae.FileNotADirectory)}static FileIsADirectory(M){return new ae(M,y.FileSystemProviderErrorCode.FileIsADirectory,ae.FileIsADirectory)}static NoPermissions(M){return new ae(M,y.FileSystemProviderErrorCode.NoPermissions,ae.NoPermissions)}static Unavailable(M){return new ae(M,y.FileSystemProviderErrorCode.Unavailable,ae.Unavailable)}constructor(M,se=y.FileSystemProviderErrorCode.Unknown,be){super(d.URI.isUri(M)?M.toString(!0):M),this.code=be?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,ae.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};e.FileSystemError=Di=ae=Le([G],Di);let Ci=e.FoldingRange=class{constructor(M,se,be){this.start=M,this.end=se,this.kind=be}};e.FoldingRange=Ci=Le([G],Ci);var Pi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Pi||(e.FoldingRangeKind=Pi={}));var ki;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(ki||(e.CommentThreadCollapsibleState=ki={}));var Ai;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ai||(e.CommentMode=Ai={}));var Ri;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ri||(e.CommentState=Ri={}));var Ti;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ti||(e.CommentThreadState=Ti={}));class fn{constructor(M,se=[]){this.tokenTypes=M,this.tokenModifiers=se}}e.SemanticTokensLegend=fn;function dn(B){return typeof B>"u"||(0,v.isStringArray)(B)}class Yt{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let se=0,be=M.tokenTypes.length;se<be;se++)this.j.set(M.tokenTypes[se],se);for(let se=0,be=M.tokenModifiers.length;se<be;se++)this.k.set(M.tokenModifiers[se],se)}}push(M,se,be,Be,He){if(typeof M=="number"&&typeof se=="number"&&typeof be=="number"&&typeof Be=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this.n(M,se,be,Be,He);if(ie.isRange(M)&&typeof se=="string"&&dn(be))return this.m(M,se,be);throw(0,L.illegalArgument)()}m(M,se,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Be=M.start.line,He=M.start.character,et=M.end.character-M.start.character,nt=this.j.get(se);let ft=0;if(be)for(const bt of be){if(!this.k.has(bt))throw new Error("`tokenModifier` is not in the provided legend");const It=this.k.get(bt);ft|=1<<It>>>0}this.n(Be,He,et,nt,ft)}n(M,se,be,Be,He){if(this.f&&(M<this.c||M===this.c&&se<this.e)){this.f=!1;const ft=this.g.length/5|0;let bt=0,It=0;for(let Dt=0;Dt<ft;Dt++){let kt=this.g[5*Dt],Wt=this.g[5*Dt+1];kt===0?(kt=bt,Wt+=It):kt+=bt,this.g[5*Dt]=kt,this.g[5*Dt+1]=Wt,bt=kt,It=Wt}}let et=M,nt=se;this.f&&this.h>0&&(et-=this.c,et===0&&(nt-=this.e)),this.g[this.h++]=et,this.g[this.h++]=nt,this.g[this.h++]=be,this.g[this.h++]=Be,this.g[this.h++]=He,this.c=M,this.e=se}static o(M){const se=[],be=M.length/5|0;for(let nt=0;nt<be;nt++)se[nt]=nt;se.sort((nt,ft)=>{const bt=M[5*nt],It=M[5*ft];if(bt===It){const Dt=M[5*nt+1],kt=M[5*ft+1];return Dt-kt}return bt-It});const Be=new Uint32Array(M.length);let He=0,et=0;for(let nt=0;nt<be;nt++){const ft=5*se[nt],bt=M[ft+0],It=M[ft+1],Dt=M[ft+2],kt=M[ft+3],Wt=M[ft+4],cn=bt-He,Nn=cn===0?It-et:It,Ht=5*nt;Be[Ht+0]=cn,Be[Ht+1]=Nn,Be[Ht+2]=Dt,Be[Ht+3]=kt,Be[Ht+4]=Wt,He=bt,et=It}return Be}build(M){return this.f?new Jt(new Uint32Array(this.g),M):new Jt(Yt.o(this.g),M)}}e.SemanticTokensBuilder=Yt;class Jt{constructor(M,se){this.resultId=se,this.data=M}}e.SemanticTokens=Jt;class mn{constructor(M,se,be){this.start=M,this.deleteCount=se,this.data=be}}e.SemanticTokensEdit=mn;class gn{constructor(M,se){this.resultId=se,this.edits=M}}e.SemanticTokensEdits=gn;var Li;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Li||(e.DebugConsoleMode=Li={}));let Xt=e.QuickInputButtons=class{constructor(){}};Xt.Back={iconPath:new Lt("arrow-left")},e.QuickInputButtons=Xt=Le([G],Xt);var Oi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var Ni;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ni||(e.InputBoxValidationSeverity=Ni={}));var Fi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Fi||(e.ExtensionKind=Fi={}));class pn{static validate(M){if(typeof M.badge=="string"){let se=(0,A.nextCharLength)(M.badge,0);if(se<M.badge.length&&(se+=(0,A.nextCharLength)(M.badge,se)),M.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Lt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,se,be){this.badge=M,this.tooltip=se,this.color=be}}e.FileDecoration=pn;let Mi=e.ColorTheme=class{constructor(M){this.kind=M}};e.ColorTheme=Mi=Le([G],Mi);var Ui;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ui||(e.ColorThemeKind=Ui={}));class Ot{static isNotebookRange(M){return M instanceof Ot?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,se){if(M<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");M<=se?(this.c=M,this.e=se):(this.c=se,this.e=M)}with(M){let se=this.c,be=this.e;return M.start!==void 0&&(se=M.start),M.end!==void 0&&(be=M.end),se===this.c&&be===this.e?this:new Ot(se,be)}}e.NotebookRange=Ot;class xt{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(se=>xt.isNotebookCellData(se))}static isNotebookCellData(M){return!0}constructor(M,se,be,Be,He,et,nt){this.kind=M,this.value=se,this.languageId=be,this.mime=Be,this.outputs=He??[],this.metadata=et,this.executionSummary=nt,xt.validate(this)}}e.NotebookCellData=xt;class vn{constructor(M){this.cells=M}}e.NotebookData=vn;class St{static isNotebookCellOutputItem(M){return M instanceof St?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const se={name:M.name,message:M.message,stack:M.stack};return St.json(se,"application/vnd.code.notebook.error")}static stdout(M){return St.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return St.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,se="application/octet-stream"){return new St(M,se)}static text(M,se=D.Mimes.text){const be=rt(St,S,"f",O).encode(String(M));return new St(be,se)}static json(M,se="text/x-json"){const be=JSON.stringify(M,void 0,"	");return St.text(be,se)}constructor(M,se){this.data=M,this.mime=se;const be=(0,D.normalizeMimeType)(se,!0);if(!be)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}e.NotebookCellOutputItem=St,S=St,O={value:new TextEncoder};class qt{static isNotebookCellOutput(M){return M instanceof qt?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,se=!1){const be=new Set,Be=new Set;for(let He=0;He<M.length;He++){const et=M[He],nt=(0,D.normalizeMimeType)(et.mime);if(!be.has(nt)||(0,m.isTextStreamMime)(nt)){be.add(nt);continue}Be.add(He),se&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return Be.size===0?M:M.filter((He,et)=>!Be.has(et))}constructor(M,se,be){this.items=qt.ensureUniqueMimeTypes(M,!0),typeof se=="string"?(this.id=se,this.metadata=be):(this.id=(0,R.generateUuid)(),this.metadata=se??be)}}e.NotebookCellOutput=qt;var Bi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Bi||(e.NotebookCellKind=Bi={}));var zi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var ji;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var $i;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})($i||(e.NotebookEditorRevealType=$i={}));class bn{constructor(M,se){this.text=M,this.alignment=se}}e.NotebookCellStatusBarItem=bn;var Wi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Wi||(e.NotebookControllerAffinity=Wi={}));var Hi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Hi||(e.NotebookControllerAffinity2=Hi={}));class En{constructor(M,se=[]){this.uri=M,this.provides=(0,w.asArray)(se)}}e.NotebookRendererScript=En;class wn{constructor(M){this.label=M}}e.NotebookKernelSourceAction=wn;let Vi=e.TimelineItem=class{constructor(M,se){this.label=M,this.timestamp=se}};e.TimelineItem=Vi=Le([G],Vi);var xi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(xi||(e.ExtensionMode=xi={}));var qi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(qi||(e.ExtensionRuntime=qi={}));var Gi;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Gi||(e.StandardTokenType=Gi={}));class yn{constructor(M,se){this.ranges=M,this.wordPattern=se}}e.LinkedEditingRanges=yn;class Sn{constructor(M,se){this.c=M,this.e=se}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=Sn;var Ki;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Ki||(e.TestResultState=Ki={}));var Yi;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(Yi||(e.TestRunProfileKind=Yi={}));let Qt=e.TestRunRequest=class{constructor(M=void 0,se=void 0,be=void 0,Be=!1){this.include=M,this.exclude=se,this.profile=be,this.continuous=Be}};e.TestRunRequest=Qt=Le([G],Qt);let Ji=e.TestRunRequest2=class extends Qt{};e.TestRunRequest2=Ji=Le([G],Ji);let Xi=e.TestMessage=ue=class{static diff(M,se,be){const Be=new ue(M);return Be.expectedOutput=se,Be.actualOutput=be,Be}constructor(M){this.message=M}};e.TestMessage=Xi=ue=Le([G],Xi);let Qi=e.TestTag=class{constructor(M){this.id=M}};e.TestTag=Qi=Le([G],Qi);let $t=e.CoveredCount=class{constructor(M,se){this.covered=M,this.total=se}};e.CoveredCount=$t=Le([G],$t);let Zi=e.FileCoverage=ge=class{static fromDetails(M,se){const be=new $t(0,0),Be=new $t(0,0),He=new $t(0,0);for(const nt of se)if("branches"in nt){be.total+=1,be.covered+=nt.executionCount>0?1:0;for(const ft of nt.branches)Be.total+=1,Be.covered+=ft.executionCount>0?1:0}else He.total+=1,He.covered+=nt.executionCount>0?1:0;const et=new ge(M,be,Be.total>0?Be:void 0,He.total>0?He:void 0);return et.detailedCoverage=se,et}constructor(M,se,be,Be){this.uri=M,this.statementCoverage=se,this.branchCoverage=be,this.functionCoverage=Be}};e.FileCoverage=Zi=ge=Le([G],Zi);let _i=e.StatementCoverage=class{constructor(M,se,be=[]){this.executionCount=M,this.location=se,this.branches=be}};e.StatementCoverage=_i=Le([G],_i);let en=e.BranchCoverage=class{constructor(M,se){this.executionCount=M,this.location=se}};e.BranchCoverage=en=Le([G],en);let tn=e.FunctionCoverage=class{constructor(M,se){this.executionCount=M,this.location=se}};e.FunctionCoverage=tn=Le([G],tn);var nn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(nn||(e.ExternalUriOpenerPriority=nn={}));var rn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(rn||(e.WorkspaceTrustState=rn={}));var sn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(sn||(e.PortAutoForwardAction=sn={}));class In{constructor(M,se,be,Be,He,et){this.kind=M,this.name=se,this.detail=be,this.uri=Be,this.range=He,this.selectionRange=et}}e.TypeHierarchyItem=In;class Dn{constructor(M){this.uri=M}}e.TextTabInput=Dn;class Cn{constructor(M,se){this.original=M,this.modified=se}}e.TextDiffTabInput=Cn;class Pn{constructor(M,se,be,Be){this.base=M,this.input1=se,this.input2=be,this.result=Be}}e.TextMergeTabInput=Pn;class kn{constructor(M,se){this.uri=M,this.viewType=se}}e.CustomEditorTabInput=kn;class An{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=An;class Rn{constructor(M,se){this.uri=M,this.notebookType=se}}e.NotebookEditorTabInput=Rn;class Tn{constructor(M,se,be){this.original=M,this.modified=se,this.notebookType=be}}e.NotebookDiffEditorTabInput=Tn;class Ln{constructor(){}}e.TerminalEditorTabInput=Ln;class On{constructor(M,se){this.uri=M,this.inputBoxUri=se}}e.InteractiveWindowInput=On;var on;(function(B){B[B.Up=1]="Up",B[B.Down=2]="Down"})(on||(e.InteractiveSessionVoteDirection=on={}));var an;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(an||(e.InteractiveSessionCopyKind=an={}));var ln;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone"})(ln||(e.InteractiveEditorResponseFeedbackKind=ln={}))}),define(pe[135],ve([1,0,18,15,151,71,98,28,142,61,57,22,8,4,51,159,225,131,89,129,69,90,133,134]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(ye){function Ie(Q){const{selectionStartLineNumber:Pe,selectionStartColumn:Fe,positionLineNumber:We,positionColumn:Me}=Q,Ze=new n.Position(Pe-1,Fe-1),lt=new n.Position(We-1,Me-1);return new n.Selection(Ze,lt)}ye.to=Ie;function fe(Q){const{anchor:Pe,active:Fe}=Q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}ye.from=fe})(r||(e.Selection=r={}));var i;(function(ye){function Ie(Q){if(!Q)return;const{start:Pe,end:Fe}=Q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}ye.from=Ie;function fe(Q){if(!Q)return;const{startLineNumber:Pe,startColumn:Fe,endLineNumber:We,endColumn:Me}=Q;return new n.Range(Pe-1,Fe-1,We-1,Me-1)}ye.to=fe})(i||(e.Range=i={}));var a;(function(ye){function Ie(fe){switch(fe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}ye.to=Ie})(a||(e.TokenType=a={}));var l;(function(ye){function Ie(Q){return new n.Position(Q.lineNumber-1,Q.column-1)}ye.to=Ie;function fe(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=fe})(l||(e.Position=l={}));var c;(function(ye){function Ie(Pe,Fe,We){return(0,w.coalesce)((0,w.asArray)(Pe).map(Me=>fe(Me,Fe,We)))}ye.from=Ie;function fe(Pe,Fe,We){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:We?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Q(Pe.scheme,Fe),pattern:De.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:We?.isBuiltin}}function Q(Pe,Fe){return Fe&&typeof Pe=="string"?Fe.transformOutgoingScheme(Pe):Pe}})(c||(e.DocumentSelector=c={}));var p;(function(ye){function Ie(Q){switch(Q){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}ye.from=Ie;function fe(Q){switch(Q){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(p||(e.DiagnosticTag=p={}));var P;(function(ye){function Ie(Q){let Pe;return Q.code&&((0,E.isString)(Q.code)||(0,E.isNumber)(Q.code)?Pe=String(Q.code):Pe={value:String(Q.code.value),target:Q.code.target}),{...i.from(Q.range),message:Q.message,source:Q.source,code:Pe,severity:I.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(T.from),tags:Array.isArray(Q.tags)?(0,w.coalesce)(Q.tags.map(p.from)):void 0}}ye.from=Ie;function fe(Q){const Pe=new n.Diagnostic(i.to(Q),Q.message,I.to(Q.severity));return Pe.source=Q.source,Pe.code=(0,E.isString)(Q.code)?Q.code:Q.code?.value,Pe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(T.to),Pe.tags=Q.tags&&(0,w.coalesce)(Q.tags.map(p.to)),Pe}ye.to=fe})(P||(e.Diagnostic=P={}));var T;(function(ye){function Ie(Q){return{...i.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=Ie;function fe(Q){return new n.DiagnosticRelatedInformation(new n.Location(Q.resource,i.to(Q)),Q.message)}ye.to=fe})(T||(e.DiagnosticRelatedInformation=T={}));var I;(function(ye){function Ie(Q){switch(Q){case n.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}ye.from=Ie;function fe(Q){switch(Q){case s.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}ye.to=fe})(I||(e.DiagnosticSeverity=I={}));var F;(function(ye){function Ie(Q){return typeof Q=="number"&&Q>=n.ViewColumn.One?Q-1:Q===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}ye.from=Ie;function fe(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(F||(e.ViewColumn=F={}));function H(ye){return typeof ye.range<"u"}function ee(ye){return ye.length===0?!0:!!H(ye[0])}e.isDecorationOptionsArr=ee;var ce;(function(ye){function Ie(Me){return Me.map(ye.from)}ye.fromMany=Ie;function fe(Me){return Me&&typeof Me=="object"&&typeof Me.language=="string"&&typeof Me.value=="string"}function Q(Me){let Ze;if(fe(Me)){const{language:ct,value:pt}=Me;Ze={value:"```"+ct+`
`+pt+"\n```\n"}}else n.MarkdownString.isMarkdownString(Me)?Ze={value:Me.value,isTrusted:Me.isTrusted,supportThemeIcons:Me.supportThemeIcons,supportHtml:Me.supportHtml,baseUri:Me.baseUri}:typeof Me=="string"?Ze={value:Me}:Ze={value:""};const lt=Object.create(null);Ze.uris=lt;const mt=ct=>{try{let pt=m.URI.parse(ct,!0);pt=pt.with({query:Pe(pt.query,lt)}),lt[ct]=pt}catch{}return""},ut=new v.marked.Renderer;return ut.link=mt,ut.image=ct=>typeof ct=="string"?mt(D.parseHrefAndDimensions(ct).href):"",(0,v.marked)(Ze.value,{renderer:ut}),Ze}ye.from=Q;function Pe(Me,Ze){if(!Me)return Me;let lt;try{lt=(0,d.parse)(Me)}catch{}if(!lt)return Me;let mt=!1;return lt=(0,y.cloneAndChange)(lt,ut=>{if(m.URI.isUri(ut)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[ct]=ut,mt=!0,ct}else return}),mt?JSON.stringify(lt):Me}function Fe(Me){const Ze=new n.MarkdownString(Me.value,Me.supportThemeIcons);return Ze.isTrusted=Me.isTrusted,Ze.supportHtml=Me.supportHtml,Ze.baseUri=Me.baseUri?m.URI.from(Me.baseUri):void 0,Ze}ye.to=Fe;function We(Me){if(Me)return typeof Me=="string"?Me:ye.from(Me)}ye.fromStrict=We})(ce||(e.MarkdownString=ce={}));function ae(ye){return ee(ye)?ye.map(Ie=>({range:i.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?ce.fromMany(Ie.hoverMessage):Ie.hoverMessage?ce.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):ye.map(Ie=>({range:i.from(Ie)}))}e.fromRangeOrRangeWithMessage=ae;function ue(ye){return typeof ye>"u"?ye:typeof ye=="string"?m.URI.file(ye):ye}e.pathOrURIToURI=ue;var ge;(function(ye){function Ie(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ue(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Ie})(ge||(e.ThemableDecorationAttachmentRenderOptions=ge={}));var G;(function(ye){function Ie(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?ge.from(fe.before):void 0,after:fe.after?ge.from(fe.after):void 0}}ye.from=Ie})(G||(e.ThemableDecorationRenderOptions=G={}));var te;(function(ye){function Ie(fe){if(typeof fe>"u")return fe;switch(fe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Ie})(te||(e.DecorationRangeBehavior=te={}));var W;(function(ye){function Ie(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?te.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?G.from(fe.light):void 0,dark:fe.dark?G.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?ge.from(fe.before):void 0,after:fe.after?ge.from(fe.after):void 0}}ye.from=Ie})(W||(e.DecorationRenderOptions=W={}));var K;(function(ye){function Ie(Q){return{text:Q.newText,eol:Q.newEol&&Qe.from(Q.newEol),range:i.from(Q.range)}}ye.from=Ie;function fe(Q){const Pe=new n.TextEdit(i.to(Q.range),Q.text);return Pe.newEol=typeof Q.eol>"u"?void 0:Qe.to(Q.eol),Pe}ye.to=fe})(K||(e.TextEdit=K={}));var q;(function(ye){function Ie(Q,Pe){const Fe={edits:[]};if(Q instanceof n.WorkspaceEdit){const We=new A.ResourceSet;for(const Me of Q._allEntries())Me._type===1&&m.URI.isUri(Me.to)&&Me.from===void 0&&We.add(Me.to);for(const Me of Q._allEntries())if(Me._type===1){let Ze;Me.options?.contents&&(ArrayBuffer.isView(Me.options.contents)?Ze={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(Me.options.contents))}:Ze={type:"dataTransferItem",id:Me.options.contents._itemId}),Fe.edits.push({oldResource:Me.from,newResource:Me.to,options:{...Me.options,contents:Ze},metadata:Me.metadata})}else Me._type===2?Fe.edits.push({resource:Me.uri,textEdit:K.from(Me.edit),versionId:We.has(Me.uri)?void 0:Pe?.getTextDocumentVersion(Me.uri),metadata:Me.metadata}):Me._type===6?Fe.edits.push({resource:Me.uri,textEdit:{range:i.from(Me.range),text:Me.edit.value,insertAsSnippet:!0},versionId:We.has(Me.uri)?void 0:Pe?.getTextDocumentVersion(Me.uri),metadata:Me.metadata}):Me._type===3?Fe.edits.push({metadata:Me.metadata,resource:Me.uri,cellEdit:Me.edit,notebookMetadata:Me.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Me.uri)}):Me._type===5&&Fe.edits.push({metadata:Me.metadata,resource:Me.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Me.uri),cellEdit:{editType:1,index:Me.index,count:Me.count,cells:Me.cells.map(_e.from)}})}return Fe}ye.from=Ie;function fe(Q){const Pe=new n.WorkspaceEdit,Fe=new A.ResourceMap;for(const We of Q.edits)if(We.textEdit){const Me=We,Ze=m.URI.revive(Me.resource),lt=i.to(Me.textEdit.range),mt=Me.textEdit.text,ut=Me.textEdit.insertAsSnippet;let ct;ut?ct=n.SnippetTextEdit.replace(lt,new n.SnippetString(mt)):ct=n.TextEdit.replace(lt,mt);const pt=Fe.get(Ze);pt?pt.push(ct):Fe.set(Ze,[ct])}else Pe.renameFile(m.URI.revive(We.oldResource),m.URI.revive(We.newResource),We.options);for(const[We,Me]of Fe)Pe.set(We,Me);return Pe}ye.to=fe})(q||(e.WorkspaceEdit=q={}));var ie;(function(ye){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}ye.from=fe;function Q(Pe){for(const Fe in Ie)if(Ie[Fe]===Pe)return Number(Fe);return n.SymbolKind.Property}ye.to=Q})(ie||(e.SymbolKind=ie={}));var re;(function(ye){function Ie(Q){switch(Q){case n.SymbolTag.Deprecated:return 1}}ye.from=Ie;function fe(Q){switch(Q){case 1:return n.SymbolTag.Deprecated}}ye.to=fe})(re||(e.SymbolTag=re={}));var de;(function(ye){function Ie(Q){return{name:Q.name,kind:ie.from(Q.kind),tags:Q.tags&&Q.tags.map(re.from),containerName:Q.containerName,location:U.from(Q.location)}}ye.from=Ie;function fe(Q){const Pe=new n.SymbolInformation(Q.name,ie.to(Q.kind),Q.containerName,U.to(Q.location));return Pe.tags=Q.tags&&Q.tags.map(re.to),Pe}ye.to=fe})(de||(e.WorkspaceSymbol=de={}));var $;(function(ye){function Ie(Q){const Pe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),kind:ie.from(Q.kind),tags:Q.tags?.map(re.from)??[]};return Q.children&&(Pe.children=Q.children.map(Ie)),Pe}ye.from=Ie;function fe(Q){const Pe=new n.DocumentSymbol(Q.name,Q.detail,ie.to(Q.kind),i.to(Q.range),i.to(Q.selectionRange));return(0,w.isNonEmptyArray)(Q.tags)&&(Pe.tags=Q.tags.map(re.to)),Q.children&&(Pe.children=Q.children.map(fe)),Pe}ye.to=fe})($||(e.DocumentSymbol=$={}));var V;(function(ye){function Ie(Q){const Pe=new n.CallHierarchyItem(ie.to(Q.kind),Q.name,Q.detail||"",m.URI.revive(Q.uri),i.to(Q.range),i.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}ye.to=Ie;function fe(Q,Pe,Fe){if(Pe=Pe??Q._sessionId,Fe=Fe??Q._itemId,Pe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Fe,name:Q.name,detail:Q.detail,kind:ie.from(Q.kind),uri:Q.uri,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),tags:Q.tags?.map(re.from)}}ye.from=fe})(V||(e.CallHierarchyItem=V={}));var N;(function(ye){function Ie(fe){return new n.CallHierarchyIncomingCall(V.to(fe.from),fe.fromRanges.map(Q=>i.to(Q)))}ye.to=Ie})(N||(e.CallHierarchyIncomingCall=N={}));var k;(function(ye){function Ie(fe){return new n.CallHierarchyOutgoingCall(V.to(fe.to),fe.fromRanges.map(Q=>i.to(Q)))}ye.to=Ie})(k||(e.CallHierarchyOutgoingCall=k={}));var U;(function(ye){function Ie(Q){return{range:Q.range&&i.from(Q.range),uri:Q.uri}}ye.from=Ie;function fe(Q){return new n.Location(m.URI.revive(Q.uri),i.to(Q.range))}ye.to=fe})(U||(e.location=U={}));var X;(function(ye){function Ie(Q){const Pe=Q,Fe=Q;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Fe.uri,range:i.from(Pe.targetRange?Pe.targetRange:Fe.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}ye.from=Ie;function fe(Q){return{targetUri:m.URI.revive(Q.uri),targetRange:i.to(Q.range),targetSelectionRange:Q.targetSelectionRange?i.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?i.to(Q.originSelectionRange):void 0}}ye.to=fe})(X||(e.DefinitionLink=X={}));var ne;(function(ye){function Ie(Q){return{range:i.from(Q.range),contents:ce.fromMany(Q.contents)}}ye.from=Ie;function fe(Q){return new n.Hover(Q.contents.map(ce.to),i.to(Q.range))}ye.to=fe})(ne||(e.Hover=ne={}));var z;(function(ye){function Ie(Q){return{range:i.from(Q.range),expression:Q.expression}}ye.from=Ie;function fe(Q){return new n.EvaluatableExpression(i.to(Q.range),Q.expression)}ye.to=fe})(z||(e.EvaluatableExpression=z={}));var j;(function(ye){function Ie(Q){if(Q instanceof n.InlineValueText)return{type:"text",range:i.from(Q.range),text:Q.text};if(Q instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Ie;function fe(Q){switch(Q.type){case"text":return{range:i.to(Q.range),text:Q.text};case"variable":return{range:i.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:i.to(Q.range),expression:Q.expression}}}ye.to=fe})(j||(e.InlineValue=j={}));var Y;(function(ye){function Ie(Q){return{frameId:Q.frameId,stoppedLocation:i.from(Q.stoppedLocation)}}ye.from=Ie;function fe(Q){return new n.InlineValueContext(Q.frameId,i.to(Q.stoppedLocation))}ye.to=fe})(Y||(e.InlineValueContext=Y={}));var x;(function(ye){function Ie(Q){return{range:i.from(Q.range),kind:Q.kind}}ye.from=Ie;function fe(Q){return new n.DocumentHighlight(i.to(Q.range),Q.kind)}ye.to=fe})(x||(e.DocumentHighlight=x={}));var Z;(function(ye){function Ie(fe){switch(fe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}ye.to=Ie})(Z||(e.CompletionTriggerKind=Z={}));var J;(function(ye){function Ie(fe){return{triggerKind:Z.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Ie})(J||(e.CompletionContext=J={}));var _;(function(ye){function Ie(Q){switch(Q){case n.CompletionItemTag.Deprecated:return 1}}ye.from=Ie;function fe(Q){switch(Q){case 1:return n.CompletionItemTag.Deprecated}}ye.to=fe})(_||(e.CompletionItemTag=_={}));var le;(function(ye){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function fe(Fe){return Ie.get(Fe)??9}ye.from=fe;const Q=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Fe){return Q.get(Fe)??n.CompletionItemKind.Property}ye.to=Pe})(le||(e.CompletionItemKind=le={}));var Ee;(function(ye){function Ie(fe,Q){const Pe=new n.CompletionItem(fe.label);return Pe.insertText=fe.insertText,Pe.kind=le.to(fe.kind),Pe.tags=fe.tags?.map(_.to),Pe.detail=fe.detail,Pe.documentation=D.isMarkdownString(fe.documentation)?ce.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,g.Range.isIRange(fe.range)?Pe.range=i.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Pe.insertText=new n.SnippetString(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Fe=>K.to(Fe))),Pe.command=Q&&fe.command?Q.fromInternal(fe.command):void 0,Pe}ye.to=Ie})(Ee||(e.CompletionItem=Ee={}));var Ce;(function(ye){function Ie(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ce.fromStrict(Q.documentation)}}ye.from=Ie;function fe(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?ce.to(Q.documentation):Q.documentation}}ye.to=fe})(Ce||(e.ParameterInformation=Ce={}));var ke;(function(ye){function Ie(Q){return{label:Q.label,documentation:ce.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ce.from):[],activeParameter:Q.activeParameter}}ye.from=Ie;function fe(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?ce.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ce.to):[],activeParameter:Q.activeParameter}}ye.to=fe})(ke||(e.SignatureInformation=ke={}));var Ue;(function(ye){function Ie(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ke.from):[]}}ye.from=Ie;function fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ke.to):[]}}ye.to=fe})(Ue||(e.SignatureHelp=Ue={}));var je;(function(ye){function Ie(fe,Q){const Pe=new n.InlayHint(l.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(me.to.bind(void 0,fe)),Q.kind&&Se.to(Q.kind));return Pe.textEdits=Q.textEdits&&Q.textEdits.map(K.to),Pe.tooltip=D.isMarkdownString(Q.tooltip)?ce.to(Q.tooltip):Q.tooltip,Pe.paddingLeft=Q.paddingLeft,Pe.paddingRight=Q.paddingRight,Pe}ye.to=Ie})(je||(e.InlayHint=je={}));var me;(function(ye){function Ie(fe,Q){const Pe=new n.InlayHintLabelPart(Q.label);return Pe.tooltip=D.isMarkdownString(Q.tooltip)?ce.to(Q.tooltip):Q.tooltip,b.Command.is(Q.command)&&(Pe.command=fe.fromInternal(Q.command)),Q.location&&(Pe.location=U.to(Q.location)),Pe}ye.to=Ie})(me||(e.InlayHintLabelPart=me={}));var Se;(function(ye){function Ie(Q){return Q}ye.from=Ie;function fe(Q){return Q}ye.to=fe})(Se||(e.InlayHintKind=Se={}));var we;(function(ye){function Ie(Q){return{range:i.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=Ie;function fe(Q){let Pe;if(Q.url)try{Pe=typeof Q.url=="string"?m.URI.parse(Q.url,!0):m.URI.revive(Q.url)}catch{}return new n.DocumentLink(i.to(Q.range),Pe)}ye.to=fe})(we||(e.DocumentLink=we={}));var Ne;(function(ye){function Ie(Q){const Pe=new n.ColorPresentation(Q.label);return Q.textEdit&&(Pe.textEdit=K.to(Q.textEdit)),Q.additionalTextEdits&&(Pe.additionalTextEdits=Q.additionalTextEdits.map(Fe=>K.to(Fe))),Pe}ye.to=Ie;function fe(Q){return{label:Q.label,textEdit:Q.textEdit?K.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Pe=>K.from(Pe)):void 0}}ye.from=fe})(Ne||(e.ColorPresentation=Ne={}));var ze;(function(ye){function Ie(Q){return new n.Color(Q[0],Q[1],Q[2],Q[3])}ye.to=Ie;function fe(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=fe})(ze||(e.Color=ze={}));var tt;(function(ye){function Ie(Q){return{range:i.from(Q.range)}}ye.from=Ie;function fe(Q){return new n.SelectionRange(i.to(Q.range))}ye.to=fe})(tt||(e.SelectionRange=tt={}));var Ve;(function(ye){function Ie(fe){switch(fe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}ye.to=Ie})(Ve||(e.TextDocumentSaveReason=Ve={}));var Xe;(function(ye){function Ie(Q){switch(Q){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Ie;function fe(Q){switch(Q){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}ye.to=fe})(Xe||(e.TextEditorLineNumbersStyle=Xe={}));var Qe;(function(ye){function Ie(Q){if(Q===n.EndOfLine.CRLF)return 1;if(Q===n.EndOfLine.LF)return 0}ye.from=Ie;function fe(Q){if(Q===1)return n.EndOfLine.CRLF;if(Q===0)return n.EndOfLine.LF}ye.to=fe})(Qe||(e.EndOfLine=Qe={}));var it;(function(ye){function Ie(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Ie})(it||(e.ProgressLocation=it={}));var Ge;(function(ye){function Ie(Q){const Pe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Pe.kind=Ye.from(Q.kind)),Pe}ye.from=Ie;function fe(Q){const Pe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Pe.kind=Ye.to(Q.kind)),Pe}ye.to=fe})(Ge||(e.FoldingRange=Ge={}));var Ye;(function(ye){function Ie(Q){if(Q)switch(Q){case n.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}ye.from=Ie;function fe(Q){if(Q)switch(Q.value){case b.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}ye.to=fe})(Ye||(e.FoldingRangeKind=Ye={}));var he;(function(ye){function Ie(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?u.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Ie})(he||(e.TextEditorOpenOptions=he={}));var De;(function(ye){function Ie(Fe){return Fe instanceof n.RelativePattern?Fe.toJSON():typeof Fe=="string"?Fe:fe(Fe)||Q(Fe)?new n.RelativePattern(Fe.baseUri??Fe.base,Fe.pattern).toJSON():Fe}ye.from=Ie;function fe(Fe){const We=Fe;return We?m.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function Q(Fe){const We=Fe;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function Pe(Fe){return typeof Fe=="string"?Fe:new n.RelativePattern(m.URI.revive(Fe.baseUri),Fe.pattern)}ye.to=Pe})(De||(e.GlobPattern=De={}));var Te;(function(ye){function Ie(fe){if(fe){if(Array.isArray(fe))return fe.map(Ie);if(typeof fe=="string")return fe;{const Q=fe;return{language:Q.language,scheme:Q.scheme,pattern:De.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=Ie})(Te||(e.LanguageSelector=Te={}));var Re;(function(ye){function Ie(Q){return{start:Q.start,end:Q.end}}ye.from=Ie;function fe(Q){return new n.NotebookRange(Q.start,Q.end)}ye.to=fe})(Re||(e.NotebookRange=Re={}));var Oe;(function(ye){function Ie(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=Ie;function fe(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=fe})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var $e;(function(ye){function Ie(fe){if(fe===f.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(fe===f.NotebookCellExecutionState.Pending)return;if(fe===f.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Ie})($e||(e.NotebookCellExecutionState=$e={}));var qe;(function(ye){function Ie(Q){switch(Q){case n.NotebookCellKind.Markup:return f.CellKind.Markup;case n.NotebookCellKind.Code:default:return f.CellKind.Code}}ye.from=Ie;function fe(Q){switch(Q){case f.CellKind.Markup:return n.NotebookCellKind.Markup;case f.CellKind.Code:default:return n.NotebookCellKind.Code}}ye.to=fe})(qe||(e.NotebookCellKind=qe={}));var xe;(function(ye){function Ie(Q){const Pe={metadata:Q.metadata??Object.create(null),cells:[]};for(const Fe of Q.cells)n.NotebookCellData.validate(Fe),Pe.cells.push(_e.from(Fe));return Pe}ye.from=Ie;function fe(Q){const Pe=new n.NotebookData(Q.cells.map(_e.to));return(0,E.isEmptyObject)(Q.metadata)||(Pe.metadata=Q.metadata),Pe}ye.to=fe})(xe||(e.NotebookData=xe={}));var _e;(function(ye){function Ie(Q){return{cellKind:qe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Oe.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Je.from):[]}}ye.from=Ie;function fe(Q){return new n.NotebookCellData(qe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Je.to):void 0,Q.metadata,Q.internalMetadata?Oe.to(Q.internalMetadata):void 0)}ye.to=fe})(_e||(e.NotebookCellData=_e={}));var Ke;(function(ye){function Ie(Q){return{mime:Q.mime,valueBytes:L.VSBuffer.wrap(Q.data)}}ye.from=Ie;function fe(Q){return new n.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}ye.to=fe})(Ke||(e.NotebookCellOutputItem=Ke={}));var Je;(function(ye){function Ie(Q){return{outputId:Q.id,items:Q.items.map(Ke.from),metadata:Q.metadata}}ye.from=Ie;function fe(Q){const Pe=Q.items.map(Ke.to);return new n.NotebookCellOutput(Pe,Q.outputId,Q.metadata)}ye.to=fe})(Je||(e.NotebookCellOutput=Je={}));var at;(function(ye){function Ie(Pe){return Q(Pe)?{include:(0,E.withNullAsUndefined)(De.from(Pe.include)),exclude:(0,E.withNullAsUndefined)(De.from(Pe.exclude))}:(0,E.withNullAsUndefined)(De.from(Pe))}ye.from=Ie;function fe(Pe){return Q(Pe)?{include:De.to(Pe.include),exclude:De.to(Pe.exclude)}:De.to(Pe)}ye.to=fe;function Q(Pe){const Fe=Pe;return Fe?!(0,E.isUndefinedOrNull)(Fe.include)&&!(0,E.isUndefinedOrNull)(Fe.exclude):!1}})(at||(e.NotebookExclusiveDocumentPattern=at={}));var vt;(function(ye){function Ie(fe,Q,Pe){const Fe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Fe,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Ie})(vt||(e.NotebookStatusBarItem=vt={}));var ot;(function(ye){function Ie(fe,Q,Pe){const Fe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:Q.toInternal(Fe,Pe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ye.from=Ie})(ot||(e.NotebookKernelSourceAction=ot={}));var Mt;(function(ye){function Ie(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Ie})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var Et;(function(ye){function Ie(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=Ie;function fe(Q){return new n.NotebookRendererScript(m.URI.revive(Q.uri),Q.provides)}ye.to=fe})(Et||(e.NotebookRendererScript=Et={}));var Ct;(function(ye){function Ie(Q){return{message:ce.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location&&{range:i.from(Q.location.range),uri:Q.location.uri}}}ye.from=Ie;function fe(Q){const Pe=new n.TestMessage(typeof Q.message=="string"?Q.message:ce.to(Q.message));return Pe.actualOutput=Q.actual,Pe.expectedOutput=Q.expected,Pe.location=Q.location?U.to(Q.location):void 0,Pe}ye.to=fe})(Ct||(e.TestMessage=Ct={}));var ht;(function(ye){ye.namespace=O.namespaceTestTag,ye.denamespace=O.denamespaceTestTag})(ht||(e.TestTag=ht={}));var dt;(function(ye){function Ie(Q){const Pe=(0,h.getPrivateApiFor)(Q).controllerId;return{extId:S.TestId.fromExtHostTestItem(Q,Pe).toString(),label:Q.label,uri:m.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Fe=>ht.namespace(Pe,Fe.id)),range:g.Range.lift(i.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ce.fromStrict(Q.error)||null}}ye.from=Ie;function fe(Q){return{parent:void 0,error:void 0,id:S.TestId.fromString(Q.extId).localId,label:Q.label,uri:m.URI.revive(Q.uri),tags:(Q.tags||[]).map(Pe=>{const{tagId:Fe}=ht.denamespace(Pe);return new n.TestTag(Fe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=fe})(dt||(e.TestItem=dt={})),function(ye){function Ie(Q){return{id:Q.id}}ye.from=Ie;function fe(Q){return new n.TestTag(Q.id)}ye.to=fe}(ht||(e.TestTag=ht={}));var At;(function(ye){const Ie=(Q,Pe)=>{const Fe=[];for(const[Me,Ze]of Pe)S.TestId.compare(Ze.item.extId,Me)===2&&(Pe.delete(Me),Fe.push(Ze));const We={...dt.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Me=>({state:Me.state,duration:Me.duration,messages:Me.messages.filter(Ze=>Ze.type===0).map(Ct.to)})),children:Fe.map(Me=>Ie(Me,Pe))};for(const Me of We.children)Me.parent=We;return We};function fe(Q){const Pe=[],Fe=new Map;for(const We of Q.items){Fe.set(We.item.extId,We);const Me=S.TestId.root(We.item.extId);Q.request.targets.some(Ze=>Ze.controllerId===Me&&Ze.testIds.includes(We.item.extId))&&Pe.push(We)}return{completedAt:Q.completedAt,results:Pe.map(We=>Ie(We,Fe))}}ye.to=fe})(At||(e.TestResults=At={}));var Rt;(function(ye){function Ie(Fe){return{covered:Fe.covered,total:Fe.covered}}function fe(Fe){return"line"in Fe?l.from(Fe):i.from(Fe)}function Q(Fe){return"branches"in Fe?{count:Fe.executionCount,location:fe(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(We=>({count:We.executionCount,location:We.location&&fe(We.location)})):void 0}:{type:0,count:Fe.executionCount,location:fe(Fe.location)}}ye.fromDetailed=Q;function Pe(Fe){return{uri:Fe.uri,statement:Ie(Fe.statementCoverage),branch:Fe.branchCoverage&&Ie(Fe.branchCoverage),function:Fe.functionCoverage&&Ie(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Q)}}ye.fromFile=Pe})(Rt||(e.TestCoverage=Rt={}));var wt;(function(ye){function Ie(fe){switch(fe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}ye.to=Ie})(wt||(e.CodeActionTriggerKind=wt={}));var Pt;(function(ye){function Ie(Q){const Pe=new n.TypeHierarchyItem(ie.to(Q.kind),Q.name,Q.detail||"",m.URI.revive(Q.uri),i.to(Q.range),i.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}ye.to=Ie;function fe(Q,Pe,Fe){if(Pe=Pe??Q._sessionId,Fe=Fe??Q._itemId,Pe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Fe,kind:ie.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:i.from(Q.range),selectionRange:i.from(Q.selectionRange),tags:Q.tags?.map(re.from)}}ye.from=fe})(Pt||(e.TypeHierarchyItem=Pt={}));var Ut;(function(ye){function Ie(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Ie})(Ut||(e.ViewBadge=Ut={}));var gt;(function(ye){function Ie(Fe,We,Me){const Ze=We.fileData;return Ze?new class extends n.DataTransferItem{asFile(){return new n.DataTransferFile(Ze.name,m.URI.revive(Ze.uri),We.id,(0,C.once)(()=>Me()))}}("",We.id):Fe===R.Mimes.uriList&&We.uriListData?new n.DataTransferItem(Pe(We.uriListData)):new n.DataTransferItem(We.asString)}ye.to=Ie;async function fe(Fe,We){const Me=await We.asString();if(Fe===R.Mimes.uriList)return{id:We.id,asString:Me,fileData:void 0,uriListData:Q(Me)};const Ze=We.asFile();return{id:We.id,asString:Me,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function Q(Fe){return o.UriList.split(Fe).map(We=>{if(We.startsWith("#"))return We;try{return m.URI.parse(We)}catch{}return We})}function Pe(Fe){return o.UriList.create(Fe.map(We=>typeof We=="string"?We:m.URI.revive(We)))}})(gt||(e.DataTransferItem=gt={}));var Tt;(function(ye){function Ie(Q,Pe){const Fe=Q.items.map(([We,Me])=>[We,gt.to(We,Me,()=>Pe(Me.id))]);return new n.DataTransfer(Fe)}ye.toDataTransfer=Ie;async function fe(Q){const Pe={items:[]},Fe=[];return Q.forEach((We,Me)=>{Fe.push((async()=>{Pe.items.push([Me,await gt.from(Me,We)])})())}),await Promise.all(Fe),Pe}ye.toDataTransferDTO=fe})(Tt||(e.DataTransfer=Tt={}));var st;(function(ye){function Ie(Q){return{message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}ye.to=Ie;function fe(Q){return{kind:"reply",message:Q.message,metadata:Q.metadata,title:Q.title,tooltip:Q.tooltip}}ye.from=fe})(st||(e.InteractiveSessionReplyFollowup=st={}));var yt;(function(ye){function Ie(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",args:fe.args}:st.from(fe)}ye.from=Ie})(yt||(e.InteractiveSessionFollowup=yt={}))}),define(pe[279],ve([1,0,51,131,69,130,90,135,4]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const d=(f,S,O,t)=>{let n=S;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!O(n,r)){const i=n;n=r,f.listener?.(t(r,i))}}}},R=(f,S)=>f===S,y={range:(f,S)=>f===S?!0:!f||!S?!1:f.isEqual(S),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,S)=>!(f.length!==S.length||f.some(O=>!S.find(t=>O.id===t.id)))},E=f=>S=>({op:4,update:f(S)}),m=(f,S)=>({range:(()=>{let O;const t=E(n=>({range:w.Range.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return O},set(n){f.listener?.({op:6}),y.range(O,n)||(O=n,f.listener?.(t(n)))}}})(),label:d(f,S,y.label,E(O=>({label:O}))),description:d(f,void 0,y.description,E(O=>({description:O}))),sortText:d(f,void 0,y.sortText,E(O=>({sortText:O}))),canResolveChildren:d(f,!1,y.canResolveChildren,O=>({op:2,state:O})),busy:d(f,!1,y.busy,E(O=>({busy:O}))),error:d(f,void 0,y.error,E(O=>({error:A.MarkdownString.fromStrict(O)||null}))),tags:d(f,[],y.tags,(O,t)=>({op:1,new:O.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),g=f=>{const S=o.TestId.fromString(f.extId),O=new s(S.controllerId,S.localId,f.label,v.URI.revive(f.uri)||void 0);return O.range=A.Range.to(f.range||void 0),O.description=f.description||void 0,O.sortText=f.sortText||void 0,O.tags=f.tags.map(t=>A.TestTag.to({id:(0,D.denamespaceTestTag)(t).tagId})),O},b=f=>{let S;for(const O of f.tests){const t=g(O.item);(0,L.getPrivateApiFor)(t).parent=S,S=t}return S};e.toItemFromContext=b;class s{constructor(S,O,t,n){if(O.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(O)} symbol`);const r=(0,L.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof h?void 0:r.parent}},children:{value:(0,C.createTestItemChildren)(r,L.getPrivateApiFor,s),enumerable:!0,writable:!1},...m(r,t)})}}e.TestItemImpl=s;class h extends s{constructor(S,O){super(S,S,O,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class u extends C.TestItemCollection{constructor(S,O,t){super({controllerId:S,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:L.getPrivateApiFor,getChildren:n=>n.children,root:new h(S,O),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=u}),define(pe[280],ve([1,0,36,200,52]),function(oe,e,w,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function C(D,A,v,d){const R=new w.ExtensionIdentifierMap;return D.forEach(y=>{const E=R.get(y.identifier);E&&d.warn((0,L.localize)(0,null,E.extensionLocation.fsPath,y.extensionLocation.fsPath)),R.set(y.identifier,y)}),A.forEach(y=>{const E=R.get(y.identifier);if(E)if(E.isBuiltin){if(o.gte(E.version,y.version)){d.warn(`Skipping extension ${y.extensionLocation.path} in favour of the builtin extension ${E.extensionLocation.path}.`);return}y.isBuiltin=!0}else d.warn((0,L.localize)(1,null,E.extensionLocation.fsPath,y.extensionLocation.fsPath));else if(y.isBuiltin){d.warn(`Skipping obsolete builtin extension ${y.extensionLocation.path}`);return}R.set(y.identifier,y)}),v.forEach(y=>{d.info((0,L.localize)(2,null,y.extensionLocation.fsPath));const E=R.get(y.identifier);E&&E.isBuiltin&&(y.isBuiltin=!0),R.set(y.identifier,y)}),Array.from(R.values())}e.dedupExtensions=C}),define(pe[281],ve([1,0,7,3,29,4,42,49,64,56,280,13]),function(oe,e,w,L,o,C,D,A,v,d,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class E{constructor(b,s,h,u,f,S,O){this.b=b,this.c=h,this.d=u,this.f=f,this.g=S,this.h=O;const t=s.args["install-builtin-extension"];if(t){f.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!s.args["do-not-sync"],installPreReleaseVersion:!!s.args["pre-release"]};D.mark("code/server/willInstallBuiltinExtensions"),this.a=b.installExtensions([],this.i(t),r,!!s.args.force).then(()=>{D.mark("code/server/didInstallBuiltinExtensions"),f.trace("Finished installing builtin extensions")},i=>{f.error(i)})}else this.a=Promise.resolve();const n=s.args["install-extension"];n&&(f.trace("Installing extensions passed via args..."),this.a.then(()=>b.installExtensions(this.i(n),[],{isMachineScoped:!!s.args["do-not-sync"],installPreReleaseVersion:!!s.args["pre-release"],isApplicationScoped:!0},!!s.args.force)).then(()=>{f.trace("Finished installing extensions")},r=>{f.error(r)}))}i(b){return b.map(s=>/\.vsix$/i.test(s)?C.URI.file((0,w.isAbsolute)(s)?s:(0,w.join)((0,o.cwd)(),s)):s)}whenExtensionsReady(){return this.a}async scanExtensions(b,s,h,u){D.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${b}`),await this.whenExtensionsReady();const f=h?h.filter(O=>O.scheme===y.Schemas.file).map(O=>O.fsPath):void 0;s=s??this.c.defaultProfile.extensionsResource;const S=await this.j(s,b??L.language,f,u);return this.f.trace("Scanned Extensions",S),this.q(S),D.mark("code/server/didScanExtensions"),S}async scanSingleExtension(b,s,h){await this.whenExtensionsReady();const u=b.scheme===y.Schemas.file?b.fsPath:null;if(!u)return null;const f=await this.n(u,s,h??L.language);return f?(this.q([f]),f):null}async j(b,s,h,u){await this.o(s,u);const[f,S,O]=await Promise.all([this.l(s),this.m(b,s),this.k(s,h)]);return(0,R.dedupExtensions)(f,S,O,this.f)}async k(b,s){return s?(await Promise.all(s.map(h=>this.d.scanOneOrMultipleExtensions(C.URI.file((0,w.resolve)(h)),1,{language:b})))).flat().map(h=>(0,d.toExtensionDescription)(h,!0)):[]}async l(b){return(await this.d.scanSystemExtensions({language:b,useCache:!0})).map(h=>(0,d.toExtensionDescription)(h,!1))}async m(b,s){return(await this.d.scanUserExtensions({profileLocation:b,language:s,useCache:!0})).map(u=>(0,d.toExtensionDescription)(u,!1))}async n(b,s,h){const u=C.URI.file((0,w.resolve)(b)),f=s?0:1,S=await this.d.scanExistingExtension(u,f,{language:h});return S?(0,d.toExtensionDescription)(S,!1):null}async o(b,s){if(!(b===L.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(u=>u.id===b)){this.f.trace(`Language Pack ${b} is already installed. Skipping language pack installation.`);return}}catch(h){this.f.error(h)}if(!s){this.f.trace(`No language pack id provided for language ${b}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${s} for language ${b} is not installed. It will be installed now.`);try{await this.b.installExtensions([s],[],{isMachineScoped:!0},!0)}catch(h){this.f.error(h)}}}q(b){const s=(t,n)=>t.replace(/file/g,"vscode-remote"),h=t=>{let n="";return n+=t.global?"g":"",n+=t.ignoreCase?"i":"",n+=t.multiline?"m":"",new RegExp(s(t.source,!0),n)},u=new class{mapDefined(t){return v.ContextKeyDefinedExpr.create(t)}mapNot(t){return v.ContextKeyNotExpr.create(t)}mapEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyEqualsExpr.create(t,s(n,!1)):v.ContextKeyEqualsExpr.create(t,n)}mapNotEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyNotEqualsExpr.create(t,s(n,!1)):v.ContextKeyNotEqualsExpr.create(t,n)}mapGreater(t,n){return v.ContextKeyGreaterExpr.create(t,n)}mapGreaterEquals(t,n){return v.ContextKeyGreaterEqualsExpr.create(t,n)}mapSmaller(t,n){return v.ContextKeySmallerExpr.create(t,n)}mapSmallerEquals(t,n){return v.ContextKeySmallerEqualsExpr.create(t,n)}mapRegex(t,n){return t==="resourceScheme"&&n?v.ContextKeyRegexExpr.create(t,h(n)):v.ContextKeyRegexExpr.create(t,n)}mapIn(t,n){return v.ContextKeyInExpr.create(t,n)}mapNotIn(t,n){return v.ContextKeyNotInExpr.create(t,n)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const n=v.ContextKeyExpr.deserialize(t.when);if(!n)return;const r=n.map(u);t.when=r.serialize()},S=t=>{if(Array.isArray(t))for(const n of t)f(n);else f(t)},O=t=>{for(const n in t)S(t[n])};b.forEach(t=>{t.contributes&&(t.contributes.menus&&O(t.contributes.menus),t.contributes.keybindings&&S(t.contributes.keybindings),t.contributes.views&&O(t.contributes.views))})}}e.RemoteExtensionsScannerService=E;class m{constructor(b,s){this.a=b,this.b=s}listen(b,s){throw new Error("Invalid listen")}async call(b,s,h){const u=this.b(b);switch(s){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=h[0],S=h[1]?C.URI.revive(u.transformIncoming(h[1])):void 0,O=Array.isArray(h[2])?h[2].map(r=>C.URI.revive(u.transformIncoming(r))):void 0,t=h[3];return(await this.a.scanExtensions(f,S,O,t)).map(r=>(0,A.transformOutgoingURIs)(r,u))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(C.URI.revive(u.transformIncoming(h[0])),h[1],h[2]);return f?(0,A.transformOutgoingURIs)(f,u):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=m}),define(pe[136],ve([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const L=[];function o(A){const v=new w(A);return L[v.nid]=v,v}e.createProxyIdentifier=o;function C(A){return L[A].sid}e.getStringIdentifierForProxy=C;class D{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=D}),define(pe[282],ve([1,0,136]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var o;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(o||(e.TabInputKind=o={}));var C;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(C||(e.TabModelOperationKind=C={}));var D;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(D||(e.WebviewEditorCapabilities=D={}));var A;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var v;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var d;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(d||(e.NotebookEditorRevealType=d={}));var R;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class y{static mixin(s){return s._id=y.a++,s}}e.IdObject=y,y.a=0;var E;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(E||(e.ISuggestDataDtoField=E={}));var m;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var g;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,w.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,w.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,w.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,w.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,w.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,w.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,w.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,w.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostSemanticSimilarity:(0,w.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,w.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.createProxyIdentifier)("ExtHostIssueReporter")}});var Ft=this&&this.__classPrivateFieldSet||function(oe,e,w,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!o:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(oe,w):o?o.value=w:e.set(oe,w),w},rt=this&&this.__classPrivateFieldGet||function(oe,e,w,L){if(w==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!L:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?L:w==="a"?L.call(oe):L?L.value:e.get(oe)};define(pe[283],ve([1,0,8,134,135,22,282,18,12,61,51,106,4,2,5,266,279,15,136,39,96,37,277]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t){"use strict";var n,r,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=e.ExtHostCommands=class{constructor(I,F,H){n.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),i.set(this,void 0),Ft(this,n,I.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=F,Ft(this,i,H,"f"),Ft(this,r,I.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,ee=>{const ce=this.c.get(ee);return ce?.result===p.Void?ce:void 0},F),this.f=[{processArgument(ee){return(0,d.revive)(ee)}},{processArgument(ee){return(0,C.cloneAndChange)(ee,function(ce){if(R.Range.isIRange(ce))return o.Range.to(ce);if(y.Position.isIPosition(ce))return o.Position.to(ce);if(R.Range.isIRange(ce.range)&&E.URI.isUri(ce.uri))return o.location.to(ce);if(ce instanceof h.VSBuffer)return ce.buffer.buffer;if(!Array.isArray(ce))return ce})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const F=this.registerCommand(!1,I.id,async(...H)=>{const ee=I.args.map((ae,ue)=>{if(!ae.validate(H[ue]))throw new Error(`Invalid argument '${ae.name}' when running '${I.id}', received: ${H[ue]}`);return ae.convert(H[ue])}),ce=await this.executeCommand(I.internalId,...ee);return I.result.convert(ce,H,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new L.Disposable(()=>{F.dispose(),this.c.delete(I.id)})}registerCommand(I,F,H,ee,ce,ae){if(this.d.trace("ExtHostCommands#registerCommand",F),!F.trim().length)throw new Error("invalid id");if(this.b.has(F))throw new Error(`command '${F}' already exists`);return this.b.set(F,{callback:H,thisArg:ee,description:ce,extension:ae}),I&&rt(this,n,"f").$registerCommand(F),new L.Disposable(()=>{this.b.delete(F)&&I&&rt(this,n,"f").$unregisterCommand(F)})}executeCommand(I,...F){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,F,!0)}async g(I,F,H){if(this.b.has(I))return rt(this,n,"f").$fireCommandActivationEvent(I),this.h(I,F,!1);{let ee=!1;const ce=(0,C.cloneAndChange)(F,function(ae){if(ae instanceof L.Position)return o.Position.from(ae);if(ae instanceof L.Range)return o.Range.from(ae);if(ae instanceof L.Location)return o.location.from(ae);if(L.NotebookRange.isNotebookRange(ae))return o.NotebookRange.from(ae);if(ae instanceof ArrayBuffer)return ee=!0,h.VSBuffer.wrap(new Uint8Array(ae));if(ae instanceof Uint8Array)return ee=!0,h.VSBuffer.wrap(ae);if(ae instanceof h.VSBuffer)return ee=!0,ae;if(!Array.isArray(ae))return ae});try{const ae=await rt(this,n,"f").$executeCommand(I,ee?new u.SerializableObjectWithBuffers(ce):ce,H);return(0,d.revive)(ae)}catch(ae){if(ae instanceof Error&&ae.message==="$executeCommand:retry")return this.g(I,F,!1);throw ae}}}async h(I,F,H){const ee=this.b.get(I);if(!ee)throw new Error("Unknown command");const{callback:ce,thisArg:ae,description:ue}=ee;if(ue)for(let G=0;G<ue.args.length;G++)try{(0,w.validateConstraint)(F[G],ue.args[G].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${ue.args[G].name}' - ${ue.args[G].description}`)}const ge=S.StopWatch.create();try{return await ce.apply(ae,F)}catch(G){if(I===this.converter.delegatingCommandId){const te=this.converter.getActualCommand(...F);te&&(I=te.command)}if(this.d.error(G,I,ee.extension?.identifier),!H)throw G;if(ee.extension?.identifier){const te=rt(this,i,"f").onExtensionError(ee.extension.identifier,G);this.d.trace("forwarded error to extension?",te,ee.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.toErrorMessage)(G)),this.id=I,this.source=ee.extension?.displayName??ee.extension?.name}}}finally{this.j(ee,I,ge.elapsed())}}j(I,F,H){I.extension&&rt(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new O.TelemetryTrustedValue(F),duration:H})}$executeContributedCommand(I,...F){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const H=this.b.get(I);return H?(F=F.map(ee=>this.f.reduce((ce,ae)=>ae.processArgument(ce,H.extension?.identifier),ee)),this.h(I,F,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),rt(this,n,"f").$getCommands().then(F=>(I&&(F=F.filter(H=>H[0]!=="_")),F))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[F,H]of this.b){const{description:ee}=H;ee&&(I[F]=ee)}return Promise.resolve(I)}};n=new WeakMap,r=new WeakMap,i=new WeakMap,e.ExtHostCommands=a=Le([Ae(0,b.IExtHostRpcService),Ae(1,v.ILogService),Ae(2,t.IExtHostTelemetry)],a),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class l{constructor(I,F,H){this.d=I,this.f=F,this.g=H,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,F){if(!I)return;const H={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return H;const ee=this.f(I.command);if(ee)H.id=ee.internalId,H.arguments=ee.args.map((ce,ae)=>ce.convert(I.arguments&&I.arguments[ae]));else if((0,A.isNonEmptyArray)(I.arguments)){const ce=`${I.command}/${++this.c}`;this.b.set(ce,I),F.add((0,m.toDisposable)(()=>{this.b.delete(ce),this.g.trace("CommandsConverter#DISPOSE",ce)})),H.$ident=ce,H.id=this.delegatingCommandId,H.arguments=[ce],this.g.trace("CommandsConverter#CREATE",I.command,ce)}return H}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const F=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],F?F.command:"MISSING"),F?this.d.executeCommand(F.command,...F.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.CommandsConverter=l;class c{constructor(I,F,H,ee){this.name=I,this.description=F,this.validate=H,this.convert=ee}optional(){return new c(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,F){return new c(I??this.name,F??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",T=>E.URI.isUri(T),T=>T),c.Position=new c("position","A position in a text document",T=>L.Position.isPosition(T),o.Position.from),c.Range=new c("range","A range in a text document",T=>L.Range.isRange(T),o.Range.from),c.Selection=new c("selection","A selection in a text document",T=>L.Selection.isSelection(T),o.Selection.from),c.Number=new c("number","",T=>typeof T=="number",T=>T),c.String=new c("string","",T=>typeof T=="string",T=>T),c.CallHierarchyItem=new c("item","A call hierarchy item",T=>T instanceof L.CallHierarchyItem,o.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",T=>T instanceof L.TypeHierarchyItem,o.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",T=>T instanceof s.TestItemImpl,o.TestItem.from);class p{constructor(I,F){this.description=I,this.convert=F}}e.ApiCommandResult=p,p.Void=new p("no result",T=>T);class P{constructor(I,F,H,ee,ce){this.id=I,this.internalId=F,this.description=H,this.args=ee,this.result=ce}}e.ApiCommand=P}),define(pe[284],ve([1,0,9,2,13,214]),function(oe,e,w,L,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class D extends C.DiskFileSystemProviderClient{static register(v,d,R){const y=v.getConnection();if(!y)return L.Disposable.None;const E=new L.DisposableStore,m=(async()=>{try{const g=await v.getRawEnvironment();g?d.registerProvider(o.Schemas.vscodeRemote,E.add(new D(g,y))):R.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){R.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,w.getErrorMessage)(g))}})();return E.add(d.onWillActivateFileSystemProvider(g=>{g.scheme===o.Schemas.vscodeRemote&&g.join(m)})),E}constructor(v,d){super(d.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=D}),define(pe[91],ve([1,0,33,14,7,8,23,167,299,300]),function(oe,e,w,L,o,C,D,A,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const R=new RegExp(e.CorruptZipMessage);class y extends Error{constructor(n,r){let i=r.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=r}}e.ExtractError=y;function E(t){const n=t.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,i)=>r+i,n&61440)}function m(t){if(t instanceof y)return t;let n;return R.test(t.message)&&(n="CorruptZip"),new y(n,t)}function g(t,n,r,i,a,l){const c=o.dirname(n),p=o.join(i,c);if(!p.startsWith(i))return Promise.reject(new Error(A.localize(0,null,n)));const P=o.join(i,n);let T;return l.onCancellationRequested(()=>{T?.destroy()}),Promise.resolve(D.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((I,F)=>{if(!l.isCancellationRequested)try{T=(0,w.createWriteStream)(P,{mode:r}),T.once("close",()=>I()),T.once("error",F),t.once("error",F),t.pipe(T)}catch(H){F(H)}}))}function b(t,n,r,i){let a=(0,L.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),t.close()}),new Promise((c,p)=>{const P=new L.Sequencer,T=I=>{I.isCancellationRequested||(l++,t.readEntry())};t.once("error",p),t.once("close",()=>a.then(()=>{i.isCancellationRequested||t.entryCount===l?c():p(new y("Incomplete",new Error(A.localize(1,null,l,t.entryCount))))},p)),t.readEntry(),t.on("entry",I=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(I.fileName)){T(i);return}const F=I.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(F)){const ce=o.join(n,F);a=(0,L.createCancelablePromise)(ae=>D.Promises.mkdir(ce,{recursive:!0}).then(()=>T(ae)).then(void 0,p));return}const H=h(t,I),ee=E(I);a=(0,L.createCancelablePromise)(ce=>P.queue(()=>H.then(ae=>g(ae,F,ee,n,r,ce).then(()=>T(ce)))).then(null,p))})})}function s(t,n=!1){return new Promise((r,i)=>{(0,v.open)(t,n?{lazyEntries:!0}:void 0,(a,l)=>{a?i(m(a)):r((0,C.assertIsDefined)(l))})})}function h(t,n){return new Promise((r,i)=>{t.openReadStream(n,(a,l)=>{a?i(m(a)):r((0,C.assertIsDefined)(l))})})}function u(t,n){return new Promise((r,i)=>{const a=new d.ZipFile;n.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const l=(0,w.createWriteStream)(t);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>r(t))})}e.zip=u;function f(t,n,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let l=s(t,!0);return r.overwrite&&(l=l.then(c=>D.Promises.rm(n).then(()=>c))),l.then(c=>b(c,n,{sourcePathRegex:a},i))}e.extract=f;function S(t,n){return s(t).then(r=>new Promise((i,a)=>{r.on("entry",l=>{l.fileName===n&&h(r,l).then(c=>i(c),c=>a(c))}),r.once("close",()=>a(new Error(A.localize(2,null,n))))}))}function O(t,n){return S(t,n).then(r=>new Promise((i,a)=>{const l=[];r.once("error",a),r.on("data",c=>l.push(c)),r.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=O}),define(pe[285],ve([1,0,14,9,2,13,3,19,52,8,21,23,91,24,25,30,34,80,16,12]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let S=e.ExtensionsDownloader=class Zt extends o.Disposable{constructor(t,n,r,i,a,l){super(),this.h=n,this.i=r,this.j=i,this.k=a,this.l=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,n,r){await this.g;const i=(0,A.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,l=>this.i.download(t,l,n))}catch(l){throw new b.ExtensionManagementError(l.message,b.ExtensionManagementErrorCode.Download)}let a=!1;if(r&&this.m(t)){const l=await this.n(t);try{a=await this.k.verify(i.fsPath,l.fsPath,this.l.getLevel()===f.LogLevel.Trace)}catch(c){const p=c;if(a=p.code,p.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${p.output}`),a===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||a===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.ExtensionManagementError(E.CorruptZipMessage,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(l)}catch(c){this.l.error(c)}}}return a===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):a===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${a}': ${t.identifier.id}`),{location:i,verificationStatus:a}}m(t){if(!t.isSigned)return!1;const n=this.j.getValue("extensions.verifySignature");return(0,d.isBoolean)(n)?n:!0}async n(t){await this.g;const n=(0,A.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${Zt.c}`);return await this.r(t,n,r=>this.i.downloadSignatureArchive(t,r)),n}async r(t,n,r){if(await this.h.exists(n))return;if(n.scheme!==C.Schemas.file){await r(n);return}const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,R.generateUuid)()}`);await this.h.exists(i)||await r(i);try{await this.t(i,n,Date.now()+2*60*1e3)}catch(a){try{await this.h.del(i)}catch{}if(a.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(a)}. Deleted the file from downloaded location`,i.path),a}}async delete(t){await this.g,await this.h.del(t)}async t(t,n,r){try{await y.Promises.rename(t.fsPath,n.fsPath)}catch(i){if(D.isWindows&&i&&i.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.t(t,n,r);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],r=[],i=[];for(const c of t.children)if(c.name.endsWith(Zt.c))i.push(c.resource);else{const p=s.ExtensionKey.parse(c.name);p&&r.push([p,c])}const a=(0,s.groupByExtension)(r,([c])=>c),l=[];for(const c of a)c.sort((p,P)=>v.rcompare(p[0].version,P[0].version)),n.push(...c.slice(1).map(p=>p[1].resource)),l.push(c[0][1]);l.sort((c,p)=>c.mtime-p.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(c=>c.resource)),n.push(...i),await w.Promises.settled(n.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(t){this.l.error(t)}}v(t){return this.f?s.ExtensionKey.create(t).toString().toLowerCase():(0,R.generateUuid)()}};S.c=".sigzip",e.ExtensionsDownloader=S=Le([Ae(0,g.INativeEnvironmentService),Ae(1,u.IFileService),Ae(2,b.IExtensionGalleryService),Ae(3,m.IConfigurationService),Ae(4,h.IExtensionSignatureVerificationService),Ae(5,f.ILogService)],S)}),define(pe[286],ve([1,0,91,179]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function o(C){return(0,w.buffer)(C,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=o}),define(pe[137],ve([1,0,14,15,20,39,9,6,2,28,13,7,3,19,52,8,4,21,23,91,178,79,25,254,30,34,45,56,285,255,286,230,239,77,16,5,12,27,31,35,32]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t,n,r,i,a,l,c,p,P,T,I,F,H,ee,ce,ae,ue,ge,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(r.IExtensionManagementService);let te=e.ExtensionManagementService=class extends n.AbstractExtensionManagementService{constructor($,V,N,k,U,X,ne,z,j,Y,x,Z){super($,V,N,Y,Z),this.Z=U,this.ab=X,this.bb=ne,this.cb=j,this.db=x,this.X=this.B(new A.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new d.ResourceSet;const J=this.B(z.createInstance(p.ExtensionsLifecycle));this.S=this.B(z.createInstance(W,le=>J.postUninstall(le))),this.U=this.B(new T.ExtensionsManifestCache(Z,j,x,this,this.v)),this.W=this.B(z.createInstance(c.ExtensionsDownloader));const _=this.B(new I.ExtensionsWatcher(this,this.Z,Z,X,x,j,N));this.B(_.onDidChangeExtensionsByAnotherSource(le=>this.kb(le))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip($){this.v.trace("ExtensionManagementService#zip",$.identifier.id);const V=await this.jb($),N=await(0,f.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,V);return s.URI.file(N)}async unzip($){return this.v.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const{location:V,cleanup:N}=await this.fb($),k=y.resolve(V.fsPath);try{return await(0,P.getManifest)(k)}finally{await N()}}getInstalled($,V=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions($??null,V)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation($){return this.S.scanUserExtensionAtLocation($)}async install($,V={}){this.v.trace("ExtensionManagementService#install",$.toString());const{location:N,cleanup:k}=await this.fb($);try{const U=await(0,P.getManifest)(y.resolve(N.fsPath));if(U.engines&&U.engines.vscode&&!(0,F.isEngineValid)(U.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,i.getGalleryExtensionId)(U.publisher,U.name),this.w.version));return await this.z(U,N,V)}finally{await k()}}async installFromLocation($,V){this.v.trace("ExtensionManagementService#installFromLocation",$.toString());const N=await this.S.scanUserExtensionAtLocation($);if(!N)throw new Error(`Cannot find a valid extension from the location ${$.toString()}`);return await this.ob([[N,void 0]],V),this.v.info("Successfully installed extension",N.identifier.id,V.toString()),N}async installExtensionsFromProfile($,V,N){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",$,V.toString(),N.toString());const k=(await this.S.scanExtensions(1,V)).filter(U=>$.some(X=>(0,i.areSameExtensions)(X,U.identifier)));if(k.length){const U=await Promise.all(k.map(X=>this.S.scanMetadata(X,V)));await this.ob(k.map((X,ne)=>[X,U[ne]]),N),this.v.info("Successfully installed extensions",k.map(X=>X.identifier.id),N.toString())}return k}async updateMetadata($,V,N=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",$.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0),V.isMachineScoped=V.isMachineScoped||void 0,V.isBuiltin=V.isBuiltin||void 0,V.pinned=V.pinned||void 0,$=await this.S.updateMetadata($,V,N),this.U.invalidate(N),this.X.fire($),$}async reinstallFromGallery($){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",$.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const V=await this.getTargetPlatform(),[N]=await this.t.getExtensions([{...$.identifier,preRelease:$.preRelease}],{targetPlatform:V,compatible:!0},o.CancellationToken.None);if(!N)throw new Error(S.localize(2,null));await this.S.setUninstalled($);try{await this.S.removeUninstalledExtension($)}catch(k){throw new Error(S.localize(3,null,(0,C.toErrorMessage)(k)))}return this.installFromGallery(N)}copyExtensions($,V){return this.S.copyExtensions($,V)}markAsUninstalled(...$){return this.S.setUninstalled(...$)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch($){this.v.error($)}}async download($,V,N){const{location:k}=await this.W.download($,V,!N);return k}async fb($){if($.scheme===R.Schemas.file)return{location:$,async cleanup(){}};this.v.trace("Downloading extension from",$.toString());const V=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)());return await this.bb.download($,V),this.v.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.cb.del(V)}catch(k){this.v.error(k)}}}}P(){return this.y.defaultProfile.extensionsResource}Q($,V,N){if(s.URI.isUri(V))return new ie($,V,N,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const k=i.ExtensionKey.create(V).toString();let U=this.Y.get(k);return U||(this.Y.set(k,U=new q($,V,N,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),U.waitUntilTaskIsFinished().finally(()=>this.Y.delete(k))),U}R($,V){return new re($,V.profileLocation,this.ab)}async jb($){const V=async k=>{let U=await u.Promises.readdir(k);U=U.map(z=>y.join(k,z));const X=await Promise.all(U.map(z=>u.Promises.stat(z)));let ne=Promise.resolve([]);return X.forEach((z,j)=>{const Y=U[j];z.isFile()&&(ne=ne.then(x=>[...x,Y])),z.isDirectory()&&(ne=ne.then(x=>V(Y).then(Z=>[...x,...Z])))}),ne};return(await V($.location.fsPath)).map(k=>({path:`extension/${y.relative($.location.fsPath,k)}`,localPath:k}))}async kb({added:$,removed:V}){if(V)for(const N of V.extensions)this.v.info("Extensions removed from another source",N.id,V.profileLocation.toString()),this.p.fire({identifier:N,profileLocation:V.profileLocation});if($){const k=(await this.S.scanExtensions(1,$.profileLocation)).filter(U=>$.extensions.some(X=>(0,i.areSameExtensions)(X,U.identifier)));this.m.fire(k.map(U=>(this.v.info("Extensions added from another source",U.identifier.id,$.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:$.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(V=>this.lb.add(V)));const $=await this.cb.resolve(this.Z.userExtensionsLocation);for(const V of $.children??[])V.isDirectory&&this.lb.add(V.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(V=>this.nb(V)))}async nb($){if(!$.affects(this.Z.userExtensionsLocation,1))return;const V=[];for(const N of $.rawAdded){if(this.lb.has(N)||!this.db.extUri.isEqual(this.db.extUri.dirname(N),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(N,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(N).startsWith(".")||!(await this.cb.stat(N)).isDirectory)continue;const k=await this.S.scanUserExtensionAtLocation(N);k&&k.installedTimestamp===void 0&&(this.lb.add(N),V.push(k))}V.length&&(await this.ob(V.map(N=>[N,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",V.map(N=>N.identifier.id)))}async ob($,V){const N=$.map(k=>k[0]);await this.pb(N),await this.ab.addExtensionsToProfile($,V),this.m.fire(N.map(k=>({local:k,identifier:k.identifier,operation:1,profileLocation:V})))}async pb($){const V=await this.S.getUninstalledExtensions();for(const N of $){const k=i.ExtensionKey.create(N);V[k.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",k.id),await this.S.setInstalled(k),this.v.info("Removed the extension from uninstalled list:",k.id))}}};e.ExtensionManagementService=te=Le([Ae(0,r.IExtensionGalleryService),Ae(1,ue.ITelemetryService),Ae(2,ce.ILogService),Ae(3,t.INativeEnvironmentService),Ae(4,l.IExtensionsScannerService),Ae(5,a.IExtensionsProfileScannerService),Ae(6,O.IDownloadService),Ae(7,ee.IInstantiationService),Ae(8,H.IFileService),Ae(9,ae.IProductService),Ae(10,ge.IUriIdentityService),Ae(11,G.IUserDataProfilesService)],te);let W=e.ExtensionsScanner=class extends v.Disposable{constructor($,V,N,k,U,X){super(),this.k=$,this.l=V,this.m=N,this.n=k,this.p=U,this.s=X,this.h=this.B(new A.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,m.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new w.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions($,V){const N={includeInvalid:!0,profileLocation:V};let k=[];return $===null||$===0?k.push(...await this.m.scanAllExtensions({includeInvalid:!0},N,!1)):$===1&&k.push(...await this.m.scanUserExtensions(N)),k=$!==null?k.filter(U=>U.type===$):k,Promise.all(k.map(U=>this.y(U)))}async scanAllUserExtensions($){const V=await this.m.scanUserExtensions({includeAllVersions:!$,includeInvalid:!0});return Promise.all(V.map(N=>this.y(N)))}async scanUserExtensionAtLocation($){try{const V=await this.m.scanExistingExtension($,1,{includeInvalid:!0});if(V)return await this.y(V)}catch(V){this.s.error(V)}return null}async extractUserExtension($,V,N,k){await this.j.catch(()=>{});const U=$.toString(),X=y.join(this.m.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),ne=y.join(this.m.userExtensionsLocation.fsPath,U);try{await u.Promises.rm(ne)}catch{throw new r.ExtensionManagementError(S.localize(4,null,ne,$.id),r.ExtensionManagementErrorCode.Delete)}await this.u($,V,X,k),await this.m.updateMetadata(s.URI.file(X),N);try{this.h.fire(s.URI.file(ne)),await this.v($,X,ne,Date.now()+2*60*1e3),this.s.info("Renamed to",ne)}catch(z){try{await u.Promises.rm(X)}catch{}if(z.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",$.id);else throw this.s.info(`Rename failed because of ${(0,D.getErrorMessage)(z)}. Deleted from extracted location`,X),z}return this.w(s.URI.file(ne),1)}async scanMetadata($,V){return V?(await this.n.scanProfileExtensions(V)).find(k=>(0,i.areSameExtensions)(k.identifier,$.identifier))?.metadata:this.m.scanMetadata($.location)}async updateMetadata($,V,N){return N?await this.n.updateMetadata([[$,V]],N):await this.m.updateMetadata($.location,V),this.w($.location,$.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...$){const V=$.map(N=>i.ExtensionKey.create(N));await this.t(N=>V.forEach(k=>{N[k.toString()]=!0,this.s.info("Marked extension as uninstalled",k.toString())}))}async setInstalled($){await this.t(V=>delete V[$.toString()])}async removeExtension($,V){this.s.trace(`Deleting ${V} extension from disk`,$.identifier.id,$.location.fsPath);const N=this.p.extUri.joinPath(this.p.extUri.dirname($.location),`._${(0,h.generateUuid)()}`);await this.v($.identifier,$.location.fsPath,N.fsPath,Date.now()+2*60*1e3),await this.l.del(N,{recursive:!0}),this.s.info("Deleted from disk",$.identifier.id,$.location.fsPath)}async removeUninstalledExtension($){await this.removeExtension($,"uninstalled"),await this.t(V=>delete V[i.ExtensionKey.create($).toString()])}async copyExtensions($,V){const N=await this.scanExtensions(1,$),k=await Promise.all(N.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,$)]));await this.n.addExtensionsToProfile(k,V)}async t($){return this.g.queue(async()=>{let V;try{V=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(k){if((0,H.toFileOperationResult)(k)!==1)throw k}let N={};if(V)try{N=JSON.parse(V)}catch{}return $&&($(N),Object.keys(N).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(N))):await this.l.del(this.c)),N})}async u($,V,N,k){this.s.trace(`Started extracting the extension from ${V} to ${N}`);try{await u.Promises.rm(N)}catch(U){throw new r.ExtensionManagementError(this.D(U).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(V,N,{sourcePath:"extension",overwrite:!0},k),this.s.info(`Extracted extension to ${N}:`,$.id)}catch(U){try{await u.Promises.rm(N)}catch{}let X=r.ExtensionManagementErrorCode.Extract;throw U instanceof f.ExtractError&&(U.type==="CorruptZip"?X=r.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(X=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(U.message,X)}}async v($,V,N,k){try{await u.Promises.rename(V,N)}catch(U){if(E.isWindows&&U&&U.code==="EPERM"&&Date.now()<k)return this.s.info(`Failed renaming ${V} to ${N} with 'EPERM' error. Trying again...`,$.id),this.v($,V,N,k);throw new r.ExtensionManagementError(U.message||S.localize(5,null,V,N),U.code||r.ExtensionManagementErrorCode.Rename)}}async w($,V){const N=await this.m.scanExistingExtension($,V,{includeInvalid:!0});if(N)return this.y(N);throw new Error(S.localize(6,null,$.path))}async y($){const V=await this.l.resolve($.location);let N,k;return V.children&&(N=V.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,k=V.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:$.identifier,type:$.type,isBuiltin:$.isBuiltin||!!$.metadata?.isBuiltin,location:$.location,manifest:$.manifest,targetPlatform:$.targetPlatform,validations:$.validations,isValid:$.isValid,readmeUrl:N,changelogUrl:k,publisherDisplayName:$.metadata?.publisherDisplayName||null,publisherId:$.metadata?.publisherId||null,isApplicationScoped:!!$.metadata?.isApplicationScoped,isMachineScoped:!!$.metadata?.isMachineScoped,isPreReleaseVersion:!!$.metadata?.isPreReleaseVersion,preRelease:!!$.metadata?.preRelease,installedTimestamp:$.metadata?.installedTimestamp,updated:!!$.metadata?.updated,pinned:!!$.metadata?.pinned}}async z(){const $=await this.getUninstalledExtensions();if(Object.keys($).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys($));const V=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const U of V)$[i.ExtensionKey.create(U).toString()]||N.add(U.identifier.id.toLowerCase());try{const U=(0,i.groupByExtension)(V,X=>X.identifier);await w.Promises.settled(U.map(async X=>{const ne=X.sort((z,j)=>g.rcompare(z.manifest.version,j.manifest.version))[0];N.has(ne.identifier.id.toLowerCase())||await this.k(await this.y(ne))}))}catch(U){this.s.error(U)}const k=V.filter(U=>U.metadata&&$[i.ExtensionKey.create(U).toString()]);await Promise.allSettled(k.map(U=>this.removeUninstalledExtension(U)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const $=[];let V;try{V=await this.l.resolve(this.m.userExtensionsLocation)}catch(N){(0,H.toFileOperationResult)(N)!==1&&this.s.error(N)}for(const N of V?.children??[])N.isDirectory&&N.name.startsWith("._")&&(0,h.isUUID)(N.name.substring(2))&&$.push((async()=>{this.s.trace("Deleting the generated extension folder",N.resource.toString());try{await this.l.del(N.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",N.resource.toString())}catch(k){this.s.error(k)}})());await Promise.allSettled($)}D($){const V=Array.isArray($)?$:[$];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((N,k)=>new Error(`${N.message}${N.message?",":""}${k instanceof Error?k.message:k}`),new Error(""))}};e.ExtensionsScanner=W=Le([Ae(1,H.IFileService),Ae(2,l.IExtensionsScannerService),Ae(3,a.IExtensionsProfileScannerService),Ae(4,ge.IUriIdentityService),Ae(5,ce.ILogService)],W);class K extends n.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor($,V,N,k,U,X,ne,z,j){super(),this.identifier=$,this.source=V,this.m=N,this.n=k,this.o=U,this.p=X,this.q=ne,this.s=z,this.t=j,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h($){const[V,N]=await this.y($);return this.j=V.isBuiltin||V.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[V,N]],this.j),V}async v({zipPath:$,key:V,metadata:N},k){let U=await this.w(V);return U||(this.t.trace("Extracting extension...",V.id),U=await this.n.extractUserExtension(V,$,N,k),this.t.info("Extracting extension completed.",V.id)),U}async w($){return await this.x($)?(this.t.trace("Removing the extension from uninstalled list:",$.id),await this.n.setInstalled($),this.t.info("Removed the extension from uninstalled list:",$.id),(await this.n.scanAllUserExtensions(!0)).find(k=>i.ExtensionKey.create(k).equals($))):void 0}async x($){return!!(await this.n.getUninstalledExtensions())[$.toString()]}}class q extends K{constructor($,V,N,k,U,X,ne,z,j,Y){super(V.identifier,V,N,U,X,ne,z,j,Y),this.z=V,this.A=k}async y($){const N=(await this.n.scanExtensions(null,this.m.profileLocation)).find(ne=>(0,i.areSameExtensions)(ne.identifier,this.z.identifier));N&&(this.l=3);const k={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||N?.isMachineScoped,isBuiltin:this.m.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,b.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:N?.preRelease)};if(N?.manifest.version===this.z.version)return[await this.n.updateMetadata(N,k),k];const{location:U,verificationStatus:X}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=X,this.C(U.fsPath),[await this.v({zipPath:U.fsPath,key:i.ExtensionKey.create(this.z),metadata:k},$),k]}catch(ne){try{await this.A.delete(U)}catch(z){this.t.warn("Error while deleting the downloaded file",U.toString(),(0,D.getErrorMessage)(z))}throw ne}}async C($){try{await(0,P.getManifest)($)}catch(V){throw new r.ExtensionManagementError((0,n.joinErrors)(V).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=q;class ie extends K{constructor($,V,N,k,U,X,ne,z,j,Y){super({id:(0,i.getGalleryExtensionId)($.publisher,$.name)},V,N,U,X,ne,z,j,Y),this.z=$,this.A=V,this.B=k}async h($){const V=await super.h($);return this.E(V,$),V}async y($){const V=new i.ExtensionKey(this.identifier,this.z.version),k=(await this.n.scanExtensions(1,this.m.profileLocation)).find(ne=>(0,i.areSameExtensions)(this.identifier,ne.identifier)),U={isApplicationScoped:this.m.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||k?.isMachineScoped,isBuiltin:this.m.isBuiltin||k?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(k)if(this.l=3,V.equals(new i.ExtensionKey(k.identifier,k.manifest.version)))try{await this.n.removeExtension(k,"existing")}catch{throw new Error(S.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&g.gt(k.manifest.version,this.z.version)&&await this.n.setUninstalled(k);else{const ne=await this.w(V);if(ne)try{await this.n.removeExtension(ne,"existing")}catch{throw new Error(S.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:y.resolve(this.A.fsPath),key:V,metadata:U},$),U]}async E($,V){try{let[N]=await this.B.getExtensions([{id:$.identifier.id,version:$.manifest.version}],V);if(N||([N]=await this.B.getExtensions([{id:$.identifier.id}],V)),N){const k={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata($,k,this.m.profileLocation)}}catch{}}}class re extends n.AbstractExtensionTask{constructor($,V,N){super(),this.extension=$,this.j=V,this.k=N}async h($){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[70],ve([1,0,85,76,26,287,15,9,6,2,7,3,21,43,104]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(T,I){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,T,I)}constructor(T,I=""){this.f=!0,this.debugLabel=I,this.socket=T,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,A.onUnexpectedError)(F)}},this.socket.on("error",this.a),this.b=F=>{this.traceSocketEvent("close",{hadError:F}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(T){const I=F=>{this.traceSocketEvent("read",F),T(D.VSBuffer.wrap(F))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(T){const I=F=>{T({type:0,hadError:F,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(T){const I=()=>{T()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(T){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",T),this.socket.write(T.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,A.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,A.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((T,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),T();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),T()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=b;var s;(function(P){P[P.MinHeaderByteSize=2]="MinHeaderByteSize",P[P.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var h;(function(P){P[P.PeekHeader=1]="PeekHeader",P[P.ReadHeader=2]="ReadHeader",P[P.ReadBody=3]="ReadBody",P[P.Fin=4]="Fin"})(h||(h={}));class u extends d.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(T,I){this.socket.traceSocketEvent(T,I)}constructor(T,I,F,H){super(),this.f=this.B(new v.Emitter),this.g=this.B(new v.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=T,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:F?.byteLength||0,recordInflateBytes:H}),this.a=this.B(new f(this,I,F,H,this.f,(ee,ce)=>this.k(ee,ce))),this.B(this.a.onError(ee=>{console.error(ee),(0,A.onUnexpectedError)(ee),this.g.fire({type:0,hadError:!0,error:ee})})),this.b=new g.ChunkStream,this.B(this.socket.onData(ee=>this.l(ee))),this.B(this.socket.onClose(async ee=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ee)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(T){return this.f.event(T)}onClose(T){return this.g.event(T)}onEnd(T){return this.socket.onEnd(T)}write(T){let I=0;for(;I<T.byteLength;)this.a.writeMessage(T.slice(I,Math.min(I+262144,T.byteLength))),I+=262144}k(T,I){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",T);let F=2;T.byteLength<126?F+=0:T.byteLength<2**16?F+=2:F+=8;const H=D.VSBuffer.alloc(F);if(I?H.writeUInt8(194,0):H.writeUInt8(130,0),T.byteLength<126)H.writeUInt8(T.byteLength,1);else if(T.byteLength<2**16){H.writeUInt8(126,1);let ee=1;H.writeUInt8(T.byteLength>>>8&255,++ee),H.writeUInt8(T.byteLength>>>0&255,++ee)}else{H.writeUInt8(127,1);let ee=1;H.writeUInt8(0,++ee),H.writeUInt8(0,++ee),H.writeUInt8(0,++ee),H.writeUInt8(0,++ee),H.writeUInt8(T.byteLength>>>24&255,++ee),H.writeUInt8(T.byteLength>>>16&255,++ee),H.writeUInt8(T.byteLength>>>8&255,++ee),H.writeUInt8(T.byteLength>>>0&255,++ee)}this.socket.write(D.VSBuffer.concat([H,T]))}end(){this.h=!0,this.socket.end()}l(T){if(T.byteLength!==0){for(this.b.acceptChunk(T);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),F=I.readUInt8(0),H=(F&128)>>>7,ee=(F&64)>>>6,ce=I.readUInt8(1),ae=(ce&128)>>>7,ue=ce&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=H,this.j.firstFrameOfMessage&&(this.j.compressed=!!ee),this.j.firstFrameOfMessage=!!H,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),F=I.readUInt8(1),H=(F&128)>>>7;let ee=F&127,ce=1;ee===126?ee=I.readUInt8(++ce)*2**8+I.readUInt8(++ce):ee===127&&(ee=I.readUInt8(++ce)*0+I.readUInt8(++ce)*0+I.readUInt8(++ce)*0+I.readUInt8(++ce)*0+I.readUInt8(++ce)*2**24+I.readUInt8(++ce)*2**16+I.readUInt8(++ce)*2**8+I.readUInt8(++ce));let ae=0;H&&(ae=I.readUInt8(++ce)*2**24+I.readUInt8(++ce)*2**16+I.readUInt8(++ce)*2**8+I.readUInt8(++ce)),this.j.state=3,this.j.readLen=ee,this.j.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),t(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(I,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class f extends d.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(T,I,F,H,ee,ce){super(),this.l=T,this.m=ee,this.n=ce,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new v.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,I?(this.b=this.B(new S(this.l,H,F,{windowBits:15})),this.f=this.B(new O(this.l,{windowBits:15})),this.B(this.b.onError(ae=>this.a.fire(ae))),this.B(this.f.onError(ae=>this.a.fire(ae)))):(this.b=null,this.f=null)}writeMessage(T){this.g.push(T),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const T=this.g.shift();if(this.f){const I=await this.s(this.f,T);this.n(I,!0)}else this.n(T,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(T,I){return new Promise((F,H)=>{T.write(I),T.flush(ee=>F(ee))})}acceptFrame(T,I,F){this.h.push({data:T,isCompressed:I,isLastFrameOfMessage:F}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const T=this.h.shift();if(this.b&&T.isCompressed){const I=await this.w(this.b,T.data,T.isLastFrameOfMessage);this.m.fire(I)}else this.m.fire(T.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(T,I,F){return new Promise((H,ee)=>{T.write(I),F&&T.write(D.VSBuffer.fromByteArray([0,0,255,255])),T.flush(ce=>H(ce))})}}class S extends d.Disposable{get recordedInflateBytes(){return this.j?D.VSBuffer.concat(this.f):D.VSBuffer.alloc(0)}constructor(T,I,F,H){super(),this.h=T,this.j=I,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,C.createInflateRaw)(H),this.b.on("error",ee=>{this.h.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this.a.fire(ee)}),this.b.on("data",ee=>{this.h.traceSocketEvent("zlibInflateData",ee),this.g.push(D.VSBuffer.wrap(ee))}),F&&(this.h.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(T){this.j&&this.f.push(T.clone()),this.h.traceSocketEvent("zlibInflateWrite",T),this.b.write(T.buffer)}flush(T){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=D.VSBuffer.concat(this.g);this.g.length=0,T(I)})}}class O extends d.Disposable{constructor(T,I){super(),this.g=T,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,C.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent("zlibDeflateData",F),this.f.push(D.VSBuffer.wrap(F))})}write(T){this.g.traceSocketEvent("zlibDeflateWrite",T.buffer),this.b.write(T.buffer)}flush(T){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=D.VSBuffer.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),T(I)})}}function t(P,T){if(T===0)return;const I=P.byteLength>>>2;for(let ue=0;ue<I;ue++){const ge=P.readUInt32BE(ue*4);P.writeUInt32BE(ge^T,ue*4)}const F=I*4,H=P.byteLength-F,ee=T>>>24&255,ce=T>>>16&255,ae=T>>>8&255;H>=1&&P.writeUInt8(P.readUInt8(F)^ee,F),H>=2&&P.writeUInt8(P.readUInt8(F+1)^ce,F+1),H>=3&&P.writeUInt8(P.readUInt8(F+2)^ae,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function r(){const P=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${P}-sock`;const T=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,o.tmpdir)(),I=(0,R.join)(T,`vscode-ipc-${P}.sock`);return a(I),I}e.createRandomIPCHandle=r;function i(P,T,I){const F=(0,w.createHash)("md5").update(P).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${I}-${T}-sock`;const H=I.substr(0,4),ee=T.substr(0,6),ce=F.substr(0,8);let ae;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ae=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${ce}-${H}-${ee}.sock`):ae=(0,R.join)(P,`${H}-${ee}.sock`),a(ae),ae}e.createStaticIPCHandle=i;function a(P){const T=n[y.platform];typeof T=="number"&&P.length>=T&&console.warn(`WARNING: IPC handle "${P}" is longer than ${T} chars, try a shorter --user-data-dir`)}class l extends m.IPCServer{static b(T){const I=v.Event.fromNodeEventEmitter(T,"connection");return v.Event.map(I,F=>({protocol:new g.Protocol(new b(F,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(F,"close"))}))}constructor(T){super(l.b(T)),this.d=T}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function c(P){return new Promise((T,I)=>{const F=(0,L.createServer)();F.on("error",I),F.listen(P,()=>{F.removeListener("error",I),T(new l(F))})})}e.serve=c;function p(P,T){return new Promise((I,F)=>{const H=(0,L.createConnection)(P,()=>{H.removeListener("error",F),I(g.Client.fromSocket(new b(H,`ipc-client${T}`),T))});H.once("error",F)})}e.connect=p}),define(pe[138],ve([1,0,83,14,15,9,8,24,25,84,12,44,233,287]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let g=e.RequestService=class extends y.AbstractRequestService{constructor(u,f,S,O){super(!!f.isRemoteServer,O),this.j=u,this.k=f,this.l=S,this.m(),this.B(u.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const u=this.j.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,f){const{f:S,g:O}=this;let t;try{t=await(0,d.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,C.getErrorMessage)(i)))}const n={...process.env,...t},r=u.agent?u.agent:await(0,E.getProxyAgent)(u.url||"",n,{proxyUrl:S,strictSSL:O});return u.agent=r,u.strictSSL=O,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>s(u,f))}async resolveProxy(u){}};e.RequestService=g=Le([Ae(0,A.IConfigurationService),Ae(1,v.INativeEnvironmentService),Ae(2,R.ILogService),Ae(3,R.ILoggerService)],g);async function b(h){return((0,w.parse)(h.url).protocol==="https:"?await new Promise((S,O)=>{oe(["https"],S,O)}):await new Promise((S,O)=>{oe(["http"],S,O)})).request}async function s(h,u){return L.Promises.withAsyncBody(async(f,S)=>{const O=(0,w.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await b(h),n={hostname:O.hostname,port:O.port?parseInt(O.port):O.protocol==="https:"?443:80,protocol:O.protocol,path:O.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,D.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password);const r=t(n,i=>{const a=(0,D.isNumber)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)s({...h,url:i.headers.location,followRedirects:a-1},u).then(f,S);else{let l=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,m.createGunzip)())),f({res:i,stream:(0,o.streamToBufferReadableStream)(l)})}});r.on("error",S),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),u.onCancellationRequested(()=>{r.abort(),S(new C.CancellationError)})})}e.nodeRequest=s}),define(pe[139],ve([1,0,50,76,88,13,7,15,6,70,84,12,41,3,58,127,2,275,24]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(i={},a,l,c,p,P){const T=await(0,o.getNLSConfiguration)(l,c.userDataPath);let I={};if(a)try{I=await(0,R.getResolvedShellEnv)(P,p,c.args,process.env)}catch(ue){p.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const H={...process.env,...I,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(T,void 0,0),...i},ee=c.isBuilt?(0,D.join)(c.appRoot,"bin"):(0,D.join)(c.appRoot,"resources","server","bin-dev"),ce=(0,D.join)(ee,"remote-cli");let ae=t(H,"PATH");return ae?ae=ce+D.delimiter+ae:ae=ce,n(H,"PATH",ae),c.args["without-browser-env-var"]||(H.BROWSER=(0,D.join)(ee,"helpers",m.isWindows?"browser.cmd":"browser.sh")),r(H),H}e.buildUserEnvironment=f;class S{constructor(a,l){this.socket=a,this.initialDataChunk=l}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let a,l,c;return this.socket instanceof d.NodeSocket?(a=!0,l=!1,c=A.VSBuffer.alloc(0)):(a=!1,l=this.socket.permessageDeflate,c=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:a,permessageDeflate:l,inflateBytes:c.buffer.toString("base64")}}}let O=e.ExtensionHostConnection=class{constructor(a,l,c,p,P,T,I,F){this.i=a,this.j=P,this.l=T,this.m=I,this.n=F,this.b=new v.Emitter,this.onClose=this.b.event,this.c=!m.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=l,this.g=null,this.h=new S(c,p),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(a){this.l.info(`${this.o}${a}`)}q(a){this.l.error(`${this.o}${a}`)}async r(a,l){const c=new s.DisposableStore;c.add(l.socket),c.add((0,s.toDisposable)(()=>{a.destroy()}));const p=()=>{c.dispose()};c.add(l.socket.onEnd(p)),c.add(l.socket.onClose(p)),c.add(v.Event.fromNodeEventEmitter(a,"end")(p)),c.add(v.Event.fromNodeEventEmitter(a,"close")(p)),c.add(v.Event.fromNodeEventEmitter(a,"error")(p)),c.add(l.socket.onData(P=>a.write(P.buffer))),c.add(v.Event.fromNodeEventEmitter(a,"data")(P=>{l.socket.write(A.VSBuffer.wrap(P))})),l.initialDataChunk.byteLength>0&&a.write(l.initialDataChunk.buffer)}async s(a,l){await l.socketDrain();const c=l.toIExtHostSocketMessage();let p;l.socket instanceof d.NodeSocket?p=l.socket.socket:p=l.socket.socket.socket,a.send(c,p)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(a)}acceptReconnection(a,l,c){this.f=a,this.p("The client has reconnected.");const p=new S(l,c);if(!this.g){this.h=p;return}this.s(this.g,p)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(a){try{let l=process.execArgv?process.execArgv.filter(ce=>!/^--inspect(-brk)?=/.test(ce)):[];a.port&&!process.pkg&&(l=[`--inspect${a.break?"-brk":""}=${a.port}`]);const c=await f(a.env,!0,a.language,this.j,this.l,this.n);(0,g.removeDangerousEnvVariables)(c);let p;if(this.c)(0,h.writeExtHostConnection)(new h.SocketExtHostConnection,c),p=null;else{const{namedPipeServer:ce,pipeName:ae}=await this.u();(0,h.writeExtHostConnection)(new h.IPCExtHostConnection(ae),c),p=ce}const P={env:c,execArgv:l,silent:!0},T=["--type=extensionHost","--transformURIs"],I=this.j.args["use-host-proxy"];T.push(`--useHostProxy=${I?"true":"false"}`),this.g=w.fork(C.FileAccess.asFileUri("bootstrap-fork").fsPath,T,P);const F=this.g.pid;this.p(`<${F}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const H=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),ee=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(H(ce=>this.p(`<${F}> ${ce}`)),ee(ce=>this.p(`<${F}><stderr> ${ce}`)),this.g.on("error",ce=>{this.q(`<${F}> Extension Host Process had an error`),this.l.error(ce),this.t()}),this.g.on("exit",(ce,ae)=>{this.m.setExitInfo(this.i,{code:ce,signal:ae}),this.p(`<${F}> Extension Host Process exited with code: ${ce}, signal: ${ae}.`),this.t()}),p)p.on("connection",ce=>{p.close(),this.r(ce,this.h)});else{const ce=ae=>{ae.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",ce),this.s(this.g,this.h),this.h=null)};this.g.on("message",ce)}}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}u(){return new Promise((a,l)=>{const c=(0,d.createRandomIPCHandle)(),p=L.createServer();p.on("error",l),p.listen(c,()=>{p?.removeListener("error",l),a({pipeName:c,namedPipeServer:p})})})}};e.ExtensionHostConnection=O=Le([Ae(4,E.IServerEnvironmentService),Ae(5,y.ILogService),Ae(6,b.IExtensionHostStatusService),Ae(7,u.IConfigurationService)],O);function t(i,a){const l=Object.keys(i).filter(p=>p.toLowerCase()===a.toLowerCase()),c=l.length>0?l[0]:a;return i[c]}function n(i,a,l){const c=Object.keys(i).filter(P=>P.toLowerCase()===a.toLowerCase()),p=c.length>0?c[0]:a;i[p]=l}function r(i){for(const a of Object.keys(i))i[a]===null&&delete i[a]}}),define(pe[288],ve([1,0,81,12,63,115,24,44,138,37,31,30,125,137,80,109,53,2,110,66,13,16,27,41,118,82,119,9,4,7,29,231,79,35,123,62,3,56,128,32,45,67,126,124,112,113,194,103]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t,n,r,i,a,l,c,p,P,T,I,F,H,ee,ce,ae,ue,ge,G,te,W,K,q,ie,re,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class $ extends h.Disposable{constructor(U,X){super(),this.a=U,this.b=X,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const U=await this.f();await U.invokeFunction(async X=>{const ne=X.get(D.IConfigurationService),z=X.get(L.ILogService);process.platform==="win32"&&(0,de.setUNCHostAllowlist)((0,de.toUNCHostAllowlist)(ne.getValue("security.allowedUNCHosts")));try{await this.g(U.createInstance(r.ExtensionManagementCLI,new L.ConsoleLogger(z.getLevel(),!1)))}catch(j){throw z.error(j),console.error((0,l.getErrorMessage)(j)),j}})}async f(){const U=new w.ServiceCollection,X={_serviceBrand:void 0,...s.default};U.set(t.IProductService,X);const ne=new n.ServerEnvironmentService(this.a,X);U.set(n.IServerEnvironmentService,ne);const z=new ie.LoggerService((0,L.getLogLevel)(ne),ne.logsHome);U.set(L.ILoggerService,z);const j=new q.LogService(this.B(z.createLogger("remoteCLI",{name:(0,re.localize)(0,null)})));U.set(L.ILogService,j),j.trace(`Remote configuration data at ${this.b}`),j.trace("process arguments:",this.a);const Y=this.B(new u.FileService(j));U.set(O.IFileService,Y),Y.registerProvider(S.Schemas.file,this.B(new f.DiskFileSystemProvider(j)));const x=new H.UriIdentityService(Y);U.set(F.IUriIdentityService,x);const Z=this.B(new W.ServerUserDataProfilesService(x,ne,Y,j));U.set(ge.IUserDataProfilesService,Z);const J=this.B(new C.ConfigurationService(Z.defaultProfile.settingsResource,Y,new te.NullPolicyService,j));return U.set(D.IConfigurationService,J),await Promise.all([J.initialize(),Z.init()]),U.set(A.IRequestService,new o.SyncDescriptor(v.RequestService)),U.set(I.IDownloadService,new o.SyncDescriptor(T.DownloadService)),U.set(R.ITelemetryService,d.NullTelemetryService),U.set(y.IExtensionGalleryService,new o.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),U.set(G.IExtensionsProfileScannerService,new o.SyncDescriptor(K.ExtensionsProfileScannerService)),U.set(ae.IExtensionsScannerService,new o.SyncDescriptor(ue.ExtensionsScannerService)),U.set(g.IExtensionSignatureVerificationService,new o.SyncDescriptor(g.ExtensionSignatureVerificationService)),U.set(m.INativeServerExtensionManagementService,new o.SyncDescriptor(m.ExtensionManagementService)),U.set(i.ILanguagePackService,new o.SyncDescriptor(a.NativeLanguagePackService)),new b.InstantiationService(U)}async g(U){if(this.a["list-extensions"])return U.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const X={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return U.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),X,!!this.a.force)}else{if(this.a["uninstall-extension"])return U.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return U.locateExtension(this.a["locate-extension"])}}h(U){return U.map(X=>/\.vsix$/i.test(X)?c.URI.file((0,p.isAbsolute)(X)?X:(0,p.join)((0,P.cwd)(),X)):X)}}function V(k){setTimeout(()=>process.exit(k),0)}async function N(k,U,X){if(k.help){const z=s.default.serverApplicationName+(ce.isWindows?".cmd":"");console.log((0,ee.buildHelpMessage)(s.default.nameLong,z,s.default.version,X,{noInputFiles:!0,noPipe:!0}));return}if(k.version){console.log((0,ee.buildVersionMessage)(s.default.version,s.default.commit));return}const ne=new $(k,U);try{await ne.run(),V(0)}catch{V(1)}finally{ne.dispose()}}e.run=N}),define(pe[289],ve([1,0,70,263,33,283,4,12,87]),function(oe,e,w,L,o,C,D,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class d{constructor(E,m,g){this.b=E,this.c=m,this.f=g,this.a=L.createServer((b,s)=>this.h(b,s)),this.g().catch(b=>(m.error(b),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,m){const g=(s,h)=>{m.writeHead(s,{"content-type":"application/json"}),m.end(JSON.stringify(h||null),u=>u&&this.c.error(u))},b=[];E.setEncoding("utf8"),E.on("data",s=>b.push(s)),E.on("end",async()=>{try{const s=JSON.parse(b.join(""));let h;switch(s.type){case"open":h=await this.i(s);break;case"openExternal":h=await this.j(s);break;case"status":h=await this.l(s);break;case"extensionManagement":h=await this.k(s);break;default:g(404,`Unknown message type: ${s.type}`);break}g(200,h)}catch(s){const h=s instanceof Error?s.message:JSON.stringify(s);g(500,h),this.c.error("Error while processing pipe request",s)}})}async i(E){const{fileURIs:m,folderURIs:g,forceNewWindow:b,diffMode:s,mergeMode:h,addMode:u,forceReuseWindow:f,gotoLineMode:S,waitMarkerFilePath:O,remoteAuthority:t}=E,n=[];if(Array.isArray(g))for(const l of g)try{n.push({folderUri:D.URI.parse(l)})}catch{}if(Array.isArray(m))for(const l of m)try{(0,v.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:D.URI.parse(l)}):n.push({fileUri:D.URI.parse(l)})}catch{}const r=O?D.URI.file(O):void 0,a={forceNewWindow:b,diffMode:s,mergeMode:h,addMode:u,gotoLineMode:S,forceReuseWindow:f,preferNewWindow:!f&&!r&&!u,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",n,a),""}async j(E){for(const m of E.uris){const g=D.URI.parse(m),b=g.scheme==="file"?g:m;await this.b.executeCommand("_remoteCLI.openExternal",b)}}async k(E){const m=b=>b?.map(s=>/\.vsix$/i.test(s)?D.URI.parse(s):s),g={list:E.list,install:m(E.install),uninstall:m(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&o.existsSync(this.f)&&o.unlinkSync(this.f)}}e.CLIServerBase=d;let R=e.CLIServer=class extends d{constructor(E,m){super(E,m,(0,w.createRandomIPCHandle)())}};e.CLIServer=R=Le([Ae(0,C.IExtHostCommands),Ae(1,A.ILogService)],R)}),define(pe[290],ve([1,0,26,6,22,2,7,3,4,70,68,289,121,86,270,272,139,8]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class u extends b.AbstractVariableResolverService{constructor(O,t,n,r,i){super({getFolderUri:a=>{const l=t.filter(c=>c.name===a);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(a,l)=>r[`config:${l}`],getExecPath:()=>O.VSCODE_EXEC_PATH,getAppRoot:()=>O.VSCODE_CWD,getFilePath:()=>{if(n)return D.normalize(n.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async a=>{const c=(await i.getInstalled()).find(p=>p.identifier.id===a);return c&&{extensionLocation:c.location}}},void 0,Promise.resolve(w.homedir()),Promise.resolve(O))}}class f extends C.Disposable{constructor(O,t,n,r,i,a){super(),this.g=O,this.h=t,this.i=n,this.j=r,this.l=i,this.m=a,this.a=0,this.b=new Map,this.c=this.B(new L.Emitter),this.onExecuteCommand=this.c.event}async call(O,t,n){switch(t){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,n);case"$createProcess":{const r=(0,R.createURITransformer)(O.remoteAuthority);return this.n(r,n)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,n);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,n);case"$listProcesses":return this.i.listProcesses.apply(this.i,n);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,n);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,n);case"$start":return this.i.start.apply(this.i,n);case"$input":return this.i.input.apply(this.i,n);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,n);case"$shutdown":return this.i.shutdown.apply(this.i,n);case"$resize":return this.i.resize.apply(this.i,n);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,n);case"$getCwd":return this.i.getCwd.apply(this.i,n);case"$processBinary":return this.i.processBinary.apply(this.i,n);case"$sendCommandResult":return this.r(n[0],n[1],n[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,n);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,n);case"$getDefaultSystemShell":return this.s.apply(this,n);case"$getProfiles":return this.t.apply(this,n);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(n[0],n[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,n);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,n);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,n);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,n);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,n);case"$updateTitle":return this.i.updateTitle.apply(this.i,n);case"$updateProperty":return this.i.updateProperty.apply(this.i,n);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,n);case"$requestDetachInstance":return this.i.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,n)}throw new Error(`IPC Command ${t} not found`)}listen(O,t,n){switch(t){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||L.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||L.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||L.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||L.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||L.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||L.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(O,t){const n={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd>"u"?t.shellLaunchConfig.cwd:v.URI.revive(O.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment,reconnectionProperties:t.shellLaunchConfig.reconnectionProperties,type:t.shellLaunchConfig.type,isFeatureTerminal:t.shellLaunchConfig.isFeatureTerminal},r=await(0,s.buildUserEnvironment)(t.resolverEnv,!!t.shellLaunchConfig.useShellEnvironment,A.language,this.g,this.h,this.m);this.h.trace("baseEnv",r);const i=ge=>({uri:v.URI.revive(O.transformIncoming(ge.uri)),name:ge.name,index:ge.index,toResource:()=>{throw new Error("Not implemented")}}),a=t.workspaceFolders.map(i),l=t.activeWorkspaceFolder?i(t.activeWorkspaceFolder):void 0,c=t.activeFileResource?v.URI.revive(O.transformIncoming(t.activeFileResource)):void 0,p=new u(r,a,c,t.resolvedVariables,this.l),P=g.createVariableResolver(l,process.env,p),T=await g.getCwd(n,w.homedir(),P,l?.uri,t.configuration["terminal.integrated.cwd"],this.h);n.cwd=T;const I=A.isWindows?"terminal.integrated.env.windows":A.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",F=t.configuration[I],H=await g.createTerminalEnvironment(n,F,P,this.j.version,t.configuration["terminal.integrated.detectLocale"],r);if(!n.strictEnv){const ge=[];for(const[K,q,ie]of t.envVariableCollections)ge.push([K,{map:(0,m.deserializeEnvironmentVariableCollection)(q),descriptionMap:(0,m.deserializeEnvironmentDescriptionMap)(ie)}]);const G=new Map(ge),te=new E.MergedEnvironmentVariableCollection(G),W=l?(0,h.withNullAsUndefined)(l):void 0;await te.applyToProcessEnvironment(H,{workspaceFolder:W},P)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:T,cols:t.cols,rows:t.rows,env:H});const ee=(0,d.createRandomIPCHandle)();H.VSCODE_IPC_HOOK_CLI=ee;const ce=await this.i.createProcess(n,T,t.cols,t.rows,t.unicodeVersion,H,r,t.options,t.shouldPersistTerminal,t.workspaceId,t.workspaceName),ae={executeCommand:(ge,...G)=>this.p(ce,ge,G,O)},ue=new y.CLIServerBase(ae,this.h,ee);return this.i.onProcessExit(ge=>ge.id===ce&&ue.dispose()),{persistentTerminalId:ce,resolvedShellLaunchConfig:n}}p(O,t,n,r){let i,a;const l=new Promise((P,T)=>{i=P,a=T}),c=++this.a;this.b.set(c,{resolve:i,reject:a,uriTransformer:r});const p=(0,o.cloneAndChange)(n,P=>{if(P&&P.$mid===1)return r.transformOutgoing(P);if(P&&P instanceof v.URI)return r.transformOutgoingURI(P)});return this.c.fire({reqId:c,persistentProcessId:O,commandId:t,commandArgs:p}),l}r(O,t,n){const r=this.b.get(O);if(!r)return;this.b.delete(O);const i=(0,o.cloneAndChange)(n,a=>{if(a&&a.$mid===1)return r.uriTransformer.transformIncoming(a)});t?r.reject(i):r.resolve(i)}s(O){return this.i.getDefaultSystemShell(O)}async t(O,t,n,r){return this.i.getProfiles?.(O,t,n,r)||[]}u(){return{...process.env}}w(O,t){return this.i.getWslPath(O,t)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=f}),define(pe[291],ve([1,0,26,6,2,13,7,99,23,43,24,115,78,261,202,79,203,212,221,25,125,30,80,118,213,137,16,110,66,63,109,81,82,119,12,53,27,44,232,138,117,31,37,246,122,253,35,123,267,268,237,243,290,68,41,274,284,127,56,128,45,32,262,67,244,113,126,124,112,111,196,281,228,257]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t,n,r,i,a,l,c,p,P,T,I,F,H,ee,ce,ae,ue,ge,G,te,W,K,q,ie,re,de,$,V,N,k,U,X,ne,z,j,Y,x,Z,J,_,le,Ee,Ce,ke,Ue,je,me,Se,we,Ne,ze,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ve="monacoworkbench";async function Xe(Re,Oe,$e,qe){const xe=new T.ServiceCollection,_e=new Ge,Ke={_serviceBrand:void 0,...ee.default};xe.set(ce.IProductService,Ke);const Je=new ne.ServerEnvironmentService(Oe,Ke);xe.set(f.IEnvironmentService,Je),xe.set(f.INativeEnvironmentService,Je);const at=new ke.LoggerService((0,H.getLogLevel)(Je),Je.logsHome);xe.set(H.ILoggerService,at),_e.registerChannel("logger",new Se.LoggerChannel(at,st=>it(st.remoteAuthority)));const vt=at.createLogger("remoteagent",{name:(0,we.localize)(0,null)}),ot=new me.LogService(vt,[new Ye((0,H.getLogLevel)(Je))]);xe.set(H.ILogService,ot),setTimeout(()=>Te(Je.logsHome.fsPath).then(null,st=>ot.error(st)),1e4),ot.onDidChangeLogLevel(st=>(0,H.log)(ot,st,`Log level changed to ${(0,H.LogLevelToString)(ot.getLevel())}`)),ot.trace(`Remote configuration data at ${$e}`),ot.trace("process arguments:",Je.args),Array.isArray(Ke.serverGreeting)&&ot.info(`

${Ke.serverGreeting.join(`
`)}

`),_e.registerChannel(g.ExtensionHostDebugBroadcastChannel.ChannelName,new g.ExtensionHostDebugBroadcastChannel);const Mt=new d.StaticRouter(st=>st.clientId==="renderer"),Et=qe.add(new l.FileService(ot));xe.set(a.IFileService,Et),Et.registerProvider(C.Schemas.file,qe.add(new c.DiskFileSystemProvider(ot)));const Ct=new de.UriIdentityService(Et);xe.set(re.IUriIdentityService,Ct);const ht=new y.ConfigurationService(Je.machineSettingsResource,Et,new Ee.NullPolicyService,ot);xe.set(R.IConfigurationService,ht);const dt=new Ue.ServerUserDataProfilesService(Ct,Je,Et,ot);xe.set(_.IUserDataProfilesService,dt),_e.registerChannel("userDataProfiles",new tt.RemoteUserDataProfilesServiceChannel(dt,st=>it(st.remoteAuthority)));const[,,At]=await Promise.all([ht.initialize(),dt.init(),(0,A.getMachineId)(ot.error.bind(ot))]),Rt=new Y.ExtensionHostStatusService;xe.set(Y.IExtensionHostStatusService,Rt),xe.set(ae.IRequestService,new p.SyncDescriptor(ge.RequestService));let wt=W.NullAppender;const Pt=(0,W.isInternalTelemetry)(Ke,ht);if((0,W.supportsTelemetry)(Ke,Je)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?wt=new Ce.OneDataSystemAppender(!1,Ve,null,()=>new le.TelemetryClient(st)):Ke.aiConfig&&Ke.aiConfig.ariaKey&&(wt=new Ce.OneDataSystemAppender(Pt,Ve,null,Ke.aiConfig.ariaKey)),qe.add((0,o.toDisposable)(()=>wt?.flush()));const yt={appenders:[wt],commonProperties:(0,G.resolveCommonProperties)((0,w.release)(),(0,w.hostname)(),process.arch,Ke.commit,Ke.version+"-remote",At,Pt,"remoteAgent"),piiPaths:(0,W.getPiiPathsFromEnvironment)(Je)},ye=Je.args["telemetry-level"];let Ie=3;ye==="all"?Ie=3:ye==="error"?Ie=2:ye==="crash"?Ie=1:ye!==void 0&&(Ie=0),xe.set(k.IServerTelemetryService,new p.SyncDescriptor(k.ServerTelemetryService,[yt,Ie]))}else xe.set(k.IServerTelemetryService,k.ServerNullTelemetryService);xe.set(O.IExtensionGalleryService,new p.SyncDescriptor(S.ExtensionGalleryServiceWithNoStorageService));const Ut=_e.getChannel("download",Mt);xe.set(b.IDownloadService,new s.DownloadServiceChannelClient(Ut,()=>it("renderer"))),xe.set(J.IExtensionsProfileScannerService,new p.SyncDescriptor(je.ExtensionsProfileScannerService)),xe.set(x.IExtensionsScannerService,new p.SyncDescriptor(Z.ExtensionsScannerService)),xe.set(t.IExtensionSignatureVerificationService,new p.SyncDescriptor(t.ExtensionSignatureVerificationService)),xe.set(i.INativeServerExtensionManagementService,new p.SyncDescriptor(i.ExtensionManagementService));const gt=new P.InstantiationService(xe);xe.set(I.ILanguagePackService,gt.createInstance(F.NativeLanguagePackService));const Tt=gt.createInstance(ie.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ht.getValue("terminal.integrated.persistentSessionScrollback")??100},!0);return xe.set(q.IPtyService,Tt),xe.set(h.IEncryptionMainService,new p.SyncDescriptor(u.EncryptionMainService,[At])),xe.set(E.ICredentialsMainService,new p.SyncDescriptor(m.CredentialsWebMainService)),gt.invokeFunction(st=>{const yt=st.get(i.INativeServerExtensionManagementService),ye=st.get(x.IExtensionsScannerService),Ie=st.get(O.IExtensionGalleryService),fe=st.get(I.ILanguagePackService),Q=new $.RemoteAgentEnvironmentChannel(Re,Je,dt,Rt);_e.registerChannel("remoteextensionsenvironment",Q);const Pe=new N.ServerTelemetryChannel(st.get(k.IServerTelemetryService),wt);_e.registerChannel("telemetry",Pe),_e.registerChannel(z.REMOTE_TERMINAL_CHANNEL_NAME,new U.RemoteTerminalChannel(Je,ot,Tt,Ke,yt,ht));const Fe=new Ne.RemoteExtensionsScannerService(gt.createInstance(n.ExtensionManagementCLI,ot),Je,dt,ye,ot,Ie,fe);_e.registerChannel(ze.RemoteExtensionsScannerChannelName,new Ne.RemoteExtensionsScannerChannel(Fe,ut=>it(ut.remoteAuthority)));const We=new V.RemoteAgentFileSystemProviderChannel(ot,Je);_e.registerChannel(j.REMOTE_FILE_SYSTEM_CHANNEL_NAME,We),_e.registerChannel("request",new ue.RequestChannel(st.get(ae.IRequestService)));const Me=new r.ExtensionManagementChannel(yt,ut=>it(ut.remoteAuthority));_e.registerChannel("extensions",Me);const Ze=d.ProxyChannel.fromService(st.get(I.ILanguagePackService));_e.registerChannel("languagePacks",Ze);const lt=d.ProxyChannel.fromService(st.get(h.IEncryptionMainService));_e.registerChannel("encryption",lt);const mt=d.ProxyChannel.fromService(st.get(E.ICredentialsMainService));return _e.registerChannel("credentials",mt),Fe.whenExtensionsReady().then(()=>yt.cleanUp()),qe.add(new K.default(st.get(te.ITelemetryService))),{telemetryService:st.get(te.ITelemetryService)}}),{socketServer:_e,instantiationService:gt}}e.setupServerServices=Xe;const Qe=Object.create(null);function it(Re){return Qe[Re]||(Qe[Re]=(0,X.createURITransformer)(Re)),Qe[Re]}class Ge extends d.IPCServer{constructor(){const Oe=new L.Emitter;super(Oe.event),this.b=Oe}acceptConnection(Oe,$e){this.b.fire({protocol:Oe,onDidClientDisconnect:$e})}}e.SocketServer=Ge;class Ye extends H.AbstractLogger{constructor(Oe=H.DEFAULT_LOG_LEVEL){super(),this.setLevel(Oe),this.g=!!process.stdout.isTTY}trace(Oe,...$e){this.f(H.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${he()}]\x1B[0m`,Oe,...$e):console.log(`[${he()}]`,Oe,...$e))}debug(Oe,...$e){this.f(H.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${he()}]\x1B[0m`,Oe,...$e):console.log(`[${he()}]`,Oe,...$e))}info(Oe,...$e){this.f(H.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${he()}]\x1B[0m`,Oe,...$e):console.log(`[${he()}]`,Oe,...$e))}warn(Oe,...$e){this.f(H.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${he()}]\x1B[0m`,Oe,...$e):console.warn(`[${he()}]`,Oe,...$e))}error(Oe,...$e){this.f(H.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${he()}]\x1B[0m`,Oe,...$e):console.error(`[${he()}]`,Oe,...$e))}dispose(){}flush(){}}function he(){const Re=new Date;return`${De(Re.getHours())}:${De(Re.getMinutes())}:${De(Re.getSeconds())}`}function De(Re){return Re<10?`0${Re}`:String(Re)}async function Te(Re){const Oe=D.basename(Re),$e=D.dirname(Re),_e=(await v.Promises.readdir($e)).filter(Je=>/^\d{8}T\d{6}$/.test(Je)).sort().filter(Je=>Je!==Oe),Ke=_e.slice(0,Math.max(0,_e.length-9));await Promise.all(Ke.map(Je=>v.Promises.rm(D.join($e,Je))))}}),define(pe[292],ve([1,0,85,33,76,293,83,140,15,9,38,2,13,7,42,3,17,4,21,155,103,104,70,24,5,12,27,55,31,139,258,259,41,291,264]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E,m,g,b,s,h,u,f,S,O,t,n,r,i,a,l,c,p,P,T,I,F,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const ee=5*60*1e3;let ce=class extends y.Disposable{constructor(G,te,W,K,q,ie,re,de){super(),this.k=G,this.l=te,this.m=W,this.n=q,this.p=ie,this.r=re,this.s=de,this.h=ue.create(this.p),this.i=(0,l.getRemoteServerRootPath)(ie),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=K?this.s.createInstance(H.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(G,te){if(G.method!=="GET")return(0,H.serveError)(G,te,405,`Unsupported method ${G.method}`);if(!G.url)return(0,H.serveError)(G,te,400,"Bad request.");const W=D.parse(G.url,!0);let K=W.pathname;if(!K)return(0,H.serveError)(G,te,400,"Bad request.");if(K.startsWith(this.i)&&K.charCodeAt(this.i.length)===47&&(K=K.substring(this.i.length)),K==="/version")return te.writeHead(200,{"Content-Type":"text/plain"}),void te.end(this.p.commit||"");if(K==="/delay-shutdown")return this.H(),te.writeHead(200),void te.end("OK");if(!(0,T.requestHasValidConnectionToken)(this.l,G,W))return(0,H.serveError)(G,te,403,"Forbidden.");if(K==="/vscode-remote-resource"){const q=W.query.path;if(typeof q!="string")return(0,H.serveError)(G,te,400,"Bad request.");let ie;try{ie=h.URI.from({scheme:E.Schemas.file,path:q}).fsPath}catch{return(0,H.serveError)(G,te,400,"Bad request.")}const re=Object.create(null);this.n.isBuilt&&((0,R.isEqualOrParent)(ie,this.n.builtinExtensionsPath,!b.isLinux)||(0,R.isEqualOrParent)(ie,this.n.extensionsPath,!b.isLinux))&&(re["Cache-Control"]="public, max-age=31536000"),re.Vary="Origin";const de=G.headers.origin;return de&&this.h.matches(de)&&(re["Access-Control-Allow-Origin"]=de),(0,H.serveFile)(ie,1,this.r,G,te,re)}if(this.g){this.g.handle(G,te,W);return}return te.writeHead(404,{"Content-Type":"text/plain"}),void te.end("Not found")}handleUpgrade(G,te){let W=(0,u.generateUuid)(),K=!1,q=!1;if(G.url){const N=D.parse(G.url,!0).query;typeof N.reconnectionToken=="string"&&(W=N.reconnectionToken),N.reconnection==="true"&&(K=!0),N.skipWebSocketFrames==="true"&&(q=!0)}if(G.headers.upgrade===void 0||G.headers.upgrade.toLowerCase()!=="websocket"){te.end("HTTP/1.1 400 Bad Request");return}const ie=G.headers["sec-websocket-key"],re=w.createHash("sha1");re.update(ie+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const $=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${re.digest("base64")}`];let V=!1;if(!q&&!this.n.args["disable-websocket-compression"]&&G.headers["sec-websocket-extensions"]){const N=Array.isArray(G.headers["sec-websocket-extensions"])?G.headers["sec-websocket-extensions"]:[G.headers["sec-websocket-extensions"]];for(const k of N)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(k)){if(/\b(permessage-deflate)\b/.test(k)){V=!0,$.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(k)){V=!0,$.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}te.write($.join(`\r
`)+`\r
\r
`),te.setTimeout(0),te.setNoDelay(!0),q?this.v(new t.NodeSocket(te,`server-connection-${W}`),K,W):this.v(new t.WebSocketNodeSocket(new t.NodeSocket(te,`server-connection-${W}`),V,null,!0),K,W)}handleServerError(G){this.r.error("Error occurred in server"),this.r.error(G)}t(G){let te;return G instanceof t.NodeSocket?te=G.socket:te=G.socket.socket,te.remoteAddress||"<unknown>"}async u(G,te,W){const K=te.getSocket();this.r.error(`${G} ${W}.`);const q={type:"error",reason:W};te.sendControl(v.VSBuffer.fromString(JSON.stringify(q))),te.dispose(),await K.drain(),K.dispose()}v(G,te,W){const K=this.t(G),q=`[${K}][${W.substr(0,8)}]`,ie=new O.PersistentProtocol({socket:G}),re=this.m?new this.m.validator:null,de=this.m?new this.m.signer:null;let $;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})($||($={}));let V=0;const N=U=>{V=3,k.dispose(),this.u(q,ie,U)},k=ie.onControlMessage(U=>{if(V===0){let X;try{X=JSON.parse(U.toString())}catch{return N("Malformed first message")}if(X.type!=="auth")return N("Invalid first message");if(this.l.type===2&&!this.l.validate(X.auth))return N("Unauthorized client refused: auth mismatch");let ne=(0,u.generateUuid)();if(de)try{ne=de.sign(X.data)}catch{}let z=(0,u.generateUuid)();if(re)try{z=re.createNewMessage(z)}catch{}const j={type:"sign",data:z,signedData:ne};ie.sendControl(v.VSBuffer.fromString(JSON.stringify(j))),V=1}else if(V===1){let X;try{X=JSON.parse(U.toString())}catch{return N("Malformed second message")}if(X.type!=="connectionType")return N("Invalid second message");if(typeof X.signedData!="string")return N("Invalid second message field type");const ne=X.commit,z=this.p.commit;if(ne&&z&&ne!==z)return N("Client refused: version mismatch");let j=!1;if(!re)j=!0;else if(this.l.validate(X.signedData))j=!0;else try{j=re.validate(X.signedData)==="ok"}catch{}if(!j){if(this.n.isBuilt)return N("Unauthorized client refused");this.r.error(`${q} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const Y in this.b)this.b[Y].shortenReconnectionGraceTimeIfNecessary();for(const Y in this.a)this.a[Y].shortenReconnectionGraceTimeIfNecessary();V=2,k.dispose(),this.w(K,q,ie,G,te,W,X)}})}async w(G,te,W,K,q,ie,re){const de=re.desiredConnectionType===1?`${te}[ManagementConnection]`:re.desiredConnectionType===2?`${te}[ExtensionHostConnection]`:te;if(re.desiredConnectionType===1)if(q){if(!this.b[ie])return this.f.has(ie)?this.u(de,W,"Unknown reconnection token (seen before)"):this.u(de,W,"Unknown reconnection token (never seen)");W.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const $=W.readEntireBuffer();W.dispose(),this.b[ie].acceptReconnection(G,K,$)}else{if(this.b[ie])return this.u(de,W,"Duplicate reconnection token");W.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const $=new P.ManagementConnection(this.r,ie,G,W);this.k.acceptConnection($.protocol,$.onClose),this.b[ie]=$,this.f.add(ie),$.onClose(()=>{delete this.b[ie]})}else if(re.desiredConnectionType===2){const $=re.args||{language:"en"},V=await this.C($);if(V.port&&this.r.trace(`${de} - startParams debug port ${V.port}`),this.r.trace(`${de} - startParams language: ${V.language}`),this.r.trace(`${de} - startParams env: ${JSON.stringify(V.env)}`),q){if(!this.a[ie])return this.f.has(ie)?this.u(de,W,"Unknown reconnection token (seen before)"):this.u(de,W,"Unknown reconnection token (never seen)");W.sendPause(),W.sendControl(v.VSBuffer.fromString(JSON.stringify(V.port?{debugPort:V.port}:{})));const N=W.readEntireBuffer();W.dispose(),this.a[ie].acceptReconnection(G,K,N)}else{if(this.a[ie])return this.u(de,W,"Duplicate reconnection token");W.sendPause(),W.sendControl(v.VSBuffer.fromString(JSON.stringify(V.port?{debugPort:V.port}:{})));const N=W.readEntireBuffer();W.dispose();const k=this.s.createInstance(p.ExtensionHostConnection,ie,G,K,N);this.a[ie]=k,this.f.add(ie),k.onClose(()=>{delete this.a[ie],this.D()}),k.start(V)}}else if(re.desiredConnectionType===3){const $=re.args;this.y(W,$)}else return this.u(de,W,"Unknown initial data received")}async y(G,te){const W=G.getSocket().socket,K=G.readEntireBuffer();G.dispose(),W.pause();const q=await this.z(te.host,te.port);K.byteLength>0&&q.write(K.buffer),q.on("end",()=>W.end()),q.on("close",()=>W.end()),q.on("error",()=>W.destroy()),W.on("end",()=>q.end()),W.on("close",()=>q.end()),W.on("error",()=>q.destroy()),q.pipe(W),W.pipe(q)}z(G,te){return new Promise((W,K)=>{const q=o.createConnection({host:G,port:te},()=>{q.removeListener("error",K),q.pause(),W(q)});q.once("error",K)})}C(G){return typeof G.port=="number"?(0,f.findFreePort)(G.port,10,5e3).then(te=>(G.port=te,G)):(G.debugId=void 0,G.port=void 0,G.break=void 0,Promise.resolve(G))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(G=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!G?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},ee))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ce=Le([Ae(4,I.IServerEnvironmentService),Ae(5,a.IProductService),Ae(6,i.ILogService),Ae(7,r.IInstantiationService)],ce);async function ae(ge,G,te){const W=await(0,T.determineServerConnectionToken)(G);W instanceof T.ServerConnectionTokenParseError&&(console.warn(W.message),process.exit(1));function K(j){(0,d.setUnexpectedErrorHandler)(Y=>{(0,d.isSigPipeError)(Y)&&Y.stack&&/unexpectedErrorHandler/.test(Y.stack)||j(Y)})}const q=[];K(j=>{q.push(j),console.error(j)});let ie=!1;process.on("SIGPIPE",()=>{ie||(ie=!0,(0,d.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const re=new y.DisposableStore,{socketServer:de,instantiationService:$}=await(0,F.setupServerServices)(W,G,te,re);$.invokeFunction(j=>{const Y=j.get(i.ILogService);q.forEach(x=>Y.error(x)),q.length=0,K(x=>Y.error(x))}),$.invokeFunction(j=>{const Y=j.get(n.IConfigurationService);process.platform==="win32"&&(0,S.setUNCHostAllowlist)((0,S.toUNCHostAllowlist)(Y.getValue("security.allowedUNCHosts")))}),$.invokeFunction(j=>{const Y=j.get(i.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const x=(0,m.join)(process.env.HOMEDRIVE,"node_modules"),Z=(0,m.dirname)((0,m.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),J=(0,m.join)(Z,"node_modules");if(L.existsSync(x)||L.existsSync(J)){const _=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${x}
* ${J}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Y.warn(_),console.warn(_),process.exit(0)}}});const V=$.invokeFunction(j=>{const Y=j.get(i.ILogService);if(L.existsSync((0,m.join)(E.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Z){Y.error(Z)}return null}),N=L.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(N&&ge&&typeof ge!="string"){const j=W.type!==0?`?${E.connectionTokenQueryName}=${W.value}`:"";console.log(`Web UI available at http://localhost${ge.port===80?"":`:${ge.port}`}/${j}`)}const k=$.createInstance(ce,de,W,V,N);g.mark("code/server/ready");const U=C.performance.now(),X=global.vscodeServerStartTime,ne=global.vscodeServerListenTime,z=global.vscodeServerCodeLoadedTime;if($.invokeFunction(j=>{j.get(c.ITelemetryService).publicLog2("serverStart",{startTime:X,startedTime:ne,codeLoadedTime:z,readyTime:U})}),G["print-startup-performance"]){const j=A.LoaderStats.get();let Y="";Y+=`

### Load AMD-module
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],j.amdLoad),Y+=`

### Load commonjs-module
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],j.nodeRequire),Y+=`

### Invoke AMD-module factory
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],j.amdInvoke),Y+=`

### Invoke commonjs-module
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],j.nodeEval),Y+=`Start-up time: ${ne-X}
`,Y+=`Code loading time: ${z-X}
`,Y+=`Initialized time: ${U-X}
`,Y+=`
`,console.log(Y)}return k}e.createServer=ae;class ue{static create(G){const te=G.webEndpointUrlTemplate,W=G.commit,K=G.quality;if(!te||!W||!K)return new ue(null);const q=(0,u.generateUuid)(),re=new URL(te.replace("{{uuid}}",q).replace("{{commit}}",W).replace("{{quality}}",K)).origin,de=(0,s.escapeRegExpCharacters)(re).replace(q,"[a-zA-Z0-9\\-]+");try{const $=(0,s.createRegExp)(`^${de}$`,!0,{matchCase:!1});return new ue($)}catch{return new ue(null)}}constructor(G){this.a=G}matches(G){return this.a?this.a.test(G):!1}}}),define(pe[301],ve([1,0,26,33,13,288,292,62,7,293,41,53,42]),function(oe,e,w,L,o,C,D,A,v,d,R,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,E.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=d.performance.now();const m={onMultipleValues:(u,f)=>{console.error(`Option '${u}' can only be defined once. Using value ${f}.`)},onEmptyValue:u=>{console.error(`Ignoring option '${u}': Value must not be empty.`)},onUnknownOption:u=>{console.error(`Ignoring option '${u}': not supported for server.`)},onDeprecatedOption:(u,f)=>{console.warn(`Option '${u}' is deprecated: ${f}`)}};function g(){return(0,A.parseArgs)(process.argv.slice(2),R.serverOptions,m)}function b(u){const f=u["server-data-dir"]||u["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(w.homedir(),y.default.serverDataFolderName||".vscode-remote"),S=u["user-data-dir"]||(0,v.join)(f,"data"),O=(0,v.join)(S,"User"),t=(0,v.join)(O,"globalStorage"),n=(0,v.join)(O,"History"),r=(0,v.join)(S,"Machine");u["user-data-dir"]=S;const i=(0,v.dirname)(o.FileAccess.asFileUri("").fsPath),a=u["builtin-extensions-dir"]||(0,v.join)(i,"extensions");return u["builtin-extensions-dir"]=a,u["extensions-dir"]=u["extensions-dir"]||(0,v.join)(f,"extensions"),[f,u["extensions-dir"],S,O,r,t,n].forEach(l=>{try{L.existsSync(l)||L.mkdirSync(l,{mode:448})}catch(c){console.error(c)}}),f}function s(u=g()){return(0,C.run)(u,b(u),R.serverOptions)}e.spawnCli=s;function h(u,f=g()){return(0,D.createServer)(u,f,b(f))}e.createServer=h})}).call(this);

//# sourceMappingURL=server.main.js.map
